(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12068,        425]
NotebookOptionsPosition[     11783,        410]
NotebookOutlinePosition[     12137,        426]
CellTagsIndexPosition[     12094,        423]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  StyleBox[GridBox[{
     {
      RowBox[{
       StyleBox["\[IndentingNewLine]",
        FontColor->RGBColor[0, 1, 0]], 
       StyleBox[" ",
        FontFamily->"Helvetica",
        FontSize->18,
        FontColor->GrayLevel[0]], 
       StyleBox[
        RowBox[{
         StyleBox[
          RowBox[{"Single", " ", "Qubit", "  ", "Tools"}],
          FontFamily->"Helvetica",
          FontSize->18], "\[IndentingNewLine]"}],
        FontColor->GrayLevel[1]]}], 
      StyleBox["",
       FontColor->RGBColor[0, 1, 0]]},
     {
      ButtonBox[
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0]]], 
      ButtonBox[
       RowBox[{"PX", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"PY", "[", "\[SelectionPlaceholder]", "]"}]], 
      ButtonBox[
       SubscriptBox["\[Sigma]", "\[SelectionPlaceholder]"]]},
     {
      ButtonBox[
       RowBox[{"Ket", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Bra", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"KetX", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"BraX", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"KetY", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"BraY", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"Ket1", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Bra1", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"ProjG", "[", 
        RowBox[{
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox[",",
          ScriptLevel->0], 
         RowBox[{
          StyleBox["{",
           ScriptLevel->0], "\[SelectionPlaceholder]", "}"}]}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Tr", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox["RandomQubit1"], 
      ButtonBox[
       RowBox[{"Adj", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox["RandomKet1"], 
      ButtonBox["RandomBra1"]},
     {
      ButtonBox[
       RowBox[{"Rotqbit", "[", 
        RowBox[{
         RowBox[{"{", 
          StyleBox["\[SelectionPlaceholder]",
           ScriptLevel->0], 
          StyleBox["}",
           ScriptLevel->0]}], 
         StyleBox[",",
          ScriptLevel->0], 
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0]}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"RotX", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"RotY", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"RotZ", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"Comm", "[", 
        RowBox[{
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox[",",
          ScriptLevel->0], "\[SelectionPlaceholder]"}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Fidelity", "[", 
        RowBox[{
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox[",",
          ScriptLevel->0], "\[SelectionPlaceholder]"}], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"Purity", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Entropy", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[""], 
      ButtonBox[""]},
     {
      RowBox[{"\[IndentingNewLine]", 
       StyleBox[
        RowBox[{"MultiQubit", " ", "Tools"}],
        FontFamily->"Helvetica",
        FontSize->18,
        FontColor->GrayLevel[1]]}], 
      RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]"}]},
     {
      ButtonBox[
       RowBox[{"KetV", "[", 
        RowBox[{"{", 
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox["}",
          ScriptLevel->0]}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"SP", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", 
          RowBox[{"{", "\[SelectionPlaceholder]", "}"}]}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"PTr", "[", 
        RowBox[{
         RowBox[{"{", 
          StyleBox["\[SelectionPlaceholder]",
           ScriptLevel->0], 
          StyleBox["}",
           ScriptLevel->0]}], 
         StyleBox[",",
          ScriptLevel->0], 
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0]}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{
        RowBox[{"AF", "["}], 
        StyleBox[
         RowBox[{
         "\[SelectionPlaceholder]", "\[TensorProduct]", 
          "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"MeasureKet", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", 
          RowBox[{"{", "\[SelectionPlaceholder]", "}"}], ",", 
          RowBox[{"{", "\[SelectionPlaceholder]", "}"}]}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox["RandomQubit2"]},
     {
      ButtonBox[
       RowBox[{"RandomQubitN", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"MultiQProj", "[", 
        RowBox[{
         RowBox[{"{", "\[SelectionPlaceholder]", "}"}], ",", 
         RowBox[{"{", "\[SelectionPlaceholder]", "}"}]}], "]"}]]},
     {
      RowBox[{"\[IndentingNewLine]", 
       StyleBox[" ",
        FontFamily->"Helvetica",
        FontSize->18,
        FontColor->GrayLevel[1]], 
       RowBox[{
        StyleBox[
         RowBox[{"Common", " ", "Gates"}],
         FontFamily->"Helvetica",
         FontSize->18,
         FontColor->GrayLevel[1]], "\[IndentingNewLine]"}]}], ""},
     {
      ButtonBox[
       RowBox[{"CNOT", "[", 
        StyleBox[
         RowBox[{
         "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
          "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"CPHASE", "[", 
        StyleBox[
         RowBox[{
         "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
          "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"Had", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", 
          RowBox[{"{", "\[SelectionPlaceholder]", "}"}]}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"CPHASEV", "[", 
        RowBox[{
        "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
         RowBox[{"{", 
          StyleBox["\[SelectionPlaceholder]",
           ScriptLevel->0], 
          StyleBox["}",
           ScriptLevel->0]}]}], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"ControlledX", "[", 
        RowBox[{
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox[",",
          ScriptLevel->0], 
         StyleBox["\[SelectionPlaceholder]",
          ScriptLevel->0], 
         StyleBox[",",
          ScriptLevel->0], "\[SelectionPlaceholder]"}], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"ControlledY", "[", 
        RowBox[{
        "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
         "\[SelectionPlaceholder]"}], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"had", "[", 
        StyleBox[
         RowBox[{"\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"HALL", "[", 
        StyleBox["\[SelectionPlaceholder]",
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"Toffoli", "[", 
        StyleBox[
         RowBox[{
         "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
          "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[
       RowBox[{"Swap", "[", 
        RowBox[{
        "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
         "\[SelectionPlaceholder]"}], 
        StyleBox["]",
         ScriptLevel->0]}]]},
     {
      ButtonBox[
       RowBox[{"TwoOp", "[", 
        StyleBox[
         RowBox[{
         "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
          "\[SelectionPlaceholder]", ",", "\[SelectionPlaceholder]", ",", 
          "\[SelectionPlaceholder]"}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]], 
      ButtonBox[""]}
    }],
   Background->RGBColor[0.571389, 0.19675, 0.570504]], 
  "\[IndentingNewLine]"}]], NotebookDefault,
 PageBreakAbove->True,
 GridBoxOptions->{GridBoxSpacings->{"Columns" -> {
     Offset[0.27999999999999997`], {
      Offset[0.]}, 
     Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
     Offset[0.2], {
      Offset[0.]}, 
     Offset[0.2]}, "RowsIndexed" -> {}}}]
},
WindowSize->{808, 853},
WindowMargins->{{309, Automatic}, {Automatic, 0}},
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (June 27, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 11221, 388, 796, NotebookDefault,
 PageBreakAbove->True]
}
]
*)

(* End of internal cache information *)

