(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    179380,       5077]
NotebookOptionsPosition[    157478,       4362]
NotebookOutlinePosition[    168971,       4712]
CellTagsIndexPosition[    168595,       4695]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Basics of Cluster Model ", "Title",
 CellTags->"c:1"],

Cell["Cluster State computations, basics", "Subtitle"],

Cell[TextData[{
 "Version: November-2014--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9.0-10.3"
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, {
  3.512204743716008*^9, 3.512204766816266*^9}, {3.624968936725236*^9, 
  3.624968941032831*^9}, {3.6251847546118107`*^9, 3.6251847658162823`*^9}, {
  3.655403427553523*^9, 3.6554034281029587`*^9}}],

Cell[CellGroupData[{

Cell["\<\
Cluster State basics:                                                    To \
open double click at down arrow------------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.512204867845098*^9, 3.5122049049071093`*^9}},
 FontFamily->"Times",
 CellTags->"c:2"],

Cell[CellGroupData[{

Cell["Discard Theorem", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:0.0.0"}],

Cell[TextData[StyleBox["Uses the Qdensity package:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell["?QDENSITY`Qdensity`*", "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Rho]$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Discord",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Discord", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Mutual",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Mutual", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["neg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "neg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-16adcbae-f13a-4f1a-a715-a6399776ecd8", {
            "ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.19]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6573772039357443`*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  StyleBox["Access",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["the",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["2014",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["QDENSpalette",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["it",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["by",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  StyleBox["clicking",
   FontFamily->"Helvetica"], 
  StyleBox[" ",
   FontFamily->"Helvetica"], 
  RowBox[{
   StyleBox["here",
    FontFamily->"Helvetica"], 
   StyleBox[":",
    FontFamily->"Helvetica"], 
   StyleBox[" ",
    FontFamily->"Helvetica"], 
   ButtonBox[
    RowBox[{"QDENSpalette", ".", "nb"}],
    BaseStyle->"Hyperlink",
    ButtonData:>{"QDENSpalette14.nb", None}]}]}]], "Text",
 CellChangeTimes->{{3.625184809702572*^9, 3.625184831474201*^9}},
 FontFamily->"Courier New",
 CellTags->"b:0.0.0"],

Cell[TextData[StyleBox["We set the number of Qubits to 2",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", "2"}], ";"}]], "Input",
 CellTags->"b:0.0.0"],

Cell[TextData[StyleBox["Decide whether the computation will be carried out \
numerically (icalc=0) or \nalgebraically (icalc=1)",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Icalc", "=", "0"}]], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101195992*^9, 3.624968925011549*^9, 
  3.625184705397367*^9, 3.655403432617752*^9, 3.657377203985688*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure1", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/discard1.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"figure2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/discard2.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure1", "]"}], "\n", 
 RowBox[{"Show", "[", "figure2", "]"}]}], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQlQFMfbxuXwBAVRvGJUkEBEUcMhRkkQLPBCQRFFUAkofgSjiKJREsUr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    "], {{0, 0}, {300, 107}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{300, 107},
   PlotRange->{{0, 300}, {0, 107}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101461933*^9, 3.624968925130021*^9, 
  3.625184705479383*^9, 3.655403432707243*^9, 3.657377204046442*^9},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztXUlMFN0W7v+9P4ZBNyKjOKISkxecEYfG/C8RNeBCnlGMK0h04cJuac0v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    "], {{0, 0}, {300, 46}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{300, 46},
   PlotRange->{{0, 300}, {0, 46}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101461933*^9, 3.624968925130021*^9, 
  3.625184705479383*^9, 3.655403432707243*^9, 3.657377204052311*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["We'll show that the two circuits in the figures are \
equivalent:\nThe unknown qubit one, will be generated at Random:", \
"DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]", "=", "RandomQubit1"}]], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.05312479099492074`", 
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771014772043`*^9, 3.624968925161828*^9, 
  3.625184705514533*^9, 3.655403432824588*^9, 3.657377204086195*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{"Icalc", "==", "1"}], ",", 
    RowBox[{"\[Rho]1", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"A", "*", 
         RowBox[{"Ket", "[", "0", "]"}]}], "+", 
        RowBox[{"B", "*", 
         RowBox[{"Ket", "[", "1", "]"}]}]}], ")"}], "\[TensorProduct]", 
      RowBox[{"Adj", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A", "*", 
          RowBox[{"Ket", "[", "0", "]"}]}], "+", 
         RowBox[{"B", "*", 
          RowBox[{"Ket", "[", "1", "]"}]}]}], ")"}], "]"}]}]}], ",", 
    RowBox[{"\[Rho]1", "=", "\[Rho]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", "\[Rho]1"}], "Input",
 CellChangeTimes->{3.6167091464740953`*^9},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.05312479099492074`", 
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771015064697`*^9, 3.624968925195376*^9, 
  3.6251847055267773`*^9, 3.655403432890551*^9, 3.657377204119677*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["The second one is in the |+\[RightAngleBracket] \
state, its density matrix is thus:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]2", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"KetX", "[", "0", "]"}], "\[TensorProduct]", 
    RowBox[{"BraX", "[", "0", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.616708936423403*^9, 3.616708940628549*^9}, 
   3.6167090276581917`*^9},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101519733*^9, 3.624968925228435*^9, 
  3.6251847055474567`*^9, 3.655403432956851*^9, 3.657377204152519*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["The initial state is therefore:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]12", "=", 
  RowBox[{"AF", "[", 
   RowBox[{"\[Rho]1", " ", "\[TensorProduct]", " ", "\[Rho]2"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.616709050438341*^9, 3.616709058332323*^9}},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.02656239549746037`", "0.02656239549746037`", 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}]},
     {"0.02656239549746037`", "0.02656239549746037`", 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      "0.47343760450253963`", "0.47343760450253963`"},
     {
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      "0.47343760450253963`", "0.47343760450253963`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101543392*^9, 3.62496892524574*^9, 
  3.625184705561448*^9, 3.6554034330236273`*^9, 3.657377204167227*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["We perform the control phase operation between the \
two qubits,", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]CP", "=", 
  RowBox[{"Chop", "[", " ", 
   RowBox[{
    RowBox[{"CPHASE", "[", 
     RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", "\[Rho]12", ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"CPHASE", "[", 
      RowBox[{"2", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.02656239549746037`", "0.02656239549746037`", 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03161091500905114`"}], "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}]},
     {"0.02656239549746037`", "0.02656239549746037`", 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03161091500905114`"}], "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03161091500905114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      "0.47343760450253963`", 
      RowBox[{"-", "0.47343760450253963`"}]},
     {
      RowBox[{
       RowBox[{"-", "0.03161091500905114`"}], "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03161091500905114`"}], "+", 
       RowBox[{"0.0897064264881928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"-", "0.47343760450253963`"}], "0.47343760450253963`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101555797*^9, 3.6249689252789803`*^9, 
  3.6251847055801983`*^9, 3.655403433263802*^9, 3.65737720418722*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["Now we measure the second Qubit, in the Z basis:", \
"DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["P", "a_"], ":=", 
   RowBox[{"AF", "[", 
    RowBox[{"\[DoubleStruckCapitalI]", "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "a"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]M", "[", "a_", "]"}], " ", ":=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", " ", 
     RowBox[{"2", "*", 
      RowBox[{
       SubscriptBox["P", "a"], ".", "\[Rho]CP", ".", 
       SubscriptBox["P", "a"]}]}]}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6167090735761414`*^9, 3.616709083260242*^9}},
 CellTags->"b:0.0.0"],

Cell[TextData[StyleBox["The two possible remaining density matrices for Qubit \
one are,", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]M", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]M", "[", "1", "]"}]}], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.053124790994920734`", 
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771015784693`*^9, 3.624968925328445*^9, 
  3.625184705596527*^9, 3.655403433363213*^9, 3.657377204207304*^9},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.053124790994920734`", 
      RowBox[{
       RowBox[{"-", "0.06322183001810228`"}], "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.06322183001810228`"}], "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771015784693`*^9, 3.624968925328445*^9, 
  3.625184705596527*^9, 3.655403433363213*^9, 3.65737720421192*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["second Circuit", "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" is simply:", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]M2C", "[", "a_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"MatrixPower", "[", 
     RowBox[{
      SubscriptBox["\[Sigma]", "3"], ",", "a"}], "]"}], ".", "\[Rho]1", ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"MatrixPower", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "3"], ",", "a"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]M2C", "[", "0", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]M2C", "[", "1", "]"}], "]"}]}], "Input",
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.05312479099492074`", 
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.06322183001810228`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101594195*^9, 3.624968925361363*^9, 
  3.62518470563034*^9, 3.655403433459659*^9, 3.657377204235733*^9},
 CellTags->"b:0.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.05312479099492074`", 
      RowBox[{
       RowBox[{"-", "0.06322183001810228`"}], "-", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.06322183001810228`"}], "+", 
       RowBox[{"0.1794128529763856`", " ", "\[ImaginaryI]"}]}], 
      "0.9468752090050793`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101594195*^9, 3.624968925361363*^9, 
  3.62518470563034*^9, 3.655403433459659*^9, 3.65737720423997*^9},
 CellTags->"b:0.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]M2C", "[", "0", "]"}], "]"}], "==", 
  RowBox[{"\[Rho]M", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]M2C", "[", "1", "]"}], "]"}], "==", 
  RowBox[{"\[Rho]M", "[", "1", "]"}]}]}], "Input",
 CellChangeTimes->{{3.616776906136436*^9, 3.616776920399952*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101623077*^9, 3.6249689253937387`*^9, 
  3.6251847056623087`*^9, 3.655403433558507*^9, 3.657377204252138*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777101623077*^9, 3.6249689253937387`*^9, 
  3.6251847056623087`*^9, 3.655403433558507*^9, 3.657377204256173*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Identity Gate with 3 qubits", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:0.0.1"}],

Cell[TextData[StyleBox["We set the number of Qubits to 3",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", "3"}], ";"}]], "Input",
 CellTags->"b:0.0.1"],

Cell[TextData[StyleBox["Decide whether the computation will be carried out \
numerically (icalc=0) or \nalgebraically (icalc=1)",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Icalc", "=", "0"}]], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145545768*^9, 3.624968925446054*^9, 
  3.625184705697545*^9, 3.655403433663823*^9, 3.657377204290942*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure1", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/ClusterI3q.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure1", "]"}]}], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJy11M1twyAUAOCnqodcufTerNAJWnmCVNybSM21UVrpKRuwAiuwAit4BVZg
BQrImMfPJdR9ki3M95KHwfB8+jqcHwDge+dvhyO+Xq/H2/ujf3i7/XyeAj0F
8Zf7p7CCMwDGpd1IcUIdno1C0f7kfrWoScVLNZARxTLpUo3hfhVVWV1kDait
yjg3kbQRFarupfM/otzUvZrn9oiy2Jo5OrOHuHCW5QxWY6tFBE27Rlj7sjTJ
RoIGO0oDSK8SaZ4B14AGe1r+I1vXjqVZoe9la+wq6fLrnT56zZdVnMncJ12x
qzmCipTKtZWxoWTOSLpiV3MENcuUM5COx6JI3mXRjD0lERWroZui8JBuflL4
3Uk+ff3RnFcjKlDNgbWYmr0/qFbyvT/Zp/p0+rtuEb9aTF3o
    "], {{0, 0}, {82, 22}}, {
    0, 255},
    ColorFunction->GrayLevel],
   ImageSize->{82, 22},
   PlotRange->{{0, 82}, {0, 22}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771456606007`*^9, 3.6249689254778557`*^9, 
  3.625184705730389*^9, 3.655403433725707*^9, 3.6573772043203793`*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["We'll show that the circuit in the figure is equivalent to doing \
nothing on qubit 1.\nThe", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" unknown qubit one", "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[", will be generated at Random:", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]", "=", "RandomQubit1"}]], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3095976661904875`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095125`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145684291*^9, 3.624968925496312*^9, 
  3.625184705742071*^9, 3.6554034337766113`*^9, 3.6573772043322678`*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{"Icalc", "==", "1"}], ",", 
    RowBox[{"\[Rho]1", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"A", "*", 
         RowBox[{"Ket", "[", "0", "]"}]}], "+", 
        RowBox[{"B", "*", 
         RowBox[{"Ket", "[", "1", "]"}]}]}], ")"}], "\[TensorProduct]", 
      RowBox[{"Adj", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A", "*", 
          RowBox[{"Ket", "[", "0", "]"}]}], "+", 
         RowBox[{"B", "*", 
          RowBox[{"Ket", "[", "1", "]"}]}]}], ")"}], "]"}]}]}], ",", 
    RowBox[{"\[Rho]1", "=", "\[Rho]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", "\[Rho]1"}], "Input",
 CellChangeTimes->{3.6167091277891397`*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3095976661904875`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095125`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145694392*^9, 3.6249689255289593`*^9, 
  3.625184705753479*^9, 3.655403433841649*^9, 3.657377204352754*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["second and third ones are in the |+\[RightAngleBracket] state", 
  "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[", its density matrix are thus:", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]2", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"KetX", "[", "0", "]"}], "\[TensorProduct]", 
    RowBox[{"BraX", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]3", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"KetX", "[", "0", "]"}], "\[TensorProduct]", 
    RowBox[{"BraX", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.616709156811275*^9, 3.616709182863801*^9}},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145703294*^9, 3.624968925546268*^9, 
  3.625184705780973*^9, 3.6554034339078407`*^9, 3.65737720436845*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145703294*^9, 3.624968925546268*^9, 
  3.625184705780973*^9, 3.6554034339078407`*^9, 3.6573772043726673`*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["initial state", "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" i", "DisplayText",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["s therefo", "DisplayText",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["re:", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]123", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
   "\[Rho]1", " ", "\[TensorProduct]", " ", "\[Rho]2", "\[TensorProduct]", 
    "\[Rho]3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.616709195176017*^9, 3.61670920949111*^9}},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      "0.07739941654762188`", 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      "0.07739941654762188`", 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      "0.07739941654762188`", 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      "0.07739941654762188`", 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", "0.17260058345237814`", 
      "0.17260058345237814`"},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", "0.17260058345237814`", 
      "0.17260058345237814`"},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", "0.17260058345237814`", 
      "0.17260058345237814`"},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", "0.17260058345237814`", 
      "0.17260058345237814`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145734655*^9, 3.624968925578467*^9, 
  3.6251847058134327`*^9, 3.655403434024193*^9, 3.657377204402841*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[StyleBox["We perform the control phase operation between the \
three qubits,", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"CPOp", "=", 
   RowBox[{
    RowBox[{"CPHASE", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"3", ",", "2", ",", "3"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]CP", "=", 
  RowBox[{"Chop", "[", " ", 
   RowBox[{"CPOp", ".", "\[Rho]123", ".", 
    RowBox[{"Adj", "[", "CPOp", "]"}]}], "]"}]}]}], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      
      RowBox[{"-", "0.07739941654762188`"}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      
      RowBox[{"-", "0.07739941654762188`"}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {"0.07739941654762188`", "0.07739941654762188`", "0.07739941654762188`", 
      
      RowBox[{"-", "0.07739941654762188`"}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"-", "0.07739941654762188`"}], 
      RowBox[{"-", "0.07739941654762188`"}], 
      RowBox[{"-", "0.07739941654762188`"}], "0.07739941654762188`", 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", 
      RowBox[{"-", "0.17260058345237814`"}], "0.17260058345237814`"},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", 
      RowBox[{"-", "0.17260058345237814`"}], "0.17260058345237814`"},
     {
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"-", "0.17260058345237814`"}], 
      RowBox[{"-", "0.17260058345237814`"}], "0.17260058345237814`", 
      RowBox[{"-", "0.17260058345237814`"}]},
     {
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.037899134411639446`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.037899134411639446`"}], "+", 
       RowBox[{"0.03413330839869818`", " ", "\[ImaginaryI]"}]}], 
      "0.17260058345237814`", "0.17260058345237814`", 
      RowBox[{"-", "0.17260058345237814`"}], "0.17260058345237814`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771457450743`*^9, 3.624968925596923*^9, 
  3.625184705826949*^9, 3.655403434091488*^9, 3.657377204437392*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Now we ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["measure the first and second Qubits, in the X basis:", 
  "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_"}]], ":=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"PX", "[", "a", "]"}], "\[TensorProduct]", 
    RowBox[{"PX", "[", "b", "]"}], "\[TensorProduct]", 
    "\[DoubleStruckCapitalI]"}], "]"}], " "}]], "Input",
 CellChangeTimes->{
  3.616709763302298*^9, {3.6167102096460447`*^9, 3.6167102461277723`*^9}, {
   3.616777010152708*^9, 3.616777016538834*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox["P", 
  RowBox[{"1", ",", "1"}]]], "Input",
 CellChangeTimes->{{3.616709778296945*^9, 3.6167097922020607`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0"},
     {"0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"]},
     {
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}]},
     {
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}]},
     {
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"], "0"},
     {"0", 
      FractionBox["1", "4"], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      RowBox[{"-", 
       FractionBox["1", "4"]}], "0", 
      FractionBox["1", "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145771978*^9, 3.624968925646387*^9, 
  3.625184705853788*^9, 3.6554034342532387`*^9, 3.657377204478058*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]M", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], " ", ":=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", " ", 
     RowBox[{
      RowBox[{"2", "^", "2"}], "*", 
      RowBox[{
       SubscriptBox["P", 
        RowBox[{"a", ",", "b"}]], ".", "\[Rho]CP", ".", 
       SubscriptBox["P", 
        RowBox[{"a", ",", "b"}]]}]}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.616709224746393*^9, 3.616709249403404*^9}, {
   3.616709281859956*^9, 3.616709335251461*^9}, {3.616709385691539*^9, 
   3.6167094078650513`*^9}, {3.616709585966175*^9, 3.616709588609523*^9}, 
   3.616709703422193*^9, 3.616777033088513*^9},
 CellTags->"b:0.0.1"],

Cell[TextData[StyleBox["The gate is realized up to a prefactor depending on \
the measurements which is of the form:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prefactor", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     RowBox[{"s", "[", "1", "]"}], ",", "b"}], "]"}], ".", 
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     RowBox[{"s", "[", "3", "]"}], ",", "a"}], "]"}]}]}]], "Input",
 CellTags->"b:0.0.1"],

Cell[TextData[{
 StyleBox["The action of the ",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["prefactor",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" can removed performing:",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]Final", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prefactor", "[", 
    RowBox[{"a", ",", "b"}], "]"}], ".", 
   RowBox[{"\[Rho]M", "[", 
    RowBox[{"a", ",", "b"}], "]"}], ".", 
   RowBox[{"Adj", "[", 
    RowBox[{"Prefactor", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "]"}]}]}]], "Input",
 CellTags->"b:0.0.1"],

Cell[TextData[StyleBox["We can then plot the four possible outcomes, which \
should all give the matrix, \nirrespective of the measured values at this \
point:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]Final", "[", 
   RowBox[{"0", ",", "0"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]Final", "[", 
   RowBox[{"1", ",", "0"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]Final", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]Final", "[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3095976661904875`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095124`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145806278*^9, 3.624968925728859*^9, 
  3.6251847058910847`*^9, 3.6554034343410597`*^9, 3.657377204519053*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3095976661904875`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095124`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145806278*^9, 3.624968925728859*^9, 
  3.6251847058910847`*^9, 3.6554034343410597`*^9, 3.657377204523418*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.30959766619048756`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095124`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145806278*^9, 3.624968925728859*^9, 
  3.6251847058910847`*^9, 3.6554034343410597`*^9, 3.657377204526626*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.30959766619048756`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095124`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145806278*^9, 3.624968925728859*^9, 
  3.6251847058910847`*^9, 3.6554034343410597`*^9, 3.657377204529605*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The Identity", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" Circuit", "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" is simply:", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.0.1"],

Cell[CellGroupData[{

Cell[BoxData["\[Rho]1"], "Input",
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3095976661904875`", 
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15159653764655778`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.13653323359479272`", " ", "\[ImaginaryI]"}]}], 
      "0.6904023338095125`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771458350277`*^9, 3.624968925779797*^9, 
  3.625184705930579*^9, 3.655403434542583*^9, 3.657377204554379*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]Final", "[", 
    RowBox[{"0", ",", "0"}], "]"}], "]"}], "==", 
  "\[Rho]1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]Final", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "]"}], "==", 
  "\[Rho]1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]Final", "[", 
    RowBox[{"0", ",", "1"}], "]"}], "]"}], "==", 
  "\[Rho]1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"\[Rho]Final", "[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}], "==", "\[Rho]1"}]}], "Input",
 CellChangeTimes->{{3.616777062447845*^9, 3.616777078028553*^9}},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145848106*^9, 3.624968925810566*^9, 
  3.625184705941867*^9, 3.655403434608623*^9, 3.6573772045678453`*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145848106*^9, 3.624968925810566*^9, 
  3.625184705941867*^9, 3.655403434608623*^9, 3.6573772045715113`*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145848106*^9, 3.624968925810566*^9, 
  3.625184705941867*^9, 3.655403434608623*^9, 3.6573772045740833`*^9},
 CellTags->"b:0.0.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777145848106*^9, 3.624968925810566*^9, 
  3.625184705941867*^9, 3.655403434608623*^9, 3.6573772045769176`*^9},
 CellTags->"b:0.0.1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.616710634870246*^9, 3.6167106404761972`*^9}}],

Cell[TextData[{
 "Last Version:18-Aug-2005\n",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{"References", ":"}], 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"[", "1", "]"}], " ", 
         RowBox[{"R", ".", " ", "Raussendorf"}], " ", "and", " ", 
         RowBox[{"H", ".", " ", "J", ".", " ", "Briegel"}]}], ",", " ", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "Lett", ".", " ", "86"}], 
         " ", 
         RowBox[{"(", "2001", ")"}], " ", "5188"}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", 
         RowBox[{"R", ".", " ", "Raussendorf"}]}], ",", " ", 
        RowBox[{
         RowBox[{"D", ".", " ", "Brownie"}], " ", "and", " ", 
         RowBox[{"H", ".", "J", ".", " ", "Briegel"}]}], ",", " ", "\n", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "A"}], " ", "68"}], ",", 
        " ", 
        RowBox[{"022312", " ", 
         RowBox[{"(", "2003", ")"}]}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", "Michael", " ", 
         RowBox[{"I", ".", " ", "Nielsen"}]}], ",", " ", 
        RowBox[{"quant", "-", 
         RowBox[{"ph", "/", "0504097"}]}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "3", "]"}], " ", "QDENSITY", " ", "manual"}], ",", " ", 
        
        RowBox[{"Sect", ".", " ", "11"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
      "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}], TraditionalForm]], 
  "DefinitionBox",
  GridBoxOptions->{
  GridBoxDividers->{
   "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
    "RowsIndexed" -> {}},
  GridBoxSpacings->{"Columns" -> {
      Offset[0.27999999999999997`], {
       Offset[0.5599999999999999]}, 
      Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
      Offset[0.2], {
       Offset[0.16]}, 
      Offset[0.2]}, "RowsIndexed" -> {}}},
  CellTags->"S5.1.1"]
}], "Abstract",
 CellTags->"b:0.0.1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["An example of CNOT gate in the cluster model approach", "Section",
 FontFamily->"Times",
 CellTags->"c:5"],

Cell[CellGroupData[{

Cell["Step 1: Build the cluster state", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:6", "b:0.1.0"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 CellTags->"b:0.1.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.616777167963558*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["?QDENSITY`Qdensity`*", "Input",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3616762767-9341626", {"CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"s", "QDENSITY`Qdensity`"}},
          
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3616762767-9341626", {"SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3616762767-9341626", {"Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.61677716799409*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["The diagrammatic representation of the gate, as in \
Ref.[1], is :", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<QDENSITY/drawings/CNOTc4qubits.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJzt3WuuG0UQhmFD+IHEKlhKWEJYQSLBX6SAhLI6lmYOOsIa9aWm7/119/tI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    "], {{0, 0}, {267, 
    191}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{267, 191},
   PlotRange->{{0, 267}, {0, 191}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771681781197`*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["Icalc controls whether the qubits are handeld \
algebraically (1) or numerically (0):", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Icalc", "=", "0"}], ";"}]], "Input",
 CellTags->"b:0.1.0"],

Cell[TextData[StyleBox["Set total number of qubits to 4:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nq", "=", "4"}], ";"}]], "Input",
 CellTags->"b:0.1.0"],

Cell[TextData[StyleBox["The figure tells us that qubits 2 and 3 are in |+\
\[RightAngleBracket] state while qubits 1 (target) and 4 (control) are in \na \
general 1 qubit state:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ket1", "=", "RandomKet1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ket4", "=", "RandomKet1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{"Icalc", "\[Equal]", "1"}], ",", 
    RowBox[{
     RowBox[{"ket1", "=", 
      RowBox[{"Ket1", "[", 
       RowBox[{
        SubscriptBox["\[Theta]", "1"], ",", 
        SubscriptBox["\[Phi]", "1"]}], "]"}]}], ";", 
     RowBox[{"ket4", "=", 
      RowBox[{"Ket1", "[", 
       RowBox[{
        SubscriptBox["\[Theta]", "4"], ",", 
        SubscriptBox["\[Phi]", "4"]}], "]"}]}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", "ket1", "\[IndentingNewLine]", "ket4"}], \
"Input",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.004857408835732322`"}], "+", 
       RowBox[{"0.8133222836712083`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.5051693409964685`"}], "-", 
       RowBox[{"0.2885952275773921`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168301903*^9},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.1908183228261877`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.6009942767213168`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.5955131401309829`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.49775329928927475`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168304638*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["The structure of the Cluster is essentially described \
in ClusterLinks, which \ncontains the pairs of CPHASE interacting qubits:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"NCS", "=", "nq"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClusterLinks", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Nlinks", "=", 
  RowBox[{"Length", "[", "ClusterLinks", "]"}]}]}], "Input",
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox["4",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168314919*^9},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168319009*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["The 4 qubit initial state before building in the \
correlations is:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InitialState", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"ket1", "\[TensorProduct]", 
     RowBox[{"KetX", "[", "0", "]"}], "\[TensorProduct]", 
     RowBox[{"KetX", "[", "0", "]"}], "\[TensorProduct]", "ket4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]initial", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"InitialState", "\[TensorProduct]", 
     RowBox[{"Adj", "[", "InitialState", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Tr", "[", "\[Rho]initial", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.61671043315341*^9, 3.616710504866544*^9}, 
   3.616710569010128*^9, 3.616710730517968*^9, 3.616710768484768*^9, {
   3.6167108314710913`*^9, 3.616710842225979*^9}, {3.616710888450427*^9, 
   3.616710930037013*^9}},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox["0.9999999999999992`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168332642*^9},
 CellTags->"b:0.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["We define recursively the operation of the CPHASE \
gates:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CPhaseG", "[", "0", "]"}], "=", "InitialState"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CPhaseG", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"ChpaseG", "[", "i", "]"}], "=", 
    RowBox[{"CPHASEV", "[", 
     RowBox[{
      RowBox[{"ClusterLinks", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
      RowBox[{"ClusterLinks", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
      RowBox[{"CPhaseG", "[", 
       RowBox[{"i", "-", "1"}], "]"}]}], "]"}]}]}], ";"}]}], "Input",
 CellTags->"b:0.1.0"],

Cell[TextData[StyleBox["We compute the cluster vector and build its pure \
state density matrix:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"ClusterVector", "=", 
  RowBox[{"CPhaseG", "[", "Nlinks", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ClusterDensity", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"ClusterVector", "\[TensorProduct]", 
     RowBox[{"Adj", "[", "ClusterVector", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Tr", "[", "ClusterDensity", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Eigenvalues", "[", "ClusterDensity", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.616710982724258*^9, 3.616711005161613*^9}, 
   3.616712197592655*^9},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.24486446011181145`"}], "+", 
       RowBox[{"0.07613875958866706`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.20386325043574913`"}], "+", 
       RowBox[{"0.2409631579067803`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.24486446011181145`"}], "+", 
       RowBox[{"0.07613875958866706`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.20386325043574913`"}], "+", 
       RowBox[{"0.2409631579067803`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.24486446011181145`"}], "+", 
       RowBox[{"0.07613875958866706`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.20386325043574913`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.2409631579067803`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.24486446011181145`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.07613875958866706`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.20386325043574913`"}], "+", 
       RowBox[{"0.2409631579067803`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.03852425683547098`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1793365700079583`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.07859287693446008`"}], "-", 
       RowBox[{"0.21165597819110463`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.03852425683547098`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1793365700079583`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.07859287693446008`"}], "-", 
       RowBox[{"0.21165597819110463`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03852425683547098`"}], "+", 
       RowBox[{"0.1793365700079583`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.07859287693446008`"}], "-", 
       RowBox[{"0.21165597819110463`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.03852425683547098`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1793365700079583`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.07859287693446008`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.21165597819110463`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168362328*^9},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox["0.9999999999999992`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168366953*^9},
 CellTags->"b:0.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1.0000000000000002`"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168370471*^9},
 CellTags->"b:0.1.0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Measure qubits 1 and 2 in the X basis", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:7", "b:0.1.1"}],

Cell[TextData[StyleBox["Preparation of measurements on the X bases for qubits \
1 and 2, first build the proyectors\nand then operate and Trace Off the \
measured qubits:",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.1"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_"}]], ":=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"PX", "[", "a", "]"}], " ", "\[TensorProduct]", " ", 
    RowBox[{"PX", "[", "b", "]"}], " ", "\[TensorProduct]", 
    "\[DoubleStruckCapitalI]", "  ", "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.616711063704723*^9, 3.616711088913883*^9}, {
  3.616712322113811*^9, 3.616712322730981*^9}, {3.61671296999189*^9, 
  3.616712980069525*^9}},
 CellTags->"b:0.1.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]M", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], " ", ":=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", " ", 
     RowBox[{
      RowBox[{"2", "^", "2"}], "*", 
      RowBox[{
       SubscriptBox["P", 
        RowBox[{"a", ",", "b"}]], ".", "ClusterDensity", ".", 
       RowBox[{"Adj", "[", 
        SubscriptBox["P", 
         RowBox[{"a", ",", "b"}]], "]"}]}]}]}], "]"}], "]"}]}]], "Input"],

Cell[TextData[StyleBox["The result of the measurement is generated at \
random:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"M1", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "]"}]}], "\n", 
 RowBox[{"M2", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "]"}]}]}], "Input",
 CellTags->"b:0.1.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771684006166`*^9},
 CellTags->"b:0.1.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168403153*^9},
 CellTags->"b:0.1.1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 3: Undo prefactor cluster operations and compare to usual CNOT gate\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:8", "b:0.1.2"}],

Cell[TextData[StyleBox["According to their PRL paper the outcome in qubits 3 \
and 4 will be \nthe target of the CNOT[1,4] and the control untouched up to \
this \noperations. We undo them to compare. The prefactor operations are:", \
"DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrefactorOp", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MatrixPower", "[", 
       RowBox[{
        RowBox[{"s", "[", "3", "]"}], ",", "M1"}], "]"}], ".", 
      RowBox[{"MatrixPower", "[", 
       RowBox[{
        RowBox[{"s", "[", "1", "]"}], ",", "M2"}], "]"}]}], ")"}], 
    "\[TensorProduct]", 
    RowBox[{"MatrixPower", "[", 
     RowBox[{
      RowBox[{"s", "[", "3", "]"}], ",", "M1"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.616711113159659*^9, 3.616711138658896*^9}, {
   3.616711169572579*^9, 3.6167112135594187`*^9}, {3.616711467851672*^9, 
   3.616711494029461*^9}, {3.616711532828186*^9, 3.616711537732802*^9}, 
   3.6167115830365067`*^9, 3.616711951030356*^9, {3.616712049741931*^9, 
   3.6167120595290823`*^9}},
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]},
     {
      RowBox[{"-", "1"}], "0", "0", "0"},
     {"0", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6167771684130573`*^9},
 CellTags->"b:0.1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A34", "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PrefactorOp", ".", 
    RowBox[{"\[Rho]M", "[", 
     RowBox[{"M1", ",", "M2"}], "]"}], ".", 
    RowBox[{"Adj", "[", "PrefactorOp", "]"}]}], "]"}]}]], "Input",
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.263022858150199`", 
      RowBox[{"0.012517514960775716`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.23124396396598698`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.09235074136207383`"}], "-", 
       RowBox[{"0.16391985305509923`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.27306200281671633`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.17392567421515678`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.012517514960775716`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.23124396396598698`", " ", "\[ImaginaryI]"}]}], 
      "0.20390037363547417`", 
      RowBox[{"0.13971969989604094`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0889938649643224`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.13991637416728536`"}], "+", 
       RowBox[{"0.24834745401321232`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.09235074136207383`"}], "+", 
       RowBox[{"0.16391985305509923`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.13971969989604094`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0889938649643224`", " ", "\[ImaginaryI]"}]}], 
      "0.13458289482777863`", 
      RowBox[{
       RowBox[{"-", "0.204268745825555`"}], "+", 
       RowBox[{"0.10910883800293489`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.27306200281671633`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.17392567421515678`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.13991637416728536`"}], "-", 
       RowBox[{"0.24834745401321232`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.204268745825555`"}], "-", 
       RowBox[{"0.10910883800293489`", " ", "\[ImaginaryI]"}]}], 
      "0.3984938733865476`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168449635*^9},
 CellTags->"b:0.1.2"]
}, Open  ]],

Cell[TextData[StyleBox["The reduced density matrix for both qubits are:", \
"DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Chop", "[", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", "A34"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "A34"}], "]"}], "]"}]}], "Input",
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.4669232317856732`", 
      RowBox[{
       RowBox[{"-", "0.2322671155293592`"}], "+", 
       RowBox[{"0.08442760095811308`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2322671155293592`"}], "-", 
       RowBox[{"0.08442760095811308`", " ", "\[ImaginaryI]"}]}], 
      "0.5330767682143263`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168473525*^9},
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3976057529779776`", 
      RowBox[{
       RowBox[{"-", "0.19175123086477927`"}], "-", 
       RowBox[{"0.12213512596305211`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.19175123086477927`"}], "+", 
       RowBox[{"0.12213512596305211`", " ", "\[ImaginaryI]"}]}], 
      "0.6023942470220218`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.61677716847707*^9},
 CellTags->"b:0.1.2"]
}, Open  ]],

Cell[TextData[{
 StyleBox["And we ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox["compare with a standard realization of the CNOT", "DisplayText",
  FontWeight->"Bold",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 StyleBox[" gate between 1 and 4.", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:0.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ket14", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"ket1", "\[TensorProduct]", "ket4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]14", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"Ket14", "\[TensorProduct]", 
     RowBox[{"Adj", "[", "Ket14", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CN14", "=", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"CNOT", "[", 
      RowBox[{"2", ",", "2", ",", "1"}], "]"}], ".", "\[Rho]14", ".", 
     RowBox[{"Adj", "[", 
      RowBox[{"CNOT", "[", 
       RowBox[{"2", ",", "2", ",", "1"}], "]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", "CN14"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "CN14"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.616713077617625*^9, 3.616713134210723*^9}},
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.4669232317856733`", 
      RowBox[{
       RowBox[{"-", "0.2322671155293593`"}], "+", 
       RowBox[{"0.08442760095811305`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2322671155293593`"}], "-", 
       RowBox[{"0.08442760095811305`", " ", "\[ImaginaryI]"}]}], 
      "0.5330767682143265`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168487946*^9},
 CellTags->"b:0.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.39760575297797784`", 
      RowBox[{
       RowBox[{"-", "0.19175123086477935`"}], "-", 
       RowBox[{"0.12213512596305212`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.19175123086477935`"}], "+", 
       RowBox[{"0.12213512596305212`", " ", "\[ImaginaryI]"}]}], 
      "0.6023942470220219`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616777168491146*^9},
 CellTags->"b:0.1.2"]
}, Open  ]],

Cell[BoxData["Quit"], "Input",
 CellTags->"b:0.1.2"],

Cell[TextData[{
 "Last Version:1-Aug-2014\n",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{"References", ":"}], 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"[", "1", "]"}], " ", 
         RowBox[{"R", ".", " ", "Raussendorf"}], " ", "and", " ", 
         RowBox[{"H", ".", " ", "J", ".", " ", "Briegel"}]}], ",", " ", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "Lett", ".", " ", "86"}], 
         " ", 
         RowBox[{"(", "2001", ")"}], " ", "5188"}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", 
         RowBox[{"R", ".", " ", "Raussendorf"}]}], ",", " ", 
        RowBox[{
         RowBox[{"D", ".", " ", "Brownie"}], " ", "and", " ", 
         RowBox[{"H", ".", "J", ".", " ", "Briegel"}]}], ",", " ", "\n", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "A"}], " ", "68"}], ",", 
        " ", 
        RowBox[{"022312", " ", 
         RowBox[{"(", "2003", ")"}]}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", "Michael", " ", 
         RowBox[{"I", ".", " ", "Nielsen"}]}], ",", " ", 
        RowBox[{"quant", "-", 
         RowBox[{"ph", "/", "0504097"}]}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "3", "]"}], " ", "QDENSITY", " ", "manual"}], ",", " ", 
        
        RowBox[{"Sect", ".", " ", "11"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
      "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}], TraditionalForm]], 
  "DefinitionBox",
  GridBoxOptions->{
  GridBoxDividers->{
   "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
    "RowsIndexed" -> {}},
  GridBoxSpacings->{"Columns" -> {
      Offset[0.27999999999999997`], {
       Offset[0.5599999999999999]}, 
      Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
      Offset[0.2], {
       Offset[0.16]}, 
      Offset[0.2]}, "RowsIndexed" -> {}}},
  CellTags->"S5.1.1"]
}], "Abstract",
 CellChangeTimes->{{3.616777257062727*^9, 3.616777260953898*^9}},
 CellTags->"b:0.1.2"]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"Working",
WindowToolbars->{},
WindowSize->{900, 626},
WindowMargins->{{279, Automatic}, {130, Automatic}},
PrintingStartingPageNumber->77,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"export", "home", "brunojd"}, 
  "c.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 23.409337`8.121964096655068}, {77, 
    77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 78, 78, 78, 78, 78, 
    78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 79, 79, 79, 79, 79, 79, 79, 
    79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 80, 80, 80, 80, 80, 80, 80, 80, 
    80, 80, 80, 80, 80, 80, 80, 80, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 
    81, 81, 81, 81, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82}, 
    Automatic}},
CellLabelAutoDelete->True,
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 59, 1, 51, "Title",
   CellTags->"c:1"]},
 "c:2"->{
  Cell[1080, 38, 277, 6, 51, "Section",
   CellTags->"c:2"]},
 "c:3"->{
  Cell[1382, 48, 108, 3, 58, "Subsection",
   CellTags->{"c:3", "b:0.0.0"}]},
 "b:0.0.0"->{
  Cell[1382, 48, 108, 3, 58, "Subsection",
   CellTags->{"c:3", "b:0.0.0"}],
  Cell[1493, 53, 138, 3, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[1634, 58, 105, 2, 46, "Input",
   CellTags->"b:0.0.0"],
  Cell[1764, 64, 59, 1, 45, "Input",
   CellTags->"b:0.0.0"],
  Cell[1826, 67, 33527, 940, 579, "Print",
   CellTags->"b:0.0.0"],
  Cell[35368, 1010, 1113, 43, 26, "Text",
   CellTags->"b:0.0.0"],
  Cell[36484, 1055, 200, 5, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[36687, 1062, 91, 3, 46, "Input",
   CellTags->"b:0.0.0"],
  Cell[36781, 1067, 271, 6, 51, "Text",
   CellTags->"b:0.0.0"],
  Cell[37077, 1077, 75, 2, 45, "Input",
   CellTags->"b:0.0.0"],
  Cell[37155, 1081, 245, 6, 45, "Output",
   CellTags->"b:0.0.0"],
  Cell[37437, 1092, 470, 13, 94, "Input",
   CellTags->"b:0.0.0"],
  Cell[37910, 1107, 9958, 168, 139, "Output",
   CellTags->"b:0.0.0"],
  Cell[47871, 1277, 3985, 70, 78, "Output",
   CellTags->"b:0.0.0"],
  Cell[51871, 1350, 303, 7, 51, "Text",
   CellTags->"b:0.0.0"],
  Cell[52199, 1361, 87, 2, 45, "Input",
   CellTags->"b:0.0.0"],
  Cell[52289, 1365, 1034, 25, 62, "Output",
   CellTags->"b:0.0.0"],
  Cell[53360, 1395, 774, 23, 62, "Input",
   CellTags->"b:0.0.0"],
  Cell[54137, 1420, 1036, 25, 62, "Output",
   CellTags->"b:0.0.0"],
  Cell[55188, 1448, 267, 6, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[55480, 1458, 305, 8, 45, "Input",
   CellTags->"b:0.0.0"],
  Cell[55788, 1468, 842, 24, 80, "Output",
   CellTags->"b:0.0.0"],
  Cell[56645, 1495, 214, 5, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[56884, 1504, 238, 6, 45, "Input",
   CellTags->"b:0.0.0"],
  Cell[57125, 1512, 1973, 40, 94, "Output",
   CellTags->"b:0.0.0"],
  Cell[59113, 1555, 247, 6, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[59385, 1565, 331, 9, 46, "Input",
   CellTags->"b:0.0.0"],
  Cell[59719, 1576, 2024, 45, 94, "Output",
   CellTags->"b:0.0.0"],
  Cell[61758, 1624, 233, 6, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[61994, 1632, 658, 19, 64, "Input",
   CellTags->"b:0.0.0"],
  Cell[62655, 1653, 247, 6, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[62927, 1663, 145, 3, 61, "Input",
   CellTags->"b:0.0.0"],
  Cell[63075, 1668, 1035, 25, 62, "Output",
   CellTags->"b:0.0.0"],
  Cell[64113, 1695, 1040, 27, 62, "Output",
   CellTags->"b:0.0.0"],
  Cell[65168, 1725, 453, 15, 23, "Text",
   CellTags->"b:0.0.0"],
  Cell[65646, 1744, 599, 17, 79, "Input",
   CellTags->"b:0.0.0"],
  Cell[66248, 1763, 1031, 25, 62, "Output",
   CellTags->"b:0.0.0"],
  Cell[67282, 1790, 1036, 27, 62, "Output",
   CellTags->"b:0.0.0"]},
 "c:4"->{
  Cell[69243, 1851, 120, 3, 58, "Subsection",
   CellTags->{"c:4", "b:0.0.1"}]},
 "b:0.0.1"->{
  Cell[69243, 1851, 120, 3, 58, "Subsection",
   CellTags->{"c:4", "b:0.0.1"}],
  Cell[69366, 1856, 200, 5, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[69569, 1863, 91, 3, 46, "Input",
   CellTags->"b:0.0.1"],
  Cell[69663, 1868, 271, 6, 51, "Text",
   CellTags->"b:0.0.1"],
  Cell[69959, 1878, 75, 2, 45, "Input",
   CellTags->"b:0.0.1"],
  Cell[70037, 1882, 245, 6, 45, "Output",
   CellTags->"b:0.0.1"],
  Cell[70319, 1893, 257, 7, 62, "Input",
   CellTags->"b:0.0.1"],
  Cell[70579, 1902, 838, 19, 54, "Output",
   CellTags->"b:0.0.1"],
  Cell[71432, 1924, 563, 16, 51, "Text",
   CellTags->"b:0.0.1"],
  Cell[72020, 1944, 87, 2, 45, "Input",
   CellTags->"b:0.0.1"],
  Cell[72110, 1948, 1037, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[73184, 1978, 774, 23, 62, "Input",
   CellTags->"b:0.0.1"],
  Cell[73961, 2003, 1035, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[75011, 2031, 522, 16, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[75558, 2051, 469, 12, 61, "Input",
   CellTags->"b:0.0.1"],
  Cell[76030, 2065, 841, 24, 80, "Output",
   CellTags->"b:0.0.1"],
  Cell[76874, 2091, 844, 24, 80, "Output",
   CellTags->"b:0.0.1"],
  Cell[77733, 2118, 643, 21, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[78401, 2143, 274, 7, 45, "Input",
   CellTags->"b:0.0.1"],
  Cell[78678, 2152, 5808, 102, 158, "Output",
   CellTags->"b:0.0.1"],
  Cell[84501, 2257, 249, 6, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[84775, 2267, 436, 13, 62, "Input",
   CellTags->"b:0.0.1"],
  Cell[85214, 2282, 6066, 120, 158, "Output",
   CellTags->"b:0.0.1"],
  Cell[91295, 2405, 369, 12, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[94509, 2515, 753, 20, 50, "Input",
   CellTags->"b:0.0.1"],
  Cell[95265, 2537, 275, 6, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[95543, 2545, 347, 11, 46, "Input",
   CellTags->"b:0.0.1"],
  Cell[95893, 2558, 430, 15, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[96326, 2575, 386, 12, 46, "Input",
   CellTags->"b:0.0.1"],
  Cell[96715, 2589, 303, 7, 51, "Text",
   CellTags->"b:0.0.1"],
  Cell[97043, 2600, 503, 13, 94, "Input",
   CellTags->"b:0.0.1"],
  Cell[97549, 2615, 1037, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[98589, 2642, 1037, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[99629, 2669, 1038, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[100670, 2696, 1038, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[101723, 2724, 455, 15, 23, "Text",
   CellTags->"b:0.0.1"],
  Cell[102203, 2743, 55, 1, 45, "Input",
   CellTags->"b:0.0.1"],
  Cell[102261, 2746, 1035, 25, 62, "Output",
   CellTags->"b:0.0.1"],
  Cell[103333, 2776, 706, 21, 94, "Input",
   CellTags->"b:0.0.1"],
  Cell[104042, 2799, 250, 6, 45, "Output",
   CellTags->"b:0.0.1"],
  Cell[104295, 2807, 250, 6, 45, "Output",
   CellTags->"b:0.0.1"],
  Cell[104548, 2815, 250, 6, 45, "Output",
   CellTags->"b:0.0.1"],
  Cell[104801, 2823, 250, 6, 45, "Output",
   CellTags->"b:0.0.1"],
  Cell[105189, 2836, 2052, 57, 95, "Abstract",
   CellTags->"b:0.0.1"]},
 "c:5"->{
  Cell[107290, 2899, 112, 2, 51, "Section",
   CellTags->"c:5"]},
 "c:6"->{
  Cell[107427, 2905, 124, 3, 58, "Subsection",
   CellTags->{"c:6", "b:0.1.0"}]},
 "b:0.1.0"->{
  Cell[107427, 2905, 124, 3, 58, "Subsection",
   CellTags->{"c:6", "b:0.1.0"}],
  Cell[107576, 2912, 105, 2, 46, "Input",
   CellTags->"b:0.1.0"],
  Cell[107684, 2916, 173, 3, 22, "Print",
   CellTags->"b:0.1.0"],
  Cell[107894, 2924, 59, 1, 45, "Input",
   CellTags->"b:0.1.0"],
  Cell[107956, 2927, 18626, 499, 327, "Print",
   CellTags->"b:0.1.0"],
  Cell[126597, 3429, 249, 6, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[126871, 3439, 262, 8, 62, "Input",
   CellTags->"b:0.1.0"],
  Cell[127136, 3449, 3192, 58, 223, "Output",
   CellTags->"b:0.1.0"],
  Cell[130343, 3510, 268, 6, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[130614, 3518, 93, 3, 45, "Input",
   CellTags->"b:0.1.0"],
  Cell[130710, 3523, 200, 5, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[130913, 3530, 90, 3, 46, "Input",
   CellTags->"b:0.1.0"],
  Cell[131006, 3535, 321, 7, 51, "Text",
   CellTags->"b:0.1.0"],
  Cell[131352, 3546, 734, 22, 108, "Input",
   CellTags->"b:0.1.0"],
  Cell[132089, 3570, 893, 25, 62, "Output",
   CellTags->"b:0.1.0"],
  Cell[132985, 3597, 886, 23, 62, "Output",
   CellTags->"b:0.1.0"],
  Cell[133886, 3623, 297, 6, 51, "Text",
   CellTags->"b:0.1.0"],
  Cell[134208, 3633, 472, 14, 78, "Input",
   CellTags->"b:0.1.0"],
  Cell[134683, 3649, 154, 5, 45, "Output",
   CellTags->"b:0.1.0"],
  Cell[134840, 3656, 154, 5, 45, "Output",
   CellTags->"b:0.1.0"],
  Cell[135009, 3664, 235, 6, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[135269, 3674, 843, 20, 78, "Input",
   CellTags->"b:0.1.0"],
  Cell[136115, 3696, 172, 5, 45, "Output",
   CellTags->"b:0.1.0"],
  Cell[136302, 3704, 241, 6, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[136546, 3712, 643, 20, 62, "Input",
   CellTags->"b:0.1.0"],
  Cell[137192, 3734, 255, 6, 23, "Text",
   CellTags->"b:0.1.0"],
  Cell[137472, 3744, 636, 15, 94, "Input",
   CellTags->"b:0.1.0"],
  Cell[138111, 3761, 2829, 75, 286, "Output",
   CellTags->"b:0.1.0"],
  Cell[140943, 3838, 172, 5, 45, "Output",
   CellTags->"b:0.1.0"],
  Cell[141118, 3845, 891, 35, 286, "Output",
   CellTags->"b:0.1.0"]},
 "c:7"->{
  Cell[142058, 3886, 138, 3, 58, "Subsection",
   CellTags->{"c:7", "b:0.1.1"}]},
 "b:0.1.1"->{
  Cell[142058, 3886, 138, 3, 58, "Subsection",
   CellTags->{"c:7", "b:0.1.1"}],
  Cell[142199, 3891, 314, 7, 51, "Text",
   CellTags->"b:0.1.1"],
  Cell[142516, 3900, 543, 13, 48, "Input",
   CellTags->"b:0.1.1"],
  Cell[143577, 3933, 238, 6, 23, "Text",
   CellTags->"b:0.1.1"],
  Cell[143840, 3943, 286, 9, 62, "Input",
   CellTags->"b:0.1.1"],
  Cell[144129, 3954, 156, 5, 45, "Output",
   CellTags->"b:0.1.1"],
  Cell[144288, 3961, 154, 5, 45, "Output",
   CellTags->"b:0.1.1"]},
 "c:8"->{
  Cell[144491, 3972, 173, 5, 58, "Subsection",
   CellTags->{"c:8", "b:0.1.2"}]},
 "b:0.1.2"->{
  Cell[144491, 3972, 173, 5, 58, "Subsection",
   CellTags->{"c:8", "b:0.1.2"}],
  Cell[144667, 3979, 391, 8, 79, "Text",
   CellTags->"b:0.1.2"],
  Cell[145083, 3991, 830, 21, 46, "Input",
   CellTags->"b:0.1.2"],
  Cell[145916, 4014, 769, 23, 94, "Output",
   CellTags->"b:0.1.2"],
  Cell[146722, 4042, 254, 7, 46, "Input",
   CellTags->"b:0.1.2"],
  Cell[146979, 4051, 2331, 54, 94, "Output",
   CellTags->"b:0.1.2"],
  Cell[149325, 4108, 232, 6, 23, "Text",
   CellTags->"b:0.1.2"],
  Cell[149582, 4118, 304, 10, 62, "Input",
   CellTags->"b:0.1.2"],
  Cell[149889, 4130, 946, 26, 62, "Output",
   CellTags->"b:0.1.2"],
  Cell[150838, 4158, 947, 26, 62, "Output",
   CellTags->"b:0.1.2"],
  Cell[151800, 4187, 500, 15, 23, "Text",
   CellTags->"b:0.1.2"],
  Cell[152325, 4206, 1037, 32, 110, "Input",
   CellTags->"b:0.1.2"],
  Cell[153365, 4240, 946, 26, 62, "Output",
   CellTags->"b:0.1.2"],
  Cell[154314, 4268, 949, 26, 62, "Output",
   CellTags->"b:0.1.2"],
  Cell[155278, 4297, 52, 1, 45, "Input",
   CellTags->"b:0.1.2"],
  Cell[155333, 4300, 2117, 58, 95, "Abstract",
   CellTags->"b:0.1.2"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 158690, 4393},
 {"c:2", 158758, 4396},
 {"c:3", 158830, 4399},
 {"b:0.0.0", 158922, 4402},
 {"c:4", 161472, 4479},
 {"b:0.0.1", 161567, 4482},
 {"c:5", 164552, 4571},
 {"c:6", 164628, 4574},
 {"b:0.1.0", 164724, 4577},
 {"c:7", 166778, 4638},
 {"b:0.1.1", 166874, 4641},
 {"c:8", 167369, 4656},
 {"b:0.1.2", 167465, 4659}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 59, 1, 51, "Title",
 CellTags->"c:1"],
Cell[607, 23, 54, 0, 35, "Subtitle"],
Cell[664, 25, 391, 9, 20, "Abstract"],
Cell[CellGroupData[{
Cell[1080, 38, 277, 6, 51, "Section",
 CellTags->"c:2"],
Cell[CellGroupData[{
Cell[1382, 48, 108, 3, 58, "Subsection",
 CellTags->{"c:3", "b:0.0.0"}],
Cell[1493, 53, 138, 3, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[1634, 58, 105, 2, 46, "Input",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[1764, 64, 59, 1, 45, "Input",
 CellTags->"b:0.0.0"],
Cell[1826, 67, 33527, 940, 579, "Print",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[35368, 1010, 1113, 43, 26, "Text",
 CellTags->"b:0.0.0"],
Cell[36484, 1055, 200, 5, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[36687, 1062, 91, 3, 46, "Input",
 CellTags->"b:0.0.0"],
Cell[36781, 1067, 271, 6, 51, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[37077, 1077, 75, 2, 45, "Input",
 CellTags->"b:0.0.0"],
Cell[37155, 1081, 245, 6, 45, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37437, 1092, 470, 13, 94, "Input",
 CellTags->"b:0.0.0"],
Cell[37910, 1107, 9958, 168, 139, "Output",
 CellTags->"b:0.0.0"],
Cell[47871, 1277, 3985, 70, 78, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[51871, 1350, 303, 7, 51, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[52199, 1361, 87, 2, 45, "Input",
 CellTags->"b:0.0.0"],
Cell[52289, 1365, 1034, 25, 62, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53360, 1395, 774, 23, 62, "Input",
 CellTags->"b:0.0.0"],
Cell[54137, 1420, 1036, 25, 62, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[55188, 1448, 267, 6, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[55480, 1458, 305, 8, 45, "Input",
 CellTags->"b:0.0.0"],
Cell[55788, 1468, 842, 24, 80, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[56645, 1495, 214, 5, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[56884, 1504, 238, 6, 45, "Input",
 CellTags->"b:0.0.0"],
Cell[57125, 1512, 1973, 40, 94, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[59113, 1555, 247, 6, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[59385, 1565, 331, 9, 46, "Input",
 CellTags->"b:0.0.0"],
Cell[59719, 1576, 2024, 45, 94, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[61758, 1624, 233, 6, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[61994, 1632, 658, 19, 64, "Input",
 CellTags->"b:0.0.0"],
Cell[62655, 1653, 247, 6, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[62927, 1663, 145, 3, 61, "Input",
 CellTags->"b:0.0.0"],
Cell[63075, 1668, 1035, 25, 62, "Output",
 CellTags->"b:0.0.0"],
Cell[64113, 1695, 1040, 27, 62, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[65168, 1725, 453, 15, 23, "Text",
 CellTags->"b:0.0.0"],
Cell[CellGroupData[{
Cell[65646, 1744, 599, 17, 79, "Input",
 CellTags->"b:0.0.0"],
Cell[66248, 1763, 1031, 25, 62, "Output",
 CellTags->"b:0.0.0"],
Cell[67282, 1790, 1036, 27, 62, "Output",
 CellTags->"b:0.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68355, 1822, 373, 9, 62, "Input"],
Cell[68731, 1833, 230, 5, 45, "Output"],
Cell[68964, 1840, 230, 5, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[69243, 1851, 120, 3, 58, "Subsection",
 CellTags->{"c:4", "b:0.0.1"}],
Cell[69366, 1856, 200, 5, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[69569, 1863, 91, 3, 46, "Input",
 CellTags->"b:0.0.1"],
Cell[69663, 1868, 271, 6, 51, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[69959, 1878, 75, 2, 45, "Input",
 CellTags->"b:0.0.1"],
Cell[70037, 1882, 245, 6, 45, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70319, 1893, 257, 7, 62, "Input",
 CellTags->"b:0.0.1"],
Cell[70579, 1902, 838, 19, 54, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[71432, 1924, 563, 16, 51, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[72020, 1944, 87, 2, 45, "Input",
 CellTags->"b:0.0.1"],
Cell[72110, 1948, 1037, 25, 62, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73184, 1978, 774, 23, 62, "Input",
 CellTags->"b:0.0.1"],
Cell[73961, 2003, 1035, 25, 62, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[75011, 2031, 522, 16, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[75558, 2051, 469, 12, 61, "Input",
 CellTags->"b:0.0.1"],
Cell[76030, 2065, 841, 24, 80, "Output",
 CellTags->"b:0.0.1"],
Cell[76874, 2091, 844, 24, 80, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[77733, 2118, 643, 21, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[78401, 2143, 274, 7, 45, "Input",
 CellTags->"b:0.0.1"],
Cell[78678, 2152, 5808, 102, 158, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[84501, 2257, 249, 6, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[84775, 2267, 436, 13, 62, "Input",
 CellTags->"b:0.0.1"],
Cell[85214, 2282, 6066, 120, 158, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[91295, 2405, 369, 12, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[91667, 2419, 430, 11, 48, "Input"],
Cell[CellGroupData[{
Cell[92122, 2434, 139, 3, 48, "Input"],
Cell[92264, 2439, 2230, 73, 230, "Output"]
}, Open  ]],
Cell[94509, 2515, 753, 20, 50, "Input",
 CellTags->"b:0.0.1"],
Cell[95265, 2537, 275, 6, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[95543, 2545, 347, 11, 46, "Input",
 CellTags->"b:0.0.1"],
Cell[95893, 2558, 430, 15, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[96326, 2575, 386, 12, 46, "Input",
 CellTags->"b:0.0.1"],
Cell[96715, 2589, 303, 7, 51, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[97043, 2600, 503, 13, 94, "Input",
 CellTags->"b:0.0.1"],
Cell[97549, 2615, 1037, 25, 62, "Output",
 CellTags->"b:0.0.1"],
Cell[98589, 2642, 1037, 25, 62, "Output",
 CellTags->"b:0.0.1"],
Cell[99629, 2669, 1038, 25, 62, "Output",
 CellTags->"b:0.0.1"],
Cell[100670, 2696, 1038, 25, 62, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[101723, 2724, 455, 15, 23, "Text",
 CellTags->"b:0.0.1"],
Cell[CellGroupData[{
Cell[102203, 2743, 55, 1, 45, "Input",
 CellTags->"b:0.0.1"],
Cell[102261, 2746, 1035, 25, 62, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103333, 2776, 706, 21, 94, "Input",
 CellTags->"b:0.0.1"],
Cell[104042, 2799, 250, 6, 45, "Output",
 CellTags->"b:0.0.1"],
Cell[104295, 2807, 250, 6, 45, "Output",
 CellTags->"b:0.0.1"],
Cell[104548, 2815, 250, 6, 45, "Output",
 CellTags->"b:0.0.1"],
Cell[104801, 2823, 250, 6, 45, "Output",
 CellTags->"b:0.0.1"]
}, Open  ]],
Cell[105066, 2832, 120, 2, 45, "Input"],
Cell[105189, 2836, 2052, 57, 95, "Abstract",
 CellTags->"b:0.0.1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[107290, 2899, 112, 2, 51, "Section",
 CellTags->"c:5"],
Cell[CellGroupData[{
Cell[107427, 2905, 124, 3, 58, "Subsection",
 CellTags->{"c:6", "b:0.1.0"}],
Cell[CellGroupData[{
Cell[107576, 2912, 105, 2, 46, "Input",
 CellTags->"b:0.1.0"],
Cell[107684, 2916, 173, 3, 22, "Print",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107894, 2924, 59, 1, 45, "Input",
 CellTags->"b:0.1.0"],
Cell[107956, 2927, 18626, 499, 327, "Print",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[126597, 3429, 249, 6, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[CellGroupData[{
Cell[126871, 3439, 262, 8, 62, "Input",
 CellTags->"b:0.1.0"],
Cell[127136, 3449, 3192, 58, 223, "Output",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[130343, 3510, 268, 6, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[130614, 3518, 93, 3, 45, "Input",
 CellTags->"b:0.1.0"],
Cell[130710, 3523, 200, 5, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[130913, 3530, 90, 3, 46, "Input",
 CellTags->"b:0.1.0"],
Cell[131006, 3535, 321, 7, 51, "Text",
 CellTags->"b:0.1.0"],
Cell[CellGroupData[{
Cell[131352, 3546, 734, 22, 108, "Input",
 CellTags->"b:0.1.0"],
Cell[132089, 3570, 893, 25, 62, "Output",
 CellTags->"b:0.1.0"],
Cell[132985, 3597, 886, 23, 62, "Output",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[133886, 3623, 297, 6, 51, "Text",
 CellTags->"b:0.1.0"],
Cell[CellGroupData[{
Cell[134208, 3633, 472, 14, 78, "Input",
 CellTags->"b:0.1.0"],
Cell[134683, 3649, 154, 5, 45, "Output",
 CellTags->"b:0.1.0"],
Cell[134840, 3656, 154, 5, 45, "Output",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[135009, 3664, 235, 6, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[CellGroupData[{
Cell[135269, 3674, 843, 20, 78, "Input",
 CellTags->"b:0.1.0"],
Cell[136115, 3696, 172, 5, 45, "Output",
 CellTags->"b:0.1.0"]
}, Open  ]],
Cell[136302, 3704, 241, 6, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[136546, 3712, 643, 20, 62, "Input",
 CellTags->"b:0.1.0"],
Cell[137192, 3734, 255, 6, 23, "Text",
 CellTags->"b:0.1.0"],
Cell[CellGroupData[{
Cell[137472, 3744, 636, 15, 94, "Input",
 CellTags->"b:0.1.0"],
Cell[138111, 3761, 2829, 75, 286, "Output",
 CellTags->"b:0.1.0"],
Cell[140943, 3838, 172, 5, 45, "Output",
 CellTags->"b:0.1.0"],
Cell[141118, 3845, 891, 35, 286, "Output",
 CellTags->"b:0.1.0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[142058, 3886, 138, 3, 58, "Subsection",
 CellTags->{"c:7", "b:0.1.1"}],
Cell[142199, 3891, 314, 7, 51, "Text",
 CellTags->"b:0.1.1"],
Cell[142516, 3900, 543, 13, 48, "Input",
 CellTags->"b:0.1.1"],
Cell[143062, 3915, 512, 16, 50, "Input"],
Cell[143577, 3933, 238, 6, 23, "Text",
 CellTags->"b:0.1.1"],
Cell[CellGroupData[{
Cell[143840, 3943, 286, 9, 62, "Input",
 CellTags->"b:0.1.1"],
Cell[144129, 3954, 156, 5, 45, "Output",
 CellTags->"b:0.1.1"],
Cell[144288, 3961, 154, 5, 45, "Output",
 CellTags->"b:0.1.1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[144491, 3972, 173, 5, 58, "Subsection",
 CellTags->{"c:8", "b:0.1.2"}],
Cell[144667, 3979, 391, 8, 79, "Text",
 CellTags->"b:0.1.2"],
Cell[CellGroupData[{
Cell[145083, 3991, 830, 21, 46, "Input",
 CellTags->"b:0.1.2"],
Cell[145916, 4014, 769, 23, 94, "Output",
 CellTags->"b:0.1.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146722, 4042, 254, 7, 46, "Input",
 CellTags->"b:0.1.2"],
Cell[146979, 4051, 2331, 54, 94, "Output",
 CellTags->"b:0.1.2"]
}, Open  ]],
Cell[149325, 4108, 232, 6, 23, "Text",
 CellTags->"b:0.1.2"],
Cell[CellGroupData[{
Cell[149582, 4118, 304, 10, 62, "Input",
 CellTags->"b:0.1.2"],
Cell[149889, 4130, 946, 26, 62, "Output",
 CellTags->"b:0.1.2"],
Cell[150838, 4158, 947, 26, 62, "Output",
 CellTags->"b:0.1.2"]
}, Open  ]],
Cell[151800, 4187, 500, 15, 23, "Text",
 CellTags->"b:0.1.2"],
Cell[CellGroupData[{
Cell[152325, 4206, 1037, 32, 110, "Input",
 CellTags->"b:0.1.2"],
Cell[153365, 4240, 946, 26, 62, "Output",
 CellTags->"b:0.1.2"],
Cell[154314, 4268, 949, 26, 62, "Output",
 CellTags->"b:0.1.2"]
}, Open  ]],
Cell[155278, 4297, 52, 1, 45, "Input",
 CellTags->"b:0.1.2"],
Cell[155333, 4300, 2117, 58, 95, "Abstract",
 CellTags->"b:0.1.2"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
