(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    417491,      12052]
NotebookOptionsPosition[    366085,      10693]
NotebookOutlinePosition[    385894,      11123]
CellTagsIndexPosition[    382040,      11055]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Introductory Tutorial  Tour of Functions in QDensity", "Title",
 CellChangeTimes->{{3.614245752001307*^9, 3.61424575865956*^9}, {
  3.61442223595407*^9, 3.614422242848609*^9}},
 CellTags->"c:1"],

Cell["Basic tools in QDENSITY", "Subtitle"],

Cell[TextData[{
 "Version: 5.0-July 2014--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9.0 and 10.3"
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, {
  3.5122043095457993`*^9, 3.512204334243861*^9}, {3.512204716872068*^9, 
  3.512204717487535*^9}, {3.61332114153409*^9, 3.61332117425388*^9}, {
  3.614245762990281*^9, 3.614245774903561*^9}, {3.655397820173614*^9, 
  3.655397820585164*^9}},
 FontSize->24],

Cell[TextData[StyleBox["In this tutorial we provide simple examples of the \
commands  contained in the  QDensity package: \nOther tuorials are provided \
for QCWave and for special applications in other notebook files.",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.61451053161129*^9, 3.614510600783663*^9}, {
  3.6157266998820877`*^9, 3.615726725879055*^9}},
 FontFamily->"Courier New",
 FontSize->24,
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Getting started                To  open   double   \
click at down arrow  --------------------------->>",
 FontSize->24]], "Section",
 CellChangeTimes->{{3.5122044149751883`*^9, 3.512204420963462*^9}, {
  3.512204654694922*^9, 3.512204703295166*^9}},
 FontFamily->"Times",
 CellTags->{"c:2", "b:5.0"}],

Cell[TextData[{
 StyleBox["All the codes simulating quantum circuits will start by loading \
the ",
  FontFamily->"Helvetica"],
 "QDENSITY and QCWave",
 StyleBox[" packages.\nTo make the package fully available copy the QDENSITY  \
directory to this location on \nyour user account:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6140757541788397`*^9, 3.6140758077373037`*^9}},
 TextJustification->0,
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToFileName", "[", " ", 
  RowBox[{"{", 
   RowBox[{"$UserBaseDirectory", ",", " ", "\"\<Applications\>\""}], "}"}], 
  "]"}]], "Input",
 CellTags->"b:5.0"],

Cell[BoxData[
 TagBox["\<\"/Users/franktabakin/Library/Mathematica/Applications/\"\>",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379785491362*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Then you can load the packages ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[" and ",
  FontFamily->"Helvetica"],
 "QCWave ....",
 StyleBox["  using:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613321198283746*^9, 3.6133212155955057`*^9}, {
  3.624626119284376*^9, 3.624626120386023*^9}},
 TextJustification->0,
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<QDENSITY`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<QDENSITY`Qdensity`\>\"", ",", "\"\<QDENSITY`QCWave`\>\"", ",", 
      "\"\<QDENSITY`BTSystem`\>\"", ",", "\"\<QDENSITY`Circuits`\>\""}], 
     "}"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.624625410362973*^9, 3.6246255156047792`*^9}, 
   3.624625556565637*^9, {3.624625593780973*^9, 3.62462560030564*^9}, 
   3.624626128993533*^9}],

Cell[TextData[StyleBox["To see all the commands contained in the package:  ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 CellChangeTimes->{{3.613321230783722*^9, 3.6133212398385773`*^9}, 
   3.6133971194048977`*^9, 3.613397155369432*^9},
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Rho]$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Discord",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Discord", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Mutual",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Mutual", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["neg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "neg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-352349e9-18c9-4adc-8b9a-db9d187d5650", {
            "ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.095]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6573797856727943`*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[StyleBox["If you click on any entry in the display above, \
information about it will appear above this line.\nWe now illustrate most of \
the items in the above list.",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.615726750302065*^9, 3.615726801577874*^9}},
 FontFamily->"Courier New",
 CellTags->"b:5.0"]
}, Open  ]],

Cell["Basic Functions in roughly alphabetic order", "Section",
 CellChangeTimes->{{3.614245836034204*^9, 3.614245838451766*^9}, {
  3.614245883720427*^9, 3.614245902652607*^9}, {3.615726809058713*^9, 
  3.615726818935968*^9}},
 FontFamily->"Times",
 CellTags->"c:3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Adj"}]], "Input",
 CellChangeTimes->{{3.614245973539517*^9, 3.6142459754182787`*^9}}],

Cell[BoxData[
 StyleBox["\<\"Adj[A]\\n\\n\t gives the adjoint of matrix A.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379786085011*^9},
 CellTags->"Info-2c0f646f-059b-4433-ad89-87142edf7c5f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"state", "=", "RandomKet1"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "state", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Adj", "[", "state", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6142459929567957`*^9, 3.614246085064147*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.7978264550797939`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.412533595777903`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.39919902072419955`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1841985933230863`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786173553*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"0.7978264550797939`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.412533595777903`", " ", "\[ImaginaryI]"}]}],"\")\"","\" |\"",
    "\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.39919902072419955`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.1841985933230863`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797862287188`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.7978264550797939`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.412533595777903`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.39919902072419955`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1841985933230863`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797862841454`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.7978264550797939`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.412533595777903`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.39919902072419955`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.1841985933230863`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786339675*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AF"}]], "Input",
 CellChangeTimes->{{3.6142461128797913`*^9, 3.614246113974354*^9}}],

Cell[BoxData[
 StyleBox["\<\"AF[state]\\n\\n   AF denotes ArrayFlatten,  which is needed \
for \\nthe MMA 9.0 and 10.0 built-in Tensorproduct setup.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379786445154*^9},
 CellTags->"Info-5c2ca537-a5ba-47aa-ba2a-3cbe51935a6c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
   RowBox[{"Ket", "[", "0", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614246220823657*^9, 3.6142462597006607`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786523602*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786584359*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"00\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786640683*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  TemplateBox[{"0"},
   "Ket"], "\[TensorProduct]", 
  TemplateBox[{"0"},
   "Ket"]}], "\n", 
 RowBox[{"AF", "[", 
  RowBox[{
   TemplateBox[{"0"},
    "Ket"], "\[TensorProduct]", 
   TemplateBox[{"0"},
    "Ket"]}], "]"}], "\n", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614246220823657*^9, 3.614246282164315*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797867277193`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379786783869*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"00\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797868391857`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Bra1"}]], "Input",
 CellChangeTimes->{{3.614246322163365*^9, 3.614246324845842*^9}}],

Cell[BoxData[
 StyleBox["\<\"Bra1[\[Theta],\[Phi]],\\n\\n\t returns a general one qubit bra \
state.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737978695251*^9},
 CellTags->"Info-00297780-1a94-4632-bed8-d9b43b05118d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Bra1", "[", 
  RowBox[{"a", ",", "b"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614246333795867*^9, 3.6142463871689034`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]], " ", 
       RowBox[{"Cos", "[", 
        FractionBox["a", "2"], "]"}]}], 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]}]], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["a", "2"], "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787040164*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]], " ", 
      RowBox[{"Cos", "[", 
        FractionBox["a", "2"], "]"}]}],"\" ) \"","\" < \"","\"0\"","\" |\"",
    "\" + \"","\" ( \"",RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]}]], " ", 
      RowBox[{"Sin", "[", 
        FractionBox["a", "2"], "]"}]}],"\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787095393*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BraV"}]], "Input",
 CellChangeTimes->{{3.6142466507943993`*^9, 3.614246653218107*^9}}],

Cell[BoxData[
 StyleBox["\<\"BraV[a_] is a multi-qubit state vector bra,\\n\\n\t variable a \
must be list.\\n\\n\t Example of use, \\nBraV[{a,b,c}]=AF[Bra[a]\
\[TensorProduct]Bra[b]\[TensorProduct]Bra[c]],\\nwith a,b and c {0,1}\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737978720366*^9},
 CellTags->"Info-093e684c-345b-4e53-a49a-caee177e52e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"BraV", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"BraV", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6142466732326727`*^9, 3.6142467446759567`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787290765*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"","1","\" ) \"","\" < \"","\"000\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797873509493`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", 
      "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787405813*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\" ( \"","1","\" ) \"","\" < \"","\"1101\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797874623337`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BraX"}]], "Input",
 CellChangeTimes->{{3.6142467767662163`*^9, 3.614246778818458*^9}}],

Cell[BoxData[
 StyleBox["\<\"BraX[0], BraX[1],\\n\\n\t one qubit \[LeftAngleBracket]+|, \
\[LeftAngleBracket]-|, respectively.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379787583395*^9},
 CellTags->"Info-846a5560-b8ac-418a-a62a-1fec72db3032"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"BraX", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"BraX", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6142467868128767`*^9, 3.6142468220723877`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787674189*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",FractionBox["1", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",
    FractionBox["1", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379787736347*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797877960176`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",FractionBox["1", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737978785143*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BraY"}]], "Input",
 CellChangeTimes->{{3.614246849249104*^9, 3.6142468524237967`*^9}}],

Cell[BoxData[
 StyleBox["\<\"BraY[0], BraY[1],\\n\\n\t one qubit eigenstates of Sigma[2], \
respectively.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379787986721*^9},
 CellTags->"Info-a028856f-8f7e-402c-bc87-cee2515b09f9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"BraY", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"BraY", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BraY", "[", "0", "]"}], ".", 
   RowBox[{"s", "[", "2", "]"}]}], "==", 
  RowBox[{"BraY", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BraY", "[", "1", "]"}], ".", 
   RowBox[{"s", "[", "2", "]"}]}], "\[Equal]", " ", 
  RowBox[{"-", " ", 
   RowBox[{"BraY", "[", "1", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.614247006311235*^9, 3.614247009150887*^9}, {
  3.614248319852743*^9, 3.614248507164525*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797880751343`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",FractionBox["1", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",
    RowBox[{"-", 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]]}],"\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737978814002*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788197133*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",FractionBox["1", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",
    FractionBox["\[ImaginaryI]", 
     SqrtBox["2"]],"\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797882508497`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788314118*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797883735943`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CNOT"}]], "Input",
 CellChangeTimes->{{3.614248534002109*^9, 3.614248535772028*^9}}],

Cell[BoxData[
 StyleBox["\<\"CNOT[L,q1,q2]\\n\\n\t Returns the CNOT operator with q1 qubit \
as control, \\n\\n q2 qubit as target within L qubits--same as ControlledX. \
\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379788502334*^9},
 CellTags->"Info-874662f4-b6b9-478e-b9c1-800bd4c92b37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CNOT", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CNOT", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
  RowBox[{"CNOT", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6142485410539303`*^9, 3.614248637119021*^9}, 
   3.614248668913207*^9, {3.61424870598875*^9, 3.614248826764021*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797885937777`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788651379*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797887289267`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788785026*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788840229*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797888966837`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CNOT", "[", 
  RowBox[{"3", ",", "1", ",", "3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"AF", "[", 
     RowBox[{
      TemplateBox[{"0"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"1"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"1"},
       "Ket"]}], "]"}]}], "==", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"0"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"], "\[TensorProduct]", 
     TemplateBox[{"1"},
      "Ket"]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6142488479457607`*^9, 3.6142488991657143`*^9}, {
  3.614248931293337*^9, 3.61424893608473*^9}, {3.6142519543755198`*^9, 
  3.614252121754683*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379788983141*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789040262*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789096208*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789151539*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737978920691*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789271974*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789329509*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737978940306*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789462069*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Comm"}]], "Input",
 CellChangeTimes->{
  3.6142521505535316`*^9, {3.61433508228055*^9, 3.6143350854284077`*^9}, {
   3.614335122113619*^9, 3.6143351275484047`*^9}, 3.614362461276052*^9, {
   3.614362552632021*^9, 3.614362554197974*^9}}],

Cell[BoxData[
 StyleBox["\<\"Comm[A,B]\\n\\n\t gives the commutator of A and B defined as \
AB-BA.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379789570318*^9},
 CellTags->"Info-5d1c58a2-6403-4804-ba84-559e76715cb8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Comm", "[", 
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], ",", " ", 
   RowBox[{"s", "[", "2", "]"}]}], "]"}], "\n", 
 RowBox[{"2", "*", "I", "*", 
  RowBox[{"s", "[", "3", "]"}]}]}], "Input",
 CellChangeTimes->{{3.614334288635127*^9, 3.6143343148174963`*^9}, 
   3.614334720065689*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"2", " ", "\[ImaginaryI]"}], "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "\[ImaginaryI]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789659965*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"2", " ", "\[ImaginaryI]"}], "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "\[ImaginaryI]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789719964*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "ControlledX"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ControlledX", "[", 
   RowBox[{"3", ",", "1", ",", "2"}], "]"}], "\[Equal]", 
  RowBox[{"CNOT", "[", 
   RowBox[{"3", ",", "1", ",", "2"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614362614538291*^9, 3.614362699525647*^9}}],

Cell[BoxData[
 StyleBox["\<\"ControlledX[L,q1,q2]\\n\\n\t Returns the ControlledX operator \
with q1 qubit as control, \\n\\n q2 qubit as target within L qubits--same as \
CNOT \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379789833428*^9},
 CellTags->"Info-38311c02-69e9-4a8c-a04c-57077032ab03"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379789921151*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "ControlledY"}], "\[IndentingNewLine]", 
 RowBox[{"ControlledY", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ControlledY", "[", 
  RowBox[{"3", ",", "1", ",", "2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614362732759206*^9, 3.614362771657608*^9}}],

Cell[BoxData[
 StyleBox["\<\"ControlledY[L,q1,q2]\\n\\n\t Returns the ControlledY operator \
with q1 qubit as control,\\n\\n q2 qubit as target within L qubits\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379790052186*^9},
 CellTags->"Info-d3842e71-4851-4381-822f-de0e8ce4c427"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0", "0", "\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790137945*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0", "0", "0", "0", "\[ImaginaryI]", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "\[ImaginaryI]", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790196457*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "ControlledZ"}], "\[IndentingNewLine]", 
 RowBox[{"ControlledZ", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ControlledZ", "[", 
  RowBox[{"3", ",", "1", ",", "2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614362732759206*^9, 3.614362797935917*^9}}],

Cell[BoxData[
 StyleBox["\<\"ControlledZ[L,q1,q2]\\n\\n\t Returns the ControlledY operator \
with q1 qubit as control,\\n\\n q2 qubit as target within L qubits\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379790302906*^9},
 CellTags->"Info-09879ac4-afef-4a7b-9602-5b1f00002d6e"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790387829*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "1"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797904521303`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "CPHASE"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ControlledZ", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[Equal]", 
  RowBox[{"CPHASE", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ControlledZ", "[", 
   RowBox[{"3", ",", "1", ",", "2"}], "]"}], "\[Equal]", 
  RowBox[{"CPHASE", "[", 
   RowBox[{"3", ",", "1", ",", "2"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ControlledZ", "[", 
   RowBox[{"4", ",", "1", ",", "3"}], "]"}], "\[Equal]", 
  RowBox[{"CPHASE", "[", 
   RowBox[{"4", ",", "1", ",", "3"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614362826874774*^9, 3.6143628297387123`*^9}, {
  3.614362861654415*^9, 3.614362913670909*^9}}],

Cell[BoxData[
 StyleBox["\<\"CPHASE[L,q1,q2]\\n\\n\t Returns the CPHASE operator of q1 and \
q2 within L qubits. \\n\\n Its action on twoqubits is \
|ab\[RightAngleBracket]-->(-)^(ab)|ab\[RightAngleBracket]\\n\\n --same as \
ControlledZ.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379790573141*^9},
 CellTags->"Info-e7330879-672f-4479-8554-cc0302121a51"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790655353*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790723818*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379790786128*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "CPHASEV"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"state2", "=", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "+", " ", 
    RowBox[{"b", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "+", 
    RowBox[{"c", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], " ", "+", 
    RowBox[{"d", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}]}]}], ";", 
  RowBox[{"DForm", "[", "state2", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"1", ",", "2", ",", " ", "state2"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"2", ",", "1", ",", " ", "state2"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614362927474474*^9, 3.614362999628557*^9}, {
  3.614363054110908*^9, 3.6143631520813923`*^9}, {3.614363195628676*^9, 
  3.614363214256654*^9}, {3.614363286883906*^9, 3.614363409682499*^9}}],

Cell[BoxData[
 StyleBox["\<\"CPHASEV[q1,q2,A],\\n\\n\t returns the CPHASE operated on the \
vector A, which should be a list of Lenght 2^n.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.6573797909033413`*^9},
 CellTags->"Info-d21abeb4-312a-4973-b745-b6ba0c5154a0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"","c","\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"","d","\")\"","\" |\"",
    "\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979098827*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"","c","\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "d"}],"\")\"",
    "\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791051874*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"","c","\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "d"}],"\")\"",
    "\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797911186*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"state3", "=", 
   RowBox[{
    RowBox[{"a000", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "+", " ", 
    RowBox[{"a001", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "+", 
    RowBox[{"a010", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", 
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], " ", "+", 
    RowBox[{"a011", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", 
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "+", 
    RowBox[{"a100", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "+", " ", 
    RowBox[{"a101", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "+", 
    RowBox[{"a110", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", 
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], " ", "+", 
    RowBox[{"a111", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", 
       RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}]}]}], ";", 
  RowBox[{"DForm", "[", "state3", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"1", ",", "2", ",", " ", "state3"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"2", ",", "1", ",", " ", "state3"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614363424770273*^9, 3.6143634845168123`*^9}, {
  3.6143635363301573`*^9, 3.6143636919767227`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a000","\")\"","\" |\"","\"000\"","\" >\"","\" + \"",
    "\"(\"","a001","\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    "a010","\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"","a011",
    "\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"","a100","\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"","a101","\")\"","\" |\"",
    "\"101\"","\" >\"","\" + \"","\"(\"","a110","\")\"","\" |\"","\"110\"",
    "\" >\"","\" + \"","\"(\"","a111","\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791213386*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a000","\")\"","\" |\"","\"000\"","\" >\"","\" + \"",
    "\"(\"","a001","\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    "a010","\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"","a011",
    "\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"","a100","\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"","a101","\")\"","\" |\"",
    "\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "a110"}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "a111"}],
    "\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791289673*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a000","\")\"","\" |\"","\"000\"","\" >\"","\" + \"",
    "\"(\"","a001","\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    "a010","\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"","a011",
    "\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"","a100","\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"","a101","\")\"","\" |\"",
    "\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "a110"}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{"-", "a111"}],
    "\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791352133*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"CPHASEV", "[", 
   RowBox[{"1", ",", "2", ",", " ", "state2"}], "]"}], "==", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"2", ",", "1", ",", " ", "state2"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPHASEV", "[", 
   RowBox[{"1", ",", "2", ",", " ", "state3"}], "]"}], "==", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"2", ",", "1", ",", " ", "state3"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPHASEV", "[", 
   RowBox[{"1", ",", "3", ",", " ", "state3"}], "]"}], "==", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"3", ",", "1", ",", " ", "state3"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPHASEV", "[", 
   RowBox[{"2", ",", "3", ",", " ", "state3"}], "]"}], "==", 
  RowBox[{"CPHASEV", "[", 
   RowBox[{"3", ",", "2", ",", " ", "state3"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6143637944936657`*^9, 3.61436385735527*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791439239*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791507279*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791573839*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379791640708*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "EnTropy"}], "\[IndentingNewLine]", 
 RowBox[{"?", "Entropy"}]}], "Input",
 CellChangeTimes->{{3.6143639613051023`*^9, 3.614363987624148*^9}}],

Cell[BoxData[
 StyleBox["\<\"\\nEnTropy[\[Rho]],\\n\\n\t gives the entropy of the system \
described by the \\n\\n density matrix \[Rho]. Defined = -Tr[ \[Rho].Log[\
\[Rho],2]].\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797917727957`*^9},
 CellTags->"Info-891c8fa4-c205-4d06-857a-695db3e58aee"],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"Entropy\\\", \\\"[\\\", StyleBox[\\\"list\\\
\", \\\"TI\\\"], \\\"]\\\"}]\) gives the base \[ExponentialE] information \
entropy of the values in \!\(\*StyleBox[\\\"list\\\", \
\\\"TI\\\"]\).\\n\!\(\*RowBox[{\\\"Entropy\\\", \\\"[\\\", \
RowBox[{StyleBox[\\\"k\\\", \\\"TI\\\"], \\\",\\\", StyleBox[\\\"list\\\", \\\
\"TI\\\"]}], \\\"]\\\"}]\) gives the base \!\(\*StyleBox[\\\"k\\\", \
\\\"TI\\\"]\) information entropy.\"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Entropy"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379791870757*^9},
 CellTags->"Info-6d9cdeda-c896-487a-85e7-1d6fd48eb8e3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rho4", "=", 
   RowBox[{"RandomQubitN", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", "rho4", "]"}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "rho4", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ev", "=", 
  RowBox[{"Eigenvalues", "[", "rho4", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "rho4", "]"}], "\[IndentingNewLine]", 
 RowBox[{"-", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ev", "[", 
      RowBox[{"[", "i", "]"}], "]"}], 
     RowBox[{"Log", "[", 
      RowBox[{"2", ",", 
       RowBox[{"ev", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "ev", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EnTropy2", "[", "rho4", "]"}], "\[Equal]", 
  RowBox[{"EnTropy", "[", "rho4", "]"}]}]}], "Input",
 CellChangeTimes->{{3.61436400261379*^9, 3.614364353929431*^9}, {
  3.614364384123972*^9, 3.6143644461635857`*^9}, {3.6144198799778557`*^9, 
  3.614419892969673*^9}, {3.6144199299252043`*^9, 3.61441993008107*^9}, {
  3.6144203067033653`*^9, 3.614420307275901*^9}, {3.6144203862826853`*^9, 
  3.6144204008149157`*^9}}],

Cell[BoxData[
 TagBox["0.9999999999999999`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797919624443`*^9}],

Cell[BoxData[
 TagBox["3.355159699883595`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979202923*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0.20443202353244666`"},
      {"0.17658251141903367`"},
      {"0.12635505739095648`"},
      {"0.09162237790051529`"},
      {"0.08709163092481076`"},
      {"0.07231800407665316`"},
      {"0.05716214537236412`"},
      {"0.0455389833387202`"},
      {"0.03978954486059415`"},
      {"0.03862133468337912`"},
      {"0.020654861566742122`"},
      {"0.020155105513420746`"},
      {"0.011259087602666699`"},
      {"0.0070263694519697205`"},
      {"0.001260095760526049`"},
      {"0.00013086660520103958`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797920959578`*^9}],

Cell[BoxData[
 TagBox["16",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379792162303*^9}],

Cell[BoxData[
 TagBox["3.355159699883595`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379792228426*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379792295774*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "Fidelity"}], "\[IndentingNewLine]", 
 RowBox[{"?", "FidelityB"}]}], "Input",
 CellChangeTimes->{{3.614420460182651*^9, 3.614420463508287*^9}, {
  3.614420925806958*^9, 3.614420927820056*^9}}],

Cell[BoxData[
 StyleBox["\<\"Fidelity[Op1,Op2] or FidelityB[Op1,Op2]\\n\\n\t returns the \
concurrence of operators Op1 and Op2\\n\\n defined as =MatrixPower[ \
MatrixPower[Op1,1/2].Op2.MatrixPower[Op1,1/2],1/2].\\nNow have \
FidelityB[Op1,Op2] as an alternative method which uses eigenvalues \
of\\nOp1.Op2\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797924440813`*^9},
 CellTags->"Info-e408696f-92f9-4bd6-8524-6a40ef9a3ba5"],

Cell[BoxData[
 StyleBox["\<\"FidelityB[Op1,Op2]\\n\\n\t Now have FidelityB[Op1,Op2] as an \
alternative method which uses eigenvalues of\\nOp1.Op2\"\>", "MSG"]], "Print",\
 "PrintUsage",
 CellChangeTimes->{3.65737979256851*^9},
 CellTags->"Info-b1842af5-aadb-47a6-a26c-52fa12aa1130"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r1", "=", 
   RowBox[{"RandomQubitN", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r2", "=", 
   RowBox[{"RandomQubitN", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Fidelity", "[", 
  RowBox[{"r1", ",", "r2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FidelityB", "[", 
  RowBox[{"r1", ",", "r2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614420516095016*^9, 3.6144205831698227`*^9}}],

Cell[BoxData[
 TagBox["0.7511783710577160655397221944440389052`18.822138089820815",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797926641912`*^9}],

Cell[BoxData[
 TagBox["0.7511783710577159781909609394202287449`18.822138089820815",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797927293*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"?", "had"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.614420940704094*^9, 3.614420942004622*^9}, {
  3.614420976012958*^9, 3.614420993674203*^9}, {3.6144210301484337`*^9, 
  3.6144210824109707`*^9}, {3.614421123213375*^9, 3.614421132707284*^9}}],

Cell[BoxData[
 StyleBox["\<\"had[L, q]  where L=n_q is the total number of qubits\\n and q \
designates the single qubit on which a Hadamard acts--see Hadamard.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797928480797`*^9},
 CellTags->"Info-aadd0053-bbf9-4abb-999a-4af8610966bd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Had"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"see Hadamard.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379792992825*^9},
 CellTags->"Info-bdad4a9d-a693-4b2b-aacf-38da24bc3666"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Hadamard"}]], "Input",
 CellChangeTimes->{3.6144210979588203`*^9, 3.614422207067137*^9}],

Cell[BoxData[
 StyleBox["\<\"Hadamard, had, Had, HALL:\\n\\n\t \[ScriptCapitalH]\\n\\n \
Hadamard  acting on one qubit.\\n\\n\t had[L,q] is a Hadamard acting on one \
qubit q out of L \\n\\n qubits (use as had[1,1] or had[2,2]).\\n\\n\t \
Had[L,Q]   acts on  all members of set \\n\\n Q={q1,q2,...} of the L qubits,  \
where qi>0 indicated that\\n\\n the ith qubit is acted on by a Hadamard, \
whereas qj=0 \\n\\n designates that the jth qubit is acted on by a unit 2x2 \
operator.\\n\\n\t For example, Had[3,{1,0,1}] has a Hadamard acting on \\n\\n \
qubits 1 and 3 and a unit 2x2 acts on qubit 2.\\n\\n To get a Hadamard acting \
on all qubits, include all \\n\\n qubits in Q, e.g., use \
Q={1,1,1,....}.\\n\\n\t HALL[L]=Had[L,{1,1,1....}] is also provided where \\n\
\\n the array of 1's has length L of all the qubits\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.657379793127583*^9},
 CellTags->"Info-0d5fe874-3fec-47bc-9615-c2a4041baccc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "HALL"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"HALL[L]\\n\\n\t returns a Hadamard applied to each of the L \
qubits\\n\\n of a L qubit system-see Hadamard.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.657379793260462*^9},
 CellTags->"Info-22a7525c-5f19-48ba-8611-44b52dc54da9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\[ScriptCapitalH]"}]], "Input",
 CellChangeTimes->{{3.614422142173387*^9, 3.614422143111677*^9}}],

Cell[BoxData[
 StyleBox["\<\"The single qubit Hadamard--See Hadamard\"\>", "MSG"]], "Print",\
 "PrintUsage",
 CellChangeTimes->{3.6573797933935623`*^9},
 CellTags->"Info-d526400f-aef5-4559-9a83-05cbe7f6ad26"]
}, Open  ]],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard operator",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" for one qubit is defined as \nHad |0\[RightAngleBracket] = (|0\
\[RightAngleBracket] + |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 "  and Had |1\[RightAngleBracket] = ",
 StyleBox[" (|0\[RightAngleBracket] - |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox[", \nthis is equivalent to Had = (",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "1"], TraditionalForm]]],
 StyleBox[" + ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "3"], TraditionalForm]]],
 StyleBox["\[RightAngleBracket]/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox["\nTo Hadamard qubit-one in a one qubit system use:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613395051437973*^9, 3.613395051953808*^9}},
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HA", " ", "=", " ", 
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}]}]], "Input",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797934933243`*^9},
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["or the script form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData["\[ScriptCapitalH]"], "Input",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379793592162*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[StyleBox["If we have 3 qubits and want to Hadamard the second \
one,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HAD32", "=", 
  RowBox[{"had", "[", 
   RowBox[{"3", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.613395079179223*^9, 3.613395086367363*^9}, {
  3.613395131040553*^9, 3.613395145640243*^9}, {3.61339538195849*^9, 
  3.613395393218055*^9}, {3.613395619570511*^9, 3.613395623461936*^9}, {
  3.6135049161353807`*^9, 3.6135049204543056`*^9}},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0"},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979369179*^9},
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["which  is equivalent to",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  RowBox[{
  "\[DoubleStruckCapitalI]", "  ", "\[TensorProduct]", " ", 
   "\[ScriptCapitalH]", " ", "\[TensorProduct]", "\[DoubleStruckCapitalI]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6133959477066393`*^9, 3.613395950338436*^9}, {
   3.614015919554443*^9, 3.614015932928617*^9}, 3.614075965489653*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0"},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379793792242*^9},
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["If we want to apply Hadamards as above to an initial \
system of |000\[RightAngleBracket],  we construct the initial density matrix \
and transform to the new density matrix, also we check the subsystems 2 and 1 \
to verify that it is only qubit 2 that has been subjected to a Hadamard:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.614015951445463*^9, 3.614015952625804*^9}},
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]000", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]FINAL", "=", 
   RowBox[{"HAD32", " ", ".", " ", "\[Rho]000", " ", ".", " ", 
    RowBox[{"Adj", "[", "HAD32", "]"}]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], "]"}]}], "Input",
 CellChangeTimes->{{3.6140159800992002`*^9, 3.61401603406218*^9}, 
   3.6140759655067387`*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379793891968*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379793964204*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797940304728`*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794097268*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Sometimes we need a ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard on every one of the qubits;",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" in that case you may use the command ",
  FontFamily->"Helvetica"],
 StyleBox["HALL",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[":",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"HALL", "[", "3", "]"}], ".", "\[Rho]000", " ", ".", 
  RowBox[{"Adj", "[", 
   RowBox[{"HALL", "[", "3", "]"}], "]"}]}]], "Input",
 CellTags->{"i:2", "b:5.2.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794183317*^9},
 CellTags->{"i:2", "b:5.2.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"HALL", "[", "3", "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", "  ", 
     RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614596436026184*^9, 3.6145964927323923`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"100\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"101\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     RowBox[{"2", " ", 
       SqrtBox["2"]}]],"\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797942762613`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["The action of a Hadamard on state vectors is  also \
simple to evaluatel, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"Ket", "[", "1", "]"}]}]}], "Input",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794358705*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794430482*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794497213*^9},
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Ket"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Ket[0], Ket[1],\\n\\n\t one qubit |0\[RightAngleBracket] and \
|1\[RightAngleBracket] state, respectively.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.657379794662429*^9},
 CellTags->"Info-f7d565f3-a635-4078-98aa-59d3af9152f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Ket", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Ket", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", " ", 
  RowBox[{
   RowBox[{"a", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "+", " ", 
   RowBox[{"b", " ", 
    RowBox[{"Ket", "[", "1", "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.614422466663094*^9, 3.614422509766438*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797947658863`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"0\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797948404827`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379794907937*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797949800034`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379795052157*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 TemplateBox[{"0"},
  "Ket"], "\n", 
 TemplateBox[{"1"},
  "Ket"]}], "Input",
 CellChangeTimes->{{3.614422517802367*^9, 3.614422546462709*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379795148954*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379795218513*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Ket1"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Ket1[\[Theta],\[Phi]],\\n\\n\t returns a general one qubit ket \
state of the form\\n\\n \
=Cos[\[Theta]/2]*Exp[-\[ImaginaryI]*\[Phi]/2]*Ket[0]+Sin[\[Theta]/2]*Ket[1]*\
Exp[\[ImaginaryI]*\[Phi]/2]  \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797953545523`*^9},
 CellTags->"Info-416b572d-d5c8-4fe0-8d3f-b4c26afac64d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Ket1", "[", 
  RowBox[{"a", ",", "b"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614422572418518*^9, 3.614422587544961*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]}]], " ", 
       RowBox[{"Cos", "[", 
        FractionBox["a", "2"], "]"}]}]},
     {
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]], " ", 
       RowBox[{"Sin", "[", 
        FractionBox["a", "2"], "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797954665833`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]}]], " ", 
      RowBox[{"Cos", "[", 
        FractionBox["a", "2"], "]"}]}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "b"}], "2"]], " ", 
      RowBox[{"Sin", "[", 
        FractionBox["a", "2"], "]"}]}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379795541295*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "KetV"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"KetV[a_] is a multi-qubit state vector ket,\\n\\n\t variable a \
must be list of Length[a]=2^n. Example of \\nuse, KetV[{0,1,1}]=AF[Ket[0]\
\[TensorProduct]Ket[1]\[TensorProduct]Ket[1] ] .\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.6573797956910553`*^9},
 CellTags->"Info-137f1b17-35ef-40c3-8ed3-60006956dbee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}], "]"}], " ", "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], "]"}], " ", "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6144226108476686`*^9, 3.6144226813871927`*^9}, {
  3.6144412022134857`*^9, 3.614441226420148*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379795799184*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797958746777`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "KetX"}]], "Input",
 CellChangeTimes->{{3.614441258259615*^9, 3.614441259077114*^9}}],

Cell[BoxData[
 StyleBox["\<\"KetX[0], KetX[1], \\n\\n\t one qubit |+\[RightAngleBracket], \
|-\[RightAngleBracket], states, respectively. \\n\\n Eigenvectors of \
Sigma1.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797959920197`*^9},
 CellTags->"Info-788771c2-59da-498a-bf47-58aa5c931796"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"KetX", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"KetX", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6144412739120626`*^9, 3.6144413121182327`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797962497873`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797963306627`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797963972473`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379796474886*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], ".", 
   RowBox[{"KetX", "[", "0", "]"}]}], "==", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], ".", 
   RowBox[{"KetX", "[", "1", "]"}]}], "\[Equal]", 
  RowBox[{"-", 
   RowBox[{"KetX", "[", "1", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.6144413773435087`*^9, 3.6144414423539057`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379796571312*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379796642848*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "KetY"}]], "Input",
 CellChangeTimes->{{3.614441329107194*^9, 3.614441329813712*^9}}],

Cell[BoxData[
 StyleBox["\<\"KetY[0], KetY[1], \\n\\n Eigenvectors of Sigma2.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379796799123*^9},
 CellTags->"Info-92495a93-9b9b-4a3b-b401-900973831db7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"KetY", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"KetY", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6144413448997917`*^9, 3.614441354236189*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379796900937*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    FractionBox["\[ImaginaryI]", 
     SqrtBox["2"]],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379796974978*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797051714*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797119747*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "2", "]"}], ".", 
   RowBox[{"KetY", "[", "0", "]"}]}], "==", 
  RowBox[{"KetY", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "2", "]"}], ".", 
   RowBox[{"KetY", "[", "1", "]"}]}], "\[Equal]", " ", 
  RowBox[{"-", 
   RowBox[{"KetY", "[", "1", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.614441454199959*^9, 3.614441498195979*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797972190943`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797296924*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MeasureKet"}]], "Input",
 CellChangeTimes->{{3.6144415373817377`*^9, 3.614441541709017*^9}, {
  3.614592273157029*^9, 3.614592274821485*^9}, {3.6145939063792067`*^9, 
  3.614593906929339*^9}}],

Cell[BoxData[
 StyleBox["\<\"MeasureKet[V,M,MV],\\n\\n\t Performs the measurement on qubits \
in list M={m1,..,mn},\\n\\n with possible measured computational basis values \
input in list \\n\\n MV={0,1,...0,0,1}, on the original ket V. The output is \
normalized \\n\\n to 1.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573797974157057`*^9},
 CellTags->"Info-cac96c74-43ec-4b27-82e5-d3e4b3ef2839"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"V", "=", " ", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"KetV", "[", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1"}], "}"}], "]"}]}], " ", "+", " ", 
    RowBox[{"b", " ", 
     RowBox[{"KetV", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}], "]"}]}]}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"M", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"MV", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"VIN", "=", "V"}], "\[IndentingNewLine]", 
 RowBox[{"MeasureKet", "[", 
  RowBox[{"VIN", ",", "M", ",", "MV"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"MV", "=", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"VIN", "=", "V"}], "\[IndentingNewLine]", 
 RowBox[{"MeasureKet", "[", 
  RowBox[{"VIN", ",", "M", ",", "MV"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614441561399622*^9, 3.614441787442144*^9}, 
   3.614591743746738*^9, {3.614591806855259*^9, 3.6145918221757927`*^9}, {
   3.6145923662578373`*^9, 3.614592383277123*^9}, {3.614592414135347*^9, 
   3.614592564754755*^9}, {3.614592679915752*^9, 3.614592691535849*^9}, {
   3.614592748930993*^9, 3.614592752193014*^9}, {3.6145927895195303`*^9, 
   3.614592820026711*^9}, {3.614593663681929*^9, 3.614593692333312*^9}, 
   3.6145939011474333`*^9, 3.614594006881509*^9, {3.6162752100285397`*^9, 
   3.616275246173676*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"011\"","\" >\"","\" + \"",
    "\"(\"","b","\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797519712*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797597567*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979767634*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"a"},
     {"0"},
     {"0"},
     {"0"},
     {"b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797977534857`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["b", 
       RowBox[{"Abs", "[", "b", "]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979782957*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379797908399*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"a"},
     {"0"},
     {"0"},
     {"0"},
     {"b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798018255*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["a", 
       RowBox[{"Abs", "[", "a", "]"}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798104985*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"V2", "=", " ", 
  RowBox[{"RandomKetN", "[", "3", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "V2", "]"}]}], "Input",
 CellChangeTimes->{{3.614441809935204*^9, 3.614441887137776*^9}, {
   3.614441951640544*^9, 3.6144420690841513`*^9}, {3.614447068022142*^9, 
   3.6144471412105923`*^9}, {3.614447247620689*^9, 3.6144472546502542`*^9}, {
   3.614447290784616*^9, 3.614447451999667*^9}, {3.61444754790277*^9, 
   3.614447558538529*^9}, {3.614447595094149*^9, 3.6144476294743156`*^9}, {
   3.61444765990373*^9, 3.614447709163107*^9}, {3.6144479111467743`*^9, 
   3.614447924342799*^9}, {3.6144485580838223`*^9, 3.614448561265571*^9}, {
   3.614448609448677*^9, 3.614448613608323*^9}, {3.614505450860712*^9, 
   3.6145054691082172`*^9}, 3.614505578453307*^9, 3.6145058482061367`*^9, {
   3.614505894203332*^9, 3.6145058975561857`*^9}, {3.614507404141903*^9, 
   3.614507426999959*^9}, {3.616274117730371*^9, 3.616274125514978*^9}, {
   3.616274714456523*^9, 3.616274757316812*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.44130113742207216`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.2574671875275666`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.4464772045031611`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.10984689440026163`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.0036045336773698157`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.08646084156319354`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.19108955638958924`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.34250736907523854`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.12237906824063706`"}], "+", 
       RowBox[{"0.1878228870716552`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.31738978885672947`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.31232702244629584`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.1273197992197719`"}], "+", 
       RowBox[{"0.14943248169612214`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798262837*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"0.44130113742207216`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.2574671875275666`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.4464772045031611`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.10984689440026163`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.0036045336773698157`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.08646084156319354`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.19108955638958924`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.34250736907523854`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.12237906824063706`"}], "+", 
      RowBox[{"0.1878228870716552`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.31738978885672947`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.31232702244629584`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.1273197992197719`"}], "+", 
      RowBox[{"0.14943248169612214`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798342054*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"M", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"MV", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VIN", "=", "V2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"M1", "=", 
  RowBox[{"MeasureKet", "[", 
   RowBox[{"VIN", ",", "M", ",", "MV"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"coefM", "=", 
  RowBox[{
   RowBox[{"BraV", "[", "MV", "]"}], ".", "VIN"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coefM", "/", 
   RowBox[{"Abs", "[", "coefM", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.614447845664352*^9, 3.6144478620539293`*^9}, {
   3.614448670083866*^9, 3.6144486899135237`*^9}, {3.614448749493156*^9, 
   3.6144487548116283`*^9}, {3.6145052899949427`*^9, 3.614505292715643*^9}, {
   3.614505369460784*^9, 3.6145054362375174`*^9}, {3.6145075537031193`*^9, 
   3.614507556660602*^9}, {3.6145919154577293`*^9, 3.614591916166312*^9}, {
   3.614593731393724*^9, 3.614593739368225*^9}, 3.61459377510005*^9, 
   3.614594025105673*^9, 3.614594175386559*^9, {3.616274953305228*^9, 
   3.616274957490177*^9}, {3.616275281913205*^9, 3.616275316121235*^9}, 
   3.616275464896818*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979845148*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798530016*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.6485416143268311`"}], "+", 
       RowBox[{"0.7611791999827292`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798608506*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.1273197992197719`"}], "+", 
       RowBox[{"0.14943248169612214`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798686903*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.6485416143268311`"}], "+", 
       RowBox[{"0.7611791999827292`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797987644043`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{"M", "\[IndentingNewLine]", "MV", "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "V2", "]"}]}], "Input",
 CellChangeTimes->{{3.614505251976288*^9, 3.61450526153181*^9}, {
   3.6145068005619183`*^9, 3.614506804723233*^9}, {3.614506849442808*^9, 
   3.614506849880166*^9}, {3.61450737236136*^9, 3.614507376691518*^9}, 
   3.616274969324851*^9, {3.6162751269300747`*^9, 3.616275127345277*^9}, {
   3.616275487384389*^9, 3.6162754879809732`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379798874187*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797989529963`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"0.44130113742207216`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.2574671875275666`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.4464772045031611`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.10984689440026163`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.0036045336773698157`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.08646084156319354`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.19108955638958924`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.34250736907523854`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.12237906824063706`"}], "+", 
      RowBox[{"0.1878228870716552`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.31738978885672947`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.31232702244629584`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.1273197992197719`"}], "+", 
      RowBox[{"0.14943248169612214`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797990310163`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"MV", "=", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VIN", "=", "V2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MeasureKet", "[", 
  RowBox[{"VIN", ",", "M", ",", "MV"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"coefM", "=", 
  RowBox[{
   RowBox[{"BraV", "[", "MV", "]"}], ".", "VIN"}]}], "\[IndentingNewLine]", 
 RowBox[{"coefM", "/", 
  RowBox[{"Abs", "[", "coefM", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6145942951955147`*^9, 3.614594308704638*^9}, {
   3.6162749861342688`*^9, 3.61627499587253*^9}, {3.6162753573526773`*^9, 
   3.616275372335478*^9}, 3.616275500679903*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737979914008*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6083273026407433`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.7936862685355198`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799220549*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799297105*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6083273026407433`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.7936862685355198`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799375492*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CompMeasureKet"}]], "Input",
 CellChangeTimes->{{3.614448847815399*^9, 3.61444884875624*^9}}],

Cell[BoxData[
 StyleBox["\<\"CompMeasureKet, \\n\\n\t Precompiled version of \
MeasureKet.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379799522626*^9},
 CellTags->"Info-f202f6f3-80ab-435c-ae95-49c13199b2b7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DForm", "[", "V2", "]"}]], "Input",
 CellChangeTimes->{3.61627502897992*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"0.44130113742207216`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.2574671875275666`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.4464772045031611`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.10984689440026163`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.0036045336773698157`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.08646084156319354`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.19108955638958924`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.34250736907523854`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.12237906824063706`"}], "+", 
      RowBox[{"0.1878228870716552`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.31738978885672947`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.31232702244629584`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.1273197992197719`"}], "+", 
      RowBox[{"0.14943248169612214`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799647393*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"M", "\[IndentingNewLine]", "MV", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VIN", "=", "V2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"CompMeasureKet", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", "VIN", "]"}], ",", "M", ",", "MV"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"coef", "=", 
  RowBox[{
   RowBox[{"BraV", "[", "MV", "]"}], ".", "VIN"}]}], "\[IndentingNewLine]", 
 RowBox[{"coef", "/", 
  RowBox[{"Abs", "[", "coef", "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.614448839127489*^9, 3.614448840318677*^9}, {
   3.614448899604739*^9, 3.614448905082274*^9}, {3.6144489484954767`*^9, 
   3.614448952735024*^9}, {3.614449005001347*^9, 3.614449011334914*^9}, {
   3.6144492218122253`*^9, 3.614449227075783*^9}, {3.6144492757083883`*^9, 
   3.614449276799939*^9}, {3.614450676330131*^9, 3.614450682436977*^9}, {
   3.614505694369494*^9, 3.614505696144351*^9}, {3.6145074865779533`*^9, 
   3.6145074912685423`*^9}, {3.614594324073798*^9, 3.6145943368506317`*^9}, 
   3.616273881853422*^9, {3.616275574039041*^9, 3.616275599686981*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799767263*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573797998529654`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"0.6083273026407433`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.7936862685355198`", " ", "\[ImaginaryI]"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379799932543*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.17115720251727126`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.22330926264398931`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800019874*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6083273026407433`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.7936862685355198`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800097847*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"?", "MultiQProj"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.614508455427945*^9, 3.614508484337957*^9}, {
  3.6145085334985332`*^9, 3.614508534183443*^9}, {3.6145086375110197`*^9, 
  3.614508677007021*^9}}],

Cell[BoxData[
 StyleBox["\<\"MultiQProj[{a1,a2,..,an},{b1,b2,...,bn}]\\n\\n\t  ai={0,1,2,3} \
and bi={0,1} builds the following multi-qubit projector \\n\\n operator: \
\\n\\n    ai correspond to: (0) no measurement,(1)X, (2)Y and (3)Z.\\n\\n    \
bi (0,1) correspond to the measured values in the same order. \\n\\n The \
length of both lists should be the same. The values b \\n\\n for the \
unmeasured qubits are not relevant.\\n\\n Examples:\\n\\n \
A={1,3,2};B={0,0,1};resP=MultiQProj[A,B]\[IndentingNewLine]\\n resP==AF[ \
PX[0]\[TensorProduct] \!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(0\)]\) \
\[TensorProduct] PY[1]]\\n\\n another \
case:\\nA={1,0,2,3};B={0,0,1,1};resP=MultiQProj[A,B]; same as\
\[IndentingNewLine]resP==AF[ PX[0]\[TensorProduct] \[DoubleStruckCapitalI] \
\[TensorProduct] PY[1] \[TensorProduct] \
\!\(\*SubscriptBox[\(\[ScriptCapitalP]\), \(1\)]\)]\\n\\n where qubit 2 is \
not measured.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798002544622`*^9},
 CellTags->"Info-588279c0-98f2-4a4e-a41b-ce51d461028a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "=", 
  RowBox[{"MultiQProj", "[", 
   RowBox[{"A", ",", "B"}], "]"}]}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800380048*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "=", 
  RowBox[{"MultiQProj", "[", 
   RowBox[{"A", ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], " "}], "\[IndentingNewLine]", 
 RowBox[{" ", "\[DoubleStruckCapitalI]", " "}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"PX", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"resP", "==", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", " ", "\[TensorProduct]", " ", 
    RowBox[{"PX", "[", "1", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614508695355081*^9, 3.6145087264591637`*^9}, {
  3.614508756879928*^9, 3.614508782909286*^9}, {3.614508843860021*^9, 
  3.614508890342486*^9}, {3.614508988775113*^9, 3.6145090018922586`*^9}, {
  3.6145092738476067`*^9, 3.614509278313364*^9}, {3.614509309531726*^9, 
  3.614509310565604*^9}, {3.61450935294333*^9, 3.6145093533482103`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798004960947`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800575776*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800652536*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798007310057`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800808956*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "0", ",", "2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "=", 
  RowBox[{"MultiQProj", "[", 
   RowBox[{"A", ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], " "}], "\[IndentingNewLine]", 
 RowBox[{" ", "\[DoubleStruckCapitalI]", " "}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"PY", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"resP", "==", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", " ", "\[TensorProduct]", " ", 
    RowBox[{"PY", "[", "1", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614508695355081*^9, 3.6145087264591637`*^9}, {
  3.614508756879928*^9, 3.614508782909286*^9}, {3.614508843860021*^9, 
  3.614508890342486*^9}, {3.614508988775113*^9, 3.6145090018922586`*^9}, {
  3.6145092738476067`*^9, 3.614509278313364*^9}, {3.614509309531726*^9, 
  3.614509310565604*^9}, {3.61450935294333*^9, 3.6145093533482103`*^9}, {
  3.6145093879178057`*^9, 3.614509400032482*^9}, {3.614509487229842*^9, 
  3.614509488239806*^9}, {3.614509525937937*^9, 3.614509538425111*^9}, {
  3.61450957584088*^9, 3.6145095821505537`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800913752*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379800997815*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798010855093`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"]},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737980116465*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379801254504*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "0", ",", "2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "=", 
  RowBox[{"MultiQProj", "[", 
   RowBox[{"A", ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"resP", "==", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", " ", "\[TensorProduct]", " ", 
    RowBox[{"PY", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614508695355081*^9, 3.6145087264591637`*^9}, {
  3.614508756879928*^9, 3.614508782909286*^9}, {3.614508843860021*^9, 
  3.614508890342486*^9}, {3.614508988775113*^9, 3.6145090018922586`*^9}, {
  3.6145092738476067`*^9, 3.614509278313364*^9}, {3.614509309531726*^9, 
  3.614509310565604*^9}, {3.61450935294333*^9, 3.6145093533482103`*^9}, {
  3.6145093879178057`*^9, 3.614509400032482*^9}, {3.614509487229842*^9, 
  3.614509488239806*^9}, {3.614509525937937*^9, 3.614509538425111*^9}, {
  3.614509585604697*^9, 3.6145095906663933`*^9}, {3.6145097369116297`*^9, 
  3.614509737608274*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["\[ImaginaryI]", "2"], 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["\[ImaginaryI]", "2"], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798013835697`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379801464595*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "=", 
  RowBox[{"MultiQProj", "[", 
   RowBox[{"A", ",", "B"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"resP", "==", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    RowBox[{"PX", "[", "0", "]"}], "\[TensorProduct]", " ", 
    SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", " ", 
    RowBox[{"PY", "[", "1", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614508695355081*^9, 3.6145087264591637`*^9}, {
  3.614508756879928*^9, 3.614508782909286*^9}, {3.614508843860021*^9, 
  3.614508890342486*^9}, {3.614508988775113*^9, 3.6145090018922586`*^9}, {
  3.6145092738476067`*^9, 3.614509278313364*^9}, {3.614509309531726*^9, 
  3.614509310565604*^9}, {3.61450935294333*^9, 3.6145093533482103`*^9}, {
  3.6145093879178057`*^9, 3.614509400032482*^9}, {3.614509487229842*^9, 
  3.614509488239806*^9}, {3.614509525937937*^9, 3.614509538425111*^9}, {
  3.614509585604697*^9, 3.6145097311287518`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "4"], 
      FractionBox["\[ImaginaryI]", "4"], "0", "0", 
      FractionBox["1", "4"], 
      FractionBox["\[ImaginaryI]", "4"], "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "4"]}], 
      FractionBox["1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "4"]}], 
      FractionBox["1", "4"], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "4"], 
      FractionBox["\[ImaginaryI]", "4"], "0", "0", 
      FractionBox["1", "4"], 
      FractionBox["\[ImaginaryI]", "4"], "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "4"]}], 
      FractionBox["1", "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "4"]}], 
      FractionBox["1", "4"], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379801591838*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798016747417`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "2", ",", "3"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resP", "=", 
   RowBox[{"MultiQProj", "[", 
    RowBox[{"A", ",", "B"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resP", "==", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    RowBox[{"PX", "[", "0", "]"}], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", " ", "\[TensorProduct]", " ", 
    RowBox[{"PY", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614508695355081*^9, 3.6145087264591637`*^9}, {
  3.614508756879928*^9, 3.614508782909286*^9}, {3.614508843860021*^9, 
  3.614508890342486*^9}, {3.614508988775113*^9, 3.6145090018922586`*^9}, {
  3.6145092738476067`*^9, 3.614509278313364*^9}, {3.614509309531726*^9, 
  3.614509310565604*^9}, {3.61450935294333*^9, 3.6145093533482103`*^9}, {
  3.6145093879178057`*^9, 3.614509400032482*^9}, {3.614509487229842*^9, 
  3.614509488239806*^9}, {3.614509525937937*^9, 3.614509538425111*^9}, {
  3.614509585604697*^9, 3.6145097311287518`*^9}, {3.614509771682529*^9, 
  3.614509857291686*^9}, {3.614509928704132*^9, 3.614509943856105*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379801773444*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MultiProjCBasis"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"MultiProjCbasis[{a1,a2,..,an}]\\n\\n\t ai={0,1} builds the \
multi-qubit projector operator \\nin the computational basis: AF[\
\[ScriptCapitalP]a1 \[TensorProduct] \[ScriptCapitalP]an ]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379801916934*^9},
 CellTags->"Info-b68e6ad4-5e52-4c6c-84b4-7a6a0b5f7a35"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"MultiProjCBasis", "[", 
   RowBox[{"{", "0", "}"}], "]"}], "==", 
  SubscriptBox["\[ScriptCapitalP]", "0"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MultiProjCBasis", "[", 
   RowBox[{"{", "1", "}"}], "]"}], "==", 
  SubscriptBox["\[ScriptCapitalP]", "1"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MultiProjCBasis", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MultiProjCBasis", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MultiProjCBasis", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}],
     "}"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614510252399572*^9, 3.614510261094627*^9}, {
  3.614510301436459*^9, 3.614510441019246*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802039712*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802120586*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802209455*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802298315*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802386855*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "nb"}], "\[IndentingNewLine]", "nb", "\[IndentingNewLine]", 
 RowBox[{"?", 
  "nq"}], "\[IndentingNewLine]", "nq", "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.614510624400877*^9, 3.614510645073004*^9}, {
   3.614510677787549*^9, 3.614510679035461*^9}, {3.614510726936481*^9, 
   3.614510728229434*^9}, 3.614510786695373*^9}],

Cell[BoxData[
 StyleBox["\<\"Sets the basis  Preset to 2, i.e 0 and 1.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379802541253*^9},
 CellTags->"Info-ed1414fc-f6fa-4fcc-bf97-c1f43e431070"],

Cell[BoxData[
 TagBox["2",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802667107*^9}],

Cell[BoxData[
 StyleBox["\<\"Returns the total number of qubits. Preset to 6\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379802797812*^9},
 CellTags->"Info-2c4fc2fd-f794-4a5a-9889-c5f744581475"],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379802900278*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "OneOp"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OneOp", "[", 
   RowBox[{"1", ",", "1", ",", "1"}], "]"}], "\[Equal]", 
  RowBox[{"s", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OneOp", "[", 
   RowBox[{"1", ",", "1", ",", "2"}], "]"}], "\[Equal]", 
  RowBox[{"s", "[", "2", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OneOp", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OneOp", "[", 
   RowBox[{"4", ",", "3", ",", "1"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6145108271720047`*^9, 3.61451091975165*^9}, 
   3.614510993798172*^9, {3.6145159079944468`*^9, 3.614515980618222*^9}, {
   3.61451601720253*^9, 3.614516149867836*^9}}],

Cell[BoxData[
 StyleBox["\<\"OneOp[L_,q_,op_]\\n\\n\t is the main ingredient used to \
\\nbuild one body operators from the Pauli matrices in a multiqubit system. \
It builds \\noperation Pauli operator op on q. For example, we have the \
equivalence for s[1] acting on qubit\\n3 in a 4 qubit system:\\nOneOp[4,3,1]\
\[Equal]AF[s[0]\[TensorProduct] s[0]\[TensorProduct] s[1]\[TensorProduct] \
s[0]] .\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798030547867`*^9},
 CellTags->"Info-d1dc9e4d-f3a5-48da-8a5b-8b97c414c404"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798031682377`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379803252521*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379803343625*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737980343124*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798035201683`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379803635058*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TwoOp"}]], "Input",
 CellChangeTimes->{{3.6145108271720047`*^9, 3.61451091975165*^9}, 
   3.614510993798172*^9, {3.6145159079944468`*^9, 3.614515980618222*^9}, {
   3.61451601720253*^9, 3.614516149867836*^9}, {3.6148562469383583`*^9, 
   3.614856371256057*^9}, {3.614892588880438*^9, 3.614892603819571*^9}}],

Cell[BoxData[
 StyleBox["\<\"TwoOp[L_,q1_,q2_,op1_,op2_]\\n\\n\t is the main ingredient \
used to \\nbuild two body operators from the Pauli matrices in a multiqubit \
system. It builds \\noperation op1 on q1 and op2 on q2.\"\>", "MSG"]], "Print",\
 "PrintUsage",
 CellChangeTimes->{3.6573798037699003`*^9},
 CellTags->"Info-e4bfdb26-48d7-4c97-ac32-1b390ec92a67"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TwoOp", "[", 
  RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.614892814320258*^9, 3.61489281452115*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]},
     {"1", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379803873836*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"TwoOp", "[", 
   RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "3"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "3", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TwoOp", "[", 
   RowBox[{"3", ",", "1", ",", "2", ",", "2", ",", "1"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TwoOp", "[", 
   RowBox[{"4", ",", "1", ",", "3", ",", "2", ",", "1"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6145108271720047`*^9, 3.61451091975165*^9}, 
   3.614510993798172*^9, {3.6145159079944468`*^9, 3.614515980618222*^9}, {
   3.61451601720253*^9, 3.614516149867836*^9}, {3.6148562469383583`*^9, 
   3.614856371256057*^9}, {3.614892588880438*^9, 3.614892718373517*^9}, {
   3.6148927492540083`*^9, 3.61489276559754*^9}, {3.614892805894182*^9, 
   3.6148928253110447`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379803990996*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804076356*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804164989*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ThreeOp"}]], "Input",
 CellChangeTimes->{{3.6145108271720047`*^9, 3.61451091975165*^9}, 
   3.614510993798172*^9, {3.6145159079944468`*^9, 3.614515980618222*^9}, {
   3.61451601720253*^9, 3.614516149867836*^9}, {3.6148562469383583`*^9, 
   3.614856371256057*^9}, {3.614892588880438*^9, 3.614892603819571*^9}, {
   3.614892960248869*^9, 3.614892968741435*^9}}],

Cell[BoxData[
 StyleBox["\<\"ThreeOp[L_,q1_,q2_,q3_,op1_,op2_,op3_]\\n\\n\t used to \
\\nbuild three body operators from the Pauli matrices in a multiqubit system. \
It builds \\noperation \[Sigma]op1 on q1, \[Sigma]op2 on q2 and \[Sigma]op3 \
on q3.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798043198547`*^9},
 CellTags->"Info-c49aa579-b2ac-4be5-8c01-fe2b55d58867"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ThreeOp", "[", 
  RowBox[{"3", ",", "1", ",", "2", ",", "3", ",", "0", ",", "0", ",", "1"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.614892814320258*^9, 3.61489281452115*^9}, {
  3.614892983568767*^9, 3.614893013996725*^9}, {3.614893053383253*^9, 
  3.614893053696198*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804441863*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ThreeOp", "[", 
   RowBox[{"3", ",", "1", ",", "2", ",", "3", ",", "0", ",", "0", ",", "1"}], 
   "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ThreeOp", "[", 
   RowBox[{"4", ",", "1", ",", "2", ",", "4", ",", "2", ",", "1", ",", "3"}], 
   "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "3", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ThreeOp", "[", 
   RowBox[{"6", ",", "1", ",", "3", ",", "2", ",", "1", ",", "3", ",", "1"}], 
   "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "3", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6145108271720047`*^9, 3.61451091975165*^9}, 
   3.614510993798172*^9, {3.6145159079944468`*^9, 3.614515980618222*^9}, {
   3.61451601720253*^9, 3.614516149867836*^9}, {3.6148562469383583`*^9, 
   3.614856371256057*^9}, {3.614892588880438*^9, 3.614892718373517*^9}, {
   3.6148927492540083`*^9, 3.61489276559754*^9}, {3.614892805894182*^9, 
   3.6148928253110447`*^9}, {3.614893026013103*^9, 3.6148933390613937`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804553293*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798046416187`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804731617*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 OverscriptBox["n", "^"]], "Input",
 CellChangeTimes->{{3.6149398345723886`*^9, 3.6149398647164907`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]},
      {
       RowBox[{
        RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Phi]", "]"}]}]},
      {
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379804841258*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "PartialTrace"}], "\[IndentingNewLine]", 
 RowBox[{"?", "PTrGen"}]}], "Input",
 CellChangeTimes->{{3.614596353685004*^9, 3.614596358065962*^9}, {
  3.614596520474407*^9, 3.6145965407109737`*^9}, {3.614597568486021*^9, 
  3.614597620030398*^9}}],

Cell[BoxData[
 StyleBox["\<\"PTrS[q,L,V] and PTr[traceout,\[CapitalOmega]] \\n\\n\\n\\n \
PTr[traceout,\[CapitalOmega]] returns the partial trace \\n\\n of general \
operator \[CapitalOmega] over those qubits \\n\\n specified by the traceout \
array 'traceout'. \\n\\n\\n\\n PTrS[q, L,V] returns the partial trace of spin \
basis \\n\\n operator of length L over single qubit q within L qubits, \\n\\n \
with the array V specifying the spin basis operator.\\n\\n This method \
reduces the operator down to the requisite smaller arrays.\\n\\n\\n\\n  see \
also PTrGen\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798049902554`*^9},
 CellTags->"Info-385432f1-0550-45c5-9d1a-2e76d8cfa09d"],

Cell[BoxData[
 StyleBox["\<\"PTrGen[traceout,\[CapitalOmega]] \\n\\n\\n\\n PTrGen[traceout,\
\[CapitalOmega]] returns the partial \\n\\n trace of a general operator \
\[CapitalOmega] over those\\n\\n qubits specified by the traceout array \
'traceout'.  \\nThis method builds up the requisite arrays and can be faster. \
\\n\\n\\n\\n see also PTr\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379805129529*^9},
 CellTags->"Info-a1a711db-5027-4c00-bb16-a10c159f153f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"rhoR", "=", " ", 
    RowBox[{"RandomQubitN", "[", "3", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", " ", "rhoR"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", " ", "rhoR"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PTrGen", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], ",", "  ", "rhoR"}], "]"}], "\[Equal]",
     "%"}]}]}]], "Input",
 CellChangeTimes->{{3.6145965658679247`*^9, 3.614596704233473*^9}, {
  3.614596736520089*^9, 3.6145967400738792`*^9}, {3.614597634856848*^9, 
  3.6145977251675262`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.15092361827518427`", 
      RowBox[{"0.026867896575786167`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03193278703935807`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03048671443025667`"}], "+", 
       RowBox[{"0.042061042364209746`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0006755108445181386`"}], "-", 
       RowBox[{"0.009586493949963713`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04465845191026647`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.002722116726159482`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.018014118344688062`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0031442923851557336`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.004225997423120895`"}], "+", 
       RowBox[{"0.03960429819270881`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.019034637808145464`"}], "+", 
       RowBox[{"0.023718127638492726`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.026867896575786167`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03193278703935807`", " ", "\[ImaginaryI]"}]}], 
      "0.15818001142097463`", 
      RowBox[{"0.03460115163020213`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.010802012565459325`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00589698281174238`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.028997223935687915`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.020811867912931083`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.05745543020854408`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.04617377926767537`"}], "-", 
       RowBox[{"0.0038184661473149293`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.018558111923256966`"}], "-", 
       RowBox[{"0.008234748078322494`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.01078393252162627`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.002480346689915116`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03048671443025667`"}], "-", 
       RowBox[{"0.042061042364209746`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03460115163020213`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.010802012565459325`", " ", "\[ImaginaryI]"}]}], 
      "0.1445542317545664`", 
      RowBox[{
       RowBox[{"-", "0.04506500829519092`"}], "-", 
       RowBox[{"0.018821489310939715`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00663985187064849`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.018805738127205082`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.018276855756895673`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.014993304372468125`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.026378884144069897`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.015429727759177928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.003889648158401518`"}], "-", 
       RowBox[{"0.057968121141195296`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.0006755108445181386`"}], "+", 
       RowBox[{"0.009586493949963713`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00589698281174238`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.028997223935687915`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.04506500829519092`"}], "+", 
       RowBox[{"0.018821489310939715`", " ", "\[ImaginaryI]"}]}], 
      "0.09221808783605034`", 
      RowBox[{"0.009934105332995756`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.014167466878701579`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.015450467402634883`"}], "+", 
       RowBox[{"0.03438755930079344`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.00045335395254266154`"}], "+", 
       RowBox[{"0.024825140168757802`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03144934008225966`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.007285012290258082`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.04465845191026647`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.002722116726159482`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.020811867912931083`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.05745543020854408`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00663985187064849`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.018805738127205082`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.009934105332995756`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.014167466878701579`", " ", "\[ImaginaryI]"}]}], 
      "0.145577265707828`", 
      RowBox[{
       RowBox[{"-", "0.0027114975300122825`"}], "-", 
       RowBox[{"0.02792963485016937`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04493051615907199`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.019291205184221682`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.033319435701912314`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.04190965416266101`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.018014118344688062`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0031442923851557336`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.04617377926767537`"}], "+", 
       RowBox[{"0.0038184661473149293`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.018276855756895673`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.014993304372468125`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.015450467402634883`"}], "-", 
       RowBox[{"0.03438755930079344`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0027114975300122825`"}], "+", 
       RowBox[{"0.02792963485016937`", " ", "\[ImaginaryI]"}]}], 
      "0.09303757044260749`", 
      RowBox[{"0.04068568357779525`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.022085564669753626`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.004970325676512875`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.02914435867449851`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.004225997423120895`"}], "-", 
       RowBox[{"0.03960429819270881`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.018558111923256966`"}], "+", 
       RowBox[{"0.008234748078322494`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.026378884144069897`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.015429727759177928`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.00045335395254266154`"}], "-", 
       RowBox[{"0.024825140168757802`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04493051615907199`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.019291205184221682`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04068568357779525`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.022085564669753626`", " ", "\[ImaginaryI]"}]}], 
      "0.10267897401778794`", 
      RowBox[{"0.035941893153599455`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.01878175055681254`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.019034637808145464`"}], "-", 
       RowBox[{"0.023718127638492726`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.01078393252162627`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.002480346689915116`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.003889648158401518`"}], "+", 
       RowBox[{"0.057968121141195296`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03144934008225966`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.007285012290258082`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.033319435701912314`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.04190965416266101`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.004970325676512875`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.02914435867449851`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.035941893153599455`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.01878175055681254`", " ", "\[ImaginaryI]"}]}], 
      "0.1128302405450011`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805247642*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.2965008839830123`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.02415639904577388`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.05986242188952744`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.014443801728815316`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.02276983717998806`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.032643924857394174`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.05149614811262472`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.02415639904577388`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.05986242188952744`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2512175818635821`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.07528683520799738`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.032887577235212954`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.010867308488255253`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.00014713473881059792`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.014443801728815316`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.02276983717998806`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.07528683520799738`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03288757723521296`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.24723320577235436`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.00912311514159146`"}], "-", 
       RowBox[{"0.037603239867752256`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.032643924857394174`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.05149614811262473`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.01086730848825525`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.00014713473881059792`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.00912311514159146`"}], "+", 
       RowBox[{"0.037603239867752256`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.20504832838105147`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805349102*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.5477184658465944`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.025311110217070568`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.022622702441177464`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.025311110217070568`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.022622702441177464`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.4522815341534058`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805440703*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805537548*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"psi", "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "=", 
  RowBox[{"AF", "[", 
   RowBox[{"psi", "\[TensorProduct]", " ", 
    RowBox[{"Adj", "[", "psi", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.61459683500141*^9, 3.6145969517221003`*^9}, 
   3.614596987024096*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805703412*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Tr", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
   RowBox[{"Bra", "[", "0", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
   RowBox[{"Bra", "[", "1", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6145970412566433`*^9, 3.614597051302167*^9}, {
  3.614597161605191*^9, 3.614597166192556*^9}, {3.614597253331628*^9, 
  3.614597256458207*^9}}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805822659*^9}],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379805915277*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", "rho"}], " ", "]"}], 
  "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Bra", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", "rho"}], " ", "]"}], "\[Equal]", 
  RowBox[{"AF", "[", "  ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", "  ", 
      RowBox[{"Ket", "[", "0", "]"}]}], ")"}], "\[TensorProduct]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Bra", "[", "0", "]"}], "\[TensorProduct]", " ", 
      RowBox[{"Bra", "[", "0", "]"}]}], ")"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6145971209935617`*^9, 3.614597131645557*^9}, {
  3.614597186905508*^9, 3.6145973176014633`*^9}, {3.614597347895032*^9, 
  3.6145973733086977`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806039083*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806136701*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rho4", "=", 
   RowBox[{"RandomQubitN", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resT", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", "rho4"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PTrGen", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", "  ", "rho4"}], "]"}], 
  "\[Equal]", "%"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Tr", "[", "resT", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Tr", "[", 
   RowBox[{"resT", ".", "resT"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614597414109103*^9, 3.6145974687590857`*^9}, {
  3.614597746002454*^9, 3.61459780320525*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.5215022907340003`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.028480849465245317`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0511999253516309`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.028480849465245317`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0511999253516309`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.4784977092659994`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806254734*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806359103*^9}],

Cell[BoxData[
 TagBox["0.9999999999999998`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806459072*^9}],

Cell[BoxData[
 TagBox["0.5077898792981678`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806558999*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ProjG"}]], "Input",
 CellChangeTimes->{{3.614621779500534*^9, 3.614621783793659*^9}}],

Cell[BoxData[
 StyleBox["\<\"ProjG[a,vec], \\n\\n\t  Projection operator into any direction \
defined by the unit three-vector vec. \\n\\n\t Here a equals 0 or 1. \\n\\n\t \
For example,\\n\\n\t ProjG[0,nhat] equals (\[DoubleStruckCapitalI] + \
nhat.sigvec)/2 and\\n\\n\t ProjG[1,nhat] equals (\[DoubleStruckCapitalI] - \
nhat.sigvec)/2,\\n\\n\t where nhat is a unit direction vector and sigvec is \
the Pauli vector.\\n\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379806726221*^9},
 CellTags->"Info-0b66b116-268e-467e-afe1-19a1784a7433"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"0", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}], "==", 
  SubscriptBox["\[ScriptCapitalP]", "0"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}], "==", 
  SubscriptBox["\[ScriptCapitalP]", "1"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"0", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"PX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"PX", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"0", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"PY", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ProjG", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"PY", "[", "1", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6146218072518997`*^9, 3.614621893360815*^9}, {
  3.6146219354019423`*^9, 3.614622040841241*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737980686754*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379806959424*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807061172*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798071601257`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807272052*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807370921*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  OverscriptBox["\[Sigma]", "\[RightVector]"], "=", 
  RowBox[{"{", " ", 
   RowBox[{
    RowBox[{"s", "[", "1", "]"}], ",", " ", 
    RowBox[{"s", "[", "2", "]"}], ",", "  ", 
    RowBox[{"s", "[", "3", "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  OverscriptBox["n", "^"], "=", 
  RowBox[{"{", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", "\[Theta]", "]"}], "  ", 
     RowBox[{"Cos", "[", "\[Phi]", "]"}]}], ",", "  ", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
     RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ",", " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}], " ", 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  OverscriptBox["n", "^"], ".", 
  OverscriptBox["\[Sigma]", "\[RightVector]"]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   OverscriptBox["n", "^"], ".", 
   OverscriptBox["n", "^"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[DoubleStruckCapitalI]", " ", "+", 
     RowBox[{
      OverscriptBox["n", "^"], ".", 
      OverscriptBox["\[Sigma]", "\[RightVector]"]}]}], ")"}], "/", "2"}], " ",
   "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"AF", "[", 
    RowBox[{"ProjG", "[", 
     RowBox[{"0", ",", 
      OverscriptBox["n", "^"]}], "]"}], "]"}], ",", " ", 
   RowBox[{
    RowBox[{"Element", "[", 
     RowBox[{"\[Theta]", ",", " ", "Reals"}], "]"}], "&&", 
    RowBox[{"Element", "[", 
     RowBox[{"\[Phi]", ",", "Reals"}], "]"}]}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.614622700666028*^9, 3.614622742492999*^9}, {
   3.614623104245549*^9, 3.614623199052805*^9}, {3.614623264707073*^9, 
   3.614623346938325*^9}, {3.614623450209985*^9, 3.614623482663021*^9}, {
   3.614623513093705*^9, 3.6146235389324837`*^9}, {3.614623580747607*^9, 
   3.61462359244693*^9}, {3.614623721142283*^9, 3.614623752933078*^9}, {
   3.614623793667309*^9, 3.6146238020819387`*^9}, {3.614623934656144*^9, 
   3.6146239351394243`*^9}, 3.6146240586601877`*^9, {3.614785911147131*^9, 
   3.6147859217665033`*^9}, 3.6147859545722237`*^9, {3.614939929241047*^9, 
   3.614939929254902*^9}, {3.614940083980501*^9, 3.614940097670382*^9}, {
   3.615976644798956*^9, 3.615976666478043*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"1"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", "\[ImaginaryI]"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"\[ImaginaryI]"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"1"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", "1"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807490446*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]},
      {
       RowBox[{
        RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Phi]", "]"}]}]},
      {
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807594474*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", "\[Theta]", "]"}], 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], 
      RowBox[{"-", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807699189*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807793254*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        FractionBox["\[Theta]", "2"], "]"}], "2"], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Phi]", "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Phi]", "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}], "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379807906529*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox[
       RowBox[{"Cos", "[", 
        FractionBox["\[Theta]", "2"], "]"}], "2"], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Phi]", "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Phi]", "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], 
      SuperscriptBox[
       RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}], "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379808005334*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 OverscriptBox["\[Sigma]", "\[RightVector]"], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   OverscriptBox["\[Sigma]", "\[RightVector]"], "[", 
   RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
  RowBox[{"s", "[", "1", "]"}], "==", 
  SubscriptBox["\[Sigma]", "1"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   OverscriptBox["\[Sigma]", "\[RightVector]"], "[", 
   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
  RowBox[{"s", "[", "2", "]"}], "==", 
  SubscriptBox["\[Sigma]", "2"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   OverscriptBox["\[Sigma]", "\[RightVector]"], "[", 
   RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
  RowBox[{"s", "[", "3", "]"}], "==", 
  SubscriptBox["\[Sigma]", "3"]}]}], "Input",
 CellChangeTimes->{{3.614940042996229*^9, 3.6149400674459057`*^9}, {
  3.615976497612711*^9, 3.615976506309054*^9}, {3.615976695593787*^9, 
  3.615976754779663*^9}, {3.615976793256731*^9, 3.61597681624091*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"1"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", "\[ImaginaryI]"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"\[ImaginaryI]"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"1"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", "1"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798081334753`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379808238831*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379808338839*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379808451829*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{"ProjG", "[", 
       RowBox[{"0", ",", 
        OverscriptBox["n", "^"]}], "]"}], "]"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[DoubleStruckCapitalI]", " ", "+", 
        RowBox[{
         OverscriptBox["n", "^"], ".", 
         OverscriptBox["\[Sigma]", "\[RightVector]"]}]}], ")"}], "/", "2"}]}],
     ",", " ", 
    RowBox[{
     RowBox[{"Element", "[", 
      RowBox[{"\[Theta]", ",", " ", "Reals"}], "]"}], "&&", 
     RowBox[{"Element", "[", 
      RowBox[{"\[Phi]", ",", "Reals"}], "]"}]}]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"s", "[", "0", "]"}], "-", 
   RowBox[{"s", "[", "0", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{"ProjG", "[", 
       RowBox[{"1", ",", 
        OverscriptBox["n", "^"]}], "]"}], "]"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[DoubleStruckCapitalI]", " ", "-", 
        RowBox[{
         OverscriptBox["n", "^"], ".", 
         OverscriptBox["\[Sigma]", "\[RightVector]"]}]}], ")"}], "/", "2"}]}],
     ",", " ", 
    RowBox[{
     RowBox[{"Element", "[", 
      RowBox[{"\[Theta]", ",", " ", "Reals"}], "]"}], "&&", 
     RowBox[{"Element", "[", 
      RowBox[{"\[Phi]", ",", "Reals"}], "]"}]}]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"s", "[", "0", "]"}], "-", 
   RowBox[{"s", "[", "0", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.614623853378378*^9, 3.614623895508724*^9}, {
  3.614623993288425*^9, 3.614624002253435*^9}, {3.614624071888228*^9, 
  3.614624109991733*^9}, {3.6149399239556303`*^9, 3.614939929214218*^9}, {
  3.614940103891426*^9, 3.614940113421453*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379808593255*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798086932487`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`Rot*"}]], "Input",
 CellChangeTimes->{{3.614785320884952*^9, 3.6147853278385973`*^9}, 
   3.6147853620737*^9, {3.6147854175106907`*^9, 3.614785470926012*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-82b6cc58-6216-4849-a74c-178f66beae31", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-82b6cc58-6216-4849-a74c-178f66beae31", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-82b6cc58-6216-4849-a74c-178f66beae31", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-82b6cc58-6216-4849-a74c-178f66beae31", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.2375]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657379808851769*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`Random*"}]], "Input",
 CellChangeTimes->{{3.614785320884952*^9, 3.6147853278385973`*^9}, 
   3.6147853620737*^9, {3.6147854175106907`*^9, 3.614785470926012*^9}, {
   3.614801734918335*^9, 3.614801737092087*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-b570e7a8-ecc0-4f29-ace0-0cc8cbb687fe", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.10555555555555554`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657379809007133*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ra1", "=", "RandomKet1"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "ra1", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.614801760941936*^9, 3.614801902522766*^9}, {
   3.616278458196355*^9, 3.616278568191065*^9}, {3.616278606296336*^9, 
   3.616278680426774*^9}, {3.616279160206479*^9, 3.616279186236405*^9}, {
   3.6162793326466846`*^9, 3.616279334975986*^9}, {3.616279411820554*^9, 
   3.616279467819096*^9}, 3.616279942437193*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.24115734281732865`"}], "-", 
       RowBox[{"0.83699261967686`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.13227182861373316`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.47306516883716115`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809149123*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.24115734281732865`"}], "-", 
      RowBox[{"0.83699261967686`", " ", "\[ImaginaryI]"}]}],"\")\"","\" |\"",
    "\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.13227182861373316`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.47306516883716115`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809250723*^9}],

Cell[CellGroupData[{

Cell[BoxData[{"RandomKet2", "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.21670785812329493`"}], "+", 
       RowBox[{"0.17261479676784705`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.11759877624419926`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.48425407585082253`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.48094914096272406`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.4449316290368991`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.41077669205073103`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.2773024207788116`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798093741713`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.21670785812329493`"}], "+", 
      RowBox[{"0.17261479676784705`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.11759877624419926`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.48425407585082253`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"01\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.48094914096272406`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.4449316290368991`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.41077669205073103`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.2773024207788116`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809472374*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"RandomBra1", "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", 
  "]"}], "\[IndentingNewLine]", "RandomBra2", "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614801760941936*^9, 3.614801870010709*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.379805887194687`"}], "+", 
       RowBox[{"0.7098602746120487`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.465363292021548`"}], "+", 
       RowBox[{"0.3678082177151986`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809597011*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.379805887194687`"}], "+", 
      RowBox[{"0.7098602746120487`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.465363292021548`"}], "+", 
      RowBox[{"0.3678082177151986`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809705398*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.08378301753248653`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.3742363798311565`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.05186204187530741`"}], "+", 
       RowBox[{"0.5117077991491013`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.31854247839490485`"}], "+", 
       RowBox[{"0.5971212217743195`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2905821334976893`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.21431741539883023`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798098066683`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.08378301753248653`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.3742363798311565`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"00\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.05186204187530741`"}], "+", 
      RowBox[{"0.5117077991491013`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"01\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.31854247839490485`"}], "+", 
      RowBox[{"0.5971212217743195`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"10\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.2905821334976893`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.21431741539883023`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"11\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379809905835*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RandomKetN", "[", "4", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RandomBraN", "[", "4", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6148156640920773`*^9, 3.6148157293882303`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.14141239246141343`"}], "+", 
      RowBox[{"0.11105909118142532`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.2840097520692344`"}], "+", 
      RowBox[{"0.05295505603636`", " ", "\[ImaginaryI]"}]}],"\")\"","\" |\"",
    "\"0001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.16263280772169053`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.23680343266619952`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.2133432847675023`"}], "+", 
      RowBox[{"0.08628652655839471`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.22484629490468233`"}], "+", 
      RowBox[{"0.009850767079295223`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.24652758698556787`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.18670146280153868`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.15792681256853605`"}], "+", 
      RowBox[{"0.23140911200837938`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.12641517505783473`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.19012273989600303`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"0111\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.07034307211742878`"}], "+", 
      RowBox[{"0.00022674501418385628`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.20020388161719868`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.12862855347178875`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.10834220769011052`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.18565821555933065`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.09632372606219165`"}], "-", 
      RowBox[{"0.2501534958037083`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.031285405567656153`"}], "-", 
      RowBox[{"0.2747758979545781`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.14250500234753577`"}], "-", 
      RowBox[{"0.28078656435762106`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.1316015151682294`"}], "-", 
      RowBox[{"0.16506561332307268`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.18972506068026326`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.18969511657357388`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798100331697`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.048146329227314315`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.24958521424375094`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0000\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.019432742601494298`"}], "+", 
      RowBox[{"0.1524694711251525`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0001\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.25789141123178755`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.19896934720638484`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0010\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.2559250376342714`"}], "+", 
      RowBox[{"0.22374326208722659`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0011\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.18386882883757955`"}], "+", 
      RowBox[{"0.26949954255068387`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0100\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.01897603565749958`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.10895603374427733`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0101\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.21380239606912163`"}], "+", 
      RowBox[{"0.20190257310825901`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0110\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.11083748022653746`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.25391906955299104`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0111\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.2107490883544167`"}], "-", 
      RowBox[{"0.17811394325477756`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1000\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.05601429935936918`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.24138799501523428`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1001\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.039343807793198064`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.01960764292047539`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1010\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.08264482385124022`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.22943283221552271`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1011\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.21823739961320512`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.2443332415761194`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1100\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.03516824461771625`"}], "-", 
      RowBox[{"0.07011749753682063`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1101\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.05526386407561222`"}], "+", 
      RowBox[{"0.18986183621926633`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1110\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.2132361046451166`"}], "+", 
      RowBox[{"0.1058564903868553`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1111\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379810140007*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", "  ", 
  RowBox[{
  "Now", " ", "we", " ", "look", " ", "at", " ", "some", " ", "random", " ", 
   "qubit", " ", "density", " ", "matrices"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6148515915303917`*^9, 3.614851609365136*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"r1", "=", "RandomQubit1"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Pvec", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      RowBox[{"r1", ".", 
       RowBox[{"s", "[", "1", "]"}]}], "]"}], "]"}], ",", 
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      RowBox[{"r1", ".", 
       RowBox[{"s", "[", "2", "]"}]}], "]"}], "]"}], ",", 
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      RowBox[{"r1", ".", 
       RowBox[{"s", "[", "3", "]"}]}], "]"}], "]"}]}], 
   "}"}]}], "\[IndentingNewLine]", "RandomQubit2", "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614815742039184*^9, 3.614815756814451*^9}, {
  3.614851541981352*^9, 3.614851549753937*^9}, {3.614851642012006*^9, 
  3.61485164270822*^9}, {3.614851715504431*^9, 3.614851715965639*^9}, {
  3.614851756419454*^9, 3.6148517756691313`*^9}, {3.6148518226899223`*^9, 
  3.6148518742002153`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6141255876728244`", 
      RowBox[{"0.031922594573263754`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.4829301075277924`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.031922594573263754`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.4829301075277924`", " ", "\[ImaginaryI]"}]}], 
      "0.38587441232717573`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798102985992`*^9}],

Cell[BoxData[
 TagBox["1.0000000000000002`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379810405982*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0.06384518914652751`"},
      {"0.9658602150555848`"},
      {"0.2282511753456487`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379810517235*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.2116458168945951`", 
      RowBox[{
       RowBox[{"-", "0.029219668871850128`"}], "+", 
       RowBox[{"0.030014862022779636`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.05564687670076135`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.065396037575249`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.055565723893160585`"}], "-", 
       RowBox[{"0.07793501971473933`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.029219668871850128`"}], "-", 
       RowBox[{"0.030014862022779636`", " ", "\[ImaginaryI]"}]}], 
      "0.17165062317865928`", 
      RowBox[{"0.0600062769666029`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.14309044190604034`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04592649502309938`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.06295201241495907`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.05564687670076135`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.065396037575249`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0600062769666029`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.14309044190604034`", " ", "\[ImaginaryI]"}]}], 
      "0.29900656065627795`", 
      RowBox[{"0.03778172060671432`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0048891146866999165`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.055565723893160585`"}], "+", 
       RowBox[{"0.07793501971473933`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04592649502309938`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.06295201241495907`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.03778172060671432`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0048891146866999165`", " ", "\[ImaginaryI]"}]}], 
      "0.3176969992704677`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798106216307`*^9}],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798107435007`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"rho", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"RandomQubitN", "[", "8", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Tr", "[", "rho", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Purity", "[", "rho", "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Eigenvalues", "[", "rho", "]"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"n", ",", "Ev"}], "}"}]}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "Eigenvalues"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Thin", ",", 
      RowBox[{"PointSize", "[", "Small", "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.61484529851468*^9, 3.614845342016259*^9}, 
   3.6148454481442947`*^9, {3.6148454854699907`*^9, 3.614845488079021*^9}, {
   3.614845542122632*^9, 3.6148455554295464`*^9}, {3.614845625976268*^9, 
   3.614845627077035*^9}, {3.614845680311096*^9, 3.6148457053301287`*^9}, {
   3.614845772669839*^9, 3.614845773286627*^9}}],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379810917684*^9}],

Cell[BoxData[
 TagBox["0.007794252014643704`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798110324793`*^9}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {{}, 
     {RGBColor[1, 0, 0], PointSize[Small], Thickness[Tiny], 
      PointBox[CompressedData["
1:eJw1zXs4lHkfx/E7senIJiHHemylw4Yk5z4RImGIMA4zZhiGMQ5bJDSlgwgl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       "]]}, {}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["n", TraditionalForm], 
     FormBox["Ev", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotLabel->FormBox["Eigenvalues", TraditionalForm],
   PlotRange->{{0., 256.}, {0., 0.01506090844634103}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379811198535*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Rotqbit"}]], "Input",
 CellChangeTimes->{{3.614785480038932*^9, 3.61478548925773*^9}}],

Cell[BoxData[
 StyleBox["\<\"Rotqbit[v,t],\\n\\n\t builds the matrix corresponding to a \
rotation around \\n\\n axis v of an angle t: MatrixExp[-\[ImaginaryI] t/2 \
\[Sigma].v]\\n\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379811396491*^9},
 CellTags->"Info-d05aa854-9745-4a27-a60e-aa6a2ce8d635"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 OverscriptBox["n", "^"], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   OverscriptBox["n", "^"], ".", 
   OverscriptBox["n", "^"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6147855657483788`*^9, 3.614785600978034*^9}, {
   3.614939929218698*^9, 3.614939929225316*^9}, 3.614940254634865*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{"Cos", "[", "\[Phi]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]},
      {
       RowBox[{
        RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Phi]", "]"}]}]},
      {
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379811538631*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798116503353`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   OverscriptBox["n", "^"], ".", 
   OverscriptBox["\[Sigma]", "\[RightVector]"]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Eigenvalues", "[", "%", 
  "]"}], "\[IndentingNewLine]", "Ket1"}], "Input",
 CellChangeTimes->{{3.614785674340254*^9, 3.614785724225272*^9}, 
   3.614939929228693*^9, 3.614940121059119*^9, {3.615191145365663*^9, 
   3.615191222919488*^9}, {3.61519125320268*^9, 3.615191306885151*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", "\[Theta]", "]"}], 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Phi]"}]], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]},
     {
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "\[Phi]"}]], " ", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}], 
      RowBox[{"-", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798117816687`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"-", "1"}]},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379811888089*^9}],

Cell[BoxData[
 TagBox["Ket1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379811996167*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Eigen*"}]], "Input",
 CellChangeTimes->{{3.615191179141171*^9, 3.615191182386868*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["System`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["System`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["Eigensystem",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-c944a212-227d-40b8-9864-4b3cd0a46831", {
            "Eigensystem", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Eigenvalues",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-c944a212-227d-40b8-9864-4b3cd0a46831", {
            "Eigenvalues", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["EigenvectorCentrality",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-c944a212-227d-40b8-9864-4b3cd0a46831", {
            "EigenvectorCentrality", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Eigenvectors",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-c944a212-227d-40b8-9864-4b3cd0a46831", {
            "Eigenvectors", "System`"}},
          ButtonNote->"System`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.2375]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6573798121594467`*^9}]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["The following rotations are about a specific axis.  \
The Wigner rotations using Euler angles are illustrated in a separate \
notebook.",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.61572689893294*^9, 3.615726948250309*^9}},
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Rotation", " ", "about", " ", "x", " ", "axis"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Rotqbit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "\[Theta]"}], "]"}], 
     ".", 
     RowBox[{"Ket", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
   RowBox[{"DForm", "[", " ", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "I"}], " ", 
       RowBox[{"Pi", "/", "4"}]}], "]"}], 
     RowBox[{"Ket1", "[", 
      RowBox[{"\[Theta]", ",", 
       RowBox[{
        RowBox[{"-", "Pi"}], "/", "2"}]}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Rotation", " ", "about", " ", "y", " ", "axis"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Rotqbit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "\[Theta]"}], "]"}], 
     ".", 
     RowBox[{"Ket", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
   RowBox[{"DForm", "[", 
    RowBox[{"Ket1", "[", 
     RowBox[{"\[Theta]", ",", " ", "0"}], "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Rotation", " ", "about", " ", "z", " ", "axis"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Rotqbit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "\[Theta]"}], "]"}], 
     ".", 
     RowBox[{"Ket", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"DForm", "[", "%", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.614786508360718*^9, 3.614786547529126*^9}, {
   3.614801221063384*^9, 3.61480131232961*^9}, {3.614801435512061*^9, 
   3.6148015208273153`*^9}, {3.6148015636914*^9, 3.614801609056766*^9}, 
   3.614801668085327*^9, {3.615191352266014*^9, 3.615191408041358*^9}, {
   3.615196734450344*^9, 3.6151967407273817`*^9}, {3.615196785579686*^9, 
   3.615196796546771*^9}, {3.615196844493659*^9, 3.6151968779808064`*^9}, {
   3.615196924622155*^9, 3.6151970306924562`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}]}],"\")\"","\" |\"","\"1\"",
    "\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379812288911*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}]}],"\")\"","\" |\"","\"1\"",
    "\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737981239509*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{"Sin", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798124997883`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{"Sin", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379812606491*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]}]],"\")\"","\" |\"",
    "\"0\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379812732025*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Rotqbit", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "\[Theta]"}], "]"}], 
  "\[Equal]", 
  RowBox[{"RotX", "[", "\[Theta]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rotqbit", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "\[Theta]"}], "]"}], 
  "\[Equal]", 
  RowBox[{"RotY", "[", "\[Theta]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rotqbit", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "\[Theta]"}], "]"}], 
  "\[Equal]", 
  RowBox[{"RotZ", "[", "\[Theta]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.614801572327919*^9, 3.614801594354293*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379812895492*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813011022*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813128476*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  OverscriptBox["n", "^"], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[Theta]", "\[Rule]", " ", 
     RowBox[{"Pi", "/", "2"}]}], ",", 
    RowBox[{"\[Phi]", "\[Rule]", " ", 
     RowBox[{"Pi", "/", "2"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.615029043823103*^9, 3.61502907175375*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813251837*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"MatrixExp", "[", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      RowBox[{"t", "/", "2"}], " ", 
      RowBox[{"s", "[", "3", "]"}]}], "]"}], " ", "/.", " ", 
    RowBox[{"{", 
     RowBox[{"t", "\[Rule]", " ", "Pi"}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{"%", "\[Equal]", 
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", 
     RowBox[{"s", "[", "3", "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.61504389387061*^9, 3.615043894548263*^9}, {
  3.615043934181923*^9, 3.615043989079728*^9}, {3.6151909187896633`*^9, 
  3.615191019685482*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", "\[ImaginaryI]"}], "0"},
     {"0", "\[ImaginaryI]"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813379879*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813495059*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "  ", 
   RowBox[{
    RowBox[{"A", " ", 
     RowBox[{"Pi", "/", "2"}], " ", "spin", " ", 
     RowBox[{"1", "/", "2"}], " ", "rotation", " ", "about", " ", "the", " ", 
     "y"}], "-", 
    RowBox[{
    "axis", " ", "is", " ", "a", " ", "Hadamard", " ", "within", " ", "a", 
     " ", "phase"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Rotqbit", "[", 
     RowBox[{
      OverscriptBox["n", "^"], ",", 
      RowBox[{
       RowBox[{"-", "Pi"}], "/", "2"}]}], "]"}], " ", "/.", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Theta]", "\[Rule]", " ", 
       RowBox[{"Pi", "/", "2"}]}], ",", 
      RowBox[{"\[Phi]", "\[Rule]", " ", 
       RowBox[{"Pi", "/", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", " ", 
   RowBox[{"rotH", "=", 
    RowBox[{
     RowBox[{"s", "[", "3", "]"}], ".", 
     RowBox[{"Rotqbit", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
       RowBox[{
        RowBox[{"-", "Pi"}], "/", "2"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   StyleBox[" ", "MSG"], 
   StyleBox["\[ScriptCapitalH]", "MSG",
    FontSize->16], 
   StyleBox[" ", "MSG",
    FontSize->16], 
   StyleBox["\[IndentingNewLine]", "MSG",
    FontSize->16], 
   RowBox[{
    RowBox[{
     StyleBox["rotH", "MSG",
      FontSize->16], 
     StyleBox[".", "MSG",
      FontSize->16], 
     RowBox[{"Ket", "[", "0", "]"}]}], "\[Equal]", 
    RowBox[{"\[ScriptCapitalH]", ".", 
     RowBox[{"Ket", "[", "0", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     StyleBox["rotH", "MSG",
      FontSize->16], 
     StyleBox[".", "MSG",
      FontSize->16], 
     RowBox[{"Ket", "[", "1", "]"}]}], "\[Equal]", 
    RowBox[{"\[ScriptCapitalH]", ".", 
     RowBox[{"Ket", "[", "1", "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.614851996640057*^9, 3.61485200629327*^9}, {
   3.614852054959833*^9, 3.614852058567501*^9}, {3.6148521062555933`*^9, 
   3.6148521074013367`*^9}, {3.6148522256006203`*^9, 3.61485229334475*^9}, {
   3.614852395806662*^9, 3.6148524058968773`*^9}, 3.6148524518974752`*^9, {
   3.614852498737692*^9, 3.6148526130097446`*^9}, {3.614852664397533*^9, 
   3.614852733794731*^9}, {3.61502923280228*^9, 3.61502924488446*^9}, 
   3.615043529223188*^9, {3.615043573523369*^9, 3.615043621254875*^9}, {
   3.6150436644758177`*^9, 3.615043669694355*^9}, {3.6151908499091682`*^9, 
   3.6151908504386272`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], 
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813632255*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813740039*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813855321*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379813962007*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379814097386*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Wigner*"}]], "Input",
 CellChangeTimes->{{3.615197729890328*^9, 3.6151977389484997`*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["System`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["System`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["WignerD",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-476d15fe-cef0-436f-baa3-d34430b89f3b", {
            "WignerD", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["WignerSemicircleDistribution",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-476d15fe-cef0-436f-baa3-d34430b89f3b", {
            "WignerSemicircleDistribution", "System`"}},
          ButtonNote->"System`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.475]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657379814277031*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Rotqbit", "[", 
   RowBox[{
    OverscriptBox["n", "^"], ",", "\[Theta]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rotqbit", "[", 
   RowBox[{
    OverscriptBox["n", "^"], ",", "\[Theta]"}], "]"}], ".", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"DForm", "[", "%", "]"}], ",", 
   RowBox[{"Trig", "\[Rule]", "False"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.614785522477777*^9, 3.614785558195698*^9}, {
  3.614785610887342*^9, 3.6147856668089037`*^9}, {3.6147857498647547`*^9, 
  3.6147857858612413`*^9}, {3.614785964559079*^9, 3.6147860011430264`*^9}, {
  3.614786072466282*^9, 3.614786186016363*^9}, {3.614786229034487*^9, 
  3.614786245224031*^9}, {3.6147863688332863`*^9, 3.614786474317567*^9}, {
  3.6149399292330112`*^9, 3.614939929236423*^9}, {3.615197105693131*^9, 
  3.61519717017575*^9}, {3.6151972057705803`*^9, 3.61519722065207*^9}, {
  3.615197267923493*^9, 3.615197270823805*^9}, {3.615197308353696*^9, 
  3.615197336442299*^9}, {3.6151973714529743`*^9, 3.61519740156769*^9}, {
  3.615197434560234*^9, 3.61519747538588*^9}, {3.61519757387516*^9, 
  3.615197596374447*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "-", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}]}]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", "\[Phi]", "]"}]}], " ", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
           RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", "\[Phi]", "]"}]}], " ", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
           RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ")"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379814435251*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"Cos", "[", 
        FractionBox["\[Theta]", "2"], "]"}], "+", 
      RowBox[{
        FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
        RowBox[{"(", 
          RowBox[{
            RowBox[{"Sin", "[", 
              FractionBox["\[Theta]", "2"], "]"}], "-", 
            RowBox[{"Sin", "[", 
              FractionBox[
               RowBox[{"3", " ", "\[Theta]"}], "2"], "]"}]}], ")"}]}]}],
    "\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}], " ", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}], " ", 
      RowBox[{"(", 
        RowBox[{
          RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", 
            RowBox[{"Cos", "[", "\[Phi]", "]"}]}], "+", 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}], ")"}]}],"\")\"","\" |\"",
    "\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798145516644`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Trig"}]], "Input",
 CellChangeTimes->{{3.6151972348665*^9, 3.615197236974169*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"Trig is an option for various polynomial manipulation \
functions that specifies whether trigonometric functions should be treated \
like polynomial elements.\"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Trig"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379814725465*^9},
 CellTags->"Info-d221bb50-e497-4c82-b5fc-8356b5bb91bc"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Pauli", " ", "Matrices", "  ", "Equivalent", " ", "Forms"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.6148527839843616`*^9, 3.61485279782648*^9}, {
  3.614853642302339*^9, 3.614853647960286*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "PauliMatrix"}], "\[IndentingNewLine]", 
 RowBox[{"?", "s"}]}], "Input",
 CellChangeTimes->{{3.614852990130526*^9, 3.61485299300521*^9}, {
  3.6148530242906113`*^9, 3.6148530424685907`*^9}, {3.614853103694531*^9, 
  3.6148531667538652`*^9}, {3.614853213462365*^9, 3.614853219851118*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"PauliMatrix\\\", \\\"[\\\", \
StyleBox[\\\"k\\\", \\\"TI\\\"], \\\"]\\\"}]\) gives the \!\(\*StyleBox[\\\"k\
\\\", \\\"TI\\\"]\)\!\(\*SuperscriptBox[\\\"\[Null]\\\", \\\"th\\\"]\) Pauli \
spin matrix \!\(\*SubscriptBox[\\\"\[Sigma]\\\", StyleBox[\\\"k\\\", \\\"TI\\\
\"]]\).\"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/PauliMatrix"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798148998327`*^9},
 CellTags->"Info-b721e6a4-0022-44d8-b7dd-bd64b7b406bf"],

Cell[BoxData[
 StyleBox["\<\"s[i] with i={0,1,2,3}\\n\\n Returns the Pauli Sigma \
matrices.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379815075304*^9},
 CellTags->"Info-10189915-d906-4ad1-b6a6-15b156632072"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"PauliMatrix", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PauliMatrix", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PauliMatrix", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PauliMatrix", "[", "3", "]"}]}], "Input",
 CellChangeTimes->{{3.614853235195223*^9, 3.614853293781836*^9}, {
  3.614853396073605*^9, 3.6148533989306*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798152250147`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379815332665*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379815439992*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379815555726*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox["\[Sigma]", "0"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "1"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "2"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "3"]}], "Input",
 CellChangeTimes->{{3.614853344845902*^9, 3.614853385273594*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798157222548`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379815841235*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379815952464*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379816063593*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"PauliMatrix", "[", "0", "]"}], ",", 
    RowBox[{"PauliMatrix", "[", "1", "]"}], ",", 
    RowBox[{"PauliMatrix", "[", "2", "]"}], ",", 
    RowBox[{"PauliMatrix", "[", "3", "]"}]}], "}"}], "==", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], ",", 
    RowBox[{"s", "[", "1", "]"}], ",", 
    RowBox[{"s", "[", "2", "]"}], ",", 
    RowBox[{"s", "[", "3", "]"}]}], "}"}], "==", 
  RowBox[{"{", 
   RowBox[{"Sigma0", ",", "Sigma1", ",", "Sigma2", ",", "Sigma3"}], "}"}], 
  "\[Equal]", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Sigma]", "0"], ",", 
    SubscriptBox["\[Sigma]", "1"], ",", 
    SubscriptBox["\[Sigma]", "2"], ",", 
    SubscriptBox["\[Sigma]", "3"]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.61485280432136*^9, 3.61485296208074*^9}, {
  3.614853246097472*^9, 3.6148532529361362`*^9}, {3.614853421554577*^9, 
  3.6148534242538843`*^9}, {3.614853592851345*^9, 3.6148536112644043`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379816237996*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SP"}]], "Input",
 CellChangeTimes->{{3.614853668755834*^9, 3.6148536700879583`*^9}}],

Cell[BoxData[
 StyleBox["\<\"SP[Length[V],V]\\n\\n\t SP returns the tensor or spin \
product(SP) of \\n\\n Length[V] qubits with the components\\n\\n specified by \
the array V.  The array V={0, 1,2,q,...}has \\n\\n a length equal to the \
number of qubits\\n\\n and the entries in the array V specify the\\n\\n \
components of the qth Pauli operator.  \\n\\n\t For example:  SP[2,{3,2}] \
returns the same 4X4 matrix as\\n\\n AF[Sigma3\[TensorProduct]Sigma2].  The \
advantage of SP is that it\\n\\n works for large dimensional matrices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798164622717`*^9},
 CellTags->"Info-21644ead-71af-4f98-8ad2-9968bde6c1da"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "0", "}"}]}], "]"}], "==", 
  RowBox[{"PauliMatrix", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}], "==", 
  RowBox[{"PauliMatrix", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "==", 
  RowBox[{"PauliMatrix", "[", "2", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", "3", "}"}]}], "]"}], "==", 
  RowBox[{"PauliMatrix", "[", "3", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6148536800383663`*^9, 3.614853747878002*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379816611562*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737981673384*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379816855432*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379816973583*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"4", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "0"], "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"6", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}]}],
    "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "0"], "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "0"], "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "1"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6148537593542633`*^9, 3.614853803202862*^9}, {
  3.6148538344332438`*^9, 3.614853927306975*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798171514387`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379817274476*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379817384963*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Swap"}]], "Input",
 CellChangeTimes->{{3.614853941635272*^9, 3.614853945396525*^9}}],

Cell[BoxData[
 StyleBox["\<\"Swap[L,q1,q2]\\n\\n\t swaps the content of qubits 1 and 2,  \
within L qubits.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737981757069*^9},
 CellTags->"Info-b7cb155d-5de8-45d9-8a6c-5b03473bf152"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Swap", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Swap", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Swap", "[", 
    RowBox[{"4", ",", "1", ",", "3"}], "]"}], ".", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614853962558292*^9, 3.614854015413516*^9}, {
  3.614854056689136*^9, 3.614854132622916*^9}, {3.614854173008792*^9, 
  3.6148541936947308`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798177966423`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379817918097*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379818029361*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"example", "=", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"a", " ", 
        RowBox[{
         RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "0", "]"}]}]}], "-", 
       RowBox[{"b", " ", 
        RowBox[{
         RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
         RowBox[{"Ket", "[", "0", "]"}]}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Swap", "[", 
      RowBox[{"4", ",", "1", ",", "3"}], "]"}], ".", "example"}], "==", 
    RowBox[{"AF", "[", 
     RowBox[{
      RowBox[{"a", " ", 
       RowBox[{
        RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "0", "]"}]}]}], "-", 
      RowBox[{"b", " ", 
       RowBox[{
        RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
        RowBox[{"Ket", "[", "0", "]"}]}]}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.614854229952134*^9, 3.6148543953533573`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798182411947`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "TensorProduct"}], "\[IndentingNewLine]", 
 RowBox[{"?", "TensorProductQ"}]}], "Input",
 CellChangeTimes->{{3.615985423703212*^9, 3.615985434547131*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"TensorProduct\\\", \\\"[\\\", \
RowBox[{SubscriptBox[StyleBox[\\\"tensor\\\", \\\"TI\\\"], \
StyleBox[\\\"1\\\", \\\"TR\\\"]], \\\",\\\", SubscriptBox[StyleBox[\\\"tensor\
\\\", \\\"TI\\\"], StyleBox[\\\"2\\\", \\\"TR\\\"]], \\\",\\\", StyleBox[\\\"\
\[Ellipsis]\\\", \\\"TR\\\"]}], \\\"]\\\"}]\) represents the tensor product \
of the \!\(\*SubscriptBox[StyleBox[\\\"tensor\\\", \\\"TI\\\"], \
StyleBox[\\\"i\\\", \\\"TI\\\"]]\).\"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TensorProduct"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379818405459*^9},
 CellTags->"Info-0028b352-8054-49ed-abe5-cda0408f50df"],

Cell[BoxData[
 StyleBox["\<\"TensorProductQ[{a,b,c,...}], Note need to include {.. } \
brackets\\n\\n\t gives the tensor product of A,B,C ... . \\n\\n Now using \
built in definition of TensorProduct.\\nTensorProductQ provides the flattened \
\\nmatrix to be used in qdensity.  \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379818631789*^9},
 CellTags->"Info-2f41ef63-436f-4024-924a-6a24761da18c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TensorProductQ", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Ket", "[", "1", "]"}], ",", " ", 
      RowBox[{"Ket", "[", "0", "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"TensorProductQ", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Ket", "[", "1", "]"}], ",", " ", 
      RowBox[{"Ket", "[", "0", "]"}], ",", " ", 
      RowBox[{"Ket", "[", "0", "]"}]}], "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.615978822977233*^9, 3.615978831826138*^9}, {
   3.615983062143643*^9, 3.6159831222208147`*^9}, {3.615983169311181*^9, 
   3.615983230725636*^9}, {3.615983280495962*^9, 3.615983306417789*^9}, {
   3.615983530981984*^9, 3.615983538136979*^9}, {3.615983571617949*^9, 
   3.6159837691272583`*^9}, {3.615984223768341*^9, 3.615984273989393*^9}, {
   3.615984373643537*^9, 3.615984393872876*^9}, {3.61598446067636*^9, 
   3.615984519075465*^9}, 3.615985407537881*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798188009872`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798189237947`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], ",", " ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "}"}], "]"}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], ",", " ", 
     RowBox[{"s", "[", "2", "]"}]}], "}"}], "]"}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"s", "[", "2", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6148544531415987`*^9, 3.614854574129356*^9}, {
  3.614854651899497*^9, 3.614854652696967*^9}, {3.61598456318707*^9, 
  3.615984572108046*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379819056929*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798191739264`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Toffoli"}]], "Input",
 CellChangeTimes->{{3.615717495013706*^9, 3.615717509655819*^9}}],

Cell[BoxData[
 StyleBox["\<\"Toffoli[L,q1,q2, q3] \\n\\n\tReturns the Toffoli operator with \
q1 and q2 as control qubits, \\n\\n q3 as target qubit within L qubits \"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798193589077`*^9},
 CellTags->"Info-9533eb03-5b6c-4532-b7f8-a5d01fddaaf5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Toffoli", "[", 
  RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Toffoli", "[", 
  RowBox[{"3", ",", "3", ",", "2", ",", "1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.615717522627043*^9, 3.615717567726281*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379819512196*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379819629674*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"state3", "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Toffoli", "[", 
    RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "]"}], ".", "state3"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"state3", "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Toffoli", "[", 
    RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "]"}], ".", "state3"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"state3", "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"Ket", "[", "1", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Toffoli", "[", 
    RowBox[{"3", ",", "1", ",", "2", ",", "3"}], "]"}], ".", "state3"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{
  3.615717591092379*^9, {3.615717629319591*^9, 3.615717746325338*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737981977457*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"110\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737981989999*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"110\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798200198812`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737982013995*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"011\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379820299686*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"011\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379820422194*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "xb"}], "\[IndentingNewLine]", "nq", "\[IndentingNewLine]", 
 RowBox[{"Row", "[", 
  RowBox[{"xb", "[", "5", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Row", "[", 
  RowBox[{"xb", "[", 
   RowBox[{
    RowBox[{"2", "^", "nq"}], "-", "1"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.615717770936335*^9, 3.615717839123303*^9}, {
  3.615890193588212*^9, 3.615890243538904*^9}}],

Cell[BoxData[
 StyleBox["\<\"xb[i]\\n\\n\t returns number i in binary;  \\n\\n See Xb (note \
capital X) for the associated binary array from 0 to nb^nq -1.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379820656847*^9},
 CellTags->"Info-5fc5572a-8da7-4705-a6f3-5314ca8e46c7"],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379820788932*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"0","0","0","1","0","1"},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379820907662*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"1","1","1","1","1","1"},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379821054122*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "Xb"}], "\[IndentingNewLine]", "nq", "\[IndentingNewLine]", 
 RowBox[{"2", "^", "nq"}], "\[IndentingNewLine]", "nb", "\[IndentingNewLine]", 
 RowBox[{"Xb", "[", 
  RowBox[{"2", "^", "nq"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6157178557794447`*^9, 3.615717898622518*^9}, {
  3.615718025024171*^9, 3.615718067929324*^9}, {3.61572572005256*^9, 
  3.6157257457816057`*^9}, {3.615890085620804*^9, 3.615890125097165*^9}, {
  3.615890158588896*^9, 3.61589016656564*^9}}],

Cell[BoxData[
 StyleBox["\<\"Xb (note capital X)\\n\\n\t returns the binary \\narray for \
the numbers 0 to nb^nq -1.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379821328994*^9},
 CellTags->"Info-68041fe5-c507-404a-a534-107cdd947610"],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379821488022*^9}],

Cell[BoxData[
 TagBox["64",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379821609071*^9}],

Cell[BoxData[
 TagBox["2",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379821730238*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "1", "0"},
     {"0", "0", "0", "0", "1", "1"},
     {"0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "1", "0", "1"},
     {"0", "0", "0", "1", "1", "0"},
     {"0", "0", "0", "1", "1", "1"},
     {"0", "0", "1", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "1"},
     {"0", "0", "1", "0", "1", "0"},
     {"0", "0", "1", "0", "1", "1"},
     {"0", "0", "1", "1", "0", "0"},
     {"0", "0", "1", "1", "0", "1"},
     {"0", "0", "1", "1", "1", "0"},
     {"0", "0", "1", "1", "1", "1"},
     {"0", "1", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "1"},
     {"0", "1", "0", "0", "1", "0"},
     {"0", "1", "0", "0", "1", "1"},
     {"0", "1", "0", "1", "0", "0"},
     {"0", "1", "0", "1", "0", "1"},
     {"0", "1", "0", "1", "1", "0"},
     {"0", "1", "0", "1", "1", "1"},
     {"0", "1", "1", "0", "0", "0"},
     {"0", "1", "1", "0", "0", "1"},
     {"0", "1", "1", "0", "1", "0"},
     {"0", "1", "1", "0", "1", "1"},
     {"0", "1", "1", "1", "0", "0"},
     {"0", "1", "1", "1", "0", "1"},
     {"0", "1", "1", "1", "1", "0"},
     {"0", "1", "1", "1", "1", "1"},
     {"1", "0", "0", "0", "0", "0"},
     {"1", "0", "0", "0", "0", "1"},
     {"1", "0", "0", "0", "1", "0"},
     {"1", "0", "0", "0", "1", "1"},
     {"1", "0", "0", "1", "0", "0"},
     {"1", "0", "0", "1", "0", "1"},
     {"1", "0", "0", "1", "1", "0"},
     {"1", "0", "0", "1", "1", "1"},
     {"1", "0", "1", "0", "0", "0"},
     {"1", "0", "1", "0", "0", "1"},
     {"1", "0", "1", "0", "1", "0"},
     {"1", "0", "1", "0", "1", "1"},
     {"1", "0", "1", "1", "0", "0"},
     {"1", "0", "1", "1", "0", "1"},
     {"1", "0", "1", "1", "1", "0"},
     {"1", "0", "1", "1", "1", "1"},
     {"1", "1", "0", "0", "0", "0"},
     {"1", "1", "0", "0", "0", "1"},
     {"1", "1", "0", "0", "1", "0"},
     {"1", "1", "0", "0", "1", "1"},
     {"1", "1", "0", "1", "0", "0"},
     {"1", "1", "0", "1", "0", "1"},
     {"1", "1", "0", "1", "1", "0"},
     {"1", "1", "0", "1", "1", "1"},
     {"1", "1", "1", "0", "0", "0"},
     {"1", "1", "1", "0", "0", "1"},
     {"1", "1", "1", "0", "1", "0"},
     {"1", "1", "1", "0", "1", "1"},
     {"1", "1", "1", "1", "0", "0"},
     {"1", "1", "1", "1", "0", "1"},
     {"1", "1", "1", "1", "1", "0"},
     {"1", "1", "1", "1", "1", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379821855258*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Row", "[", 
   RowBox[{
    RowBox[{"Xb", "[", "64", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", 
  RowBox[{"Row", "[", 
   RowBox[{"xb", "[", "0", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Row", "[", 
   RowBox[{
    RowBox[{"Xb", "[", "64", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}], " ", "]"}], "\[Equal]", 
  RowBox[{"Row", "[", 
   RowBox[{"xb", "[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Row", "[", 
   RowBox[{
    RowBox[{"Xb", "[", "64", "]"}], "[", 
    RowBox[{"[", "64", "]"}], "]"}], " ", "]"}], "\[Equal]", 
  RowBox[{"Row", "[", 
   RowBox[{"xb", "[", "63", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.615725756963025*^9, 3.615725883756158*^9}, 
   3.6158893185179043`*^9, {3.6158893539993753`*^9, 3.615889433592304*^9}, {
   3.6158898625077133`*^9, 3.615890015340971*^9}, {3.61589027560233*^9, 
   3.615890332448655*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379822028368*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379822153254*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379822274349*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", 
  "Xd"}], "\[IndentingNewLine]", "nq", "\[IndentingNewLine]", "nb", "\
\[IndentingNewLine]", 
 RowBox[{"Xd", "[", "nq", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Xd", "[", "12", "]"}]}], "Input",
 CellChangeTimes->{{3.615717949466103*^9, 3.615717966244197*^9}, {
  3.6157180152826157`*^9, 3.615718016823469*^9}, {3.6157180771210003`*^9, 
  3.615718087133255*^9}}],

Cell[BoxData[
 StyleBox["\<\"Xd (note capital X)\\n\\n\t the decimal array for \\nthe \
numbers 0 to nb^nq -1.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379822494782*^9},
 CellTags->"Info-8d295e0d-1b50-4caa-953c-4f6017747a05"],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379822639503*^9}],

Cell[BoxData[
 TagBox["2",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798228194017`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"2"},
      {"3"},
      {"4"},
      {"5"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379822941374*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"1"},
      {"2"},
      {"3"},
      {"4"},
      {"5"},
      {"6"},
      {"7"},
      {"8"},
      {"9"},
      {"10"},
      {"11"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379823095417*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "ZeroT"}], "\[IndentingNewLine]", 
 RowBox[{"ZeroT", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ZeroT", "[", "8", "]"}]}], "Input",
 CellChangeTimes->{{3.615725911108685*^9, 3.6157259408143*^9}}],

Cell[BoxData[
 StyleBox["\<\"ZeroT[L]\\n\\n returns a table of 0 of length L.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379823293913*^9},
 CellTags->"Info-c1aa3443-5335-43ca-9920-6f3bf58523a1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798234401407`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379823563676*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "\[ScriptCapitalH] "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalH]", " ", ".", "\[ScriptCapitalH]"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{"TensorProduct", "[", 
   RowBox[{"\[ScriptCapitalH]", ",", "\[ScriptCapitalH]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", ".", "%"}]}], "Input",
 CellChangeTimes->{{3.615726001640814*^9, 3.615726012171053*^9}, {
  3.6157260487112923`*^9, 3.615726150686191*^9}}],

Cell[BoxData[
 StyleBox["\<\"The single qubit Hadamard--See Hadamard\"\>", "MSG"]], "Print",\
 "PrintUsage",
 CellChangeTimes->{3.657379823755907*^9},
 CellTags->"Info-4e3414bd-b2ab-4cb0-81e3-94bd7d88d16e"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379823924746*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379824041695*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798241693783`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Information", "[", 
  RowBox[{"\"\<\[ScriptCapitalP]\>\"", ",", 
   RowBox[{"LongForm", "\[Rule]", "False"}]}], "]"}], "\n", 
 SubscriptBox["\[ScriptCapitalP]", "0"], "\n", 
 SubscriptBox["\[ScriptCapitalP]", "1"], "\n", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], ".", 
  SubscriptBox["\[ScriptCapitalP]", "1"]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "0"], ".", 
   SubscriptBox["\[ScriptCapitalP]", "0"]}], "\[Equal]", 
  SubscriptBox["\[ScriptCapitalP]", "0"]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "1"], ".", 
   SubscriptBox["\[ScriptCapitalP]", "1"]}], "\[Equal]", 
  SubscriptBox["\[ScriptCapitalP]", "1"]}], "\n", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"0"},
     "Bra"]}], "]"}]}], "\n", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "1"], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Bra"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.615726267930459*^9, 3.615726398516514*^9}, {
  3.61572642918371*^9, 3.615726476354792*^9}}],

Cell[BoxData[
 StyleBox["\<\"Subscripted with 0 or 1 returns the one qubit projection \
operator\\n\\n |0\[RightAngleBracket]\[LeftAngleBracket]0| or |1\
\[RightAngleBracket]\[LeftAngleBracket]1| respectively.\\n\\n Commonly used \
together with \[TensorProduct] to \\nbuild density matrices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573798243887653`*^9},
 CellTags->"Info-5b50adc8-151f-43ee-a446-e64801889e5f"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379824541451*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798246676893`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737982478621*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379824908033*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737982505846*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379825174676*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379825297728*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", 
  "\[DoubleStruckCapitalI]"}], "\[IndentingNewLine]", \
"\[DoubleStruckCapitalI]"}], "Input",
 CellChangeTimes->{
  3.615726514398831*^9, {3.6157265489595222`*^9, 3.615726556674471*^9}}],

Cell[BoxData[
 StyleBox["\<\"\\n\[DoubleStruckCapitalI]\\n\\n returns the identity matrix \
for one qubit, 2x2.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737982558736*^9},
 CellTags->"Info-92782b98-7fcd-4eed-8344-6354c870fa12"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379825742385*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\[Sigma]"}]], "Input",
 CellChangeTimes->{{3.615726624824768*^9, 3.6157266331038237`*^9}}],

Cell[BoxData[
 StyleBox["\<\"Should be used with subscripts 0,1,2,3. Returns the \
\\ncorresponding Pauli Matrix.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657379825939727*^9},
 CellTags->"Info-e4d03799-ff7e-4ce0-955d-a1cfa7f1a68d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox["\[Sigma]", "0"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "1"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "2"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "3"]}], "Input",
 CellChangeTimes->{{3.614853344845902*^9, 3.614853385273594*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379826106576*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379826234089*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379826353139*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.657379826485487*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"rho", "=", "RandomQubit2"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.624555344894073*^9, 3.624555391284725*^9}, {
   3.624555423191414*^9, 3.624555436378261*^9}, 3.624555493832679*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.18077382408241657`", 
      RowBox[{
       RowBox[{"-", "0.032872669154721965`"}], "+", 
       RowBox[{"0.05084050520730458`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.004850080440935863`"}], "+", 
       RowBox[{"0.00030471367977759405`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.004099265792125853`"}], "+", 
       RowBox[{"0.06398620402569685`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.032872669154721965`"}], "-", 
       RowBox[{"0.05084050520730458`", " ", "\[ImaginaryI]"}]}], 
      "0.4577950439206961`", 
      RowBox[{"0.01639596397485633`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.06382982762342096`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.3418102340087035`"}], "-", 
       RowBox[{"0.006067552562081153`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.004850080440935863`"}], "-", 
       RowBox[{"0.00030471367977759405`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.01639596397485633`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.06382982762342096`", " ", "\[ImaginaryI]"}]}], 
      "0.025727042190856194`", 
      RowBox[{
       RowBox[{"-", "0.010860140853558582`"}], "-", 
       RowBox[{"0.0705555699434753`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.004099265792125853`"}], "-", 
       RowBox[{"0.06398620402569685`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.3418102340087035`"}], "+", 
       RowBox[{"0.006067552562081153`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.010860140853558582`"}], "+", 
       RowBox[{"0.0705555699434753`", " ", "\[ImaginaryI]"}]}], 
      "0.3357040898060312`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6573798266658688`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Schmidt"}]], "Input",
 CellChangeTimes->{{3.6245555476642923`*^9, 3.624555557169273*^9}, {
  3.624555590120469*^9, 3.6245555944732027`*^9}, {3.624555634220767*^9, 
  3.624555640778657*^9}}],

Cell[BoxData[
 StyleBox["\<\"Schmidt[statein]: Module Schmidt Decomposition for 2 qubit \
statein.  Also generates the Schmidt number Snos.\\n\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.657379826854682*^9},
 CellTags->"Info-ff186f53-09b0-44bc-afa0-a5daee5abd4f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Schmidt", "[", "rho", "]"}]], "Input",
 CellChangeTimes->{{3.6245559310268106`*^9, 3.624555936994074*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{
         TemplateBox[{
          "\" + \"","\"(\"",RowBox[{"-", "0.9954462110482246`"}],"\")\"",
           "\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
             RowBox[{"-", "0.0768931552069345`"}], "-", 
             RowBox[{"0.056340780896753165`", " ", "\[ImaginaryI]"}]}],
           "\")\"","\" |\"","\"1\"","\" >\""},
          "RowDefault"], ",", 
         TemplateBox[{
          "\" + \"","\"(\"",RowBox[{"-", "0.09532492281525154`"}],"\")\"",
           "\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
             RowBox[{"0.8029694412093402`", "\[VeryThinSpace]"}], "+", 
             RowBox[{"0.5883478865214242`", " ", "\[ImaginaryI]"}]}],"\")\"",
           "\" |\"","\"1\"","\" >\""},
          "RowDefault"], ",", 
         TemplateBox[{"\" + \"","\"(\"",RowBox[{
             RowBox[{"-", "0.9380314666217063`"}], "-", 
             RowBox[{"0.0013051060723927284`", " ", "\[ImaginaryI]"}]}],
           "\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
             RowBox[{"0.19142564006301563`", "\[VeryThinSpace]"}], "+", 
             RowBox[{"0.2888797131197259`", " ", "\[ImaginaryI]"}]}],"\")\"",
           "\" |\"","\"1\"","\" >\""},
          "RowDefault"], ",", 
         TemplateBox[{"\" + \"","\"(\"",RowBox[{
             RowBox[{"-", "0.34397854200622396`"}], "+", 
             RowBox[{"0.04211919948126718`", " ", "\[ImaginaryI]"}]}],"\")\"",
           "\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
             RowBox[{"-", "0.6103360082808785`"}], "-", 
             RowBox[{"0.712316427348193`", " ", "\[ImaginaryI]"}]}],"\")\"",
           "\" |\"","\"1\"","\" >\""},
          "RowDefault"]}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.191422696182509`", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0.06193989524572913`"}], "}"}]}], "}"}]},
      {"2"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65737982701656*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"?", "RandomKet*"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.624556338612381*^9, 3.624556353068204*^9}, {
   3.624556386988662*^9, 3.624556416293865*^9}, {3.657379006226432*^9, 
   3.657379010893365*^9}, 3.6573791670141478`*^9}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-622fb936-e13e-40de-ac7b-5116ecf7ecc2", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-622fb936-e13e-40de-ac7b-5116ecf7ecc2", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-622fb936-e13e-40de-ac7b-5116ecf7ecc2", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.31666666666666665`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657379827178245*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"?", "Oracle"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "See", " ", "Grover", " ", "search", " ", "notebook", " ", "for", " ", 
    "use", " ", "of", " ", "Oracle"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.614516366211095*^9, 3.614516374262849*^9}, {
  3.616342693472596*^9, 3.616342717883381*^9}, {3.624555317620537*^9, 
  3.6245553291953707`*^9}}],

Cell[BoxData[
 StyleBox["\<\"Oracle[nqx,nqy,itype]\\n\\n\t is an Oracle for nqx Qubits in x \
and nqy Qubits in y. \\n\\n\t Oracle | x, y\[RightAngleBracket] = | x, y+f(x)\
\[RightAngleBracket].\\n\\n Oracle[nqx,nqy,itype] provides an Oracle \
type\\n\\n itype=-1 ( a random function f(x)) and itype=-2 \\n\\n ( a f(x) \
with value 1 only at \\n a random marked value of x).\\n\\n The later is \
useful for Grover's search. \\n\\n See also Definef\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.657379827394685*^9},
 CellTags->"Info-d09e4591-2898-4584-9a8e-c6f8d43d2cdc"]
}, Open  ]],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Quit", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.6142459628182993`*^9, 3.614245965043126*^9}, {
   3.614510650247691*^9, 3.614510657211667*^9}, 3.614510822253696*^9, {
   3.6146216913973627`*^9, 3.6146216989256563`*^9}}]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1564, 750},
WindowMargins->{{Automatic, 70}, {53, Automatic}},
Visible->True,
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, 32000},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"export", "home", "brunojd"}, 
  "t.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 18.585304`8.02174465349935}, {1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 
    5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7,
     7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
    8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
    10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 
    11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 
    12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 
    13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 
    14, 14, 14}, Automatic}, "NextIndexingNumber" -> 5, 
  "IndexEntries" -> {{"i:1", "CNOT\t"}, {"i:2", "HALL"}, {
    "i:3", "bra", "Quantum Density package"}, {
    "i:4", "ket", "Quantum Density Package"}}},
CellLabelAutoDelete->True,
InputAliases->{"intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation>" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation<" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "symb" -> RowBox[{"Symbolize", "[", 
     TagBox[
     "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"], 
     "]"}], "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        ",", "\[Placeholder]"}], "]"}], "addia" -> 
  RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[Placeholder]\"", "\[Rule]", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "pattwraper" -> 
  TagBox["\[Placeholder]", NotationPatternTag, TagStyle -> 
    "NotationPatternWrapperStyle"], "madeboxeswraper" -> 
  TagBox["\[Placeholder]", NotationMadeBoxesTag, TagStyle -> 
    "NotationMadeBoxesWrapperStyle"]},
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 200, 3, 51, "Title",
   CellTags->"c:1"]},
 "b:5.0"->{
  Cell[1250, 40, 436, 8, 75, "Text",
   CellTags->"b:5.0"],
  Cell[1711, 52, 325, 6, 59, "Section",
   CellTags->{"c:2", "b:5.0"}],
  Cell[2039, 60, 464, 12, 80, "Text",
   CellTags->"b:5.0"],
  Cell[2528, 76, 179, 5, 46, "Input",
   CellTags->"b:5.0"],
  Cell[2710, 83, 212, 5, 46, "Output",
   CellTags->"b:5.0"],
  Cell[2937, 91, 413, 14, 24, "Text",
   CellTags->"b:5.0"],
  Cell[3832, 120, 161, 3, 23, "Text",
   CellTags->"b:5.0"],
  Cell[4018, 127, 228, 5, 46, "Input",
   CellTags->"b:5.0"],
  Cell[4249, 134, 33418, 929, 306, "Print",
   CellTags->"b:5.0"],
  Cell[37682, 1066, 333, 6, 51, "Text",
   CellTags->"b:5.0"]},
 "c:2"->{
  Cell[1711, 52, 325, 6, 59, "Section",
   CellTags->{"c:2", "b:5.0"}]},
 "c:3"->{
  Cell[38030, 1075, 266, 5, 51, "Section",
   CellTags->"c:3"]},
 "Info-2c0f646f-059b-4433-ad89-87142edf7c5f"->{
  Cell[38438, 1088, 213, 4, 77, "Print",
   CellTags->"Info-2c0f646f-059b-4433-ad89-87142edf7c5f"]},
 "Info-5c2ca537-a5ba-47aa-ba2a-3cbe51935a6c"->{
  Cell[42000, 1186, 287, 5, 92, "Print",
   CellTags->"Info-5c2ca537-a5ba-47aa-ba2a-3cbe51935a6c"]},
 "Info-00297780-1a94-4632-bed8-d9b43b05118d"->{
  Cell[48452, 1388, 235, 4, 77, "Print",
   CellTags->"Info-00297780-1a94-4632-bed8-d9b43b05118d"]},
 "Info-093e684c-345b-4e53-a49a-caee177e52e6"->{
  Cell[50830, 1462, 367, 6, 143, "Print",
   CellTags->"Info-093e684c-345b-4e53-a49a-caee177e52e6"]},
 "Info-846a5560-b8ac-418a-a62a-1fec72db3032"->{
  Cell[53623, 1548, 262, 4, 75, "Print",
   CellTags->"Info-846a5560-b8ac-418a-a62a-1fec72db3032"]},
 "Info-a028856f-8f7e-402c-bc87-cee2515b09f9"->{
  Cell[56545, 1641, 241, 4, 77, "Print",
   CellTags->"Info-a028856f-8f7e-402c-bc87-cee2515b09f9"]},
 "Info-874662f4-b6b9-478e-b9c1-800bd4c92b37"->{
  Cell[60184, 1758, 307, 5, 111, "Print",
   CellTags->"Info-874662f4-b6b9-478e-b9c1-800bd4c92b37"]},
 "Info-5d1c58a2-6403-4804-ba84-559e76715cb8"->{
  Cell[71497, 2166, 234, 4, 77, "Print",
   CellTags->"Info-5d1c58a2-6403-4804-ba84-559e76715cb8"]},
 "Info-38311c02-69e9-4a8c-a04c-57077032ab03"->{
  Cell[73896, 2243, 313, 5, 111, "Print",
   CellTags->"Info-38311c02-69e9-4a8c-a04c-57077032ab03"]},
 "Info-d3842e71-4851-4381-822f-de0e8ce4c427"->{
  Cell[74705, 2267, 298, 5, 111, "Print",
   CellTags->"Info-d3842e71-4851-4381-822f-de0e8ce4c427"]},
 "Info-09879ac4-afef-4a7b-9602-5b1f00002d6e"->{
  Cell[77175, 2336, 298, 5, 111, "Print",
   CellTags->"Info-09879ac4-afef-4a7b-9602-5b1f00002d6e"]},
 "Info-e7330879-672f-4479-8554-cc0302121a51"->{
  Cell[80013, 2417, 373, 6, 143, "Print",
   CellTags->"Info-e7330879-672f-4479-8554-cc0302121a51"]},
 "Info-d21abeb4-312a-4973-b745-b6ba0c5154a0"->{
  Cell[82266, 2483, 279, 5, 77, "Print",
   CellTags->"Info-d21abeb4-312a-4973-b745-b6ba0c5154a0"]},
 "Info-891c8fa4-c205-4d06-857a-695db3e58aee"->{
  Cell[90284, 2700, 315, 5, 128, "Print",
   CellTags->"Info-891c8fa4-c205-4d06-857a-695db3e58aee"]},
 "Info-6d9cdeda-c896-487a-85e7-1d6fd48eb8e3"->{
  Cell[90602, 2707, 770, 15, 58, "Print",
   CellTags->"Info-6d9cdeda-c896-487a-85e7-1d6fd48eb8e3"]},
 "Info-e408696f-92f9-4bd6-8524-6a40ef9a3ba5"->{
  Cell[94814, 2834, 445, 7, 143, "Print",
   CellTags->"Info-e408696f-92f9-4bd6-8524-6a40ef9a3ba5"]},
 "Info-b1842af5-aadb-47a6-a26c-52fa12aa1130"->{
  Cell[95262, 2843, 283, 5, 92, "Print",
   CellTags->"Info-b1842af5-aadb-47a6-a26c-52fa12aa1130"]},
 "Info-aadd0053-bbf9-4abb-999a-4af8610966bd"->{
  Cell[96764, 2888, 301, 5, 60, "Print",
   CellTags->"Info-aadd0053-bbf9-4abb-999a-4af8610966bd"]},
 "Info-bdad4a9d-a693-4b2b-aacf-38da24bc3666"->{
  Cell[97139, 2900, 178, 3, 40, "Print",
   CellTags->"Info-bdad4a9d-a693-4b2b-aacf-38da24bc3666"]},
 "Info-0d5fe874-3fec-47bc-9615-c2a4041baccc"->{
  Cell[97474, 2912, 959, 14, 519, "Print",
   CellTags->"Info-0d5fe874-3fec-47bc-9615-c2a4041baccc"]},
 "Info-22a7525c-5f19-48ba-8611-44b52dc54da9"->{
  Cell[98520, 2934, 275, 5, 109, "Print",
   CellTags->"Info-22a7525c-5f19-48ba-8611-44b52dc54da9"]},
 "Info-d526400f-aef5-4559-9a83-05cbe7f6ad26"->{
  Cell[98961, 2948, 208, 4, 43, "Print",
   CellTags->"Info-d526400f-aef5-4559-9a83-05cbe7f6ad26"]},
 "b:5.2.0"->{
  Cell[99184, 2955, 1273, 42, 111, "Text",
   CellTags->"b:5.2.0"],
  Cell[100482, 3001, 136, 4, 45, "Input",
   CellTags->"b:5.2.0"],
  Cell[100621, 3007, 843, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[101467, 3037, 131, 3, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[101623, 3044, 65, 1, 45, "Input",
   CellTags->"b:5.2.0"],
  Cell[101691, 3047, 841, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[102547, 3078, 170, 4, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[102742, 3086, 391, 8, 45, "Input",
   CellTags->"b:5.2.0"],
  Cell[103136, 3096, 1758, 61, 246, "Output",
   CellTags->"b:5.2.0"],
  Cell[104897, 3159, 135, 3, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[105057, 3166, 366, 8, 45, "Input",
   CellTags->"b:5.2.0"],
  Cell[105426, 3176, 1759, 61, 246, "Output",
   CellTags->"b:5.2.0"],
  Cell[107224, 3242, 464, 7, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[107713, 3253, 850, 22, 93, "Input",
   CellTags->"b:5.2.0"],
  Cell[108566, 3277, 991, 25, 158, "Output",
   CellTags->"b:5.2.0"],
  Cell[109560, 3304, 1091, 29, 176, "Output",
   CellTags->"b:5.2.0"],
  Cell[110654, 3335, 751, 23, 80, "Output",
   CellTags->"b:5.2.0"],
  Cell[111408, 3360, 649, 19, 62, "Output",
   CellTags->"b:5.2.0"],
  Cell[112072, 3382, 429, 15, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[112526, 3401, 196, 5, 46, "Input",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[112725, 3408, 2600, 89, 230, "Output",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[116970, 3546, 186, 4, 23, "Text",
   CellTags->"b:5.2.0"],
  Cell[117181, 3554, 426, 13, 76, "Input",
   CellTags->"b:5.2.0"],
  Cell[117610, 3569, 723, 23, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[118336, 3594, 639, 19, 62, "Output",
   CellTags->"b:5.2.0"],
  Cell[118978, 3615, 747, 24, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[285384, 8234, 312, 6, 23, "Text",
   CellTags->"b:5.2.0"]},
 "i:2"->{
  Cell[112526, 3401, 196, 5, 46, "Input",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[112725, 3408, 2600, 89, 230, "Output",
   CellTags->{"i:2", "b:5.2.0"}]},
 "Info-f7d565f3-a635-4078-98aa-59d3af9152f8"->{
  Cell[119823, 3648, 273, 5, 75, "Print",
   CellTags->"Info-f7d565f3-a635-4078-98aa-59d3af9152f8"]},
 "Info-416b572d-d5c8-4fe0-8d3f-b4c26afac64d"->{
  Cell[124135, 3793, 365, 6, 111, "Print",
   CellTags->"Info-416b572d-d5c8-4fe0-8d3f-b4c26afac64d"]},
 "Info-137f1b17-35ef-40c3-8ed3-60006956dbee"->{
  Cell[126571, 3869, 357, 6, 92, "Print",
   CellTags->"Info-137f1b17-35ef-40c3-8ed3-60006956dbee"]},
 "Info-788771c2-59da-498a-bf47-58aa5c931796"->{
  Cell[128220, 3921, 308, 5, 111, "Print",
   CellTags->"Info-788771c2-59da-498a-bf47-58aa5c931796"]},
 "Info-92495a93-9b9b-4a3b-b401-900973831db7"->{
  Cell[131924, 4046, 216, 4, 77, "Print",
   CellTags->"Info-92495a93-9b9b-4a3b-b401-900973831db7"]},
 "Info-cac96c74-43ec-4b27-82e5-d3e4b3ef2839"->{
  Cell[135687, 4172, 414, 6, 177, "Print",
   CellTags->"Info-cac96c74-43ec-4b27-82e5-d3e4b3ef2839"]},
 "Info-f202f6f3-80ab-435c-ae95-49c13199b2b7"->{
  Cell[159476, 4836, 226, 4, 75, "Print",
   CellTags->"Info-f202f6f3-80ab-435c-ae95-49c13199b2b7"]},
 "Info-588279c0-98f2-4a4e-a41b-ce51d461028a"->{
  Cell[166582, 5026, 1054, 16, 451, "Print",
   CellTags->"Info-588279c0-98f2-4a4e-a41b-ce51d461028a"]},
 "Info-b68e6ad4-5e52-4c6c-84b4-7a6a0b5f7a35"->{
  Cell[186187, 5583, 354, 6, 92, "Print",
   CellTags->"Info-b68e6ad4-5e52-4c6c-84b4-7a6a0b5f7a35"]},
 "Info-ed1414fc-f6fa-4fcc-bf97-c1f43e431070"->{
  Cell[189529, 5680, 209, 4, 40, "Print",
   CellTags->"Info-ed1414fc-f6fa-4fcc-bf97-c1f43e431070"]},
 "Info-2c4fc2fd-f794-4a5a-9889-c5f744581475"->{
  Cell[189876, 5692, 215, 4, 40, "Print",
   CellTags->"Info-2c4fc2fd-f794-4a5a-9889-c5f744581475"]},
 "Info-d1dc9e4d-f3a5-48da-8a5b-8b97c414c404"->{
  Cell[191573, 5739, 538, 8, 143, "Print",
   CellTags->"Info-d1dc9e4d-f3a5-48da-8a5b-8b97c414c404"]},
 "Info-e4bfdb26-48d7-4c97-ac32-1b390ec92a67"->{
  Cell[194348, 5824, 363, 6, 109, "Print",
   CellTags->"Info-e4bfdb26-48d7-4c97-ac32-1b390ec92a67"]},
 "Info-c49aa579-b2ac-4be5-8c01-fe2b55d58867"->{
  Cell[197951, 5928, 388, 6, 109, "Print",
   CellTags->"Info-c49aa579-b2ac-4be5-8c01-fe2b55d58867"]},
 "Info-385432f1-0550-45c5-9d1a-2e76d8cfa09d"->{
  Cell[203286, 6080, 704, 10, 415, "Print",
   CellTags->"Info-385432f1-0550-45c5-9d1a-2e76d8cfa09d"]},
 "Info-a1a711db-5027-4c00-bb16-a10c159f153f"->{
  Cell[203993, 6092, 482, 7, 262, "Print",
   CellTags->"Info-a1a711db-5027-4c00-bb16-a10c159f153f"]},
 "Info-0b66b116-268e-467e-afe1-19a1784a7433"->{
  Cell[224886, 6608, 556, 8, 262, "Print",
   CellTags->"Info-0b66b116-268e-467e-afe1-19a1784a7433"]},
 "Info-d05aa854-9745-4a27-a60e-aa6a2ce8d635"->{
  Cell[279339, 8043, 316, 5, 126, "Print",
   CellTags->"Info-d05aa854-9745-4a27-a60e-aa6a2ce8d635"]},
 "Info-d221bb50-e497-4c82-b5fc-8356b5bb91bc"->{
  Cell[305336, 8850, 486, 11, 42, "Print",
   CellTags->"Info-d221bb50-e497-4c82-b5fc-8356b5bb91bc"]},
 "Info-b721e6a4-0022-44d8-b7dd-bd64b7b406bf"->{
  Cell[306441, 8881, 629, 13, 45, "Print",
   CellTags->"Info-b721e6a4-0022-44d8-b7dd-bd64b7b406bf"]},
 "Info-10189915-d906-4ad1-b6a6-15b156632072"->{
  Cell[307073, 8896, 228, 4, 77, "Print",
   CellTags->"Info-10189915-d906-4ad1-b6a6-15b156632072"]},
 "Info-21644ead-71af-4f98-8ad2-9968bde6c1da"->{
  Cell[314535, 9130, 679, 10, 349, "Print",
   CellTags->"Info-21644ead-71af-4f98-8ad2-9968bde6c1da"]},
 "Info-b7cb155d-5de8-45d9-8a6c-5b03473bf152"->{
  Cell[318613, 9258, 242, 4, 75, "Print",
   CellTags->"Info-b7cb155d-5de8-45d9-8a6c-5b03473bf152"]},
 "Info-0028b352-8054-49ed-abe5-cda0408f50df"->{
  Cell[323197, 9393, 785, 15, 42, "Print",
   CellTags->"Info-0028b352-8054-49ed-abe5-cda0408f50df"]},
 "Info-2f41ef63-436f-4024-924a-6a24761da18c"->{
  Cell[323985, 9410, 414, 6, 143, "Print",
   CellTags->"Info-2f41ef63-436f-4024-924a-6a24761da18c"]},
 "Info-9533eb03-5b6c-4532-b7f8-a5d01fddaaf5"->{
  Cell[328070, 9538, 306, 5, 111, "Print",
   CellTags->"Info-9533eb03-5b6c-4532-b7f8-a5d01fddaaf5"]},
 "Info-5fc5572a-8da7-4705-a6f3-5314ca8e46c7"->{
  Cell[334210, 9718, 295, 5, 109, "Print",
   CellTags->"Info-5fc5572a-8da7-4705-a6f3-5314ca8e46c7"]},
 "Info-68041fe5-c507-404a-a534-107cdd947610"->{
  Cell[335580, 9760, 253, 4, 92, "Print",
   CellTags->"Info-68041fe5-c507-404a-a534-107cdd947610"]},
 "Info-8d295e0d-1b50-4caa-953c-4f6017747a05"->{
  Cell[341041, 9927, 246, 4, 92, "Print",
   CellTags->"Info-8d295e0d-1b50-4caa-953c-4f6017747a05"]},
 "Info-c1aa3443-5335-43ca-9920-6f3bf58523a1"->{
  Cell[343359, 10012, 216, 4, 77, "Print",
   CellTags->"Info-c1aa3443-5335-43ca-9920-6f3bf58523a1"]},
 "Info-4e3414bd-b2ab-4cb0-81e3-94bd7d88d16e"->{
  Cell[345545, 10085, 206, 4, 43, "Print",
   CellTags->"Info-4e3414bd-b2ab-4cb0-81e3-94bd7d88d16e"]},
 "Info-5b50adc8-151f-43ee-a446-e64801889e5f"->{
  Cell[349620, 10218, 433, 7, 126, "Print",
   CellTags->"Info-5b50adc8-151f-43ee-a446-e64801889e5f"]},
 "Info-92782b98-7fcd-4eed-8344-6354c870fa12"->{
  Cell[352751, 10321, 246, 4, 92, "Print",
   CellTags->"Info-92782b98-7fcd-4eed-8344-6354c870fa12"]},
 "Info-e4d03799-ff7e-4ce0-955d-a1cfa7f1a68d"->{
  Cell[353786, 10354, 249, 4, 60, "Print",
   CellTags->"Info-e4d03799-ff7e-4ce0-955d-a1cfa7f1a68d"]},
 "Info-ff186f53-09b0-44bc-afa0-a5daee5abd4f"->{
  Cell[359814, 10528, 280, 5, 58, "Print",
   CellTags->"Info-ff186f53-09b0-44bc-afa0-a5daee5abd4f"]},
 "Info-d09e4591-2898-4584-9a8e-c6f8d43d2cdc"->{
  Cell[365217, 10674, 585, 9, 296, "Print",
   CellTags->"Info-d09e4591-2898-4584-9a8e-c6f8d43d2cdc"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 370398, 10788},
 {"b:5.0", 370469, 10791},
 {"c:2", 371110, 10812},
 {"c:3", 371193, 10815},
 {"Info-2c0f646f-059b-4433-ad89-87142edf7c5f", 371306, 10818},
 {"Info-5c2ca537-a5ba-47aa-ba2a-3cbe51935a6c", 371455, 10821},
 {"Info-00297780-1a94-4632-bed8-d9b43b05118d", 371604, 10824},
 {"Info-093e684c-345b-4e53-a49a-caee177e52e6", 371753, 10827},
 {"Info-846a5560-b8ac-418a-a62a-1fec72db3032", 371903, 10830},
 {"Info-a028856f-8f7e-402c-bc87-cee2515b09f9", 372052, 10833},
 {"Info-874662f4-b6b9-478e-b9c1-800bd4c92b37", 372201, 10836},
 {"Info-5d1c58a2-6403-4804-ba84-559e76715cb8", 372351, 10839},
 {"Info-38311c02-69e9-4a8c-a04c-57077032ab03", 372500, 10842},
 {"Info-d3842e71-4851-4381-822f-de0e8ce4c427", 372650, 10845},
 {"Info-09879ac4-afef-4a7b-9602-5b1f00002d6e", 372800, 10848},
 {"Info-e7330879-672f-4479-8554-cc0302121a51", 372950, 10851},
 {"Info-d21abeb4-312a-4973-b745-b6ba0c5154a0", 373100, 10854},
 {"Info-891c8fa4-c205-4d06-857a-695db3e58aee", 373249, 10857},
 {"Info-6d9cdeda-c896-487a-85e7-1d6fd48eb8e3", 373399, 10860},
 {"Info-e408696f-92f9-4bd6-8524-6a40ef9a3ba5", 373549, 10863},
 {"Info-b1842af5-aadb-47a6-a26c-52fa12aa1130", 373699, 10866},
 {"Info-aadd0053-bbf9-4abb-999a-4af8610966bd", 373848, 10869},
 {"Info-bdad4a9d-a693-4b2b-aacf-38da24bc3666", 373997, 10872},
 {"Info-0d5fe874-3fec-47bc-9615-c2a4041baccc", 374146, 10875},
 {"Info-22a7525c-5f19-48ba-8611-44b52dc54da9", 374297, 10878},
 {"Info-d526400f-aef5-4559-9a83-05cbe7f6ad26", 374447, 10881},
 {"b:5.2.0", 374562, 10884},
 {"i:2", 376429, 10939},
 {"Info-f7d565f3-a635-4078-98aa-59d3af9152f8", 376634, 10944},
 {"Info-416b572d-d5c8-4fe0-8d3f-b4c26afac64d", 376784, 10947},
 {"Info-137f1b17-35ef-40c3-8ed3-60006956dbee", 376935, 10950},
 {"Info-788771c2-59da-498a-bf47-58aa5c931796", 377085, 10953},
 {"Info-92495a93-9b9b-4a3b-b401-900973831db7", 377236, 10956},
 {"Info-cac96c74-43ec-4b27-82e5-d3e4b3ef2839", 377386, 10959},
 {"Info-f202f6f3-80ab-435c-ae95-49c13199b2b7", 377537, 10962},
 {"Info-588279c0-98f2-4a4e-a41b-ce51d461028a", 377687, 10965},
 {"Info-b68e6ad4-5e52-4c6c-84b4-7a6a0b5f7a35", 377840, 10968},
 {"Info-ed1414fc-f6fa-4fcc-bf97-c1f43e431070", 377990, 10971},
 {"Info-2c4fc2fd-f794-4a5a-9889-c5f744581475", 378140, 10974},
 {"Info-d1dc9e4d-f3a5-48da-8a5b-8b97c414c404", 378290, 10977},
 {"Info-e4bfdb26-48d7-4c97-ac32-1b390ec92a67", 378441, 10980},
 {"Info-c49aa579-b2ac-4be5-8c01-fe2b55d58867", 378592, 10983},
 {"Info-385432f1-0550-45c5-9d1a-2e76d8cfa09d", 378743, 10986},
 {"Info-a1a711db-5027-4c00-bb16-a10c159f153f", 378895, 10989},
 {"Info-0b66b116-268e-467e-afe1-19a1784a7433", 379046, 10992},
 {"Info-d05aa854-9745-4a27-a60e-aa6a2ce8d635", 379197, 10995},
 {"Info-d221bb50-e497-4c82-b5fc-8356b5bb91bc", 379348, 10998},
 {"Info-b721e6a4-0022-44d8-b7dd-bd64b7b406bf", 379499, 11001},
 {"Info-10189915-d906-4ad1-b6a6-15b156632072", 379650, 11004},
 {"Info-21644ead-71af-4f98-8ad2-9968bde6c1da", 379800, 11007},
 {"Info-b7cb155d-5de8-45d9-8a6c-5b03473bf152", 379952, 11010},
 {"Info-0028b352-8054-49ed-abe5-cda0408f50df", 380102, 11013},
 {"Info-2f41ef63-436f-4024-924a-6a24761da18c", 380253, 11016},
 {"Info-9533eb03-5b6c-4532-b7f8-a5d01fddaaf5", 380404, 11019},
 {"Info-5fc5572a-8da7-4705-a6f3-5314ca8e46c7", 380555, 11022},
 {"Info-68041fe5-c507-404a-a534-107cdd947610", 380706, 11025},
 {"Info-8d295e0d-1b50-4caa-953c-4f6017747a05", 380856, 11028},
 {"Info-c1aa3443-5335-43ca-9920-6f3bf58523a1", 381006, 11031},
 {"Info-4e3414bd-b2ab-4cb0-81e3-94bd7d88d16e", 381157, 11034},
 {"Info-5b50adc8-151f-43ee-a446-e64801889e5f", 381308, 11037},
 {"Info-92782b98-7fcd-4eed-8344-6354c870fa12", 381460, 11040},
 {"Info-e4d03799-ff7e-4ce0-955d-a1cfa7f1a68d", 381611, 11043},
 {"Info-ff186f53-09b0-44bc-afa0-a5daee5abd4f", 381762, 11046},
 {"Info-d09e4591-2898-4584-9a8e-c6f8d43d2cdc", 381913, 11049}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 200, 3, 51, "Title",
 CellTags->"c:1"],
Cell[748, 25, 43, 0, 35, "Subtitle"],
Cell[794, 27, 453, 11, 32, "Abstract"],
Cell[1250, 40, 436, 8, 75, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[1711, 52, 325, 6, 59, "Section",
 CellTags->{"c:2", "b:5.0"}],
Cell[2039, 60, 464, 12, 80, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[2528, 76, 179, 5, 46, "Input",
 CellTags->"b:5.0"],
Cell[2710, 83, 212, 5, 46, "Output",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[2937, 91, 413, 14, 24, "Text",
 CellTags->"b:5.0"],
Cell[3353, 107, 476, 11, 46, "Input"],
Cell[3832, 120, 161, 3, 23, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[4018, 127, 228, 5, 46, "Input",
 CellTags->"b:5.0"],
Cell[4249, 134, 33418, 929, 306, "Print",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[37682, 1066, 333, 6, 51, "Text",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[38030, 1075, 266, 5, 51, "Section",
 CellTags->"c:3"],
Cell[CellGroupData[{
Cell[38321, 1084, 114, 2, 42, "Input"],
Cell[38438, 1088, 213, 4, 77, "Print",
 CellTags->"Info-2c0f646f-059b-4433-ad89-87142edf7c5f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38688, 1097, 316, 5, 93, "Input"],
Cell[39007, 1104, 863, 22, 62, "Output"],
Cell[39873, 1128, 551, 12, 45, "Output"],
Cell[40427, 1142, 858, 21, 45, "Output"],
Cell[41288, 1165, 559, 12, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41884, 1182, 113, 2, 45, "Input"],
Cell[42000, 1186, 287, 5, 92, "Print",
 CellTags->"Info-5c2ca537-a5ba-47aa-ba2a-3cbe51935a6c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42324, 1196, 429, 9, 76, "Input"],
Cell[42756, 1207, 1699, 46, 96, "Output"],
Cell[44458, 1255, 641, 20, 94, "Output"],
Cell[45102, 1277, 220, 6, 45, "Output"],
Cell[CellGroupData[{
Cell[45347, 1287, 367, 13, 86, "Input"],
Cell[45717, 1302, 1701, 46, 96, "Output"],
Cell[47421, 1350, 641, 20, 94, "Output"],
Cell[48065, 1372, 222, 6, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[48336, 1384, 113, 2, 45, "Input"],
Cell[48452, 1388, 235, 4, 77, "Print",
 CellTags->"Info-00297780-1a94-4632-bed8-d9b43b05118d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48724, 1397, 210, 4, 61, "Input"],
Cell[48937, 1403, 1038, 30, 62, "Output"],
Cell[49978, 1435, 697, 18, 64, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50712, 1458, 115, 2, 45, "Input"],
Cell[50830, 1462, 367, 6, 143, "Print",
 CellTags->"Info-093e684c-345b-4e53-a49a-caee177e52e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51234, 1473, 434, 10, 91, "Input"],
Cell[51671, 1485, 640, 17, 45, "Output"],
Cell[52314, 1504, 228, 6, 45, "Output"],
Cell[52545, 1512, 687, 18, 45, "Output"],
Cell[53235, 1532, 233, 7, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53505, 1544, 115, 2, 45, "Input"],
Cell[53623, 1548, 262, 4, 75, "Print",
 CellTags->"Info-846a5560-b8ac-418a-a62a-1fec72db3032"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53922, 1557, 307, 5, 91, "Input"],
Cell[54232, 1564, 694, 21, 56, "Output"],
Cell[54929, 1587, 356, 9, 67, "Output"],
Cell[55288, 1598, 720, 22, 56, "Output"],
Cell[56011, 1622, 379, 10, 67, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56427, 1637, 115, 2, 45, "Input"],
Cell[56545, 1641, 241, 4, 77, "Print",
 CellTags->"Info-a028856f-8f7e-402c-bc87-cee2515b09f9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56823, 1650, 719, 17, 121, "Input"],
Cell[57545, 1669, 732, 22, 56, "Output"],
Cell[58280, 1693, 391, 10, 67, "Output"],
Cell[58674, 1705, 706, 21, 56, "Output"],
Cell[59383, 1728, 370, 9, 67, "Output"],
Cell[59756, 1739, 135, 4, 45, "Output"],
Cell[59894, 1745, 137, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60068, 1754, 113, 2, 45, "Input"],
Cell[60184, 1758, 307, 5, 111, "Print",
 CellTags->"Info-874662f4-b6b9-478e-b9c1-800bd4c92b37"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60528, 1768, 2055, 73, 140, "Input"],
Cell[62586, 1843, 703, 20, 94, "Output"],
Cell[63292, 1865, 701, 20, 94, "Output"],
Cell[63996, 1887, 137, 4, 45, "Output"],
Cell[64136, 1893, 135, 4, 45, "Output"],
Cell[64274, 1899, 135, 4, 45, "Output"],
Cell[64412, 1905, 137, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[64574, 1913, 4532, 166, 220, "Input"],
Cell[69109, 2081, 969, 24, 158, "Output"],
Cell[70081, 2107, 135, 4, 45, "Output"],
Cell[70219, 2113, 135, 4, 45, "Output"],
Cell[70357, 2119, 135, 4, 45, "Output"],
Cell[70495, 2125, 134, 4, 45, "Output"],
Cell[70632, 2131, 135, 4, 45, "Output"],
Cell[70770, 2137, 135, 4, 45, "Output"],
Cell[70908, 2143, 134, 4, 45, "Output"],
Cell[71045, 2149, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[71229, 2159, 265, 5, 45, "Input"],
Cell[71497, 2166, 234, 4, 77, "Print",
 CellTags->"Info-5d1c58a2-6403-4804-ba84-559e76715cb8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71768, 2175, 310, 8, 61, "Input"],
Cell[72081, 2185, 728, 21, 62, "Output"],
Cell[72812, 2208, 728, 21, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73577, 2234, 316, 7, 61, "Input"],
Cell[73896, 2243, 313, 5, 111, "Print",
 CellTags->"Info-38311c02-69e9-4a8c-a04c-57077032ab03"],
Cell[74212, 2250, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74384, 2259, 318, 6, 76, "Input"],
Cell[74705, 2267, 298, 5, 111, "Print",
 CellTags->"Info-d3842e71-4851-4381-822f-de0e8ce4c427"],
Cell[75006, 2274, 747, 21, 94, "Output"],
Cell[75756, 2297, 1061, 26, 158, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76854, 2328, 318, 6, 76, "Input"],
Cell[77175, 2336, 298, 5, 111, "Print",
 CellTags->"Info-09879ac4-afef-4a7b-9602-5b1f00002d6e"],
Cell[77476, 2343, 723, 21, 94, "Output"],
Cell[78202, 2366, 1015, 26, 158, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79254, 2397, 756, 18, 91, "Input"],
Cell[80013, 2417, 373, 6, 143, "Print",
 CellTags->"Info-e7330879-672f-4479-8554-cc0302121a51"],
Cell[80389, 2425, 135, 4, 45, "Output"],
Cell[80527, 2431, 135, 4, 45, "Output"],
Cell[80665, 2437, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80837, 2446, 1426, 35, 91, "Input"],
Cell[82266, 2483, 279, 5, 77, "Print",
 CellTags->"Info-d21abeb4-312a-4973-b745-b6ba0c5154a0"],
Cell[82548, 2490, 409, 10, 45, "Output"],
Cell[82960, 2502, 425, 10, 45, "Output"],
Cell[83388, 2514, 423, 10, 45, "Output"],
Cell[CellGroupData[{
Cell[83836, 2528, 2594, 61, 106, "Input"],
Cell[86433, 2591, 685, 13, 45, "Output"],
Cell[87121, 2606, 720, 14, 45, "Output"],
Cell[87844, 2622, 720, 14, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[88613, 2642, 908, 24, 91, "Input"],
Cell[89524, 2668, 135, 4, 45, "Output"],
Cell[89662, 2674, 135, 4, 45, "Output"],
Cell[89800, 2680, 135, 4, 45, "Output"],
Cell[89938, 2686, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90110, 2695, 171, 3, 62, "Input"],
Cell[90284, 2700, 315, 5, 128, "Print",
 CellTags->"Info-891c8fa4-c205-4d06-857a-695db3e58aee"],
Cell[90602, 2707, 770, 15, 58, "Print",
 CellTags->"Info-6d9cdeda-c896-487a-85e7-1d6fd48eb8e3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91409, 2727, 1244, 30, 141, "Input"],
Cell[92656, 2759, 152, 4, 45, "Output"],
Cell[92811, 2765, 148, 4, 45, "Output"],
Cell[92962, 2771, 1165, 34, 286, "Output"],
Cell[94130, 2807, 133, 4, 45, "Output"],
Cell[94266, 2813, 149, 4, 45, "Output"],
Cell[94418, 2819, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94590, 2828, 221, 4, 62, "Input"],
Cell[94814, 2834, 445, 7, 143, "Print",
 CellTags->"Info-e408696f-92f9-4bd6-8524-6a40ef9a3ba5"],
Cell[95262, 2843, 283, 5, 92, "Print",
 CellTags->"Info-b1842af5-aadb-47a6-a26c-52fa12aa1130"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95582, 2853, 462, 11, 93, "Input"],
Cell[96047, 2866, 191, 4, 45, "Output"],
Cell[96241, 2872, 187, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96465, 2881, 296, 5, 61, "Input"],
Cell[96764, 2888, 301, 5, 60, "Print",
 CellTags->"Info-aadd0053-bbf9-4abb-999a-4af8610966bd"],
Cell[CellGroupData[{
Cell[97090, 2897, 46, 1, 45, "Input"],
Cell[97139, 2900, 178, 3, 40, "Print",
 CellTags->"Info-bdad4a9d-a693-4b2b-aacf-38da24bc3666"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97354, 2908, 117, 2, 45, "Input"],
Cell[97474, 2912, 959, 14, 519, "Print",
 CellTags->"Info-0d5fe874-3fec-47bc-9615-c2a4041baccc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98470, 2931, 47, 1, 45, "Input"],
Cell[98520, 2934, 275, 5, 109, "Print",
 CellTags->"Info-22a7525c-5f19-48ba-8611-44b52dc54da9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98832, 2944, 126, 2, 45, "Input"],
Cell[98961, 2948, 208, 4, 43, "Print",
 CellTags->"Info-d526400f-aef5-4559-9a83-05cbe7f6ad26"]
}, Open  ]],
Cell[99184, 2955, 1273, 42, 111, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[100482, 3001, 136, 4, 45, "Input",
 CellTags->"b:5.2.0"],
Cell[100621, 3007, 843, 28, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[101467, 3037, 131, 3, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[101623, 3044, 65, 1, 45, "Input",
 CellTags->"b:5.2.0"],
Cell[101691, 3047, 841, 28, 84, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[102547, 3078, 170, 4, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[102742, 3086, 391, 8, 45, "Input",
 CellTags->"b:5.2.0"],
Cell[103136, 3096, 1758, 61, 246, "Output",
 CellTags->"b:5.2.0"],
Cell[104897, 3159, 135, 3, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[105057, 3166, 366, 8, 45, "Input",
 CellTags->"b:5.2.0"],
Cell[105426, 3176, 1759, 61, 246, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[107224, 3242, 464, 7, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[107713, 3253, 850, 22, 93, "Input",
 CellTags->"b:5.2.0"],
Cell[108566, 3277, 991, 25, 158, "Output",
 CellTags->"b:5.2.0"],
Cell[109560, 3304, 1091, 29, 176, "Output",
 CellTags->"b:5.2.0"],
Cell[110654, 3335, 751, 23, 80, "Output",
 CellTags->"b:5.2.0"],
Cell[111408, 3360, 649, 19, 62, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[112072, 3382, 429, 15, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[112526, 3401, 196, 5, 46, "Input",
 CellTags->{"i:2", "b:5.2.0"}],
Cell[112725, 3408, 2600, 89, 230, "Output",
 CellTags->{"i:2", "b:5.2.0"}]
}, Open  ]],
Cell[CellGroupData[{
Cell[115362, 3502, 438, 10, 61, "Input"],
Cell[115803, 3514, 1152, 29, 67, "Output"]
}, Open  ]],
Cell[116970, 3546, 186, 4, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[117181, 3554, 426, 13, 76, "Input",
 CellTags->"b:5.2.0"],
Cell[117610, 3569, 723, 23, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[118336, 3594, 639, 19, 62, "Output",
 CellTags->"b:5.2.0"],
Cell[118978, 3615, 747, 24, 84, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[119774, 3645, 46, 1, 45, "Input"],
Cell[119823, 3648, 273, 5, 75, "Print",
 CellTags->"Info-f7d565f3-a635-4078-98aa-59d3af9152f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120133, 3658, 503, 11, 106, "Input"],
Cell[120639, 3671, 619, 18, 62, "Output"],
Cell[121261, 3691, 221, 6, 45, "Output"],
Cell[121485, 3699, 617, 18, 62, "Output"],
Cell[122105, 3719, 221, 6, 45, "Output"],
Cell[122329, 3727, 284, 8, 45, "Output"],
Cell[CellGroupData[{
Cell[122638, 3739, 158, 5, 70, "Input"],
Cell[122799, 3746, 617, 18, 62, "Output"],
Cell[123419, 3766, 617, 18, 62, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[124085, 3790, 47, 1, 45, "Input"],
Cell[124135, 3793, 365, 6, 111, "Print",
 CellTags->"Info-416b572d-d5c8-4fe0-8d3f-b4c26afac64d"],
Cell[CellGroupData[{
Cell[124525, 3803, 207, 4, 61, "Input"],
Cell[124735, 3809, 1047, 31, 94, "Output"],
Cell[125785, 3842, 687, 18, 64, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[126521, 3866, 47, 1, 45, "Input"],
Cell[126571, 3869, 357, 6, 92, "Print",
 CellTags->"Info-137f1b17-35ef-40c3-8ed3-60006956dbee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126965, 3880, 824, 20, 61, "Input"],
Cell[127792, 3902, 135, 4, 45, "Output"],
Cell[127930, 3908, 137, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128104, 3917, 113, 2, 45, "Input"],
Cell[128220, 3921, 308, 5, 111, "Print",
 CellTags->"Info-788771c2-59da-498a-bf47-58aa5c931796"],
Cell[CellGroupData[{
Cell[128553, 3930, 305, 5, 91, "Input"],
Cell[128861, 3937, 703, 22, 84, "Output"],
Cell[129567, 3961, 348, 9, 67, "Output"],
Cell[129918, 3972, 727, 23, 84, "Output"],
Cell[130648, 3997, 370, 10, 67, "Output"],
Cell[CellGroupData[{
Cell[131043, 4011, 428, 12, 61, "Input"],
Cell[131474, 4025, 135, 4, 45, "Output"],
Cell[131612, 4031, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[131808, 4042, 113, 2, 45, "Input"],
Cell[131924, 4046, 216, 4, 77, "Print",
 CellTags->"Info-92495a93-9b9b-4a3b-b401-900973831db7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132177, 4055, 303, 5, 91, "Input"],
Cell[132483, 4062, 713, 22, 84, "Output"],
Cell[133199, 4086, 358, 9, 67, "Output"],
Cell[133560, 4097, 737, 23, 84, "Output"],
Cell[134300, 4122, 382, 10, 67, "Output"],
Cell[CellGroupData[{
Cell[134707, 4136, 429, 12, 61, "Input"],
Cell[135139, 4150, 137, 4, 45, "Output"],
Cell[135279, 4156, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[135463, 4166, 221, 4, 45, "Input"],
Cell[135687, 4172, 414, 6, 177, "Print",
 CellTags->"Info-cac96c74-43ec-4b27-82e5-d3e4b3ef2839"]
}, Open  ]],
Cell[CellGroupData[{
Cell[136138, 4183, 1588, 36, 166, "Input"],
Cell[137729, 4221, 288, 8, 45, "Output"],
Cell[138020, 4231, 682, 21, 78, "Output"],
Cell[138705, 4254, 681, 21, 78, "Output"],
Cell[139389, 4277, 691, 24, 158, "Output"],
Cell[140083, 4303, 664, 19, 56, "Output"],
Cell[140750, 4324, 682, 21, 78, "Output"],
Cell[141435, 4347, 689, 24, 158, "Output"],
Cell[142127, 4373, 665, 19, 56, "Output"],
Cell[CellGroupData[{
Cell[142817, 4396, 1014, 15, 61, "Input"],
Cell[143834, 4413, 1693, 42, 158, "Output"],
Cell[145530, 4457, 1707, 30, 61, "Output"],
Cell[CellGroupData[{
Cell[147262, 4491, 1288, 27, 151, "Input"],
Cell[148553, 4520, 681, 21, 78, "Output"],
Cell[149237, 4543, 682, 21, 78, "Output"],
Cell[149922, 4566, 731, 20, 45, "Output"],
Cell[150656, 4588, 732, 20, 45, "Output"],
Cell[151391, 4610, 733, 20, 45, "Output"],
Cell[CellGroupData[{
Cell[152149, 4634, 456, 6, 76, "Input"],
Cell[152608, 4642, 682, 21, 78, "Output"],
Cell[153293, 4665, 684, 21, 78, "Output"],
Cell[153980, 4688, 1709, 30, 61, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[155726, 4723, 673, 15, 106, "Input"],
Cell[156402, 4740, 681, 21, 78, "Output"],
Cell[157086, 4763, 728, 19, 45, "Output"],
Cell[157817, 4784, 730, 19, 45, "Output"],
Cell[158550, 4805, 728, 19, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[159351, 4832, 122, 2, 46, "Input"],
Cell[159476, 4836, 226, 4, 75, "Print",
 CellTags->"Info-f202f6f3-80ab-435c-ae95-49c13199b2b7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159739, 4845, 100, 2, 45, "Input"],
Cell[159842, 4849, 1707, 30, 61, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[161586, 4884, 1079, 19, 138, "Input"],
Cell[162668, 4905, 682, 21, 78, "Output"],
Cell[163353, 4928, 684, 21, 78, "Output"],
Cell[164040, 4951, 781, 21, 45, "Output"],
Cell[164824, 4974, 730, 19, 45, "Output"],
Cell[165557, 4995, 728, 19, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166322, 5019, 257, 5, 62, "Input"],
Cell[166582, 5026, 1054, 16, 451, "Print",
 CellTags->"Info-588279c0-98f2-4a4e-a41b-ce51d461028a"],
Cell[CellGroupData[{
Cell[167661, 5046, 369, 11, 77, "Input"],
Cell[168033, 5059, 1261, 36, 194, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169331, 5100, 1224, 27, 140, "Input"],
Cell[170558, 5129, 1263, 36, 194, "Output"],
Cell[171824, 5167, 627, 18, 62, "Output"],
Cell[172454, 5187, 627, 18, 62, "Output"],
Cell[173084, 5207, 775, 24, 80, "Output"],
Cell[173862, 5233, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[174034, 5242, 1420, 30, 140, "Input"],
Cell[175457, 5274, 1263, 34, 194, "Output"],
Cell[176723, 5310, 627, 18, 62, "Output"],
Cell[177353, 5330, 629, 18, 62, "Output"],
Cell[177985, 5350, 773, 23, 80, "Output"],
Cell[178761, 5375, 135, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[178921, 5383, 1243, 26, 93, "Input"],
Cell[180167, 5411, 1265, 34, 194, "Output"],
Cell[181435, 5447, 135, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[181595, 5455, 1196, 25, 93, "Input"],
Cell[182794, 5482, 1557, 44, 194, "Output"],
Cell[184354, 5528, 137, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[184516, 5536, 1399, 30, 93, "Input"],
Cell[185918, 5568, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[186126, 5580, 58, 1, 46, "Input"],
Cell[186187, 5583, 354, 6, 92, "Print",
 CellTags->"Info-b68e6ad4-5e52-4c6c-84b4-7a6a0b5f7a35"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[186590, 5595, 1844, 42, 110, "Input"],
Cell[188437, 5639, 135, 4, 45, "Output"],
Cell[188575, 5645, 135, 4, 45, "Output"],
Cell[188713, 5651, 135, 4, 45, "Output"],
Cell[188851, 5657, 135, 4, 45, "Output"],
Cell[188989, 5663, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189161, 5672, 365, 6, 109, "Input"],
Cell[189529, 5680, 209, 4, 40, "Print",
 CellTags->"Info-ed1414fc-f6fa-4fcc-bf97-c1f43e431070"],
Cell[189741, 5686, 132, 4, 45, "Output"],
Cell[189876, 5692, 215, 4, 40, "Print",
 CellTags->"Info-2c4fc2fd-f794-4a5a-9889-c5f744581475"],
Cell[190094, 5698, 132, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190263, 5707, 1307, 30, 158, "Input"],
Cell[191573, 5739, 538, 8, 143, "Print",
 CellTags->"Info-d1dc9e4d-f3a5-48da-8a5b-8b97c414c404"],
Cell[192114, 5749, 629, 18, 62, "Output"],
Cell[192746, 5769, 135, 4, 45, "Output"],
Cell[192884, 5775, 673, 19, 62, "Output"],
Cell[193560, 5796, 134, 4, 45, "Output"],
Cell[193697, 5802, 137, 4, 45, "Output"],
Cell[193837, 5808, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[194009, 5817, 336, 5, 46, "Input"],
Cell[194348, 5824, 363, 6, 109, "Print",
 CellTags->"Info-e4bfdb26-48d7-4c97-ac32-1b390ec92a67"],
Cell[CellGroupData[{
Cell[194736, 5834, 176, 3, 46, "Input"],
Cell[194915, 5839, 745, 22, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195697, 5866, 1400, 30, 78, "Input"],
Cell[197100, 5898, 135, 4, 45, "Output"],
Cell[197238, 5904, 135, 4, 45, "Output"],
Cell[197376, 5910, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[197560, 5920, 388, 6, 46, "Input"],
Cell[197951, 5928, 388, 6, 109, "Print",
 CellTags->"Info-c49aa579-b2ac-4be5-8c01-fe2b55d58867"],
Cell[CellGroupData[{
Cell[198364, 5938, 299, 6, 46, "Input"],
Cell[198666, 5946, 969, 24, 158, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[199672, 5975, 1766, 37, 78, "Input"],
Cell[201441, 6014, 135, 4, 45, "Output"],
Cell[201579, 6020, 137, 4, 45, "Output"],
Cell[201719, 6026, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[201903, 6036, 119, 2, 47, "Input"],
Cell[202025, 6040, 948, 28, 78, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[203010, 6073, 273, 5, 61, "Input"],
Cell[203286, 6080, 704, 10, 415, "Print",
 CellTags->"Info-385432f1-0550-45c5-9d1a-2e76d8cfa09d"],
Cell[203993, 6092, 482, 7, 262, "Print",
 CellTags->"Info-a1a711db-5027-4c00-bb16-a10c159f153f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[204512, 6104, 760, 22, 91, "Input"],
Cell[205275, 6128, 8318, 165, 158, "Output"],
Cell[213596, 6295, 2651, 54, 94, "Output"],
Cell[216250, 6351, 1095, 26, 62, "Output"],
Cell[217348, 6379, 135, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[217508, 6387, 619, 15, 78, "Input"],
Cell[218130, 6404, 2097, 48, 286, "Output"],
Cell[CellGroupData[{
Cell[220252, 6456, 489, 11, 61, "Input"],
Cell[220744, 6469, 132, 4, 45, "Output"],
Cell[220879, 6475, 132, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[221060, 6485, 1012, 28, 61, "Input"],
Cell[222075, 6515, 135, 4, 45, "Output"],
Cell[222213, 6521, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[222397, 6531, 797, 22, 108, "Input"],
Cell[223197, 6555, 1091, 26, 62, "Output"],
Cell[224291, 6583, 135, 4, 45, "Output"],
Cell[224429, 6589, 150, 4, 45, "Output"],
Cell[224582, 6595, 150, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224769, 6604, 114, 2, 46, "Input"],
Cell[224886, 6608, 556, 8, 262, "Print",
 CellTags->"Info-0b66b116-268e-467e-afe1-19a1784a7433"],
Cell[CellGroupData[{
Cell[225467, 6620, 1344, 38, 126, "Input"],
Cell[226814, 6660, 134, 4, 45, "Output"],
Cell[226951, 6666, 135, 4, 45, "Output"],
Cell[227089, 6672, 135, 4, 45, "Output"],
Cell[227227, 6678, 137, 4, 45, "Output"],
Cell[227367, 6684, 135, 4, 45, "Output"],
Cell[227505, 6690, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[227689, 6700, 2292, 56, 160, "Input"],
Cell[229984, 6758, 4328, 117, 128, "Output"],
Cell[234315, 6877, 948, 28, 78, "Output"],
Cell[235266, 6907, 1278, 35, 62, "Output"],
Cell[236547, 6944, 132, 4, 45, "Output"],
Cell[236682, 6950, 1399, 40, 84, "Output"],
Cell[238084, 6992, 1399, 40, 84, "Output"],
Cell[CellGroupData[{
Cell[239508, 7036, 945, 22, 103, "Input"],
Cell[240456, 7060, 4330, 117, 128, "Output"],
Cell[244789, 7179, 135, 4, 45, "Output"],
Cell[244927, 7185, 135, 4, 45, "Output"],
Cell[245065, 7191, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[245249, 7201, 1768, 50, 70, "Input"],
Cell[247020, 7253, 135, 4, 45, "Output"],
Cell[247158, 7259, 137, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[247332, 7268, 205, 3, 46, "Input"],
Cell[247540, 7273, 1729, 50, 54, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249306, 7328, 258, 4, 46, "Input"],
Cell[249567, 7334, 3096, 84, 54, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252700, 7423, 521, 9, 91, "Input"],
Cell[253224, 7434, 867, 23, 62, "Output"],
Cell[254094, 7459, 535, 12, 45, "Output"],
Cell[CellGroupData[{
Cell[254654, 7475, 97, 1, 61, "Input"],
Cell[254754, 7478, 1144, 29, 94, "Output"],
Cell[255901, 7509, 930, 18, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[256880, 7533, 264, 4, 91, "Input"],
Cell[257147, 7539, 860, 23, 45, "Output"],
Cell[258010, 7564, 527, 12, 45, "Output"],
Cell[258540, 7578, 1124, 27, 45, "Output"],
Cell[259667, 7607, 933, 18, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[260637, 7630, 354, 7, 91, "Input"],
Cell[260994, 7639, 3180, 54, 76, "Output"],
Cell[264177, 7695, 3288, 54, 91, "Output"]
}, Open  ]],
Cell[267480, 7752, 262, 5, 46, "Input"],
Cell[CellGroupData[{
Cell[267767, 7761, 1019, 24, 108, "Input"],
Cell[268789, 7787, 923, 23, 62, "Output"],
Cell[269715, 7812, 150, 4, 45, "Output"],
Cell[269868, 7818, 737, 21, 78, "Output"],
Cell[270608, 7841, 2314, 51, 94, "Output"],
Cell[272925, 7894, 136, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273098, 7903, 1294, 29, 140, "Input"],
Cell[274395, 7934, 134, 4, 45, "Output"],
Cell[274532, 7940, 154, 4, 45, "Output"],
Cell[274689, 7946, 4495, 88, 272, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279221, 8039, 115, 2, 46, "Input"],
Cell[279339, 8043, 316, 5, 126, "Print",
 CellTags->"Info-d05aa854-9745-4a27-a60e-aa6a2ce8d635"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279692, 8053, 324, 7, 68, "Input"],
Cell[280019, 8062, 948, 28, 78, "Output"],
Cell[280970, 8092, 134, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[281141, 8101, 469, 10, 82, "Input"],
Cell[281613, 8113, 1075, 30, 68, "Output"],
Cell[282691, 8145, 692, 21, 62, "Output"],
Cell[283386, 8168, 135, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[283546, 8176, 115, 2, 46, "Input"],
Cell[283664, 8180, 1693, 50, 54, "Print"]
}, Open  ]]
}, Open  ]],
Cell[285384, 8234, 312, 6, 23, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[285721, 8244, 2272, 59, 205, "Input"],
Cell[287996, 8305, 466, 12, 61, "Output"],
Cell[288465, 8319, 465, 12, 61, "Output"],
Cell[288933, 8333, 400, 9, 61, "Output"],
Cell[289336, 8344, 398, 9, 61, "Output"],
Cell[289737, 8355, 354, 10, 55, "Output"],
Cell[CellGroupData[{
Cell[290116, 8369, 739, 22, 78, "Input"],
Cell[290858, 8393, 135, 4, 45, "Output"],
Cell[290996, 8399, 135, 4, 45, "Output"],
Cell[291134, 8405, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[291318, 8415, 333, 9, 47, "Input"],
Cell[291654, 8426, 682, 21, 78, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[292373, 8452, 635, 17, 62, "Input"],
Cell[293011, 8471, 673, 19, 62, "Output"],
Cell[293687, 8492, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[293859, 8501, 2446, 66, 139, "Input"],
Cell[296308, 8569, 819, 27, 84, "Output"],
Cell[297130, 8598, 819, 27, 84, "Output"],
Cell[297952, 8627, 819, 27, 84, "Output"],
Cell[298774, 8656, 135, 4, 45, "Output"],
Cell[298912, 8662, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[299084, 8671, 118, 2, 46, "Input"],
Cell[299205, 8675, 1210, 36, 54, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[300452, 8716, 1219, 25, 86, "Input"],
Cell[301674, 8743, 2459, 69, 94, "Output"],
Cell[304136, 8814, 1061, 28, 62, "Output"],
Cell[CellGroupData[{
Cell[305222, 8846, 111, 2, 46, "Input"],
Cell[305336, 8850, 486, 11, 42, "Print",
 CellTags->"Info-d221bb50-e497-4c82-b5fc-8356b5bb91bc"]
}, Open  ]]
}, Open  ]],
Cell[305849, 8865, 248, 5, 46, "Input"],
Cell[CellGroupData[{
Cell[306122, 8874, 316, 5, 61, "Input"],
Cell[306441, 8881, 629, 13, 45, "Print",
 CellTags->"Info-b721e6a4-0022-44d8-b7dd-bd64b7b406bf"],
Cell[307073, 8896, 228, 4, 77, "Print",
 CellTags->"Info-10189915-d906-4ad1-b6a6-15b156632072"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307338, 8905, 374, 6, 91, "Input"],
Cell[307715, 8913, 629, 18, 62, "Output"],
Cell[308347, 8933, 627, 18, 62, "Output"],
Cell[308977, 8953, 673, 19, 62, "Output"],
Cell[309653, 8974, 649, 19, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310339, 8998, 291, 5, 95, "Input"],
Cell[310633, 9005, 629, 18, 62, "Output"],
Cell[311265, 9025, 627, 18, 62, "Output"],
Cell[311895, 9045, 673, 19, 62, "Output"],
Cell[312571, 9066, 649, 19, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[313257, 9090, 987, 25, 47, "Input"],
Cell[314247, 9117, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[314419, 9126, 113, 2, 45, "Input"],
Cell[314535, 9130, 679, 10, 349, "Print",
 CellTags->"Info-21644ead-71af-4f98-8ad2-9968bde6c1da"],
Cell[CellGroupData[{
Cell[315239, 9144, 737, 21, 91, "Input"],
Cell[315979, 9167, 135, 4, 45, "Output"],
Cell[316117, 9173, 134, 4, 45, "Output"],
Cell[316254, 9179, 135, 4, 45, "Output"],
Cell[316392, 9185, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[316576, 9195, 1468, 36, 78, "Input"],
Cell[318047, 9233, 137, 4, 45, "Output"],
Cell[318187, 9239, 135, 4, 45, "Output"],
Cell[318325, 9245, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[318497, 9254, 113, 2, 46, "Input"],
Cell[318613, 9258, 242, 4, 75, "Print",
 CellTags->"Info-b7cb155d-5de8-45d9-8a6c-5b03473bf152"]
}, Open  ]],
Cell[CellGroupData[{
Cell[318892, 9267, 1346, 33, 78, "Input"],
Cell[320241, 9302, 703, 20, 94, "Output"],
Cell[320947, 9324, 135, 4, 45, "Output"],
Cell[321085, 9330, 135, 4, 45, "Output"],
Cell[CellGroupData[{
Cell[321245, 9338, 1578, 38, 62, "Input"],
Cell[322826, 9378, 137, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[323012, 9388, 182, 3, 61, "Input"],
Cell[323197, 9393, 785, 15, 42, "Print",
 CellTags->"Info-0028b352-8054-49ed-abe5-cda0408f50df"],
Cell[323985, 9410, 414, 6, 143, "Print",
 CellTags->"Info-2f41ef63-436f-4024-924a-6a24761da18c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[324436, 9421, 967, 20, 76, "Input"],
Cell[325406, 9443, 643, 20, 94, "Output"],
Cell[326052, 9465, 691, 24, 158, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[326780, 9494, 856, 23, 61, "Input"],
Cell[327639, 9519, 135, 4, 45, "Output"],
Cell[327777, 9525, 137, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[327951, 9534, 116, 2, 45, "Input"],
Cell[328070, 9538, 306, 5, 111, "Print",
 CellTags->"Info-9533eb03-5b6c-4532-b7f8-a5d01fddaaf5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[328413, 9548, 275, 5, 61, "Input"],
Cell[328691, 9555, 969, 24, 158, "Output"],
Cell[329663, 9581, 969, 24, 158, "Output"],
Cell[CellGroupData[{
Cell[330657, 9609, 1745, 44, 211, "Input"],
Cell[332405, 9655, 220, 6, 45, "Output"],
Cell[332628, 9663, 220, 6, 45, "Output"],
Cell[332851, 9671, 223, 6, 45, "Output"],
Cell[333077, 9679, 220, 6, 45, "Output"],
Cell[333300, 9687, 221, 6, 45, "Output"],
Cell[333524, 9695, 221, 6, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[333794, 9707, 413, 9, 94, "Input"],
Cell[334210, 9718, 295, 5, 109, "Print",
 CellTags->"Info-5fc5572a-8da7-4705-a6f3-5314ca8e46c7"],
Cell[334508, 9725, 132, 4, 45, "Output"],
Cell[334643, 9731, 187, 6, 45, "Output"],
Cell[334833, 9739, 187, 6, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[335057, 9750, 520, 8, 126, "Input"],
Cell[335580, 9760, 253, 4, 92, "Print",
 CellTags->"Info-68041fe5-c507-404a-a534-107cdd947610"],
Cell[335836, 9766, 132, 4, 45, "Output"],
Cell[335971, 9772, 133, 4, 45, "Output"],
Cell[336107, 9778, 132, 4, 45, "Output"],
Cell[336242, 9784, 2961, 80, 1054, "Output"],
Cell[CellGroupData[{
Cell[339228, 9868, 955, 25, 76, "Input"],
Cell[340186, 9895, 135, 4, 45, "Output"],
Cell[340324, 9901, 135, 4, 45, "Output"],
Cell[340462, 9907, 135, 4, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[340646, 9917, 392, 8, 110, "Input"],
Cell[341041, 9927, 246, 4, 92, "Print",
 CellTags->"Info-8d295e0d-1b50-4caa-953c-4f6017747a05"],
Cell[341290, 9933, 132, 4, 45, "Output"],
Cell[341425, 9939, 134, 4, 45, "Output"],
Cell[341562, 9945, 721, 24, 126, "Output"],
Cell[342286, 9971, 801, 30, 222, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[343124, 10006, 232, 4, 76, "Input"],
Cell[343359, 10012, 216, 4, 77, "Print",
 CellTags->"Info-c1aa3443-5335-43ca-9920-6f3bf58523a1"],
Cell[343578, 10018, 684, 21, 78, "Output"],
Cell[344265, 10041, 747, 26, 158, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[345049, 10072, 493, 11, 91, "Input"],
Cell[345545, 10085, 206, 4, 43, "Print",
 CellTags->"Info-4e3414bd-b2ab-4cb0-81e3-94bd7d88d16e"],
Cell[345754, 10091, 627, 18, 62, "Output"],
Cell[346384, 10111, 1239, 42, 130, "Output"],
Cell[347626, 10155, 703, 20, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[348366, 10180, 1251, 36, 165, "Input"],
Cell[349620, 10218, 433, 7, 126, "Print",
 CellTags->"Info-5b50adc8-151f-43ee-a446-e64801889e5f"],
Cell[350056, 10227, 627, 18, 62, "Output"],
Cell[350686, 10247, 629, 18, 62, "Output"],
Cell[351318, 10267, 626, 18, 62, "Output"],
Cell[351947, 10287, 135, 4, 45, "Output"],
Cell[352085, 10293, 134, 4, 45, "Output"],
Cell[352222, 10299, 135, 4, 45, "Output"],
Cell[352360, 10305, 135, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[352532, 10314, 216, 5, 61, "Input"],
Cell[352751, 10321, 246, 4, 92, "Print",
 CellTags->"Info-92782b98-7fcd-4eed-8344-6354c870fa12"],
Cell[353000, 10327, 627, 18, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[353664, 10350, 119, 2, 45, "Input"],
Cell[353786, 10354, 249, 4, 60, "Print",
 CellTags->"Info-e4d03799-ff7e-4ce0-955d-a1cfa7f1a68d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[354072, 10363, 291, 5, 95, "Input"],
Cell[354366, 10370, 627, 18, 62, "Output"],
Cell[354996, 10390, 627, 18, 62, "Output"],
Cell[355626, 10410, 673, 19, 62, "Output"],
Cell[356302, 10431, 649, 19, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[356988, 10455, 236, 4, 61, "Input"],
Cell[357227, 10461, 2341, 57, 94, "Output"],
Cell[CellGroupData[{
Cell[359593, 10522, 218, 4, 45, "Input"],
Cell[359814, 10528, 280, 5, 58, "Print",
 CellTags->"Info-ff186f53-09b0-44bc-afa0-a5daee5abd4f"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[360143, 10539, 130, 2, 45, "Input"],
Cell[360276, 10543, 2609, 59, 78, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[362922, 10607, 279, 5, 61, "Input"],
Cell[363204, 10614, 1523, 43, 54, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[364764, 10662, 450, 10, 77, "Input"],
Cell[365217, 10674, 585, 9, 296, "Print",
 CellTags->"Info-d09e4591-2898-4584-9a8e-c6f8d43d2cdc"]
}, Open  ]],
Cell[365817, 10686, 264, 5, 45, "Input"]
}
]
*)

(* End of internal cache information *)
