(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    115651,       3676]
NotebookOptionsPosition[     94353,       2988]
NotebookOutlinePosition[    106450,       3356]
CellTagsIndexPosition[    105868,       3331]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Grover searching algorithms", "Title",
 CellTags->"c:1"],

Cell["Searching for one or two items on a database", "Subtitle"],

Cell[TextData[{
 "Version: 4.0-July-2014--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9.0,10."
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, 
   3.5122121329923573`*^9, {3.614175149032529*^9, 3.6141751667935123`*^9}}],

Cell[TextData[ButtonBox["Click here to get the palette: QDENSpalette.nb",
 BaseStyle->"Hyperlink",
 ButtonData:>{"QDENSpalette.nb", None}]], "Text"],

Cell[CellGroupData[{

Cell["\<\
Grover Searching Algorithm-Single Marked Item.             To open double \
click at down arrow---------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.51221208965519*^9, 3.512212105663488*^9}},
 FontFamily->"Times",
 CellTags->"c:2"],

Cell[CellGroupData[{

Cell["Step 1: Setting the conditions", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:1.0.0"}],

Cell["\<\
Grover's search algorithm making use of density matrices in subspace |x\
\[RightAngleBracket]. 
The space |y\[RightAngleBracket] is part of the search, but keeps the same \
state during 
the process and can therefore be suppressed.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 CellTags->"b:1.0.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.615987357153634*^9, 3.615987389828127*^9, 
  3.616263695163247*^9, 3.6249686374461937`*^9, 3.655402727357239*^9, 
  3.657377253075595*^9},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Discord",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Discord", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Rho]$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Mutual",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Mutual", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["neg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "neg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-41af27a7-bfdd-4cb4-b62a-6a5c6e8923c4", {
            "xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.1357142857142857]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657377253670566*^9},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/Grover.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnU1u2zAQhadFF10V4BGqK3CTbQsuuk4hoLsiAUpkVyAtQOQGugKv4Cvo
CrqCrqArTCn5T7YsagjSriTPAFFszuQ94bNEaaIQ+fz8+1G/B4A/H93m8cl8
eX19evv+wb35+vb313Ob+um+Pr0DQI7/Eg/mLB7Cyo1Jae5XyyHGjBIDfb/h
MBuzg6FqVz9nlkJDCGlQKGEVZLmqJBRYKVFEmJN2aKY0DJbCHRu10BWCySw2
mDVus0+PRTma+XF49XJ8NbA1w6qHl9Hy3rlft2/lfiPP1F4uvfKoHas6XSN1
09IAtLlA0Q4JSH65WcqxoSSAAi0sGpBYaVBY5qAjzEk7NFMaiFVV2QgvUiyH
xi2CaXjtmYZ3YCLLNOj1geZMI5lagmAaXvt50jAgTNvEKjz0KTkUyTuVZdAw
7ra87fbdnfixT4GTTiVJLIOGcL1Kk21b+kOfAuk7lWXQgO1GgWvrD30K9DqV
u+ph3SmBdYanjcoVfvezjGPDzRm1PO/Z7pbG7ppyOpRFOI/ZUPdnLMv3G/T6
QHOmkUwtQTANrz3T8A5MZJkGvT7QnGkkU0sQTMNrzzS8AxPZedC4qx72VrGS
YyNRMA2vPdPwDkxkmQa9PtCcaQSryQjHiVggjSsG0/DaMw3vwER2ffNGk4PI
c8r+DMrjaSRTSxCdvSoaRF0eB+jl8TSSqSWIzr59alVkUB4G6OXxNJKpJYjO
PtucDdDL42kEq1173tiodks+U/rl8TSSqSWIrb3VjZvNqGdKvzzBNSWVWoLY
2ZduYje2N0AtT3GFTaSWIBZ4v3HFYBpee6bhHZjIMg16faB5AhqjTwy6mFjh
sj4aMWmm4c0yjYhyphHifiO13hNOf+GlR5srfg7Lx0aAAtOgp5mGN8s0IsqZ
Roj7DdVICkyDnl4WDbX95rsDuSMau+VKdTmhaURW5lJcWBC5QhroWQW7VSg1
or1UtSoajQTtPnE7vgx2pyDaB7wkS2923jT0BjeuptmMluwUFAC0RIyAohmm
qTs0bxrQdKuEB3WDHtY4XnmFpqiaQmNdoNjONWvqYbul0e6rGf/95o5TabqJ
A9Ca9gfM/untqo4N93FXkjJvaCFRgsrqYlNlaDOVUQwWRqO0aErCNWUfhWxQ
F6PpSft500ADlnC/cYxCnC4rXhMNvheN1gxIMw1vlmlElDONEPcbqpEUmAY9
zTS8WaYRUT4TGoMedizW1MNSuMSkV3JskBWYBj29OhoX/ptAL6zf4Nt5/bew
8qm/sruh2p3EP+7OZZU=
    "], {{0, 0}, {270, 95}}, {0, 255},
    ColorFunction->GrayLevel],
   ImageSize->{270, 95},
   PlotRange->{{0, 270}, {0, 95}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.61598735729135*^9, 3.615987389961987*^9, 
  3.616263695313698*^9, 3.6249686375872173`*^9, 3.655402728092935*^9, 
  3.657377253755685*^9},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell[TextData[{
 "Set the number of x  \n- ",
 Cell[BoxData[
  FormBox["nqx", TraditionalForm]]],
 " is the number of qubits of the unknown state"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"nqx", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"nqx", " ", ">", "10"}], ",", 
   RowBox[{
   "Print", "[", "\"\<Check your nqx, it may take too long to compute\>\"", 
    "]"}], ","}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"qtab", ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    SubscriptBox["qx", "i"], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "nqx"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", "qtab"}], "Input",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       SubscriptBox["qx", "1"]},
      {
       SubscriptBox["qx", "2"]},
      {
       SubscriptBox["qx", "3"]},
      {
       SubscriptBox["qx", "4"]},
      {
       SubscriptBox["qx", "5"]},
      {
       SubscriptBox["qx", "6"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159873573124743`*^9, 3.6159873899744453`*^9, 
  3.616263695323935*^9, 3.624968637598523*^9, 3.65540272814977*^9, 
  3.6573772537684927`*^9},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"nq", "=", "nqx"}], ";"}]], "Input",
 CellTags->"b:1.0.0"],

Cell["Total number of bits;  we suppress the y bit", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nbits", "=", 
  RowBox[{"2", "^", "nq"}]}]], "Input",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 TagBox["64",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357326133*^9, 3.61598739000148*^9, 
  3.6162636953395147`*^9, 3.624968637635784*^9, 3.655402728222393*^9, 
  3.657377253806973*^9},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell["In the figure we depict the full searching circuit.", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell["Initialize all n qubits ( x and y qubits)  to Zero State", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[TextData[{
 StyleBox["NOTE: The state  |0\[RightAngleBracket] is the array \
(1,0,0,0,...,0) in the nq bit space",
  FontSize->12],
 "\n",
 StyleBox["Here  \[Rho]0=rh0  is the density matrix in the |x\
\[RightAngleBracket]  space",
  FontSize->12],
 " "
}], "SmallText",
 CellChangeTimes->{{3.5122123980269423`*^9, 3.512212399913834*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell["\<\
 rh0=N[Table[KroneckerDelta[i, 1] * KroneckerDelta[i, j],{i, 1, nbits},{j, 1, \
nbits}]];\
\>", "Input",
 CellChangeTimes->{{3.512212354078671*^9, 3.512212386253564*^9}},
 CellTags->"b:1.0.0"],

Cell[TextData[{
 "Prepare State By Hadamarding all x qubits and since |y\[RightAngleBracket]  \
remains as ",
 Cell[BoxData[
  FractionBox["1", 
   SqrtBox["2"]]]],
 "( |0\[RightAngleBracket] - |1\[RightAngleBracket] ), the |y\
\[RightAngleBracket] space can be suppressed"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell["\<\
Prepare the x qubits in equi-weighted state by Hadamarding all of them using \
HALL\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "Generate", " ", "the", "  ", "density", " ", "matrix", "  ", "\[Rho]1"}], 
  "=", "rh1", " "}]], "Text",
 CellChangeTimes->{{3.512212417603921*^9, 3.512212420740584*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.0.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rh1", "=", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"HALL", "[", "nqx", "]"}], ".", "rh0", ".", 
     RowBox[{"Adj", "[", 
      RowBox[{"N", "[", 
       RowBox[{"HALL", "[", "nqx", "]"}], "]"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.512212412706369*^9, 3.512212426878147*^9}},
 CellTags->"b:1.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Building the Grover operator", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:1.0.1"}],

Cell["\<\
Prepare the Grover operator G as the \"inversion about the mean\" times the \
Oracle
The Oracle defines an arbitrary single marked state as indicated by the \
function f.
When acting in just the |x\[RightAngleBracket] space, the Grover Oracle G \
changes the sign of the marked state.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nx", "=", 
  RowBox[{"2", "^", "nqx"}]}]], "Input",
 CellTags->"b:1.0.1"],

Cell[BoxData[
 TagBox["64",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357389688*^9, 3.615987390066737*^9, 
  3.616263695424559*^9, 3.624968637696746*^9, 3.655402728324648*^9, 
  3.657377253870184*^9},
 CellTags->"b:1.0.1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Generate", " ", "the", "  ", "marked", " ", "state", " ", 
  "randomly", " ", "and", " ", "include", " ", "in", " ", "the", " ", 
  "Oracle"}]], "Text",
 CellChangeTimes->{{3.614517930548231*^9, 3.614517931040362*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{"ReplacePart", "[", 
    RowBox[{
     RowBox[{"ZeroT", "[", "nx", "]"}], ",", "1", ",", 
     RowBox[{"xpick", "=", 
      RowBox[{"RandomInteger", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "nx"}], "}"}], "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"markit", "=", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], "f"]}], ";"}]}], "Input",
 CellTags->"b:1.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OracleG", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"markit", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "*", 
      RowBox[{"KroneckerDelta", "[", 
       RowBox[{"i", ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "nx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "nx"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellTags->"b:1.0.1"],

Cell[TextData[{
 "phaseinvert is the (2 |0\[RightAngleBracket]\[LeftAngleBracket]0| - I)  \
phase inversion matrix  in the ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["n", "x"], TraditionalForm]]],
 " space "
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"phaseinvert", "=", 
   RowBox[{"N", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}], "*", 
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "^", 
        RowBox[{"KroneckerDelta", "[", 
         RowBox[{"1", ",", "j"}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"2", "^", "nqx"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", 
        RowBox[{"2", "^", "nqx"}]}], "}"}]}], "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"b:1.0.1"],

Cell["\<\
Put the above together to form Inversion about the mean: Invmean \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell["Invmean = N[HALL[nq]].(phaseinvert .N[ HALL[nq]]);", "Input",
 CellTags->"b:1.0.1"],

Cell["Then the Grover operator reads:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell["G = N[Invmean . OracleG];", "Input",
 CellTags->"b:1.0.1"],

Cell["\<\
Apply G  nG Times  to obtain the final density matrix \[Rho]F [ nG ] =rhF[nG] \
\>", "Text",
 CellChangeTimes->{{3.512212571591008*^9, 3.512212580176152*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.0.1"],

Cell["\<\
rhF[0] = N[rh1];
rhF[nG_] := rhF[nG] = G . (rhF[nG-1] . (Adj[G]))\
\>", "Input",
 CellChangeTimes->{{3.512212445601252*^9, 3.512212446651054*^9}, {
  3.512212586577342*^9, 3.5122126004141808`*^9}},
 CellTags->"b:1.0.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: Apply the Grover operator a certain number of times", \
"Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:5", "b:1.0.2"}],

Cell["\<\
The Grover operator, G, must be applied a number of times which 
is estimated here:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ntry", "=", 
  RowBox[{
   RowBox[{"IntegerPart", "[", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"Length", "[", "f", "]"}], "]"}], "]"}], "-", "1"}]}]], "Input",
 CellTags->"b:1.0.2"],

Cell[BoxData[
 TagBox["7",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357460978*^9, 3.6159873901121607`*^9, 
  3.616263695505975*^9, 3.624968637752466*^9, 3.65540272844001*^9, 
  3.657377253943684*^9},
 CellTags->"b:1.0.2"]
}, Open  ]],

Cell["Get final density matrix after ntry iterations.", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Z", "=", 
   RowBox[{"rhF", "[", "ntry", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5122126126180477`*^9, 3.5122126136533957`*^9}},
 CellTags->"b:1.0.2"],

Cell["\<\
Take Trace for Projective Measurements using Tr  [ | n \[RightAngleBracket]\
\[LeftAngleBracket] n |  \[Rho]  ] = \[LeftAngleBracket] n | \[Rho]  | n \
\[RightAngleBracket] directly.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Clear", "[", "R", "]"}], ";", 
   RowBox[{"R", ":=", 
    RowBox[{"N", "[", 
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"Z", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "i"}], "]"}], "]"}], " ", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "nx"}], "}"}]}], "]"}], "]"}], 
    " "}]}]}]], "Input",
 CellTags->"b:1.0.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 4: Analyze results ", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:6", "b:1.0.3"}],

Cell["Look at results", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"probsearch", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", "  ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"R", "[", 
        RowBox[{"[", " ", "i", "]"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "nx"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellTags->"b:1.0.3"],

Cell["\<\
We can plot the possible outcomes of the search with their probabilities:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot1", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"probsearch", ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Item", " ", "number"}], ",", "Probability"}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"PointSize", "[", "0.025`", "]"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1.`"}], "}"}]}]}], "]"}]}]], "Input",
 CellTags->{"ListPlot", "b:1.0.3"}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {{}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.025], 
      AbsoluteThickness[1.6], PointBox[CompressedData["
1:eJxdy8sKQVEUh/E/I2aUgYGBW5Ik9ztnu1+OW0bGwkh5Be+jlGfxHMojIFLn
27Va/dbXjmxP671bknnPZ3/f0zrYl9vVv7F+B+O0B/bBATgIh+AwHIXjcAJO
wik4DWfgLJyD83ABLsIluAxX4Cpcg+twA27CLbgNW7Bx+gyrgw6riw6rhw6r
jw5rgA5riA5rhA5rjA5rgg5rig7LRoc1Q4c1N9VjzHX3Pn59jr7A/4XZOfrS
6TOs1d8vLCoBYQ==
       "]]}, {}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox[
      RowBox[{"Item", " ", "number"}], TraditionalForm], 
     FormBox["Probability", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0., 64.}, {0, 1.}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {0, 0}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357564906*^9, 3.615987390208487*^9, 
  3.6162636957149277`*^9, 3.624968638120916*^9, 3.6554027286078167`*^9, 
  3.657377254055038*^9},
 CellTags->{"ListPlot", "b:1.0.3"}]
}, Open  ]],

Cell["Isolate the maximum probability:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"Max", "[", "probsearch", "]"}], "]"}]], "Input",
 CellTags->"b:1.0.3"],

Cell[BoxData[
 TagBox["0.9074492475732603`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357700984*^9, 3.6159873902177773`*^9, 
  3.616263695729025*^9, 3.624968638257928*^9, 3.6554027289392157`*^9, 
  3.657377254073859*^9},
 CellTags->"b:1.0.3"]
}, Open  ]],

Cell["\<\
And get the position corresponding to the maximum probability:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"grover", " ", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Position", "[", 
    RowBox[{"probsearch", ",", 
     RowBox[{"Max", "[", "probsearch", "]"}]}], "]"}], "]"}]}]], "Input",
 CellTags->{"Ordering", "b:1.0.3"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"58"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987357730404*^9, 3.615987390249031*^9, 
  3.616263695751708*^9, 3.6249686382865868`*^9, 3.655402729000564*^9, 
  3.657377254088088*^9},
 CellTags->{"Ordering", "b:1.0.3"}]
}, Open  ]],

Cell["Compare to the \"unknown\" marked state as stored in f ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"[", "s", "]"}], "]"}], "==", "1"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<marked item is number=\>\"", ",", "s", ",", 
        "\"\<    \n          Grover search found=\>\"", ",", "grover"}], 
       "]"}], ",", "\"\<\>\""}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "1", ",", 
     RowBox[{"Length", "[", "f", "]"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"b:1.0.3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"marked item is number=\"\>", "\[InvisibleSpace]", "58", 
   "\[InvisibleSpace]", "\<\"    \\n          Grover search found=\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", "58", "}"}]}],
  SequenceForm[
  "marked item is number=", 58, "    \n          Grover search found=", {58}],
  Editable->False]], "Print",
 CellChangeTimes->{3.615987357742938*^9, 3.61598739025881*^9, 
  3.616263695763381*^9, 3.624968638300056*^9, 3.655402729050187*^9, 
  3.657377254123094*^9},
 CellTags->"b:1.0.3"]
}, Open  ]],

Cell["Quit", "Input",
 CellTags->"b:1.0.3"],

Cell[TextData[{
 "Last Version: 15-Aug-2014\n",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{"References", ":"}], 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"[", "1", "]"}], " ", 
         RowBox[{"Lov", ".", " ", "K", ".", " ", "Grover"}]}], ",", " ", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "Lett", ".", " ", "79"}], 
         " ", 
         RowBox[{"(", "1997", ")"}], " ", "325"}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", "QDENSITY", " ", "manual"}], ",", " ", 
        RowBox[{"Sect", ".", " ", "8"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
      "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}], TraditionalForm]], 
  "DefinitionBox",
  GridBoxOptions->{
  GridBoxDividers->{
   "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
    "RowsIndexed" -> {}},
  GridBoxSpacings->{"Columns" -> {
      Offset[0.27999999999999997`], {
       Offset[0.5599999999999999]}, 
      Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
      Offset[0.2], {
       Offset[0.16]}, 
      Offset[0.2]}, "RowsIndexed" -> {}}},
  CellTags->"S5.1.1"]
}], "Abstract",
 CellChangeTimes->{{3.614175277061693*^9, 3.614175281887051*^9}},
 CellTags->"b:1.0.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Grover Searching Algorithm-Two Marked Items.              To open double \
click at down arrow---------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.5122121106395903`*^9, 3.5122121176392*^9}},
 FontFamily->"Times",
 CellTags->"c:7"],

Cell[CellGroupData[{

Cell["Step 1: Setting the conditions", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:8", "b:1.1.0"}],

Cell["\<\
Grover's search algorithm making use of density matrices in subspace |x\
\[RightAngleBracket]. 
The space |y\[RightAngleBracket] is part of the search, but keeps the same \
state during 
the process and can therefore be suppressed.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 CellTags->"b:1.1.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.615987507850161*^9},
 CellTags->"b:1.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3615973107-5307318", {"Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3615973107-5307318", {"RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3615973107-5307318", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3615973107-5307318", {"EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3615973107-5307318", {"RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3615973107-5307318", {"xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.1357142857142857]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.615987507882738*^9},
 CellTags->"b:1.1.0"]
}, Open  ]],

Cell["\<\
Set the number of x  
- nqx is the number of qubits of the unknown state\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"nqx", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"nqx", " ", ">", "10"}], ",", 
   RowBox[{
   "Print", "[", "\"\<Check your nqx, it may take too long to compute\>\"", 
    "]"}], ","}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"qtab", ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    SubscriptBox["qx", "i"], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "nqx"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", "qtab"}], "Input",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       SubscriptBox["qx", "1"]},
      {
       SubscriptBox["qx", "2"]},
      {
       SubscriptBox["qx", "3"]},
      {
       SubscriptBox["qx", "4"]},
      {
       SubscriptBox["qx", "5"]},
      {
       SubscriptBox["qx", "6"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987507908849*^9},
 CellTags->"b:1.1.0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"nq", "=", "nqx"}], ";"}]], "Input",
 CellTags->"b:1.1.0"],

Cell["Total number of bits;  we suppress the y bit", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"n", "=", 
  RowBox[{"2", "^", "nq"}]}]], "Input",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 TagBox["64",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987507921154*^9},
 CellTags->"b:1.1.0"]
}, Open  ]],

Cell["In the figure we depict the full searching circuit.", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell["Initialize all n qubits ( x and y qubits)  to Zero State", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[TextData[{
 StyleBox["NOTE: the | 0  \[RightAngleBracket] state is the array \
(1,0,0,0,...,0) in the nq bit space",
  FontSize->12],
 "\n",
 StyleBox["Here  \[Rho]0 =rh0 is the density matrix in the |x \
\[RightAngleBracket]  space",
  FontSize->12],
 " "
}], "SmallText",
 CellChangeTimes->{{3.512212675614489*^9, 3.512212677314245*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rh0", "=", 
   RowBox[{"N", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "1"}], "]"}], "*", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{"i", ",", "j"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5122126719441233`*^9, 3.512212672054604*^9}},
 CellTags->"b:1.1.0"],

Cell[TextData[{
 "Prepare State By Hadamarding all x qubits and  since |y\[RightAngleBracket] \
 remains as ",
 Cell[BoxData[
  FractionBox["1", 
   SqrtBox["2"]]]],
 "( |0\[RightAngleBracket] - |1\[RightAngleBracket] ), the |y\
\[RightAngleBracket] space can be suppressed"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell["\<\
Prepare the x qubits in equi-weighted state by Hadamarding all of them using \
HALL\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 RowBox[{"Generate", " ", "the", "  ", "density", " ", "matrix", "  ", 
  "\[Rho]1", " "}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"rh1", "=", 
   RowBox[{
    RowBox[{"N", "[", 
     RowBox[{"HALL", "[", "nqx", "]"}], "]"}], ".", "rh0", ".", 
    RowBox[{"(", 
     RowBox[{"Adj", "[", 
      RowBox[{"N", "[", 
       RowBox[{"HALL", "[", "nqx", "]"}], "]"}], "]"}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5122126809292192`*^9, 3.5122126858539352`*^9}},
 CellTags->"b:1.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Prepare the Grover operator", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:9", "b:1.1.1"}],

Cell["\<\
Prepare the Grover operator G as the \"inversion about the mean\" times the \
Oracle.
The Oracle defines an arbitrary set of two marked states as indicated by the \
function f.
When acting in just the | x \[RightAngleBracket] space, the Grover OracleG \
changes the sign of the marked states.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nx", "=", 
  RowBox[{"2", "^", "nqx"}]}]], "Input",
 CellTags->"b:1.1.1"],

Cell[BoxData[
 TagBox["64",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159875196244307`*^9},
 CellTags->"b:1.1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"f", "=", 
  RowBox[{"ReplacePart", "[", 
   RowBox[{
    RowBox[{"ZeroT", "[", "nx", "]"}], ",", "1", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xpick1", "=", 
        RowBox[{"RandomInteger", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "nx"}], "}"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"xpick2", "=", 
        RowBox[{"RandomInteger", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "nx"}], "}"}], "]"}]}], "}"}]}], "}"}]}], 
   "]"}]}], "\n", 
 RowBox[{"markit", "=", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"-", "1"}], ")"}], "f"]}]}], "Input",
 CellTags->"b:1.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"1"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"1"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159875196353197`*^9},
 CellTags->"b:1.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {
       RowBox[{"-", "1"}]},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {
       RowBox[{"-", "1"}]},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.615987519637882*^9},
 CellTags->"b:1.1.1"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"OracleG", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"markit", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "*", 
      RowBox[{"KroneckerDelta", "[", 
       RowBox[{"i", ",", "j"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "nx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "nx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{" "}]}], "Input",
 CellTags->"b:1.1.1"],

Cell["\<\
phaseinvert is the (2 | 0 \[RightAngleBracket] \[LeftAngleBracket]  0 | - I ) \
 phase inversion matrix in the nqx space \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.1"],

Cell["\<\
phaseinvert = \
N[Table[KroneckerDelta[i,j]*(-1)*(-1)^KroneckerDelta[1,j],{i,1,2^nqx},{j, 1, \
nx}]];\
\>", "Input",
 CellTags->"b:1.1.1"],

Cell["\<\
Put the above together to form Inversion about the mean: Invmean \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.1"],

Cell["Invmean = N[HALL[nq]] . (phaseinvert .N[ HALL[nq]]);", "Input",
 CellTags->"b:1.1.1"],

Cell["The Grover operator is thus:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.1"],

Cell["G = N[Invmean . OracleG];", "Input",
 CellTags->"b:1.1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: Apply the Grover Operator ntry times", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:10", "b:1.1.2"}],

Cell["\<\
Apply G   nG Times to obtain the final density matrix \[Rho]F [ nG ]=rhF[nG]. \
The definition is 
done recursively:  \
\>", "Text",
 CellChangeTimes->{{3.512212701889825*^9, 3.512212707838779*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:1.1.2"],

Cell["\<\
rhF[0] = N[rh1];
rhF[nG_] := rhF[nG] = G . (rhF[nG-1] . (Adj[G]))\
\>", "Input",
 CellChangeTimes->{{3.512212713102189*^9, 3.5122127333771*^9}},
 CellTags->"b:1.1.2"],

Cell["\<\
The number of times we apply the Grover operator is defined here:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ntry", "=", 
  RowBox[{
   RowBox[{"IntegerPart", "[", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"Length", "[", "f", "]"}], "]"}], "]"}], "-", "4"}]}]], "Input",
 CellTags->"b:1.1.2"],

Cell[BoxData[
 TagBox["4",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159875386298113`*^9},
 CellTags->"b:1.1.2"]
}, Open  ]],

Cell["Get final density matrix after ntry iterations.", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Z", "=", 
   RowBox[{"rhF", "[", "ntry", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.512212740566826*^9, 3.512212741403082*^9}},
 CellTags->"b:1.1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 4: Analyze results", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:11", "b:1.1.3"}],

Cell["\<\
Take Trace for Projective Measurements using Tr  [ | n \[RightAngleBracket]\
\[LeftAngleBracket] n |  \[Rho] ] = \[LeftAngleBracket] n | \[Rho] | n \
\[RightAngleBracket] directly.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Clear", "[", "R", "]"}], ";", 
   RowBox[{"R", ":=", 
    RowBox[{"N", "[", 
     RowBox[{"Table", "[", " ", 
      RowBox[{
       RowBox[{"Z", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "i"}], "]"}], "]"}], " ", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "nx"}], "}"}]}], "]"}], "]"}], 
    " "}]}]}]], "Input",
 CellTags->"b:1.1.3"],

Cell["Look at results", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"probsearch", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", "  ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"R", "[", 
        RowBox[{"[", " ", "i", "]"}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "nx"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellTags->"b:1.1.3"],

Cell["Plot the possible results with their probabilities:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"probsearch", ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "0.025`", "]"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1.`"}], "}"}]}]}], "]"}]], "Input",
 CellTags->{"ListPlot", "b:1.1.3"}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.025], 
     AbsoluteThickness[1.6], PointBox[CompressedData["
1:eJxdzjsKAjEURuEfK0sLCwsLFREREcf3cxLfz1FxCYK1W5jluCsXYGNrp2FE
mBPIDd89TfKX2/makGS/173ReRk3w/vT/y1s3Ek4BafhDJyFc3ABLsIluAxX
4Cpcg+uw5+wF74eJ3EBvwi24DXfgLtyD+/AAHsIj/HeM7sMGtnGHsCbosKbo
sGbosObosBbosJbosFbosNbosDbosLbosHbosPbosAJ0WAd0WEd0WKe/P0gf
vfU=
      "]]}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0., 64.}, {0, 1.}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {0, 0}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159874234525957`*^9, 3.61598754653301*^9},
 CellTags->{"ListPlot", "b:1.1.3"}]
}, Open  ]],

Cell["Find the highest probabilities from the table", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"val", "=", 
  RowBox[{"Max", "[", "probsearch", "]"}]}]], "Input",
 CellTags->"b:1.1.3"],

Cell[BoxData[
 TagBox["0.499591157771647`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159874235394917`*^9, 3.6159875533602257`*^9},
 CellTags->"b:1.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"grover", " ", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Position", "[", 
    RowBox[{"probsearch", ",", 
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"val", "-", ".01"}], ")"}], "<", "#", "<", 
         RowBox[{"(", 
          RowBox[{"val", "+", ".01"}], ")"}]}], "&"}], ")"}]}]}], "]"}], 
   "]"}]}]], "Input",
 CellTags->{"Ordering", "b:1.1.3"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"17"},
      {"28"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6159874237475023`*^9, 3.615987553396874*^9},
 CellTags->{"Ordering", "b:1.1.3"}]
}, Open  ]],

Cell["Compare to the \"unknown\"  marked state as stored in f ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:1.1.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"[", "s", "]"}], "]"}], "==", "1"}], ",", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<marked item is number=\>\"", ",", "s", ",", 
        "\"\<    \n          Grover search found=\>\"", ",", "grover"}], 
       "]"}], ",", "\"\<\>\""}], "]"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "1", ",", 
     RowBox[{"Length", "[", "f", "]"}]}], "}"}]}], "]"}]], "Input",
 CellTags->"b:1.1.3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"marked item is number=\"\>", "\[InvisibleSpace]", "17", 
   "\[InvisibleSpace]", "\<\"    \\n          Grover search found=\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"17", ",", "28"}], "}"}]}],
  SequenceForm[
  "marked item is number=", 17, "    \n          Grover search found=", {17, 
   28}],
  Editable->False]], "Print",
 CellChangeTimes->{3.6159875582413816`*^9},
 CellTags->"b:1.1.3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"marked item is number=\"\>", "\[InvisibleSpace]", "28", 
   "\[InvisibleSpace]", "\<\"    \\n          Grover search found=\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"17", ",", "28"}], "}"}]}],
  SequenceForm[
  "marked item is number=", 28, "    \n          Grover search found=", {17, 
   28}],
  Editable->False]], "Print",
 CellChangeTimes->{3.61598755824339*^9},
 CellTags->"b:1.1.3"]
}, Open  ]],

Cell["Quit", "Input",
 CellTags->"b:1.1.3"],

Cell[TextData[{
 "Last Version: 18-Aug-2005\n",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{"References", ":"}], 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"[", "1", "]"}], " ", 
         RowBox[{"Lov", ".", " ", "K", ".", " ", "Grover"}]}], ",", " ", 
        RowBox[{
         RowBox[{"Phys", ".", " ", "Rev", ".", " ", "Lett", ".", " ", "79"}], 
         " ", 
         RowBox[{"(", "1997", ")"}], " ", "325"}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", "QDENSITY", " ", "manual"}], ",", " ", 
        RowBox[{"Sect", ".", " ", "8"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
      "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}], TraditionalForm]], 
  "DefinitionBox",
  GridBoxOptions->{
  GridBoxDividers->{
   "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
    "RowsIndexed" -> {}},
  GridBoxSpacings->{"Columns" -> {
      Offset[0.27999999999999997`], {
       Offset[0.5599999999999999]}, 
      Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
      Offset[0.2], {
       Offset[0.16]}, 
      Offset[0.2]}, "RowsIndexed" -> {}}},
  CellTags->"S5.1.1"]
}], "Abstract",
 CellTags->"b:1.1.3"]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->{},
WindowSize->{1117, 739},
WindowMargins->{{277, Automatic}, {Automatic, 68}},
PrintingStartingPageNumber->39,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"home", "bruno", "PITT", "QC"}, 
  "Test1.1.nb.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 20.212814`8.058201763306208}, {39, 
    39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 40, 40, 40, 40, 40, 40, 40, 
    40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 41, 41, 41, 41, 41, 41, 41, 41, 
    41, 41, 41, 41, 41, 41, 41, 41, 41, 41, 42, 42, 42, 42, 42, 42, 42, 42, 
    42, 42, 42, 42, 42, 42, 42, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 
    43, 43, 43, 43, 43, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 
    44, 44, 44, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45}, 
    Automatic}},
CellLabelAutoDelete->True,
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 62, 1, 51, "Title",
   CellTags->"c:1"]},
 "c:2"->{
  Cell[1120, 40, 257, 6, 51, "Section",
   CellTags->"c:2"]},
 "c:3"->{
  Cell[1402, 50, 123, 3, 58, "Subsection",
   CellTags->{"c:3", "b:1.0.0"}]},
 "b:1.0.0"->{
  Cell[1402, 50, 123, 3, 58, "Subsection",
   CellTags->{"c:3", "b:1.0.0"}],
  Cell[1528, 55, 303, 8, 79, "Text",
   CellTags->"b:1.0.0"],
  Cell[1856, 67, 105, 2, 46, "Input",
   CellTags->"b:1.0.0"],
  Cell[1964, 71, 291, 5, 22, "Print",
   CellTags->"b:1.0.0"],
  Cell[2292, 81, 84, 2, 46, "Input",
   CellTags->"b:1.0.0"],
  Cell[2379, 85, 33503, 935, 432, "Print",
   CellTags->"b:1.0.0"],
  Cell[35919, 1025, 251, 7, 62, "Input",
   CellTags->"b:1.0.0"],
  Cell[36173, 1034, 1743, 34, 127, "Output",
   CellTags->"b:1.0.0"],
  Cell[37931, 1071, 206, 7, 53, "Text",
   CellTags->"b:1.0.0"],
  Cell[38162, 1082, 538, 16, 95, "Input",
   CellTags->"b:1.0.0"],
  Cell[38703, 1100, 1032, 33, 132, "Output",
   CellTags->"b:1.0.0"],
  Cell[39750, 1136, 92, 3, 46, "Input",
   CellTags->"b:1.0.0"],
  Cell[39845, 1141, 108, 2, 23, "Text",
   CellTags->"b:1.0.0"],
  Cell[39978, 1147, 99, 3, 46, "Input",
   CellTags->"b:1.0.0"],
  Cell[40080, 1152, 272, 7, 45, "Output",
   CellTags->"b:1.0.0"],
  Cell[40367, 1162, 115, 2, 23, "Text",
   CellTags->"b:1.0.0"],
  Cell[40485, 1166, 120, 2, 23, "Text",
   CellTags->"b:1.0.0"],
  Cell[40608, 1170, 391, 12, 45, "SmallText",
   CellTags->"b:1.0.0"],
  Cell[41002, 1184, 202, 5, 45, "Input",
   CellTags->"b:1.0.0"],
  Cell[41207, 1191, 333, 10, 34, "Text",
   CellTags->"b:1.0.0"],
  Cell[41543, 1203, 155, 5, 23, "Text",
   CellTags->"b:1.0.0"],
  Cell[41701, 1210, 256, 7, 24, "Text",
   CellTags->"b:1.0.0"],
  Cell[41960, 1219, 365, 11, 46, "Input",
   CellTags->"b:1.0.0"]},
 "c:4"->{
  Cell[42362, 1235, 129, 3, 58, "Subsection",
   CellTags->{"c:4", "b:1.0.1"}]},
 "b:1.0.1"->{
  Cell[42362, 1235, 129, 3, 58, "Subsection",
   CellTags->{"c:4", "b:1.0.1"}],
  Cell[42494, 1240, 356, 9, 79, "Text",
   CellTags->"b:1.0.1"],
  Cell[42875, 1253, 97, 3, 46, "Input",
   CellTags->"b:1.0.1"],
  Cell[42975, 1258, 271, 7, 45, "Output",
   CellTags->"b:1.0.1"],
  Cell[43261, 1268, 290, 6, 24, "Text",
   CellTags->"b:1.0.1"],
  Cell[43554, 1276, 460, 15, 64, "Input",
   CellTags->"b:1.0.1"],
  Cell[44017, 1293, 455, 14, 46, "Input",
   CellTags->"b:1.0.1"],
  Cell[44475, 1309, 269, 9, 25, "Text",
   CellTags->"b:1.0.1"],
  Cell[44747, 1320, 713, 22, 46, "Input",
   CellTags->"b:1.0.1"],
  Cell[45463, 1344, 137, 4, 23, "Text",
   CellTags->"b:1.0.1"],
  Cell[45603, 1350, 89, 1, 45, "Input",
   CellTags->"b:1.0.1"],
  Cell[45695, 1353, 95, 2, 23, "Text",
   CellTags->"b:1.0.1"],
  Cell[45793, 1357, 64, 1, 45, "Input",
   CellTags->"b:1.0.1"],
  Cell[45860, 1360, 216, 5, 23, "Text",
   CellTags->"b:1.0.1"],
  Cell[46079, 1367, 229, 6, 59, "Input",
   CellTags->"b:1.0.1"]},
 "c:5"->{
  Cell[46345, 1378, 154, 4, 58, "Subsection",
   CellTags->{"c:5", "b:1.0.2"}]},
 "b:1.0.2"->{
  Cell[46345, 1378, 154, 4, 58, "Subsection",
   CellTags->{"c:5", "b:1.0.2"}],
  Cell[46502, 1384, 155, 5, 51, "Text",
   CellTags->"b:1.0.2"],
  Cell[46682, 1393, 205, 6, 46, "Input",
   CellTags->"b:1.0.2"],
  Cell[46890, 1401, 271, 7, 45, "Output",
   CellTags->"b:1.0.2"],
  Cell[47176, 1411, 111, 2, 23, "Text",
   CellTags->"b:1.0.2"],
  Cell[47290, 1415, 193, 5, 46, "Input",
   CellTags->"b:1.0.2"],
  Cell[47486, 1422, 254, 6, 23, "Text",
   CellTags->"b:1.0.2"],
  Cell[47743, 1430, 419, 14, 45, "Input",
   CellTags->"b:1.0.2"]},
 "c:6"->{
  Cell[48199, 1449, 117, 3, 58, "Subsection",
   CellTags->{"c:6", "b:1.0.3"}]},
 "b:1.0.3"->{
  Cell[48199, 1449, 117, 3, 58, "Subsection",
   CellTags->{"c:6", "b:1.0.3"}],
  Cell[48319, 1454, 79, 2, 23, "Text",
   CellTags->"b:1.0.3"],
  Cell[48401, 1458, 362, 12, 46, "Input",
   CellTags->"b:1.0.3"],
  Cell[48766, 1472, 145, 4, 23, "Text",
   CellTags->"b:1.0.3"],
  Cell[48936, 1480, 492, 13, 46, "Input",
   CellTags->{"ListPlot", "b:1.0.3"}],
  Cell[49431, 1495, 1417, 37, 218, "Output",
   CellTags->{"ListPlot", "b:1.0.3"}],
  Cell[50863, 1535, 96, 2, 23, "Text",
   CellTags->"b:1.0.3"],
  Cell[50984, 1541, 115, 3, 46, "Input",
   CellTags->"b:1.0.3"],
  Cell[51102, 1546, 292, 7, 45, "Output",
   CellTags->"b:1.0.3"],
  Cell[51409, 1556, 134, 4, 23, "Text",
   CellTags->"b:1.0.3"],
  Cell[51568, 1564, 241, 6, 46, "Input",
   CellTags->{"Ordering", "b:1.0.3"}],
  Cell[51812, 1572, 811, 22, 45, "Output",
   CellTags->{"Ordering", "b:1.0.3"}],
  Cell[52638, 1597, 119, 2, 23, "Text",
   CellTags->"b:1.0.3"],
  Cell[52782, 1603, 569, 17, 62, "Input",
   CellTags->"b:1.0.3"],
  Cell[53354, 1622, 539, 12, 37, "Print",
   CellTags->"b:1.0.3"],
  Cell[53908, 1637, 43, 1, 45, "Input",
   CellTags->"b:1.0.3"],
  Cell[53954, 1640, 1334, 38, 49, "Abstract",
   CellTags->"b:1.0.3"]},
 "ListPlot"->{
  Cell[48936, 1480, 492, 13, 46, "Input",
   CellTags->{"ListPlot", "b:1.0.3"}],
  Cell[49431, 1495, 1417, 37, 218, "Output",
   CellTags->{"ListPlot", "b:1.0.3"}],
  Cell[88162, 2784, 311, 8, 46, "Input",
   CellTags->{"ListPlot", "b:1.1.3"}],
  Cell[88476, 2794, 1188, 32, 266, "Output",
   CellTags->{"ListPlot", "b:1.1.3"}]},
 "Ordering"->{
  Cell[51568, 1564, 241, 6, 46, "Input",
   CellTags->{"Ordering", "b:1.0.3"}],
  Cell[51812, 1572, 811, 22, 45, "Output",
   CellTags->{"Ordering", "b:1.0.3"}],
  Cell[90162, 2850, 448, 14, 46, "Input",
   CellTags->{"Ordering", "b:1.1.3"}],
  Cell[90613, 2866, 731, 21, 62, "Output",
   CellTags->{"Ordering", "b:1.1.3"}]},
 "c:7"->{
  Cell[55337, 1684, 257, 6, 51, "Section",
   CellTags->"c:7"]},
 "c:8"->{
  Cell[55619, 1694, 123, 3, 58, "Subsection",
   CellTags->{"c:8", "b:1.1.0"}]},
 "b:1.1.0"->{
  Cell[55619, 1694, 123, 3, 58, "Subsection",
   CellTags->{"c:8", "b:1.1.0"}],
  Cell[55745, 1699, 303, 8, 79, "Text",
   CellTags->"b:1.1.0"],
  Cell[56073, 1711, 105, 2, 46, "Input",
   CellTags->"b:1.1.0"],
  Cell[56181, 1715, 173, 3, 22, "Print",
   CellTags->"b:1.1.0"],
  Cell[56391, 1723, 84, 2, 46, "Input",
   CellTags->"b:1.1.0"],
  Cell[56478, 1727, 18561, 493, 285, "Print",
   CellTags->"b:1.1.0"],
  Cell[75054, 2223, 144, 5, 51, "Text",
   CellTags->"b:1.1.0"],
  Cell[75223, 2232, 538, 16, 95, "Input",
   CellTags->"b:1.1.0"],
  Cell[75764, 2250, 911, 31, 132, "Output",
   CellTags->"b:1.1.0"],
  Cell[76690, 2284, 92, 3, 46, "Input",
   CellTags->"b:1.1.0"],
  Cell[76785, 2289, 108, 2, 23, "Text",
   CellTags->"b:1.1.0"],
  Cell[76918, 2295, 95, 3, 46, "Input",
   CellTags->"b:1.1.0"],
  Cell[77016, 2300, 155, 5, 45, "Output",
   CellTags->"b:1.1.0"],
  Cell[77186, 2308, 115, 2, 23, "Text",
   CellTags->"b:1.1.0"],
  Cell[77304, 2312, 120, 2, 23, "Text",
   CellTags->"b:1.1.0"],
  Cell[77427, 2316, 392, 12, 45, "SmallText",
   CellTags->"b:1.1.0"],
  Cell[77822, 2330, 568, 17, 46, "Input",
   CellTags->"b:1.1.0"],
  Cell[78393, 2349, 334, 10, 34, "Text",
   CellTags->"b:1.1.0"],
  Cell[78730, 2361, 155, 5, 23, "Text",
   CellTags->"b:1.1.0"],
  Cell[78888, 2368, 162, 4, 24, "Text",
   CellTags->"b:1.1.0"],
  Cell[79053, 2374, 394, 12, 46, "Input",
   CellTags->"b:1.1.0"]},
 "c:9"->{
  Cell[79484, 2391, 128, 3, 58, "Subsection",
   CellTags->{"c:9", "b:1.1.1"}]},
 "b:1.1.1"->{
  Cell[79484, 2391, 128, 3, 58, "Subsection",
   CellTags->{"c:9", "b:1.1.1"}],
  Cell[79615, 2396, 364, 9, 79, "Text",
   CellTags->"b:1.1.1"],
  Cell[80004, 2409, 97, 3, 46, "Input",
   CellTags->"b:1.1.1"],
  Cell[80104, 2414, 157, 5, 45, "Output",
   CellTags->"b:1.1.1"],
  Cell[80298, 2424, 677, 22, 64, "Input",
   CellTags->"b:1.1.1"],
  Cell[80978, 2448, 1499, 83, 1054, "Output",
   CellTags->"b:1.1.1"],
  Cell[82480, 2533, 1543, 85, 1054, "Output",
   CellTags->"b:1.1.1"],
  Cell[84038, 2621, 500, 16, 62, "Input",
   CellTags->"b:1.1.1"],
  Cell[84541, 2639, 193, 5, 23, "Text",
   CellTags->"b:1.1.1"],
  Cell[84737, 2646, 148, 5, 45, "Input",
   CellTags->"b:1.1.1"],
  Cell[84888, 2653, 137, 4, 23, "Text",
   CellTags->"b:1.1.1"],
  Cell[85028, 2659, 91, 1, 45, "Input",
   CellTags->"b:1.1.1"],
  Cell[85122, 2662, 92, 2, 23, "Text",
   CellTags->"b:1.1.1"],
  Cell[85217, 2666, 64, 1, 45, "Input",
   CellTags->"b:1.1.1"]},
 "c:10"->{
  Cell[85318, 2672, 138, 3, 58, "Subsection",
   CellTags->{"c:10", "b:1.1.2"}]},
 "b:1.1.2"->{
  Cell[85318, 2672, 138, 3, 58, "Subsection",
   CellTags->{"c:10", "b:1.1.2"}],
  Cell[85459, 2677, 256, 7, 51, "Text",
   CellTags->"b:1.1.2"],
  Cell[85718, 2686, 176, 5, 59, "Input",
   CellTags->"b:1.1.2"],
  Cell[85897, 2693, 137, 4, 23, "Text",
   CellTags->"b:1.1.2"],
  Cell[86059, 2701, 205, 6, 46, "Input",
   CellTags->"b:1.1.2"],
  Cell[86267, 2709, 156, 5, 45, "Output",
   CellTags->"b:1.1.2"],
  Cell[86438, 2717, 111, 2, 23, "Text",
   CellTags->"b:1.1.2"],
  Cell[86552, 2721, 189, 5, 46, "Input",
   CellTags->"b:1.1.2"]},
 "c:11"->{
  Cell[86778, 2731, 117, 3, 58, "Subsection",
   CellTags->{"c:11", "b:1.1.3"}]},
 "b:1.1.3"->{
  Cell[86778, 2731, 117, 3, 58, "Subsection",
   CellTags->{"c:11", "b:1.1.3"}],
  Cell[86898, 2736, 252, 6, 23, "Text",
   CellTags->"b:1.1.3"],
  Cell[87153, 2744, 419, 14, 45, "Input",
   CellTags->"b:1.1.3"],
  Cell[87575, 2760, 79, 2, 23, "Text",
   CellTags->"b:1.1.3"],
  Cell[87657, 2764, 362, 12, 46, "Input",
   CellTags->"b:1.1.3"],
  Cell[88022, 2778, 115, 2, 23, "Text",
   CellTags->"b:1.1.3"],
  Cell[88162, 2784, 311, 8, 46, "Input",
   CellTags->{"ListPlot", "b:1.1.3"}],
  Cell[88476, 2794, 1188, 32, 266, "Output",
   CellTags->{"ListPlot", "b:1.1.3"}],
  Cell[89679, 2829, 109, 2, 23, "Text",
   CellTags->"b:1.1.3"],
  Cell[89813, 2835, 112, 3, 46, "Input",
   CellTags->"b:1.1.3"],
  Cell[89928, 2840, 197, 5, 45, "Output",
   CellTags->"b:1.1.3"],
  Cell[90162, 2850, 448, 14, 46, "Input",
   CellTags->{"Ordering", "b:1.1.3"}],
  Cell[90613, 2866, 731, 21, 62, "Output",
   CellTags->{"Ordering", "b:1.1.3"}],
  Cell[91359, 2890, 120, 2, 23, "Text",
   CellTags->"b:1.1.3"],
  Cell[91504, 2896, 569, 17, 62, "Input",
   CellTags->"b:1.1.3"],
  Cell[92076, 2915, 460, 12, 37, "Print",
   CellTags->"b:1.1.3"],
  Cell[92539, 2929, 457, 12, 37, "Print",
   CellTags->"b:1.1.3"],
  Cell[93011, 2944, 43, 1, 45, "Input",
   CellTags->"b:1.1.3"],
  Cell[93057, 2947, 1268, 37, 49, "Abstract",
   CellTags->"b:1.1.3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 95614, 3019},
 {"c:2", 95682, 3022},
 {"c:3", 95754, 3025},
 {"b:1.0.0", 95846, 3028},
 {"c:4", 97382, 3075},
 {"b:1.0.1", 97477, 3078},
 {"c:5", 98486, 3109},
 {"b:1.0.2", 98581, 3112},
 {"c:6", 99133, 3129},
 {"b:1.0.3", 99228, 3132},
 {"ListPlot", 100444, 3167},
 {"Ordering", 100789, 3176},
 {"c:7", 101125, 3185},
 {"c:8", 101200, 3188},
 {"b:1.1.0", 101295, 3191},
 {"c:9", 102713, 3234},
 {"b:1.1.1", 102808, 3237},
 {"c:10", 103763, 3266},
 {"b:1.1.2", 103859, 3269},
 {"c:11", 104412, 3286},
 {"b:1.1.3", 104508, 3289}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 62, 1, 51, "Title",
 CellTags->"c:1"],
Cell[610, 23, 64, 0, 35, "Subtitle"],
Cell[677, 25, 267, 7, 20, "Abstract"],
Cell[947, 34, 148, 2, 22, "Text"],
Cell[CellGroupData[{
Cell[1120, 40, 257, 6, 51, "Section",
 CellTags->"c:2"],
Cell[CellGroupData[{
Cell[1402, 50, 123, 3, 58, "Subsection",
 CellTags->{"c:3", "b:1.0.0"}],
Cell[1528, 55, 303, 8, 79, "Text",
 CellTags->"b:1.0.0"],
Cell[CellGroupData[{
Cell[1856, 67, 105, 2, 46, "Input",
 CellTags->"b:1.0.0"],
Cell[1964, 71, 291, 5, 22, "Print",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2292, 81, 84, 2, 46, "Input",
 CellTags->"b:1.0.0"],
Cell[2379, 85, 33503, 935, 432, "Print",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35919, 1025, 251, 7, 62, "Input",
 CellTags->"b:1.0.0"],
Cell[36173, 1034, 1743, 34, 127, "Output",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[37931, 1071, 206, 7, 53, "Text",
 CellTags->"b:1.0.0"],
Cell[CellGroupData[{
Cell[38162, 1082, 538, 16, 95, "Input",
 CellTags->"b:1.0.0"],
Cell[38703, 1100, 1032, 33, 132, "Output",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[39750, 1136, 92, 3, 46, "Input",
 CellTags->"b:1.0.0"],
Cell[39845, 1141, 108, 2, 23, "Text",
 CellTags->"b:1.0.0"],
Cell[CellGroupData[{
Cell[39978, 1147, 99, 3, 46, "Input",
 CellTags->"b:1.0.0"],
Cell[40080, 1152, 272, 7, 45, "Output",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[40367, 1162, 115, 2, 23, "Text",
 CellTags->"b:1.0.0"],
Cell[40485, 1166, 120, 2, 23, "Text",
 CellTags->"b:1.0.0"],
Cell[40608, 1170, 391, 12, 45, "SmallText",
 CellTags->"b:1.0.0"],
Cell[41002, 1184, 202, 5, 45, "Input",
 CellTags->"b:1.0.0"],
Cell[41207, 1191, 333, 10, 34, "Text",
 CellTags->"b:1.0.0"],
Cell[41543, 1203, 155, 5, 23, "Text",
 CellTags->"b:1.0.0"],
Cell[41701, 1210, 256, 7, 24, "Text",
 CellTags->"b:1.0.0"],
Cell[41960, 1219, 365, 11, 46, "Input",
 CellTags->"b:1.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42362, 1235, 129, 3, 58, "Subsection",
 CellTags->{"c:4", "b:1.0.1"}],
Cell[42494, 1240, 356, 9, 79, "Text",
 CellTags->"b:1.0.1"],
Cell[CellGroupData[{
Cell[42875, 1253, 97, 3, 46, "Input",
 CellTags->"b:1.0.1"],
Cell[42975, 1258, 271, 7, 45, "Output",
 CellTags->"b:1.0.1"]
}, Open  ]],
Cell[43261, 1268, 290, 6, 24, "Text",
 CellTags->"b:1.0.1"],
Cell[43554, 1276, 460, 15, 64, "Input",
 CellTags->"b:1.0.1"],
Cell[44017, 1293, 455, 14, 46, "Input",
 CellTags->"b:1.0.1"],
Cell[44475, 1309, 269, 9, 25, "Text",
 CellTags->"b:1.0.1"],
Cell[44747, 1320, 713, 22, 46, "Input",
 CellTags->"b:1.0.1"],
Cell[45463, 1344, 137, 4, 23, "Text",
 CellTags->"b:1.0.1"],
Cell[45603, 1350, 89, 1, 45, "Input",
 CellTags->"b:1.0.1"],
Cell[45695, 1353, 95, 2, 23, "Text",
 CellTags->"b:1.0.1"],
Cell[45793, 1357, 64, 1, 45, "Input",
 CellTags->"b:1.0.1"],
Cell[45860, 1360, 216, 5, 23, "Text",
 CellTags->"b:1.0.1"],
Cell[46079, 1367, 229, 6, 59, "Input",
 CellTags->"b:1.0.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46345, 1378, 154, 4, 58, "Subsection",
 CellTags->{"c:5", "b:1.0.2"}],
Cell[46502, 1384, 155, 5, 51, "Text",
 CellTags->"b:1.0.2"],
Cell[CellGroupData[{
Cell[46682, 1393, 205, 6, 46, "Input",
 CellTags->"b:1.0.2"],
Cell[46890, 1401, 271, 7, 45, "Output",
 CellTags->"b:1.0.2"]
}, Open  ]],
Cell[47176, 1411, 111, 2, 23, "Text",
 CellTags->"b:1.0.2"],
Cell[47290, 1415, 193, 5, 46, "Input",
 CellTags->"b:1.0.2"],
Cell[47486, 1422, 254, 6, 23, "Text",
 CellTags->"b:1.0.2"],
Cell[47743, 1430, 419, 14, 45, "Input",
 CellTags->"b:1.0.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48199, 1449, 117, 3, 58, "Subsection",
 CellTags->{"c:6", "b:1.0.3"}],
Cell[48319, 1454, 79, 2, 23, "Text",
 CellTags->"b:1.0.3"],
Cell[48401, 1458, 362, 12, 46, "Input",
 CellTags->"b:1.0.3"],
Cell[48766, 1472, 145, 4, 23, "Text",
 CellTags->"b:1.0.3"],
Cell[CellGroupData[{
Cell[48936, 1480, 492, 13, 46, "Input",
 CellTags->{"ListPlot", "b:1.0.3"}],
Cell[49431, 1495, 1417, 37, 218, "Output",
 CellTags->{"ListPlot", "b:1.0.3"}]
}, Open  ]],
Cell[50863, 1535, 96, 2, 23, "Text",
 CellTags->"b:1.0.3"],
Cell[CellGroupData[{
Cell[50984, 1541, 115, 3, 46, "Input",
 CellTags->"b:1.0.3"],
Cell[51102, 1546, 292, 7, 45, "Output",
 CellTags->"b:1.0.3"]
}, Open  ]],
Cell[51409, 1556, 134, 4, 23, "Text",
 CellTags->"b:1.0.3"],
Cell[CellGroupData[{
Cell[51568, 1564, 241, 6, 46, "Input",
 CellTags->{"Ordering", "b:1.0.3"}],
Cell[51812, 1572, 811, 22, 45, "Output",
 CellTags->{"Ordering", "b:1.0.3"}]
}, Open  ]],
Cell[52638, 1597, 119, 2, 23, "Text",
 CellTags->"b:1.0.3"],
Cell[CellGroupData[{
Cell[52782, 1603, 569, 17, 62, "Input",
 CellTags->"b:1.0.3"],
Cell[53354, 1622, 539, 12, 37, "Print",
 CellTags->"b:1.0.3"]
}, Open  ]],
Cell[53908, 1637, 43, 1, 45, "Input",
 CellTags->"b:1.0.3"],
Cell[53954, 1640, 1334, 38, 49, "Abstract",
 CellTags->"b:1.0.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[55337, 1684, 257, 6, 51, "Section",
 CellTags->"c:7"],
Cell[CellGroupData[{
Cell[55619, 1694, 123, 3, 58, "Subsection",
 CellTags->{"c:8", "b:1.1.0"}],
Cell[55745, 1699, 303, 8, 79, "Text",
 CellTags->"b:1.1.0"],
Cell[CellGroupData[{
Cell[56073, 1711, 105, 2, 46, "Input",
 CellTags->"b:1.1.0"],
Cell[56181, 1715, 173, 3, 22, "Print",
 CellTags->"b:1.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56391, 1723, 84, 2, 46, "Input",
 CellTags->"b:1.1.0"],
Cell[56478, 1727, 18561, 493, 285, "Print",
 CellTags->"b:1.1.0"]
}, Open  ]],
Cell[75054, 2223, 144, 5, 51, "Text",
 CellTags->"b:1.1.0"],
Cell[CellGroupData[{
Cell[75223, 2232, 538, 16, 95, "Input",
 CellTags->"b:1.1.0"],
Cell[75764, 2250, 911, 31, 132, "Output",
 CellTags->"b:1.1.0"]
}, Open  ]],
Cell[76690, 2284, 92, 3, 46, "Input",
 CellTags->"b:1.1.0"],
Cell[76785, 2289, 108, 2, 23, "Text",
 CellTags->"b:1.1.0"],
Cell[CellGroupData[{
Cell[76918, 2295, 95, 3, 46, "Input",
 CellTags->"b:1.1.0"],
Cell[77016, 2300, 155, 5, 45, "Output",
 CellTags->"b:1.1.0"]
}, Open  ]],
Cell[77186, 2308, 115, 2, 23, "Text",
 CellTags->"b:1.1.0"],
Cell[77304, 2312, 120, 2, 23, "Text",
 CellTags->"b:1.1.0"],
Cell[77427, 2316, 392, 12, 45, "SmallText",
 CellTags->"b:1.1.0"],
Cell[77822, 2330, 568, 17, 46, "Input",
 CellTags->"b:1.1.0"],
Cell[78393, 2349, 334, 10, 34, "Text",
 CellTags->"b:1.1.0"],
Cell[78730, 2361, 155, 5, 23, "Text",
 CellTags->"b:1.1.0"],
Cell[78888, 2368, 162, 4, 24, "Text",
 CellTags->"b:1.1.0"],
Cell[79053, 2374, 394, 12, 46, "Input",
 CellTags->"b:1.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79484, 2391, 128, 3, 58, "Subsection",
 CellTags->{"c:9", "b:1.1.1"}],
Cell[79615, 2396, 364, 9, 79, "Text",
 CellTags->"b:1.1.1"],
Cell[CellGroupData[{
Cell[80004, 2409, 97, 3, 46, "Input",
 CellTags->"b:1.1.1"],
Cell[80104, 2414, 157, 5, 45, "Output",
 CellTags->"b:1.1.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80298, 2424, 677, 22, 64, "Input",
 CellTags->"b:1.1.1"],
Cell[80978, 2448, 1499, 83, 1054, "Output",
 CellTags->"b:1.1.1"],
Cell[82480, 2533, 1543, 85, 1054, "Output",
 CellTags->"b:1.1.1"]
}, Open  ]],
Cell[84038, 2621, 500, 16, 62, "Input",
 CellTags->"b:1.1.1"],
Cell[84541, 2639, 193, 5, 23, "Text",
 CellTags->"b:1.1.1"],
Cell[84737, 2646, 148, 5, 45, "Input",
 CellTags->"b:1.1.1"],
Cell[84888, 2653, 137, 4, 23, "Text",
 CellTags->"b:1.1.1"],
Cell[85028, 2659, 91, 1, 45, "Input",
 CellTags->"b:1.1.1"],
Cell[85122, 2662, 92, 2, 23, "Text",
 CellTags->"b:1.1.1"],
Cell[85217, 2666, 64, 1, 45, "Input",
 CellTags->"b:1.1.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85318, 2672, 138, 3, 58, "Subsection",
 CellTags->{"c:10", "b:1.1.2"}],
Cell[85459, 2677, 256, 7, 51, "Text",
 CellTags->"b:1.1.2"],
Cell[85718, 2686, 176, 5, 59, "Input",
 CellTags->"b:1.1.2"],
Cell[85897, 2693, 137, 4, 23, "Text",
 CellTags->"b:1.1.2"],
Cell[CellGroupData[{
Cell[86059, 2701, 205, 6, 46, "Input",
 CellTags->"b:1.1.2"],
Cell[86267, 2709, 156, 5, 45, "Output",
 CellTags->"b:1.1.2"]
}, Open  ]],
Cell[86438, 2717, 111, 2, 23, "Text",
 CellTags->"b:1.1.2"],
Cell[86552, 2721, 189, 5, 46, "Input",
 CellTags->"b:1.1.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86778, 2731, 117, 3, 58, "Subsection",
 CellTags->{"c:11", "b:1.1.3"}],
Cell[86898, 2736, 252, 6, 23, "Text",
 CellTags->"b:1.1.3"],
Cell[87153, 2744, 419, 14, 45, "Input",
 CellTags->"b:1.1.3"],
Cell[87575, 2760, 79, 2, 23, "Text",
 CellTags->"b:1.1.3"],
Cell[87657, 2764, 362, 12, 46, "Input",
 CellTags->"b:1.1.3"],
Cell[88022, 2778, 115, 2, 23, "Text",
 CellTags->"b:1.1.3"],
Cell[CellGroupData[{
Cell[88162, 2784, 311, 8, 46, "Input",
 CellTags->{"ListPlot", "b:1.1.3"}],
Cell[88476, 2794, 1188, 32, 266, "Output",
 CellTags->{"ListPlot", "b:1.1.3"}]
}, Open  ]],
Cell[89679, 2829, 109, 2, 23, "Text",
 CellTags->"b:1.1.3"],
Cell[CellGroupData[{
Cell[89813, 2835, 112, 3, 46, "Input",
 CellTags->"b:1.1.3"],
Cell[89928, 2840, 197, 5, 45, "Output",
 CellTags->"b:1.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90162, 2850, 448, 14, 46, "Input",
 CellTags->{"Ordering", "b:1.1.3"}],
Cell[90613, 2866, 731, 21, 62, "Output",
 CellTags->{"Ordering", "b:1.1.3"}]
}, Open  ]],
Cell[91359, 2890, 120, 2, 23, "Text",
 CellTags->"b:1.1.3"],
Cell[CellGroupData[{
Cell[91504, 2896, 569, 17, 62, "Input",
 CellTags->"b:1.1.3"],
Cell[92076, 2915, 460, 12, 37, "Print",
 CellTags->"b:1.1.3"],
Cell[92539, 2929, 457, 12, 37, "Print",
 CellTags->"b:1.1.3"]
}, Open  ]],
Cell[93011, 2944, 43, 1, 45, "Input",
 CellTags->"b:1.1.3"],
Cell[93057, 2947, 1268, 37, 49, "Abstract",
 CellTags->"b:1.1.3"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
