(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    471180,      13976]
NotebookOptionsPosition[    335910,      10393]
NotebookOutlinePosition[    439857,      12903]
CellTagsIndexPosition[    437736,      12823]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 "Teleportation ",
 StyleBox["with Density Matrices July 2014",
  FontFamily->"Helvetica"]
}], "Title",
 CellChangeTimes->{{3.61416248512105*^9, 3.6141624859101267`*^9}},
 CellTags->"c:1"],

Cell["Several Examples of Teleportation circuits", "Subtitle"],

Cell[TextData[{
 "Version: 4.0-July-2014--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9.0-10.0"
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, 
   3.512212791983045*^9, {3.6140770588712482`*^9, 3.614077073459979*^9}, {
   3.6141625203427143`*^9, 3.6141625250894213`*^9}},
 FontSize->16],

Cell[TextData[ButtonBox["Click here to get the 2014 palette: QDENSpalette.nb",
 BaseStyle->"Hyperlink",
 ButtonData:>{"QDENSpalette14.nb", None}]], "Text",
 CellChangeTimes->{{3.625185693536873*^9, 3.625185694965887*^9}},
 FontSize->16],

Cell["To open double click at down arrow", "Text",
 CellChangeTimes->{3.6251856350049047`*^9},
 FontSize->16],

Cell[CellGroupData[{

Cell["\<\
Teleportation Algorithm: One Qubit.                           To open double \
click at down arrow----------------->>\
\>", "Section",
 CellChangeTimes->{{3.512212804904114*^9, 3.512212806228137*^9}, {
  3.512214565679203*^9, 3.512214625017166*^9}},
 FontFamily->"Times",
 CellTags->"c:2"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.0.0"}],

Cell[TextData[StyleBox["Teleportation with Density Matrices July 2014 uses \
Qdensity package",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.614162472511528*^9, 3.614162510015319*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.0.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:2.0.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.625185732701585*^9, 3.625185782541073*^9, 
  3.6554026849079933`*^9, 3.657377270501914*^9},
 CellTags->"b:2.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Discord",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Discord", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Mutual",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Mutual", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["neg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "neg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Rho]$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-039b0073-7c5f-422a-a008-36b62b536edb", {
            "v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657377271096607*^9},
 CellTags->"b:4.0.0"]
}, Open  ]],

Cell[TextData[StyleBox["In the following figure we present the key \
ingredients in the teleportation process:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/1tele.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:4.0.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQdcVWUfxx9IFFA0Q0VwgRNfUwJHKhqZAzAwc2VpqGhGvirlSk3UcGYC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    "], {{0, 0}, {500, 164}}, {0, 255},
    ColorFunction->GrayLevel],
   ImageSize->{500, 164},
   PlotRange->{{0, 500}, {0, 164}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185732958137*^9, 3.625185782802306*^9, 
  3.655402685750936*^9, 3.6573772711776953`*^9},
 CellTags->"b:4.0.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["NOTE: The ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 ButtonBox["Hadamard and CNOT gates",
  BaseStyle->"Hyperlink",
  ButtonData:>{"Tutorial.nb", "Quantum Gates"}],
 StyleBox[" acting on qubits 2 and 3 are used to build the a \nprecise EPR \
state  ", "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None],
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"1", "/", 
         SqrtBox["2"]}], 
        RowBox[{"(", 
         RowBox[{"|", "00"}], "\[RightAngleBracket]"}]}], " ", "+"}], " ", 
      "|", "11"}], "\[RightAngleBracket]"}], " ", ")"}], TraditionalForm]]],
 StyleBox[", in the following the 4 different EPR states are considered", 
  "DisplayText",
  FontWeight->"Plain",
  FontVariations->{"CompatibilityType"->0},
  Background->None]
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 1: Alice prepares the state to be teleported", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.0.1"}],

Cell[TextData[StyleBox["Alice needs to specify qubit which will be teleported \
during the process. \nIn this example we construct it by choosing a random \
polarization vector:\nNote that if the magnitude of the polarization vector \
is less than 1, the state is not pure ", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 Evaluatable->False,
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"thet", "=", 
  RowBox[{"N", "[", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "\[Pi]"}], "}"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"phi", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"2", " ", "\[Pi]"}]}], "}"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"P", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.395091186351873*^9, 3.395091189108654*^9}, {
   3.5122136672080393`*^9, 3.5122136715934267`*^9}, 3.512213743667622*^9, {
   3.512214177620192*^9, 3.5122141852552834`*^9}},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["1.0388686652994208`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185732970084*^9, 3.625185782832546*^9, 
  3.655402685921468*^9, 3.6573772711907463`*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["3.754475765103738`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185732970084*^9, 3.625185782832546*^9, 
  3.655402685921468*^9, 3.657377271195067*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["0.7387480222998739`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185732970084*^9, 3.625185782832546*^9, 
  3.655402685921468*^9, 3.657377271198369*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["Therefore its cartesian components are:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell["\<\
Px = P Sin[thet] Cos[phi]
Py = P Sin[thet] Sin[phi]
Pz = P Cos[thet]\
\>", "Input",
 CellChangeTimes->{{3.51221370954722*^9, 3.512213750240114*^9}, {
  3.51221419908955*^9, 3.5122142183035192`*^9}},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", "0.5207964328478547`"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733011445*^9, 3.6251857828664513`*^9, 
  3.65540268654529*^9, 3.657377271225499*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", "0.3662339544868559`"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733011445*^9, 3.6251857828664513`*^9, 
  3.65540268654529*^9, 3.657377271229904*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["0.3746897470786258`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733011445*^9, 3.6251857828664513`*^9, 
  3.65540268654529*^9, 3.6573772712327547`*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["\<\
This example permits both an algebraic computation or a numerical one. 
This is controlled by the value of Icalc: 1 [Algebraic] / Else [Numerical]\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Icalc", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.3950912467501907`*^9, 3.395091247300149*^9}},
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Icalc", "==", "1"}], ",", 
     RowBox[{"Clear", "[", 
      RowBox[{"Px", ",", "Py", ",", "Pz"}], "]"}], ","}], " ", "]"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"Px", ",", " ", "Py", ",", " ", "Pz"}], "}"}]}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"-", "0.5207964328478547`"}]},
      {
       RowBox[{"-", "0.3662339544868559`"}]},
      {"0.3746897470786258`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733050511*^9, 3.625185782905628*^9, 
  3.655402687050151*^9, 3.657377271264493*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["\<\
Once the polarization vector has been chosen, in this case at random, we can 
write down its density matrix\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "\[Psi]"], " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     StyleBox[
      RowBox[{"1", "/", "2"}],
      FontSize->12], 
     StyleBox[")",
      FontSize->12]}], 
    StyleBox[
     RowBox[{"(", " ", 
      RowBox[{"\[DoubleStruckCapitalI]", " ", "+", " ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Px", ",", "Py", ",", "Pz"}], "}"}], ".", " ", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["\[Sigma]", "1"], ",", " ", 
          SubscriptBox["\[Sigma]", "2"], " ", ",", 
          SubscriptBox["\[Sigma]", "3"]}], "}"}]}]}], ")"}],
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12], 
  StyleBox[
   RowBox[{"Chop", "[", 
    SubscriptBox["\[Rho]", "\[Psi]"], " ", "]"}],
   FontSize->12], " "}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6873448735393128`", 
      RowBox[{
       RowBox[{"-", "0.26039821642392735`"}], "+", 
       RowBox[{"0.18311697724342796`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.26039821642392735`"}], "-", 
       RowBox[{"0.18311697724342796`", " ", "\[ImaginaryI]"}]}], 
      "0.3126551264606871`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857330774317`*^9, 3.625185782932557*^9, 
  3.655402687216379*^9, 3.657377271291587*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["\<\
If everything went ok, the density matrix should be Hermitian:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"Adj", "[", 
    SubscriptBox["\[Rho]", "\[Psi]"], "]"}], "]"}], "==", 
  RowBox[{"Chop", "[", 
   SubscriptBox["\[Rho]", "\[Psi]"], "]"}]}]], "Input",
 CellChangeTimes->{{3.614160646136724*^9, 3.61416064658626*^9}, {
  3.614160870001058*^9, 3.614160904310989*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733094253*^9, 3.625185782965308*^9, 
  3.655402687489869*^9, 3.6573772713260307`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Icalc", "\[Equal]", "0"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{"Adj", "[", 
         SubscriptBox["\[Rho]", "\[Psi]"], "]"}], "]"}], "==", 
       RowBox[{"Chop", "[", 
        SubscriptBox["\[Rho]", "\[Psi]"], "]"}]}], ",", 
      RowBox[{"Print", "[", "\"\<Hermitian\>\"", "]"}], ",", 
      RowBox[{"Print", "[", "\"\<Not Hermitian\>\"", "]"}]}], "]"}], ",", 
    "\"\<\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6141608419086742`*^9, 3.61416085892073*^9}, 
   3.614160924429037*^9, 3.6141609573540077`*^9},
 FontFamily->"Courier New",
 CellTags->"b:4.0.1"],

Cell[BoxData["\<\"Hermitian\"\>"], "Print",
 CellChangeTimes->{3.625185733199505*^9, 3.625185783073897*^9, 
  3.655402687665288*^9, 3.657377271359398*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["Its Eigenvalues, Trace and Purity can be readily computed:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"evPsi", ":=", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["\[Rho]", "\[Psi]"], "]"}]}], ";", 
  RowBox[{"Chop", "[", "evPsi", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "\[Psi]"], " ", "]"}], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["\[Rho]", "\[Psi]"],
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]}], "Input",
 CellChangeTimes->{{3.614160974475049*^9, 3.6141609970304413`*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0.8693740111499371`"},
      {"0.130625988850063`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733214261*^9, 3.625185783098488*^9, 
  3.6554026878329268`*^9, 3.657377271391719*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733214261*^9, 3.625185783098488*^9, 
  3.6554026878329268`*^9, 3.657377271396058*^9},
 CellTags->"b:4.0.1"],

Cell[BoxData[
 TagBox["0.7728743202259873`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733214261*^9, 3.625185783098488*^9, 
  3.6554026878329268`*^9, 3.657377271398842*^9},
 CellTags->"b:4.0.1"]
}, Open  ]],

Cell["Eigenvalues should be positive", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"evPsi", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
     RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "2"}], "}"}]}], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->{"Do", "b:4.0.1"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733244299*^9, 3.625185783148966*^9, 
  3.655402688270466*^9, 3.657377271413439*^9},
 CellTags->{"Do", "b:4.0.1"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733244299*^9, 3.625185783148966*^9, 
  3.655402688270466*^9, 3.65737727141722*^9},
 CellTags->{"Do", "b:4.0.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Bob prepares the Bell state", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:4.0.2"}],

Cell["\<\
Bob needs to share a Bell state, 2 qubits, with Alice. He prepares it in the \
following way. 
First, he constructs the four density matrices needed:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "00"], " ", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "01"], " ", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "10"], " ", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "11"], " ", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6141605706763372`*^9, 3.614160576335867*^9}, {
  3.614161020496354*^9, 3.614161059948771*^9}, {3.614161184177329*^9, 
  3.614161230815668*^9}},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733262642*^9, 3.625185783182633*^9, 
  3.6554026886751537`*^9, 3.657377271443119*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733262642*^9, 3.625185783182633*^9, 
  3.6554026886751537`*^9, 3.6573772714474773`*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733262642*^9, 3.625185783182633*^9, 
  3.6554026886751537`*^9, 3.657377271450408*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733262642*^9, 3.625185783182633*^9, 
  3.6554026886751537`*^9, 3.6573772714536657`*^9},
 CellTags->"b:4.0.2"]
}, Open  ]],

Cell["\<\
The Bell state operator of qubits i and j can be decomposed into the action \
of a Hadamard 
on qubit i and a CNOT gate on qubits i and j.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Bellop", "[", 
    RowBox[{"qi_", ",", "qj_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"2", ",", "qi", ",", "qj"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"2", ",", "qi"}], "]"}]}], " "}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.2"],

Cell["\<\
NOTE: an alternative way using LEFT operator \
BellOp[qi_,qj_]:=CNOT[2,qi,qj].had[2,qi].(\[Sigma]\[CircleTimes]\
\[DoubleStruckCapitalI])\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Bellop", "[", 
  RowBox[{"1", ",", "2"}], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857333007603`*^9, 3.625185783249731*^9, 
  3.655402689316976*^9, 3.657377271481552*^9},
 CellTags->"b:4.0.2"]
}, Open  ]],

Cell["\<\
The density matrix for any of the four Bell states produced by Bob from \
qubits 2 & 3. 
Afterwards, Bob sends one of these qubits to Alice who has qubit 1 in state \
\[Psi]\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "B00"], ":=", 
   RowBox[{
    RowBox[{"Bellop", "[", 
     RowBox[{"1", ",", "2"}], "]"}], ".", 
    SubscriptBox["\[Rho]", "00"], ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"Bellop", "[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "B01"], ":=", 
   RowBox[{
    RowBox[{"Bellop", "[", 
     RowBox[{"1", ",", "2"}], "]"}], ".", 
    SubscriptBox["\[Rho]", "01"], ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"Bellop", "[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "B10"], ":=", 
   RowBox[{
    RowBox[{"Bellop", "[", 
     RowBox[{"1", ",", "2"}], "]"}], ".", 
    SubscriptBox["\[Rho]", "10"], ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"Bellop", "[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "B11"], ":=", 
   RowBox[{
    RowBox[{"Bellop", "[", 
     RowBox[{"1", ",", "2"}], "]"}], ".", 
    SubscriptBox["\[Rho]", "11"], ".", 
    RowBox[{"Adj", "[", 
     RowBox[{"Bellop", "[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.614161290983507*^9, 3.614161316896241*^9}, {
  3.6141613488568983`*^9, 3.614161377812509*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:4.0.2"],

Cell["Checks on Bell states", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  SubscriptBox["\[Rho]", "B00"],
  FontSize->24], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]", "B01"],
  FontSize->24], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]", "B10"],
  FontSize->24], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]", "B11"],
  FontSize->24]}], "Input",
 FontSize->16,
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733328494*^9, 3.62518578328163*^9, 
  3.6554026895001097`*^9, 3.657377271515456*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733328494*^9, 3.62518578328163*^9, 
  3.6554026895001097`*^9, 3.6573772715199223`*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733328494*^9, 3.62518578328163*^9, 
  3.6554026895001097`*^9, 3.6573772715230827`*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733328494*^9, 3.62518578328163*^9, 
  3.6554026895001097`*^9, 3.657377271526222*^9},
 CellTags->"b:4.0.2"]
}, Open  ]],

Cell["\<\
Bob needs to know the type of Bell state shared with Alice, either by \
preparing it himself or 
by being informed of its type by a message from Alice or from a third party \
distributor of Bell states  
In our example we pick one of the 4 Bell States at random\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ipick", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "4"}], "}"}], "]"}]}], ";"}]], "Input",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"B", " "}]], "=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"Ipick", "==", "1"}], ",", 
    SubscriptBox["\[Rho]", "B00"], ",", 
    RowBox[{"Ipick", "==", "2"}], ",", 
    SubscriptBox["\[Rho]", "B01"], ",", 
    RowBox[{"Ipick", "==", "3"}], ",", 
    SubscriptBox["\[Rho]", "B10"], ",", 
    RowBox[{"Ipick", "==", "4"}], ",", 
    SubscriptBox["\[Rho]", "B11"]}], "]"}]}]], "Input",
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857333771772`*^9, 3.625185783332048*^9, 
  3.655402690181954*^9, 3.657377271563579*^9},
 CellTags->"b:4.0.2"]
}, Open  ]],

Cell["\<\
He computes the vector and tensor polarizations of the Bell state in the \
following way:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", 
     StyleBox[
      SubscriptBox["\[Rho]", "B"],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PA",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PB",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.614161487699767*^9, 3.614161515563787*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.0.2"],

Cell["Vector polarizations are zero for Bell states", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData[{"PA", "\[IndentingNewLine]", "PB"}], "Input",
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733410487*^9, 3.6251857833652*^9, 
  3.655402690410563*^9, 3.657377271597432*^9},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733410487*^9, 3.6251857833652*^9, 
  3.655402690410563*^9, 3.657377271601972*^9},
 CellTags->"b:4.0.2"]
}, Open  ]],

Cell["Tensor polarizations for Bell state", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.2"],

Cell[CellGroupData[{

Cell[BoxData["TAB"], "Input",
 CellChangeTimes->{{3.6141615674579363`*^9, 3.614161571091181*^9}},
 CellTags->"b:4.0.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"1"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", "1"}]},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857334294977`*^9, 3.6251857833863173`*^9, 
  3.655402690718356*^9, 3.6573772716251183`*^9},
 CellTags->"b:4.0.2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: The three Qubits", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:5", "b:4.0.3"}],

Cell["\<\
The tensor product of both the qubit prepared by Alice and the Bell state \
prepared 
by Bob can be computed. The complete density matrix is then:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "C"], "=", 
  RowBox[{"Chop", "[", 
   StyleBox[" ",
    FontSize->12], 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "\[Psi]"], " ", "\[TensorProduct]", 
     SubscriptBox["\[Rho]", "B"]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.61416159145573*^9, 3.614161654740621*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.0.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.3436724367696564`", "0", "0", "0.3436724367696564`", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "+", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], "0", "0", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "+", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0.3436724367696564`", "0", "0", "0.3436724367696564`", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "+", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], "0", "0", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "+", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "-", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], "0", "0", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "-", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], 
      "0.15632756323034355`", "0", "0", "0.15632756323034355`"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "-", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], "0", "0", 
      RowBox[{
       RowBox[{"-", "0.13019910821196368`"}], "-", 
       RowBox[{"0.09155848862171398`", " ", "\[ImaginaryI]"}]}], 
      "0.15632756323034355`", "0", "0", "0.15632756323034355`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857334606667`*^9, 3.6251857834152317`*^9, 
  3.6554026909052896`*^9, 3.657377271641837*^9},
 CellTags->"b:4.0.3"]
}, Open  ]],

Cell["We check its length and Trace:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  StyleBox[
   SubscriptBox["\[Rho]", "C"],
   FontSize->12], 
  StyleBox["]",
   FontSize->12]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.3"],

Cell[BoxData[
 TagBox["8",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733475905*^9, 3.625185783432536*^9, 
  3.655402691177394*^9, 3.657377271675487*^9},
 CellTags->"b:4.0.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    StyleBox[
     SubscriptBox["\[Rho]", "C"],
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.3"],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857335104237`*^9, 3.6251857834667473`*^9, 
  3.655402691344146*^9, 3.657377271881908*^9},
 CellTags->"b:4.0.3"]
}, Open  ]],

Cell[TextData[{
 "The Trace of ",
 Cell[BoxData[
  StyleBox[
   SubscriptBox["\[Rho]", "C"],
   FontSize->12]],
  FontFamily->"Helvetica"],
 "squared is a meassure of the purity of the state of the whole system:"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "C"], 
     StyleBox[".",
      FontSize->12], 
     SubscriptBox["\[Rho]", "C"]}], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.3"],

Cell[BoxData[
 TagBox["0.7728743202259873`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733543614*^9, 3.625185783499*^9, 
  3.6554026915273657`*^9, 3.6573772718974857`*^9},
 CellTags->"b:4.0.3"]
}, Open  ]],

Cell["\<\
Finally we check its eigenvalues are positive as they should be:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"evC", ":=", 
   RowBox[{"Eigenvalues", "[", 
    StyleBox[
     SubscriptBox["\[Rho]", "C"],
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"evC", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
     RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", 
     RowBox[{"Length", "[", "evC", "]"}]}], "}"}]}], "]"}]}], "Input",
 FontFamily->"Courier New",
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271925973*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271929967*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271932542*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.6573772719352217`*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271937994*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271940626*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271943283*^9},
 CellTags->{"Do", "b:4.0.3"}],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733577161*^9, 3.6251857835325823`*^9, 
  3.655402691686316*^9, 3.657377271945953*^9},
 CellTags->{"Do", "b:4.0.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 4: Bob sends qubit 2 to Alice", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:6", "b:4.0.4"}],

Cell["\<\
Alice, now receives one qubit from Bob and performs the following operations. \
Let us remind that the labelling is 
now: 
\tQubit 1: Original unknown qubit Alice wants to teleport
\tQubit 2: Qubit that Bob is sending her from the EPR pair
\tQubit 3: Bob's qubit that was in a Bell state with Qubit 2
\
\>", "Text",
 TextJustification->0,
 FontFamily->"Helvetica",
 CellTags->"b:4.0.4"],

Cell["\<\
Now Alice performs a series of operations with her original qubit and the one \
received from Bob.
CNOT on Alice's Qubits 1,2; 
Followed by Hadamard on qubit 1, 
whereby Alice entangles her original qubit with one of the shared ones\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 RowBox[{"Three", " ", "qubit", " ", "density", "  ", "is", " ", "now", " ", 
  "denoted", " ", "by", " ", 
  SubscriptBox["\[Rho]", "T"]}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "T"], "=", 
   RowBox[{
    RowBox[{"had", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    StyleBox[
     SubscriptBox["\[Rho]", "C"],
     FontSize->12], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}]}], ";"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Some", " ", "Checks", " ", "on", " ", 
   SubscriptBox["\[Rho]", "T"]}], ",", " ", "Trace", ",", " ", "purity", ",", 
  " ", 
  RowBox[{"eigenvalues", " ", "and", " ", 
   RowBox[{"length", "."}]}]}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "T"], "]"}], "]"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "T"], ".", 
     SubscriptBox["\[Rho]", "T"]}], "]"}], "]"}], "]"}]}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 TagBox["0.9999999999999999`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733631421*^9, 3.6251857836326227`*^9, 
  3.655402692986524*^9, 3.65737727198204*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData[
 TagBox["0.7728743202259871`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733631421*^9, 3.6251857836326227`*^9, 
  3.655402692986524*^9, 3.657377271986211*^9},
 CellTags->"b:4.0.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"evF", ":=", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["\[Rho]", "T"], "]"}]}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{"evF", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], ",", 
      RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
      RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "evF", "]"}]}], "}"}]}], "]"}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.657377272008531*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.657377272012546*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.6573772720152693`*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.657377272017887*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.6573772720205*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.657377272023074*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.6573772720259867`*^9},
 CellTags->"b:4.0.4"],

Cell[BoxData["\<\"Positive eigenvalue\"\>"], "Print",
 CellChangeTimes->{3.625185733661241*^9, 3.625185783683856*^9, 
  3.655402693287449*^9, 3.6573772720286922`*^9},
 CellTags->"b:4.0.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "T"], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 TagBox["8",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857337115717`*^9, 3.625185783732316*^9, 
  3.6554026946651506`*^9, 3.657377272060317*^9},
 CellTags->"b:4.0.4"]
}, Open  ]],

Cell[TextData[{
 "Four Projection Operators for Qubits 1 and 2 are used for ",
 ButtonBox["projective measurements",
  BaseStyle->"Hyperlink",
  ButtonData:>{"Tutorial.nb", None}],
 " on Qubits 1 & 2 by Alice"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.4"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_"}]], "  ", ":=", "  ", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "a"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "b"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614161749948984*^9, 3.614161762882802*^9}},
 CellTags->"b:4.0.4"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    SubscriptBox["P", 
     RowBox[{"0", ",", "0"}]], ";"}], "\n", " ", 
   RowBox[{
    SubscriptBox["P", 
     RowBox[{"0", ",", "1"}]], " ", ";"}], " ", "\[IndentingNewLine]", " ", 
   RowBox[{
    SubscriptBox["P", 
     RowBox[{"1", ",", "0"}]], " ", ";"}], "\n", " ", 
   RowBox[{
    SubscriptBox["P", 
     RowBox[{"1", ",", "1"}]], ";"}]}]}]], "Input",
 CellChangeTimes->{3.614161737425476*^9, 3.614161772387948*^9},
 FontFamily->"Courier New",
 CellTags->"b:4.0.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 5: Alice measures the state of her Qubits", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:7", "b:4.0.5"}],

Cell[TextData[{
 "After receiving the qubit form Bob and performing the abovementioned \
operations, \nshe measures the state of her two qubits obtaining values: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "a"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["a", "b"], TraditionalForm]]],
 ". Bob's  Density Matrix, \nafter Alice measures is computed:"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["a", "A"], "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["a", "B"], "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}]}], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "Bob"], "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", " ", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"4", "*", 
     RowBox[{
      SubscriptBox["P", 
       RowBox[{"a", ",", "b"}]], ".", 
      SubscriptBox["\[Rho]", "T"], ".", 
      SubscriptBox["P", 
       RowBox[{"a", ",", "b"}]]}]}]}], "]"}], " "}]], "Input",
 CellTags->"b:4.0.5"],

Cell["\<\
Qubit 3 has no polarization, but if Alice makes a measurement, its state is \
delineated \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Chop", "[", " ", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", " ", 
     SubscriptBox["\[Rho]", "T"]}], "]"}], "]"}], " "}]], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.49999999999999994`", "0"},
     {"0", "0.49999999999999994`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733756298*^9, 3.625185783799244*^9, 
  3.6554026949574213`*^9, 3.657377272119071*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Rho]", "Bob"], "[", 
      RowBox[{"0", ",", "0"}], "]"}], "+", 
     RowBox[{
      SubscriptBox["\[Rho]", "Bob"], "[", 
      RowBox[{"0", ",", "1"}], "]"}], "+", 
     RowBox[{
      SubscriptBox["\[Rho]", "Bob"], "[", 
      RowBox[{"1", ",", "0"}], "]"}], "+", 
     RowBox[{
      SubscriptBox["\[Rho]", "Bob"], "[", 
      RowBox[{"1", ",", "1"}], "]"}]}], "]"}], "/", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.6141618085671673`*^9, 3.614161812639009*^9}},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.4999999999999999`", "0"},
     {"0", "0.4999999999999999`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733778392*^9, 3.625185783816663*^9, 
  3.6554026950997953`*^9, 3.657377272135251*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Ipick"], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733793648*^9, 3.625185783849825*^9, 
  3.655402695272773*^9, 3.657377272159704*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "[", 
  RowBox[{"0", ",", "0"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "[", 
  RowBox[{"0", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "[", 
  RowBox[{"1", ",", "0"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "[", 
  RowBox[{"1", ",", "1"}], "]"}]}], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6873448735393127`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.31265512646068705`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733827499*^9, 3.625185783882029*^9, 
  3.655402695453474*^9, 3.657377272177175*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.31265512646068705`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.6873448735393127`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733827499*^9, 3.625185783882029*^9, 
  3.655402695453474*^9, 3.657377272181728*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6873448735393127`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2603982164239273`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.2603982164239273`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.31265512646068705`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733827499*^9, 3.625185783882029*^9, 
  3.655402695453474*^9, 3.6573772721852407`*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.31265512646068705`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2603982164239273`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.2603982164239273`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.6873448735393127`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733827499*^9, 3.625185783882029*^9, 
  3.655402695453474*^9, 3.657377272188552*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell[TextData[{
 "Alice Classically transmits the result of her measurement to Bob (",
 Cell[BoxData[
  SubscriptBox["a", "A"]]],
 ", ",
 Cell[BoxData[
  SubscriptBox["a", "B"]]],
 ") as one of the \nfour cases \
|00\[RightAngleBracket],|01\[RightAngleBracket],|10\[RightAngleBracket] or \
|11\[RightAngleBracket]. \nBob, chooses his corresponding density matrix once \
he has received the data from Alice."
}], "Text",
 CellChangeTimes->{{3.614161830153281*^9, 3.614161833202059*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "B"], "=", 
  RowBox[{
   SubscriptBox["\[Rho]", "Bob"], "[", 
   RowBox[{
    SubscriptBox["a", "A"], ",", 
    SubscriptBox["a", "B"]}], "]"}]}]], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.31265512646068705`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.6873448735393127`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251857338616667`*^9, 3.62518578393293*^9, 
  3.655402696216761*^9, 3.657377272209396*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell["\<\
Also need to know the type of Bell state shared marked by Ipick\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell["Ipick", "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733876893*^9, 3.6251857839656897`*^9, 
  3.655402696391164*^9, 3.657377272224655*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell["\<\
Then he will need to perform rotations which will be made of:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["S", 
   RowBox[{"i_", " ", ",", "j_", " "}]], "  ", ":=", "  ", 
  RowBox[{
   SubscriptBox["\[Sigma]", "i"], " ", ".", "  ", 
   SubscriptBox["\[Sigma]", "j"]}]}]], "Input",
 CellTags->"b:4.0.5"],

Cell["\<\
Here we detail the four possibilities explicitly:
\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[TextData[{
 StyleBox["If Qubits 1 & 2 are in |00> State:Bob",
  FontWeight->"Bold"],
 "\n        Ipick=1 (Does Nothing)\n        Ipick=2 (rotates about x-axis  )\n\
        Ipick=3 (rotates about the z-axis)\n        Ipick=4 (rotates about \
x-axis and then the z-axis )\n                and would have the following \
polarization for his qubit 3\n      \n",
 StyleBox["If Qubits 1 & 2 are in |01> State:Bob",
  FontWeight->"Bold"],
 "\n        Ipick=1 (rotates about x-axis )\n        Ipick=2 (Does Nothing)\n \
       Ipick=3 (rotates about x-axis and then the z-axis)\n        Ipick=4 \
(rotates about the z-axis)\n                 and would have the following \
polarization for his qubit 3   \n\n",
 StyleBox["If Qubits 1 & 2 are in |10> State:Bob",
  FontWeight->"Bold"],
 "\n        Ipick=1 (rotates about the z-axis)\n        Ipick=2 (rotates \
about x-axis and then the z-axis)\n        Ipick=3 (Does Nothing)\n        \
Ipick=4 (rotates about x-axis)\n                 and would have the following \
polarization for his qubit 3           \n\n",
 StyleBox["If Qubits 1 & 2 are in |11> State:Bob",
  FontWeight->"Bold"],
 "\n        Ipick=1 (rotates about x-axis and then the z-axis)\n        \
Ipick=2 (rotates about the z-axis)\n        Ipick=3 (rotates about x-axis )\n \
       Ipick=4 (Does Nothing)\n                and would have the following \
polarization for his qubit 3"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Rot", "=", 
  RowBox[{"Which", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox["a", "A"], ",", 
       SubscriptBox["a", "B"]}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], ",", " ", 
    RowBox[{"Which", "[", " ", 
     RowBox[{
      RowBox[{"Ipick", "\[Equal]", "1"}], ",", 
      SubscriptBox["S", 
       RowBox[{"0", " ", ",", "0"}]], ",", 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "2"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"1", ",", " ", "0"}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "3"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{" ", 
         RowBox[{"3", ",", "0"}]}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "4"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"3", ",", "1"}]],
       FontSize->12]}], 
     StyleBox["]",
      FontSize->12]}], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{
       SubscriptBox["a", "A"], ",", 
       SubscriptBox["a", "B"]}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], ",", " ", 
    RowBox[{"Which", "[", " ", 
     RowBox[{
      RowBox[{"Ipick", "\[Equal]", "1"}], ",", 
      SubscriptBox["S", 
       RowBox[{"1", " ", ",", "0"}]], ",", 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "2"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"0", ",", " ", "0"}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "3"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{" ", 
         RowBox[{"3", ",", "1"}]}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "4"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"3", ",", "0"}]],
       FontSize->12]}], 
     StyleBox["]",
      FontSize->12]}], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    StyleBox[
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["a", "A"], ",", 
        SubscriptBox["a", "B"]}], "}"}], "==", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}],
     FontSize->12], ",", " ", 
    RowBox[{"Which", "[", " ", 
     RowBox[{
      RowBox[{"Ipick", "\[Equal]", "1"}], ",", 
      SubscriptBox["S", 
       RowBox[{"0", " ", ",", "3"}]], ",", 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "2"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"3", ",", " ", "1"}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "3"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{" ", 
         RowBox[{"0", ",", "0"}]}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "4"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"1", ",", "0"}]],
       FontSize->12]}], 
     StyleBox["]",
      FontSize->12]}], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{
       SubscriptBox["a", "A"], ",", 
       SubscriptBox["a", "B"]}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], ",", 
    RowBox[{"Which", "[", " ", 
     RowBox[{
      RowBox[{"Ipick", "\[Equal]", "1"}], ",", 
      SubscriptBox["S", 
       RowBox[{"1", " ", ",", "3"}]], ",", 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "2"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"3", ",", " ", "0"}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "3"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{" ", 
         RowBox[{"1", ",", "0"}]}]],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       RowBox[{"Ipick", "\[Equal]", "4"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      StyleBox[
       SubscriptBox["S", 
        RowBox[{"0", ",", "0"}]],
       FontSize->12]}], 
     StyleBox["]",
      FontSize->12]}]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"Adj", "[", "Rot", "]"}], "\n", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Rot", ".", 
     SubscriptBox["\[Rho]", "B"], ".", 
     RowBox[{"Adj", "[", "Rot", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"Chop", "[", 
  RowBox[{"Simplify", "[", "X", "]"}], "]"}], "\n", 
 RowBox[{"Chop", "[", 
  SubscriptBox["\[Rho]", "B"], "]"}]}], "Input",
 CellChangeTimes->{{3.614161920973034*^9, 3.614161936789051*^9}},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733916149*^9, 3.6251857840688133`*^9, 
  3.655402696567751*^9, 3.657377272277279*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733916149*^9, 3.6251857840688133`*^9, 
  3.655402696567751*^9, 3.657377272281941*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6873448735393127`", 
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      "0.31265512646068705`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733916149*^9, 3.6251857840688133`*^9, 
  3.655402696567751*^9, 3.657377272285492*^9},
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.31265512646068705`", 
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "-", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.2603982164239273`"}], "+", 
       RowBox[{"0.1831169772434279`", " ", "\[ImaginaryI]"}]}], 
      "0.6873448735393127`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185733916149*^9, 3.6251857840688133`*^9, 
  3.655402696567751*^9, 3.65737727228869*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell["\<\
... finally, Bob, extracts the polarization for his 3 qubit
and gets....\
\>", "DisplayText",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PFINAL", "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Simplify", "[", " ", 
      RowBox[{"Tr", "[", 
       RowBox[{"X", ".", 
        SubscriptBox["\[Sigma]", "1"]}], "]"}], "]"}], ",", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Tr", "[", 
       RowBox[{"X", ".", 
        SubscriptBox["\[Sigma]", "2"]}], "]"}], "]"}], ",", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Tr", "[", 
       RowBox[{"X", ".", 
        SubscriptBox["\[Sigma]", "3"]}], "]"}], "]"}]}], "}"}], 
   "]"}]}]], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"-", "0.5207964328478546`"}]},
      {
       RowBox[{"-", "0.3662339544868558`"}]},
      {"0.3746897470786257`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.62518573396122*^9, 3.625185784131157*^9, 
  3.6554026972463617`*^9, 3.6573772723040333`*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell["\<\
... which you can now compare to the original
state in the hands of Alice:\
\>", "DisplayText",
 FontFamily->"Helvetica",
 CellTags->"b:4.0.5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Px", ",", "Py", ",", "Pz"}], "}"}]], "Input",
 CellTags->"b:4.0.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"-", "0.5207964328478547`"}]},
      {
       RowBox[{"-", "0.3662339544868559`"}]},
      {"0.3746897470786258`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.62518573399466*^9, 3.6251857841478157`*^9, 
  3.65540269741842*^9, 3.657377272326808*^9},
 CellTags->"b:4.0.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"Px", ",", "Py", ",", "Pz"}], "}"}], "==", "PFINAL"}]], "Input",
 CellChangeTimes->{{3.614162232075718*^9, 3.614162239590818*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185734028225*^9, 3.625185784182538*^9, 
  3.6554026975745087`*^9, 3.657377272343238*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6141623245441437`*^9, 3.614162326942347*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Two qubit teleportation algorithm using 6 qubits.       To open double click \
at down arrow----------------->>\
\>", "Section",
 CellChangeTimes->{{3.512212808903927*^9, 3.512212836239826*^9}, {
  3.512214568142479*^9, 3.512214572092629*^9}, {3.512214618478846*^9, 
  3.512214627667285*^9}},
 FontFamily->"Times",
 CellTags->"c:8"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.1.0"}],

Cell[TextData[StyleBox["Uses the Qdensity package:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:4.1.0"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.1.0"],

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.1.0"],

Cell[TextData[StyleBox["We set the number of Qubits to 6", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", "6"}], ";"}]], "Input",
 CellTags->"b:4.1.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/2teleport.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:4.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 1: Alice  prepares the two qubit state to be teleported and a four qubit \
entangled state is provided\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:9", "b:4.1.1"}],

Cell[TextData[StyleBox["We prepare a random two qubit state. First a random \
one qubit state is prepared.", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.1"],

Cell[BoxData[
 RowBox[{"a", "=", "RandomQubit1"}]], "Input",
 CellTags->"b:4.1.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "AB"], "=", "RandomQubit2"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PA", "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], "  ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "1"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "0"]}], "]"}]}], "]"}], ",", 
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], "  ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "2"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "0"]}], "]"}]}], "]"}], " ", ",", 
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], "  ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "3"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "0"]}], "]"}]}], "]"}]}], " ", "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PB", "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], " ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "0"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "1"]}], "]"}]}], "]"}], ",", 
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], " ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "0"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "2"]}], "]"}]}], "]"}], " ", ",", " ", 
      RowBox[{"Tr", "[", 
       RowBox[{
        SubscriptBox["\[Rho]", "AB"], " ", ".", 
        RowBox[{"AF", "[", 
         RowBox[{
          SubscriptBox["\[Sigma]", "0"], " ", "\[TensorProduct]", " ", 
          SubscriptBox["\[Sigma]", "3"]}], "]"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"T", "[", 
     RowBox[{"i", ",", "j"}], "]"}], "=", " ", 
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      RowBox[{
       SubscriptBox["\[Rho]", "AB"], " ", ".", 
       RowBox[{"AF", "[", 
        RowBox[{
         SubscriptBox["\[Sigma]", "i"], " ", "\[TensorProduct]", " ", 
         SubscriptBox["\[Sigma]", "j"]}], "]"}]}], "]"}], " ", "]"}]}]}], 
  "  "}], "\[IndentingNewLine]", "PA", "\[IndentingNewLine]", "PB"}], "Input",
 CellChangeTimes->{{3.6141626410408297`*^9, 3.614162767595152*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.1.1"],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i", ",", "j"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.614162792418023*^9, 3.614162817092474*^9}}],

Cell[TextData[StyleBox["The density matrix to be teleported and its \
eigenvalues are:", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.1"],

Cell[BoxData[{
 SubscriptBox["\[Rho]", "AB"], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Eigenvalues", "[", 
   SubscriptBox["\[Rho]", "AB"], "]"}], "]"}]}], "Input",
 CellTags->"b:4.1.1"],

Cell[TextData[{
 "We also need the ",
 StyleBox["entangled state made of qubits 3, 4, 5, and 6",
  FontWeight->"Bold"],
 " which is constructed as:"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "1"], "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OpE", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "2", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "3"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "3456"], "=", " ", 
  RowBox[{"OpE", ".", 
   SubscriptBox["\[Rho]", "1"], ".", 
   RowBox[{"Adj", "[", "OpE", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "3456"], "]"}]}], "Input",
 CellChangeTimes->{{3.614162853754754*^9, 3.614162882341107*^9}},
 CellTags->"b:4.1.1"],

Cell["Then the FULL density matrix for the \"initial\" system is:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "0"], "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "AB"], "\[TensorProduct]", 
     SubscriptBox["\[Rho]", "3456"]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "0"], "]"}]}], "Input",
 CellChangeTimes->{{3.614162904074505*^9, 3.614162921344118*^9}},
 CellTags->"b:4.1.1"],

Cell["is the full density matrix hermitian?", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.1"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"Adj", "[", 
        SubscriptBox["\[Rho]", "0"], "]"}], " ", "-", 
       SubscriptBox["\[Rho]", "0"]}], "]"}], "\[Equal]", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Length", "[", 
          SubscriptBox["\[Rho]", "0"], "]"}], ",", 
         RowBox[{"Length", "[", 
          SubscriptBox["\[Rho]", "0"], "]"}]}], "}"}]}], "]"}]}], ",", 
    RowBox[{"Print", "[", "\"\<Hermitian\>\"", "]"}], ",", 
    RowBox[{"Print", "[", "\"\<Not Hermitian\>\"", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.395092188543119*^9, 3.3950922073352137`*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Alice operates on her four qubits", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:10", "b:4.1.2"}],

Cell["\<\
Alice operations can be constructed easily in the 6 qubit space: 
[This is one of the important features of working in the Density matrix \
approach:
the mapping between the circuit in the Figure and the operations is \
straightforward] \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Bop", "[", 
    RowBox[{
    "qi_", ",", "qj_", ",", "qk_", ",", "ql_", ",", "qm_", ",", "qn_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"had", "[", 
     RowBox[{"6", ",", "qi"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"6", ",", "qj"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"6", ",", "qi", ",", "qk"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"6", ",", "qj", ",", "ql"}], "]"}]}]}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: The final state density matrix is obtained", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:11", "b:4.1.3"}],

Cell["\<\
The application of Alice operations to the initial density matrix is readily \
evaluated:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.3"],

Cell[BoxData[
 RowBox[{
  StyleBox[" ",
   FontSize->12], 
  RowBox[{
   StyleBox[
    RowBox[{
     RowBox[{
      SubscriptBox["\[Rho]", "E"], "  ", ":=", " ", 
      RowBox[{
       RowBox[{"Bop", "[", 
        RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
        "]"}], ".", 
       SubscriptBox["\[Rho]", "0"], ".", 
       RowBox[{"Adj", "[", 
        RowBox[{"Bop", "[", 
         RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
         "]"}], "]"}]}]}], ";"}],
    FontSize->12], 
   StyleBox["\[IndentingNewLine]",
    FontSize->12], 
   RowBox[{
    StyleBox["Chop",
     FontSize->12], 
    StyleBox["[",
     FontSize->12], 
    RowBox[{"Tr", "[", 
     SubscriptBox["\[Rho]", "E"], "]"}], "]"}]}]}]], "Input",
 FontFamily->"Courier New",
 FontSize->12,
 CellTags->"b:4.1.3"],

Cell["\<\
We can check that the density matrix is proper by computing its trace and the \
trace 
of it squared (Purity):\
\>", "Text",
 CellChangeTimes->{{3.61416299175251*^9, 3.614162992876379*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.1.3"],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "E"], "]"}], "]"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Purity", "[", 
    SubscriptBox["\[Rho]", "E"], "]"}], "]"}], "]"}]}], "Input",
 CellTags->"b:4.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 4: Alice measures her four qubits, 1,2,3,4", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:12", "b:4.1.4"}],

Cell["\<\
Measurements are performed by means of projection operators. The projection \
operator on qubits 1,2,3,4 is written:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.4"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}]], ":=", 
  RowBox[{
   StyleBox[
    RowBox[{"A", 
     StyleBox["F",
      ScriptLevel->0]}]], 
   StyleBox["[",
    ScriptLevel->0], 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["a",
      ScriptLevel->0]], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["b",
       ScriptLevel->0]],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["c",
       ScriptLevel->0]],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["d",
       ScriptLevel->0]],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox["\[DoubleStruckCapitalI]",
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox["\[DoubleStruckCapitalI]",
     ScriptLevel->0]}], 
   StyleBox["]",
    ScriptLevel->0]}]}]], "Input",
 CellChangeTimes->{{3.6141630068845797`*^9, 3.614163045358687*^9}},
 CellTags->"b:4.1.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 5: Bob state is computed "
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:13", "b:4.1.5"}],

Cell["\<\
Bob's two qubit state, made of qubits 5 and 6, is obtained by taking the \
partial trace of the full final state after 
Alice's measurement (here is written in general depending on the four values \
of alice measurement)\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bob", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "4"}], "*", 
       RowBox[{
        SubscriptBox["P", 
         RowBox[{"a", ",", "b", ",", "c", ",", "d"}]], ".", 
        SubscriptBox["\[Rho]", "E"], ".", 
        SubscriptBox["P", 
         RowBox[{"a", ",", "b", ",", "c", ",", "d"}]]}]}]}], " ", "]"}], 
    "]"}]}], ";"}]], "Input",
 CellTags->"b:4.1.5"],

Cell["\<\
Alice measurement is produced at random, the result of her measurement is \
P1,P2,P3,P4\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"P1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P3", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P4", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{"{", 
  RowBox[{"P1", ",", "P2", ",", "P3", ",", "P4"}], "}"}]}], "Input",
 CellTags->"b:4.1.5"],

Cell[TextData[{
 "Bob state, once Alice has ",
 StyleBox["clasically communicated",
  FontWeight->"Bold"],
 " P1,P2,P3,P4 reads:"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.5"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "=", 
  RowBox[{"Bob", "[", 
   RowBox[{"P1", ",", "P2", ",", "P3", ",", "P4"}], "]"}]}]], "Input",
 CellTags->"b:4.1.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 6: Bob performs an arranged transformation on its state to recover the \
initial state"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:14", "b:4.1.6"}],

Cell["\<\
The coding of the operations is quite compact altough it could be improved \
slightly\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"I1", "=", 
   RowBox[{
    RowBox[{"P1", "*", "2"}], "+", "P3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"I2", "=", 
   RowBox[{
    RowBox[{"P2", "*", "2"}], "+", "P4"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P1", "*", "2"}], "+", "P3"}], "\[Equal]", "2"}], ",", " ", 
    RowBox[{"I1", "=", "3"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P1", "*", "2"}], "+", "P3"}], "\[Equal]", "3"}], ",", " ", 
    RowBox[{"I1", "=", "2"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P2", "*", "2"}], "+", "P4"}], "\[Equal]", "2"}], ",", " ", 
    RowBox[{"I2", "=", "3"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P2", "*", "2"}], "+", "P4"}], "\[Equal]", "3"}], ",", " ", 
    RowBox[{"I2", "=", "2"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"TrasF", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[Sigma]", "I1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "I2"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614163091243196*^9, 3.614163105553261*^9}},
 CellTags->"b:4.1.6"],

Cell["\<\
The 2 qubit state in Bob\[CloseCurlyQuote]s hands after the transformation \
reads:\
\>", "Text",
 CellChangeTimes->{{3.614163113898999*^9, 3.6141631282411757`*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.1.6"],

Cell[BoxData[{
 RowBox[{"BobT", "=", " ", 
  RowBox[{"Chop", "[", 
   RowBox[{"TrasF", ".", 
    SubscriptBox["\[Rho]", "Bob"], ".", 
    RowBox[{"Adj", "[", "TrasF", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Eigenvalues", "[", "BobT", "]"}], "]"}]}], "Input",
 CellTags->"b:4.1.6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 7: Moment of truth, we compare both initial Alice state and final Bob \
state"
}], "Subsection",
 CellFrame->True,
 CellChangeTimes->{3.512214416691491*^9},
 FontFamily->"Times",
 CellTags->{"c:15", "b:4.1.7"}],

Cell["\<\
The 2qubit state density matrix that Bob has is characterized by :\
\>", "Text",
 CellChangeTimes->{{3.614163142146357*^9, 3.61416314275284*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.1.7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", "BobT"}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PA",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PB",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "PA", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "PB", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "TAB", "]"}]}], "Input",
 CellChangeTimes->{{3.6141631528674726`*^9, 3.614163174737708*^9}},
 CellTags->"b:4.1.7"],

Cell["\<\
...which we can compare to the original two qubit density matrix:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.1.7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", 
     SubscriptBox["\[Rho]", "AB"]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["PA",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"TT", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"TT", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"TT", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["PB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"TT", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"TT", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"TT", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TT", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"TT", "[", 
        RowBox[{"i", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "TPA", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "TPB", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", "TTAB", "]"}]}], "Input",
 CellChangeTimes->{{3.6141632084298162`*^9, 3.614163211229075*^9}},
 CellTags->"b:4.1.7"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{
   SubscriptBox["\[Rho]", "AB"], "-", "BobT"}], 
  StyleBox[" ",
   FontSize->12], 
  StyleBox["]",
   FontSize->12]}]], "Input",
 CellTags->"b:4.1.7"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 8: For completeness all one qubit partial traces are shown\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:16", "b:4.1.8"}],

Cell[BoxData[{
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"1", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"2", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"3", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"4", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "5", ",", "6"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"5", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "6"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"6", "F"}]], "=", 
   RowBox[{"Chop", "[", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
      SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}]}],
  FontSize->12]}], "Input",
 CellTags->"b:4.1.8"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Three qubit teleportation algorithm using 9 qubits.     To open double click \
at down arrow---------------->>\
\>", "Section",
 CellChangeTimes->{{3.512212824851755*^9, 3.512212842876913*^9}, {
  3.5122145762167873`*^9, 3.512214579366783*^9}, {3.512214621492093*^9, 
  3.51221463179173*^9}},
 FontFamily->"Times",
 CellTags->"c:17"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.2.0"}],

Cell[TextData[StyleBox["Uses the Qdensity package:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:4.2.0"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.2.0"],

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.2.0"],

Cell[TextData[StyleBox["We set the number of Qubits to 9", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", 
   RowBox[{"3", "*", "3"}]}], ";"}]], "Input",
 CellTags->"b:4.2.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/3teleport.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:4.2.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 1: Alice  prepares the three qubit state to be teleported\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:18", "b:4.2.1"}],

Cell["\<\
Alice builds the density matrix to be teleported. Qubits 1, 2 and 3. Here the \
teleported
state is constructed at random in the following way:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "123"], " ", "=", 
  RowBox[{"RandomQubitN", "[", "3", "]"}]}]], "Input",
 CellChangeTimes->{{3.614163357698742*^9, 3.614163383515356*^9}},
 CellTags->"b:4.2.1"],

Cell["Its trace and purity can be readily obtained:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[{
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "123"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["\[Rho]", "123"], "]"}], "]"}]}], "Input",
 CellTags->"b:4.2.1"],

Cell["And its eigenvalues:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"Eigenvalues", "[", 
   SubscriptBox["\[Rho]", "123"], "]"}], "]"}]], "Input",
 CellTags->"b:4.2.1"],

Cell[TextData[{
 "We also need to construct the entangled state of qubits 4,5,6,7,8 and 9.\n",
 StyleBox["[NOTE: The AF is needed to flatten arrays produced by built in ",
  FontWeight->"Bold"],
 "\[TensorProduct] ",
 StyleBox["]",
  FontWeight->"Bold"]
}], "Text",
 CellChangeTimes->{{3.614163412156393*^9, 3.61416347499683*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "1"], "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OpE", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"6", ",", "3", ",", "6"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"6", ",", "3"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"6", ",", "2", ",", "5"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"6", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"6", ",", "1", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"6", ",", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "3456"], "=", " ", 
   RowBox[{"N", "[", 
    RowBox[{"OpE", ".", 
     SubscriptBox["\[Rho]", "1"], ".", 
     RowBox[{"Adj", "[", "OpE", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "3456"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  RowBox[{
   SubscriptBox["\[Rho]", "3456"], ".", 
   SubscriptBox["\[Rho]", "3456"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.614163471790934*^9, 3.614163518252565*^9}},
 CellTags->"b:4.2.1"],

Cell["Then the density matrix for the \"initial\" system is:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "0"], "=", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "123"], "\[TensorProduct]", " ", 
     SubscriptBox["\[Rho]", "3456"]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Tr", "[", 
   SubscriptBox["\[Rho]", "0"], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Purity", "[", 
   RowBox[{
    SubscriptBox["\[Rho]", "0"], ".", 
    SubscriptBox["\[Rho]", "0"]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.6141635335610313`*^9, 3.614163540525235*^9}},
 CellTags->"b:4.2.1"],

Cell["is the full density matrix hermitian?", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.1"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"Adj", "[", 
        SubscriptBox["\[Rho]", "0"], "]"}], " ", "-", 
       SubscriptBox["\[Rho]", "0"]}], "]"}], "\[Equal]", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Length", "[", 
          SubscriptBox["\[Rho]", "0"], "]"}], ",", 
         RowBox[{"Length", "[", 
          SubscriptBox["\[Rho]", "0"], "]"}]}], "}"}]}], "]"}]}], ",", 
    RowBox[{"Print", "[", "\"\<Hermitian\>\"", "]"}], ",", 
    RowBox[{"Print", "[", "\"\<Not Hermitian\>\"", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.395093008447339*^9, 3.395093022757456*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.2.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: Alice operates on its four qubits", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:19", "b:4.2.2"}],

Cell["\<\
Alice operations can be constructed easily in the 6 qubit space: \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"Bop", "[", 
     RowBox[{
     "qi_", ",", "qj_", ",", "qk_", ",", "ql_", ",", "qm_", ",", "qn_", ",", 
      "qo_", ",", "qp_", ",", "qq_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"had", "[", 
      RowBox[{"9", ",", "qi"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"9", ",", "qj"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"9", ",", "qk"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"9", ",", "qi", ",", "ql"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"9", ",", "qj", ",", "qm"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"9", ",", "qk", ",", "qn"}], "]"}]}]}], ";"}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.2.2"],

Cell["(we precompile the operator)", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CompBop", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"qi", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qj", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qk", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ql", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qm", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qn", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qo", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qp", ",", "_Integer", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"qq", ",", "_Integer", ",", "0"}], "}"}]}], "}"}], ",", " ", 
     RowBox[{"Bop", "[", 
      RowBox[{
      "qi", ",", "qj", ",", "qk", ",", "ql", ",", "qm", ",", "qn", ",", "qo", 
       ",", "qp", ",", "qq"}], "]"}], " ", ",", 
     RowBox[{"{", 
      RowBox[{"{", "   ", 
       RowBox[{
        RowBox[{"Bop", "[", 
         RowBox[{
         "qi", ",", "qj", ",", "qk", ",", "ql", ",", "qm", ",", "qn", ",", 
          "qo", ",", "qp", ",", "qq"}], "]"}], ",", "_Complex", ",", "2"}], 
       "}"}], "}"}]}], "]"}]}], "  ", ";"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.2.2"],

Cell[BoxData[
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "0"], "]"}]], "Input",
 CellTags->"b:4.2.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: The final state density matrix is obtained", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:20", "b:4.2.3"}],

Cell["\<\
The application of Alice operations to the initial density matrix is readily \
evaluated:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.3"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", "E"], "  ", ":=", " ", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"CompBop", "[", 
        RowBox[{
        "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", 
         "8", ",", "9"}], "]"}], ".", 
       SubscriptBox["\[Rho]", "0"], ".", 
       RowBox[{"Adj", "[", 
        RowBox[{"CompBop", "[", 
         RowBox[{
         "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",",
           "8", ",", "9"}], "]"}], "]"}]}], "]"}]}], ";"}]}],
  FontSize->12]], "Input",
 FontFamily->"Courier New",
 FontSize->12,
 CellTags->"b:4.2.3"],

Cell["\<\
We can check that the density matrix is indeed proper by computing its 
trace and the trace of its square:\
\>", "Text",
 CellChangeTimes->{{3.6141635925303087`*^9, 3.614163607513557*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.2.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"N", "[", 
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      SubscriptBox["\[Rho]", "E"], "]"}], "]"}], "]"}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{"N", "[", 
    RowBox[{"Chop", "[", 
     RowBox[{"Tr", "[", 
      RowBox[{
       SubscriptBox["\[Rho]", "E"], ".", 
       SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}], "]"}], "*)"}]}]], "Input",
 CellTags->"b:4.2.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 4: Alice measures her four qubits, 1,2,3,4,5,6", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:21", "b:4.2.4"}],

Cell["\<\
Alice measurement is produced here at random, the result of her measurement is 
P1,P2,P3,P4,P5,P6\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.4"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"P1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P3", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P4", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P5", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P6", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{"{", 
  RowBox[{"P1", ",", "P2", ",", "P3", ",", "P4", ",", "P5", ",", "P6"}], 
  "}"}]}], "Input",
 CellTags->"b:4.2.4"],

Cell["\<\
The projection operator on qubits 1,2,3,4,5 and 6 is written:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.4"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_", ",", "e_", ",", "f_"}]], 
  "  ", ":=", " ", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "a"], "  ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "b"], "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "c"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "d"], " ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "e"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "f"], " ", "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614163624198064*^9, 3.614163673561344*^9}},
 CellTags->"b:4.2.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 5: Bob state is computed "
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:22", "b:4.2.5"}],

Cell["\<\
Bob's three qubit state, made of qubits 7, 8 and 9, is obtained by taking the 
partial trace of the full final state after Alice measurement (here is \
written in general depending on the 
six values of alice measurement)\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"time1", "=", 
   RowBox[{"SessionTime", "[", "]"}]}], ";"}]], "Input",
 CellTags->"b:4.2.5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bob", " ", "=", " ", 
   RowBox[{"Chop", "[", 
    RowBox[{"CompPTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}],
       "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "6"}], "*", 
       RowBox[{
        SubscriptBox["P", 
         RowBox[{
         "P1", ",", "P2", ",", "P3", ",", "P4", ",", "P5", ",", "P6"}]], ".", 
        SubscriptBox["\[Rho]", "E"], ".", 
        SubscriptBox["P", 
         RowBox[{
         "P1", ",", "P2", ",", "P3", ",", "P4", ",", "P5", ",", "P6"}]]}]}]}],
      " ", "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"b:4.2.5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"time2", "=", 
   RowBox[{"SessionTime", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<The computation of Bob's density matrix took \>\"", ",", 
   RowBox[{"time2", "-", "time1"}], ",", "\"\< seconds\>\""}], 
  "]"}]}], "Input",
 CellTags->"b:4.2.5"],

Cell[TextData[{
 "Bob\[CloseCurlyQuote]s state, once Alice has ",
 StyleBox["classically communicated",
  FontWeight->"Bold"],
 " P1,P2,P3,P4,P5 and P6 reads:"
}], "Text",
 CellChangeTimes->{{3.6141637086693897`*^9, 3.614163713528344*^9}},
 FontFamily->"Helvetica",
 CellTags->"b:4.2.5"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "=", "Bob"}]], "Input",
 CellTags->"b:4.2.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 6: Bob performs an arranged transformation on its state to recover the \
initial state"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:23", "b:4.2.6"}],

Cell["\<\
The coding of the operations is quite compact altough it could be improved \
slightly\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"I1", "=", 
   RowBox[{
    RowBox[{"P1", "*", "2"}], "+", "P4"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"I2", "=", 
   RowBox[{
    RowBox[{"P2", "*", "2"}], "+", "P5"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"I3", "=", 
  RowBox[{
   RowBox[{"P3", "*", "2"}], "+", "P6"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P1", "*", "2"}], "+", "P4"}], "\[Equal]", "2"}], ",", " ", 
    RowBox[{"I1", "=", "3"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P1", "*", "2"}], "+", "P4"}], "\[Equal]", "3"}], ",", " ", 
    RowBox[{"I1", "=", "2"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P2", "*", "2"}], "+", "P5"}], "\[Equal]", "2"}], ",", " ", 
    RowBox[{"I2", "=", "3"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P2", "*", "2"}], "+", "P5"}], "\[Equal]", "3"}], ",", " ", 
    RowBox[{"I2", "=", "2"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P3", "*", "2"}], "+", "P6"}], "\[Equal]", "2"}], ",", " ", 
    RowBox[{"I3", "=", "3"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P3", "*", "2"}], "+", "P6"}], "\[Equal]", "3"}], ",", " ", 
    RowBox[{"I3", "=", "2"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"TrasF", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[Sigma]", "I1"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "I2"], "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "I3"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.614163824056059*^9, 3.614163849244542*^9}},
 CellTags->"b:4.2.6"],

Cell["\<\
The three qubit state in Bob's hands after the transformation is:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.2.6"],

Cell[BoxData[{
 RowBox[{"BobT", "=", " ", 
  RowBox[{"N", "[", 
   RowBox[{"Chop", "[", 
    RowBox[{"TrasF", ".", 
     SubscriptBox["\[Rho]", "Bob"], ".", 
     RowBox[{"Adj", "[", "TrasF", "]"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Eigenvalues", "[", "BobT", "]"}], "]"}]}], "Input",
 CellTags->"b:4.2.6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 7: Moment of truth, we compare both  initial Alice and final Bob state"
}], "Subsection",
 CellFrame->True,
 CellChangeTimes->{3.512214376194934*^9},
 FontFamily->"Times",
 CellTags->{"c:24", "b:4.2.7"}],

Cell["\<\
...we can compare Bob\[CloseCurlyQuote]s three qubit state to the original \
three qubit density matrix:\
\>", "Text",
 CellChangeTimes->{3.614163769765723*^9},
 FontFamily->"Helvetica",
 CellTags->"b:4.2.7"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"BobT", " ", "-", 
   SubscriptBox["\[Rho]", "123"]}], "]"}]], "Input",
 CellTags->"b:4.2.7"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.614163777617752*^9, 3.614163777831381*^9}},
 CellTags->"b:4.2.7"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
EPR teleportation using an GHZ state.              To open double click at \
down arrow----------------------->>\
\>", "Section",
 CellChangeTimes->{{3.5122128273908653`*^9, 3.512212828065277*^9}, {
  3.512214533171061*^9, 3.512214548029138*^9}, {3.512214640729178*^9, 
  3.5122146555167294`*^9}},
 FontFamily->"Times",
 CellTags->"c:25"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.3.0"}],

Cell["\<\
 Load the Qdensity Package, defines total number of qubits and plots the \
circuit:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.625185811512411*^9},
 CellTags->"b:4.3.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167811-1893931", {"Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167811-1893931", {"FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167811-1893931", {"Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167811-1893931", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res3$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"res3$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167811-1893931", {"\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167811-1893931", {"PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {"TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167811-1893931", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.6251858116976423`*^9},
 CellTags->"b:4.3.0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", "5"}], ";"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure1", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/GHZ.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure1", "]"}]}], "Input",
 CellTags->"b:4.3.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQd8FEXfx5dQpQsvKgIKIiU8IEWBINI70glIR5BqIp1XakJvEhEQkF7k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    "], {{0, 0}, {500, 225}}, {0, 255},
    ColorFunction->GrayLevel],
   ImageSize->{500, 225},
   PlotRange->{{0, 500}, {0, 225}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858117898083`*^9},
 CellTags->"b:4.3.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Icalc=1 computes using symbols",
  FontSlant->"Italic"],
 ", anyother Icalc value performs the computation\nnumerically."
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Icalc", "=", "1"}], ";"}]], "Input",
 CellTags->"b:4.3.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 1: Alice builds the EPR state to be teleported"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:26", "b:4.3.1"}],

Cell["\<\
 The EPR state is of the form A|00\[RightAngleBracket]+B|11\
\[RightAngleBracket]. It is built by first constructing (A|0\
\[RightAngleBracket]+B|1\[RightAngleBracket])|0\[RightAngleBracket] and then 
applying a CNOT(2,1,2). The first qubit is thus generated at random in the \
following way:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell["\<\
 A general one qubit state is built by rotating the |0\[RightAngleBracket] \
state around the x axis an angle \[Theta]\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "1"], "=", "RandomQubit1"}], ";"}]], "Input",
 CellTags->"b:4.3.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Icalc", "\[Equal]", "1"}], ",", 
    RowBox[{
     SubscriptBox["\[Rho]", "1"], "=", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"A", "^", "2"}], "+", 
          RowBox[{"B", "^", "2"}]}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"A", "*", 
           RowBox[{"Ket", "[", "0", "]"}]}], "+", 
          RowBox[{"B", "*", 
           RowBox[{"Ket", "[", "1", "]"}]}]}], ")"}], "\[TensorProduct]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"A", "*", 
           RowBox[{"Bra", "[", "0", "]"}]}], "+", 
          RowBox[{"B", "*", 
           RowBox[{"Bra", "[", "1", "]"}]}]}], ")"}]}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{
  3.614173867865993*^9, {3.614173901938492*^9, 3.6141739158764677`*^9}},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       SuperscriptBox["A", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], 
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]},
     {
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], 
      FractionBox[
       SuperscriptBox["B", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185811832943*^9},
 CellTags->"b:4.3.1"]
}, Open  ]],

Cell["Then we construct the EPR state using a CNOT gate:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"OpEPR", "=", 
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "12"], "=", " ", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "1"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "EPR"], "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"OpEPR", ".", 
    SubscriptBox["\[Rho]", "12"], ".", 
    RowBox[{"Adj", "[", "OpEPR", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Tr", "[", 
   SubscriptBox["\[Rho]", "EPR"], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Tr", "[", 
   RowBox[{
    SubscriptBox["\[Rho]", "EPR"], ".", 
    SubscriptBox["\[Rho]", "EPR"]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{
  3.614173883805382*^9, {3.614173926664487*^9, 3.6141739874228067`*^9}},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       SuperscriptBox["A", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       SuperscriptBox["B", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185811849681*^9},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858118552303`*^9},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185811859827*^9},
 CellTags->"b:4.3.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Adj", "[", 
   SubscriptBox["\[Rho]", "EPR"], 
   StyleBox["  ",
    FontSize->12], "]"}], " "}], "\[IndentingNewLine]", 
 SubscriptBox["\[Rho]", 
  RowBox[{"EPR", " "}]]}], "Input",
 CellChangeTimes->{{3.6141740251088333`*^9, 3.6141740258733883`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       SuperscriptBox[
        RowBox[{"Conjugate", "[", "A", "]"}], "2"], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "A", "]"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "B", "]"}], "2"]}]], "0", "0", 
      FractionBox[
       RowBox[{"Conjugate", "[", 
        RowBox[{"A", " ", "B"}], "]"}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "A", "]"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "B", "]"}], "2"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox[
       RowBox[{"Conjugate", "[", 
        RowBox[{"A", " ", "B"}], "]"}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "A", "]"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "B", "]"}], "2"]}]], "0", "0", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"Conjugate", "[", "B", "]"}], "2"], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "A", "]"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "B", "]"}], "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185811897066*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       SuperscriptBox["A", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox[
       RowBox[{"A", " ", "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       SuperscriptBox["B", "2"], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185811904974*^9}]
}, Open  ]],

Cell["Check on Hermiticity of the EPR (only if Icalc=0)", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Icalc", "\[Equal]", "0"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"Adj", "[", 
          SubscriptBox["\[Rho]", "EPR"], 
          StyleBox["  ",
           FontSize->12], "]"}], " ", "-", 
         SubscriptBox["\[Rho]", 
          RowBox[{"EPR", " "}]]}], "]"}], "\[Equal]", 
       RowBox[{"ConstantArray", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", 
            SubscriptBox["\[Rho]", "EPR"], "]"}], ",", 
           RowBox[{"Length", "[", 
            SubscriptBox["\[Rho]", "EPR"], "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"Print", "[", "\"\<Hermitian\>\"", "]"}], ",", 
      RowBox[{"Print", "[", "\"\<Not Hermitian\>\"", "]"}]}], "]"}], ",", 
    "\"\<\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.395093222183462*^9, 3.395093242281027*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox["\<\"\"\>",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858120314093`*^9},
 CellTags->"b:4.3.1"]
}, Open  ]],

Cell["Check on Eigenvalues of the EPR", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"evEPR", ":=", 
  RowBox[{"Chop", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["\[Rho]", "EPR"], "]"}], 
   "]"}]}], "\[IndentingNewLine]", "evEPR", "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "EPR"], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "EPR"], ".", 
     SubscriptBox["\[Rho]", "EPR"]}], "]"}], "]"}], "]"}]}], "Input",
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"},
      {"1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812064465*^9},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812069799*^9},
 CellTags->"b:4.3.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858120806093`*^9},
 CellTags->"b:4.3.1"]
}, Open  ]],

Cell["Test Positivity:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Icalc", "\[Equal]", "0"}], ",", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Re", "[", 
          RowBox[{"evEPR", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
        RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", "\"\<\>\""}], 
   "]"}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->{"Do", "b:4.3.1"}],

Cell[BoxData[
 TagBox["\<\"\"\>",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858121139297`*^9},
 CellTags->{"Do", "b:4.3.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 2: The GHZ state made of qubits 345 is built"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:27", "b:4.3.2"}],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
  "Build", " ", "the", " ", "Three", " ", "Qubit", " ", "entangled", " ", 
   "state", "   ", 
   StyleBox[
    SubscriptBox["\[Rho]", "GHZ"],
    FontSize->12], "  ", 
   RowBox[{"(", " ", 
    RowBox[{"Entangled", " ", "State", " ", "Resource"}], " ", ")"}]}], " ", 
  " "}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  StyleBox[
   SubscriptBox["\[Rho]", "00"],
   FontSize->12], 
  StyleBox["=",
   FontSize->12], 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614174115769347*^9, 3.614174164559533*^9}},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812148397*^9},
 CellTags->"b:4.3.2"]
}, Open  ]],

Cell[" Generate GHZ state operator ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/gGHZ.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", "figure2", "]"}]}], "Input",
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQtYTVn/x6mUy/DKbV7MuBQmMm/GJMUQuZNruggRU4oolCS3zJAMSRcq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    "], {{0, 0}, {250, 150}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{250, 150},
   PlotRange->{{0, 250}, {0, 150}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812176059*^9},
 CellTags->"b:4.3.2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"GHZop", "[", 
   RowBox[{"qi_", ",", "qj_", ",", "qk_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qk"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qj"}], "]"}]}], ".", 
   RowBox[{"had", "[", 
    RowBox[{"3", ",", "qi"}], "]"}]}], " "}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.2"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", "GHZ"], "   ", "is", " ", "the", " ", "density", 
     " ", "matrix", "  ", "of", " ", "the", " ", "GHZ", " ", "state", " ", 
     "produced", " ", "by", " ", "Bob", "  ", 
     RowBox[{"(", 
      RowBox[{"or", " ", "Eve"}], ")"}], " ", "from", " ", "qubits", " ", 
     "3"}], ",", 
    RowBox[{
     RowBox[{"4", " ", "&"}], " ", "5"}]}], " ", "\[IndentingNewLine]", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{
     "Bob", " ", "sends", " ", "one", " ", "of", " ", "these", " ", "qubits", 
      " ", "to", " ", "Alice", " ", "who", " ", "has", " ", "qubits", " ", 
      "1"}], " ", "&"}], " ", "2", " ", "in", " ", "state", " ", 
    SubscriptBox["\[Rho]", "EPR"]}]}]}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.2"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", 
   RowBox[{
    SubscriptBox["\[Rho]", "GHZ"], "  ", ":=", 
    RowBox[{
     RowBox[{"GHZop", "[", 
      RowBox[{"1", ",", "2", ",", "3"}], "]"}], ".", 
     SubscriptBox["\[Rho]", "00"], ".", 
     RowBox[{"Adj", "[", 
      RowBox[{"GHZop", "[", 
       RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}]}]}]}],
  FontSize->12]], "Input",
 CellChangeTimes->{3.614174196620365*^9},
 FontFamily->"Courier New",
 FontSize->12,
 CellTags->"b:4.3.2"],

Cell[" Checks on GHZ states ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.2"],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox["\[Rho]", "GHZ"]], "Input",
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812217984*^9},
 CellTags->"b:4.3.2"]
}, Open  ]],

Cell["\<\
 Vector and tensor polarizations of GHZ state 
 Vector polarizations are zero for GHZ states 
 Rank 2 Tensor polarizations for GHZ state 
 Rank 3 Tensor polarizations for GHZ state \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "k"]}], "]"}], ".", 
     StyleBox[
      SubscriptBox["\[Rho]", "GHZ"],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "GHZ", 
     StyleBox["A",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0", ",", "0"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "GHZ", 
     StyleBox["B",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3", ",", "0"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    StyleBox[
     RowBox[{
      StyleBox["P",
       FontSize->12], "GHZ", 
      StyleBox["C",
       FontSize->12]}]], 
    StyleBox["=",
     FontSize->12], 
    RowBox[{
     StyleBox["{",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "0", ",", "2"}], "]"}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "0", ",", "3"}], "]"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "0"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["AC",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "0", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TGHZBC", 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "0"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["ABC",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "k"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", "PGHZA", "\[IndentingNewLine]", "PGHZB", "\
\[IndentingNewLine]", "PGHZC", "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZAB", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZAC", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZBC", ",", "1"}], 
  "]"}], "\[IndentingNewLine]", "TGHZABC"}], "Input",
 CellChangeTimes->{{3.614174221784515*^9, 3.614174251593748*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812319075*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812324827*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812329224*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0"},
     {"0", "0", "0"},
     {"0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858123341427`*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0"},
     {"0", "0", "0"},
     {"0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812338461*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0"},
     {"0", "0", "0"},
     {"0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858123432703`*^9},
 CellTags->"b:4.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1", "0", "0"},
         {"0", 
          RowBox[{"-", "1"}], "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "1"}], "0"},
         {
          RowBox[{"-", "1"}], "0", "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {"0", "0", "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812347887*^9},
 CellTags->"b:4.3.2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 3: The initial 5 qubit state"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:28", "b:4.3.3"}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "The", " ", "initial", " ", "5", " ", "qubit", " ", "density", " ", 
   "matrix", " ", "is", " ", 
   RowBox[{"thus", ":", " ", 
    StyleBox[
     SubscriptBox["\[Rho]", "I"],
     FontSize->12]}]}], 
  StyleBox["=",
   FontSize->12], 
  StyleBox[
   RowBox[{
    StyleBox[" ",
     FontSize->12], " "}]], 
  RowBox[{
   StyleBox[
    SubscriptBox["\[Rho]", "EPR"],
    FontSize->12], " ", "\[CircleTimes]", " ", 
   StyleBox[
    SubscriptBox["\[Rho]", "GHZ"],
    FontSize->12]}]}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    SubscriptBox["\[Rho]", "I"],
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   StyleBox[" ",
    FontSize->12], 
   RowBox[{"AF", "[", 
    StyleBox[" ",
     FontSize->12], 
    RowBox[{
     StyleBox[
      SubscriptBox["\[Rho]", "EPR"],
      FontSize->12], "\[TensorProduct]", 
     StyleBox[
      SubscriptBox["\[Rho]", "GHZ"],
      FontSize->12]}], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}]], "Input",
 CellChangeTimes->{{3.614174264341939*^9, 3.614174276094805*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.3.3"],

Cell[BoxData[
 RowBox[{"Checks", " ", "on", " ", "Full", " ", "Initial", "  ", 
  StyleBox[
   SubscriptBox["\[Rho]", "I"],
   FontSize->12], " ", "Density", " ", "Matrix"}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  StyleBox[
   SubscriptBox["\[Rho]", "I"],
   FontSize->12], 
  StyleBox["]",
   FontSize->12]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.3"],

Cell[BoxData[
 TagBox["32",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.62518581241441*^9},
 CellTags->"b:4.3.3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Trace", " ", "and", " ", "purity", " ", "of", "  ", 
  StyleBox[
   SubscriptBox["\[Rho]", "I"],
   FontSize->12], " ", "Density", " ", "Matrix"}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    StyleBox[
     SubscriptBox["\[Rho]", "I"],
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Purity", "[", 
   StyleBox[
    SubscriptBox["\[Rho]", "I"],
    FontSize->12], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812430629*^9},
 CellTags->"b:4.3.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812436391*^9},
 CellTags->"b:4.3.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"Icalc", "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{"evI", ":=", 
     RowBox[{"Eigenvalues", "[", 
      StyleBox[
       SubscriptBox["\[Rho]", "I"],
       FontSize->12], 
      StyleBox["]",
       FontSize->12]}]}], 
    StyleBox[";",
     FontSize->12], "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Chop", "[", 
          RowBox[{"evI", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
        RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        StyleBox[
         RowBox[{"Length", "[", "evI", "]"}],
         FontSize->12]}], "}"}]}], "]"}]}], ",", "\"\<\>\""}], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->{"Do", "b:4.3.3"}],

Cell[BoxData[
 TagBox["\<\"\"\>",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812464712*^9},
 CellTags->{"Do", "b:4.3.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 4: Alice receives qubit 3 and performs an operation on qubits 1,2,3 \
and then Measures them"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:29", "b:4.3.4"}],

Cell["\<\
Alice performs an operation defined by (see the figure above):\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AliceOp", "=", " ", 
   RowBox[{
    RowBox[{"had", "[", 
     RowBox[{"5", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"5", ",", "3", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"5", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"5", ",", "1", ",", "3"}], "]"}]}]}], ";"}]], "Input",
 CellTags->"b:4.3.4"],

Cell["\<\
 And therefore the density matrix of the 5 qubit system after Alice operation \
reads:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "T"], " ", "=", 
   RowBox[{"AliceOp", ".", 
    SubscriptBox["\[Rho]", "I"], ".", 
    RowBox[{"Adj", "[", "AliceOp", "]"}]}]}], ";"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "T"], "]"}], "]"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "T"], ".", 
     SubscriptBox["\[Rho]", "T"]}], "]"}], "]"}], "]"}]}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858125103483`*^9},
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.62518581253272*^9},
 CellTags->"b:4.3.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"Icalc", "\[Equal]", "0"}], ",", 
   RowBox[{
    RowBox[{"evF", ":=", 
     RowBox[{"Eigenvalues", "[", 
      SubscriptBox["\[Rho]", "T"], "]"}]}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Chop", "[", 
          RowBox[{"evF", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"Print", "[", "\"\<Positive eigenvalue\>\"", "]"}], ",", 
        RowBox[{"Print", "[", "\"\<Negative\>\"", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "evF", "]"}]}], "}"}]}], "]"}]}], ",", 
   "\"\<\>\""}], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["\<\"\"\>",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858125487127`*^9},
 CellTags->"b:4.3.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "T"], "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["32",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812581111*^9},
 CellTags->"b:4.3.4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_", ",", "c_"}]], "  ", ":=", " ", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "a"], " ", "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "b"], "\[TensorProduct]", "  ", 
    SubscriptBox["\[ScriptCapitalP]", "c"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]", "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614174317867028*^9, 3.614174331723187*^9}, {
  3.614174362200873*^9, 3.6141743751577263`*^9}, {3.614174694272193*^9, 
  3.614174748123382*^9}},
 CellTags->"b:4.3.4"],

Cell["\<\
Bob's 2-Qubit Density Matrix--After measurement by Alice of abc \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RhoBob", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "3."}], 
       RowBox[{
        SubscriptBox["P", 
         RowBox[{"a", ",", "b", ",", "c"}]], ".", 
        SubscriptBox["\[Rho]", "T"], ".", 
        SubscriptBox["P", 
         RowBox[{"a", ",", "b", ",", "c"}]]}]}]}], " ", "]"}], "]"}]}], 
  ";"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.3.4"],

Cell["\<\
   Alice measures 1,2,3 and gets values P1,P2,P3. 
Here we produce them at random.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"P1", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P2", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"P3", "=", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], 
  ";"}], "\n", "P1", "\n", "P2", "\n", "P3"}], "Input",
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812631744*^9},
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812637334*^9},
 CellTags->"b:4.3.4"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812641602*^9},
 CellTags->"b:4.3.4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 5: Alice sends the result of her measurement to Bob "
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:30", "b:4.3.5"}],

Cell["\<\
 Alice classically transmits P1,P2 and P3 to Bob, which has then the following 
density matrix for qubits 4 and 5:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "45"], "=", " ", 
  RowBox[{"RhoBob", "[", 
   RowBox[{"P1", ",", "P2", ",", "P3"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Tr", "[", 
   SubscriptBox["\[Rho]", "45"], "]"}], "]"}]}], "Input",
 CellTags->"b:4.3.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"1.`", " ", 
        SuperscriptBox["B", "2"]}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"1.`", " ", "A", " ", "B"}], 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}]]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox[
        RowBox[{"1.`", " ", "A", " ", "B"}], 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}]]}], "0", "0", 
      FractionBox[
       RowBox[{"1.`", " ", 
        SuperscriptBox["A", "2"]}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812744664*^9},
 CellTags->"b:4.3.5"],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858127507153`*^9},
 CellTags->"b:4.3.5"]
}, Open  ]],

Cell["\<\
 Bob, with the values of the measurements made by Alice, performs a set of 
operations on its two qubit system depending on P1,P2,P3\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.3.5"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["S", 
   RowBox[{"i_", " ", ",", "j_", "  "}]], "  ", ":=", "  ", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    SubscriptBox["\[Sigma]", "i"], " ", "\[TensorProduct]", " ", 
    SubscriptBox["\[Sigma]", "j"]}], " ", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.614174774843773*^9, 3.614174784109489*^9}},
 CellTags->"b:4.3.5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BobOp", "=", 
  RowBox[{"Which", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
    SubscriptBox["S", 
     RowBox[{"0", " ", ",", "0"}]], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], ",", " ", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"0", ",", "0"}]],
     FontSize->12], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    StyleBox[
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "==", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}],
     FontSize->12], ",", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"1", ",", "1"}]],
     FontSize->12], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"1", ",", "1"}]],
     FontSize->12], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox[
     RowBox[{
      StyleBox["                     ",
       FontSize->12], " "}]], 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], ",", 
    SubscriptBox["S", 
     RowBox[{"1", " ", ",", "2"}]], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], ",", " ", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"1", ",", "2"}]],
     FontSize->12], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    StyleBox[
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "==", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}],
     FontSize->12], ",", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"3", ",", "0"}]],
     FontSize->12], 
    StyleBox[",",
     FontSize->12], 
    StyleBox["\[IndentingNewLine]",
     FontSize->12], 
    StyleBox["                      ",
     FontSize->12], 
    RowBox[{
     RowBox[{
      StyleBox["{",
       FontSize->12], 
      RowBox[{"P1", ",", "P2", ",", "P3"}], "}"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ",", 
    StyleBox[
     SubscriptBox["S", 
      RowBox[{"3", ",", "0"}]],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}]], "Input",
 CellTags->"b:4.3.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0", "0", "\[ImaginaryI]", "0"},
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0"},
     {"\[ImaginaryI]", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812800309*^9},
 CellTags->"b:4.3.5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "BobF"], "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"BobOp", ".", 
    SubscriptBox["\[Rho]", "45"], ".", 
    RowBox[{"Adj", "[", "BobOp", "]"}]}], "]"}]}]], "Input",
 CellTags->"b:4.3.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1.`", "\[VeryThinSpace]", "+", 
          RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
        SuperscriptBox["A", "2"]}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1.`", "\[VeryThinSpace]", "+", 
          RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", "A", " ", 
        "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1.`", "\[VeryThinSpace]", "+", 
          RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", "A", " ", 
        "B"}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]], "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1.`", "\[VeryThinSpace]", "+", 
          RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
        SuperscriptBox["B", "2"]}], 
       RowBox[{
        SuperscriptBox["A", "2"], "+", 
        SuperscriptBox["B", "2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858128313627`*^9},
 CellTags->"b:4.3.5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 6: Final comparison, we compare the EPR state and the state in Bob \
hands:"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:31", "b:4.3.6"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{
   SubscriptBox["\[Rho]", "EPR"], " ", "-", 
   SubscriptBox["\[Rho]", "BobF"]}], "]"}]], "Input",
 CellTags->"b:4.3.6"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185812864389*^9},
 CellTags->"b:4.3.6"]
}, Open  ]],

Cell[BoxData["Quit"], "Input",
 CellTags->"b:4.3.6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
EPR teleportation Algorithm: (Gorbachev and Trubilko quant-ph/9906110). 
                                                                          To \
open double click at down arrow---------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.512212829391058*^9, 3.5122128614691973`*^9}, 
   3.5122145541214247`*^9},
 FontFamily->"Times",
 CellTags->"c:32"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:3", "b:4.4.0"}],

Cell[TextData[StyleBox["Uses the Qdensity package:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:4.4.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.4.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.625185833557905*^9},
 CellTags->"b:4.4.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.4.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167833-5144361", {"Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167833-5144361", {"FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167833-5144361", {"Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167833-5144361", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res3$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"res3$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info3625167833-5144361", {"\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3625167833-5144361", {"PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {"TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3625167833-5144361", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.625185833727468*^9},
 CellTags->"b:4.4.0"]
}, Open  ]],

Cell[TextData[StyleBox["We set the number of Qubits to 5", "DisplayText",
 FontWeight->"Plain",
 FontVariations->{"CompatibilityType"->0},
 Background->None]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nqx", "=", "5"}], ";"}]], "Input",
 CellTags->"b:4.4.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 1: Alice  prepares the EPR state to be teleported and the GHZ state is \
given\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:33", "b:4.4.1"}],

Cell[BoxData[
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], "]"}]}], ";", 
  RowBox[{"B", "=", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["A", "2"]}]]}], ";"}]], "Input",
 CellTags->"b:4.4.1"],

Cell["\<\
This example permits both an algebraic computation or a numerical one. This \
is controlled
by the value of Icalc: 1 [Algebraic] / Else [Numerical]\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Icalc", "=", "1"}], ";"}]], "Input",
 CellTags->"b:4.4.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"Icalc", "==", "1"}], ",", 
     RowBox[{"Clear", "[", 
      RowBox[{"A", ",", "B"}], "]"}], ","}], " ", "]"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"A", ",", " ", "B"}], "}"}]}], "Input",
 CellChangeTimes->{{3.6141748665914717`*^9, 3.6141748754448357`*^9}},
 FontFamily->"Courier New",
 CellTags->"b:4.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"A"},
      {"B"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185833767486*^9},
 CellTags->"b:4.4.1"]
}, Open  ]],

Cell["\<\
Alice builds the EPR density matrix to be teleported. Qubits 1 and 2
And we also need the GHZ state made of qubits 3, 4 and 5\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "1"], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A", "^", "2"}], ",", 
      RowBox[{"A", " ", "B"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A", " ", "B"}], ",", 
      RowBox[{"B", "^", "2"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OpEPR", "=", 
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "12"], "=", " ", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "1"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EPR", "=", 
  RowBox[{"OpEPR", ".", 
   SubscriptBox["\[Rho]", "12"], ".", 
   RowBox[{"Adj", "[", "OpEPR", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.6141748868526707`*^9, 3.614174899821587*^9}},
 CellTags->"b:4.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["A", "2"], 
      RowBox[{"A", " ", "B"}]},
     {
      RowBox[{"A", " ", "B"}], 
      SuperscriptBox["B", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858337889347`*^9},
 CellTags->"b:4.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      SuperscriptBox["A", "2"], 
      RowBox[{"A", " ", "B"}], "0"},
     {"0", 
      RowBox[{"A", " ", "B"}], 
      SuperscriptBox["B", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185833794663*^9},
 CellTags->"b:4.4.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "345"], "=", " ", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OpGHZ", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "3"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"GHZ", "=", 
  RowBox[{"OpGHZ", ".", 
   SubscriptBox["\[Rho]", "345"], ".", 
   RowBox[{"Adj", "[", "OpGHZ", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.6141748889113626`*^9, 3.6141749153569593`*^9}},
 CellTags->"b:4.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185833809763*^9},
 CellTags->"b:4.4.1"]
}, Open  ]],

Cell["Then the density matrix for the \"initial\" system is:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "0"], "=", 
   RowBox[{"AF", "[", 
    RowBox[{"EPR", "\[TensorProduct]", "GHZ"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.614174934348748*^9, 3.6141749579708223`*^9}},
 CellTags->"b:4.4.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2: The operator corresponding to the network is built", \
"Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:34", "b:4.4.2"}],

Cell["\<\
The bulk of the network which is depicted in Fig. 3 of the abovementioned \
reference can be constructed easily: \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"Bop", "[", 
     RowBox[{"qi_", ",", "qj_", ",", "qk_", ",", "ql_", ",", "qm_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qm", ",", "qi"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"5", ",", "qm"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qi", ",", "ql"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qm", ",", "ql"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qk", ",", "qm"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"5", ",", "ql"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qj", ",", "ql"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"5", ",", "ql"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qk", ",", "ql"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"5", ",", "qj"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"5", ",", "qj", ",", "qk"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"5", ",", "qj"}], "]"}]}]}], ";"}]}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:4.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3: The final state density matrix is obtained", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:35", "b:4.4.3"}],

Cell["\<\
The application of the network to the initial density matrix is readily \
evaluated:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.3"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Rho]", "E"], "  ", ":=", " ", 
     RowBox[{
      RowBox[{"Bop", "[", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "]"}], ".", 
      SubscriptBox["\[Rho]", "0"], ".", 
      RowBox[{"Adj", "[", 
       RowBox[{"Bop", "[", 
        RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "]"}], 
       "]"}]}]}], ";"}]}],
  FontSize->12]], "Input",
 FontFamily->"Courier New",
 FontSize->12,
 CellTags->"b:4.4.3"],

Cell["\<\
We can check that the density matrix is indeed so by computing its 
trace and the trace of it squared:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "E"], "]"}], "]"}], "]"}], "\n", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{
     SubscriptBox["\[Rho]", "E"], ".", 
     SubscriptBox["\[Rho]", "E"]}], "]"}], "]"}], "]"}]}], "Input",
 CellTags->"b:4.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   SuperscriptBox["A", "2"], "+", 
   SuperscriptBox["B", "2"]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185833980671*^9},
 CellTags->"b:4.4.3"],

Cell[BoxData[
 TagBox[
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["A", "2"], "+", 
     SuperscriptBox["B", "2"]}], ")"}], "2"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834249751*^9},
 CellTags->"b:4.4.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 4: Bob state is computed and compared to the initial EPR"
}], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:36", "b:4.4.4"}],

Cell["\<\
Bob's 2 qubit state, made of qubits 4 and 5, is obtained by taking the 
partial trace of the full final state:\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "Bob"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "E"]}], "]"}]}]], "Input",
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      SuperscriptBox["A", "2"], 
      RowBox[{"A", " ", "B"}], "0"},
     {"0", 
      RowBox[{"A", " ", "B"}], 
      SuperscriptBox["B", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834572011*^9},
 CellTags->"b:4.4.4"]
}, Open  ]],

Cell["The 2qubit state density matrix is characterized by :", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", 
     StyleBox[
      SubscriptBox["\[Rho]", "Bob"],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PA",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox["PB",
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", "PA", "\[IndentingNewLine]", "PB", "\
\[IndentingNewLine]", "TAB"}], "Input",
 CellChangeTimes->{{3.6141750020247183`*^9, 3.614175011507257*^9}},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {
       RowBox[{
        SuperscriptBox["A", "2"], "-", 
        SuperscriptBox["B", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834588689*^9},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["A", "2"]}], "+", 
        SuperscriptBox["B", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834594261*^9},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"2", " ", "A", " ", "B"}]},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"2", " ", "A", " ", "B"}]},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["A", "2"]}], "-", 
            SuperscriptBox["B", "2"]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834599155*^9},
 CellTags->"b:4.4.4"]
}, Open  ]],

Cell["...which we can compare to the original EPR state:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:4.4.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TT", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", "EPR"}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["PA",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"TT", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"TT", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"TT", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"T", 
     StyleBox["PB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"TT", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"TT", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"TT", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TT", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"TT", "[", 
        RowBox[{"i", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", "TPA", "\[IndentingNewLine]", "TPB", "\
\[IndentingNewLine]", "TTAB"}], "Input",
 CellChangeTimes->{{3.614175023219013*^9, 3.614175031295293*^9}},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {
       RowBox[{
        SuperscriptBox["A", "2"], "-", 
        SuperscriptBox["B", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858346221113`*^9},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["A", "2"]}], "+", 
        SuperscriptBox["B", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.62518583462786*^9},
 CellTags->"b:4.4.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"2", " ", "A", " ", "B"}]},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"2", " ", "A", " ", "B"}]},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["A", "2"]}], "-", 
            SuperscriptBox["B", "2"]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858346327553`*^9},
 CellTags->"b:4.4.4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Step 5: For completeness all one qubit partial traces are shown\
\>", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:37", "b:4.4.5"}],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"1", "F"}]], "=", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     SubscriptBox["\[Rho]", "E"]}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"2", "F"}]], "=", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     SubscriptBox["\[Rho]", "E"]}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"3", "F"}]], "=", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "5"}], "}"}], ",", 
     SubscriptBox["\[Rho]", "E"]}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"4", "F"}]], "=", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "5"}], "}"}], ",", 
     SubscriptBox["\[Rho]", "E"]}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]", 
    RowBox[{"5", "F"}]], "=", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     SubscriptBox["\[Rho]", "E"]}], "]"}]}],
  FontSize->12]}], "Input",
 CellTags->"b:4.4.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", 
      RowBox[{
       SuperscriptBox["A", "2"], "+", 
       SuperscriptBox["B", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6251858347957067`*^9},
 CellTags->"b:4.4.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185834955398*^9},
 CellTags->"b:4.4.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "+", 
         SuperscriptBox["B", "2"]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185835147072*^9},
 CellTags->"b:4.4.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["A", "2"], "0"},
     {"0", 
      SuperscriptBox["B", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185835306938*^9},
 CellTags->"b:4.4.5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["B", "2"], "0"},
     {"0", 
      SuperscriptBox["A", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.625185835437273*^9},
 CellTags->"b:4.4.5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.61417508125383*^9, 3.61417508147797*^9}},
 CellTags->"b:4.4.5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["References", "Section",
 FontFamily->"Times",
 CellTags->{"c:32", "b:4.5"}],

Cell[TextData[{
 "\n",
 Cell[BoxData[
  FormBox[GridBox[{
     {
      RowBox[{"References", ":"}], 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"[", "1", "]"}], " ", 
         RowBox[{"C", ".", "H", ".", "Bennett"}]}], ",", " ", 
        RowBox[{"et", " ", 
         RowBox[{
         "al", ".", " ", "Phys", ".", "Rev", ".", "Lett", ".", "70"}]}], ",", 
        RowBox[{"1895", "-", 
         RowBox[{"1899", " ", 
          RowBox[{"(", "1993", ")"}]}]}]}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"[", "2", "]"}], " ", "QDENSITY", " ", "manual"}], ",", " ", 
        RowBox[{"Sect", ".", " ", "7"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
      "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}], TraditionalForm]], 
  "DefinitionBox",
  GridBoxOptions->{
  GridBoxDividers->{
   "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
    "RowsIndexed" -> {}},
  GridBoxSpacings->{"Columns" -> {
      Offset[0.27999999999999997`], {
       Offset[0.5599999999999999]}, 
      Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
      Offset[0.2], {
       Offset[0.16]}, 
      Offset[0.2]}, "RowsIndexed" -> {}}},
  CellTags->"S5.1.1"]
}], "Abstract",
 CellChangeTimes->{3.5122146834445267`*^9},
 CellTags->"b:4.5"]
}, Open  ]]
},
WindowToolbars->{},
WindowSize->{994, 871},
WindowMargins->{{Automatic, 264}, {Automatic, 0}},
PrintingStartingPageNumber->15,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"home", "bruno", "PITT", "QC"}, 
  "Test1.1.nb.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 19.580426`8.04439712024133}, {15, 
    15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 16, 16, 16, 16, 16, 16, 
    16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 
    17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 
    18, 18, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20, 20, 20, 20, 
    20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21, 21, 22, 22, 22, 22, 22, 
    22, 22, 22, 22, 22, 22, 22, 22, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 
    23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 25, 25, 25, 25, 
    25, 25, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 
    27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 28, 28, 28, 28, 
    28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 29, 29, 29, 29, 29, 29, 29, 29, 
    29, 29, 29, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 31, 31, 31, 
    31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 32, 32, 32, 32, 32, 32, 
    32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 33, 33, 33, 33, 33, 33, 33, 33, 
    33, 33, 33, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 
    35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 36, 36, 36, 36, 36, 
    36, 36, 36, 36, 36, 36, 36, 36, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 
    37, 37, 38, 38, 38}, Automatic}},
CellLabelAutoDelete->True,
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Title"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, ScriptMinSize -> 
          9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          ScriptMinSize -> 12, FontSize -> 16], 
         Cell[
          StyleData[All, "SlideShow"], PageWidth -> WindowWidth, 
          ScrollingOptions -> {
           "PagewiseDisplay" -> True, "VerticalScrollRange" -> Fit}, 
          ShowCellBracket -> False, ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Margins" -> {1, 1}, "Widths" -> {0, 5}}, 
          ScriptMinSize -> 8, FontSize -> 11], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, ScriptMinSize -> 
          7, FontSize -> 10, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, 
          PageHeaderLines -> {True, True}, 
          PrintingOptions -> {
           "FacingPages" -> True, "FirstPageHeader" -> False}, 
          CellFrameLabelMargins -> 6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 11}, CounterIncrements -> 
             "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontSize -> 
             34, FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{0, 0}, {0, 0}}, 
             CellFrameMargins -> {{12, 10}, {24, 24}}, LineSpacing -> {1, 0}, 
             FontSize -> 46], 
            Cell[
             StyleData["Title", "Condensed"], CellMargins -> {{0, 0}, {0, 0}},
              FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], CellMargins -> {{0, 0}, {0, 0}}, 
             FontSize -> 24, FontTracking -> "Plain", Background -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {0, 0}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphIndent -> -96, 
             CounterIncrements -> "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 18, FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.2, 0.700008, 0.700008]], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{0, 0}, {4, 0}}, 
             CellFrameMargins -> {{12, 10}, {12, 8}}, LineSpacing -> {1, 6}, 
             ParagraphIndent -> -157, FontSize -> 28], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{0, 0}, {0, 0}}, ParagraphIndent -> -78, 
             FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{0, 0}, {0, 0}}, ParagraphIndent -> -85, 
             FontSize -> 16, Background -> GrayLevel[0.6]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], ShowCellBracket -> False, 
             CellMargins -> {{10, 4}, {30, 10}}, PageBreakBelow -> False, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{15, 10}, {50, 10}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {12, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{9, 10}, {50, 10}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{6, 0}, {0, 1}}, CellDingbat -> 
             None, CellMargins -> {{12, Inherited}, {4, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, CellFrameMargins -> 6, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 7}, CounterIncrements -> 
             "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold", 
             FontColor -> RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellFrame -> {{8, 0}, {0, 2}}, 
             CellMargins -> {{15, 10}, {14, 32}}, 
             CellFrameMargins -> {{8, 10}, {10, 14}}, LineSpacing -> {1, 2}, 
             FontSize -> 24, FontTracking -> "Condensed"], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{8, Inherited}, {2, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{9, 0}, {2, 50}}, FontSize -> 14, FontTracking -> 
             "Plain", FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], 
             CellMargins -> {{12, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 7}, CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 13, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{15, 10}, {12, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{8, Inherited}, {2, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {4, 40}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 12}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 9}, CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontSize -> 13, 
             FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {18, 28}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{22, Inherited}, {2, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{21, 0}, {4, 20}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {5, 5}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12},
              CounterIncrements -> "Text", FontFamily -> "Times"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{15, 10}, {8, 10}}, LineSpacing -> {1, 5}, 
             ParagraphSpacing -> {0, 12}, FontSize -> 18], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {4, 4}},
              LineSpacing -> {1, 1}, ParagraphSpacing -> {0, 4}], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{9, 0}, {4, 4}}, 
             Hyphenation -> True, ParagraphSpacing -> {0, 6}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {5, 5}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 6}, 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{15, 10}, {8, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 14], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {2, 2}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{9, 0}, {4, 4}}, Hyphenation -> True, FontSize -> 
             7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Inert"], StyleMenuListing -> None, Background -> 
             RGBColor[0.870588, 0.905882, 0.972549]], 
            Cell[
             StyleData["Inert", "Printout"], StyleMenuListing -> None, 
             Background -> GrayLevel[1]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellFrame -> {{3, 0}, {0, 0}}, 
             CellMargins -> {{52, 10}, {8, 8}}, Evaluatable -> True, 
             CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{5, Inherited}, {Inherited, Inherited}}, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, ShowStringCharacters -> True,
              NumberMarks -> True, 
             LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, CounterIncrements -> 
             "Input", FontWeight -> "Bold", Background -> 
             RGBColor[1, 0.700008, 0.4]], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellFrame -> {{5, 0}, {0, 0}}, 
             CellMargins -> {{74, 10}, {8, 10}}, 
             CellFrameMargins -> {{10, 10}, {14, 14}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, Inherited}, {1, 4}}], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{44, 0}, {2, 6}},
              Background -> GrayLevel[0.900008]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineInput"], Evaluatable -> True, CellGroupingRules -> 
             "InputGrouping", CellHorizontalScrolling -> True, 
             PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, FormatType -> InputForm, 
             ShowStringCharacters -> True, NumberMarks -> True, 
             CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["InlineInput", "Presentation"], FontSize -> 18], 
            Cell[
             StyleData["InlineInput", "Condensed"]], 
            Cell[
             StyleData["InlineInput", "Printout"], FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellFrame -> {{3, 0}, {0, 0}}, 
             CellMargins -> {{52, 10}, {8, 8}}, CellEditDuplicate -> True, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, 
             CellLabelMargins -> {{3, Inherited}, {Inherited, Inherited}}, 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", FormatType -> InputForm, CounterIncrements -> 
             "Output", Background -> RGBColor[1, 0.900008, 0.900008]], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellFrame -> {{5, 0}, {0, 0}}, 
             CellMargins -> {{74, 10}, {12, 5}}, 
             CellFrameMargins -> {{10, 10}, {14, 14}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{40, Inherited}, {4, 1}}], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{44, 0}, {6, 2}}, Background -> 
             GrayLevel[0.900008]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{62, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontColor -> RGBColor[1, 0, 0]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{86, 20}, {10, 10}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{50, Inherited}, {Inherited, Inherited}}], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{54, Inherited}, {Inherited, Inherited}}, 
             FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{62, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{86, 20}, {4, 4}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{50, Inherited}, {Inherited, Inherited}}], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{54, Inherited}, {Inherited, Inherited}}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{62, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, FormatType -> 
             InputForm, CounterIncrements -> "Graphics", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             CellMargins -> {{86, 20}, {8, 8}}, FontSize -> 18], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             CellMargins -> {{52, Inherited}, {Inherited, Inherited}}, 
             ImageSize -> {175, 175}], 
            Cell[
             StyleData["Graphics", "Printout"], 
             CellMargins -> {{54, Inherited}, {Inherited, Inherited}}, 
             ImageSize -> {250, 250}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 11, FontWeight -> "Bold", FontColor -> 
             RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 8], 
            Cell[
             StyleData["CellLabel", "Printout"], FontSize -> 8, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Unique Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Author"], ShowCellBracket -> False, 
             CellMargins -> {{10, 4}, {2, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16, FontSlant -> "Italic"], 
            Cell[
             StyleData["Author", "Presentation"], 
             CellMargins -> {{15, 10}, {4, 16}}, LineSpacing -> {1, 5}, 
             ParagraphSpacing -> {0, 12}, FontSize -> 24], 
            Cell[
             StyleData["Author", "Condensed"], 
             CellMargins -> {{8, 10}, {1, 4}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 4}, FontSize -> 12], 
            Cell[
             StyleData["Author", "Printout"], 
             CellMargins -> {{9, 0}, {4, 12}}, ParagraphSpacing -> {0, 6}, 
             FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Copyright"], ShowCellBracket -> False, 
             CellMargins -> {{10, 10}, {40, 2}}, FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["Copyright", "Presentation"], 
             CellMargins -> {{15, 10}, {50, 4}}, LineSpacing -> {1, 5}, 
             FontSize -> 14], 
            Cell[
             StyleData["Copyright", "Condensed"], 
             CellMargins -> {{8, 10}, {12, 1}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["Copyright", "Printout"], 
             CellMargins -> {{9, 0}, {72, 4}}, FontSize -> 7]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Example"], CellMargins -> {{12, 10}, {5, 12}}, 
             LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 12}, 
             CounterIncrements -> "Example", FontFamily -> "Times", 
             FontWeight -> "Bold"], 
            Cell[
             StyleData["Example", "Presentation"], 
             CellMargins -> {{18, 10}, {8, 20}}, LineSpacing -> {1, 5}, 
             ParagraphSpacing -> {0, 12}, FontSize -> 18], 
            Cell[
             StyleData["Example", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 4}], 
            Cell[
             StyleData["Example", "Printout"], 
             CellMargins -> {{9, 0}, {4, 10}}, ParagraphSpacing -> {0, 6}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Definition"], CellFrame -> {{3, 0}, {0, 0}}, 
             CellMargins -> {{52, 10}, {8, 8}}, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{23, Inherited}, {Inherited, Inherited}}, 
             ShowStringCharacters -> True, CounterIncrements -> "Definition", 
             FontFamily -> "Helvetica", FontWeight -> "Bold", FontColor -> 
             GrayLevel[1], Background -> RGBColor[0.2, 0.700008, 0.700008]], 
            Cell[
             StyleData["Definition", "Presentation"], 
             CellFrame -> {{5, 0}, {0, 0}}, 
             CellMargins -> {{74, 10}, {8, 12}}, 
             CellFrameMargins -> {{10, 10}, {14, 14}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Definition", "Condensed"], 
             CellMargins -> {{40, 10}, {1, 4}}], 
            Cell[
             StyleData["Definition", "Printout"], 
             CellMargins -> {{44, 0}, {2, 6}}, Hyphenation -> True, 
             Background -> GrayLevel[0.6]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Theorem"], CellFrame -> {{3, 0}, {0, 0}}, 
             CellMargins -> {{52, 10}, {8, 8}}, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, 
             CellLabelMargins -> {{23, Inherited}, {Inherited, Inherited}}, 
             ShowStringCharacters -> True, CounterIncrements -> "Theorem", 
             FontFamily -> "Helvetica", FontWeight -> "Bold", FontColor -> 
             GrayLevel[1], Background -> 
             RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["Theorem", "Presentation"], 
             CellFrame -> {{5, 0}, {0, 0}}, 
             CellMargins -> {{74, 10}, {8, 12}}, 
             CellFrameMargins -> {{10, 10}, {14, 14}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Theorem", "Condensed"], 
             CellMargins -> {{40, 10}, {1, 4}}], 
            Cell[
             StyleData["Theorem", "Printout"], 
             CellMargins -> {{44, 0}, {2, 6}}, Hyphenation -> True, 
             Background -> GrayLevel[0.4]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ExerciseMain"], CellFrame -> {{6, 0}, {0, 1}}, 
             CellMargins -> {{12, Inherited}, {4, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, CellFrameColor -> RGBColor[0.571389, 0.19675, 0.570504], 
             LineSpacing -> {1, 7}, CounterIncrements -> "Subsection", 
             CounterAssignments -> {{"Subsubsection", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 16, FontWeight -> "Bold", FontColor -> 
             RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["ExerciseMain", "Presentation"], 
             CellFrame -> {{8, 0}, {0, 2}}, 
             CellMargins -> {{18, 10}, {12, 32}}, 
             CellFrameMargins -> {{10, 10}, {14, 14}}, LineSpacing -> {1, 2}, 
             FontSize -> 24, FontTracking -> "Condensed"], 
            Cell[
             StyleData["ExerciseMain", "Condensed"], 
             CellMargins -> {{8, Inherited}, {2, 12}}, FontSize -> 12], 
            Cell[
             StyleData["ExerciseMain", "Printout"], 
             CellMargins -> {{9, 0}, {2, 50}}, CellFrameColor -> 
             GrayLevel[0.500008], FontSize -> 14, FontTracking -> "Plain", 
             FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Exercise"], CellDingbat -> "\[FilledDownTriangle]", 
             CellMargins -> {{23, Inherited}, {4, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, LineSpacing -> {1, 7}, CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontSize -> 13, 
             FontWeight -> "Bold", FontColor -> 
             RGBColor[0.571389, 0.19675, 0.570504]], 
            Cell[
             StyleData["Exercise", "Presentation"], 
             CellMargins -> {{28, 10}, {10, 34}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Exercise", "Condensed"], 
             CellMargins -> {{17, Inherited}, {2, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Exercise", "Printout"], 
             CellFrame -> {{0, 0}, {0.5, 0}}, CellDingbat -> None, 
             CellMargins -> {{9, 0}, {6, 20}}, Hyphenation -> True, FontSize -> 
             11, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ExerciseText"], CellMargins -> {{62, 10}, {5, 5}}, 
             LineSpacing -> {1, 3}, ParagraphSpacing -> {0, 8}, 
             CounterIncrements -> "ExerciseText", FontFamily -> "Times"], 
            Cell[
             StyleData["ExerciseText", "Presentation"], 
             CellMargins -> {{100, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             ParagraphSpacing -> {0, 12}, FontSize -> 18], 
            Cell[
             StyleData["ExerciseText", "Condensed"], 
             CellMargins -> {{52, 10}, {2, 2}}, LineSpacing -> {1, 1}, 
             ParagraphSpacing -> {0, 4}], 
            Cell[
             StyleData["ExerciseText", "Printout"], 
             CellMargins -> {{54, 0}, {4, 4}}, Hyphenation -> True, 
             ParagraphSpacing -> {0, 6}]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], CellMargins -> {{62, 10}, {2, 10}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, "TwoByteSyntaxCharacterAutoReplacement" -> 
             True, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             CellMargins -> {{100, 10}, {8, 16}}, FontSize -> 18], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], 
             CellMargins -> {{52, 10}, {2, 10}}, FontSize -> 10], 
            Cell[
             StyleData["DisplayFormula", "Printout"], 
             CellMargins -> {{54, 10}, {2, 10}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["ChemicalFormula"], CellMargins -> {{62, 10}, {2, 10}},
              DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", AutoSpacing -> False, 
             ScriptBaselineShifts -> {0.6, Automatic}, ScriptLevel -> 1, 
             SingleLetterItalics -> False, ZeroWidthTimes -> True], 
            Cell[
             StyleData["ChemicalFormula", "Presentation"], 
             CellMargins -> {{100, 10}, {8, 12}}, FontSize -> 18], 
            Cell[
             StyleData["ChemicalFormula", "Condensed"], 
             CellMargins -> {{52, 10}, {2, 10}}, FontSize -> 10], 
            Cell[
             StyleData["ChemicalFormula", "Printout"], 
             CellMargins -> {{54, 10}, {2, 10}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellMargins -> {{12, 10}, {Inherited, 6}}, 
             Hyphenation -> False, LanguageCategory -> "Formula", FontFamily -> 
             "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{20, 30}, {4, 4}}, FontSize -> 18], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {Inherited, 4}}, FontSize -> 9.5], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{9, 0}, {Inherited, 4}}, FontSize -> 9.5]}, 
           Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Automatic Numbering", "Section"], 
         Cell[
         "The following styles are useful for numbered equations, figures, \
etc.  They automatically give the cell a FrameLabel containing a reference to \
a particular counter, and also increment that counter.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["NumberedEquation"], 
             CellMargins -> {{62, 10}, {Inherited, Inherited}}, 
             CellFrameLabels -> {{None, 
                Cell[
                 TextData[{"(", 
                   CounterBox["NumberedEquation"], ")"}]]}, {None, None}}, 
             DefaultFormatType -> DefaultInputFormatType, 
             "TwoByteSyntaxCharacterAutoReplacement" -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, CounterIncrements -> 
             "NumberedEquation", FormatTypeAutoConvert -> False], 
            Cell[
             StyleData["NumberedEquation", "Presentation"], 
             CellMargins -> {{100, 10}, {6, 8}}, FontSize -> 18], 
            Cell[
             StyleData["NumberedEquation", "Condensed"], 
             CellMargins -> {{52, 10}, {Inherited, Inherited}}], 
            Cell[
             StyleData["NumberedEquation", "Printout"], 
             CellMargins -> {{54, 0}, {Inherited, Inherited}}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["NumberedFigure"], 
             CellMargins -> {{62, 145}, {Inherited, Inherited}}, 
             CellFrameLabels -> {{None, None}, {
                Cell[
                 TextData[{"Figure ", 
                   CounterBox["NumberedFigure"]}]], None}}, CounterIncrements -> 
             "NumberedFigure", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             FormatTypeAutoConvert -> False], 
            Cell[
             StyleData["NumberedFigure", "Presentation"], 
             CellMargins -> {{100, 145}, {8, 6}}, FontSize -> 18], 
            Cell[
             StyleData["NumberedFigure", "Condensed"]], 
            Cell[
             StyleData["NumberedFigure", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["NumberedTable"], 
             CellMargins -> {{62, 145}, {Inherited, Inherited}}, 
             CellFrameLabels -> {{None, None}, {
                Cell[
                 TextData[{"Table ", 
                   CounterBox["NumberedTable"]}]], None}}, TextAlignment -> 
             Center, CounterIncrements -> "NumberedTable", 
             FormatTypeAutoConvert -> False], 
            Cell[
             StyleData["NumberedTable", "Presentation"], 
             CellMargins -> {{100, 145}, {8, 8}}, FontSize -> 18], 
            Cell[
             StyleData["NumberedTable", "Condensed"]], 
            Cell[
             StyleData["NumberedTable", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 6], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 9, 
          FontWeight -> "Bold"]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "SlideShow"]], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "SlideShow"]], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "SlideShow"]], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontColor -> RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLinkText"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLinkText", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLinkText", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLinkText", "SlideShow"]], 
            Cell[
             StyleData["RefGuideLinkText", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "SlideShow"]], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DemosLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Demos", #]}]& )}], 
            Cell[
             StyleData["DemosLink", "SlideShow"]], 
            Cell[
             StyleData["DemosLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TourLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["Tour", #]}]& )}], 
            Cell[
             StyleData["TourLink", "SlideShow"]], 
            Cell[
             StyleData["TourLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["OtherInformationLink", "SlideShow"]], 
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MasterIndexLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontColor -> 
             RGBColor[0.269993, 0.308507, 0.6], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MasterIndex", #]}]& )}], 
            Cell[
             StyleData["MasterIndexLink", "SlideShow"]], 
            Cell[
             StyleData["MasterIndexLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Slide Show Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowNavigationBar"], Editable -> False, 
             CellFrame -> True, CellMargins -> {{0, 0}, {3, 3}}, 
             CellElementSpacings -> {"CellMinHeight" -> 0.8125}, 
             CellGroupingRules -> {"SectionGrouping", 30}, CellFrameMargins -> 
             False, CellFrameColor -> GrayLevel[1], CellFrameLabelMargins -> 
             False, TextAlignment -> Center, CounterIncrements -> 
             "SlideShowNavigationBar", StyleMenuListing -> None, FontSize -> 
             10, Magnification -> 1, Background -> GrayLevel[0.8], 
             GridBoxOptions -> {
              BaselinePosition -> Center, 
               GridBoxAlignment -> {
                "Columns" -> {
                  Center, Center, Center, Center, Center, Center, Right, {
                   Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
                 "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {
                "Columns" -> {3.5, 3.5, 3.5, 3.5, 13, 5, {4}}, 
                 "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}, GridBoxSpacings -> {"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "Presentation"]], 
            Cell[
             StyleData["SlideShowNavigationBar", "SlideShow"], Deletable -> 
             False, ShowCellBracket -> False, 
             CellMargins -> {{-1, -1}, {-1, -1}}, PageBreakAbove -> True, 
             CellFrameMargins -> {{1, 1}, {0, 0}}], 
            Cell[
             StyleData["SlideShowNavigationBar", "Printout"], 
             CellMargins -> {{18, 4}, {4, 4}}, LineSpacing -> {1, 3}, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideShowSection"], CellFrame -> {{0, 0}, {0, 0.5}}, 
             CellMargins -> {{0, 0}, {10, 0}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, CellFrameMargins -> {{12, 4}, {6, 12}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", 
               "gridMathematica" -> FormBox[
                 RowBox[{"grid", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               "webMathematica" -> FormBox[
                 RowBox[{"web", 
                   AdjustmentBox[
                    StyleBox["Mathematica", FontSlant -> "Italic"], 
                    BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
               Inherited}, CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             18, FontWeight -> "Plain", FontColor -> GrayLevel[1], Background -> 
             RGBColor[0.408011, 0.440726, 0.8]], 
            Cell[
             StyleData["SlideShowSection", "Presentation"], 
             CellFrameMargins -> {{18, 10}, {10, 16}}, FontSize -> 27], 
            Cell[
             StyleData["SlideShowSection", "SlideShow"], ShowCellBracket -> 
             False, PageBreakAbove -> True], 
            Cell[
             StyleData["SlideShowSection", "Printout"], 
             CellMargins -> {{18, 30}, {0, 30}}, CellFrameMargins -> 5, 
             FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideHyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontSize -> 26, FontColor -> 
             GrayLevel[0.400015], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 0.5, 
               ButtonMinHeight -> 0.85, ButtonNote -> None}], 
            Cell[
             StyleData["SlideHyperlink", "Presentation"], 
             CellMargins -> {{10, 10}, {8, 12}}, FontSize -> 36], 
            Cell[
             StyleData["SlideHyperlink", "SlideShow"]], 
            Cell[
             StyleData["SlideHyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOCLink"], 
             CellMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, ButtonStyleMenuListing -> Automatic, 
             FontFamily -> "Helvetica", 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonMargins -> 1.5, 
               ButtonNote -> ButtonData}], 
            Cell[
             StyleData["SlideTOCLink", "Presentation"], 
             CellMargins -> {{35, 10}, {4, 6}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOCLink", "SlideShow"]], 
            Cell[
             StyleData["SlideTOCLink", "Printout"], 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SlideTOC"], CellDingbat -> "\[Bullet]", 
             CellMargins -> {{18, Inherited}, {Inherited, Inherited}}, 
             StyleMenuListing -> None, FontFamily -> "Helvetica"], 
            Cell[
             StyleData["SlideTOC", "Presentation"], 
             CellMargins -> {{25, 10}, {8, 6}}, FontSize -> 18], 
            Cell[
             StyleData["SlideTOC", "SlideShow"], FontSize -> 14], 
            Cell[
             StyleData["SlideTOC", "Printout"], FontSize -> 10, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]]}, Open]]}, Visible -> False, 
  FrontEndVersion -> 
  "10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, 2015)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 204, 6, 52, "Title",
   CellTags->"c:1"]},
 "c:2"->{
  Cell[1528, 53, 299, 7, 51, "Section",
   CellTags->"c:2"]},
 "c:3"->{
  Cell[1852, 64, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.0.0"}],
  Cell[46267, 1238, 142, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.0.1"}],
  Cell[121646, 3744, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.1.0"}],
  Cell[147189, 4662, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.2.0"}],
  Cell[166373, 5310, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.3.0"}],
  Cell[272400, 8415, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.4.0"}]},
 "b:4.0.0"->{
  Cell[1852, 64, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.0.0"}],
  Cell[1960, 69, 247, 5, 23, "Text",
   CellTags->"b:4.0.0"],
  Cell[2649, 92, 112, 3, 46, "Input",
   CellTags->"b:4.0.0"],
  Cell[2764, 97, 33520, 937, 495, "Print",
   CellTags->"b:4.0.0"],
  Cell[36299, 1037, 269, 6, 23, "Text",
   CellTags->"b:4.0.0"],
  Cell[36593, 1047, 250, 7, 62, "Input",
   CellTags->"b:4.0.0"],
  Cell[36846, 1056, 8361, 142, 196, "Output",
   CellTags->"b:4.0.0"],
  Cell[45222, 1201, 1008, 32, 56, "Text",
   CellTags->"b:4.0.0"]},
 "b:2.0.0"->{
  Cell[2232, 78, 133, 3, 46, "Input",
   CellTags->"b:2.0.0"],
  Cell[2368, 83, 244, 4, 22, "Print",
   CellTags->"b:2.0.0"]},
 "b:4.0.1"->{
  Cell[46267, 1238, 142, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.0.1"}],
  Cell[46412, 1243, 453, 9, 79, "Text",
   Evaluatable->False,
   CellTags->"b:4.0.1"],
  Cell[46890, 1256, 742, 21, 78, "Input",
   CellTags->"b:4.0.1"],
  Cell[47635, 1279, 243, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[47881, 1287, 240, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[48124, 1295, 241, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[48380, 1304, 103, 2, 23, "Text",
   CellTags->"b:4.0.1"],
  Cell[48508, 1310, 230, 7, 73, "Input",
   CellTags->"b:4.0.1"],
  Cell[48741, 1319, 260, 7, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[49004, 1328, 260, 7, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[49267, 1337, 244, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[49526, 1346, 218, 5, 51, "Text",
   CellTags->"b:4.0.1"],
  Cell[49747, 1353, 161, 4, 45, "Input",
   CellTags->"b:4.0.1"],
  Cell[49933, 1361, 384, 12, 64, "Input",
   CellTags->"b:4.0.1"],
  Cell[50320, 1375, 873, 25, 78, "Output",
   CellTags->"b:4.0.1"],
  Cell[51208, 1403, 179, 5, 51, "Text",
   CellTags->"b:4.0.1"],
  Cell[51412, 1412, 863, 30, 48, "Input",
   CellTags->"b:4.0.1"],
  Cell[52278, 1444, 1019, 27, 62, "Output",
   CellTags->"b:4.0.1"],
  Cell[53312, 1474, 134, 4, 23, "Text",
   CellTags->"b:4.0.1"],
  Cell[54041, 1502, 710, 19, 48, "Input",
   CellTags->"b:4.0.1"],
  Cell[54754, 1523, 176, 3, 21, "Print",
   CellTags->"b:4.0.1"],
  Cell[54945, 1529, 122, 2, 23, "Text",
   CellTags->"b:4.0.1"],
  Cell[55092, 1535, 821, 28, 84, "Input",
   CellTags->"b:4.0.1"],
  Cell[55916, 1565, 797, 22, 62, "Output",
   CellTags->"b:4.0.1"],
  Cell[56716, 1589, 227, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[56946, 1597, 243, 6, 45, "Output",
   CellTags->"b:4.0.1"],
  Cell[57204, 1606, 94, 2, 23, "Text",
   CellTags->"b:4.0.1"],
  Cell[57323, 1612, 512, 14, 46, "Input",
   CellTags->{"Do", "b:4.0.1"}],
  Cell[57838, 1628, 194, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.1"}],
  Cell[58035, 1633, 193, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.1"}]},
 "Do"->{
  Cell[57323, 1612, 512, 14, 46, "Input",
   CellTags->{"Do", "b:4.0.1"}],
  Cell[57838, 1628, 194, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.1"}],
  Cell[58035, 1633, 193, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.1"}],
  Cell[85246, 2555, 788, 25, 64, "Input",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86037, 2582, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86236, 2587, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86435, 2592, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86634, 2597, 198, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86835, 2602, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87034, 2607, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87233, 2612, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87432, 2617, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[219733, 6746, 682, 20, 46, "Input",
   CellTags->{"Do", "b:4.3.1"}],
  Cell[220418, 6768, 171, 5, 45, "Output",
   CellTags->{"Do", "b:4.3.1"}],
  Cell[253915, 7748, 1000, 31, 64, "Input",
   CellTags->{"Do", "b:4.3.3"}],
  Cell[254918, 7781, 169, 5, 45, "Output",
   CellTags->{"Do", "b:4.3.3"}]},
 "c:4"->{
  Cell[58277, 1642, 128, 3, 58, "Subsection",
   CellTags->{"c:4", "b:4.0.2"}]},
 "b:4.0.2"->{
  Cell[58277, 1642, 128, 3, 58, "Subsection",
   CellTags->{"c:4", "b:4.0.2"}],
  Cell[58408, 1647, 221, 6, 51, "Text",
   CellTags->"b:4.0.2"],
  Cell[58654, 1657, 1161, 28, 94, "Input",
   CellTags->"b:4.0.2"],
  Cell[59818, 1687, 794, 22, 94, "Output",
   CellTags->"b:4.0.2"],
  Cell[60615, 1711, 796, 22, 94, "Output",
   CellTags->"b:4.0.2"],
  Cell[61414, 1735, 794, 22, 94, "Output",
   CellTags->"b:4.0.2"],
  Cell[62211, 1759, 796, 22, 94, "Output",
   CellTags->"b:4.0.2"],
  Cell[63022, 1784, 210, 6, 51, "Text",
   CellTags->"b:4.0.2"],
  Cell[63235, 1792, 340, 11, 46, "Input",
   CellTags->"b:4.0.2"],
  Cell[63578, 1805, 209, 6, 23, "Text",
   CellTags->"b:4.0.2"],
  Cell[63812, 1815, 132, 4, 46, "Input",
   CellTags->"b:4.0.2"],
  Cell[63947, 1821, 1178, 40, 138, "Output",
   CellTags->"b:4.0.2"],
  Cell[65140, 1864, 245, 7, 51, "Text",
   CellTags->"b:4.0.2"],
  Cell[65388, 1873, 1408, 45, 121, "Input",
   CellTags->"b:4.0.2"],
  Cell[66799, 1920, 85, 2, 23, "Text",
   CellTags->"b:4.0.2"],
  Cell[66909, 1926, 378, 14, 116, "Input",
   CellTags->"b:4.0.2"],
  Cell[67290, 1942, 893, 26, 112, "Output",
   CellTags->"b:4.0.2"],
  Cell[68186, 1970, 895, 26, 112, "Output",
   CellTags->"b:4.0.2"],
  Cell[69084, 1998, 941, 28, 112, "Output",
   CellTags->"b:4.0.2"],
  Cell[70028, 2028, 939, 28, 112, "Output",
   CellTags->"b:4.0.2"],
  Cell[70982, 2059, 333, 8, 79, "Text",
   CellTags->"b:4.0.2"],
  Cell[71318, 2069, 185, 6, 46, "Input",
   CellTags->"b:4.0.2"],
  Cell[71528, 2079, 477, 14, 46, "Input",
   CellTags->"b:4.0.2"],
  Cell[72008, 2095, 894, 26, 112, "Output",
   CellTags->"b:4.0.2"],
  Cell[72917, 2124, 161, 5, 23, "Text",
   CellTags->"b:4.0.2"],
  Cell[73081, 2131, 2199, 90, 99, "Input",
   CellTags->"b:4.0.2"],
  Cell[75283, 2223, 109, 2, 23, "Text",
   CellTags->"b:4.0.2"],
  Cell[75417, 2229, 81, 1, 61, "Input",
   CellTags->"b:4.0.2"],
  Cell[75501, 2232, 771, 23, 78, "Output",
   CellTags->"b:4.0.2"],
  Cell[76275, 2257, 771, 23, 78, "Output",
   CellTags->"b:4.0.2"],
  Cell[77061, 2283, 99, 2, 23, "Text",
   CellTags->"b:4.0.2"],
  Cell[77185, 2289, 119, 2, 45, "Input",
   CellTags->"b:4.0.2"],
  Cell[77307, 2293, 2593, 71, 78, "Output",
   CellTags->"b:4.0.2"]},
 "c:5"->{
  Cell[79949, 2370, 117, 3, 58, "Subsection",
   CellTags->{"c:5", "b:4.0.3"}]},
 "b:4.0.3"->{
  Cell[79949, 2370, 117, 3, 58, "Subsection",
   CellTags->{"c:5", "b:4.0.3"}],
  Cell[80069, 2375, 218, 6, 51, "Text",
   CellTags->"b:4.0.3"],
  Cell[80312, 2385, 399, 12, 48, "Input",
   CellTags->"b:4.0.3"],
  Cell[80714, 2399, 2252, 52, 158, "Output",
   CellTags->"b:4.0.3"],
  Cell[82981, 2454, 94, 2, 23, "Text",
   CellTags->"b:4.0.3"],
  Cell[83100, 2460, 197, 8, 46, "Input",
   CellTags->"b:4.0.3"],
  Cell[83300, 2470, 223, 6, 45, "Output",
   CellTags->"b:4.0.3"],
  Cell[83560, 2481, 332, 14, 46, "Input",
   CellTags->"b:4.0.3"],
  Cell[83895, 2497, 229, 6, 45, "Output",
   CellTags->"b:4.0.3"],
  Cell[84139, 2506, 272, 10, 26, "Text",
   CellTags->"b:4.0.3"],
  Cell[84436, 2520, 389, 16, 46, "Input",
   CellTags->"b:4.0.3"],
  Cell[84828, 2538, 242, 6, 45, "Output",
   CellTags->"b:4.0.3"],
  Cell[85085, 2547, 136, 4, 23, "Text",
   CellTags->"b:4.0.3"],
  Cell[85246, 2555, 788, 25, 64, "Input",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86037, 2582, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86236, 2587, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86435, 2592, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86634, 2597, 198, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[86835, 2602, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87034, 2607, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87233, 2612, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}],
  Cell[87432, 2617, 196, 3, 22, "Print",
   CellTags->{"Do", "b:4.0.3"}]},
 "c:6"->{
  Cell[87677, 2626, 127, 3, 58, "Subsection",
   CellTags->{"c:6", "b:4.0.4"}]},
 "b:4.0.4"->{
  Cell[87677, 2626, 127, 3, 58, "Subsection",
   CellTags->{"c:6", "b:4.0.4"}],
  Cell[87807, 2631, 396, 11, 163, "Text",
   CellTags->"b:4.0.4"],
  Cell[88206, 2644, 304, 8, 107, "Text",
   CellTags->"b:4.0.4"],
  Cell[88513, 2654, 211, 5, 24, "Text",
   CellTags->"b:4.0.4"],
  Cell[88727, 2661, 517, 17, 46, "Input",
   CellTags->"b:4.0.4"],
  Cell[89247, 2680, 292, 8, 24, "Text",
   CellTags->"b:4.0.4"],
  Cell[89564, 2692, 394, 12, 64, "Input",
   CellTags->"b:4.0.4"],
  Cell[89961, 2706, 242, 6, 45, "Output",
   CellTags->"b:4.0.4"],
  Cell[90206, 2714, 243, 6, 45, "Output",
   CellTags->"b:4.0.4"],
  Cell[90486, 2725, 669, 19, 64, "Input",
   CellTags->"b:4.0.4"],
  Cell[91158, 2746, 186, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[91347, 2751, 186, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[91536, 2756, 188, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[91727, 2761, 186, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[91916, 2766, 184, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[92103, 2771, 186, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[92292, 2776, 188, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[92483, 2781, 188, 3, 22, "Print",
   CellTags->"b:4.0.4"],
  Cell[92708, 2789, 136, 4, 46, "Input",
   CellTags->"b:4.0.4"],
  Cell[92847, 2795, 227, 6, 45, "Output",
   CellTags->"b:4.0.4"],
  Cell[93089, 2804, 269, 8, 23, "Text",
   CellTags->"b:4.0.4"],
  Cell[93361, 2814, 415, 10, 48, "Input",
   CellTags->"b:4.0.4"],
  Cell[93779, 2826, 527, 17, 102, "Input",
   CellTags->"b:4.0.4"]},
 "c:7"->{
  Cell[94343, 2848, 139, 3, 58, "Subsection",
   CellTags->{"c:7", "b:4.0.5"}]},
 "b:4.0.5"->{
  Cell[94343, 2848, 139, 3, 58, "Subsection",
   CellTags->{"c:7", "b:4.0.5"}],
  Cell[94485, 2853, 444, 13, 82, "Text",
   CellTags->"b:4.0.5"],
  Cell[94932, 2868, 372, 13, 62, "Input",
   CellTags->"b:4.0.5"],
  Cell[95307, 2883, 471, 16, 50, "Input",
   CellTags->"b:4.0.5"],
  Cell[95781, 2901, 161, 5, 23, "Text",
   CellTags->"b:4.0.5"],
  Cell[95967, 2910, 246, 8, 46, "Input",
   CellTags->"b:4.0.5"],
  Cell[96216, 2920, 758, 20, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[97011, 2945, 615, 18, 46, "Input",
   CellTags->"b:4.0.5"],
  Cell[97629, 2965, 756, 20, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[98422, 2990, 53, 1, 46, "Input",
   CellTags->"b:4.0.5"],
  Cell[98478, 2993, 223, 6, 45, "Output",
   CellTags->"b:4.0.5"],
  Cell[98738, 3004, 451, 13, 94, "Input",
   CellTags->"b:4.0.5"],
  Cell[99192, 3019, 1185, 30, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[100380, 3051, 1185, 30, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[101568, 3083, 1181, 28, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[102752, 3113, 1179, 28, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[103946, 3144, 533, 14, 81, "Text",
   CellTags->"b:4.0.5"],
  Cell[104504, 3162, 228, 8, 46, "Input",
   CellTags->"b:4.0.5"],
  Cell[104735, 3172, 1186, 30, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[105936, 3205, 135, 4, 23, "Text",
   CellTags->"b:4.0.5"],
  Cell[106096, 3213, 44, 1, 45, "Input",
   CellTags->"b:4.0.5"],
  Cell[106143, 3216, 225, 6, 45, "Output",
   CellTags->"b:4.0.5"],
  Cell[106383, 3225, 133, 4, 23, "Text",
   CellTags->"b:4.0.5"],
  Cell[106519, 3231, 236, 7, 48, "Input",
   CellTags->"b:4.0.5"],
  Cell[106758, 3240, 122, 5, 51, "Text",
   CellTags->"b:4.0.5"],
  Cell[106883, 3247, 1457, 27, 751, "Text",
   CellTags->"b:4.0.5"],
  Cell[108365, 3278, 5997, 226, 174, "Input",
   CellTags->"b:4.0.5"],
  Cell[114365, 3506, 720, 20, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[115088, 3528, 720, 20, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[115811, 3550, 1016, 27, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[116830, 3579, 1015, 27, 62, "Output",
   CellTags->"b:4.0.5"],
  Cell[117860, 3609, 151, 5, 35, "DisplayText",
   CellTags->"b:4.0.5"],
  Cell[118036, 3618, 577, 18, 47, "Input",
   CellTags->"b:4.0.5"],
  Cell[118616, 3638, 876, 25, 78, "Output",
   CellTags->"b:4.0.5"],
  Cell[119507, 3666, 153, 5, 35, "DisplayText",
   CellTags->"b:4.0.5"],
  Cell[119685, 3675, 107, 3, 46, "Input",
   CellTags->"b:4.0.5"],
  Cell[119795, 3680, 873, 25, 78, "Output",
   CellTags->"b:4.0.5"]},
 "c:8"->{
  Cell[121279, 3732, 342, 8, 51, "Section",
   CellTags->"c:8"]},
 "b:4.1.0"->{
  Cell[121646, 3744, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.1.0"}],
  Cell[121754, 3749, 138, 3, 29, "Text",
   CellTags->"b:4.1.0"],
  Cell[121895, 3754, 133, 3, 53, "Input",
   CellTags->"b:4.1.0"],
  Cell[122031, 3759, 112, 3, 53, "Input",
   CellTags->"b:4.1.0"],
  Cell[122146, 3764, 215, 5, 29, "Text",
   CellTags->"b:4.1.0"],
  Cell[122364, 3771, 91, 3, 50, "Input",
   CellTags->"b:4.1.0"],
  Cell[122458, 3776, 254, 7, 74, "Input",
   CellTags->"b:4.1.0"]},
 "c:9"->{
  Cell[122749, 3788, 208, 6, 58, "Subsection",
   CellTags->{"c:9", "b:4.1.1"}]},
 "b:4.1.1"->{
  Cell[122749, 3788, 208, 6, 58, "Subsection",
   CellTags->{"c:9", "b:4.1.1"}],
  Cell[122960, 3796, 265, 6, 29, "Text",
   CellTags->"b:4.1.1"],
  Cell[123228, 3804, 82, 2, 50, "Input",
   CellTags->"b:4.1.1"],
  Cell[123313, 3808, 2736, 77, 237, "Input",
   CellTags->"b:4.1.1"],
  Cell[126384, 3898, 245, 6, 29, "Text",
   CellTags->"b:4.1.1"],
  Cell[126632, 3906, 203, 5, 74, "Input",
   CellTags->"b:4.1.1"],
  Cell[126838, 3913, 208, 7, 29, "Text",
   CellTags->"b:4.1.1"],
  Cell[127049, 3922, 1107, 30, 120, "Input",
   CellTags->"b:4.1.1"],
  Cell[128159, 3954, 123, 2, 29, "Text",
   CellTags->"b:4.1.1"],
  Cell[128285, 3958, 402, 11, 74, "Input",
   CellTags->"b:4.1.1"],
  Cell[128690, 3971, 101, 2, 29, "Text",
   CellTags->"b:4.1.1"],
  Cell[128794, 3975, 804, 22, 106, "Input",
   CellTags->"b:4.1.1"]},
 "c:10"->{
  Cell[129635, 4002, 135, 3, 58, "Subsection",
   CellTags->{"c:10", "b:4.1.2"}]},
 "b:4.1.2"->{
  Cell[129635, 4002, 135, 3, 58, "Subsection",
   CellTags->{"c:10", "b:4.1.2"}],
  Cell[129773, 4007, 309, 8, 97, "Text",
   CellTags->"b:4.1.2"],
  Cell[130085, 4017, 540, 17, 80, "Input",
   CellTags->"b:4.1.2"]},
 "c:11"->{
  Cell[130662, 4039, 144, 3, 58, "Subsection",
   CellTags->{"c:11", "b:4.1.3"}]},
 "b:4.1.3"->{
  Cell[130662, 4039, 144, 3, 58, "Subsection",
   CellTags->{"c:11", "b:4.1.3"}],
  Cell[130809, 4044, 161, 5, 29, "Text",
   CellTags->"b:4.1.3"],
  Cell[130973, 4051, 827, 30, 64, "Input",
   CellTags->"b:4.1.3"],
  Cell[131803, 4083, 247, 7, 63, "Text",
   CellTags->"b:4.1.3"],
  Cell[132053, 4092, 314, 9, 74, "Input",
   CellTags->"b:4.1.3"]},
 "c:12"->{
  Cell[132404, 4106, 141, 3, 58, "Subsection",
   CellTags->{"c:12", "b:4.1.4"}]},
 "b:4.1.4"->{
  Cell[132404, 4106, 141, 3, 58, "Subsection",
   CellTags->{"c:12", "b:4.1.4"}],
  Cell[132548, 4111, 188, 5, 51, "Text",
   CellTags->"b:4.1.4"],
  Cell[132739, 4118, 1242, 47, 54, "Input",
   CellTags->"b:4.1.4"]},
 "c:13"->{
  Cell[134018, 4170, 256, 8, 62, "Subsection",
   CellTags->{"c:13", "b:4.1.5"}]},
 "b:4.1.5"->{
  Cell[134018, 4170, 256, 8, 62, "Subsection",
   CellTags->{"c:13", "b:4.1.5"}],
  Cell[134277, 4180, 292, 7, 107, "Text",
   CellTags->"b:4.1.5"],
  Cell[134572, 4189, 638, 19, 76, "Input",
   CellTags->"b:4.1.5"],
  Cell[135213, 4210, 159, 5, 29, "Text",
   CellTags->"b:4.1.5"],
  Cell[135375, 4217, 696, 23, 143, "Input",
   CellTags->"b:4.1.5"],
  Cell[136074, 4242, 189, 7, 29, "Text",
   CellTags->"b:4.1.5"],
  Cell[136266, 4251, 178, 5, 50, "Input",
   CellTags->"b:4.1.5"]},
 "c:14"->{
  Cell[136481, 4261, 317, 9, 62, "Subsection",
   CellTags->{"c:14", "b:4.1.6"}]},
 "b:4.1.6"->{
  Cell[136481, 4261, 317, 9, 62, "Subsection",
   CellTags->{"c:14", "b:4.1.6"}],
  Cell[136801, 4272, 157, 5, 29, "Text",
   CellTags->"b:4.1.6"],
  Cell[136961, 4279, 1409, 43, 189, "Input",
   CellTags->"b:4.1.6"],
  Cell[138373, 4324, 223, 6, 29, "Text",
   CellTags->"b:4.1.6"],
  Cell[138599, 4332, 316, 8, 74, "Input",
   CellTags->"b:4.1.6"]},
 "c:15"->{
  Cell[138952, 4345, 350, 10, 62, "Subsection",
   CellTags->{"c:15", "b:4.1.7"}]},
 "b:4.1.7"->{
  Cell[138952, 4345, 350, 10, 62, "Subsection",
   CellTags->{"c:15", "b:4.1.7"}],
  Cell[139305, 4357, 203, 5, 29, "Text",
   CellTags->"b:4.1.7"],
  Cell[139511, 4364, 2287, 89, 194, "Input",
   CellTags->"b:4.1.7"],
  Cell[141801, 4455, 137, 4, 29, "Text",
   CellTags->"b:4.1.7"],
  Cell[141941, 4461, 2403, 94, 194, "Input",
   CellTags->"b:4.1.7"],
  Cell[144347, 4557, 199, 8, 53, "Input",
   CellTags->"b:4.1.7"]},
 "c:16"->{
  Cell[144583, 4570, 165, 5, 58, "Subsection",
   CellTags->{"c:16", "b:4.1.8"}]},
 "b:4.1.8"->{
  Cell[144583, 4570, 165, 5, 58, "Subsection",
   CellTags->{"c:16", "b:4.1.8"}],
  Cell[144751, 4577, 2021, 67, 166, "Input",
   CellTags->"b:4.1.8"]},
 "c:17"->{
  Cell[146821, 4650, 343, 8, 31, "Section",
   CellTags->"c:17"]},
 "b:4.2.0"->{
  Cell[147189, 4662, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.2.0"}],
  Cell[147297, 4667, 138, 3, 29, "Text",
   CellTags->"b:4.2.0"],
  Cell[147438, 4672, 133, 3, 53, "Input",
   CellTags->"b:4.2.0"],
  Cell[147574, 4677, 112, 3, 53, "Input",
   CellTags->"b:4.2.0"],
  Cell[147689, 4682, 215, 5, 29, "Text",
   CellTags->"b:4.2.0"],
  Cell[147907, 4689, 115, 4, 50, "Input",
   CellTags->"b:4.2.0"],
  Cell[148025, 4695, 254, 7, 74, "Input",
   CellTags->"b:4.2.0"]},
 "c:18"->{
  Cell[148316, 4707, 164, 5, 58, "Subsection",
   CellTags->{"c:18", "b:4.2.1"}]},
 "b:4.2.1"->{
  Cell[148316, 4707, 164, 5, 58, "Subsection",
   CellTags->{"c:18", "b:4.2.1"}],
  Cell[148483, 4714, 215, 6, 63, "Text",
   CellTags->"b:4.2.1"],
  Cell[148701, 4722, 210, 5, 50, "Input",
   CellTags->"b:4.2.1"],
  Cell[148914, 4729, 109, 2, 29, "Text",
   CellTags->"b:4.2.1"],
  Cell[149026, 4733, 229, 6, 74, "Input",
   CellTags->"b:4.2.1"],
  Cell[149258, 4741, 84, 2, 29, "Text",
   CellTags->"b:4.2.1"],
  Cell[149345, 4745, 147, 4, 50, "Input",
   CellTags->"b:4.2.1"],
  Cell[149495, 4751, 378, 10, 63, "Text",
   CellTags->"b:4.2.1"],
  Cell[149876, 4763, 1609, 43, 166, "Input",
   CellTags->"b:4.2.1"],
  Cell[151488, 4808, 118, 2, 29, "Text",
   CellTags->"b:4.2.1"],
  Cell[151609, 4812, 612, 17, 97, "Input",
   CellTags->"b:4.2.1"],
  Cell[152224, 4831, 101, 2, 29, "Text",
   CellTags->"b:4.2.1"],
  Cell[152328, 4835, 802, 22, 106, "Input",
   CellTags->"b:4.2.1"]},
 "c:19"->{
  Cell[153167, 4862, 135, 3, 58, "Subsection",
   CellTags->{"c:19", "b:4.2.2"}]},
 "b:4.2.2"->{
  Cell[153167, 4862, 135, 3, 58, "Subsection",
   CellTags->{"c:19", "b:4.2.2"}],
  Cell[153305, 4867, 137, 4, 29, "Text",
   CellTags->"b:4.2.2"],
  Cell[153445, 4873, 763, 22, 106, "Input",
   CellTags->"b:4.2.2"],
  Cell[154211, 4897, 92, 2, 29, "Text",
   CellTags->"b:4.2.2"],
  Cell[154306, 4901, 1440, 38, 184, "Input",
   CellTags->"b:4.2.2"],
  Cell[155749, 4941, 108, 3, 50, "Input",
   CellTags->"b:4.2.2"]},
 "c:20"->{
  Cell[155894, 4949, 144, 3, 58, "Subsection",
   CellTags->{"c:20", "b:4.2.3"}]},
 "b:4.2.3"->{
  Cell[155894, 4949, 144, 3, 58, "Subsection",
   CellTags->{"c:20", "b:4.2.3"}],
  Cell[156041, 4954, 161, 5, 29, "Text",
   CellTags->"b:4.2.3"],
  Cell[156205, 4961, 677, 21, 46, "Input",
   CellTags->"b:4.2.3"],
  Cell[156885, 4984, 246, 6, 63, "Text",
   CellTags->"b:4.2.3"],
  Cell[157134, 4992, 432, 14, 74, "Input",
   CellTags->"b:4.2.3"]},
 "c:21"->{
  Cell[157603, 5011, 145, 3, 58, "Subsection",
   CellTags->{"c:21", "b:4.2.4"}]},
 "b:4.2.4"->{
  Cell[157603, 5011, 145, 3, 58, "Subsection",
   CellTags->{"c:21", "b:4.2.4"}],
  Cell[157751, 5016, 169, 5, 63, "Text",
   CellTags->"b:4.2.4"],
  Cell[157923, 5023, 1009, 34, 189, "Input",
   CellTags->"b:4.2.4"],
  Cell[158935, 5059, 133, 4, 29, "Text",
   CellTags->"b:4.2.4"],
  Cell[159071, 5065, 857, 17, 54, "Input",
   CellTags->"b:4.2.4"]},
 "c:22"->{
  Cell[159965, 5087, 256, 8, 62, "Subsection",
   CellTags->{"c:22", "b:4.2.5"}]},
 "b:4.2.5"->{
  Cell[159965, 5087, 256, 8, 62, "Subsection",
   CellTags->{"c:22", "b:4.2.5"}],
  Cell[160224, 5097, 293, 7, 119, "Text",
   CellTags->"b:4.2.5"],
  Cell[160520, 5106, 127, 4, 50, "Input",
   CellTags->"b:4.2.5"],
  Cell[160650, 5112, 668, 20, 99, "Input",
   CellTags->"b:4.2.5"],
  Cell[161321, 5134, 323, 8, 97, "Input",
   CellTags->"b:4.2.5"],
  Cell[161647, 5144, 287, 8, 29, "Text",
   CellTags->"b:4.2.5"],
  Cell[161937, 5154, 102, 3, 50, "Input",
   CellTags->"b:4.2.5"]},
 "c:23"->{
  Cell[162076, 5162, 317, 9, 62, "Subsection",
   CellTags->{"c:23", "b:4.2.6"}]},
 "b:4.2.6"->{
  Cell[162076, 5162, 317, 9, 62, "Subsection",
   CellTags->{"c:23", "b:4.2.6"}],
  Cell[162396, 5173, 157, 5, 29, "Text",
   CellTags->"b:4.2.6"],
  Cell[162556, 5180, 2013, 61, 258, "Input",
   CellTags->"b:4.2.6"],
  Cell[164572, 5243, 137, 4, 29, "Text",
   CellTags->"b:4.2.6"],
  Cell[164712, 5249, 352, 10, 74, "Input",
   CellTags->"b:4.2.6"]},
 "c:24"->{
  Cell[165101, 5264, 343, 9, 62, "Subsection",
   CellTags->{"c:24", "b:4.2.7"}]},
 "b:4.2.7"->{
  Cell[165101, 5264, 343, 9, 62, "Subsection",
   CellTags->{"c:24", "b:4.2.7"}],
  Cell[165447, 5275, 218, 6, 29, "Text",
   CellTags->"b:4.2.7"],
  Cell[165668, 5283, 140, 4, 50, "Input",
   CellTags->"b:4.2.7"],
  Cell[165811, 5289, 140, 3, 50, "Input",
   CellTags->"b:4.2.7"]},
 "c:25"->{
  Cell[166000, 5298, 348, 8, 31, "Section",
   CellTags->"c:25"]},
 "b:4.3.0"->{
  Cell[166373, 5310, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.3.0"}],
  Cell[166481, 5315, 155, 5, 23, "Text",
   CellTags->"b:4.3.0"],
  Cell[166661, 5324, 133, 3, 46, "Input",
   CellTags->"b:4.3.0"],
  Cell[166797, 5329, 173, 3, 22, "Print",
   CellTags->"b:4.3.0"],
  Cell[167007, 5337, 112, 3, 46, "Input",
   CellTags->"b:4.3.0"],
  Cell[167122, 5342, 28492, 755, 474, "Print",
   CellTags->"b:4.3.0"],
  Cell[195629, 6100, 119, 4, 46, "Input",
   CellTags->"b:4.3.0"],
  Cell[195773, 6108, 250, 7, 62, "Input",
   CellTags->"b:4.3.0"],
  Cell[196026, 6117, 10801, 182, 257, "Output",
   CellTags->"b:4.3.0"],
  Cell[206842, 6302, 208, 6, 51, "Text",
   CellTags->"b:4.3.0"],
  Cell[207053, 6310, 93, 3, 45, "Input",
   CellTags->"b:4.3.0"]},
 "c:26"->{
  Cell[207183, 6318, 277, 8, 62, "Subsection",
   CellTags->{"c:26", "b:4.3.1"}]},
 "b:4.3.1"->{
  Cell[207183, 6318, 277, 8, 62, "Subsection",
   CellTags->{"c:26", "b:4.3.1"}],
  Cell[207463, 6328, 364, 8, 51, "Text",
   CellTags->"b:4.3.1"],
  Cell[207830, 6338, 190, 5, 23, "Text",
   CellTags->"b:4.3.1"],
  Cell[208023, 6345, 128, 4, 46, "Input",
   CellTags->"b:4.3.1"],
  Cell[208176, 6353, 961, 30, 46, "Input",
   CellTags->"b:4.3.1"],
  Cell[209140, 6385, 1215, 39, 90, "Output",
   CellTags->"b:4.3.1"],
  Cell[210370, 6427, 114, 2, 23, "Text",
   CellTags->"b:4.3.1"],
  Cell[210509, 6433, 1013, 29, 110, "Input",
   CellTags->"b:4.3.1"],
  Cell[211525, 6464, 1289, 41, 122, "Output",
   CellTags->"b:4.3.1"],
  Cell[212817, 6507, 156, 5, 45, "Output",
   CellTags->"b:4.3.1"],
  Cell[212976, 6514, 154, 5, 45, "Output",
   CellTags->"b:4.3.1"],
  Cell[216522, 6631, 113, 2, 23, "Text",
   CellTags->"b:4.3.1"],
  Cell[216660, 6637, 1035, 29, 64, "Input",
   CellTags->"b:4.3.1"],
  Cell[217698, 6668, 163, 5, 45, "Output",
   CellTags->"b:4.3.1"],
  Cell[217876, 6676, 95, 2, 23, "Text",
   CellTags->"b:4.3.1"],
  Cell[217996, 6682, 581, 16, 94, "Input",
   CellTags->"b:4.3.1"],
  Cell[218580, 6700, 717, 23, 94, "Output",
   CellTags->"b:4.3.1"],
  Cell[219300, 6725, 154, 5, 45, "Output",
   CellTags->"b:4.3.1"],
  Cell[219457, 6732, 156, 5, 45, "Output",
   CellTags->"b:4.3.1"],
  Cell[219628, 6740, 80, 2, 23, "Text",
   CellTags->"b:4.3.1"],
  Cell[219733, 6746, 682, 20, 46, "Input",
   CellTags->{"Do", "b:4.3.1"}],
  Cell[220418, 6768, 171, 5, 45, "Output",
   CellTags->{"Do", "b:4.3.1"}]},
 "c:27"->{
  Cell[220638, 6779, 275, 8, 62, "Subsection",
   CellTags->{"c:27", "b:4.3.2"}]},
 "b:4.3.2"->{
  Cell[220638, 6779, 275, 8, 62, "Subsection",
   CellTags->{"c:27", "b:4.3.2"}],
  Cell[220916, 6789, 375, 12, 25, "Text",
   CellTags->"b:4.3.2"],
  Cell[221316, 6805, 460, 13, 46, "Input",
   CellTags->"b:4.3.2"],
  Cell[221779, 6820, 991, 25, 158, "Output",
   CellTags->"b:4.3.2"],
  Cell[222785, 6848, 93, 2, 23, "Text",
   CellTags->"b:4.3.2"],
  Cell[222903, 6854, 268, 7, 62, "Input",
   CellTags->"b:4.3.2"],
  Cell[223174, 6863, 11917, 201, 182, "Output",
   CellTags->"b:4.3.2"],
  Cell[235106, 7067, 423, 13, 46, "Input",
   CellTags->"b:4.3.2"],
  Cell[235532, 7082, 828, 21, 41, "Text",
   CellTags->"b:4.3.2"],
  Cell[236363, 7105, 487, 16, 46, "Input",
   CellTags->"b:4.3.2"],
  Cell[236853, 7123, 86, 2, 23, "Text",
   CellTags->"b:4.3.2"],
  Cell[236964, 7129, 77, 2, 46, "Input",
   CellTags->"b:4.3.2"],
  Cell[237044, 7133, 1091, 29, 176, "Output",
   CellTags->"b:4.3.2"],
  Cell[238150, 7165, 253, 7, 107, "Text",
   CellTags->"b:4.3.2"],
  Cell[238428, 7176, 5530, 217, 303, "Input",
   CellTags->"b:4.3.2"],
  Cell[243961, 7395, 704, 22, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[244668, 7419, 704, 22, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[245375, 7443, 704, 22, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[246082, 7467, 683, 20, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[246768, 7489, 681, 20, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[247452, 7511, 683, 20, 78, "Output",
   CellTags->"b:4.3.2"],
  Cell[248138, 7533, 2476, 66, 78, "Output",
   CellTags->"b:4.3.2"]},
 "c:28"->{
  Cell[250663, 7605, 259, 8, 62, "Subsection",
   CellTags->{"c:28", "b:4.3.3"}]},
 "b:4.3.3"->{
  Cell[250663, 7605, 259, 8, 62, "Subsection",
   CellTags->{"c:28", "b:4.3.3"}],
  Cell[250925, 7615, 579, 23, 25, "Text",
   CellTags->"b:4.3.3"],
  Cell[251507, 7640, 624, 26, 46, "Input",
   CellTags->"b:4.3.3"],
  Cell[252134, 7668, 231, 6, 24, "Text",
   CellTags->"b:4.3.3"],
  Cell[252390, 7678, 197, 8, 46, "Input",
   CellTags->"b:4.3.3"],
  Cell[252590, 7688, 154, 5, 45, "Output",
   CellTags->"b:4.3.3"],
  Cell[252759, 7696, 228, 6, 24, "Text",
   CellTags->"b:4.3.3"],
  Cell[253012, 7706, 552, 23, 64, "Input",
   CellTags->"b:4.3.3"],
  Cell[253567, 7731, 154, 5, 45, "Output",
   CellTags->"b:4.3.3"],
  Cell[253724, 7738, 154, 5, 45, "Output",
   CellTags->"b:4.3.3"],
  Cell[253915, 7748, 1000, 31, 64, "Input",
   CellTags->{"Do", "b:4.3.3"}],
  Cell[254918, 7781, 169, 5, 45, "Output",
   CellTags->{"Do", "b:4.3.3"}]},
 "c:29"->{
  Cell[255136, 7792, 323, 9, 62, "Subsection",
   CellTags->{"c:29", "b:4.3.4"}]},
 "b:4.3.4"->{
  Cell[255136, 7792, 323, 9, 62, "Subsection",
   CellTags->{"c:29", "b:4.3.4"}],
  Cell[255462, 7803, 134, 4, 23, "Text",
   CellTags->"b:4.3.4"],
  Cell[255599, 7809, 398, 12, 46, "Input",
   CellTags->"b:4.3.4"],
  Cell[256000, 7823, 158, 5, 23, "Text",
   CellTags->"b:4.3.4"],
  Cell[256183, 7832, 585, 18, 81, "Input",
   CellTags->"b:4.3.4"],
  Cell[256771, 7852, 156, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[256930, 7859, 153, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[257120, 7869, 819, 24, 64, "Input",
   CellTags->"b:4.3.4"],
  Cell[257942, 7895, 163, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[258142, 7905, 136, 4, 46, "Input",
   CellTags->"b:4.3.4"],
  Cell[258281, 7911, 155, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[258451, 7919, 652, 14, 48, "Input",
   CellTags->"b:4.3.4"],
  Cell[259106, 7935, 136, 4, 23, "Text",
   CellTags->"b:4.3.4"],
  Cell[259245, 7941, 622, 20, 48, "Input",
   CellTags->"b:4.3.4"],
  Cell[259870, 7963, 154, 5, 51, "Text",
   CellTags->"b:4.3.4"],
  Cell[260049, 7972, 511, 17, 124, "Input",
   CellTags->"b:4.3.4"],
  Cell[260563, 7991, 154, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[260720, 7998, 154, 5, 45, "Output",
   CellTags->"b:4.3.4"],
  Cell[260877, 8005, 154, 5, 45, "Output",
   CellTags->"b:4.3.4"]},
 "c:30"->{
  Cell[261080, 8016, 283, 8, 62, "Subsection",
   CellTags->{"c:30", "b:4.3.5"}]},
 "b:4.3.5"->{
  Cell[261080, 8016, 283, 8, 62, "Subsection",
   CellTags->{"c:30", "b:4.3.5"}],
  Cell[261366, 8026, 186, 5, 51, "Text",
   CellTags->"b:4.3.5"],
  Cell[261577, 8035, 296, 8, 62, "Input",
   CellTags->"b:4.3.5"],
  Cell[261876, 8045, 1429, 45, 122, "Output",
   CellTags->"b:4.3.5"],
  Cell[263308, 8092, 158, 5, 45, "Output",
   CellTags->"b:4.3.5"],
  Cell[263481, 8100, 204, 5, 51, "Text",
   CellTags->"b:4.3.5"],
  Cell[263688, 8107, 364, 9, 50, "Input",
   CellTags->"b:4.3.5"],
  Cell[264077, 8120, 3546, 130, 177, "Input",
   CellTags->"b:4.3.5"],
  Cell[267626, 8252, 815, 23, 94, "Output",
   CellTags->"b:4.3.5"],
  Cell[268478, 8280, 236, 7, 46, "Input",
   CellTags->"b:4.3.5"],
  Cell[268717, 8289, 1891, 57, 122, "Output",
   CellTags->"b:4.3.5"]},
 "c:31"->{
  Cell[270657, 8352, 306, 9, 62, "Subsection",
   CellTags->{"c:31", "b:4.3.6"}]},
 "b:4.3.6"->{
  Cell[270657, 8352, 306, 9, 62, "Subsection",
   CellTags->{"c:31", "b:4.3.6"}],
  Cell[270988, 8365, 168, 5, 46, "Input",
   CellTags->"b:4.3.6"],
  Cell[271159, 8372, 723, 21, 94, "Output",
   CellTags->"b:4.3.6"],
  Cell[271897, 8396, 52, 1, 45, "Input",
   CellTags->"b:4.3.6"]},
 "c:32"->{
  Cell[271998, 8403, 377, 8, 74, "Section",
   CellTags->"c:32"],
  Cell[334470, 10346, 81, 2, 51, "Section",
   CellTags->{"c:32", "b:4.5"}]},
 "b:4.4.0"->{
  Cell[272400, 8415, 105, 3, 58, "Subsection",
   CellTags->{"c:3", "b:4.4.0"}],
  Cell[272508, 8420, 138, 3, 23, "Text",
   CellTags->"b:4.4.0"],
  Cell[272671, 8427, 133, 3, 46, "Input",
   CellTags->"b:4.4.0"],
  Cell[272807, 8432, 173, 3, 22, "Print",
   CellTags->"b:4.4.0"],
  Cell[273017, 8440, 112, 3, 46, "Input",
   CellTags->"b:4.4.0"],
  Cell[273132, 8445, 28490, 755, 474, "Print",
   CellTags->"b:4.4.0"],
  Cell[301637, 9203, 215, 5, 23, "Text",
   CellTags->"b:4.4.0"],
  Cell[301855, 9210, 91, 3, 46, "Input",
   CellTags->"b:4.4.0"]},
 "c:33"->{
  Cell[301983, 9218, 185, 6, 58, "Subsection",
   CellTags->{"c:33", "b:4.4.1"}]},
 "b:4.4.1"->{
  Cell[301983, 9218, 185, 6, 58, "Subsection",
   CellTags->{"c:33", "b:4.4.1"}],
  Cell[302171, 9226, 276, 10, 56, "Input",
   CellTags->"b:4.4.1"],
  Cell[302450, 9238, 219, 6, 51, "Text",
   CellTags->"b:4.4.1"],
  Cell[302672, 9246, 93, 3, 45, "Input",
   CellTags->"b:4.4.1"],
  Cell[302790, 9253, 423, 13, 64, "Input",
   CellTags->"b:4.4.1"],
  Cell[303216, 9268, 691, 21, 62, "Output",
   CellTags->"b:4.4.1"],
  Cell[303922, 9292, 197, 5, 51, "Text",
   CellTags->"b:4.4.1"],
  Cell[304144, 9301, 963, 30, 94, "Input",
   CellTags->"b:4.4.1"],
  Cell[305110, 9333, 761, 23, 68, "Output",
   CellTags->"b:4.4.1"],
  Cell[305874, 9358, 833, 25, 100, "Output",
   CellTags->"b:4.4.1"],
  Cell[306744, 9388, 873, 24, 80, "Input",
   CellTags->"b:4.4.1"],
  Cell[307620, 9414, 1091, 29, 176, "Output",
   CellTags->"b:4.4.1"],
  Cell[308726, 9446, 118, 2, 23, "Text",
   CellTags->"b:4.4.1"],
  Cell[308847, 9450, 259, 7, 46, "Input",
   CellTags->"b:4.4.1"]},
 "c:34"->{
  Cell[309143, 9462, 154, 4, 58, "Subsection",
   CellTags->{"c:34", "b:4.4.2"}]},
 "b:4.4.2"->{
  Cell[309143, 9462, 154, 4, 58, "Subsection",
   CellTags->{"c:34", "b:4.4.2"}],
  Cell[309300, 9468, 185, 5, 23, "Text",
   CellTags->"b:4.4.2"],
  Cell[309488, 9475, 1176, 32, 64, "Input",
   CellTags->"b:4.4.2"]},
 "c:35"->{
  Cell[310701, 9512, 144, 3, 58, "Subsection",
   CellTags->{"c:35", "b:4.4.3"}]},
 "b:4.4.3"->{
  Cell[310701, 9512, 144, 3, 58, "Subsection",
   CellTags->{"c:35", "b:4.4.3"}],
  Cell[310848, 9517, 156, 5, 23, "Text",
   CellTags->"b:4.4.3"],
  Cell[311007, 9524, 519, 17, 46, "Input",
   CellTags->"b:4.4.3"],
  Cell[311529, 9543, 174, 5, 51, "Text",
   CellTags->"b:4.4.3"],
  Cell[311728, 9552, 366, 11, 62, "Input",
   CellTags->"b:4.4.3"],
  Cell[312097, 9565, 227, 8, 47, "Output",
   CellTags->"b:4.4.3"],
  Cell[312327, 9575, 281, 10, 51, "Output",
   CellTags->"b:4.4.3"]},
 "c:36"->{
  Cell[312657, 9591, 287, 8, 62, "Subsection",
   CellTags->{"c:36", "b:4.4.4"}]},
 "b:4.4.4"->{
  Cell[312657, 9591, 287, 8, 62, "Subsection",
   CellTags->{"c:36", "b:4.4.4"}],
  Cell[312947, 9601, 182, 5, 51, "Text",
   CellTags->"b:4.4.4"],
  Cell[313154, 9610, 244, 8, 46, "Input",
   CellTags->"b:4.4.4"],
  Cell[313401, 9620, 833, 25, 100, "Output",
   CellTags->"b:4.4.4"],
  Cell[314249, 9648, 117, 2, 23, "Text",
   CellTags->"b:4.4.4"],
  Cell[314391, 9654, 2265, 90, 143, "Input",
   CellTags->"b:4.4.4"],
  Cell[316659, 9746, 792, 25, 80, "Output",
   CellTags->"b:4.4.4"],
  Cell[317454, 9773, 817, 26, 80, "Output",
   CellTags->"b:4.4.4"],
  Cell[318274, 9801, 2704, 75, 82, "Output",
   CellTags->"b:4.4.4"],
  Cell[320993, 9879, 114, 2, 23, "Text",
   CellTags->"b:4.4.4"],
  Cell[321132, 9885, 2284, 91, 143, "Input",
   CellTags->"b:4.4.4"],
  Cell[323419, 9978, 794, 25, 80, "Output",
   CellTags->"b:4.4.4"],
  Cell[324216, 10005, 816, 26, 80, "Output",
   CellTags->"b:4.4.4"],
  Cell[325035, 10033, 2706, 75, 82, "Output",
   CellTags->"b:4.4.4"]},
 "c:37"->{
  Cell[327790, 10114, 165, 5, 58, "Subsection",
   CellTags->{"c:37", "b:4.4.5"}]},
 "b:4.4.5"->{
  Cell[327790, 10114, 165, 5, 58, "Subsection",
   CellTags->{"c:37", "b:4.4.5"}],
  Cell[327980, 10123, 1453, 51, 111, "Input",
   CellTags->"b:4.4.5"],
  Cell[329436, 10176, 736, 22, 64, "Output",
   CellTags->"b:4.4.5"],
  Cell[330175, 10200, 1337, 43, 80, "Output",
   CellTags->"b:4.4.5"],
  Cell[331515, 10245, 1337, 43, 80, "Output",
   CellTags->"b:4.4.5"],
  Cell[332855, 10290, 705, 21, 68, "Output",
   CellTags->"b:4.4.5"],
  Cell[333563, 10313, 705, 21, 68, "Output",
   CellTags->"b:4.4.5"],
  Cell[334283, 10337, 138, 3, 45, "Input",
   CellTags->"b:4.4.5"]},
 "b:4.5"->{
  Cell[334470, 10346, 81, 2, 51, "Section",
   CellTags->{"c:32", "b:4.5"}],
  Cell[334554, 10350, 1340, 40, 49, "Abstract",
   CellTags->"b:4.5"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 403560, 11797},
 {"c:2", 403629, 11800},
 {"c:3", 403701, 11803},
 {"b:4.0.0", 404197, 11816},
 {"b:2.0.0", 404751, 11833},
 {"b:4.0.1", 404892, 11838},
 {"Do", 406956, 11900},
 {"c:4", 408162, 11933},
 {"b:4.0.2", 408257, 11936},
 {"c:5", 410493, 12003},
 {"b:4.0.3", 410588, 12006},
 {"c:6", 412144, 12051},
 {"b:4.0.4", 412239, 12054},
 {"c:7", 413789, 12101},
 {"b:4.0.5", 413884, 12104},
 {"c:8", 416427, 12179},
 {"b:4.1.0", 416507, 12182},
 {"c:9", 416998, 12197},
 {"b:4.1.1", 417094, 12200},
 {"c:10", 417927, 12225},
 {"b:4.1.2", 418024, 12228},
 {"c:11", 418252, 12235},
 {"b:4.1.3", 418349, 12238},
 {"c:12", 418710, 12249},
 {"b:4.1.4", 418807, 12252},
 {"c:13", 419036, 12259},
 {"b:4.1.5", 419133, 12262},
 {"c:14", 419630, 12277},
 {"b:4.1.6", 419727, 12280},
 {"c:15", 420090, 12291},
 {"b:4.1.7", 420188, 12294},
 {"c:16", 420622, 12307},
 {"b:4.1.8", 420719, 12310},
 {"c:17", 420883, 12315},
 {"b:4.2.0", 420964, 12318},
 {"c:18", 421457, 12333},
 {"b:4.2.1", 421554, 12336},
 {"c:19", 422452, 12363},
 {"b:4.2.2", 422549, 12366},
 {"c:20", 422980, 12379},
 {"b:4.2.3", 423077, 12382},
 {"c:21", 423439, 12393},
 {"b:4.2.4", 423536, 12396},
 {"c:22", 423900, 12407},
 {"b:4.2.5", 423997, 12410},
 {"c:23", 424493, 12425},
 {"b:4.2.6", 424590, 12428},
 {"c:24", 424954, 12439},
 {"b:4.2.7", 425051, 12442},
 {"c:25", 425345, 12451},
 {"b:4.3.0", 425426, 12454},
 {"c:26", 426197, 12477},
 {"b:4.3.1", 426294, 12480},
 {"c:27", 427826, 12525},
 {"b:4.3.2", 427923, 12528},
 {"c:28", 429454, 12573},
 {"b:4.3.3", 429551, 12576},
 {"c:29", 430404, 12601},
 {"b:4.3.4", 430501, 12604},
 {"c:30", 431811, 12643},
 {"b:4.3.5", 431908, 12646},
 {"c:31", 432685, 12669},
 {"b:4.3.6", 432782, 12672},
 {"c:32", 433078, 12681},
 {"b:4.4.0", 433236, 12686},
 {"c:33", 433800, 12703},
 {"b:4.4.1", 433897, 12706},
 {"c:34", 434873, 12735},
 {"b:4.4.2", 434970, 12738},
 {"c:35", 435199, 12745},
 {"b:4.4.3", 435296, 12748},
 {"c:36", 435795, 12763},
 {"b:4.4.4", 435892, 12766},
 {"c:37", 436879, 12795},
 {"b:4.4.5", 436977, 12798},
 {"b:4.5", 437564, 12815}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 204, 6, 52, "Title",
 CellTags->"c:1"],
Cell[752, 28, 62, 0, 35, "Subtitle"],
Cell[817, 30, 335, 9, 24, "Abstract"],
Cell[1155, 41, 236, 4, 26, "Text"],
Cell[1394, 47, 109, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[1528, 53, 299, 7, 51, "Section",
 CellTags->"c:2"],
Cell[CellGroupData[{
Cell[1852, 64, 105, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.0.0"}],
Cell[1960, 69, 247, 5, 23, "Text",
 CellTags->"b:4.0.0"],
Cell[CellGroupData[{
Cell[2232, 78, 133, 3, 46, "Input",
 CellTags->"b:2.0.0"],
Cell[2368, 83, 244, 4, 22, "Print",
 CellTags->"b:2.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2649, 92, 112, 3, 46, "Input",
 CellTags->"b:4.0.0"],
Cell[2764, 97, 33520, 937, 495, "Print",
 CellTags->"b:4.0.0"]
}, Open  ]],
Cell[36299, 1037, 269, 6, 23, "Text",
 CellTags->"b:4.0.0"],
Cell[CellGroupData[{
Cell[36593, 1047, 250, 7, 62, "Input",
 CellTags->"b:4.0.0"],
Cell[36846, 1056, 8361, 142, 196, "Output",
 CellTags->"b:4.0.0"]
}, Open  ]],
Cell[45222, 1201, 1008, 32, 56, "Text",
 CellTags->"b:4.0.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46267, 1238, 142, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.0.1"}],
Cell[46412, 1243, 453, 9, 79, "Text",
 Evaluatable->False,
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[46890, 1256, 742, 21, 78, "Input",
 CellTags->"b:4.0.1"],
Cell[47635, 1279, 243, 6, 45, "Output",
 CellTags->"b:4.0.1"],
Cell[47881, 1287, 240, 6, 45, "Output",
 CellTags->"b:4.0.1"],
Cell[48124, 1295, 241, 6, 45, "Output",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[48380, 1304, 103, 2, 23, "Text",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[48508, 1310, 230, 7, 73, "Input",
 CellTags->"b:4.0.1"],
Cell[48741, 1319, 260, 7, 45, "Output",
 CellTags->"b:4.0.1"],
Cell[49004, 1328, 260, 7, 45, "Output",
 CellTags->"b:4.0.1"],
Cell[49267, 1337, 244, 6, 45, "Output",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[49526, 1346, 218, 5, 51, "Text",
 CellTags->"b:4.0.1"],
Cell[49747, 1353, 161, 4, 45, "Input",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[49933, 1361, 384, 12, 64, "Input",
 CellTags->"b:4.0.1"],
Cell[50320, 1375, 873, 25, 78, "Output",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[51208, 1403, 179, 5, 51, "Text",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[51412, 1412, 863, 30, 48, "Input",
 CellTags->"b:4.0.1"],
Cell[52278, 1444, 1019, 27, 62, "Output",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[53312, 1474, 134, 4, 23, "Text",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[53471, 1482, 324, 8, 50, "Input"],
Cell[53798, 1492, 206, 5, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54041, 1502, 710, 19, 48, "Input",
 CellTags->"b:4.0.1"],
Cell[54754, 1523, 176, 3, 21, "Print",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[54945, 1529, 122, 2, 23, "Text",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[55092, 1535, 821, 28, 84, "Input",
 CellTags->"b:4.0.1"],
Cell[55916, 1565, 797, 22, 62, "Output",
 CellTags->"b:4.0.1"],
Cell[56716, 1589, 227, 6, 45, "Output",
 CellTags->"b:4.0.1"],
Cell[56946, 1597, 243, 6, 45, "Output",
 CellTags->"b:4.0.1"]
}, Open  ]],
Cell[57204, 1606, 94, 2, 23, "Text",
 CellTags->"b:4.0.1"],
Cell[CellGroupData[{
Cell[57323, 1612, 512, 14, 46, "Input",
 CellTags->{"Do", "b:4.0.1"}],
Cell[57838, 1628, 194, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.1"}],
Cell[58035, 1633, 193, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.1"}]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[58277, 1642, 128, 3, 58, "Subsection",
 CellTags->{"c:4", "b:4.0.2"}],
Cell[58408, 1647, 221, 6, 51, "Text",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[58654, 1657, 1161, 28, 94, "Input",
 CellTags->"b:4.0.2"],
Cell[59818, 1687, 794, 22, 94, "Output",
 CellTags->"b:4.0.2"],
Cell[60615, 1711, 796, 22, 94, "Output",
 CellTags->"b:4.0.2"],
Cell[61414, 1735, 794, 22, 94, "Output",
 CellTags->"b:4.0.2"],
Cell[62211, 1759, 796, 22, 94, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]],
Cell[63022, 1784, 210, 6, 51, "Text",
 CellTags->"b:4.0.2"],
Cell[63235, 1792, 340, 11, 46, "Input",
 CellTags->"b:4.0.2"],
Cell[63578, 1805, 209, 6, 23, "Text",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[63812, 1815, 132, 4, 46, "Input",
 CellTags->"b:4.0.2"],
Cell[63947, 1821, 1178, 40, 138, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]],
Cell[65140, 1864, 245, 7, 51, "Text",
 CellTags->"b:4.0.2"],
Cell[65388, 1873, 1408, 45, 121, "Input",
 CellTags->"b:4.0.2"],
Cell[66799, 1920, 85, 2, 23, "Text",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[66909, 1926, 378, 14, 116, "Input",
 CellTags->"b:4.0.2"],
Cell[67290, 1942, 893, 26, 112, "Output",
 CellTags->"b:4.0.2"],
Cell[68186, 1970, 895, 26, 112, "Output",
 CellTags->"b:4.0.2"],
Cell[69084, 1998, 941, 28, 112, "Output",
 CellTags->"b:4.0.2"],
Cell[70028, 2028, 939, 28, 112, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]],
Cell[70982, 2059, 333, 8, 79, "Text",
 CellTags->"b:4.0.2"],
Cell[71318, 2069, 185, 6, 46, "Input",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[71528, 2079, 477, 14, 46, "Input",
 CellTags->"b:4.0.2"],
Cell[72008, 2095, 894, 26, 112, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]],
Cell[72917, 2124, 161, 5, 23, "Text",
 CellTags->"b:4.0.2"],
Cell[73081, 2131, 2199, 90, 99, "Input",
 CellTags->"b:4.0.2"],
Cell[75283, 2223, 109, 2, 23, "Text",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[75417, 2229, 81, 1, 61, "Input",
 CellTags->"b:4.0.2"],
Cell[75501, 2232, 771, 23, 78, "Output",
 CellTags->"b:4.0.2"],
Cell[76275, 2257, 771, 23, 78, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]],
Cell[77061, 2283, 99, 2, 23, "Text",
 CellTags->"b:4.0.2"],
Cell[CellGroupData[{
Cell[77185, 2289, 119, 2, 45, "Input",
 CellTags->"b:4.0.2"],
Cell[77307, 2293, 2593, 71, 78, "Output",
 CellTags->"b:4.0.2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79949, 2370, 117, 3, 58, "Subsection",
 CellTags->{"c:5", "b:4.0.3"}],
Cell[80069, 2375, 218, 6, 51, "Text",
 CellTags->"b:4.0.3"],
Cell[CellGroupData[{
Cell[80312, 2385, 399, 12, 48, "Input",
 CellTags->"b:4.0.3"],
Cell[80714, 2399, 2252, 52, 158, "Output",
 CellTags->"b:4.0.3"]
}, Open  ]],
Cell[82981, 2454, 94, 2, 23, "Text",
 CellTags->"b:4.0.3"],
Cell[CellGroupData[{
Cell[83100, 2460, 197, 8, 46, "Input",
 CellTags->"b:4.0.3"],
Cell[83300, 2470, 223, 6, 45, "Output",
 CellTags->"b:4.0.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83560, 2481, 332, 14, 46, "Input",
 CellTags->"b:4.0.3"],
Cell[83895, 2497, 229, 6, 45, "Output",
 CellTags->"b:4.0.3"]
}, Open  ]],
Cell[84139, 2506, 272, 10, 26, "Text",
 CellTags->"b:4.0.3"],
Cell[CellGroupData[{
Cell[84436, 2520, 389, 16, 46, "Input",
 CellTags->"b:4.0.3"],
Cell[84828, 2538, 242, 6, 45, "Output",
 CellTags->"b:4.0.3"]
}, Open  ]],
Cell[85085, 2547, 136, 4, 23, "Text",
 CellTags->"b:4.0.3"],
Cell[CellGroupData[{
Cell[85246, 2555, 788, 25, 64, "Input",
 CellTags->{"Do", "b:4.0.3"}],
Cell[86037, 2582, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[86236, 2587, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[86435, 2592, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[86634, 2597, 198, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[86835, 2602, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[87034, 2607, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[87233, 2612, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}],
Cell[87432, 2617, 196, 3, 22, "Print",
 CellTags->{"Do", "b:4.0.3"}]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[87677, 2626, 127, 3, 58, "Subsection",
 CellTags->{"c:6", "b:4.0.4"}],
Cell[87807, 2631, 396, 11, 163, "Text",
 CellTags->"b:4.0.4"],
Cell[88206, 2644, 304, 8, 107, "Text",
 CellTags->"b:4.0.4"],
Cell[88513, 2654, 211, 5, 24, "Text",
 CellTags->"b:4.0.4"],
Cell[88727, 2661, 517, 17, 46, "Input",
 CellTags->"b:4.0.4"],
Cell[89247, 2680, 292, 8, 24, "Text",
 CellTags->"b:4.0.4"],
Cell[CellGroupData[{
Cell[89564, 2692, 394, 12, 64, "Input",
 CellTags->"b:4.0.4"],
Cell[89961, 2706, 242, 6, 45, "Output",
 CellTags->"b:4.0.4"],
Cell[90206, 2714, 243, 6, 45, "Output",
 CellTags->"b:4.0.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90486, 2725, 669, 19, 64, "Input",
 CellTags->"b:4.0.4"],
Cell[91158, 2746, 186, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[91347, 2751, 186, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[91536, 2756, 188, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[91727, 2761, 186, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[91916, 2766, 184, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[92103, 2771, 186, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[92292, 2776, 188, 3, 22, "Print",
 CellTags->"b:4.0.4"],
Cell[92483, 2781, 188, 3, 22, "Print",
 CellTags->"b:4.0.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92708, 2789, 136, 4, 46, "Input",
 CellTags->"b:4.0.4"],
Cell[92847, 2795, 227, 6, 45, "Output",
 CellTags->"b:4.0.4"]
}, Open  ]],
Cell[93089, 2804, 269, 8, 23, "Text",
 CellTags->"b:4.0.4"],
Cell[93361, 2814, 415, 10, 48, "Input",
 CellTags->"b:4.0.4"],
Cell[93779, 2826, 527, 17, 102, "Input",
 CellTags->"b:4.0.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94343, 2848, 139, 3, 58, "Subsection",
 CellTags->{"c:7", "b:4.0.5"}],
Cell[94485, 2853, 444, 13, 82, "Text",
 CellTags->"b:4.0.5"],
Cell[94932, 2868, 372, 13, 62, "Input",
 CellTags->"b:4.0.5"],
Cell[95307, 2883, 471, 16, 50, "Input",
 CellTags->"b:4.0.5"],
Cell[95781, 2901, 161, 5, 23, "Text",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[95967, 2910, 246, 8, 46, "Input",
 CellTags->"b:4.0.5"],
Cell[96216, 2920, 758, 20, 62, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97011, 2945, 615, 18, 46, "Input",
 CellTags->"b:4.0.5"],
Cell[97629, 2965, 756, 20, 62, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98422, 2990, 53, 1, 46, "Input",
 CellTags->"b:4.0.5"],
Cell[98478, 2993, 223, 6, 45, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98738, 3004, 451, 13, 94, "Input",
 CellTags->"b:4.0.5"],
Cell[99192, 3019, 1185, 30, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[100380, 3051, 1185, 30, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[101568, 3083, 1181, 28, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[102752, 3113, 1179, 28, 62, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[103946, 3144, 533, 14, 81, "Text",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[104504, 3162, 228, 8, 46, "Input",
 CellTags->"b:4.0.5"],
Cell[104735, 3172, 1186, 30, 62, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[105936, 3205, 135, 4, 23, "Text",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[106096, 3213, 44, 1, 45, "Input",
 CellTags->"b:4.0.5"],
Cell[106143, 3216, 225, 6, 45, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[106383, 3225, 133, 4, 23, "Text",
 CellTags->"b:4.0.5"],
Cell[106519, 3231, 236, 7, 48, "Input",
 CellTags->"b:4.0.5"],
Cell[106758, 3240, 122, 5, 51, "Text",
 CellTags->"b:4.0.5"],
Cell[106883, 3247, 1457, 27, 751, "Text",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[108365, 3278, 5997, 226, 174, "Input",
 CellTags->"b:4.0.5"],
Cell[114365, 3506, 720, 20, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[115088, 3528, 720, 20, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[115811, 3550, 1016, 27, 62, "Output",
 CellTags->"b:4.0.5"],
Cell[116830, 3579, 1015, 27, 62, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[117860, 3609, 151, 5, 35, "DisplayText",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[118036, 3618, 577, 18, 47, "Input",
 CellTags->"b:4.0.5"],
Cell[118616, 3638, 876, 25, 78, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[119507, 3666, 153, 5, 35, "DisplayText",
 CellTags->"b:4.0.5"],
Cell[CellGroupData[{
Cell[119685, 3675, 107, 3, 46, "Input",
 CellTags->"b:4.0.5"],
Cell[119795, 3680, 873, 25, 78, "Output",
 CellTags->"b:4.0.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120705, 3710, 181, 4, 46, "Input"],
Cell[120889, 3716, 206, 5, 45, "Output"]
}, Open  ]],
Cell[121110, 3724, 120, 2, 45, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[121279, 3732, 342, 8, 51, "Section",
 CellTags->"c:8"],
Cell[CellGroupData[{
Cell[121646, 3744, 105, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.1.0"}],
Cell[121754, 3749, 138, 3, 29, "Text",
 CellTags->"b:4.1.0"],
Cell[121895, 3754, 133, 3, 53, "Input",
 CellTags->"b:4.1.0"],
Cell[122031, 3759, 112, 3, 53, "Input",
 CellTags->"b:4.1.0"],
Cell[122146, 3764, 215, 5, 29, "Text",
 CellTags->"b:4.1.0"],
Cell[122364, 3771, 91, 3, 50, "Input",
 CellTags->"b:4.1.0"],
Cell[122458, 3776, 254, 7, 74, "Input",
 CellTags->"b:4.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122749, 3788, 208, 6, 58, "Subsection",
 CellTags->{"c:9", "b:4.1.1"}],
Cell[122960, 3796, 265, 6, 29, "Text",
 CellTags->"b:4.1.1"],
Cell[123228, 3804, 82, 2, 50, "Input",
 CellTags->"b:4.1.1"],
Cell[123313, 3808, 2736, 77, 237, "Input",
 CellTags->"b:4.1.1"],
Cell[126052, 3887, 329, 9, 50, "Input"],
Cell[126384, 3898, 245, 6, 29, "Text",
 CellTags->"b:4.1.1"],
Cell[126632, 3906, 203, 5, 74, "Input",
 CellTags->"b:4.1.1"],
Cell[126838, 3913, 208, 7, 29, "Text",
 CellTags->"b:4.1.1"],
Cell[127049, 3922, 1107, 30, 120, "Input",
 CellTags->"b:4.1.1"],
Cell[128159, 3954, 123, 2, 29, "Text",
 CellTags->"b:4.1.1"],
Cell[128285, 3958, 402, 11, 74, "Input",
 CellTags->"b:4.1.1"],
Cell[128690, 3971, 101, 2, 29, "Text",
 CellTags->"b:4.1.1"],
Cell[128794, 3975, 804, 22, 106, "Input",
 CellTags->"b:4.1.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129635, 4002, 135, 3, 58, "Subsection",
 CellTags->{"c:10", "b:4.1.2"}],
Cell[129773, 4007, 309, 8, 97, "Text",
 CellTags->"b:4.1.2"],
Cell[130085, 4017, 540, 17, 80, "Input",
 CellTags->"b:4.1.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130662, 4039, 144, 3, 58, "Subsection",
 CellTags->{"c:11", "b:4.1.3"}],
Cell[130809, 4044, 161, 5, 29, "Text",
 CellTags->"b:4.1.3"],
Cell[130973, 4051, 827, 30, 64, "Input",
 CellTags->"b:4.1.3"],
Cell[131803, 4083, 247, 7, 63, "Text",
 CellTags->"b:4.1.3"],
Cell[132053, 4092, 314, 9, 74, "Input",
 CellTags->"b:4.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132404, 4106, 141, 3, 58, "Subsection",
 CellTags->{"c:12", "b:4.1.4"}],
Cell[132548, 4111, 188, 5, 51, "Text",
 CellTags->"b:4.1.4"],
Cell[132739, 4118, 1242, 47, 54, "Input",
 CellTags->"b:4.1.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134018, 4170, 256, 8, 62, "Subsection",
 CellTags->{"c:13", "b:4.1.5"}],
Cell[134277, 4180, 292, 7, 107, "Text",
 CellTags->"b:4.1.5"],
Cell[134572, 4189, 638, 19, 76, "Input",
 CellTags->"b:4.1.5"],
Cell[135213, 4210, 159, 5, 29, "Text",
 CellTags->"b:4.1.5"],
Cell[135375, 4217, 696, 23, 143, "Input",
 CellTags->"b:4.1.5"],
Cell[136074, 4242, 189, 7, 29, "Text",
 CellTags->"b:4.1.5"],
Cell[136266, 4251, 178, 5, 50, "Input",
 CellTags->"b:4.1.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[136481, 4261, 317, 9, 62, "Subsection",
 CellTags->{"c:14", "b:4.1.6"}],
Cell[136801, 4272, 157, 5, 29, "Text",
 CellTags->"b:4.1.6"],
Cell[136961, 4279, 1409, 43, 189, "Input",
 CellTags->"b:4.1.6"],
Cell[138373, 4324, 223, 6, 29, "Text",
 CellTags->"b:4.1.6"],
Cell[138599, 4332, 316, 8, 74, "Input",
 CellTags->"b:4.1.6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138952, 4345, 350, 10, 62, "Subsection",
 CellTags->{"c:15", "b:4.1.7"}],
Cell[139305, 4357, 203, 5, 29, "Text",
 CellTags->"b:4.1.7"],
Cell[139511, 4364, 2287, 89, 194, "Input",
 CellTags->"b:4.1.7"],
Cell[141801, 4455, 137, 4, 29, "Text",
 CellTags->"b:4.1.7"],
Cell[141941, 4461, 2403, 94, 194, "Input",
 CellTags->"b:4.1.7"],
Cell[144347, 4557, 199, 8, 53, "Input",
 CellTags->"b:4.1.7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144583, 4570, 165, 5, 58, "Subsection",
 CellTags->{"c:16", "b:4.1.8"}],
Cell[144751, 4577, 2021, 67, 166, "Input",
 CellTags->"b:4.1.8"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[146821, 4650, 343, 8, 31, "Section",
 CellTags->"c:17"],
Cell[CellGroupData[{
Cell[147189, 4662, 105, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.2.0"}],
Cell[147297, 4667, 138, 3, 29, "Text",
 CellTags->"b:4.2.0"],
Cell[147438, 4672, 133, 3, 53, "Input",
 CellTags->"b:4.2.0"],
Cell[147574, 4677, 112, 3, 53, "Input",
 CellTags->"b:4.2.0"],
Cell[147689, 4682, 215, 5, 29, "Text",
 CellTags->"b:4.2.0"],
Cell[147907, 4689, 115, 4, 50, "Input",
 CellTags->"b:4.2.0"],
Cell[148025, 4695, 254, 7, 74, "Input",
 CellTags->"b:4.2.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[148316, 4707, 164, 5, 58, "Subsection",
 CellTags->{"c:18", "b:4.2.1"}],
Cell[148483, 4714, 215, 6, 63, "Text",
 CellTags->"b:4.2.1"],
Cell[148701, 4722, 210, 5, 50, "Input",
 CellTags->"b:4.2.1"],
Cell[148914, 4729, 109, 2, 29, "Text",
 CellTags->"b:4.2.1"],
Cell[149026, 4733, 229, 6, 74, "Input",
 CellTags->"b:4.2.1"],
Cell[149258, 4741, 84, 2, 29, "Text",
 CellTags->"b:4.2.1"],
Cell[149345, 4745, 147, 4, 50, "Input",
 CellTags->"b:4.2.1"],
Cell[149495, 4751, 378, 10, 63, "Text",
 CellTags->"b:4.2.1"],
Cell[149876, 4763, 1609, 43, 166, "Input",
 CellTags->"b:4.2.1"],
Cell[151488, 4808, 118, 2, 29, "Text",
 CellTags->"b:4.2.1"],
Cell[151609, 4812, 612, 17, 97, "Input",
 CellTags->"b:4.2.1"],
Cell[152224, 4831, 101, 2, 29, "Text",
 CellTags->"b:4.2.1"],
Cell[152328, 4835, 802, 22, 106, "Input",
 CellTags->"b:4.2.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[153167, 4862, 135, 3, 58, "Subsection",
 CellTags->{"c:19", "b:4.2.2"}],
Cell[153305, 4867, 137, 4, 29, "Text",
 CellTags->"b:4.2.2"],
Cell[153445, 4873, 763, 22, 106, "Input",
 CellTags->"b:4.2.2"],
Cell[154211, 4897, 92, 2, 29, "Text",
 CellTags->"b:4.2.2"],
Cell[154306, 4901, 1440, 38, 184, "Input",
 CellTags->"b:4.2.2"],
Cell[155749, 4941, 108, 3, 50, "Input",
 CellTags->"b:4.2.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[155894, 4949, 144, 3, 58, "Subsection",
 CellTags->{"c:20", "b:4.2.3"}],
Cell[156041, 4954, 161, 5, 29, "Text",
 CellTags->"b:4.2.3"],
Cell[156205, 4961, 677, 21, 46, "Input",
 CellTags->"b:4.2.3"],
Cell[156885, 4984, 246, 6, 63, "Text",
 CellTags->"b:4.2.3"],
Cell[157134, 4992, 432, 14, 74, "Input",
 CellTags->"b:4.2.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[157603, 5011, 145, 3, 58, "Subsection",
 CellTags->{"c:21", "b:4.2.4"}],
Cell[157751, 5016, 169, 5, 63, "Text",
 CellTags->"b:4.2.4"],
Cell[157923, 5023, 1009, 34, 189, "Input",
 CellTags->"b:4.2.4"],
Cell[158935, 5059, 133, 4, 29, "Text",
 CellTags->"b:4.2.4"],
Cell[159071, 5065, 857, 17, 54, "Input",
 CellTags->"b:4.2.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159965, 5087, 256, 8, 62, "Subsection",
 CellTags->{"c:22", "b:4.2.5"}],
Cell[160224, 5097, 293, 7, 119, "Text",
 CellTags->"b:4.2.5"],
Cell[160520, 5106, 127, 4, 50, "Input",
 CellTags->"b:4.2.5"],
Cell[160650, 5112, 668, 20, 99, "Input",
 CellTags->"b:4.2.5"],
Cell[161321, 5134, 323, 8, 97, "Input",
 CellTags->"b:4.2.5"],
Cell[161647, 5144, 287, 8, 29, "Text",
 CellTags->"b:4.2.5"],
Cell[161937, 5154, 102, 3, 50, "Input",
 CellTags->"b:4.2.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162076, 5162, 317, 9, 62, "Subsection",
 CellTags->{"c:23", "b:4.2.6"}],
Cell[162396, 5173, 157, 5, 29, "Text",
 CellTags->"b:4.2.6"],
Cell[162556, 5180, 2013, 61, 258, "Input",
 CellTags->"b:4.2.6"],
Cell[164572, 5243, 137, 4, 29, "Text",
 CellTags->"b:4.2.6"],
Cell[164712, 5249, 352, 10, 74, "Input",
 CellTags->"b:4.2.6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165101, 5264, 343, 9, 62, "Subsection",
 CellTags->{"c:24", "b:4.2.7"}],
Cell[165447, 5275, 218, 6, 29, "Text",
 CellTags->"b:4.2.7"],
Cell[165668, 5283, 140, 4, 50, "Input",
 CellTags->"b:4.2.7"],
Cell[165811, 5289, 140, 3, 50, "Input",
 CellTags->"b:4.2.7"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[166000, 5298, 348, 8, 31, "Section",
 CellTags->"c:25"],
Cell[CellGroupData[{
Cell[166373, 5310, 105, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.3.0"}],
Cell[166481, 5315, 155, 5, 23, "Text",
 CellTags->"b:4.3.0"],
Cell[CellGroupData[{
Cell[166661, 5324, 133, 3, 46, "Input",
 CellTags->"b:4.3.0"],
Cell[166797, 5329, 173, 3, 22, "Print",
 CellTags->"b:4.3.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[167007, 5337, 112, 3, 46, "Input",
 CellTags->"b:4.3.0"],
Cell[167122, 5342, 28492, 755, 474, "Print",
 CellTags->"b:4.3.0"]
}, Open  ]],
Cell[195629, 6100, 119, 4, 46, "Input",
 CellTags->"b:4.3.0"],
Cell[CellGroupData[{
Cell[195773, 6108, 250, 7, 62, "Input",
 CellTags->"b:4.3.0"],
Cell[196026, 6117, 10801, 182, 257, "Output",
 CellTags->"b:4.3.0"]
}, Open  ]],
Cell[206842, 6302, 208, 6, 51, "Text",
 CellTags->"b:4.3.0"],
Cell[207053, 6310, 93, 3, 45, "Input",
 CellTags->"b:4.3.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[207183, 6318, 277, 8, 62, "Subsection",
 CellTags->{"c:26", "b:4.3.1"}],
Cell[207463, 6328, 364, 8, 51, "Text",
 CellTags->"b:4.3.1"],
Cell[207830, 6338, 190, 5, 23, "Text",
 CellTags->"b:4.3.1"],
Cell[208023, 6345, 128, 4, 46, "Input",
 CellTags->"b:4.3.1"],
Cell[CellGroupData[{
Cell[208176, 6353, 961, 30, 46, "Input",
 CellTags->"b:4.3.1"],
Cell[209140, 6385, 1215, 39, 90, "Output",
 CellTags->"b:4.3.1"]
}, Open  ]],
Cell[210370, 6427, 114, 2, 23, "Text",
 CellTags->"b:4.3.1"],
Cell[CellGroupData[{
Cell[210509, 6433, 1013, 29, 110, "Input",
 CellTags->"b:4.3.1"],
Cell[211525, 6464, 1289, 41, 122, "Output",
 CellTags->"b:4.3.1"],
Cell[212817, 6507, 156, 5, 45, "Output",
 CellTags->"b:4.3.1"],
Cell[212976, 6514, 154, 5, 45, "Output",
 CellTags->"b:4.3.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[213167, 6524, 288, 8, 62, "Input"],
Cell[213458, 6534, 1779, 52, 128, "Output"],
Cell[215240, 6588, 1267, 40, 122, "Output"]
}, Open  ]],
Cell[216522, 6631, 113, 2, 23, "Text",
 CellTags->"b:4.3.1"],
Cell[CellGroupData[{
Cell[216660, 6637, 1035, 29, 64, "Input",
 CellTags->"b:4.3.1"],
Cell[217698, 6668, 163, 5, 45, "Output",
 CellTags->"b:4.3.1"]
}, Open  ]],
Cell[217876, 6676, 95, 2, 23, "Text",
 CellTags->"b:4.3.1"],
Cell[CellGroupData[{
Cell[217996, 6682, 581, 16, 94, "Input",
 CellTags->"b:4.3.1"],
Cell[218580, 6700, 717, 23, 94, "Output",
 CellTags->"b:4.3.1"],
Cell[219300, 6725, 154, 5, 45, "Output",
 CellTags->"b:4.3.1"],
Cell[219457, 6732, 156, 5, 45, "Output",
 CellTags->"b:4.3.1"]
}, Open  ]],
Cell[219628, 6740, 80, 2, 23, "Text",
 CellTags->"b:4.3.1"],
Cell[CellGroupData[{
Cell[219733, 6746, 682, 20, 46, "Input",
 CellTags->{"Do", "b:4.3.1"}],
Cell[220418, 6768, 171, 5, 45, "Output",
 CellTags->{"Do", "b:4.3.1"}]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[220638, 6779, 275, 8, 62, "Subsection",
 CellTags->{"c:27", "b:4.3.2"}],
Cell[220916, 6789, 375, 12, 25, "Text",
 CellTags->"b:4.3.2"],
Cell[CellGroupData[{
Cell[221316, 6805, 460, 13, 46, "Input",
 CellTags->"b:4.3.2"],
Cell[221779, 6820, 991, 25, 158, "Output",
 CellTags->"b:4.3.2"]
}, Open  ]],
Cell[222785, 6848, 93, 2, 23, "Text",
 CellTags->"b:4.3.2"],
Cell[CellGroupData[{
Cell[222903, 6854, 268, 7, 62, "Input",
 CellTags->"b:4.3.2"],
Cell[223174, 6863, 11917, 201, 182, "Output",
 CellTags->"b:4.3.2"]
}, Open  ]],
Cell[235106, 7067, 423, 13, 46, "Input",
 CellTags->"b:4.3.2"],
Cell[235532, 7082, 828, 21, 41, "Text",
 CellTags->"b:4.3.2"],
Cell[236363, 7105, 487, 16, 46, "Input",
 CellTags->"b:4.3.2"],
Cell[236853, 7123, 86, 2, 23, "Text",
 CellTags->"b:4.3.2"],
Cell[CellGroupData[{
Cell[236964, 7129, 77, 2, 46, "Input",
 CellTags->"b:4.3.2"],
Cell[237044, 7133, 1091, 29, 176, "Output",
 CellTags->"b:4.3.2"]
}, Open  ]],
Cell[238150, 7165, 253, 7, 107, "Text",
 CellTags->"b:4.3.2"],
Cell[CellGroupData[{
Cell[238428, 7176, 5530, 217, 303, "Input",
 CellTags->"b:4.3.2"],
Cell[243961, 7395, 704, 22, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[244668, 7419, 704, 22, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[245375, 7443, 704, 22, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[246082, 7467, 683, 20, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[246768, 7489, 681, 20, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[247452, 7511, 683, 20, 78, "Output",
 CellTags->"b:4.3.2"],
Cell[248138, 7533, 2476, 66, 78, "Output",
 CellTags->"b:4.3.2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[250663, 7605, 259, 8, 62, "Subsection",
 CellTags->{"c:28", "b:4.3.3"}],
Cell[250925, 7615, 579, 23, 25, "Text",
 CellTags->"b:4.3.3"],
Cell[251507, 7640, 624, 26, 46, "Input",
 CellTags->"b:4.3.3"],
Cell[252134, 7668, 231, 6, 24, "Text",
 CellTags->"b:4.3.3"],
Cell[CellGroupData[{
Cell[252390, 7678, 197, 8, 46, "Input",
 CellTags->"b:4.3.3"],
Cell[252590, 7688, 154, 5, 45, "Output",
 CellTags->"b:4.3.3"]
}, Open  ]],
Cell[252759, 7696, 228, 6, 24, "Text",
 CellTags->"b:4.3.3"],
Cell[CellGroupData[{
Cell[253012, 7706, 552, 23, 64, "Input",
 CellTags->"b:4.3.3"],
Cell[253567, 7731, 154, 5, 45, "Output",
 CellTags->"b:4.3.3"],
Cell[253724, 7738, 154, 5, 45, "Output",
 CellTags->"b:4.3.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[253915, 7748, 1000, 31, 64, "Input",
 CellTags->{"Do", "b:4.3.3"}],
Cell[254918, 7781, 169, 5, 45, "Output",
 CellTags->{"Do", "b:4.3.3"}]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[255136, 7792, 323, 9, 62, "Subsection",
 CellTags->{"c:29", "b:4.3.4"}],
Cell[255462, 7803, 134, 4, 23, "Text",
 CellTags->"b:4.3.4"],
Cell[255599, 7809, 398, 12, 46, "Input",
 CellTags->"b:4.3.4"],
Cell[256000, 7823, 158, 5, 23, "Text",
 CellTags->"b:4.3.4"],
Cell[CellGroupData[{
Cell[256183, 7832, 585, 18, 81, "Input",
 CellTags->"b:4.3.4"],
Cell[256771, 7852, 156, 5, 45, "Output",
 CellTags->"b:4.3.4"],
Cell[256930, 7859, 153, 5, 45, "Output",
 CellTags->"b:4.3.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[257120, 7869, 819, 24, 64, "Input",
 CellTags->"b:4.3.4"],
Cell[257942, 7895, 163, 5, 45, "Output",
 CellTags->"b:4.3.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[258142, 7905, 136, 4, 46, "Input",
 CellTags->"b:4.3.4"],
Cell[258281, 7911, 155, 5, 45, "Output",
 CellTags->"b:4.3.4"]
}, Open  ]],
Cell[258451, 7919, 652, 14, 48, "Input",
 CellTags->"b:4.3.4"],
Cell[259106, 7935, 136, 4, 23, "Text",
 CellTags->"b:4.3.4"],
Cell[259245, 7941, 622, 20, 48, "Input",
 CellTags->"b:4.3.4"],
Cell[259870, 7963, 154, 5, 51, "Text",
 CellTags->"b:4.3.4"],
Cell[CellGroupData[{
Cell[260049, 7972, 511, 17, 124, "Input",
 CellTags->"b:4.3.4"],
Cell[260563, 7991, 154, 5, 45, "Output",
 CellTags->"b:4.3.4"],
Cell[260720, 7998, 154, 5, 45, "Output",
 CellTags->"b:4.3.4"],
Cell[260877, 8005, 154, 5, 45, "Output",
 CellTags->"b:4.3.4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[261080, 8016, 283, 8, 62, "Subsection",
 CellTags->{"c:30", "b:4.3.5"}],
Cell[261366, 8026, 186, 5, 51, "Text",
 CellTags->"b:4.3.5"],
Cell[CellGroupData[{
Cell[261577, 8035, 296, 8, 62, "Input",
 CellTags->"b:4.3.5"],
Cell[261876, 8045, 1429, 45, 122, "Output",
 CellTags->"b:4.3.5"],
Cell[263308, 8092, 158, 5, 45, "Output",
 CellTags->"b:4.3.5"]
}, Open  ]],
Cell[263481, 8100, 204, 5, 51, "Text",
 CellTags->"b:4.3.5"],
Cell[263688, 8107, 364, 9, 50, "Input",
 CellTags->"b:4.3.5"],
Cell[CellGroupData[{
Cell[264077, 8120, 3546, 130, 177, "Input",
 CellTags->"b:4.3.5"],
Cell[267626, 8252, 815, 23, 94, "Output",
 CellTags->"b:4.3.5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[268478, 8280, 236, 7, 46, "Input",
 CellTags->"b:4.3.5"],
Cell[268717, 8289, 1891, 57, 122, "Output",
 CellTags->"b:4.3.5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[270657, 8352, 306, 9, 62, "Subsection",
 CellTags->{"c:31", "b:4.3.6"}],
Cell[CellGroupData[{
Cell[270988, 8365, 168, 5, 46, "Input",
 CellTags->"b:4.3.6"],
Cell[271159, 8372, 723, 21, 94, "Output",
 CellTags->"b:4.3.6"]
}, Open  ]],
Cell[271897, 8396, 52, 1, 45, "Input",
 CellTags->"b:4.3.6"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[271998, 8403, 377, 8, 74, "Section",
 CellTags->"c:32"],
Cell[CellGroupData[{
Cell[272400, 8415, 105, 3, 58, "Subsection",
 CellTags->{"c:3", "b:4.4.0"}],
Cell[272508, 8420, 138, 3, 23, "Text",
 CellTags->"b:4.4.0"],
Cell[CellGroupData[{
Cell[272671, 8427, 133, 3, 46, "Input",
 CellTags->"b:4.4.0"],
Cell[272807, 8432, 173, 3, 22, "Print",
 CellTags->"b:4.4.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273017, 8440, 112, 3, 46, "Input",
 CellTags->"b:4.4.0"],
Cell[273132, 8445, 28490, 755, 474, "Print",
 CellTags->"b:4.4.0"]
}, Open  ]],
Cell[301637, 9203, 215, 5, 23, "Text",
 CellTags->"b:4.4.0"],
Cell[301855, 9210, 91, 3, 46, "Input",
 CellTags->"b:4.4.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[301983, 9218, 185, 6, 58, "Subsection",
 CellTags->{"c:33", "b:4.4.1"}],
Cell[302171, 9226, 276, 10, 56, "Input",
 CellTags->"b:4.4.1"],
Cell[302450, 9238, 219, 6, 51, "Text",
 CellTags->"b:4.4.1"],
Cell[302672, 9246, 93, 3, 45, "Input",
 CellTags->"b:4.4.1"],
Cell[CellGroupData[{
Cell[302790, 9253, 423, 13, 64, "Input",
 CellTags->"b:4.4.1"],
Cell[303216, 9268, 691, 21, 62, "Output",
 CellTags->"b:4.4.1"]
}, Open  ]],
Cell[303922, 9292, 197, 5, 51, "Text",
 CellTags->"b:4.4.1"],
Cell[CellGroupData[{
Cell[304144, 9301, 963, 30, 94, "Input",
 CellTags->"b:4.4.1"],
Cell[305110, 9333, 761, 23, 68, "Output",
 CellTags->"b:4.4.1"],
Cell[305874, 9358, 833, 25, 100, "Output",
 CellTags->"b:4.4.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[306744, 9388, 873, 24, 80, "Input",
 CellTags->"b:4.4.1"],
Cell[307620, 9414, 1091, 29, 176, "Output",
 CellTags->"b:4.4.1"]
}, Open  ]],
Cell[308726, 9446, 118, 2, 23, "Text",
 CellTags->"b:4.4.1"],
Cell[308847, 9450, 259, 7, 46, "Input",
 CellTags->"b:4.4.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309143, 9462, 154, 4, 58, "Subsection",
 CellTags->{"c:34", "b:4.4.2"}],
Cell[309300, 9468, 185, 5, 23, "Text",
 CellTags->"b:4.4.2"],
Cell[309488, 9475, 1176, 32, 64, "Input",
 CellTags->"b:4.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310701, 9512, 144, 3, 58, "Subsection",
 CellTags->{"c:35", "b:4.4.3"}],
Cell[310848, 9517, 156, 5, 23, "Text",
 CellTags->"b:4.4.3"],
Cell[311007, 9524, 519, 17, 46, "Input",
 CellTags->"b:4.4.3"],
Cell[311529, 9543, 174, 5, 51, "Text",
 CellTags->"b:4.4.3"],
Cell[CellGroupData[{
Cell[311728, 9552, 366, 11, 62, "Input",
 CellTags->"b:4.4.3"],
Cell[312097, 9565, 227, 8, 47, "Output",
 CellTags->"b:4.4.3"],
Cell[312327, 9575, 281, 10, 51, "Output",
 CellTags->"b:4.4.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[312657, 9591, 287, 8, 62, "Subsection",
 CellTags->{"c:36", "b:4.4.4"}],
Cell[312947, 9601, 182, 5, 51, "Text",
 CellTags->"b:4.4.4"],
Cell[CellGroupData[{
Cell[313154, 9610, 244, 8, 46, "Input",
 CellTags->"b:4.4.4"],
Cell[313401, 9620, 833, 25, 100, "Output",
 CellTags->"b:4.4.4"]
}, Open  ]],
Cell[314249, 9648, 117, 2, 23, "Text",
 CellTags->"b:4.4.4"],
Cell[CellGroupData[{
Cell[314391, 9654, 2265, 90, 143, "Input",
 CellTags->"b:4.4.4"],
Cell[316659, 9746, 792, 25, 80, "Output",
 CellTags->"b:4.4.4"],
Cell[317454, 9773, 817, 26, 80, "Output",
 CellTags->"b:4.4.4"],
Cell[318274, 9801, 2704, 75, 82, "Output",
 CellTags->"b:4.4.4"]
}, Open  ]],
Cell[320993, 9879, 114, 2, 23, "Text",
 CellTags->"b:4.4.4"],
Cell[CellGroupData[{
Cell[321132, 9885, 2284, 91, 143, "Input",
 CellTags->"b:4.4.4"],
Cell[323419, 9978, 794, 25, 80, "Output",
 CellTags->"b:4.4.4"],
Cell[324216, 10005, 816, 26, 80, "Output",
 CellTags->"b:4.4.4"],
Cell[325035, 10033, 2706, 75, 82, "Output",
 CellTags->"b:4.4.4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[327790, 10114, 165, 5, 58, "Subsection",
 CellTags->{"c:37", "b:4.4.5"}],
Cell[CellGroupData[{
Cell[327980, 10123, 1453, 51, 111, "Input",
 CellTags->"b:4.4.5"],
Cell[329436, 10176, 736, 22, 64, "Output",
 CellTags->"b:4.4.5"],
Cell[330175, 10200, 1337, 43, 80, "Output",
 CellTags->"b:4.4.5"],
Cell[331515, 10245, 1337, 43, 80, "Output",
 CellTags->"b:4.4.5"],
Cell[332855, 10290, 705, 21, 68, "Output",
 CellTags->"b:4.4.5"],
Cell[333563, 10313, 705, 21, 68, "Output",
 CellTags->"b:4.4.5"]
}, Open  ]],
Cell[334283, 10337, 138, 3, 45, "Input",
 CellTags->"b:4.4.5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[334470, 10346, 81, 2, 51, "Section",
 CellTags->{"c:32", "b:4.5"}],
Cell[334554, 10350, 1340, 40, 49, "Abstract",
 CellTags->"b:4.5"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
