(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    730876,      21893]
NotebookOptionsPosition[    627427,      18719]
NotebookOutlinePosition[    679449,      20181]
CellTagsIndexPosition[    677399,      20120]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Introductory Tutorial", "Title",
 FontSize->16,
 CellTags->"c:1"],

Cell["Basic tools in QDENSITY/QCWave", "Subtitle",
 CellChangeTimes->{{3.624192757945726*^9, 3.624192762231759*^9}},
 FontSize->16],

Cell[TextData[{
 "Version: 4.0-July 2014--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9.0-10.3"
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, {
  3.5122043095457993`*^9, 3.512204334243861*^9}, {3.512204716872068*^9, 
  3.512204717487535*^9}, {3.61332114153409*^9, 3.61332117425388*^9}, {
  3.624192719233993*^9, 3.624192746841957*^9}, {3.655397982735033*^9, 
  3.6553979855009193`*^9}},
 FontSize->16],

Cell[CellGroupData[{

Cell["\<\
Getting started                To  open   double   click at down arrow  \
--------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.5122044149751883`*^9, 3.512204420963462*^9}, {
  3.512204654694922*^9, 3.512204703295166*^9}},
 FontFamily->"Times",
 CellTags->{"c:2", "b:5.0"}],

Cell[TextData[{
 StyleBox["All the codes simulating quantum circuits will start by loading \
the ",
  FontFamily->"Helvetica",
  FontSize->14],
 StyleBox["QDENSITY and QCWave",
  FontSize->14],
 StyleBox[" packages.\nTo make the packages fully available copy them to the  \
QDENSITY directory to this location on \nyour user account:",
  FontFamily->"Helvetica",
  FontSize->14]
}], "Text",
 CellChangeTimes->{{3.624190383474423*^9, 3.624190392079009*^9}, {
  3.6241926766759357`*^9, 3.6241926949673977`*^9}},
 TextJustification->0,
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToFileName", "[", " ", 
  RowBox[{"{", 
   RowBox[{"$UserBaseDirectory", ",", " ", "\"\<Applications\>\""}], "}"}], 
  "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData["\<\"/Users/franktabakin/Library/Mathematica/Applications/\"\>"],\
 "Output",
 CellChangeTimes->{3.655397992360775*^9, 3.6573788038941107`*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Then you can load the packages ",
  FontFamily->"Helvetica",
  FontSize->14],
 StyleBox["QDENSITY",
  FontSize->14],
 StyleBox[" and ",
  FontFamily->"Helvetica",
  FontSize->14],
 StyleBox["QCWave",
  FontSize->14],
 StyleBox["  using:",
  FontFamily->"Helvetica",
  FontSize->14]
}], "Text",
 CellChangeTimes->{{3.613321198283746*^9, 3.6133212155955057`*^9}},
 TextJustification->0,
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Needs", "[", "\"\<QDENSITY`QCWave`\>\"", "]"}], ";"}], 
  " "}]}], "Input",
 CellChangeTimes->{{3.613237576903551*^9, 3.613237577366025*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.655397992430072*^9, 3.657378804062709*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[StyleBox["To see all the commands contained in the package:  ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 CellChangeTimes->{{3.613321230783722*^9, 3.6133212398385773`*^9}, 
   3.6133971194048977`*^9, 3.613397155369432*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`Qdensity`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["about",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "about", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ControlledX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["FidelityB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "FidelityB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["look",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "look", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nq",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "nq", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["qubit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "qubit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "res1$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Snos",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Snos", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ts$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalH]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[ScriptCapitalH]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Adj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Adj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ControlledY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["for",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "for", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["matrices",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "matrices", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Observables",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Observables", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomBra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "res2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SP",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "SP", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TwoOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "TwoOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[ScriptCapitalP]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[ScriptCapitalP]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["AF",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "AF", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ControlledZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ControlledZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "mc", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["OneOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "OneOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBra2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomBra2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "res2$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Spin",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Spin", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["U",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "U", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[DoubleStruckCapitalI]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[DoubleStruckCapitalI]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["at",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "at", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASE",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "CPHASE", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Had",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Had", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "mcl", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Oracle",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Oracle", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomBraN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomBraN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Rotqbit",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Rotqbit", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["SpinObs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "SpinObs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "v", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Rho]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Bra1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Bra1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["CPHASEV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "CPHASEV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Hadamard",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Hadamard", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mcl$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "mcl$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTrace",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PartialTrace", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomKet1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RotX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "stA", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Vs",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Vs", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Rho]$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Rho]$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "BraV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["cRQN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "cRQN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["HALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "HALL", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["mc$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "mc$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTraceGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PartialTraceGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKet2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomKet2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RotY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["stB",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "stB", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["v$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "v$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Sigma]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Sigma]", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "BraX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Definef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Definef", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["i8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "i8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "MeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PartialTranspose",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PartialTranspose", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomKetN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomKetN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RotZ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RotZ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Swap",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Swap", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ws",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ws", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Phi]A1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["BraY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "BraY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["density",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "density", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["intro",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "intro", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiProjCBasis",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "MultiProjCBasis", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ProjG",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ProjG", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomQubit1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["s$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "s$", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]A2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Phi]A2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CNOT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "CNOT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["DForm2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "DForm2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["j8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "j8", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["MultiQProj",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "MultiQProj", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomQubit2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Schmidt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Schmidt", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["TensorProductQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "TensorProductQ", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Xb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Phi]B1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Coeff",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Coeff", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Discord",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Discord", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Ket1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Ket1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Mutual",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Mutual", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PTrGen",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PTrGen", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["RandomQubitN",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "RandomQubitN", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma0",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Sigma0", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ThreeOp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ThreeOp", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[Phi]B2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[Phi]B2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["Comm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Comm", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "EnTropy", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "KetV", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nb",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "nb", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Purity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Purity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsDate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "rcsDate", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Sigma1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["to",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "to", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Xd",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Xd", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["\[CapitalOmega]s",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "\[CapitalOmega]s", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"]},
        {
         ButtonBox["CompMeasureKet",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "CompMeasureKet", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["EnTropy2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "EnTropy2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "KetX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["neg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "neg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PX",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PX", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["rcsRevision",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "rcsRevision", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Sigma2", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Toffoli",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Toffoli", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroMatrix",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ZeroMatrix", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""},
        {
         ButtonBox["CompPTr",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "CompPTr", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Fidelity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Fidelity", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["KetY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "KetY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["nneg",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "nneg", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["PY",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "PY", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["res1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "res1", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["Sigma3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "Sigma3", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ts",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ts", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], 
         ButtonBox["ZeroT",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-74d6e178-6059-4b78-94fa-afe6ece3a6f7", {
            "ZeroT", "QDENSITY`Qdensity`"}},
          ButtonNote->"QDENSITY`Qdensity`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.095]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657378804598843*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[StyleBox["If you click on any entry in the display above, \
information about it will appear above this line.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "intro"}]], "Input",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData[
 StyleBox["\<\"The commonly used quantum gates and structures used in quantum\
\\n\\n circuits are implemented in the package. Several examples including \
\\n\\n teleportation circuits, Grover search algorithms and Shor's \\n\\n \
factoring algorightms are included. Several additional applications are are \
illustrated.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378804805296*^9},
 CellTags->{"b:5.0", "Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "about"}]], "Input",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData[
 StyleBox["\<\" Qdensity is a Mathematica package to simulate a quantum \
computer \\n\\n on a classical one. This simulation closely follows the \
procedures \\n\\n that would occur in an actual quantum computer, wherein \
quantum \\n\\n interference and superposition play a key role.  \\n\\n \
Although the main emphasis is on using a density matrix approach, \\n\\n \
QDENSITY also handles state vectors. The package comes with a manual \\n\\n \
and several notebooks that should allow the user to build any quantum \\n\\n \
circuit out of conventional quantum gates.  \\n\\n\\n\\n The notebooks \
develop the most relevant quantum algorithms: \\n\\n teleportation, searching \
algorithms and factoring algorithms in \\n\\n a self contained way. Some \
basic cluster model examples are also provided.\\n\\n\\n\\n We thank Joseph \
Burdis for his help with QDENSITY. We also acknowledge \\n\\n the \
participation of Matt McHugh and Mahesh Bandi at an early stage of \\n\\n \
this project. Reza Yoosoofmiya and Sushmita Biswas provided some helpful \
\\n\\n suggestions on the final versions. Insightful comments by Profs. E. \
Gerjuoy (PITT) \\n\\n and Robert B. Griffiths (CMU) are very much \
appreciated. \\n\\n This project was supported,in part, by the N.S.F \"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573788049583893`*^9},
 CellTags->{"b:5.0", "Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46"}]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 StyleBox["To access the MMA 9-10 Palette click here: ",
  FontFamily->"Helvetica"],
 ButtonBox["QDENSpalette.nb",
  BaseStyle->"Hyperlink",
  ButtonData:>{"QDENSpalette14.nb", None}]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QDENSITY`QCWave`*"}]], "Input",
 CellChangeTimes->{{3.613321230783722*^9, 3.6133212398385773`*^9}, 
   3.6133971194048977`*^9, 3.613397155369432*^9, 3.613397192178574*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`QCWave`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`QCWave`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["AmpPlots",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "AmpPlots", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["icase",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "icase", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv5",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv5", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["k1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "k1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["m2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "m2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqD",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqD", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["ns",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "ns", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["oper",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "oper", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Partner2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Partner2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["psif",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "psif", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stV$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stV$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["y$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "y$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"]},
        {
         ButtonBox["coef",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "coef", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["icase$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "icase$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv5$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv5$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["k2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "k2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["MeterGraph",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "MeterGraph", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqD$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqD$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nsz",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nsz", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["oper2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "oper2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Partner3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Partner3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["psif$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "psif$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["temp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "temp", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["\[CapitalOmega]",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "\[CapitalOmega]", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"]},
        {
         ButtonBox["coef$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "coef$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["icas$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "icas$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv6",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv6", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["k2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "k2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["n",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "n", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqs1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqs1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nsz$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nsz$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["opset",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "opset", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["pcase",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "pcase", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["size",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "size", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["temp$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "temp$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["\[CapitalOmega]ALL",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "\[CapitalOmega]ALL", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"]},
        {
         ButtonBox["DForm",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "DForm", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["ip1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "ip1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv6$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv6$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["ks",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "ks", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nimage",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nimage", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqs1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqs1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["ns$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "ns$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["opz",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "opz", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["phase",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "phase", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["size$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "size$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["wav",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "wav", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["\[CapitalOmega]SET",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "\[CapitalOmega]SET", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"]},
        {
         ButtonBox["DFormA",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "DFormA", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["is",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "is", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv7",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv7", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j3$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j3$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["ks$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "ks$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nimage$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nimage$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqs2",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqs2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["n$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "n$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["p1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "p1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Pick1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Pick1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["state",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "state", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["wf",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "wf", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], ""},
        {
         ButtonBox["hit1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "hit1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["is1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "is1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv7$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv7$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["jp",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "jp", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["kt",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "kt", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["np",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "np", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqs2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqs2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Op1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Op1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["p1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "p1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Pick2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Pick2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["state1f",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "state1f", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["wf$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "wf$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], ""},
        {
         ButtonBox["hit2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "hit2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["is2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "is2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv3$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv3$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv8",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv8", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["jp$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "jp$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["kv",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "kv", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["npartdis",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "npartdis", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqu",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqu", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["op1C",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "op1C", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["p2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "p2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Pick3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Pick3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["state2f",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "state2f", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride3$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride3$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["y",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "y", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], ""},
        {
         ButtonBox["hit3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "hit3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["is3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "is3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv4",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv4", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv8$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv8$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["js",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "js", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["kv$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "kv$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["npartdis$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "npartdis$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqu$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqu$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Op2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Op2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["p2$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "p2$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["plist",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "plist", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["statev",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "statev", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stride$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stride$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["yp1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "yp1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], ""},
        {
         ButtonBox["icas",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "icas", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["isz",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "isz", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["iv4$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "iv4$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["j1",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "j1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["js$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "js$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["m2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "m2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["np$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "np$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["nqx",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "nqx", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Op3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Op3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Partner1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "Partner1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["plist$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "plist$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stateV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stateV", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["stV",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "stV", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["yp1$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-638d9554-6409-4925-8a8f-06828477bf86", {
            "yp1$", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.06333333333333332]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.657378805342505*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic operations", "Section",
 FontFamily->"Times",
 CellTags->"c:3"],

Cell[CellGroupData[{

Cell["a) Single qubit states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],

Cell[TextData[{
 StyleBox["The initial state of the system is represented by a density \
matrix. A ",
  FontFamily->"Helvetica"],
 StyleBox["one qubit state ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["in the |0\[RightAngleBracket] state has the density matrix:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox["\[ScriptCapitalP]", "0"]], "Input",
 CellChangeTimes->{{3.613236934577767*^9, 3.6132369352505417`*^9}},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993261628*^9, 3.657378805488782*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["This is also the single qubit  projection operator  \
|0\[RightAngleBracket]\[LeftAngleBracket]0| .",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox[" For the |1\[RightAngleBracket] state, we have",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624192863641254*^9, 3.6241928761844397`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox["\[ScriptCapitalP]", "1"]], "Input",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993291581*^9, 3.657378805614993*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["This is also the single qubit  projection operator  \
|1\[RightAngleBracket]\[LeftAngleBracket]1| .",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox[" Alternatively we can define the state and associated \
density matrix making use of predefined Ket and Bra state vectors",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{3.6241929011595507`*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Ket", "[", "0", "]"}], "\n", 
 RowBox[{"Bra", "[", "1", "]"}]}], "Input",
 CellChangeTimes->{
  3.613233477447679*^9, {3.6133212815718603`*^9, 3.6133213205090647`*^9}, {
   3.624128172183983*^9, 3.624128214905511*^9}, {3.6241282673017807`*^9, 
   3.624128275973822*^9}},
 FontSize->16,
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993306919*^9, 3.6573788057270193`*^9},
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993306919*^9, 3.657378805807858*^9},
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],

Cell[TextData[StyleBox[" These Ket and Bra state vectors can be displayed in \
Dirac notation by resetting the\ncell option \[OpenCurlyDoubleQuote]convert \
to\[CloseCurlyDoubleQuote] ->  standard",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613321370591607*^9, 3.6133214350049677`*^9}, {
  3.6133249786670017`*^9, 3.6133249902641*^9}, {3.613722470598411*^9, 
  3.61372247383969*^9}, {3.624128295391075*^9, 3.624128295660448*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 TemplateBox[{"0"},
  "Ket"], "\n", 
 TemplateBox[{"1"},
  "Bra"]}], "Input",
 CellChangeTimes->{
  3.613233477447679*^9, {3.6133212815718603`*^9, 3.613321343767681*^9}},
 FontSize->16,
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993340809*^9, 3.657378805928845*^9},
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993340809*^9, 3.6573788060143127`*^9},
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],

Cell[TextData[StyleBox[" These Ket and Bra state vectors can also be \
displayed in Dirac notation using the DForm and DFormA  \
\[OpenCurlyDoubleQuote]Dirac Form\[CloseCurlyDoubleQuote] commands.",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613321370591607*^9, 3.6133214350049677`*^9}, {
  3.6133249786670017`*^9, 3.6133249902641*^9}, {3.613722470598411*^9, 
  3.61372247383969*^9}, {3.624128295391075*^9, 3.624128295660448*^9}, {
  3.624192932739489*^9, 3.624192957758863*^9}, {3.6241931737731333`*^9, 
  3.624193182480035*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DForm", "[", 
  RowBox[{"Ket", "[", "0", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", 
  RowBox[{"Bra", "[", "0", "]"}], "]"}]}], "Input",
 CellChangeTimes->{
  3.613233477447679*^9, {3.6133212815718603`*^9, 3.6133213205090647`*^9}, {
   3.624192961528791*^9, 3.6241929923917713`*^9}},
 FontSize->16,
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"0\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979933744802`*^9, 3.657378806203846*^9},
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"","1","\" ) \"","\" < \"","\"0\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979933744802`*^9, 3.657378806289298*^9},
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],

Cell[TextData[{
 StyleBox[" One can also build ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalP]", "0"], TraditionalForm]]],
 StyleBox["using the built -in  tensor product symbol \[CircleTimes]",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613321453679144*^9, 3.613321461013953*^9}, {
  3.613722492007531*^9, 3.613722561270419*^9}, {3.613722636529367*^9, 
  3.6137226680053263`*^9}, {3.624186872347973*^9, 3.624186917876183*^9}, {
  3.624186955474079*^9, 3.6241869562063017`*^9}, {3.624193024191987*^9, 
  3.6241930283870687`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
  RowBox[{"Bra", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], "\[Equal]", 
  RowBox[{"AF", "[", "%", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
  RowBox[{"Bra", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "1"], "\[Equal]", 
  RowBox[{"AF", "[", "%", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "0"], " ", "+", " ", 
   SubscriptBox["\[ScriptCapitalP]", "1"]}], "\[Equal]", 
  RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], "Input",
 CellChangeTimes->{
  3.6132372804999647`*^9, 3.624126754972478*^9, {3.624278410513*^9, 
   3.624278510252934*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979935843163`*^9, 3.657378806414282*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979935843163`*^9, 3.657378806496273*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "1"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979935843163`*^9, 3.657378806593099*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979935843163`*^9, 3.657378806685576*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979935843163`*^9, 3.657378806795629*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox[" Setting earlier cell to standard form prints out the \
ket bra form ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613237305034952*^9, 3.6132373633964367`*^9}, {
  3.6242785828604183`*^9, 3.624278589485964*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  TemplateBox[{"0"},
   "Ket"], "\[TensorProduct]", 
  TemplateBox[{"0"},
   "Bra"]}]], "Input",
 CellChangeTimes->{3.6132372804999647`*^9, 3.613237334597962*^9, 
  3.613722695737335*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979936249647`*^9, 3.6573788069124117`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Note the built -in version has to be flattened using \
the AF command to be a regular matrix; \nhopefully this will be corrected in \
future versions of Mathematica",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613321453679144*^9, 3.613321461013953*^9}, {
   3.613722492007531*^9, 3.613722561270419*^9}, {3.613722636529367*^9, 
   3.6137226680053263`*^9}, {3.624186872347973*^9, 3.624186917876183*^9}, 
   3.624186950322571*^9, 3.624193052518622*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  RowBox[{
   TemplateBox[{"0"},
    "Ket"], "\[TensorProduct]", 
   TemplateBox[{"0"},
    "Bra"]}], "]"}]], "Input",
 CellChangeTimes->{{3.6132330989721327`*^9, 3.613233136557514*^9}, {
   3.613233169676447*^9, 3.613233209580954*^9}, 3.613233496283945*^9, 
   3.613237105429709*^9, {3.613237373788392*^9, 3.613237387223764*^9}, {
   3.62412678256671*^9, 3.6241267894948473`*^9}, {3.6241930637501907`*^9, 
   3.6241930694285727`*^9}},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979936588583`*^9, 3.65737880704662*^9},
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AF"}]], "Input",
 CellChangeTimes->{{3.624126794410203*^9, 3.624126795974943*^9}},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"AF[state]\\n\\n   AF denotes ArrayFlatten,  which is needed \
for \\nthe MMA 9.0 and 10.0 built-in Tensorproduct setup.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378807277254*^9},
 CellTags->"Info-ccd51049-17f4-46bc-9e0c-87672f0e626d"]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox[" A more general 1 qubit state written using Ket in \
input form, ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613325055860667*^9, 3.613325059999547*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GenQubit", " ", "=", " ", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Ket", "[", "0", "]"}]}], " ", "+", " ", 
   RowBox[{"b", "*", 
    RowBox[{"Ket", "[", "1", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.6133250358604097`*^9, 3.613325051817881*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a"},
     {"b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993736369*^9, 3.657378807403447*^9}]
}, Open  ]],

Cell[TextData[StyleBox[" Or using Dirac notation in standard setting form, ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613325055860667*^9, 3.613325105154909*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GenQubit", "=", 
  RowBox[{
   RowBox[{"a", " ", 
    TemplateBox[{"0"},
     "Ket"]}], "+", 
   RowBox[{"b", " ", 
    TemplateBox[{"1"},
     "Ket"], " "}]}]}]], "Input",
 CellChangeTimes->{{3.6133250358604097`*^9, 3.613325039695675*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a"},
     {"b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979937582912`*^9, 3.657378807530314*^9}]
}, Open  ]],

Cell[TextData[StyleBox[" The associated density matrix can be constructed \
using: ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613325055860667*^9, 3.613325105154909*^9}, {
  3.6241931137315693`*^9, 3.624193132248291*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]GenQubit", "=", 
  RowBox[{
   RowBox[{"AF", "[", 
    RowBox[{"GenQubit", "\[TensorProduct]", 
     RowBox[{"Adj", "[", "GenQubit", "]"}]}], "]"}], "/.", "\[VeryThinSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Conjugate", "[", "a", "]"}], "\[Rule]", 
      SuperscriptBox["a", "*"]}], ",", 
     RowBox[{
      RowBox[{"Conjugate", "[", "b", "]"}], "\[Rule]", 
      SuperscriptBox["b", "*"]}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.613233576381659*^9, 3.613233599308341*^9}, 
   3.613237425824525*^9, {3.6132377526215153`*^9, 3.6132377630049953`*^9}, {
   3.613325110645986*^9, 3.613325113750218*^9}, 3.624193545145988*^9},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"a", " ", 
       SuperscriptBox["a", "*"]}], 
      RowBox[{"a", " ", 
       SuperscriptBox["b", "*"]}]},
     {
      RowBox[{"b", " ", 
       SuperscriptBox["a", "*"]}], 
      RowBox[{"b", " ", 
       SuperscriptBox["b", "*"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993775051*^9, 3.657378807646988*^9},
 CellTags->"b:5.1.0"],

Cell[TextData[{
 StyleBox["or by using the  ",
  FontFamily->"Helvetica"],
 "\[Rho]",
 StyleBox["[statein] command",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613321453679144*^9, 3.613321461013953*^9}, {
   3.613722492007531*^9, 3.613722561270419*^9}, {3.613722636529367*^9, 
   3.6137226680053263`*^9}, {3.624186872347973*^9, 3.624186917876183*^9}, 
   3.624186950322571*^9, {3.624188131831559*^9, 3.624188187203614*^9}, {
   3.624193147447171*^9, 3.624193152115807*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\[Rho]"}]], "Input",
 CellChangeTimes->{3.624187095336755*^9},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"\[Rho][statein], \\n\\n\t returns a density matrix from an \
input state\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378807796796*^9},
 CellTags->"Info-92b8f6c0-c01b-4e9a-b79f-5a7ee1940fc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"\[Rho]", "[", "GenQubit", "]"}], "/.", "\[VeryThinSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Conjugate", "[", "a", "]"}], "\[Rule]", 
      SuperscriptBox["a", "*"]}], ",", 
     RowBox[{
      RowBox[{"Conjugate", "[", "b", "]"}], "\[Rule]", 
      SuperscriptBox["b", "*"]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.624187032011507*^9, 3.6241870447353086`*^9}, {
  3.624187080003281*^9, 3.6241870842892303`*^9}, {3.624187957379554*^9, 
  3.624187963644093*^9}, {3.6241880959670687`*^9, 3.624188100230612*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"a", " ", 
       SuperscriptBox["a", "*"]}], 
      RowBox[{"a", " ", 
       SuperscriptBox["b", "*"]}]},
     {
      RowBox[{"b", " ", 
       SuperscriptBox["a", "*"]}], 
      RowBox[{"b", " ", 
       SuperscriptBox["b", "*"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979938578777`*^9, 3.6573788079044657`*^9}]
}, Open  ]],

Cell[TextData[StyleBox[" DForm is contained in QCWAVE.  It also prints out \
results in Dirac Form: ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613237639461556*^9, 3.61323767481805*^9}, {
  3.613325126686426*^9, 3.613325127878625*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DForm", "[", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Ket", "[", "0", "]"}]}], " ", "+", " ", 
   RowBox[{"b", "*", 
    RowBox[{"Ket", "[", "1", "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "DForm"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.613237447863226*^9, 3.613237491680603*^9}, 
   3.613325147241446*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397993873582*^9, 3.6573788080308943`*^9}],

Cell[BoxData[
 StyleBox["\<\"DForm[state]\\n gives output of state in Dirac form.\\nUse \
DFormA for Bra states\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737880815698*^9},
 CellTags->"Info-24462aaf-de2f-4550-90f7-f9a1ef0f9945"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "*", 
   RowBox[{"Bra", "[", "0", "]"}]}], " ", "+", " ", 
  RowBox[{"b", "*", 
   RowBox[{"Bra", "[", "1", "]"}]}]}]], "Input",
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979939459133`*^9, 3.657378808354005*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"a", " ", 
   TemplateBox[{"0"},
    "Bra"]}], "+", 
  RowBox[{"b", " ", 
   TemplateBox[{"1"},
    "Bra"]}]}]], "Input",
 CellChangeTimes->{3.613325266167737*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979939608717`*^9, 3.657378808482121*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DFormA", "[", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Bra", "[", "0", "]"}]}], " ", "+", " ", 
   RowBox[{"b", "*", 
    RowBox[{"Bra", "[", "1", "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.613237447863226*^9, 3.613237491680603*^9}, 
   3.613325147241446*^9, {3.613325222330742*^9, 3.613325236227623*^9}, {
   3.6133252764856977`*^9, 3.613325296306723*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\" ( \"","a","\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"",
    "\" ( \"","b","\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979939914513`*^9, 3.657378808602585*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["And we can evaluate the ",
  FontFamily->"Helvetica"],
 StyleBox[" trace and purity  ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["of the above density matrix.\nWith (",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  TagBox[
   RowBox[{
    RowBox[{
     RowBox[{"a", " ", 
      SuperscriptBox["a", "*"]}], "+", "b"}], " ", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]]],
  CellChangeTimes->{3.624188220549841*^9, 3.6241900557830667`*^9},
  FontSize->16],
 StyleBox["-> 1 for a normalized state, these are both equal to 1 .",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.624193238563397*^9, 3.624193315253763*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Tr", "[", "\[Rho]GenQubit", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Purity", "[", "\[Rho]GenQubit", "]"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{"a", " ", 
    SuperscriptBox["a", "*"]}], "+", 
   RowBox[{"b", " ", 
    SuperscriptBox["b", "*"]}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994008329*^9, 3.6573788087352257`*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"a", " ", 
      SuperscriptBox["a", "*"]}], "+", 
     RowBox[{"b", " ", 
      SuperscriptBox["b", "*"]}]}], ")"}], "2"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994008329*^9, 3.65737880881841*^9},
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Purity"}]], "Input",
 CellChangeTimes->{3.613237712460162*^9},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"Purity[\[Rho]]\\n\\n\t returns the purity of the state \
represented by the \\n\\n density matrix \[Rho]. It is simply \
Tr[\[Rho].\[Rho]].\\n\\n In general the Purity is a real number between 0 and \
1, \\n\\n being equal to 1 only if the state is a pure state.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378808969232*^9},
 CellTags->"Info-b2f223d4-8012-4c5d-8760-579cfb66b1bf"]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 StyleBox["The package also contains  definitions for | + \
\[RightAngleBracket] and | - \[RightAngleBracket] states, ",
  FontFamily->"Helvetica"],
 StyleBox["i.e for states in the plus or minus x-direction",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" :",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6133253196828814`*^9, 3.6133253305715427`*^9}, {
  3.624193329980069*^9, 3.624193335649941*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"KetX", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\n", 
 RowBox[{"KetX", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{
  3.613237809734796*^9, {3.6133253478006697`*^9, 3.613325389789362*^9}},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994096993*^9, 3.6573788090720453`*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994096993*^9, 3.657378809155704*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994096993*^9, 3.6573788092507343`*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994096993*^9, 3.657378809346406*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["One can readily check that the above states are eigenstates of ",
  FontFamily->"Helsinki"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", 
    RowBox[{"1", " "}]], TraditionalForm]],
  FontFamily->"Helsinki"],
 " ,w",
 StyleBox["ith eigenvalues 1 and -1 , respectively:",
  FontFamily->"Helsinki"]
}], "Text",
 CellChangeTimes->{{3.624193390337644*^9, 3.624193392924459*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Sigma]", "1"], ".", 
   RowBox[{"KetX", "[", "0", "]"}]}], " ", "==", " ", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Sigma]", "1"], ".", 
   RowBox[{"KetX", "[", "1", "]"}]}], " ", "==", 
  RowBox[{"-", 
   RowBox[{"KetX", "[", "1", "]"}]}]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994141424*^9, 3.65737880947514*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994141424*^9, 3.657378809559544*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Scalar products",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are simple to compute; for instance, if we have a general state \
in the computational basis, we can compute its scalar product with the | + \
\[RightAngleBracket] or | - \[RightAngleBracket] operators (KetX[0] and \
KetX[1]):",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.624193405569557*^9, 3.624193420093543*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Define", ":", " ", "State1"}], "=", 
    RowBox[{
     RowBox[{"a", "*", 
      RowBox[{"Bra", "[", "0", "]"}]}], "+", 
     RowBox[{"b", "*", 
      RowBox[{"Bra", "[", "1", "]"}]}]}]}], ";", "  ", 
   RowBox[{
   "set", " ", "cell", " ", "to", " ", "standard", " ", "form", " ", "and", 
    " ", "get", " ", "following"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.613237905749243*^9, 3.613237973381591*^9}, {
  3.6133948762830267`*^9, 3.6133948938882637`*^9}},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"State1", "=", 
  RowBox[{
   RowBox[{"a", " ", 
    TemplateBox[{"0"},
     "Bra"]}], "+", 
   RowBox[{"b", " ", 
    TemplateBox[{"1"},
     "Bra"]}]}]}]], "Input",
 CellChangeTimes->{
  3.613237916793249*^9, {3.613394938526773*^9, 3.613394956964025*^9}},
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "b"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994209407*^9, 3.6573788096991034`*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[TextData[StyleBox["We can also get the Dirac for  the adjoint or Bra \
space using DFormA as in:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613238103258806*^9, 3.6132381522376957`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DFormA", "[", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Bra", "[", "0", "]"}]}], "+", 
   RowBox[{"b", "*", 
    RowBox[{"Bra", "[", "1", "]"}]}]}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.613238184134593*^9, 3.6132382106570997`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\" ( \"","a","\" ) \"","\" < \"","\"0\"","\" |\"","\" + \"",
    "\" ( \"","b","\" ) \"","\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994232753*^9, 3.6573788098154163`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Now compute  scalar product <state1 | + \
\[RightAngleBracket]  and  <state1 | - \[RightAngleBracket] ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.6241884349658527`*^9, 3.624188538792109*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"State1", ".", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"State1", ".", 
  RowBox[{"KetX", "[", "1", "]"}]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["a", 
        SqrtBox["2"]], "+", 
       FractionBox["b", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994274382*^9, 3.657378809932487*^9},
 CellTags->"b:5.1.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["a", 
        SqrtBox["2"]], "-", 
       FractionBox["b", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994274382*^9, 3.6573788100167217`*^9},
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["b) MultiQubit states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:5", "b:5.1.1"}],

Cell[TextData[{
 StyleBox[" Multiqubit states and density matrices are built as tensor \
products of single qubit ones,.\nFor example, the ",
  FontFamily->"Helvetica"],
 StyleBox[" two qubit",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" density matrices   | 00 > ",
  FontFamily->"Helvetica"],
 "\[TensorProduct] ",
 StyleBox["< 00 | , | 01 > ",
  FontFamily->"Helvetica"],
 "\[TensorProduct] ",
 StyleBox["< 01 | , | 10 > ",
  FontFamily->"Helvetica"],
 "\[TensorProduct] ",
 StyleBox["< 10 | , and  | 11 > ",
  FontFamily->"Helvetica"],
 "\[TensorProduct] ",
 StyleBox["< 11 |  are obtained by:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6241885987223053`*^9, 3.624188790952106*^9}, {
  3.624188910429326*^9, 3.624188985287815*^9}, {3.6241934459235764`*^9, 
  3.624193452302559*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"AF", "[", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], ")"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "01"]}], ")"}], "]"}]}], "Input",
 CellChangeTimes->{{3.613238318350621*^9, 3.6132383361701117`*^9}, {
  3.613238366824667*^9, 3.613238408975643*^9}, {3.624193545031302*^9, 
  3.624193545043837*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994324044*^9, 3.657378810144144*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994324044*^9, 3.657378810231855*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994324044*^9, 3.657378810335835*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994324044*^9, 3.657378810434094*^9},
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[ScriptCapitalP]", "0"], " ", "==", " ", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
    RowBox[{"Bra", "[", "0", "]"}]}], "]"}]}], "\n", 
 RowBox[{"AF", "[", 
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", " ", 
   SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.613238445217594*^9, 3.613238529594364*^9}, {
   3.6132386068173*^9, 3.613238708987796*^9}, 3.61323874676079*^9, {
   3.613238853053121*^9, 3.6132388633013983`*^9}, {3.613239254165518*^9, 
   3.613239261939003*^9}, {3.6241934802629757`*^9, 3.624193497349824*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994367257*^9, 3.657378810623025*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994367257*^9, 3.657378810718515*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["For example, the ",
  FontFamily->"Helvetica"],
 StyleBox[" two qubit",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" state basis   | 00 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" , | 01 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" , | 10 >  , and  | 11 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" are obtained by:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6241885987223053`*^9, 3.624188790952106*^9}, {
  3.6241888840140457`*^9, 3.6241888982815933`*^9}, {3.624188995470202*^9, 
  3.624189017653082*^9}, {3.6241891828843603`*^9, 3.624189185054461*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
   RowBox[{"Ket", "[", "0", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
   RowBox[{"Ket", "[", "1", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
   RowBox[{"Ket", "[", "0", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
   RowBox[{"Ket", "[", "1", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613238910424962*^9, 3.613239078086611*^9}, {
  3.624193545050322*^9, 3.624193545062729*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.65737881085019*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"00\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.657378810951415*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"1"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.657378811058929*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"01\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.6573788111580553`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.657378811286045*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"10\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.6573788113846207`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.657378811480681*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994460258*^9, 3.6573788115814323`*^9}],

Cell[TextData[{
 StyleBox["A general ",
  FontFamily->"Helvetica"],
 StyleBox[" two qubit",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" state    a | 00 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" + b | 01 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" +c  | 10 >  + d  | 11 > ",
  FontFamily->"Helvetica"],
 " ",
 StyleBox[" is obtained by:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6241885987223053`*^9, 3.624188790952106*^9}, {
  3.6241888840140457`*^9, 3.6241888982815933`*^9}, {3.624188995470202*^9, 
  3.624189017653082*^9}, {3.6241891828843603`*^9, 3.624189237255275*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ket2", "=", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{
      TemplateBox[{"0"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"0"},
       "Ket"]}]}], "+", 
    RowBox[{"b", " ", 
     RowBox[{
      TemplateBox[{"0"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"1"},
       "Ket"]}]}], "+", 
    RowBox[{"c", " ", 
     RowBox[{
      TemplateBox[{"1"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"0"},
       "Ket"]}]}], "+", 
    RowBox[{"d", " ", 
     RowBox[{
      TemplateBox[{"1"},
       "Ket"], "\[TensorProduct]", 
      TemplateBox[{"1"},
       "Ket"]}]}]}]}], ";"}], "\n", 
 RowBox[{"AF", "[", "%", "]"}], "\n", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613239092907892*^9, 3.613239181291891*^9}, 
   3.613239223359084*^9, {3.61347281954606*^9, 3.613472839707197*^9}, {
   3.624189080455742*^9, 3.624189081070806*^9}, {3.6241891450310307`*^9, 
   3.62418914557896*^9}, 3.624193545071043*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a"},
     {"b"},
     {"c"},
     {"d"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979946132097`*^9, 3.657378811720084*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"","c","\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"","d","\")\"","\" |\"",
    "\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979946132097`*^9, 3.657378811808056*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ket2", "=", " ", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{
      RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
      RowBox[{"Ket", "[", "0", "]"}]}]}], "+", " ", 
    RowBox[{"b", " ", 
     RowBox[{
      RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
      RowBox[{"Ket", "[", "1", "]"}]}]}], " ", "+", " ", 
    RowBox[{"c", "  ", 
     RowBox[{
      RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
      RowBox[{"Ket", "[", "0", "]"}]}]}], " ", "+", " ", 
    RowBox[{"d", " ", 
     RowBox[{
      RowBox[{"Ket", "[", "1", "]"}], " ", "\[TensorProduct]", " ", 
      RowBox[{"Ket", "[", "1", "]"}]}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613239092907892*^9, 3.613239181291891*^9}, {
   3.613472856612748*^9, 3.613472857506443*^9}, {3.624189088353016*^9, 
   3.6241890889007072`*^9}, {3.624189152073708*^9, 3.62418915809114*^9}, 
   3.624193545079589*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a"},
     {"b"},
     {"c"},
     {"d"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994660254*^9, 3.6573788119347887`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\"(\"","a","\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    "b","\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"","c","\")\"",
    "\" |\"","\"10\"","\" >\"","\" + \"","\"(\"","d","\")\"","\" |\"",
    "\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994660254*^9, 3.657378812025096*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 StyleBox[" In earlier Qdensity versions, the use of  parentheses in the \
tensor product was essential when considering more than two qubits.\nNow, \
using the built -in tensorproduct and bra ket notation that condition is \
released.\n For instance, the ",
  FontFamily->"Helvetica"],
 StyleBox["three qubit ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["state |011\[RightAngleBracket] corresponds  the  following form:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6132392900624943`*^9, 3.613239304427401*^9}, {
  3.613239456915832*^9, 3.613239511193788*^9}, {3.624189312530551*^9, 
  3.624189326738677*^9}, {3.624193570474683*^9, 3.6241935958540173`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"state", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    TemplateBox[{"0"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"], "\[TensorProduct]", 
    TemplateBox[{"1"},
     "Ket"]}], "]"}]}], "\n", 
 RowBox[{"DForm", "[", "state", "]"}]}], "Input",
 CellChangeTimes->{{3.613239352640203*^9, 3.613239402614545*^9}, 
   3.613239435909606*^9, {3.613240267593163*^9, 3.613240347043003*^9}, {
   3.61324037856991*^9, 3.613240379232555*^9}, {3.613472902555773*^9, 
   3.6134730389793787`*^9}, {3.61347307309839*^9, 3.6134730958600273`*^9}, {
   3.624189356701209*^9, 3.6241893629108887`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"1"},
     {"0"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994696954*^9, 3.657378812169861*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"011\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994696954*^9, 3.6573788122616863`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["The associated projection operator is now simply:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.6132392900624943`*^9, 3.613239304427401*^9}, {
  3.613239456915832*^9, 3.613239511193788*^9}, {3.613239549432013*^9, 
  3.6132395776562147`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  StyleBox[" ",
   FontWeight->"Plain",
   FontColor->RGBColor[
    0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", 
    StyleBox["0",
     ScriptLevel->0]], 
   StyleBox["\[TensorProduct]",
    ScriptLevel->0], 
   StyleBox[
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["1",
      ScriptLevel->0]],
    ScriptLevel->0], 
   StyleBox["\[TensorProduct]",
    ScriptLevel->0], 
   StyleBox[
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox[
      RowBox[{"1", "  "}],
      ScriptLevel->0]],
    ScriptLevel->0]}], 
  StyleBox["]",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]]}]], "Input",
 CellChangeTimes->{{3.613239565259982*^9, 3.613239640136797*^9}, {
  3.6132396857107553`*^9, 3.613239705204183*^9}, {3.6134729658011312`*^9, 
  3.6134729660578613`*^9}, {3.624189400542938*^9, 3.624189402102648*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799472575*^9, 3.657378812401785*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[TextData[StyleBox["As an example, we build a three qubit state as \
follows: \n[Note: KetX[0] and KetX[1] are the eigenstates of SigmaX]",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613239749155994*^9, 3.613239770136057*^9}, {
   3.613396391147394*^9, 3.613396456460988*^9}, {3.613396497982882*^9, 
   3.6133965124835777`*^9}, 3.6241894304769907`*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ket123", " ", "=", 
   RowBox[{"AF", 
    StyleBox["[",
     FontWeight->"Plain",
     FontColor->RGBColor[
      0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", 
     RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", 
     RowBox[{"KetX", "[", "1", "]"}]}], 
    StyleBox["]",
     FontFamily->"Consolas-Bold",
     FontColor->RGBColor[0., 0., 0.]]}]}], " ", 
  ";"}], "\[IndentingNewLine]", "ket123", "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.6133958457522097`*^9, 3.613395848519493*^9}, 
   3.613396026250587*^9, {3.613396091979624*^9, 3.613396166495511*^9}, {
   3.613396220584749*^9, 3.613396225466898*^9}, {3.613396266763863*^9, 
   3.613396309882001*^9}, {3.6241894404356937`*^9, 3.624189451335413*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]},
     {"0"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994741623*^9, 3.6573788125393887`*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"011\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994741623*^9, 3.657378812629972*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[TextData[StyleBox["... and build the density matrix for the above state:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613396539605742*^9, 3.613396554117638*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]123", "=", 
  RowBox[{"AF", "[", 
   RowBox[{"\[Rho]", "[", 
    StyleBox[" ",
     FontWeight->"Plain",
     FontColor->RGBColor[
      0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
    StyleBox["ket123",
     FontWeight->"Plain",
     FontColor->RGBColor[
      0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
    StyleBox["]",
     FontFamily->"Consolas-Bold",
     FontColor->RGBColor[0., 0., 0.]]}], 
   StyleBox["]",
    FontFamily->"Consolas-Bold",
    FontColor->RGBColor[0., 0., 0.]]}]}]], "Input",
 CellChangeTimes->{
  3.613395852254318*^9, {3.613396342404159*^9, 3.6133963574001083`*^9}, {
   3.61339659458442*^9, 3.6133966209857817`*^9}, {3.6241894787518*^9, 
   3.624189509846406*^9}, {3.624189632417712*^9, 3.624189702415988*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994776021*^9, 3.657378812793586*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Then check its ",
  FontFamily->"Helvetica"],
 StyleBox["Trace and Purity",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Tr", "[", "\[Rho]123", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "\[Rho]123", "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994809463*^9, 3.657378812936883*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994809463*^9, 3.657378813027891*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[TextData[StyleBox["For computational base states, we can alternatively  \
use the function KetV[List] and BraV[List]:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.613396641842534*^9, 3.613396687570217*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1"}], "}"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"xx", "=", 
  RowBox[{"AF", "[", "%", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613397362719654*^9, 3.613397368242886*^9}, {
  3.61339917034266*^9, 3.6133992736777477`*^9}, {3.613399310812378*^9, 
  3.61339933698915*^9}, {3.613470980719081*^9, 3.613470981764605*^9}, {
  3.6134712188142033`*^9, 3.613471296107991*^9}, {3.6134715448010883`*^9, 
  3.613471552348054*^9}, {3.613471986218726*^9, 3.613472037065545*^9}, {
  3.624189760478997*^9, 3.624189761540278*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"1"},
     {"0"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994843165*^9, 3.657378813170369*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"011\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994843165*^9, 3.657378813267432*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["A"], "Input",
 CellChangeTimes->{3.624283018907712*^9},
 FontSize->16],

Cell[BoxData[
 TagBox["A",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994876719*^9, 3.657378813403511*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"4", "*", 
    RowBox[{"BraV", "[", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], "]"}]}], 
   " ", "+", " ", 
   RowBox[{"2", " ", 
    RowBox[{"BraV", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], "]"}]}], 
   "+", 
   RowBox[{"A", "*", 
    RowBox[{"BraV", "[", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], "]"}]}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613397382777728*^9, 3.61339738834566*^9}, 
   3.613397582815563*^9, 3.613397666567774*^9, 3.6133977911790943`*^9, {
   3.613399507634158*^9, 3.613399525092966*^9}, {3.624189780357535*^9, 
   3.624189781407083*^9}, {3.6241936582826223`*^9, 3.6241936586652937`*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "A", "0", "0", "0", "0", "0", "0", "0", "0", "0", "4", 
      "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "2", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994892235*^9, 3.657378813537005*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\" + \"","\" ( \"","A","\" ) \"","\" < \"","\"00011\"","\" |\"","\" + \"",
    "\" ( \"","4","\" ) \"","\" < \"","\"01101\"","\" |\"","\" + \"",
    "\" ( \"","2","\" ) \"","\" < \"","\"11101\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994892235*^9, 3.657378813628269*^9},
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["For example, the following expressions give the same output: \n\
Note need to array flatten (AF)  the ",
  FontFamily->"Helvetica"],
 "\[TensorProduct]",
 StyleBox[" product and the TensorProduct from.\nFor TensorProductQ, the AF \
is included,  but {} brackets are needed.",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6241270179963427`*^9, 3.624127048685725*^9}, {
  3.6241272143100863`*^9, 3.62412729249839*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", "0", "}"}], "]"}], "\[Equal]", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", 
    RowBox[{"Ket", "[", "1", "]"}]}], "]"}], "==", 
  RowBox[{"AF", "[", 
   RowBox[{"TensorProduct", "[", " ", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], ",", 
     RowBox[{"Ket", "[", "1", "]"}]}], "]"}], "]"}], "==", 
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], ",", 
     RowBox[{"Ket", "[", "1", "]"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"?", "TensorProductQ"}]}], "Input",
 CellChangeTimes->{{3.613398016719359*^9, 3.61339803341225*^9}, 
   3.6133980694684553`*^9, {3.6133981079293003`*^9, 3.613398160238776*^9}, {
   3.613398973935718*^9, 3.6133990010821333`*^9}, {3.6133990453034077`*^9, 
   3.613399059004469*^9}, {3.624126993062326*^9, 3.6241270105728607`*^9}, {
   3.624127058500506*^9, 3.624127209936392*^9}},
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994938736*^9, 3.657378813770524*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397994938736*^9, 3.657378813868621*^9},
 CellTags->"b:5.1.1"],

Cell[BoxData[
 StyleBox["\<\"TensorProductQ[{a,b,c,...}], Note need to include {.. } \
brackets\\n\\n\t gives the tensor product of A,B,C ... . \\n\\n Now using \
built in definition of TensorProduct.\\nTensorProductQ provides the flattened \
\\nmatrix to be used in qdensity.  \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.6573788140168533`*^9},
 CellTags->{"b:5.1.1", "Info-03e7af49-ee5b-411c-856b-413db1fdb043"}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ket", "[", "a", "]"}]], "Input",
 CellChangeTimes->{{3.624127496489051*^9, 3.624127515518977*^9}, 
   3.624127563900861*^9, {3.624128403799021*^9, 3.6241284176457233`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{"a"},
   "Ket"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995377294*^9, 3.6573788142602*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Ket", "[", "a", "]"}], "\[TensorProduct]", 
  RowBox[{"Ket", "[", "b", "]"}]}]], "Input",
 CellChangeTimes->{{3.624128435097604*^9, 3.624128440618766*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{
   TemplateBox[{"a"},
    "Ket"], "\[TensorProduct]", 
   TemplateBox[{"b"},
    "Ket"]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995389811*^9, 3.657378814660101*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", "a", "]"}], "\[TensorProduct]", 
   RowBox[{"Ket", "[", "b", "]"}]}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.624128435097604*^9, 3.6241284911551437`*^9}, {
  3.624128540644599*^9, 3.624128541510832*^9}, {3.624128649377005*^9, 
  3.624128669412656*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"1"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799541581*^9, 3.657378814789563*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799541581*^9, 3.657378814893045*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799541581*^9, 3.657378814995212*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799541581*^9, 3.6573788151016207`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799541581*^9, 3.657378815226714*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", 
   RowBox[{"Ket", "[", "1", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638523867292844*^9, 3.638523871174526*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"1"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995467084*^9, 3.657378815361349*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 "            ",
 Cell[BoxData[
  StyleBox[
   RowBox[{
   "                       ", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"CNOT", "[", 
        RowBox[{"2", ",", "1", ",", "2"}], "]"}], "  ", "is", " ", "the", " ",
        "ususl", " ", "CNPT", " ", "operator", " ", "for", " ", "two", " ", 
       "qubits", " ", "as", " ", "defined", " ", "by", 
       StyleBox[
        RowBox[{" ", " "}]], 
       RowBox[{"AF", "[", 
        StyleBox[
         RowBox[{
          SubscriptBox["\[ScriptCapitalP]", 
           StyleBox["0",
            ScriptLevel->0]], "\[TensorProduct]", 
          RowBox[{"s", "[", "0", "]"}]}],
         ScriptLevel->0], 
        StyleBox["]",
         ScriptLevel->0]}]}], 
      StyleBox[" ",
       ScriptLevel->0], 
      StyleBox["+",
       ScriptLevel->0], 
      RowBox[{"AF", "[", 
       StyleBox[
        RowBox[{
         SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
         RowBox[{"s", "[", "1", "]"}]}],
        ScriptLevel->0], 
       StyleBox["]",
        ScriptLevel->0]}]}], "\[IndentingNewLine]"}]}],
   FontSize->16]]]
}], "Text",
 CellChangeTimes->{{3.6241270179963427`*^9, 3.624127048685725*^9}, {
  3.6241272143100863`*^9, 3.62412729249839*^9}, {3.638523804520577*^9, 
  3.63852385627249*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{"CNOT", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   RowBox[{
    RowBox[{"AF", "[", 
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["0",
         ScriptLevel->0]], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "0"]}],
      ScriptLevel->0], 
     StyleBox["]",
      ScriptLevel->0]}], 
    StyleBox[" ",
     ScriptLevel->0], 
    StyleBox["+",
     ScriptLevel->0], 
    RowBox[{"AF", "[", 
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
       SubscriptBox["\[Sigma]", "1"]}],
      ScriptLevel->0], 
     StyleBox["]",
      ScriptLevel->0]}]}], 
   StyleBox["\[Equal]",
    ScriptLevel->0], "%"}],
  FontSize->16]}], "Input",
 CellChangeTimes->{{3.638523425969421*^9, 3.63852343337566*^9}, {
  3.6385234695574102`*^9, 3.638523504229761*^9}, {3.638523545024722*^9, 
  3.638523570289719*^9}, {3.638523650994432*^9, 3.638523683330885*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995526394*^9, 3.65737881550056*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995526394*^9, 3.657378815594345*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  StyleBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["0",
      ScriptLevel->0]], "\[TensorProduct]", 
    RowBox[{"s", "[", "0", "]"}]}],
   ScriptLevel->0], 
  StyleBox["]",
   ScriptLevel->0]}]], "Input",
 CellChangeTimes->{{3.63852352499866*^9, 3.6385235361912203`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995643797*^9, 3.657378815727222*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["c) Bell and GHZ states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:6", "b:5.1.2"}],

Cell[TextData[StyleBox[" The Bell (two qubit) and the GHZ (three qubit) \
states are important for understanding entanglement ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624193746911874*^9, 3.6241938344127073`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Bell states",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are the following:\n",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "00"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] + |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "01"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] + |10\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "10"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] - |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "11"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] - |10\[RightAngleBracket] )"
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["They can all be constructed by building  a Bell \
operator from a Hadamard and then a CNOT gate.",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624193911679122*^9, 3.624193943403536*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CNOT", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"had", "[", 
  RowBox[{"2", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Bellop", "=", " ", 
  RowBox[{
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
   RowBox[{"had", "[", 
    RowBox[{"2", ",", "1"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.62419409666529*^9, 3.624194109940762*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995684935*^9, 3.657378815859562*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995684935*^9, 3.657378815954294*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995684935*^9, 3.657378816073948*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"Adj", "[", "Bellop", "]"}], ".", "Bellop"}],
  ScriptLevel->0]], "Input",
 CellChangeTimes->{
  3.613474725914527*^9, {3.613475476151991*^9, 3.61347551145238*^9}, {
   3.613475725777679*^9, 3.613475746502296*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995760562*^9, 3.6573788162286386`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Bellop", ".", " ", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
    RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.62419424716914*^9, 3.6241942483612432`*^9}, 
   3.6241943270803843`*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799580263*^9, 3.657378816446135*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Then full 4 Bell basis states are then: ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624195080892084*^9, 3.6241951065190496`*^9}, {
  3.6241957741917477`*^9, 3.624195798637121*^9}, {3.6242730400993147`*^9, 
  3.62427304550955*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{
    SubscriptBox["B", 
     RowBox[{"i_", ",", "j_"}]], ":=", " ", 
    RowBox[{"Bellop", ".", " ", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "i", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "j", "]"}]}], "]"}]}]}], ";"}],
  FontSize->16]], "Input",
 CellChangeTimes->{{3.62419512417188*^9, 3.624195167554059*^9}, {
  3.624195230688199*^9, 3.624195232477228*^9}, {3.6241954736571827`*^9, 
  3.624195479416016*^9}, {3.624195529965721*^9, 3.62419571270053*^9}, {
  3.624272992075905*^9, 3.624273032662613*^9}},
 FontSize->16],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DForm", "[", 
  SubscriptBox["B", 
   RowBox[{"0", ",", "0"}]], " ", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  SubscriptBox["B", 
   RowBox[{"0", ",", "1"}]], " ", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  SubscriptBox["B", 
   RowBox[{"1", ",", "0"}]], " ", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", 
  SubscriptBox["B", 
   RowBox[{"1", ",", "1"}]], " ", "]"}]}], "Input",
 CellChangeTimes->{{3.613473349125198*^9, 3.6134733534557247`*^9}, {
   3.624194357915715*^9, 3.624194537703003*^9}, 3.6241951514884357`*^9, {
   3.6242730542533693`*^9, 3.62427305761736*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995847313*^9, 3.657378816596203*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"10\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995847313*^9, 3.657378816694469*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"00\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"11\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995847313*^9, 3.657378816804743*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"01\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"10\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995847313*^9, 3.6573788169093018`*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["These states are of great importance in quantum circuits. \
Check,for instance, the Teleportation circuit; click here: ",
  FontFamily->"Helvetica"],
 ButtonBox["Teleportation.nb",
  BaseStyle->"Hyperlink",
  ButtonData:>{"Teleportation.nb", None}]
}], "Text",
 CellChangeTimes->{{3.624281767463629*^9, 3.624281781018852*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Then the density matrices  \[Rho]Bell for these Bell \
states  are:",
 FontFamily->"Helsinki"]], "Text",
 CellChangeTimes->{{3.6241948152094717`*^9, 3.624194829282537*^9}, {
  3.6241949955937233`*^9, 3.624194996684126*^9}, {3.624273433301545*^9, 
  3.6242734347190933`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]Bell", 
     RowBox[{"i_", ",", "j_"}]], ":=", 
    RowBox[{"AF", "[", 
     StyleBox[
      RowBox[{"\[Rho]", "[", 
       SubscriptBox["B", 
        RowBox[{"i", ",", "j"}]], " ", "]"}],
      FontSize->16], 
     StyleBox["]",
      FontSize->16]}]}], "\[IndentingNewLine]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   SubscriptBox["\[Rho]Bell", 
    RowBox[{"0", ",", "0"}]], " "}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]Bell", 
   RowBox[{"0", ",", "1"}]],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]Bell", 
   RowBox[{"1", ",", "0"}]],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  SubscriptBox["\[Rho]Bell", 
   RowBox[{"1", ",", "1"}]],
  FontSize->16]}], "Input",
 CellChangeTimes->{{3.6241949551296053`*^9, 3.624194968930561*^9}, {
  3.62419500210884*^9, 3.624195040706745*^9}, {3.624273148057992*^9, 
  3.6242732355718517`*^9}, {3.624273340973035*^9, 3.6242734027126007`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995902513*^9, 3.6573788170535316`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995902513*^9, 3.657378817157185*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995902513*^9, 3.6573788172710047`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995902513*^9, 3.657378817385395*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"SpinObs", "[", 
    RowBox[{"AF", "[", 
     SubscriptBox["\[Rho]Bell", 
      RowBox[{"0", ",", "0"}]], "]"}], "]"}], " ", "\[IndentingNewLine]", " ", 
   RowBox[{"SpinObs", "[", 
    RowBox[{"AF", "[", 
     SubscriptBox["\[Rho]Bell", 
      RowBox[{"0", ",", "1"}]], "]"}], "]"}], "\[IndentingNewLine]", " ", 
   RowBox[{"SpinObs", "[", 
    RowBox[{"AF", "[", 
     SubscriptBox["\[Rho]Bell", 
      RowBox[{"1", ",", "0"}]], "]"}], "]"}], "\[IndentingNewLine]", " ", 
   RowBox[{"SpinObs", "[", 
    RowBox[{"AF", "[", 
     SubscriptBox["\[Rho]Bell", 
      RowBox[{"1", ",", "1"}]], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.624273682662374*^9, 3.624273711156938*^9}, 
   3.624278771795455*^9, 3.624278958189372*^9, {3.62427914402831*^9, 
   3.624279169542389*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0"},
            {"0", 
             RowBox[{"-", "1"}], "0"},
            {"0", "0", "1"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995951541*^9, 3.657378817635336*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0"},
            {"0", "1", "0"},
            {"0", "0", 
             RowBox[{"-", "1"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995951541*^9, 3.65737881773634*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{"-", "1"}], "0", "0"},
            {"0", "1", "0"},
            {"0", "0", "1"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995951541*^9, 3.6573788178452787`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{"-", "1"}], "0", "0"},
            {"0", 
             RowBox[{"-", "1"}], "0"},
            {"0", "0", 
             RowBox[{"-", "1"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397995951541*^9, 3.657378817955551*^9}]
}, Open  ]],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["GHZ state",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" ",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{3.624194686248461*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["GHZ states",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" can be prepared by having the  following operator act on a state \
with three qubits :",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.6241946940899677`*^9, 3.624194777711978*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CNOT", "[", 
  RowBox[{"3", ",", "1", ",", "3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"CNOT", "[", 
  RowBox[{"3", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"had", "[", 
  RowBox[{"3", ",", "1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.613723188502368*^9, 3.6137231992058477`*^9}, {
  3.624194606284298*^9, 3.6241946204709253`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996004842*^9, 3.657378818098672*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996004842*^9, 3.657378818201182*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0"},
     {"0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0"},
     {"0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996004842*^9, 3.657378818311735*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GHZop", "=", 
    RowBox[{
     RowBox[{"CNOT", "[", 
      RowBox[{"3", ",", "1", ",", "3"}], "]"}], ".", 
     RowBox[{"CNOT", "[", 
      RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
     RowBox[{"had", "[", 
      RowBox[{"3", ",", "1"}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.61347991741864*^9, 3.613479923268484*^9}, {
  3.624195195925902*^9, 3.624195227999786*^9}},
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Then the  basic GHZ state  is:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624195080892084*^9, 3.6241951065190496`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Then the density matrix for this GHZ state  is:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{
   RowBox[{"GHZ", "=", 
    RowBox[{"GHZop", ".", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}]}], ";"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", "%", "]"}],
  FontSize->16]}], "Input",
 CellChangeTimes->{{3.62419512417188*^9, 3.624195167554059*^9}, {
  3.624195230688199*^9, 3.624195232477228*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996083035*^9, 3.6573788184530983`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Then the density matrix for this GHZ state  is:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.6241948152094717`*^9, 3.624194829282537*^9}, {
  3.6241949955937233`*^9, 3.624194996684126*^9}, {3.624195315479396*^9, 
  3.624195332230014*^9}, {3.624195418856732*^9, 3.62419542143207*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{"\[Rho]GHZ", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"\[Rho]", "[", "GHZ", " ", "]"}], "]"}]}],
  FontSize->16], "\[IndentingNewLine]", 
 RowBox[{
  StyleBox[
   RowBox[{"Tr", "[", "\[Rho]GHZ", "]"}],
   FontSize->16], 
  StyleBox["==",
   FontSize->16], 
  StyleBox[
   RowBox[{"Tr", "[", 
    RowBox[{"\[Rho]GHZ", ".", "\[Rho]GHZ"}], "]"}],
   FontSize->16], 
  StyleBox["\[Equal]",
   FontSize->16], "1"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6241949551296053`*^9, 3.624194968930561*^9}, {
  3.62419500210884*^9, 3.624195040706745*^9}, {3.624195338949274*^9, 
  3.6241954092154627`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996121509*^9, 3.657378818666054*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996121509*^9, 3.657378818767475*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Which is mathematically equivalent to building the \
state and then its density matrix  as:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"GHZvec", "=", 
  RowBox[{"AF", "[", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        TemplateBox[{"0"},
         "Ket"], "\[TensorProduct]", 
        TemplateBox[{"0"},
         "Ket"]}], ")"}], "\[TensorProduct]", 
      TemplateBox[{"0"},
       "Ket"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        TemplateBox[{"1"},
         "Ket"], "\[TensorProduct]", 
        TemplateBox[{"1"},
         "Ket"]}], ")"}], "\[TensorProduct]", 
      TemplateBox[{"1"},
       "Ket"]}]}], 
    SqrtBox["2"]], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\n", 
 RowBox[{"\[Rho]GHZvec", "=", 
  RowBox[{"GHZvec", "\[TensorProduct]", 
   RowBox[{"Adj", "[", "GHZvec", "]"}]}]}]}], "Input",
 CellChangeTimes->{
  3.613479684446885*^9, {3.613480129298129*^9, 3.6134801392256603`*^9}, 
   3.613504219535428*^9, {3.613504257019457*^9, 3.613504300835391*^9}, {
   3.624189857781704*^9, 3.6241898588583593`*^9}},
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996166175*^9, 3.6573788189256487`*^9},
 CellTags->"b:5.1.2"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996166175*^9, 3.657378819036024*^9},
 CellTags->"b:5.1.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
          FractionBox["1", "2"]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0", "0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
          FractionBox["1", "2"]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996166175*^9, 3.657378819154984*^9},
 CellTags->"b:5.1.2"]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["Then full 8  GHZ basis states are then: ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624195080892084*^9, 3.6241951065190496`*^9}, {
  3.6241957741917477`*^9, 3.624195798637121*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.2"],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{
    RowBox[{"GHZ2", "[", 
     RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], ":=", 
    RowBox[{"GHZop", ".", 
     RowBox[{"AF", "[", 
      RowBox[{
       RowBox[{"Ket", "[", "i", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "j", "]"}], " ", "\[TensorProduct]", " ", 
       RowBox[{"Ket", "[", "k", "]"}]}], "]"}]}]}], ";"}],
  FontSize->16]], "Input",
 CellChangeTimes->{{3.62419512417188*^9, 3.624195167554059*^9}, {
  3.624195230688199*^9, 3.624195232477228*^9}, {3.6241954736571827`*^9, 
  3.624195479416016*^9}, {3.624195529965721*^9, 3.62419571270053*^9}},
 FontSize->16],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{
   StyleBox["DForm",
    FontSize->16], 
   StyleBox["[",
    FontSize->16], 
   RowBox[{"GHZ2", "[", 
    RowBox[{"0", ",", "0", ",", "0"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   StyleBox["DForm",
    FontSize->16], 
   StyleBox["[",
    FontSize->16], 
   RowBox[{"GHZ2", "[", 
    RowBox[{"0", ",", "0", ",", "1"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{
   StyleBox["DForm",
    FontSize->16], 
   StyleBox["[",
    FontSize->16], 
   RowBox[{"GHZ2", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", 
   RowBox[{"GHZ2", "[", 
    RowBox[{"0", ",", "1", ",", "1"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", 
   RowBox[{"GHZ2", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", 
   RowBox[{"GHZ2", "[", 
    RowBox[{"1", ",", "0", ",", "1"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", 
   RowBox[{"GHZ2", "[", 
    RowBox[{"1", ",", "1", ",", "0"}], "]"}], "]"}],
  FontSize->16], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"DForm", "[", 
   RowBox[{"GHZ2", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}],
  FontSize->16]}], "Input",
 CellChangeTimes->{{3.624195729281499*^9, 3.62419574397359*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378819326659*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"110\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.6573788194344387`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"101\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.6573788195482388`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"100\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378819664839*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378819810994*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"110\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378819924053*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"101\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378820044611*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"100\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996206547*^9, 3.657378820157591*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["d) Subsystems, partial traces", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:7", "b:5.1.3"}],

Cell[TextData[{
 StyleBox[" The density matrix of a specific subsystem can be computed easily \
by taking partial traces of the density matrix of the full system, e.g. we \
will build the ",
  FontFamily->"Helvetica"],
 StyleBox["4 qubit state ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["|0111\[RightAngleBracket] and then recover the state of either the \
subsystem (1) or the subsystems (24).  For example, starting with a four \
qubit state |0111\[RightAngleBracket], its density matrix is constructed and \
then partial traces taken:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "1234"], "=", 
  RowBox[{
   StyleBox[
    RowBox[{"A", 
     StyleBox["F",
      ScriptLevel->0]}]], 
   StyleBox["[",
    ScriptLevel->0], 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["0",
      ScriptLevel->0]], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["1",
       ScriptLevel->0]],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["1",
       ScriptLevel->0]],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["1",
       ScriptLevel->0]],
     ScriptLevel->0]}], 
   StyleBox["]",
    ScriptLevel->0]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox[
   StyleBox["\[Rho]",
    ScriptLevel->0], "1"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "4"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "1234"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "12"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "1234"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SpinObs", "[", 
  SubscriptBox["\[Rho]", "12"], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "24"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "1234"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SpinObs", "[", 
  SubscriptBox["\[Rho]", "24"], "]"}]}], "Input",
 CellChangeTimes->{{3.613504320353313*^9, 3.613504340252046*^9}, {
  3.613504372549904*^9, 3.613504404430119*^9}, {3.6241898726993313`*^9, 
  3.624189875722471*^9}, {3.6242792238477697`*^9, 3.624279240667081*^9}, {
  3.62427966534685*^9, 3.624279685247588*^9}},
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.657378820390038*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.657378820498386*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.657378820615383*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"1"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {
              RowBox[{"-", "1"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", 
             RowBox[{"-", "1"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.657378820730624*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.6573788208621683`*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {
              RowBox[{"-", "1"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {
              RowBox[{"-", "1"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", "1"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979962605*^9, 3.657378820979402*^9},
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[TextData[{
 StyleBox[" We can check basic properties of these density matrices, such as \
their ",
  FontFamily->"Helvetica"],
 StyleBox["length, trace ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["and ",
  FontFamily->"Helvetica"],
 StyleBox["Purity:",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "24"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "24"], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["16",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799633185*^9, 3.6573788211277933`*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799633185*^9, 3.6573788212352533`*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799633185*^9, 3.657378821351492*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["4",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799633185*^9, 3.657378821470149*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799633185*^9, 3.657378821632852*^9},
 CellTags->"b:5.1.3"],

Cell[TextData[StyleBox[" Similarly we can produce a more complicated density \
matrix that is not pure,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a123", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"1", "/", "3"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[ScriptCapitalP]", 
            StyleBox["0",
             ScriptLevel->0]], "\[TensorProduct]", 
           SubscriptBox["\[ScriptCapitalP]", 
            StyleBox["1",
             ScriptLevel->0]]}], ")"}], "\[TensorProduct]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["1",
           ScriptLevel->0]]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}], 
      StyleBox["+",
       ScriptLevel->0], 
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
           SubscriptBox["\[ScriptCapitalP]", 
            StyleBox["1",
             ScriptLevel->0]]}], ")"}], "\[TensorProduct]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["1",
           ScriptLevel->0]]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}], 
      StyleBox["+",
       ScriptLevel->0], 
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[ScriptCapitalP]", 
            StyleBox["0",
             ScriptLevel->0]], "\[TensorProduct]", 
           SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], 
         "\[TensorProduct]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["1",
           ScriptLevel->0]]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}]}], 
     StyleBox[")",
      ScriptLevel->0]}]}], 
   StyleBox["]",
    ScriptLevel->0]}]}]], "Input",
 CellChangeTimes->{{3.613504484584209*^9, 3.613504533034775*^9}, {
  3.6241898976295567`*^9, 3.6241898994948378`*^9}},
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "3"], "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "3"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979963776503`*^9, 3.65737882179601*^9},
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Tr", "[", "a123", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "a123", "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996414818*^9, 3.657378821946024*^9},
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  FractionBox["1", "3"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996414818*^9, 3.657378822055217*^9},
 CellTags->"b:5.1.3"]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["It is interesting to show the density matrix for each \
qubit taking partial traces. These subspace density matrices can be thought \
of  as the density matrices of qubit i in the environment of the remaining 2 \
qubits:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "a123"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["2", "3"], "0"},
     {"0", 
      FractionBox["1", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996444469*^9, 3.657378822195541*^9},
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", "a123"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "3"], "0"},
     {"0", 
      FractionBox["2", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979964630938`*^9, 3.657378822346772*^9},
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", "a123"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996495756*^9, 3.657378822502223*^9},
 CellTags->"b:5.1.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SpinObs", "[", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "3", "}"}], ",", "a123"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.624279781630013*^9, 3.6242797953634453`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {
              FractionBox["1", "3"]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {
              RowBox[{"-", 
               FractionBox["1", "3"]}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", 
             FractionBox["1", "3"]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979965411263`*^9, 3.6573788226622543`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["e) Pauli Spin matrices", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:8", "b:5.1.4"}],

Cell[TextData[{
 StyleBox[" The ",
  FontFamily->"Helvetica"],
 StyleBox["Pauli spin matrices ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["are defined in the package as either s[i] or ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  SubscriptBox["\[Sigma]", "i"]],
  CellChangeTimes->{{3.613723767874393*^9, 3.613723884860752*^9}}],
 StyleBox["  or by using the built in PauliMatrix[i]",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613723900464203*^9, 3.6137239541118107`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s", "[", "0", "]"}], "==", 
  SubscriptBox["\[Sigma]", "0"], "==", 
  RowBox[{"PauliMatrix", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "[", "1", "]"}], "==", 
  SubscriptBox["\[Sigma]", "1"], "==", 
  RowBox[{"PauliMatrix", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "[", "2", "]"}], "==", 
  SubscriptBox["\[Sigma]", "2"], "==", 
  RowBox[{"PauliMatrix", "[", "2", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "[", "3", "]"}], "==", 
  SubscriptBox["\[Sigma]", "3"], "==", 
  RowBox[{"PauliMatrix", "[", "3", "]"}]}]}], "Input",
 CellChangeTimes->{{3.613723767874393*^9, 3.613723884860752*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996562223*^9, 3.6573788228535624`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996562223*^9, 3.657378822964184*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996562223*^9, 3.6573788230853558`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996562223*^9, 3.6573788232058496`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox["\[Sigma]", "0"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "1"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "2"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "3"]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799666615*^9, 3.657378823361761*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799666615*^9, 3.6573788234718924`*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799666615*^9, 3.657378823617601*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799666615*^9, 3.6573788237378387`*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[StyleBox["or alternatively with the notation:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"s", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "3", "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996695574*^9, 3.657378823954956*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1"},
     {"1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996695574*^9, 3.657378824065835*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"\[ImaginaryI]", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996695574*^9, 3.657378824187985*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996695574*^9, 3.657378824308238*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[{
 StyleBox[" ",
  FontFamily->"Helvetica"],
 StyleBox["Pauli spin matrices ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["can be used to build the more general 2 and n qubit density \
matrices, e.g. for a ",
  FontFamily->"Helvetica"],
 StyleBox["general 2 qubit state",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" the density matrix",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" is:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.624195926113078*^9, 3.624195927192295*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]AB", " ", "=", " ", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "/", "4"}], ")"}], "*", 
         RowBox[{"P", "[", 
          RowBox[{"i", ",", "j"}], "]"}], " ", "*", 
         RowBox[{"(", " ", 
          RowBox[{
           SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", " ", 
           SubscriptBox["\[Sigma]", "j"]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "3"}], "}"}]}], "]"}], " ", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", "0"}], "]"}], "\[Rule]", "1"}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "x", "A"]}], " ", ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "y", "A"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "z", "A"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "1"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "x", "B"]}], " ", ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "2"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "y", "B"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "3"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "z", "B"]}]}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "4"}], ")"}], "*", 
    RowBox[{"Simplify", "[", 
     RowBox[{"AF", "[", "  ", 
      RowBox[{"4", "*", "\[Rho]AB"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Tr", "[", "%", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.613504696948608*^9, {3.613571376224772*^9, 3.6135713888075*^9}, {
   3.613571445229944*^9, 3.613571470202325*^9}, {3.613571577342877*^9, 
   3.613571594710926*^9}, {3.613571716892363*^9, 3.613571720261849*^9}, {
   3.6135718094980907`*^9, 3.61357182741768*^9}, 3.624193545107458*^9},
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "3"}], "]"}], "+", 
         SubsuperscriptBox["P", "z", "A"], "+", 
         SubsuperscriptBox["P", "z", "B"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "1"}], "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"3", ",", "2"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "B"], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "B"]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "3"}], "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"2", ",", "3"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "A"], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "A"]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"P", "[", 
             RowBox[{"1", ",", "2"}], "]"}], "+", 
            RowBox[{"P", "[", 
             RowBox[{"2", ",", "1"}], "]"}], "-", 
            RowBox[{"\[ImaginaryI]", " ", 
             RowBox[{"P", "[", 
              RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "1"}], "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"3", ",", "2"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "B"], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "B"]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "3"}], "]"}], "+", 
         SubsuperscriptBox["P", "z", "A"], "-", 
         SubsuperscriptBox["P", "z", "B"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"1", ",", "2"}], "]"}]}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "+", 
         RowBox[{"P", "[", 
          RowBox[{"2", ",", "2"}], "]"}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"P", "[", 
           RowBox[{"1", ",", "3"}], "]"}]}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"2", ",", "3"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "A"], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "A"]}]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "3"}], "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"2", ",", "3"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "A"], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "A"]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"1", ",", "2"}], "]"}]}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "+", 
         RowBox[{"P", "[", 
          RowBox[{"2", ",", "2"}], "]"}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "3"}], "]"}], "-", 
         SubsuperscriptBox["P", "z", "A"], "+", 
         SubsuperscriptBox["P", "z", "B"]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"P", "[", 
           RowBox[{"3", ",", "1"}], "]"}]}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"P", "[", 
           RowBox[{"3", ",", "2"}], "]"}]}], "+", 
         SubsuperscriptBox["P", "x", "B"], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          SubsuperscriptBox["P", "y", "B"]}]}], ")"}]}]},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"P", "[", 
             RowBox[{"1", ",", "2"}], "]"}], "+", 
            RowBox[{"P", "[", 
             RowBox[{"2", ",", "1"}], "]"}], "+", 
            RowBox[{"\[ImaginaryI]", " ", 
             RowBox[{"P", "[", 
              RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox["P", "x", "A"], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[ImaginaryI]", " ", 
             RowBox[{"P", "[", 
              RowBox[{"1", ",", "3"}], "]"}]}], "-", 
            RowBox[{"P", "[", 
             RowBox[{"2", ",", "3"}], "]"}], "+", 
            SubsuperscriptBox["P", "y", "A"]}], ")"}]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox["P", "x", "B"], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[ImaginaryI]", " ", 
             RowBox[{"P", "[", 
              RowBox[{"3", ",", "1"}], "]"}]}], "-", 
            RowBox[{"P", "[", 
             RowBox[{"3", ",", "2"}], "]"}], "+", 
            SubsuperscriptBox["P", "y", "B"]}], ")"}]}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "3"}], "]"}], "-", 
         SubsuperscriptBox["P", "z", "A"], "-", 
         SubsuperscriptBox["P", "z", "B"]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996773369*^9, 3.6573788244994297`*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996773369*^9, 3.657378824613626*^9},
 CellTags->"b:5.1.4"],

Cell[TextData[{
 StyleBox[" ",
  FontFamily->"Helvetica"],
 StyleBox["The above",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" density matrix",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" is of the form ",
  FontFamily->"Helvetica"],
 " \[Rho]AB",
 StyleBox["= ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox["1", "4"], "  ", "[", 
    RowBox[{"1", " ", "+", " ", 
     SubscriptBox[
      OverscriptBox["P", "\[RightVector]"], 
      RowBox[{"A", " "}]]}]}], TraditionalForm]]],
 ".",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["\[Sigma]", "\[RightVector]"], 
      RowBox[{"A", " "}]], "  ", "+", " ", 
     SubscriptBox[
      OverscriptBox["P", "\[RightVector]"], 
      RowBox[{"B", " "}]]}]}], TraditionalForm]]],
 ".",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[RightVector]"], "B"], " "}], 
   TraditionalForm]]],
 " + ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[LongRightArrow]"], 
     RowBox[{"A", " "}]], " "}], TraditionalForm]]],
 ". ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["T", "\[LongLeftRightArrow]"], TraditionalForm]]],
 " . ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[LongLeftArrow]"], 
     RowBox[{"A", " "}]], " "}], TraditionalForm]]],
 "]",
 StyleBox[" as discussed in the text.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Sometimes we need a ",
  FontFamily->"Helvetica"],
 StyleBox["random one qubit density matrix",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" or a ",
  FontFamily->"Helvetica"],
 StyleBox["random 2 qubit density matrix",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[". Now the states are not pure states and thus the Purity is lower \
than one. The procedure used to build the random 2 qubit state can be easily \
generalized to the n qubit case.",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{3.613504742769607*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rho", "=", "RandomQubit2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "\[Equal]", 
  RowBox[{
  "Adj", "[", "rho", 
   "]"}]}], "\[IndentingNewLine]", "rho", "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", "rho", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"SpinObs", "[", "rho", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"rho", ".", "rho"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "rho", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"Tr", "[", 
    RowBox[{"rho", ".", "rho"}], "]"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Eigenvalues", "[", "rho", "]"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"n", ",", "Ev"}], "}"}]}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "Eigenvalues"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "False"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Thick", ",", 
      RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6138139128927517`*^9, 3.61381396165273*^9}, {
  3.613814477492661*^9, 3.61381451307972*^9}, {3.613814543301866*^9, 
  3.613814543735861*^9}, {3.624279905817997*^9, 3.624279932786491*^9}, {
  3.6242799648402987`*^9, 3.624280054117082*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.657378824764257*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.28429386365224174`", 
      RowBox[{
       RowBox[{"-", "0.03077330787610559`"}], "-", 
       RowBox[{"0.04625356680708536`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.06842144628488149`"}], "-", 
       RowBox[{"0.060753283613015366`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.12445323402365842`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.10493183494616869`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03077330787610559`"}], "+", 
       RowBox[{"0.04625356680708536`", " ", "\[ImaginaryI]"}]}], 
      "0.13647101851155263`", 
      RowBox[{
       RowBox[{"-", "0.0065509898362305806`"}], "+", 
       RowBox[{"0.13372310496466447`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0976560345747542`"}], "+", 
       RowBox[{"0.019940889419422164`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.06842144628488149`"}], "+", 
       RowBox[{"0.060753283613015366`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0065509898362305806`"}], "-", 
       RowBox[{"0.13372310496466447`", " ", "\[ImaginaryI]"}]}], 
      "0.29703070322174685`", 
      RowBox[{
       RowBox[{"-", "0.03008196444269918`"}], "+", 
       RowBox[{"0.01650130425356906`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.12445323402365842`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.10493183494616869`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0976560345747542`"}], "-", 
       RowBox[{"0.019940889419422164`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03008196444269918`"}], "-", 
       RowBox[{"0.01650130425356906`", " ", "\[ImaginaryI]"}]}], 
      "0.28220441461445883`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.657378824880805*^9}],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.65737882500307*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {
              RowBox[{"-", "0.3321549617192714`"}]},
             {"0.0816247883871864`"},
             {
              RowBox[{"-", "0.1584702356724113`"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {
              RowBox[{"-", "0.12171054463760952`"}]},
             {"0.059504525107032594`"},
             {"0.16264913374797713`"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.23580448837485568`", "0.05758254003699155`", 
             "0.05846917657974543`"},
            {
             RowBox[{"-", "0.47730987982166634`"}], 
             RowBox[{"-", "0.262008447719778`"}], "0.16138834606487504`"},
            {
             RowBox[{"-", "0.001382686866812824`"}], "0.12550974212130883`", 
             "0.1329965565334011`"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.65737882512324*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.1187811430559304`", 
      RowBox[{
       RowBox[{"-", "0.03068539199213432`"}], "-", 
       RowBox[{"0.0226432892794353`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.035400587056539645`"}], "-", 
       RowBox[{"0.04433966832341536`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.07749083920956931`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.06404553163706922`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03068539199213432`"}], "+", 
       RowBox[{"0.0226432892794353`", " ", "\[ImaginaryI]"}]}], 
      "0.04956985224252391`", 
      RowBox[{"0.005342480964223606`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.057685630614281516`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0515790308950496`"}], "+", 
       RowBox[{"0.006745313260898395`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.035400587056539645`"}], "+", 
       RowBox[{"0.04433966832341536`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.005342480964223606`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.057685630614281516`", " ", "\[ImaginaryI]"}]}], 
      "0.11570169633390961`", 
      RowBox[{
       RowBox[{"-", "0.029008452675091688`"}], "+", 
       RowBox[{"0.022867725226580846`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.07749083920956931`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.06404553163706922`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0515790308950496`"}], "-", 
       RowBox[{"0.006745313260898395`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.029008452675091688`"}], "-", 
       RowBox[{"0.022867725226580846`", " ", "\[ImaginaryI]"}]}], 
      "0.11725018685851074`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.6573788252650127`*^9}],

Cell[BoxData[
 TagBox["0.40130287849087465`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.657378825391059*^9}],

Cell[BoxData[
 TagBox["0.40130287849087465`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.657378825520122*^9}],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {{}, 
     {RGBColor[1, 0, 0], PointSize[Large], Thickness[Large], 
      PointBox[{{1., 0.5235744456291674}, {2., 0.3362455066800491}, {3., 
       0.11638481149566028`}, {4., 0.02379523619512385}}]}, {}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["n", TraditionalForm], 
     FormBox["Ev", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotLabel->FormBox["Eigenvalues", TraditionalForm],
   PlotRange->{{0., 4.}, {0., 0.5235744456291674}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397996811852*^9, 3.657378825716955*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "Purity"}], "\[IndentingNewLine]", 
 RowBox[{"?", "RandomQubitN"}]}], "Input",
 CellChangeTimes->{{3.613724635990411*^9, 3.613724639549246*^9}, {
  3.613814558690959*^9, 3.613814591628696*^9}, {3.6138148675905323`*^9, 
  3.613814868253376*^9}},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"Purity[\[Rho]]\\n\\n\t returns the purity of the state \
represented by the \\n\\n density matrix \[Rho]. It is simply \
Tr[\[Rho].\[Rho]].\\n\\n In general the Purity is a real number between 0 and \
1, \\n\\n being equal to 1 only if the state is a pure state.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378826047997*^9},
 CellTags->"Info-63e4e1e7-e313-44a7-9b0f-3eaba883f1c7"],

Cell[BoxData[
 StyleBox["\<\"RandomQubitN[L], \\n\\n\t returns a random density matrix for \
a L qubit\\nstate.\\nFor compiled version of RandomQubitN--use cRQN[L], gives \
PackedArray\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378826212637*^9},
 CellTags->"Info-0ab23d4a-e032-424b-a8c4-d4983cab7aea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", "one"], "=", "RandomQubit1"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "one"], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"Purity", "[", 
     SubscriptBox["\[Rho]", "one"], "]"}], "]"}]}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.7180054249261415`", 
      RowBox[{
       RowBox[{"-", "0.12717949876733384`"}], "-", 
       RowBox[{"0.4100203308817331`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.12717949876733384`"}], "+", 
       RowBox[{"0.4100203308817331`", " ", "\[ImaginaryI]"}]}], 
      "0.2819945750738586`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997033031*^9, 3.657378826384357*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997033031*^9, 3.6573788265011272`*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["0.9636353238806075`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997033031*^9, 3.657378826628255*^9},
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "two"], "=", "RandomQubit2"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "two"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["\[Rho]", "two"], "]"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.29067565607609924`", 
      RowBox[{"0.15043662251165066`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.17163044024148616`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.05835884551453691`"}], "+", 
       RowBox[{"0.14775026982825676`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.1189391666440187`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.12954197833295908`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.15043662251165066`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.17163044024148616`", " ", "\[ImaginaryI]"}]}], 
      "0.24966610973568598`", 
      RowBox[{"0.11280900143117756`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0923867818000853`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.023665325828969366`"}], "-", 
       RowBox[{"0.16654947560557035`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.05835884551453691`"}], "-", 
       RowBox[{"0.14775026982825676`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.11280900143117756`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0923867818000853`", " ", "\[ImaginaryI]"}]}], 
      "0.15411187802506335`", 
      RowBox[{
       RowBox[{"-", "0.13439827874617127`"}], "-", 
       RowBox[{"0.09314545823106415`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.1189391666440187`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.12954197833295908`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.023665325828969366`"}], "+", 
       RowBox[{"0.16654947560557035`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.13439827874617127`"}], "+", 
       RowBox[{"0.09314545823106415`", " ", "\[ImaginaryI]"}]}], 
      "0.30554635616315134`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979970618467`*^9, 3.6573788267746887`*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["1.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979970618467`*^9, 3.657378826891671*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["0.6330358890029502`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979970618467`*^9, 3.6573788270162497`*^9},
 CellTags->"b:5.1.4"]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["Now the subsystems are also not pure states, for \
instance, the subsystem corresponding to qubit number 2 of the two qubits \
density matrix is obtained by performing the partial trace of qubit 1,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"2", ",", "two"}]], "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     SubscriptBox["\[Rho]", "two"]}], "]"}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.4447875341011626`", 
      RowBox[{"0.016038343765479385`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.07848498201042202`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.016038343765479385`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.07848498201042202`", " ", "\[ImaginaryI]"}]}], 
      "0.5552124658988373`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979970829353`*^9, 3.657378827225048*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Use R",
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontColor->GrayLevel[0]],
 StyleBox["andomQubitN[n] for n qubits",
  FontWeight->"Bold",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.614029969288464*^9, 3.61402999526291*^9}, {
  3.6140300269645433`*^9, 3.6140300291688643`*^9}, {3.614030077766451*^9, 
  3.614030087081059*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Rho]", "4"], "=", 
   RowBox[{"RandomQubitN", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Adj", "[", 
   SubscriptBox["\[Rho]", "4"], "]"}], "==", 
  SubscriptBox["\[Rho]", "4"]}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "4"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["\[Rho]", "4"], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.61402969089848*^9, 3.6140297707245197`*^9}, {
   3.614029866255438*^9, 3.6140298843911037`*^9}, 3.614029937746583*^9, 
   3.614030122867091*^9},
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997112281*^9, 3.657378827386334*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["0.9999999999999999`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997112281*^9, 3.65737882751728*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox["0.11787245729759448`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997112281*^9, 3.6573788276509457`*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[StyleBox["Analogous functions for one qubit Ket and Bra exist:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[{"RandomKet1", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DForm", "[", "%", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "RandomBra1", "\
\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.613504796013287*^9, 3.613504834610401*^9}},
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.6280432378361361`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.111663461534754`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.3899761282498528`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.6640870290569101`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979971441393`*^9, 3.6573788278135777`*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"0.6280432378361361`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.111663461534754`", " ", "\[ImaginaryI]"}]}],"\")\"","\" |\"",
    "\"0\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.3899761282498528`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.6640870290569101`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979971441393`*^9, 3.657378827931691*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"0.5483309685502147`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.187604468562069`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.38145875496736603`"}], "+", 
       RowBox[{"0.7201575734261734`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979971441393`*^9, 3.657378828058353*^9},
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.5483309685502147`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.187604468562069`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"0\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.38145875496736603`"}], "+", 
      RowBox[{"0.7201575734261734`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"1\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979971441393`*^9, 3.657378828184671*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"A3", "=", 
  RowBox[{"RandomKetN", "[", "3", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{"B3", "=", 
  RowBox[{"RandomBraN", "[", "3", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DFormA", "[", "%", "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQPembr+G5N68c/xyOBdOLn78vB9HX3JOqQPSnzp1T
QPTzK7bTQbS+KMNsEJ1nz7wKRKfcebkWRNfMOboJRHus7NgNoo/ptR0H0Ycc
np8G0U3B/ZdB9G3lC7dAtAFD/R0QfUtLUvg8kF57T0wERH8+uf3GTSC9rej8
TRAt/LHwHojeVd4Ept3edr0E0SJyR1+D6JY62x8gek/ldDD9N3rqPxB9iWcF
mH72+uXSW0A69GfhMhBt0Gyv/B2kXzcMTL/Y85zZ4O0rx35nLhYQrSC+nRNE
337dww2i08QOCoPoPIM5YiA65+HXoKMMrx0v9d4OBtEAqz7Hfg==
  "],
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.04077919686563231`"}], "+", 
       RowBox[{"0.3579945480676446`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.04806801364801416`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.3276478898797936`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.13958399612725875`"}], "-", 
       RowBox[{"0.3854403149241039`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.11366168705946682`"}], "-", 
       RowBox[{"0.19481922289882495`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.2835052983260759`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.30819878343806273`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.15699148480803937`"}], "-", 
       RowBox[{"0.34123874991063047`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.3901071704974008`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1907251321380384`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.19077008274574217`"}], "+", 
       RowBox[{"0.013674425417433958`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997178056*^9, 3.6573788283692083`*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.04077919686563231`"}], "+", 
      RowBox[{"0.3579945480676446`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"000\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.04806801364801416`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.3276478898797936`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"001\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.13958399612725875`"}], "-", 
      RowBox[{"0.3854403149241039`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"010\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.11366168705946682`"}], "-", 
      RowBox[{"0.19481922289882495`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"011\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.2835052983260759`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.30819878343806273`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"100\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.15699148480803937`"}], "-", 
      RowBox[{"0.34123874991063047`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"101\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"0.3901071704974008`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.1907251321380384`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"110\"","\" >\"","\" + \"","\"(\"",RowBox[{
      RowBox[{"-", "0.19077008274574217`"}], "+", 
      RowBox[{"0.013674425417433958`", " ", "\[ImaginaryI]"}]}],"\")\"",
    "\" |\"","\"111\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997178056*^9, 3.6573788284904337`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", "0.09287407351293807`"}], "-", 
       RowBox[{"0.014667978349164406`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.304413761604468`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.23412235517187163`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.132351992346165`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.3442769222565843`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.26976687234596974`"}], "-", 
       RowBox[{"0.07984288259941001`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2827455191871134`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.34048100624360966`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.21129539290590854`"}], "-", 
       RowBox[{"0.23625136290438617`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.3555756884203125`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.26741469520693467`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.25119940860390566`"}], "-", 
       RowBox[{"0.26665879880408627`", " ", "\[ImaginaryI]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997178056*^9, 3.657378828621253*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.09287407351293807`"}], "-", 
      RowBox[{"0.014667978349164406`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"000\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.304413761604468`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.23412235517187163`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"001\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.132351992346165`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.3442769222565843`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"010\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.26976687234596974`"}], "-", 
      RowBox[{"0.07984288259941001`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"011\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.2827455191871134`", "\[VeryThinSpace]"}], "+", 
      RowBox[{"0.34048100624360966`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"100\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.21129539290590854`"}], "-", 
      RowBox[{"0.23625136290438617`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"101\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"0.3555756884203125`", "\[VeryThinSpace]"}], "-", 
      RowBox[{"0.26741469520693467`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"110\"","\" |\"","\" + \"","\" ( \"",RowBox[{
      RowBox[{"-", "0.25119940860390566`"}], "-", 
      RowBox[{"0.26665879880408627`", " ", "\[ImaginaryI]"}]}],"\" ) \"",
    "\" < \"","\"111\"","\" |\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997178056*^9, 3.657378828746922*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Chop", "[", 
  RowBox[{
   RowBox[{"Adj", "[", "A3", "]"}], ".", "A3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"B3", ".", 
   RowBox[{"Adj", "[", "B3", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6140156770880623`*^9, 3.614015754106941*^9}, {
   3.624282786708405*^9, 3.624282793682947*^9}, 3.62428479533409*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9999999999999997`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997228015*^9, 3.657378828910193*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1.0000000000000002`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997228015*^9, 3.657378829029482*^9}]
}, Open  ]]
}, Open  ]],

Cell[TextData[{
 StyleBox["Mathematica",
  FontFamily->"Helvetica",
  FontSlant->"Italic"],
 StyleBox[" contains convenient functions for dealing with matrices such as ",
  FontFamily->"Helvetica"],
 StyleBox["MatrixExp",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" and ",
  FontFamily->"Helvetica"],
 StyleBox["MatrixPower",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[". They allow one to easily construct ",
  FontFamily->"Helvetica"],
 StyleBox["Rotations ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["and other operations:  \nThe equality ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["e", 
    RowBox[{"i", " ", "\[Alpha]", "  ", 
     SubscriptBox["\[Sigma]", "i"]}]], TraditionalForm]]],
 "= Cos \[Alpha]  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", "0"], TraditionalForm]]],
 " + i Sin \[Alpha] ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", "i"], TraditionalForm]]],
 "  ",
 StyleBox["can be demonstrated by comparing",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"ComplexExpand", "[", 
   RowBox[{"MatrixExp", "[", 
    RowBox[{"i", " ", "\[Alpha]", " ", 
     SubscriptBox["\[Sigma]", "1"]}], "]"}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "i"}], " ", "\[Alpha]"}]], "2"], "+", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"i", " ", "\[Alpha]"}]], "2"]}], 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "i"}], " ", "\[Alpha]"}]]}], "+", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"i", " ", "\[Alpha]"}]], "2"]}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "i"}], " ", "\[Alpha]"}]]}], "+", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"i", " ", "\[Alpha]"}]], "2"]}], 
      RowBox[{
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "i"}], " ", "\[Alpha]"}]], "2"], "+", 
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"i", " ", "\[Alpha]"}]], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997278648*^9, 3.65737882918736*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell["to:", "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TrigExpand", "[", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
     SubscriptBox["\[Sigma]", "0"]}], "+", " ", 
    RowBox[{"i", " ", 
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
     SubscriptBox["\[Sigma]", "1"]}]}], ")"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", "\[Alpha]", "]"}], 
      RowBox[{"i", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}]},
     {
      RowBox[{"i", " ", 
       RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], 
      RowBox[{"Cos", "[", "\[Alpha]", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799731148*^9, 3.657378829336355*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixExp", "[", 
  RowBox[{
   RowBox[{"-", "\[ImaginaryI]"}], "*", "\[Theta]", "*", 
   RowBox[{
    SubscriptBox["\[Sigma]", "3"], "/", "2"}]}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]}]], "0"},
     {"0", 
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979973263693`*^9, 3.6573788295942383`*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixPower", "[", 
  RowBox[{
   SubscriptBox["\[Sigma]", "3"], ",", "3"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979973616667`*^9, 3.657378829770842*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[{
 StyleBox["It allows us to check the formula ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[Sigma]", ".", "P"}], ")"}], "2"],
     TraditionalForm], "=", 
    SuperscriptBox["P", "2"]}], TraditionalForm]]]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"MatrixPower", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "*", 
      SubscriptBox["\[Sigma]", "1"]}], "+", 
     RowBox[{"b", "*", 
      SubscriptBox["\[Sigma]", "2"]}], "+", 
     RowBox[{"c", "*", 
      SubscriptBox["\[Sigma]", "3"]}]}], ",", "2"}], "]"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.1.4"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       SuperscriptBox["b", "2"], "+", 
       SuperscriptBox["c", "2"]}], "0"},
     {"0", 
      RowBox[{
       SuperscriptBox["a", "2"], "+", 
       SuperscriptBox["b", "2"], "+", 
       SuperscriptBox["c", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979973945293`*^9, 3.657378829942458*^9},
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[StyleBox["The rotation of a qubit state is given later",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Quantum Gates", "Section",
 FontFamily->"Times",
 CellTags->{"Quantum Gates", "c:9"}],

Cell[TextData[StyleBox["In the density matrix language any operator [O] \
acting on the density matrix of the system \[Rho] acts producing:",
 FontFamily->"Helvetica"]], "Text",
 TextAlignment->Left,
 FontFamily->"Courier New",
 FontSize->16],

Cell[TextData[{
 StyleBox["\[Rho]' = ",
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{"O", ".", "\[Rho]", ".", 
    SuperscriptBox["O", "\[Dagger]"]}], TraditionalForm]],
  FontWeight->"Bold"]
}], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 FontSize->16],

Cell[CellGroupData[{

Cell[TextData[StyleBox["a) Single qubit operations: Hadmards and rotations",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:10", "b:5.2.0"}],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard operator",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" for one qubit is defined as \nHad |0\[RightAngleBracket] = (|0\
\[RightAngleBracket] + |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 "  and Had |1\[RightAngleBracket] = ",
 StyleBox[" (|0\[RightAngleBracket] - |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox[", \nthis is equivalent to Had = (",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "1"], TraditionalForm]]],
 StyleBox[" + ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "3"], TraditionalForm]]],
 StyleBox["\[RightAngleBracket]/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox["\nTo Hadamard qubit-one in a one qubit system use:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.613395051437973*^9, 3.613395051953808*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HA", " ", "=", " ", 
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979974282*^9, 3.657378830104954*^9},
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["or the script form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData["\[ScriptCapitalH]"], "Input",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997461912*^9, 3.65737883025706*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[StyleBox["If we have 3 qubits and want to Hadamard the second \
one,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HAD32", "=", 
  RowBox[{"had", "[", 
   RowBox[{"3", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.613395079179223*^9, 3.613395086367363*^9}, {
  3.613395131040553*^9, 3.613395145640243*^9}, {3.61339538195849*^9, 
  3.613395393218055*^9}, {3.613395619570511*^9, 3.613395623461936*^9}, {
  3.6135049161353807`*^9, 3.6135049204543056`*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0"},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997499189*^9, 3.657378830426635*^9},
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["which  is equivalent to",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AF", "[", 
  RowBox[{
  "\[DoubleStruckCapitalI]", "  ", "\[TensorProduct]", " ", 
   "\[ScriptCapitalH]", " ", "\[TensorProduct]", "\[DoubleStruckCapitalI]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6133959477066393`*^9, 3.613395950338436*^9}, {
  3.614015919554443*^9, 3.614015932928617*^9}, {3.624189985515459*^9, 
  3.6241899866155157`*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", "0", "0"},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"},
     {"0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799751306*^9, 3.657378830678681*^9},
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["If we want to apply Hadamards as above to an initial \
system of |000\[RightAngleBracket],  we construct the initial density matrix \
and transform to the new density matrix, also we check the subsystems 2 and 1 \
to verify that it is only qubit 2 that has been subjected to a Hadamard:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.614015951445463*^9, 3.614015952625804*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]000", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]FINAL", "=", 
   RowBox[{"HAD32", " ", ".", " ", "\[Rho]000", " ", ".", " ", 
    RowBox[{"Adj", "[", "HAD32", "]"}]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], "]"}]}], "Input",
 CellChangeTimes->{{3.6140159800992002`*^9, 3.61401603406218*^9}, {
  3.624189994042535*^9, 3.6241899950418377`*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979975513163`*^9, 3.657378830848349*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979975513163`*^9, 3.6573788309736357`*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979975513163`*^9, 3.6573788311029053`*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979975513163`*^9, 3.657378831235354*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Sometimes we need a ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard on every one of the qubits;",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" in that case you may use the command ",
  FontFamily->"Helvetica"],
 StyleBox["HALL",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[":",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"HALL", "[", "3", "]"}], ".", "\[Rho]000", " ", ".", 
  RowBox[{"Adj", "[", 
   RowBox[{"HALL", "[", "3", "]"}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->{"i:2", "b:5.2.0"}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], 
      FractionBox["1", "8"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979975958347`*^9, 3.657378831403295*^9},
 CellTags->{"i:2", "b:5.2.0"}]
}, Open  ]],

Cell[TextData[StyleBox["The action of a Hadamard on state vectors is  also \
simple to evaluatel, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"had", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ".", 
   RowBox[{"Ket", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"had", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ".", 
   RowBox[{"KetX", "[", "0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"had", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ".", 
   RowBox[{"Ket", "[", "1", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.62419607026132*^9, 3.624196100784041*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997768345*^9, 3.657378831555297*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"","1","\")\"","\" |\"","\"0\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997768345*^9, 3.65737883168335*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["2"]]}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997768345*^9, 3.6573788318151007`*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[StyleBox["A rotation around the y axis by an angle \[Theta] \
applied to a state |0\[RightAngleBracket] can be generated by the user as:",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.62419611301157*^9, 3.624196113494347*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Roty", " ", "=", 
  RowBox[{"MatrixExp", "[", 
   RowBox[{
    RowBox[{"-", " ", "\[ImaginaryI]"}], "*", " ", 
    RowBox[{"s", "[", "2", "]"}], "*", 
    RowBox[{"\[Theta]", "/", "2"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"TrigReduce", "[", 
  RowBox[{"ComplexExpand", "[", 
   RowBox[{"Roty", "  ", ".", " ", 
    SubscriptBox["\[ScriptCapitalP]", "0"], ".", " ", 
    RowBox[{"Adj", "[", "Roty", " ", "]"}]}], "]"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}], 
      RowBox[{"-", 
       RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}]}]},
     {
      RowBox[{"Sin", "[", 
       FractionBox["\[Theta]", "2"], "]"}], 
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979978167*^9, 3.657378832013739*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}]}], 
      FractionBox[
       RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]},
     {
      FractionBox[
       RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979978167*^9, 3.657378832140629*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["and we see that Roty on state | 0 \[RightAngleBracket] gives us \
Cos ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FractionBox["\[Theta]", "2"]]],
 StyleBox["  | 0\[RightAngleBracket] + Sin ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FractionBox["\[Theta]", "2"]]],
 StyleBox["  | 1\[RightAngleBracket];   for ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  RowBox[{"\[Theta]", " ", "=", " ", 
   RowBox[{"Pi", "/", "2"}]}]]],
 StyleBox["  gives ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 StyleBox[") ( | 0\[VeryThinSpace]\[RightAngleBracket] + | 1 \
\[RightAngleBracket])= |+\[RightAngleBracket].",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Roty", ".", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614016099736486*^9, 3.614016104551073*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}]},
     {
      RowBox[{"Sin", "[", 
       FractionBox["\[Theta]", "2"], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997855852*^9, 3.657378832306817*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{"Sin", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997855852*^9, 3.6573788324361343`*^9},
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["or the user can use the ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[" command RotY[ ",
  FontFamily->"Helvetica"],
 "\[Theta]",
 StyleBox[" ]",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RotY", "[", "\[Theta]", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RotY", "[", "\[Theta]", "]"}], ".", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RotY", "[", 
   RowBox[{"Pi", "/", "2"}], "]"}], ".", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"DForm", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614016113854549*^9, 3.614016117780463*^9}, {
  3.624196202821477*^9, 3.624196222015512*^9}},
 FontSize->16,
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}], 
      RowBox[{"-", 
       RowBox[{"Sin", "[", 
        FractionBox["\[Theta]", "2"], "]"}]}]},
     {
      RowBox[{"Sin", "[", 
       FractionBox["\[Theta]", "2"], "]"}], 
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799792266*^9, 3.65737883259484*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"Cos", "[", 
       FractionBox["\[Theta]", "2"], "]"}]},
     {
      RowBox[{"Sin", "[", 
       FractionBox["\[Theta]", "2"], "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799792266*^9, 3.6573788327221603`*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",RowBox[{"Cos", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"0\"","\" >\"",
    "\" + \"","\"(\"",RowBox[{"Sin", "[", 
      FractionBox["\[Theta]", "2"], "]"}],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799792266*^9, 3.657378832853383*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799792266*^9, 3.65737883299135*^9},
 CellTags->"b:5.2.0"],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\" + \"","\"(\"",FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"0\"","\" >\"","\" + \"","\"(\"",
    FractionBox["1", 
     SqrtBox["2"]],"\")\"","\" |\"","\"1\"","\" >\""},
   "RowDefault"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799792266*^9, 3.657378833142003*^9},
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["b) Two Qubit operations: CNOT gate",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"i:1", "c:11", "b:5.2.1"}],

Cell[TextData[{
 StyleBox["Two and in general n-qubit gates can be constructed. Among them \
the CNOT gate plays a very important role. \nA CNOT gate ( |a\
\[RightAngleBracket]|b\[RightAngleBracket]  -> |a\[RightAngleBracket]|(a ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"\[CirclePlus]", " "}], TraditionalForm]],
  FontWeight->"Plain"],
 StyleBox["b) mod 2\[RightAngleBracket]) operating with qubit 1 as control \
and qubit 2 as target in a circuit with only two qubits can be constructed \
as: ",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{3.6241962514436703`*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CNOT", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397997981914*^9, 3.6573788333811903`*^9},
 CellTags->"b:5.2.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["If we apply the ",
  FontFamily->"Helvetica"],
 StyleBox["CNOT",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" to an initial density matrix  |10\[RightAngleBracket]\
\[LeftAngleBracket]10|, we write, ",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CNOT", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}], " ", ".", " ", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}], ".", 
  RowBox[{"Adj", "[", 
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614016158482085*^9, 3.614016162766512*^9}, 
   3.614016218093173*^9, 3.6241900374256907`*^9},
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998019031*^9, 3.657378833541892*^9},
 CellTags->"b:5.2.1"]
}, Open  ]],

Cell[TextData[StyleBox["which trivially  is seen to be equal to the density \
matrix for |11\[RightAngleBracket]\[LeftAngleBracket]11|",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"AF", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "1"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614016236722087*^9, 3.6140162795248423`*^9}, 
   3.6241900374336863`*^9},
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979980514383`*^9, 3.65737883370865*^9},
 CellTags->"b:5.2.1"]
}, Open  ]],

Cell[TextData[{
 StyleBox["A ",
  FontFamily->"Helvetica"],
 StyleBox["more general case",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" would be to have a CNOT gate with control in qubit 3 and target \
in qubit 5 in a circuit with 6 qubits:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CNOT", "[", 
   RowBox[{"6", ",", "3", ",", "5"}], "]"}], ";"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["c) Two Qubit operations (CPHASE)",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"i:1", "c:12", "b:5.2.2"}],

Cell[TextData[StyleBox["The Cphase operation, used mainly in the cluster \
model approach, is defined by:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["CPHASE | a b \[RightAngleBracket] = (-1)^(ab)  | a b \
\[RightAngleBracket]",
 FontFamily->"Helvetica",
 FontWeight->"Bold"]], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox[" Its syntax is is similar to a CNOT gate, but in this \
case the order of the control and target qubits is not relevant. \nTherefore, \
CPHASE[L,q1,q2], performs a CPHASE gate on qubits q1 and q2 on a system of L \
qubits.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CPHASE", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"CPHASE", "[", 
  RowBox[{"2", ",", "2", ",", "1"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998088936*^9, 3.657378833892233*^9},
 CellTags->"b:5.2.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998088936*^9, 3.657378834022197*^9},
 CellTags->"b:5.2.2"]
}, Open  ]],

Cell[TextData[{
 StyleBox["In a multiquibit environment: of say three qubits, a ",
  FontFamily->"Helvetica"],
 StyleBox["CPHASE",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" between qubits 1 and 2 is:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CPHASE", "[", 
  RowBox[{"3", ",", "2", ",", "1"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"},
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "1"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998117972*^9, 3.6573788341922894`*^9},
 CellTags->"b:5.2.2"]
}, Open  ]],

Cell[TextData[StyleBox["A different version of the same gate  is defined by \
CPHASEV[ i,  j,  a ]  and is used to get the CPHASE action on qubits i and j \
of a  state vector a.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["For instance, if we apply CPHASE to the two qubit \
vector:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["CPHASE[ 2, 1, 2]   [  a | 0 0 \[RightAngleBracket]+  \
b | 0 1 \[RightAngleBracket] +  c | 1 0 \[RightAngleBracket] + d | 1 1 \
\[RightAngleBracket] ]  =   a | 0 0\[RightAngleBracket]+ b | 0 1\
\[RightAngleBracket]+ c | 1 0\[RightAngleBracket]  -  d | 1 1\
\[RightAngleBracket]",
 FontFamily->"Helvetica",
 FontWeight->"Bold"]], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["Which corresponds to the followng command:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CPHASEV", "[", 
  RowBox[{"1", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"a"},
      {"b"},
      {"c"},
      {
       RowBox[{"-", "d"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998137677*^9, 3.657378834376893*^9},
 CellTags->"b:5.2.2"]
}, Open  ]],

Cell[TextData[StyleBox["Thus CPHASEV[  i  , j , a]  gives the result of  a \
CPHASE acting on qubits i and j for a state vector with expansion \
coefficients a:{a,b,c.....}.  The length of the array gives the total number \
of qubits.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CPHASEV", "[", 
  RowBox[{"1", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
     "h"}], "}"}]}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"a"},
      {"b"},
      {"c"},
      {"d"},
      {"e"},
      {
       RowBox[{"-", "f"}]},
      {"g"},
      {
       RowBox[{"-", "h"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998167865*^9, 3.657378834542823*^9},
 CellTags->"b:5.2.2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["d) Two Qubit operations, TwoOp",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"i:1", "c:13", "b:5.2.3"}],

Cell[TextData[StyleBox["General Two Qubit operations are build using TwoOp. \
Its syntax is is very simple and allows one to build any two qubit operation \
embedded in an L qubit system. ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.3"],

Cell[TextData[{
 StyleBox["The TwoOp function should be called with the following arguments: \
\nL: total number of qubits, \n",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "1"], TraditionalForm]],
  FontSize->18],
 StyleBox["and ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]],
  FontSize->18],
 StyleBox[", qubits involved in the operation,\n ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["op", "1"], "and", " ", 
    SubscriptBox["op", "2"]}], TraditionalForm]],
  FontSize->18],
 StyleBox[" are the Pauli \noperators ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", 
      SubscriptBox["op", "1"]], ",", 
     SubscriptBox["\[Sigma]", 
      SubscriptBox["op", "2"]]}], ")"}], TraditionalForm]],
  FontSize->18],
 StyleBox[" performed on ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "1"], TraditionalForm]],
  FontSize->18],
 StyleBox["and ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]],
  FontSize->18],
 StyleBox[".\nThus for a three qubit system with  ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Sigma]", "0"], "  ", "acting", " ", "on", " ", "qubit", 
   " ", "1", "  ", "and"}]],
  FontFamily->"Helsinki",
  FontSize->18],
 StyleBox[" ",
  FontFamily->"Helsinki",
  FontSize->18],
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[Sigma]", "1"], "  ", "acting", " ", "on", " ", "qubit", 
    " ", "2"}], ",", " ", 
   RowBox[{"the", " ", "operator", " ", "is"}]}]],
  FontFamily->"Helsinki",
  FontSize->18],
 StyleBox[" ",
  FontFamily->"Helsinki",
  FontSize->18]
}], "Text",
 CellChangeTimes->{{3.62419648465779*^9, 3.6241964902938013`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TwoOp", "[", 
  RowBox[{"3", ",", "1", ",", "2", ",", "0", ",", "1"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.2.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "1", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0"},
     {"1", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1"},
     {"0", "0", "0", "0", "1", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979982141657`*^9, 3.657378834709972*^9},
 CellTags->"b:5.2.3"]
}, Open  ]],

Cell[TextData[{
 StyleBox["For example, the CNOT and CPHASE gates between any two qubits in a \
total of L qubits have been coded using this function.\nA ThreeOp[ L,  i,  j, \
k, ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "1"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "2"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "3"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox["] is also provided by ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[", which also serves as a building block for higher order \
operators.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.2.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Measurements", "Section",
 FontFamily->"Times",
 CellTags->{"Measurement", "c:14"}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["a) Measuring  in the computational bases with density \
matrix",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"Measurements", "c:15", "b:5.3.0"}],

Cell[TextData[StyleBox["A projective measurement on our system corresponds to \
a projection of the density matrix of the full system into the unmeasured \
subsytem.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[TextData[{
 StyleBox["Let us assume we have a four qubit system initially in the | 0 0 0 \
0 \[RightAngleBracket] state, we build  its density matrix ",
  FontFamily->"Helvetica"],
 "\[Rho]4",
 StyleBox["  after a chain of Hadamard and CNOT gates act as,",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "3"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]4", "=", 
  RowBox[{"Ope", ".", " ", 
   RowBox[{"AF", "[", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalP]", "0"], "  ", "\[TensorProduct]", "  ", 
     SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", 
     SubscriptBox["\[ScriptCapitalP]", "0"], " ", "\[TensorProduct]", "  ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "]"}], ".", 
   RowBox[{"Adj", "[", "Ope", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.614016439032955*^9, 3.614016484861516*^9}, 
   3.624190037442855*^9},
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"], 
      FractionBox["1", "8"], "0", "0", 
      FractionBox["1", "8"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998247727*^9, 3.6573788348781223`*^9},
 CellTags->"b:5.3.0"]
}, Open  ]],

Cell[TextData[StyleBox["We can then measure for instance qubits 1 and 3 \
simultaneously, the projection operator would be:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_"}]], "  ", ":=", "  ", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "a"], " ", "\[TensorProduct]", "  ", 
    "\[DoubleStruckCapitalI]", "\[TensorProduct]", 
    SubscriptBox["\[ScriptCapitalP]", "b"], "\[TensorProduct]", " ", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614016522492498*^9, 3.614016554451228*^9}, 
   3.624190037451095*^9},
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["And therefore the state of the remaining subsystem, \
which depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]24", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "2"}], "*", 
       RowBox[{
        SubscriptBox["P", 
         RowBox[{"a", ",", "b"}]], ".", "\[Rho]4", ".", 
        SubscriptBox["P", 
         RowBox[{"a", ",", "b"}]]}]}]}], " ", "]"}], "]"}]}], ";"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["If the result of the measurement was (01) then we \
would have the following density matrix for the remaining subsystem:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]24", "[", 
  RowBox[{"0", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  RowBox[{"\[Rho]24", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979982875843`*^9, 3.6573788350760317`*^9},
 CellTags->"b:5.3.0"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979982875843`*^9, 3.6573788352076273`*^9},
 CellTags->"b:5.3.0"]
}, Open  ]],

Cell[TextData[StyleBox["The computation could be left depending on the values \
of the measurement:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]24", "[", 
  RowBox[{"a", ",", "b"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tr", "[", 
   RowBox[{"\[Rho]24", "[", 
    RowBox[{"a", ",", "b"}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614027714445733*^9, 3.614027774043529*^9}},
 FontSize->16,
 CellTags->"b:5.3.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0"},
     {"0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}]},
     {
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0"},
     {"0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}], "0", 
      RowBox[{
       FractionBox["1", "16"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998363819*^9, 3.657378835478386*^9},
 CellTags->"b:5.3.0"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"2", " ", "a"}]]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"2", " ", "b"}]]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998363819*^9, 3.657378835616404*^9},
 CellTags->"b:5.3.0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["b) Measuring  in the computational bases using \
MeasureKet",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],

Cell[TextData[StyleBox["Consider a similar example to the previous one, using \
kets:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "3"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ket1234", "=", 
  RowBox[{"Ope", ".", " ", 
   RowBox[{"AF", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "  ", "\[TensorProduct]", "  ", 
     RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", 
     RowBox[{"Ket", "[", "0", "]"}], " ", "\[TensorProduct]", "  ", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.6140278237220783`*^9, 3.6140278858873873`*^9}, 
   3.614027944609769*^9, 3.624190037459059*^9},
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]},
     {"0"},
     {"0"},
     {
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998430661*^9, 3.657378835776986*^9},
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[TextData[StyleBox["We can then measure for instance qubits 1 and 3 \
simultaneously, using MeasureKet.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["The state of the remaining twoqubit subsystem, which \
depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ket24", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"MeasureKet", "[", 
   RowBox[{"ket1234", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["If the result of the measurement was (01) then we \
would have the following ket for the remaining  qubit 2 and 4 subsystem:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ket24", "[", 
  RowBox[{"0", ",", "1"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0"},
     {
      FractionBox["1", 
       SqrtBox["2"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998463311*^9, 3.657378835950108*^9},
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[TextData[StyleBox["Construct the back to back density matrix for that \
state:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]24k", "=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"ket24", "[", 
     RowBox[{"0", ",", "1"}], "]"}], "\[TensorProduct]", 
    RowBox[{"Adj", "[", 
     RowBox[{"ket24", "[", 
      RowBox[{"0", ",", "1"}], "]"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614027995502036*^9, 3.6140280197666693`*^9}, 
   3.624190037466968*^9},
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998478107*^9, 3.657378836111026*^9},
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Purity", "[", "\[Rho]24k", "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.1"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998518457*^9, 3.6573788362826233`*^9},
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[TextData[StyleBox["Which is identical to the density matrix obtained \
earlier",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["c) Example with measurements in the X and Y bases \
using the density matrix",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:17", "b:5.3.2"}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/Had5q.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQlQFVe6x01eZiZOTSWzmGQmU5Z5mUzFqpgxMzpxNMskM07KZEyMSjSZ
mBijGMcBzbihgmwiyiKLICACssiqoBCCIoIbAdnCGiKyb4LIJrui8v7vnpp+
/W7fe+2+t6Eb/H5VUn3bc/uc7j7/833f6b7n++/PNy5Z+/CkSZM2P4o/S1ZZ
vblp06odSx/Bh7/s2GL++X9hwxP/Zjw0adL/bh84cGDkPzQ1NZ04cSIuLi45
Obm7uxt7BgcH6+vrGxoa7ty5w8oEBQUVFxePyMQ333zz1VdfiSycm5sbHh4u
V9UEoRL4Grx+/XpCQsLvfve7wMDAfg0pKSnZ2dmHDh2KiIhgMkxNTfX395er
dkkaRPN27Nhx8+ZNuWonCDXA1yC4deuWmZkZMzdQh4ODw71799ra2hYvXpyT
kzOiEYKNjY1cQtCnQdRSWFgo3O/h4YExQZaqCUIlcBq8ceNGSEhIdHT0unXr
LC0tsae8vDwpKenu3buwgBBmfHw8K+nr65uRkSFL7fo0+N133x09elS4//Ll
y+7u7rJUTRAqgdMg+rafn19lZeXGjRtfe+21np4eWEBEgvBIGxsbV65cefXq
VVYS8aCzszO0aXrtUjU4MDCwa9cuhKimV00QKoFpEH174cKF586dw3ZVVdXc
uXMhNGgwMjLy5MmTsbGxEAv3FRS2traGPLUOhfL5+fknTpxI1EVycnJHR4fW
V6RqEISGhqIKE85YeYaGhmJiYuBs2NnZlZSU4Lop3SJCSZgG0SveeeedsLCw
EU1IuGTJEmyjb2RmZsJH7e3t1frW8ePHo6KitHaiPMxoVlZWti4QTsK2an2F
0yC+i//t0NDV1cUmgrq7u9mezs7O4eFh9pWamhp03cHBwdG4GmMAztTb23vy
5MmTNDz33HN5eXlKN4pQEs4Xtbe3X79+Pdt2dHS0sLBAb4G9e/XVV1esWKHV
T3Jzc/fu3Wt67ZwG4dnCUPr4+CDYhEtsY2Pz2WefYcNXw+HDhzEUsK/09fVZ
WVm1trbyj1NbW3vkyJEQ1YNG4hynTZs2icd77703LhpPjBKcBgsLC+fPn8+C
Ppi5v/71rzB/6enpKSkpaWlply5d4rtM6DMJCQlagkIBGLu4uLjjuoADyelI
qEF8985/wHZpaWlERAT283eyr8BNxXDBmUVGdXV1YGDgIdWDRrq5uT311FN8
Dc6ePTsgIEDpphGKwX82ER4eDhNz/vx59JPly5cjMNRpvKBNW1vbpqYmoQbh
KCIkLNAFNC70aY2IBzFufP311zr/a1xw+/ZtmHhOgA8//LCMz1uJ8Qhfg3AI
0flh4K5cuQKJIS7T+RUEay4uLrLULlWDiBmFjui4A2cHN+PRRx+FQdyyZQui
XaVbRCiJ1jN6MXh7e8M1laV2fRosLy+PjIwU7ke9qF2WqpWlu7vb0tISLj1N
ihJSNXjt2rVdu3YJZziNQ58G0UVra2u1dqK7uru75+bmylK14jg5OY1rp5qQ
C6kaPH78eGhoqFy1S3pftK6ubseOHQMDA3LVriykQYLBvYEmkhMnTnAvzJhO
WVlZVlaW+MLiBat+SIMEQ2uSX0x5Wd5SY7CXUUejsPohDRKEspAGCUJZSIME
oSykQYJQFtIgQSgLaZAglIU0SBDKQhokCGUhDRKEspAGCUJZSIMEoSykQYJQ
FtKgOqmpqTl8+LCk1UUiIiKSkpJycnLq6+ulvoBNKAhpUJ34+/ubm5uHhYUd
EU1GRsbly5fj4uJ8fX3ZL9yHhoaUPg/i/pAG1cnBgwfZemJGcPfu3aqqKthQ
Pz+/5uZmkd8SX5LR0tIi49qeN2/eFC78a6Bwe3u7XFUrDmlQnZiiQca9e/cK
Cgp27dpVVFQkpjwEy23X1taGhoZ6enpGRkYyaeBotzXcunWLObqw0TKuSZud
nZ2SkiKycGFhYXBwsFxVKw5pUJ2YrkFGSUmJvb399evX71uSv5ZFT09PVlbW
73//+6ioKOhuRKNB2FZnZ2c0jFnMixcv7t+/3/QWMvStZYF6hb8U7urq2rZt
m3CR0nEKaVCdyKXBEU2KopCQkPv+8JyvQRRGLPnxxx+zFS87OztbW1vb2tpg
VbGHLeQCIdjY2IhRtxj0abChoeHChQvC/WjG2bNnZalacUiD6kRLg4i84K2h
16Wnp8MA6VvwUycwJYcPH+bnatEJp8Gampp9+/bhK2vWrFm9ejX2oCXx8fEV
FRVbt26F7eNiMUg7OTlZ2onpQer6orDvMMoTY0UL0qA6EWowMzNz3bp18A/R
7aUuBnv16lU3NzfDDyyYBllqCbigkLmjo+OcOXNQV2NjI8JDWEYPD49jx47x
D2tra4sIUeLJ6UCqBuEh29nZXblyxfSqFYc0qE50+qJpaWnTp0+vrKyUejT0
WG9v72vXrhkowzTY39+/YMECltkT5V999VWWdRcawU5PT0++BnFY6BT2UetQ
EPK5c+dgSYN1ERYWJlwf24i17o8fP65z+V/FYek2HBwcIK7c3FwDxhoXMCUl
5Y033li/fn11dTUt86sqdGqwqanphRdekLoIISMhISErKws2a0AXsLNMgyiw
aNEiFgai83z00UdsG73l1KlTX375JXo+/7AYwKE1rbpY1mz4tLW6qKurEz7U
4Od8wWnCwEHaGG3QRd3d3bFRoQEb3ENPDBE7d+4Upq5QHIw/zzzzDMsi8dRT
TxlIkhgYGPjYY4+xkjNmzCguLh7LdhKG0alBCARGavPmzUYcECPz8uXLv9CF
ubn57t27uXgQEd/KlSvZ6I3+j5CQjc8IAz/44AO+HRzRPFNwdXU15gz/P/zc
Z4h54fqGh4fjCiAyhQcOU4iPMKAxMTHcY8Senp5t27ZpTQqVlZXZ29vbKcqs
WbP42ZReeukleOzCYtu3b586dSq/JG4urOfYN5gQghvxzjvvCH2w7u7uuXPn
vvvuu99++61UvwVjbEBAAGxHoy7gHHIarKqqQmdgK8nD6r322muol/1XXl6e
1ljt5+d3+vRprbrQNugI1QUKOHToUEhISEtLiz4NamHAF83Pz3d2dta6DjiR
NEXB1UAQzVcWbCJcl7Nnz/KL4WNsbOzTTz/NL/n666+fOXNGqZYTfBB5WVpa
Cu0gOjZ8m8TERHTLkpISA4oTUlRUhGgOPt53ukAwwn82gR4CExMVFQU7uGHD
Bm497XsauGIwSTY2NsJXVlAG/wVpN+miublZ+BKdERr09fXV+dhCcTAy8JUF
R0LnbBi8Grj6XLGHHnpoYmSxmTDo9EURucMOwip1dnbCJxQmQzEAeviyZcsg
KEsBFhYWcPm08k3Ax7t8+TL+wuXr7+/XeUyMFXJ1G6kahPCtrKzUmSwMVt7M
zOzRRx+dPHnywoULy8vL9ZUsLCz805/+9OMf//iJJ55AUDBh3jqYGAg1CLMy
ffp0BDvsY1tbm7+/P/6KPCAiLBhBfpZbLaTmfEHg5uLigl4k6Vv60KdBtBk+
m3A/XD7hXJB66O3txcVB5H7fxDQQLGJqeDWyPOIhZISvQeb+IYz6+c9/zn/U
XllZiZ2Q4X1jQ3iGcJAMTyFK1SDcV8Stcr22rU+D6MNCX/f27dt79uyBiZSl
6lECobSM7/IRYw9fg9AO/DF4kvPmzcN+zgGrqKhYsWIFPEkYBcNvjCQnJ9/3
UZpUDYaHh+u0UMYhKfcZThxxKHuRVbWQBsc7fA1CX+0aoD6EDFzfgw3CTuzp
6uoyYApbW1s9PT3v+2Of9PR0SS08d+6cMBO90VRVVYl/OobC9331TnFIg+Md
ud7Z7unp8fLymjApa8cRpMHxjiwahAAdHR3hNMrSJEISpMHxjokaHB4eLikp
8fb2TkpKogk3RSANjnegwbCwsBGNmkSCOLGvr6+hoQGxko+PDzoAexih9Kk8
oJAGxztRUVGLFi3asGGDhWicnZ1x02H74uLiKioqVD5tOOEhDY53+vv79b1X
po+Wlpbe3l4Zc8QTpkAaJAhlIQ0ShLKQBglCWUiDBKEspEGCUBbSIEEoC2mQ
IJSFNCgLzc3NDg4OO6Xg7+9/+vTpoqKixsZGSkD2IEMalIXk5OT169dfunTp
vGgyMzMvXLgQHR3t5eXl6+t78eJFGZMTEeMI0qAsnDx50sXFxbjv3rlzp7q6
+tChQwcOHKivr5e3YaOB+GUxGO3t7TK+Dd7X18et3iZvYaUgDcqCKRpk3Lt3
j614mZ2dLVerRgkMF9x2Q0NDbGxscHBwfHw8y20BuXV0dKDnc+/ChYeHy7WY
zIhm+VPhGon6QL1yJcQZPUiDsmC6BhmVlZU2NjYqt4b8tSygu/T09JkzZ4aF
hTH1YePMmTPQnbe3N1uX5ty5c/C35apd0loWaI+VlZX4nKGKQBqUBbk0CEpL
S/38/NScnJqvQZbx88MPP2Rrl8EgrlmzZnh4+MaNG/PmzQsNDR3Rv7iocejT
YHNzc1ZWlnA/Ym1E37JUPUqQBmVBS4PolmlpaSEhIXDbYmJi6urqJB0N3p34
VLNjD6fBxsZGT09PnKa5ufnatWuxJzc3F6cMDQ4ODs6fP9/R0ZGVDAwMFO9A
Gkbq+qJwR/ft26fmH4mQBmVBS4N37typqanx8fF59tln0fekTgu0tLQ4OTn1
9fXJ3Ux54DTo4OAAS3f9+vWdO3fOnTuXxYPo7W1tbbggn3zyCZdx7Pvvv0dh
WR7BSNUgPGRbW1sjUlCNGaRBWdDpi+K+P//88wiOjDggrImBVZeVhWlwYGDg
7bffRqw3ojGI8Dzz8/NHNONPTk4OzCK8U+63+XCt7ezsqqqqtA6FApmZmSxp
i5Do6GjhHKwRa93DFZFxcUUx3Lx5E413dXVNTEw0vFgrmv3555+bmZlhmFKz
sVY/OjWIXgp/bPfu3UYcEH0bPUdf4hVl4XKfvfvuuywMhIFbtmwZtiFAeNE9
PT3wAP/whz/wp0OTkpKOHDmidZrQIOI4jDbfC8BOmFHh4vn83GdQKPz8+vp6
tCo9Pd3b2xsb9RqwwT0QwTYCUn3r8MsOKrKwsHjkkUcmTZr0ox/9CI66vqqz
s7OnT5/OskhMmzZNzQGI+tE3J/PPf/4TxsKIuw8bunTpUhZnqQ3OF0WctXr1
ajZ64/S/+OILeN3r1q2DdqCU2bNn5+XlcWd0+fJllDf2Av8f/NxnqampiDSD
goKCg4Mx1uFyYQMfMRrAtnKzQLBE27Zt00onikbCTrnIjZubm6Wl5eTJk7kU
LT/5yU82bdqE/cLCcB74OV/mzJkje3seENzd3RH77N27V6u3DA4OQoAwhcnJ
yVLfgWlqavL397+lSjgNohu/9dZbRUVF2I6Pj//zn/8MH6y2tpa9/5OVlcVf
JwpiEeZxRgEUDgkJOaILuKNaSQNHjPJF0ULE11qeHq7wiVEA5n7Hjh0PP/ww
X1zr16/Hfq2SCAPhKvCLTZ06FUMHxvPRaNjEBpd3+/btQg3m5ub+6le/Qm+E
mwQZSlq4DD0Ex0xWJfxnE5DD1q1bcREwzsMMsdxnWonPRjSPEXft2iUM7lAM
5glGv0oX1dXVBvLwamFAgxjNzp49K/7imwgcaTiWnLKmTJkCH0BnSXt7e74G
MZLT+lpGo9MXtbW1ffHFF9HHECWlpaVdunRJfNBdUFCAwdPZ2XmP+tB6PtjQ
0IDoFTFXZ2envvkHGDu5pv6kahCtgiMq19NJMeCaHDx4ENJ76KGHnn76aXi8
+iaEcekWLFiAmBG+6xtvvCHj20QPIEIN3rhxY9asWQgN2EeMb2FhYeLTccK2
qjZRgtScL+iTsJL82NAU9GkQ1gcuh3A/LCDsoCxViweiQzuhL/w1PPDCN8jI
yDh//rzKX+ZRP3wNossNDQ3FxMQ89thj8Pm5MvDHPD09ESUNDAwY9ksRc+Fo
MuZJkRepGqyrq7Ozs5NrWlKfBvv6+oSJs+GBIEYQnyNGRhAawzkXNokYJfga
hMmD9DZu3GhmZgY/hHv5s7m5GSHev/71L8jT8BQNHFEvLy/VPi2SqsEoDXLV
Lul9UUSa1tbWt5RYw580OMZo2cHbGjAI4+5z+f6gKbYfOw3YQVhJHx8fLrG7
Cjl16pSk8qmpqVLf1jNARUUFxijxhdlbBGMPaXCMkeudbcQRERER4sd5RZCa
mUI4TWpi7eKPJm/VkiANjjGyaBACDAoKQvyiiO9EyAtpcIwxUYMYqxsbG0NC
QoKDg3HvZGwYoRSkwTHGCA2ysLG9vb20tDQ8PNzJySkzM5MWd5owkAbHmPT0
9L///e9btmzZLJo9e/Z4eXm5u7vD/8zJyVHtL5UI4yANjjEDAwNFRUW5Uqis
rOzo6DA8R0qMX0iDBKEspEGCUBbSIEEoC2mQIJSFNEgQykIaJAhlIQ0ShLI8
mBrs7Oz08vLavXu3kzhQMjAwMD09/bvvvsO1ondUCBl5MDWYn5+/fPlySUuj
nD59Oi0t7ejRox4eHn5+fhcuXBgYGFD6PIiJwIOpwdzc3M2bNxv33du3b9fU
1MAsenp6CpeiJfhIvT64sDK+idfe3n7t2jXxhZubm+WqWhKkQeO4d+9eRUUF
fNSMjAy5WjXx8PHx4bahR19f3+3btwcEBKDDYyjr7e3t09Df38+WAggNDb10
6ZJctWdlZcGBEVm4uLj44MGDclUtCdKgKTQ1NVlbW6t2qXnF4a9lMTg4iGj6
5ZdfTkhIwMerV69+9NFHb2kwMzOrrq4ekW91X4a+tSygd2FE39PTY2VlpYgQ
SIMmgs7j5eWFOyjL0SYYfA0ifIbh++yzz1iGQQgB8TX8+YsXL8Iypqenj2iW
uba1tZVriSp9GqytrU1NTRXuDwkJEW83ZYQ0OKJxLLEnLi4uMjISozSXA0gk
p06diomJkbuNEwFOg2VlZRDXoUOHoMFPPvmEeZ74GxUVdeLEic7OTi7hFG5B
fHy8LLVLXV+UBRdjv3YuaXBEo0FEKwhGpk6deuTIEalXA0bQyclJau71BwGm
QWjt3//+N7R269YtGME//vGP3Lr0cFD379/v4uLCrWcFIwX3XriaHO4RjnNH
P8IfdknVIA7i6OgofmVXuSANcrS3t8+aNUuY8UcM0dHRql1oV0GYBvv7+xcs
WMDWkMdI9frrr2dmZsLthNxGNAs5zp8/H3vYVyAEZ2dnoRAgsTNnzvj4+BzU
BSyscArUiLXu4Ysa1wG0QLyJMWfNmjUWFhYZGRkGHiizKYXf/va3kL9q14kd
DXRqEHcZbtJaTZZYqRQXF+PedXR03CB4MA3Cu1u6dKm3t/eIxiZ++umnvr6+
8Dn/8Y9/wDLC5C1cuBA9lruYiBOFU5S4O/A39FXEJlq1vsLPfQY/8/Llyzk5
OXl5ebGxsejw+fn5ORoKCgq4VYUxRGzfvl0rEyszweLBV6Dxxx9/nOWG+NnP
fsamoYTF0OxFixZxWSTefvttdCGp1Y1HcO648jrnZFxdXWfPnm1ExgHcuxUr
VqxatWoNwYOLB6GpDz/8kMkEtgxRYWFhIYxXQ0MDzAQuHbe+MYBNFKacQM+E
iRzWjwFfFDc9OzsbYSaUfvLkSTQAvnFiYiI+Qh2wfZzosGFlZQVR84+DpqL8
l6LZsGHDb37zG36KlhdffFFYDMf84IMPfvCDH3DFfvjDHy5fvlxSXeMUnOOy
ZcvWr18vlBI8hxkzZhw7dkzqk2IM0Z6enhBvD8GD0yC8LAz4bPITZmjevHmd
nZ2NjY1ZWVlQnFYoDYspfOoKiaWmpuKAvgKgqYCAAFl8UUjVzc1Na2dXV1eh
FGBwMZLzNThz5kycaVFREb8Y/G2cDksAyuHg4FBaWiqpuvEI/EbcAohR61Jj
TJ4+fTq8FNyIuLg4bpZADGxSHSHPBYIH/9kEfD8bGxvYPkjM3t5e3/Lgra2t
KCZcthEahMfYpQfYL2HMZYQGPTw89GUfk8Tu3bv5ykLf0FkM1h9jPlds2rRp
aJvptY8LdMaDERERv/71r1nWD/QfDMXiZQj9IpDcuXOnNcFDK98ELOOVK1eg
L8SA+lYnPn36tFzJj6RqEPJHMCjLqq041MqVKxESTpkyBc6VgVfm4BvDU33y
ySdffvlleAh31Zo6RHaEGhwaGlq6dCmCYjYrjkuBCwL/QeQBMXgivpC/oeMc
qTlfYMucnJzksgX6NAgTzCZJtIAcwsPDZal65D8psYDh1fDwvy0tLRUVFQhk
Hqh18/gaZMF+Tk7OE088wZ8KgOcTHBx88eJFyPO+FwfxSCGlZRQgVYPl5eXQ
oFxPyfVpEOroEbzXhLuMWKyyslKWqhkhISHwvWU84ERCS4Pwf/Dxb3/7GyIR
bhBGiIGbAo8iKChIa7Jai8bGRvQcWnpXiFQNotPyH1KYiKTcZ7jviFIlTQLc
F9KgAbQ0CP8TVg8jIf5ycQrc0QENEJeBW4NicGBkfNt/IgHvQlJ53BcZXzdC
kA4fT3xh2ROAkgYNIOM722fPnoXLSr+sJ4SQBg0glwbhxG7ZsqWzs9P0QxET
D9KgAUzXICLExMREd3d3+DBytYqYYJAGDWCcBhE5Ijasra1NTk52dHRMSEjg
3jMkCCGkQQMgVH///fetra1txIGS+/bt8/Pzc3V1PXDgwJkzZ7hf3xCEPkiD
BhgeHi4oKMjIyDgnDpT89ttvm5ube3p65J2+JiYwpEGCUBbSIEEoC2mQIJSF
NEgQykIaJAhlIQ0ShLKQBglCWdSvwaGhoaioKA8PDy9xeHp6Hjx48OjRo2fO
nMnPz+/q6nqgfvNIjDvUr8HGxsbFixeHhYXFiCM6Ojo5ObmsrCwjIyM0NBSq
xDk2NDSQEgl1on4N1tfXf/HFF0Zn8evr60tPT3d1dYVZpJ8OTTza2trg6ogv
f/v2bfQoVQ3IE16DjN7e3oCAAH9/f31rBBHjlK+++oq/xNnFixe9vb337t2b
kpLCFrdHzxkcHMRfBDUjmp7g4uKiqt+RPSAaHNHElT4+PuJXLSDGBYmJidnZ
2dzH9vb2I0eOzJkzh/00vru7OzMzc/PmzejkVVVVzPxBpGxFfZXw4GhwROOX
Qob6lqwkxiN8DUJi8HOgtVdeeaWsrIztwV87O7uvv/6a+5iXl+fm5qae5QHH
lwbz8/Pd3d137NgRGhrKVhfEuAcn09raGg5GcnLyfSO+77//fv/+/eSRThj4
GoTQnJycgoKC5s2bFxkZyZXZvXv3qVOnuI/oOba2tnV1dWPdVj2MLw0i+s7N
zeUSRI5o8u/Ex8c//vjjGNlu3Lhx38ENI+GBAweKiopGvd3EmMBpsLm5+eOP
P66urm5oaHjvvfc2btzIldHSIIiLi4uIiBjrtuphfGmQ0dHRATvIUmIBWMAX
XniBnw3EMJcuXTp27Jjs7SQUgdNgTk7OX/7yFzZHmpSU9NZbb/X29rIyQg2i
88BBFaYvHGNgMhCZLliwAIMGPGTV/uZUZzwIGR4/fhz/df369ZkzZ27btk38
AVtaWiDb4uLiEkIdmNI9OA0iypg1axZb97Wmpmbu3LksJASOjo5aGoQ7tG/f
PnR7U6o2HbhwU6ZMYVkkfvnLX7KgVYXom5OBDGNiYqCmZ555RpJviWBww4YN
a9eu3UCoA1O6B6fBoaGhxYsXw69j2++//z5Cwr6+vtTUVAQvp0+f1voiQhKW
4Imju7sb3Qnj+fYxARU9//zz/JwvGEPGpmqpQIBmZmY63QYMfc899xyXsU4k
w8PDvr6+qnpCRBgNf04mISEBXYXdWXNz861bt45oUkh/8803jY2N/G9hJ7pW
a2srfyeUm5+fj1Alc0zACPDSSy/xNThjxoy0tDS0dmwaIBK0Bz7nypUrdT6b
yMrKggW3tbUV5gUwADS4d+9eXAFc8DxCBUjVHR++BuHhBAcHI/oLDQ11dnZ2
cnJiz+WFXLhwAeOwKfXKgo2NDV+DVlZWSrdINwaeD27atOmVV14pKCiAX204
1wMfhO2rV6/euHHjJkIdmNI9tJ7RI9Crq6srLS2F4wRjp2+Ww9XVVXy2rNGj
qalpyZIlP/3pT5988slPP/1UtYvQ6tNgVVXVs88+6+7uPqJJQ+zj4yMyJVxJ
SQnLK3ePUAemdA8tDYoBfil8J5Us+opOW1xcXF5ervgkrQGEGrx79y4Ln3/x
i1/AX2U7g4KCLC0tIcz7vlETFhYGV2QUW0yMIUZoMC4uLiYmZpTaMyERarCv
rw/X0NraGqKLiorCgAaXIzY21sLCAmYRd8TA0Hr9+nXEC5LetCfUjFQNIkLc
uXNnTU3N6DVp4iHUIN+NgU3UcmzYHp2Hwv7IyMjz58+PVduJUaesrEzSW2cY
sdPS0uTKH/qAINc72xDgqVOnDh8+TL8iJAhJyKJBCDAlJWXTpk0dHR1yNYwg
HhBM1CDUd+3aNbigfn5+lIGFIIwAGjQ3N+/u7r5169aQaKBZSC8/Pz86OnrP
nj0IAfQ9riUIwjCtra1vvvnmokWLzESzatUqBwcHOzs7X1/fzMxMkc8NCaX4
Hxlojnk=
    "], {{0, 0}, {300, 143}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{300, 143},
   PlotRange->{{0, 300}, {0, 143}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998585771*^9, 3.657378836535671*^9},
 CellTags->"b:5.3.2"]
}, Open  ]],

Cell[TextData[StyleBox["Let us  assume we have a five qubit system built as \
in the figure, which corresponds to:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope2", "=", 
   RowBox[{
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "2", ",", "3"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "4", ",", "5"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]1", "=", "RandomQubit1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]Initial", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"\[Rho]1", "\[TensorProduct]", " ", 
     RowBox[{"PX", "[", "0", "]"}], "\[TensorProduct]", "  ", 
     RowBox[{"PX", "[", "0", "]"}], " ", "\[TensorProduct]", " ", 
     RowBox[{"PX", "[", "0", "]"}], "\[TensorProduct]", " ", 
     RowBox[{"PX", "[", "0", "]"}]}], " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]12345", "=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"Ope2", ".", "\[Rho]Initial", ".", 
     RowBox[{"Adj", "[", "Ope2", "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.614028055934391*^9, 3.6140281077983847`*^9}, {
   3.614028143651721*^9, 3.614028179328395*^9}, 3.624190037474728*^9},
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["We now measure qubit 1 in the X basis, qubits 2, 3 \
and 4 in the Y basis and check what  \nwe have in qubit 5 ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["PP", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}]], "  ", ":=", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"PX", "[", "a", "]"}], " ", "\[TensorProduct]", "  ", 
    RowBox[{"PY", "[", "b", "]"}], "\[TensorProduct]", 
    RowBox[{"PY", "[", "c", "]"}], "\[TensorProduct]", " ", 
    RowBox[{"PY", "[", "d", "]"}], "\[TensorProduct]", 
    "\[DoubleStruckCapitalI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.614028196552731*^9, 3.614028252664482*^9}, 
   3.624190037483212*^9},
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[{
 StyleBox["(this proyector could have been written using ",
  FontFamily->"Helvetica"],
 StyleBox["MultiQProj[{1,2,2,2,0},{a,b,c,d,0}] )",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["And therefore the state of the remaining subsystem, \
which depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]5", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "4"}], "*", 
       RowBox[{
        SubscriptBox["PP", 
         RowBox[{"a", ",", "b", ",", "c", ",", "d"}]], ".", "\[Rho]12345", 
        ".", 
        RowBox[{"Adj", "[", 
         SubscriptBox["PP", 
          RowBox[{"a", ",", "b", ",", "c", ",", "d"}]], " ", "]"}]}]}]}], 
     "]"}], "]"}]}], ";"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["If the result of the measurement was 1 for qubit 2 in \
the Z bases and 0 for qubit 3 in the X bases then the \nstate of qubits 1 and \
4 would be given by the following:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]5", "[", 
  RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.614028290260133*^9, 3.614028304096052*^9}},
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6017994794387967`", 
      RowBox[{"0.20650205746311132`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.02342937347717333`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.20650205746311137`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.02342937347717333`", " ", "\[ImaginaryI]"}]}], 
      "0.39820052056120325`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998856975*^9, 3.6573788367922697`*^9},
 CellTags->"b:5.3.2"]
}, Open  ]],

Cell[TextData[StyleBox["Now we can relate this problem to the realization of \
a Hadamard in the Cluster Model, in fact, our \nexample corresponds exactly \
to Fig 2(d) of Raussendorf et al., Phys. Rev. A 022312 (2003). \nTherefore \
according to those authors the output should be, up to a prefactor depending \
on the\nprevious measurements, a Hadamard of the first qubit:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["The prefactor is the following:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["U", 
     RowBox[{"\[CapitalSigma]", ",", "H"}]], "="}], TraditionalForm]],
  FontSize->14],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SuperscriptBox[
      SubscriptBox["\[Sigma]", "x"], 
      RowBox[{"a", "+", "c", "+", "d"}]],
     TraditionalForm], 
    SuperscriptBox[
     SubscriptBox["\[Sigma]", "z"], 
     RowBox[{"b", "+", "c"}]]}], TraditionalForm]],
  FontSize->14]
}], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prefactor", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     SubscriptBox["\[Sigma]", "1"], ",", 
     RowBox[{"a", "+", "c", "+", "d"}]}], "]"}], ".", 
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     SubscriptBox["\[Sigma]", "3"], ",", 
     RowBox[{"b", "+", "c"}]}], "]"}]}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]5Final", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prefactor", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ".", 
   RowBox[{"\[Rho]5", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ".", 
   RowBox[{"Adj", "[", 
    RowBox[{"Prefactor", "[", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], "]"}]}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]5Final", "[", 
   RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "]"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6017994794387967`", 
      RowBox[{"0.20650205746311126`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.023429373477173318`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.20650205746311137`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.023429373477173346`", " ", "\[ImaginaryI]"}]}], 
      "0.39820052056120325`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539799891996*^9, 3.6573788369949913`*^9},
 CellTags->"b:5.3.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{
   RowBox[{"had", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ".", "\[Rho]1", ".", 
   RowBox[{"Adj", "[", 
    RowBox[{"had", "[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.3.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.6017994794387966`", 
      RowBox[{"0.2065020574631114`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.023429373477173294`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.2065020574631114`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.023429373477173294`", " ", "\[ImaginaryI]"}]}], 
      "0.3982005205612032`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979989472*^9, 3.657378837178122*^9},
 CellTags->"b:5.3.2"]
}, Open  ]],

Cell[TextData[StyleBox["The equivalence of the above two results confirms \
that the cluster diagram and the prefactor step does indeed represent a \
Hadamard.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.3.2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section",
 CellChangeTimes->{{3.624196660094534*^9, 3.6241966766307573`*^9}},
 FontFamily->"Times",
 CellTags->{"Measurement", "c:18"}],

Cell[CellGroupData[{

Cell["a) Von Neumann Entropy", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:19", "b:5.4.0"}],

Cell[TextData[{
 StyleBox["The Von Neumann entropy is defined as:  S[\[Rho]] = - Tr [\[Rho] \
Log[2,\[Rho] ] ];\n",
  FontFamily->"Helvetica"],
 StyleBox["We use command EnTropy for Von Neumann entropy",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 CellChangeTimes->{{3.614030534945223*^9, 3.61403055396966*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[TextData[{
 StyleBox["Which can be rewritten as  S[\[Rho]] = -\[Sum] ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["\[Rho]", "\[Lambda]"],
     TraditionalForm], 
    RowBox[{"Log", "[", 
     RowBox[{"2", ",", 
      SubscriptBox["\[Rho]", "\[Lambda]"]}], "]"}]}], TraditionalForm]]],
 StyleBox[" \n",
  FontFamily->"Helvetica"],
 StyleBox["where ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", "\[Lambda]"], " "}], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox["are the eigenvalues of \[Rho], and we keep the convenction",
  FontFamily->"Helvetica"],
 " 0*Log[2,0]:=0"
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[TextData[{
 StyleBox["The Function EnTropy[ ] is already defined in ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[", let's check some examples, Ex 11.11 and 11.12 of Nielsen and \
Chuang:",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.614030525890181*^9, 3.614030526837672*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"\[Rho]1", "=", 
  SubscriptBox["\[ScriptCapitalP]", 
   StyleBox["0",
    ScriptLevel->0]]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]2", "=", 
  RowBox[{
   RowBox[{"1", "/", "2"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], "+", 
     RowBox[{"s", "[", "1", "]"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]3", "=", 
  RowBox[{
   RowBox[{"1", "/", "3"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], "+", 
     RowBox[{"s", "[", "1", "]"}], "+", 
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["0",
       ScriptLevel->0]]}], ")"}]}]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0"},
     {"0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998969314*^9, 3.657378837367453*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998969314*^9, 3.657378837505082*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["2", "3"], 
      FractionBox["1", "3"]},
     {
      FractionBox["1", "3"], 
      FractionBox["1", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397998969314*^9, 3.657378837653635*^9},
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[TextData[StyleBox["..and their entropies are:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"EnTropy", "[", "\[Rho]1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "\[Rho]2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "\[Rho]3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.614030566535005*^9, 3.614030575275133*^9}},
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999024776*^9, 3.657378837952881*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999024776*^9, 3.6573788380922747`*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3", "-", 
        SqrtBox["5"]}], ")"}], " ", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          SqrtBox["5"]}], ")"}]}], "]"}]}], 
     RowBox[{"6", " ", 
      RowBox[{"Log", "[", "2", "]"}]}]]}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", "+", 
       SqrtBox["5"]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", "6"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         SqrtBox["5"]}], ")"}]}], "]"}]}], 
    RowBox[{"6", " ", 
     RowBox[{"Log", "[", "2", "]"}]}]]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999024776*^9, 3.657378838232601*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox["0.5500477595827574`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999024776*^9, 3.657378838374158*^9},
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox[" Now let\[CloseCurlyQuote]s check entropy of ",
  FontFamily->"Helvetica"],
 "\[Rho]",
 StyleBox["=  p | 0 > < 0 |  + (1-p) | + > < + |  case",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{
  3.6242802080850677`*^9, {3.624285236785616*^9, 3.624285238967291*^9}, {
   3.624285378446343*^9, 3.6242853789636106`*^9}, {3.624286081826631*^9, 
   3.624286196903373*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PX"}]], "Input",
 CellChangeTimes->{{3.624286043180051*^9, 3.624286047693625*^9}}],

Cell[BoxData[
 StyleBox["\<\"PX[a], \\n\\n\t Projection operators onto the eigenstates \
\\nof SigmaX. PX[0] and PX[1] are equivalent to |+\[RightAngleBracket]\
\[LeftAngleBracket]+| and \\n|-\[RightAngleBracket]\[LeftAngleBracket]-| \
respectively.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378838578453*^9},
 CellTags->"Info-aacad911-53c1-4908-87ee-2dbbf7a1d457"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Entropy", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"p", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], " ", 
     RowBox[{"PX", "[", "0", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"EnTropy", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Entropy\>\""}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", "p_", "]"}], ":=", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", "p", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "1", ",", ".1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", "p", "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "1", ",", ".1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"{", 
   RowBox[{"t1", ",", "t2"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.624284897350209*^9, 3.624284898190442*^9}, {
  3.624285758241394*^9, 3.62428577728953*^9}, {3.6242862615386667`*^9, 
  3.624286270537112*^9}},
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwd2Hk4lO3bB3BLi7KmKEskJbRQUVL5SiWekK2NQpZKSSIKJUTZIltlyRIR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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["\"p\"", TraditionalForm], 
     FormBox["\"Entropy\"", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 1}, {0., 0.6008760260464354}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979992206993`*^9, 3.6573788387977753`*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {{}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{1., 1.}, {2., 0.9527692569068709}, {3., 0.912310562561766}, {
       4., 0.8807886552931954}, {5., 0.860555127546399}, {6., 
       0.8535533905932737}, {7., 0.860555127546399}, {8., 
       0.8807886552931955}, {9., 0.912310562561766}, {10., 
       0.9527692569068709}, {11., 1.}}]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{1., 0.}, {2., 0.04723074309312919}, {3., 
       0.08768943743823399}, {4., 0.11921134470680464`}, {5., 
       0.13944487245360104`}, {6., 0.14644660940672627`}, {7., 
       0.13944487245360107`}, {8., 0.11921134470680457`}, {9., 
       0.08768943743823394}, {10., 0.04723074309312915}, {11., 
       0.}}]}, {}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0., 11.}, {0, 1.}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979992206993`*^9, 3.6573788389654617`*^9},
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox[" Now let\[CloseCurlyQuote]s check entropy of ",
  FontFamily->"Helvetica"],
 "\[Rho]",
 StyleBox["=  p | 0 > < 0 |  + (1-p) | - > < - |  case",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{
  3.6242802080850677`*^9, {3.624285236785616*^9, 3.624285238967291*^9}, {
   3.624285378446343*^9, 3.6242853789636106`*^9}, {3.624286081826631*^9, 
   3.624286196903373*^9}, {3.624286365487219*^9, 3.6242863693788958`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "\[Rho]Entropy", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Entropy", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"p", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], " ", 
     RowBox[{"PX", "[", "1", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"EnTropy", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Entropy\>\""}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", "p_", "]"}], ":=", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", "p", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "1", ",", ".1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", "p", "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "1", ",", ".1"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"{", 
   RowBox[{"t1", ",", "t2"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.624284897350209*^9, 3.624284898190442*^9}, {
  3.624285758241394*^9, 3.62428577728953*^9}, {3.6242862615386667`*^9, 
  3.624286270537112*^9}, {3.6242863073811398`*^9, 3.624286341525017*^9}},
 FontSize->16,
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwd2Hk4lO3bB3BLi7KmKEskJbRQUVL5SiWekK2NQpZKSSIKJUTZIltlyRIR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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["\"p\"", TraditionalForm], 
     FormBox["\"Entropy\"", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0, 1}, {0., 0.6008760260464354}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979993271513`*^9, 3.6573788392818213`*^9},
 CellTags->"b:5.4.0"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {{}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{1., 1.}, {2., 0.9527692569068709}, {3., 0.912310562561766}, {
       4., 0.8807886552931954}, {5., 0.860555127546399}, {6., 
       0.8535533905932737}, {7., 0.860555127546399}, {8., 
       0.8807886552931955}, {9., 0.912310562561766}, {10., 
       0.9527692569068709}, {11., 1.}}]}, 
     {RGBColor[0.880722, 0.611041, 0.142051], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{1., 0.}, {2., 0.04723074309312919}, {3., 
       0.08768943743823399}, {4., 0.11921134470680464`}, {5., 
       0.13944487245360104`}, {6., 0.14644660940672627`}, {7., 
       0.13944487245360107`}, {8., 0.11921134470680457`}, {9., 
       0.08768943743823394}, {10., 0.04723074309312915}, {11., 
       0.}}]}, {}}, {}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{},
   PlotRange->{{0., 11.}, {0, 1.}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.02], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979993271513`*^9, 3.657378839444005*^9},
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Examples using GHZ and other Multi-qubit states are easily \
generated in ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[".",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["b) Fidelity", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:20", "b:5.4.1"}],

Cell[TextData[{
 StyleBox["The fidelity of two states is defined:  Fidelity",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"[", 
    RowBox[{
     SubscriptBox["\[Rho]", "1"], ",", 
     SubscriptBox["\[Rho]", "2"]}]}], TraditionalForm]]],
 StyleBox["] = Tr [ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{
     SqrtBox[
      SubscriptBox["\[Rho]", "2"]], ".", 
     SubscriptBox["\[Rho]", "1"], ".", 
     SqrtBox[
      SubscriptBox["\[Rho]", "2"]]}]], TraditionalForm]]]
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"State1", "=", "RandomQubit2"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"SpinObs", "[", "%", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"State2", "=", "RandomQubit2"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"SpinObs", "[", "%", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.624280297749205*^9, 3.624280323872333*^9}},
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.08129212634023798`", 
      RowBox[{"0.014872287602791582`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.06344934460184602`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.10976644953542303`"}], "+", 
       RowBox[{"0.0029622042486843704`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03202292947739536`"}], "+", 
       RowBox[{"0.01904154096952271`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.014872287602791582`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.06344934460184602`", " ", "\[ImaginaryI]"}]}], 
      "0.2612160854751903`", 
      RowBox[{"0.04022236598578809`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.02978271693055369`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.034522688898216386`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.11835395432666514`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.10976644953542303`"}], "-", 
       RowBox[{"0.0029622042486843704`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.04022236598578809`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.02978271693055369`", " ", "\[ImaginaryI]"}]}], 
      "0.38641876040586004`", 
      RowBox[{"0.2038296041465842`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.11736723485369864`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03202292947739536`"}], "-", 
       RowBox[{"0.01904154096952271`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.034522688898216386`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.11835395432666514`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.2038296041465842`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.11736723485369864`", " ", "\[ImaginaryI]"}]}], 
      "0.2710730277787116`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999368682*^9, 3.657378839674096*^9},
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {
              RowBox[{"-", "0.15048752127441328`"}]},
             {"0.23078350015596152`"},
             {
              RowBox[{"-", "0.31498357636914337`"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0.43740378349875153`"},
             {"0.10783578050370524`"},
             {
              RowBox[{"-", "0.06457822650780393`"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.01639887301678547`", "0.02148235192206196`", 
             RowBox[{"-", "0.2885782768672789`"}]},
            {
             RowBox[{"-", "0.0976485158001528`"}], "0.1444905909263669`", 
             RowBox[{"-", "0.24263231715069902`"}]},
            {
             RowBox[{"-", "0.3779146330875852`"}], 
             RowBox[{"-", "0.3616331589110893`"}], 
             RowBox[{"-", "0.29526969176210077`"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999368682*^9, 3.657378839818591*^9},
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.2539147503874601`", 
      RowBox[{
       RowBox[{"-", "0.07148121481993149`"}], "-", 
       RowBox[{"0.0624863788874515`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.015631594290954308`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.05790032343686816`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.06840692303950623`"}], "-", 
       RowBox[{"0.08238310015994567`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.07148121481993149`"}], "+", 
       RowBox[{"0.0624863788874515`", " ", "\[ImaginaryI]"}]}], 
      "0.32517163759953654`", 
      RowBox[{
       RowBox[{"-", "0.109511971813141`"}], "+", 
       RowBox[{"0.104062445988988`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.15955100413147277`"}], "-", 
       RowBox[{"0.03330478776075114`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.015631594290954308`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.05790032343686816`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.109511971813141`"}], "-", 
       RowBox[{"0.104062445988988`", " ", "\[ImaginaryI]"}]}], 
      "0.17799674119194386`", 
      RowBox[{"0.10469646200299944`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.07871833667175214`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.06840692303950623`"}], "+", 
       RowBox[{"0.08238310015994567`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.15955100413147277`"}], "+", 
       RowBox[{"0.03330478776075114`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.10469646200299944`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.07871833667175214`", " ", "\[ImaginaryI]"}]}], 
      "0.24291687082105956`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999368682*^9, 3.657378839970667*^9},
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {
              RowBox[{"-", "0.2878388196810369`"}]},
             {"0.1824102223952386`"},
             {"0.1581727759739932`"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0.0664304943661359`"},
             {
              RowBox[{"-", "0.03246391556860127`"}]},
             {
              RowBox[{"-", "0.13617701684119216`"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {
             RowBox[{"-", "0.35583778970529445`"}], "0.3728910922978673`", 
             "0.3503651968448542`"},
            {
             RowBox[{"-", "0.04335869165808469`"}], 
             RowBox[{"-", "0.08221009754726956`"}], "0.04919107135223404`"},
            {
             RowBox[{"-", "0.35235535364586185`"}], "0.2824094311184073`", 
             RowBox[{"-", "0.006336757582960761`"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999368682*^9, 3.6573788401223383`*^9},
 CellTags->"b:5.4.1"]
}, Open  ]],

Cell[TextData[StyleBox["their fidelity is:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Fidelity", "[", 
  RowBox[{"State1", ",", "State2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Fidelity", "[", 
  RowBox[{"State2", ",", "State1"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox["0.7702768293453789161251421546694473363459110260009765625`19.\
43510184057347",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999418655*^9, 3.657378840388467*^9},
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox["0.77027682934537800019114683891530148684978485107421875`19.\
43510184057347",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999418655*^9, 3.6573788405448112`*^9},
 CellTags->"b:5.4.1"]
}, Open  ]],

Cell[TextData[StyleBox[" The fidelity is one if both states are the same:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fidelity", "[", 
  RowBox[{"State1", ",", "State1"}], "]"}]], "Input",
 CellChangeTimes->{{3.624280343165654*^9, 3.624280407911034*^9}},
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox["1.00000000000000034694469519536141888238489627838134765625`19.\
548455006504028",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553979994479218`*^9, 3.657378840716387*^9},
 CellTags->"b:5.4.1"]
}, Open  ]],

Cell[TextData[StyleBox[" Let's see the behavior of the Fidelity for a couple \
of interesting examples:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Fid", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"p", " ", 
     SubscriptBox["\[ScriptCapitalP]", "1"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], " ", 
     RowBox[{"PX", "[", "1", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fide", "[", "p_", "]"}], ":=", 
  RowBox[{"Fidelity", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], ",", 
    RowBox[{"\[Rho]Fid", "[", "p", "]"}]}], "]"}]}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fide", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", 
     RowBox[{"-", "5"}], ",", "7"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Fidelity\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJw1lnk01I33x8eSPFJPGltG0UKlRWUpiven0rRqk0pU0qRIotUSIX0fqSwP
D5IeSoVKZMuWGUvWFAZZY5gs0zAzxjJ8Wr5+53e+f9xzzz2vc8895/5x72uR
w6VDZ6UpFMq76fi/fCYtTPD7N5V1y7D9q1cOCVboAt1NP6isDI3OUsssEppu
L+2uS6gsapG6j3YGiea1ZVV8IZV15TvV5UMqiZ0ZE4mtHCrLoXzCdPZzEmuy
Tx7LLKWyejccjYiMICHJX1Xs+BeV1VGbzPV3I3G/vPLv2jlUVkOjQWrjChLa
Ghy3g3/MYwVEOV6bGzIFt81WB1eoKLE0rCKfW01Owj5pnF6jM5e1M852hSFj
Ejcejw7TLeawLMWFSz2LJHhxN+1w/ClFVmX3ydxqLQleDeutZRxSYC0MV4pQ
vTSBEa688ft98qxvTRNSjMJxpHvEEkUX5VhblScocXPHYXGHz1rJkGW9wovr
pgfGcEB/ZPsWH2lWYLJz1Z6oUTx2Pj7Gi6ewWgdGJy+0ihFgJmckbfiTqbD5
b66RrBi53UVBvhcnmfupObu8DEfw6Jqkgm09xvwmJVuzd6cIUqsnbA8eFDEP
Mo6Ee1kJ8do8f8Rs6XfmthzXGH7JMNLlgmTvyfQyGctr4+rC+Vh6d+chYVsz
c+Us+f1adjw4raHq5iXnMVP8/FN/FPSj7PPhFu6VUgR9ObDEqpkLaYemDlt+
KVT8rgwxq7kgRq05DYwykGtstuoyuShUP8pjWX+Ar1KPfVcSF1mnbX7EbajA
Uaf9JtKeXDwTn9C2JquhHJ6rT9HgouSeQZbDlnpcprEeBB7pRWLa5h8NlS2Q
o9Q2H8nhIHmwTKCt0AojiaJpeBIHr5dY9rruaUVkQ7ExM4aDrOgT1QqfWlEw
i+475sVB2S3fmK3sNhjTeZkV5hz07WcZZnR2QKR6nM4t7YaK5EnOTs9uiH75
T9Xe6YK6imO64GE3lA1+DUUxuqCxXu9lVH43Xml5R2/e1oWFLhmPuWQ3QkwY
FpqULuh2lwT6+XLwbtJaRtvjKzZU9h7Kvd2De8XWypX2nbCJ0REsC+FCvinC
8czcdgR6/3v+2WsuKhY2OoLfhjcn1Xq0a7gInVP6hFfRBlmdP5rmy39DpMb8
Z698p/lbfv6sgG+QXziRzBpshWxN5n8E1/pg/JJ54nx2C9a8WUVxiexD7HVX
tdoHLbAJf+45kNGH4ZqpO6KzLXhzNNqFI+iDaQw74KrKNOd6HWI79WPgxekX
Zu5f8ObnloXvTgxg3l8KIUEazWjpzo82uDmAXoMtTibDTZApM1BKjx3AulrH
mWHFTTgWrCOb8mUAx0ddsnTOTXO1P3ixBwexvvhGeFpqI46trcv23c5DukVJ
drEOGwHUXfrkGR6MypcqB480IHW8OPlGAA8dgY23y4saIP0+85Ebk4fd517O
uGs9zXdF+zuYfIeitLpGonc9pM+ctKSv5iPfUeVt287PUF+wLnDFHj4+zL+/
Jb72E/S/yBQoOvER6PKK73rgE+z2pCxnP+Ojfuxpf/X+WuQYjMrYaw6BUVOi
vnZ9DT4OlZtuMx1C5InMOqVn1ehNeuiue2wINo/TlYfmVWOuJrr4EUOQuTQV
VtBXiQuywfmes4YRWq/Ktz5VjoAiO5HdimF8kpGekf32A2I89JcTO4Yx1HGF
6/GrDOX8xn/kbg9D1vFvP1ZgKTpeJH0cTBjGMq3fm1iFJRDbe8nUFk3X9e4r
FfjF0G7Sco+YGoYX38JMbyULxqEjSdfVBUhlyIuLXYtguevDVxtjAarUDN+E
OhaCIROjYnZYgJXBRmeXG+fD673zXu3LAqwOmr3Qs+Edwm6Y3ZYJE8BkVVW6
nl42ktbNze9LFWCP5s9sHa0MFH3vEVbVCJBbfyZZp/81Gp9nL0sdFGDx6dzI
NX1PMaZvoV8pI8Tv1k7fu5QoUB6kVufNm74beRStRK9kKPJUHV8tEiKt61aJ
j1M61Hb4ST1eK0SxGvz8cjOx+NlgXAiE6Oxnrw6+n4M1UlYb/fYJURN43t3+
zzyYnCxku58Q4tqAFO/C0QJYFOhcOuMihO7bAZnjl99jv3qogrW3ENvIZQbm
TkwcvyZ5Tg8Woqdea8DsCQvu+jUdK5KFSAxtNP1ypAQ37xt60N4JYajwaKbU
kum7NPiYOrtcCDm9SJ1ffaX4N9Ftt7BXiKGSrSlDNh+QQmn7xhkR4sL7zs1b
FcqRdWKbP1tKBO9rGzaYZ5ejRk01N0dLhOYH/ktHflRAcq9Ax8dWhHzt70aV
dtWQHVxa7Oosgr6TftNJfjX+pIfY2XuKsHdocPFMzxroUk5HbIsWIbP28iaT
4I+wuionpcAWYZ+b0kPFsE+IqS3eSPSKULLxrFGa6md06Pq4XReLMN9mvb3y
o89wbBV39VBH0P30amDVvjp4mHOKCg6PwDt0KHZ8ez3i5AtvXmweQfgZKVPu
HDa6T9/ISuwbgU5/vbX8djZ0CtbzW8en+2/MlPzjxcabiym2dDUxVuVMMClc
Nooboky1jomhFH+Qdy+9EX1x7pK66b9iG76gMtqgGXrjq9bO5ImRviypZLFD
My7tHzhnNiWGjWZIoWVYMyRSp76kaIyiOZOef/97MxTO7c0JsB1FhVTm1cHH
X6C/btlVw85RdLpsv54jboHHhw5BdPcYvAjJjoiL7aj3v9yfKxjDJb2oiqqw
duiZy3e1/hqDezgvkJ3Zjo4cg0+0BePo0Iw7dmayHUgOfh1vMw7RtQTunYAO
yN3b6JTUMI64NCP2kQediDgQ2ZNTNoEsuyftIUFdeNO+p6kpeRLhs8NONEZy
QEQaOG3Km4TbbUXl/EQOGvbSfiZUTaJ9G52IyOBg/D1vqQtvEoOV9BvadRwg
4e5V6VVTMClvT09R6EEdo4KqnzYF45qiI2E+PRAPbT0UlE0iLqpt+WnbXmyk
mH42LfmJIIuHf8aSXGj5r8vfxKUQiUWqEZ1t/XjFmCefUSZNXA9SlbpH8GD/
eX13Qa0sMVZzXHFdAh//xsVnLsiSI7bMj9SnpQ4jtiXF7nuYPHFrg/rlxh1C
sB6JQ/dGKRBbzF/uYpqL4Fp8t2iGpyIR1+a/lD5/BHTXUzcOBc4hkuUy4pTJ
EbCLWP94G88lNNb8XNNSJkavT0KbjK4SYekw8WPR7VH8RUngNq2YR1DVStXk
d4/BLWs730qTSrwsMdE5/HMMwytn5dGWKBNdo6kLGXnjqDke7zZfR4VgmHU5
73aZAD+/VadURZVQc6fn+cyR4OlXg4QcDTVi0kMq5FWeBHEGhupH5qgT32Id
K85ZT2IMMt4rf6oTl0zWKwZN77n3z5GnuykahOaG0n/ig6agovRXpcqIBkGm
sX9w1UmEbFjibjmuQcgaSk450EjIn2TOvzOlQXRkRwV1LSAx9XLCeVSaRiyk
Bei1Libx1eL8bDaVRgQlszOqVpFI9th1KMyIRmjlWfXGEyQ2d8/qUPCkEXmm
nesWnSeRLZccuNWHRnhKeA7RztO+uNpitZc/jVi26bzt7IskFnnd9B28SyMO
6w0/lbiTkFMe0q6MpRFSa+sefPQmUbfj09k7hTRiRoZGt1MoiV2uznPes2iE
3nnD0I5wEiWRcu9Gy2jEQak3cvsjp+dxzOUZtTRi+6wf+wwekoj1Tnu59SuN
iLdOoE8+JUF9usfKq4dGtK44Yuo87a/3K/vJt300IjmSM96WRMJXRdtykYBG
xNzPrC54TWJiU+HYMTGNGNuo1rMyjYSbw7F/wyZoxOn84JJHb0nwgkbplSSN
8A7TdJk17c//79c04n9+/V85E8Nq
      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["\"p\"", TraditionalForm], 
     FormBox["\"Fidelity\"", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{-5, 7}, {0., 1.7320507722209013`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999588956*^9, 3.657378840962591*^9},
 CellTags->"b:5.4.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Fid2", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"Sin", "[", "p", "]"}], "2"], " ", 
     SubscriptBox["\[ScriptCapitalP]", "1"]}], "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"Cos", "[", "p", "]"}], "2"], " ", 
     RowBox[{"PX", "[", "0", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fide", "[", "p_", "]"}], ":=", 
  RowBox[{"Fidelity", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], ",", 
    RowBox[{"\[Rho]Fid2", "[", "p", "]"}]}], "]"}]}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fide", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "0", ",", 
     RowBox[{"4", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Fidelity\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.1"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJw1m3c8lf/7x+295zm2Yx2jgUoZXVfSIkJIU5tKkqwkI1FJVqKSUbZsUsnO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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{
     FormBox["\"p\"", TraditionalForm], 
     FormBox["\"Fidelity\"", TraditionalForm]},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->
    NCache[{{0, 4 Pi}, {0., 0.7071067811865243}}, {{0, 12.566370614359172`}, {
      0., 0.7071067811865243}}],
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655397999943523*^9, 3.6573788414197693`*^9},
 CellTags->"b:5.4.1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["c) GHZ study", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:4", "b:5.4.2"}],

Cell["\<\
Start with a pure three qubit state in the computational basis |abc\
\[RightAngleBracket]\[LeftAngleBracket]abc| :\
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"a_", ",", "b_", ",", "c_"}]], ":=", 
  RowBox[{"AF", "[", " ", 
   RowBox[{
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", "a"],
     ScriptLevel->0], "\[TensorProduct]", " ", 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", "b"],
     ScriptLevel->0], 
    StyleBox["\[TensorProduct]",
     ScriptLevel->0], 
    StyleBox[" ",
     ScriptLevel->0], 
    StyleBox[
     SubscriptBox["\[ScriptCapitalP]", "c"],
     ScriptLevel->0]}], 
   StyleBox["]",
    ScriptLevel->0]}]}]], "Input",
 CellChangeTimes->{{3.614030638408154*^9, 3.614030645066778*^9}, {
   3.614030725108375*^9, 3.614030743657216*^9}, 3.624190037491364*^9},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[" Generate GHZ state operator as seen in the figure:", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/gGHZ.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure2", "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  GraphicsBox[RasterBox[CompressedData["
1:eJztnQtYTVn/x6mUy/DKbV7MuBQmMm/GJMUQuZNruggRU4oolCS3zJAMSRcq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    "], {{0, 0}, {250, 150}}, {0, 255},
    ColorFunction->RGBColor],
   ImageSize->{250, 150},
   PlotRange->{{0, 250}, {0, 150}}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000120467*^9, 3.6573788417175093`*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", "GHZop", "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GHZop", "[", 
   RowBox[{"qi_", ",", "qj_", ",", "qk_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qk"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qj"}], "]"}]}], ".", 
   RowBox[{"had", "[", 
    RowBox[{"3", ",", "qi"}], "]"}]}], " "}]], "Input",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
   RowBox[{
   "GHZ\[Rho]", "   ", "is", " ", "the", " ", "density", " ", "matrix", "  ", 
    "of", " ", "any", " ", "of", " ", "the", " ", "GHZ", " ", "states"}], ",",
    " ", 
   RowBox[{"depending", " ", "on", " ", "the", " ", "initial", " ", 
    RowBox[{"state", ":", " "}]}]}]}]], "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{
     SubscriptBox[
      StyleBox[
       RowBox[{
        StyleBox["G",
         FontSize->18], 
        StyleBox["HZ",
         FontSize->12], 
        StyleBox["\[Rho]",
         FontSize->18]}]], 
      RowBox[{"a_", ",", "b_", ",", "c_"}]], "  ", ":=", 
     RowBox[{
      RowBox[{"GHZop", "[", 
       RowBox[{"1", ",", "2", ",", "3"}], "]"}], ".", 
      SubscriptBox["\[Rho]", 
       RowBox[{"a", ",", "b", ",", "c"}]], ".", 
      RowBox[{"Adj", "[", 
       RowBox[{"GHZop", "[", 
        RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}]}]}], ";"}]}],
  FontSize->18]], "Input",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[" Checks on some of the GHZ states: ", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "0", ",", "0"}]]], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980001816063`*^9, 3.657378841901753*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "0", ",", "1"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "0", ",", "1"}]]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980001970367`*^9, 3.65737884209546*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980001970367`*^9, 3.6573788422475977`*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "1", ",", "0"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "1", ",", "0"}]]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000237001*^9, 3.6573788424245987`*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["1", "2"], "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000237001*^9, 3.6573788425782423`*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "1", ",", "1"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "1", ",", "1"}]]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000270466*^9, 3.657378842858838*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0"},
     {"0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000270466*^9, 3.657378843019115*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["\<\
Now we will focus on one of the states, the usual GHZ, and study its 
properties:
 Vector and tensor polarizations of GHZ state :
 Vector polarizations are zero for GHZ states 
 Rank 2 Tensor polarizations for GHZ state 
 Rank 3 Tensor polarizations for GHZ state \
\>", "Text",
 CellChangeTimes->{3.624280594189108*^9},
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox[
    SubscriptBox["\[Rho]", "GHZ"],
    FontSize->12], 
   StyleBox["=",
    FontSize->12], 
   SubscriptBox[
    StyleBox[
     RowBox[{"G", 
      StyleBox["HZ",
       FontSize->12], "\[Rho]"}]], 
    RowBox[{"0", ",", "0", ",", "0"}]]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{
  3.6140311479182453`*^9, {3.6140312160120497`*^9, 3.614031234866044*^9}, {
   3.61403180385396*^9, 3.6140318062157497`*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980003099003`*^9, 3.657378843211377*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", 
   RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Tr", "[", 
   RowBox[{
    RowBox[{"AF", "[", 
     RowBox[{
      SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
      SubscriptBox["\[Sigma]", "j"], "\[TensorProduct]", 
      SubscriptBox["\[Sigma]", "k"]}], "]"}], ".", 
    SubscriptBox[
     StyleBox[
      RowBox[{"G", 
       StyleBox["HZ",
        FontSize->12], "\[Rho]"}]], 
     RowBox[{"0", ",", "0", ",", "0"}]]}], "]"}]}]], "Input",
 CellChangeTimes->{3.624190037499164*^9},
 FontSize->16],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PGHZA", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"2", ",", "0", ",", "0"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"3", ",", "0", ",", "0"}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PGHZB", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "2", ",", "0"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "3", ",", "0"}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PGHZC", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "0", ",", "1"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "0", ",", "2"}], "]"}], ",", 
       RowBox[{"T", "[", 
        RowBox[{"0", ",", "0", ",", "3"}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.6140308112799273`*^9, 3.614031081906542*^9}, {
  3.6140311246111403`*^9, 3.6140311298066998`*^9}, {3.6140311615443068`*^9, 
  3.614031237499469*^9}, {3.614031279696382*^9, 3.614031297515914*^9}, {
  3.614031339117463*^9, 3.614031357376213*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"TGHZAB", 
   StyleBox["=",
    FontSize->12], 
   RowBox[{"{", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "j", ",", "0"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TGHZAC", "=", 
   RowBox[{"{", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "0", ",", "j"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TGHZBC", "=", 
   RowBox[{"{", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "i", ",", "j"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TGHZABC", 
   StyleBox["=",
    FontSize->12], 
   RowBox[{"{", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "j", ",", "k"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", "PGHZA", "\[IndentingNewLine]", "PGHZB", "\
\[IndentingNewLine]", "PGHZC", "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6140314037778397`*^9, 3.614031515754469*^9}, 
   3.614031558269273*^9},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000462953*^9, 3.657378843512603*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000462953*^9, 3.657378843670843*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000462953*^9, 3.657378843826665*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"AF", "[", "TGHZAB", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", "TGHZAC", "]"}], "\[IndentingNewLine]", 
 RowBox[{"AF", "[", "TGHZBC", 
  "]"}], "\[IndentingNewLine]", "TGHZABC"}], "Input",
 CellChangeTimes->{{3.614031564509616*^9, 3.614031586486964*^9}, {
  3.6241935451189623`*^9, 3.624193545127453*^9}, {3.624227477695138*^9, 
  3.624227492793047*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000486909*^9, 3.657378844096834*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000486909*^9, 3.657378844276174*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"1"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000486909*^9, 3.6573788444316387`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1", "0", "0"},
         {"0", 
          RowBox[{"-", "1"}], "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "1"}], "0"},
         {
          RowBox[{"-", "1"}], "0", "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {"0", "0", "0"},
         {"0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000486909*^9, 3.657378844620633*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"T", "[", 
  RowBox[{"1", ",", "1", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"1", ",", "2", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"2", ",", "2", ",", "1"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000537199*^9, 3.657378844822014*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", "1"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000537199*^9, 3.657378844979198*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", "1"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000537199*^9, 3.6573788451461554`*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", "1"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000537199*^9, 3.657378845313064*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["We can reconstruct the Density Matrix ", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "8"}], ")"}], "  ", 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"i", "=", "0"}], "3"], "   ", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"j", "=", "0"}], "3"], "  ", 
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"k", "=", "0"}], "3"], "  ", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"i", ",", "j", ",", "k"}], "]"}], "*", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", 
          SubscriptBox["\[Sigma]", "j"], "\[TensorProduct]", 
          SubscriptBox["\[Sigma]", "k"]}], ")"}]}]}]}]}]}], "]"}], "==", 
  SubscriptBox[
   StyleBox[
    RowBox[{"G", 
     StyleBox["HZ",
      FontSize->12], "\[Rho]"}]], 
   RowBox[{"0", ",", "0", ",", "0"}]]}]], "Input",
 CellChangeTimes->{{3.6140316590285254`*^9, 3.614031678938483*^9}, {
   3.614031719966981*^9, 3.614031760182764*^9}, 3.624190037507101*^9},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000704904*^9, 3.6573788456356564`*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["or, identically making use of the general SP function: ", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "8"}], ")"}], "   ", 
   RowBox[{"(", "  ", 
    RowBox[{
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], "  ", "+", " ", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3", ",", "0"}], "}"}]}], "]"}], "+", " ", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "0", ",", "3"}], "}"}]}], "]"}], "+", " ", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "3", ",", "3"}], "}"}]}], "]"}], "+", " ", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "]"}], "-", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "2"}], "}"}]}], "]"}], "-", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "2"}], "}"}]}], "]"}], "-", 
     RowBox[{"SP", "[", 
      RowBox[{"3", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "]"}]}], ")"}]}], "==", 
  SubscriptBox[
   StyleBox[
    RowBox[{"G", 
     StyleBox["HZ",
      FontSize->12], "\[Rho]"}]], 
   RowBox[{"0", ",", "0", ",", "0"}]]}]], "Input",
 CellChangeTimes->{{3.6140317752912693`*^9, 3.6140317760579576`*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000734077*^9, 3.657378845822084*^9},
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SP"}]], "Input",
 CellChangeTimes->{{3.62428064876297*^9, 3.624280650023032*^9}},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"SP[Length[V],V]\\n\\n\t SP returns the tensor or spin \
product(SP) of \\n\\n Length[V] qubits with the components\\n\\n specified by \
the array V.  The array V={0, 1,2,q,...}has \\n\\n a length equal to the \
number of qubits\\n\\n and the entries in the array V specify the\\n\\n \
components of the qth Pauli operator.  \\n\\n\t For example:  SP[2,{3,2}] \
returns the same 4X4 matrix as\\n\\n AF[Sigma3\[TensorProduct]Sigma2].  The \
advantage of SP is that it\\n\\n works for large dimensional matrices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378846036922*^9},
 CellTags->"Info-015c69a6-5e03-4543-ad12-b861b736a1df"]
}, Open  ]]
}, Open  ]],

Cell["Check on the Entropy of the full system and Sub Entropies", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EnTropy", "[", 
  StyleBox[
   SubscriptBox["\[Rho]", "GHZ"],
   FontSize->12], "]"}]], "Input",
 CellChangeTimes->{{3.6140317839190683`*^9, 3.6140317864496403`*^9}, {
  3.614031832899411*^9, 3.6140318342238703`*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["0",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398000854535*^9, 3.657378846227614*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["\<\
The density matrix of the subsystem [a,b] can be obtained readily, and its 
decomposition into products of Pauli matrices is explictly given\
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.614032030845154*^9, 3.6140320377964287`*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"2"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980008830423`*^9, 3.65737884642292*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PartialTrace"}]], "Input",
 CellChangeTimes->{{3.6140320605305977`*^9, 3.6140320814856873`*^9}},
 FontSize->16],

Cell[BoxData[
 StyleBox["\<\"PTrS[q,L,V] and PTr[traceout,\[CapitalOmega]] \\n\\n\\n\\n \
PTr[traceout,\[CapitalOmega]] returns the partial trace \\n\\n of general \
operator \[CapitalOmega] over those qubits \\n\\n specified by the traceout \
array 'traceout'. \\n\\n\\n\\n PTrS[q, L,V] returns the partial trace of spin \
basis \\n\\n operator of length L over single qubit q within L qubits, \\n\\n \
with the array V specifying the spin basis operator.\\n\\n This method \
reduces the operator down to the requisite smaller arrays.\\n\\n\\n\\n  see \
also PTrGen\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378846657178*^9},
 CellTags->"Info-351e538f-bd6e-4a72-81fc-8f87e467f726"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Subsys", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"Complement", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b"}], "}"}]}], "]"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Subsys", "[", 
  RowBox[{"2", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.614032130076726*^9, 3.61403215132615*^9}},
 FontSize->16],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001127528*^9, 3.657378846853879*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Subsys23", "=", 
  RowBox[{"Subsys", "[", 
   RowBox[{"2", ",", "3"}], "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001160509*^9, 3.657378847039317*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 StyleBox[
  RowBox[{"Subsys23", "=", 
   RowBox[{"Subsys", "[", 
    RowBox[{"2", ",", "3"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 RowBox[{"SpinObs", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.61403187202464*^9, 3.614031878287242*^9}, {
  3.624280697098756*^9, 3.624280708017912*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539800120516*^9, 3.657378847227971*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"\<\"PA=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"PB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
             {"0"},
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.5599999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           Column], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]},
      {
       RowBox[{"\<\"TAB=\"\>", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", "1"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.65539800120516*^9, 3.657378847389045*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["The Entropy of the subsystem 23 is however:", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EnTropy", "[", "Subsys23", "]"}]], "Input",
 CellChangeTimes->{{3.614032202377427*^9, 3.614032203253832*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980012399483`*^9, 3.657378847579261*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell["\<\
It is simple to do the same game for the other subsystems, which can be \
checked to give the same 
result as this one.\
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell["\<\
Finally we show the Sub Entropy for the single qubit density matrices: \
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Subsys3", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "Subsys3", "]"}]}], "Input",
 CellChangeTimes->{{3.614032213886055*^9, 3.614032214537125*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980012783422`*^9, 3.657378847847918*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980012783422`*^9, 3.657378848010397*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Subsys2", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "Subsys2", "]"}]}], "Input",
 CellChangeTimes->{{3.614032233864457*^9, 3.614032241184369*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980013169193`*^9, 3.657378848193128*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980013169193`*^9, 3.657378848350173*^9},
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Subsys1", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"EnTropy", "[", "Subsys1", "]"}]}], "Input",
 CellChangeTimes->{{3.614032248083827*^9, 3.614032249486787*^9}},
 FontSize->16,
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980013570013`*^9, 3.6573788485411863`*^9},
 CellTags->"b:5.4.2"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980013570013`*^9, 3.6573788487046213`*^9},
 CellTags->"b:5.4.2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 1: The Werner state made of qubits 12  is built"
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:4", "b:5.4.3"}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "Build", " ", "the", " ", "Two", " ", "Qubit", " ", "Werner", "  ", 
   "density", " ", "matrix", "   ", 
   StyleBox["W",
    FontSize->12], "  ", 
   RowBox[{"(", " ", 
    RowBox[{"Noisy", " ", "Entangled", " ", "State", " ", "Resource"}], " ", 
    ")"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "First", " ", "get", " ", "the", " ", "Bell", " ", "density", " ", 
   "matrix"}], " "}]}], "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Bell states",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are the following:\n",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "00"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] + |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "01"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] + |10\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "10"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] - |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "11"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] - |10\[RightAngleBracket] )"
}], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["We regenerate the Bell states here in a manner that \
allows general labels",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.624283907865839*^9, 3.624283940906536*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["They can all be constructed in the following way, \
first we build a Bell operator of the form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Bellop", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], " "}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      FractionBox["1", 
       SqrtBox["2"]]},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}]},
     {
      FractionBox["1", 
       SqrtBox["2"]], "0", 
      RowBox[{"-", 
       FractionBox["1", 
        SqrtBox["2"]]}], "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001384202*^9, 3.6573788489804296`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[TextData[StyleBox["Then we build the Bell density matrix",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["RB", 
    RowBox[{"a_", ",", "b_"}]], ":=", 
   RowBox[{"Bellop", ".", 
    RowBox[{"AF", "[", 
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["a",
         ScriptLevel->0]], "\[TensorProduct]", 
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["b",
         ScriptLevel->0]]}],
      ScriptLevel->0], 
     StyleBox["]",
      ScriptLevel->0]}], ".", 
    StyleBox[
     RowBox[{"Adj", "[", "Bellop", "]"}],
     ScriptLevel->0], " "}]}]}]], "Input",
 CellChangeTimes->{{3.6140323294519157`*^9, 3.614032341498624*^9}, 
   3.614075965723287*^9, 3.6242841196834803`*^9},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[TextData[Cell[BoxData[
 StyleBox[
  RowBox[{"Here", "  ", 
   SubscriptBox["RB", 
    RowBox[{"a_", ",", "b_"}]], " ", "denotes", " ", "the", "  ", "Bell", " ",
    "density", " ", "matrix", " ", "not", " ", "the", " ", "Bell", " ", 
   "states"}],
  FontFamily->"Helvetica"]]]], "Text",
 CellChangeTimes->{
  3.6242840601391582`*^9, {3.62428412346388*^9, 3.6242841234638968`*^9}},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 SubscriptBox["RB", 
  RowBox[{"0", ",", "0"}]], "\[IndentingNewLine]", 
 SubscriptBox["RB", 
  RowBox[{"0", ",", "1"}]], "\[IndentingNewLine]", 
 SubscriptBox["RB", 
  RowBox[{"1", ",", "0"}]], "\[IndentingNewLine]", 
 SubscriptBox["RB", 
  RowBox[{"1", ",", "1"}]]}], "Input",
 CellChangeTimes->{
  3.624283983637344*^9, {3.62428412768147*^9, 3.624284137288898*^9}, 
   3.6242842248937902`*^9},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014169617`*^9, 3.6573788491890087`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014169617`*^9, 3.657378849351296*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014169617`*^9, 3.657378849515738*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014169617`*^9, 3.657378849681381*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[TextData[StyleBox["Then we build the Werner density matrix which adds a \
noisy density matrix to the Bell State density matrix with a parameter \
\[Lambda] that varies between 0 and 1;  1 being pure Bell entangled state, 0 \
being completely random or noisy.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["W", 
    RowBox[{"a_", ",", "b_", ",", 
     StyleBox["\[Lambda]_",
      FontFamily->"Helvetica"]}]], ":=", 
   RowBox[{
    RowBox[{
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"], 
     StyleBox["   ",
      FontFamily->"Helvetica"], 
     RowBox[{"Bellop", ".", 
      RowBox[{"AF", "[", 
       StyleBox[
        RowBox[{
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["a",
           ScriptLevel->0]], "\[TensorProduct]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["b",
           ScriptLevel->0]]}],
        ScriptLevel->0], 
       StyleBox["]",
        ScriptLevel->0]}], ".", 
      StyleBox[
       RowBox[{"Adj", "[", "Bellop", "]"}],
       ScriptLevel->0]}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{"(", " ", 
      RowBox[{"1", "-", " ", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}], 
      StyleBox[")",
       FontFamily->"Helvetica"]}], 
     StyleBox["  ",
      FontFamily->"Helvetica"], 
     RowBox[{
      RowBox[{"(", " ", 
       RowBox[{"AF", "[", 
        RowBox[{
         SubscriptBox["\[Sigma]", "0"], "\[TensorProduct]", " ", 
         SubscriptBox["\[Sigma]", "0"]}], "]"}], ")"}], "/", 
      "4"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.61403238458573*^9, 3.6140324279740753`*^9}, {
  3.614075965740531*^9, 3.6140759657554207`*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["General Form of Werner density Matrix for 2 qubits;  \
and check Trace",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  SubscriptBox["W", 
   RowBox[{"a", ",", "b", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"Tr", "[", 
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]], 
     StyleBox["]",
      FontSize->12]}], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["\[Equal]",
    FontSize->12], "1"}]}]}], "Input",
 CellChangeTimes->{{3.624284255764099*^9, 3.6242842566978903`*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}], 
      "0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}]},
     {"0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], "0"},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], "0", 
      "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014847116`*^9, 3.65737885000861*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980014847116`*^9, 3.657378850173918*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[TextData[StyleBox["Particular cases of Werner density Matrix for 2 \
qubits with different starting Bell state ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"0", ",", "0", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"0", ",", "1", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"1", ",", "0", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"1", ",", "1", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], "0", "0", 
      FractionBox["\[Lambda]", "2"]},
     {"0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0"},
     {
      FractionBox["\[Lambda]", "2"], "0", "0", 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001523767*^9, 3.657378850365086*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0", "0", "0"},
     {"0", 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], 
      FractionBox["\[Lambda]", "2"], "0"},
     {"0", 
      FractionBox["\[Lambda]", "2"], 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001523767*^9, 3.657378850527413*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[Lambda]", "2"]}]},
     {"0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0"},
     {
      RowBox[{"-", 
       FractionBox["\[Lambda]", "2"]}], "0", "0", 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001523767*^9, 3.657378850692279*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "0", "0", "0"},
     {"0", 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], 
      RowBox[{"-", 
       FractionBox["\[Lambda]", "2"]}], "0"},
     {"0", 
      RowBox[{"-", 
       FractionBox["\[Lambda]", "2"]}], 
      FractionBox[
       RowBox[{"1", "+", "\[Lambda]"}], "4"], "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001523767*^9, 3.657378850856522*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[TextData[StyleBox["Check eigenvalues of Werner density Matrix for 2 \
qubits with different starting Bell state ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001967321*^9, 3.6573788513318443`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001967321*^9, 3.6573788515098667`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001967321*^9, 3.657378851676231*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398001967321*^9, 3.657378851861142*^9},
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 2: Look at the Polarization and Tensor Polarization of the Werner \
state  "
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:4", "b:5.4.3"}],

Cell["\<\
Vector and tensor polarizations of Werner state  
Rank 2 Tensor polarizations for Werner state \
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"AF", "[", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", " ", 
       SubscriptBox["\[Sigma]", "j"]}], "]"}], ".", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "W", 
     StyleBox["A",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "W", 
     StyleBox["B",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    StyleBox[
     RowBox[{"TW", 
      StyleBox["AB",
       FontSize->12]}]], 
    StyleBox["=",
     FontSize->12], 
    RowBox[{
     StyleBox["{",
      FontSize->12], 
     RowBox[{
      StyleBox["Table",
       FontSize->12], 
      StyleBox["[",
       FontSize->12], 
      RowBox[{
       StyleBox[
        RowBox[{"T", "[", 
         RowBox[{"i", ",", "j"}], "]"}],
        FontSize->12], 
       StyleBox[",",
        FontSize->12], 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", "PWA", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", "PWB", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{"TWAB", ",", "1"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.614032537117626*^9, 3.6140325593447638`*^9}, 
   3.614075965756727*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980021896257`*^9, 3.657378852061854*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980021896257`*^9, 3.6573788522262*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", "\[Lambda]"}], "0", "0"},
     {"0", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"1", "+", "a", "+", "b"}]], " ", "\[Lambda]"}], "0"},
     {"0", "0", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980021896257`*^9, 3.65737885239359*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["\<\
Vector polarizations of Werner state are zero 
Rank 2 Tensor polarizations for Werner state are diagonal\
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell["Vector polarizations of Werner state are zero ", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell["Look at Purity and Entropy", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{"EnTropy", "[", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]}], "Input",
 CellChangeTimes->{{3.614032588998851*^9, 3.6140325897969513`*^9}, {
  3.614032621352804*^9, 3.614032641185923*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", "a"}]], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", "b"}]], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}]}]]}], ")"}], " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398002344304*^9, 3.657378852831912*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", 
    RowBox[{"4", " ", 
     RowBox[{"Log", "[", "2", "]"}]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "a"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "b"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], 
             RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], ")"}]}],
       " ", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "a"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "b"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], 
         ")"}]}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "+", "a"}]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "+", "b"}]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], ")"}], 
      " ", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "a"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "b"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], 
         ")"}]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], "a"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "+", "b"}]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], ")"}], 
      " ", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "a"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "b"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "a", "+", "b"}]]}], ")"}], " ", 
           "\[Lambda]"}]}], ")"}]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"1", "+", "a"}]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], "b"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{"a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]}], ")"}], 
      " ", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "a"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "b"}]], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"1", "+", "a", "+", "b"}]]}], ")"}], " ", 
           "\[Lambda]"}]}], ")"}]}], "]"}]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398002344304*^9, 3.6573788617059526`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 3:  Structure of the Werner Density Matrix"
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:4", "b:5.4.3"}],

Cell["\<\
Reconstruct Density Matrix 
Note the Werner state has zero polarization for each qubit and a simple \
tensor polarization structure\
\>", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "4"}], ")"}], "  ", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", "0"}], "3"], "   ", 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"j", "=", "0"}], "3"], "    ", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "*", 
      RowBox[{"AF", "[", 
       RowBox[{
        SubscriptBox["\[Sigma]", "i"], "\[TensorProduct]", " ", 
        SubscriptBox["\[Sigma]", "j"]}], "]"}]}]}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"%", "-", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]]}], "]"}]}], "Input",
 CellChangeTimes->{3.614032670457302*^9, 3.614075965772884*^9},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}], 
      "0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}]},
     {"0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], "0"},
     {"0", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", "4"]}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], "0"},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "a"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "b"]}], ")"}], " ", "\[Lambda]"}], "0", 
      "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980116627417`*^9, 3.657378861973013*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980116627417`*^9, 3.657378862163417*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[TextData[{
 " Werner Density Matrix  has Form\n",
 "= (1/4)  [ 1 + \[Lambda] ( ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "a"], "  ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Sigma]", "1"], "\[CircleTimes]", 
      SubscriptBox["\[Sigma]", "1"]}], ")"}]}], TraditionalForm]]],
 "   - ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{"a", "+", "b", " "}]], TraditionalForm]]],
 " ",
 Cell[BoxData[
  RowBox[{"  ", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", "2"], "\[CircleTimes]", 
     SubscriptBox["\[Sigma]", "2"]}], ")"}]}]],
  FontFamily->"Helvetica"],
 "  + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], "b"], TraditionalForm]]],
 Cell[BoxData[
  RowBox[{"  ", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", "3"], "\[CircleTimes]", 
     SubscriptBox["\[Sigma]", "3"]}], ")"}]}]],
  FontFamily->"Helvetica"],
 " ]"
}], "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"reconstruct", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "4"}], ")"}], "    ", 
   RowBox[{"(", "  ", 
    RowBox[{
     RowBox[{"SP", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "]"}], "  ", "+", 
     RowBox[{"\[Lambda]", 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "a"}], "  ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], "-", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "a"}], "  ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "b"}], "   ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "b"}], " ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"3", " ", ",", " ", "3"}], "}"}]}], "]"}]}]}], ")"}]}]}], 
    " ", ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"reconstruct", "-", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", "\[Lambda]"}]]}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}], 
      "0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "a"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "+", "a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}]},
     {"0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "a"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "+", "a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}], 
      "0"},
     {"0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "a"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"1", "+", "a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}], 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{"1", "+", "b"}]], " ", "\[Lambda]"}]}], ")"}]}], "0"},
     {
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "a"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], 
          RowBox[{"2", "+", "a", "+", "b"}]]}], ")"}], " ", "\[Lambda]"}], 
      "0", "0", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "b"], " ", "\[Lambda]"}]}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980116954823`*^9, 3.657378862367461*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980116954823`*^9, 3.657378862544736*^9},
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 3: Look at the Entropy, Purity and Sub-entropy of the Werner state  "
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 FontSize->16,
 CellTags->{"c:4", "b:5.4.3"}],

Cell["Check on Purity", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Purity", "[", 
   StyleBox[
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]],
    FontSize->12], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", "a"}]], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", "b"}]], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", "b"}], ")"}]}]]}], ")"}], " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980117359056`*^9, 3.6573788627567663`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980117359056`*^9, 3.657378862931238*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980117359056`*^9, 3.657378863123605*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980117359056`*^9, 3.657378863290263*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["\[Lambda]", "2"]}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980117359056`*^9, 3.657378863457383*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Check on Entropy", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"EnTropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"EnTropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"EnTropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"EnTropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.614032710043343*^9, 3.614032723384405*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1", "-", "\[Lambda]"}], ")"}]}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", "\[Lambda]"}]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}], "]"}]}]}], 
   RowBox[{"4", " ", 
    RowBox[{"Log", "[", "2", "]"}]}]],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398011802853*^9, 3.657378863740616*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "-", 
       RowBox[{"3", " ", "\[Lambda]"}]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}], "]"}]}]}], 
   RowBox[{"4", " ", 
    RowBox[{"Log", "[", "2", "]"}]}]],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398011802853*^9, 3.6573788639267263`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "-", 
       RowBox[{"3", " ", "\[Lambda]"}]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}], "]"}]}]}], 
   RowBox[{"4", " ", 
    RowBox[{"Log", "[", "2", "]"}]}]],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398011802853*^9, 3.65737886409447*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"1", "-", "\[Lambda]"}], ")"}]}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"1", "-", "\[Lambda]"}], "4"], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", "\[Lambda]"}]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}], "]"}]}]}], 
   RowBox[{"4", " ", 
    RowBox[{"Log", "[", "2", "]"}]}]],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398011802853*^9, 3.657378864291819*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Prepare for Entropy versus \[Lambda] plot", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ent", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"EnTropy", "[", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12], "]"}], "]"}], " ", "/.", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "x"}], ",", 
     RowBox[{"b", "\[Rule]", "y"}], ",", 
     RowBox[{"\[Lambda]", " ", "\[Rule]", "z"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.6140327367383137`*^9, 3.6140327374686337`*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"0", ",", "0", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001", ",", "0.99999"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.614075215014765*^9, 3.6140752185969553`*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1Hk4lVsbBnDp4HQkGgxFlKHSMVSUiO4TEu2SlIpPkiO7QSHKWKhUyrCV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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0.0001, 0.99999}, {0., 1.9999999783521847`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012016532*^9, 3.657378864613036*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"0", ",", "1", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001", ",", "0.99999"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.614075224205271*^9, 3.614075230256526*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1Hk4lVsbBnDp4HQkGgxFlKHSMVSUiO4TEu2SlIpPkiO7QSHKWKhUyrCV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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0.0001, 0.99999}, {0., 1.9999999783521847`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012070311*^9, 3.657378864938283*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "0", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001", ",", "0.99999"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6140752434418917`*^9, 3.614075246984686*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1Hk4lVsbBnDp4HQkGgxFlKHSMVSUiO4TEu2SlIpPkiO7QSHKWKhUyrCV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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0.0001, 0.99999}, {0., 1.9999999783521847`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980121334257`*^9, 3.657378865150568*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "1", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001", ",", "0.99999"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.614075252733848*^9, 3.614075259561561*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1Hk4lVsbBnDp4HQkGgxFlKHSMVSUiO4TEu2SlIpPkiO7QSHKWKhUyrCV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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0.0001, 0.99999}, {0., 1.9999999783521847`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012178543*^9, 3.6573788653687267`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Same plot for all Bell states cases.", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell["Look at Sub-system 2", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"r2", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  StyleBox[
   RowBox[{
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "1"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "2"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "3"]}], "]"}]}],
   FontSize->12], 
  StyleBox["}",
   FontSize->12]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980122109537`*^9, 3.6573788655596113`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980122109537`*^9, 3.6573788657323914`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Entropy and Purity of system 2", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"EnTropy", "[", "r2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "r2", "]"}]}], "Input",
 CellChangeTimes->{{3.6140327604969683`*^9, 3.614032761137768*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980122492123`*^9, 3.657378865982686*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox["1", "2"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980122492123`*^9, 3.657378866163074*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Look at Sub-system 1", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"r1", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  StyleBox[
   RowBox[{
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "1"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "2"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "3"]}], "]"}]}],
   FontSize->12], 
  StyleBox["}",
   FontSize->12]}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox["1", "2"], "0"},
     {"0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012283278*^9, 3.65737886636101*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"0"},
      {"0"},
      {"0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012283278*^9, 3.657378866536723*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Entropy and Purity of system 1", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"EnTropy", "[", "r1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "r1", "]"}]}], "Input",
 CellChangeTimes->{{3.614032767302979*^9, 3.6140327678759127`*^9}},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012316731*^9, 3.6573788667387466`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox["1", "2"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012316731*^9, 3.657378866922161*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Eigenvalues of sub-systems", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", "r1", "]"}], "]"}], 
  "  "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", "r2", "]"}], "]"}], " "}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox["1", "2"]},
      {
       FractionBox["1", "2"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012354579*^9, 3.6573788671849213`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       FractionBox["1", "2"]},
      {
       FractionBox["1", "2"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012354579*^9, 3.657378867367402*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell["Double Check on Entropy of the Full Werner case", "Text",
 FontFamily->"Helvetica",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"val", "=", 
  RowBox[{
   RowBox[{"FullSimplify", "[", 
    RowBox[{"Eigenvalues", "[", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12], "]"}], "]"}], " ", "/.", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"b", "->", "0"}]}], "}"}]}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{
        FractionBox["1", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]},
      {
       FractionBox[
        RowBox[{"1", "-", "\[Lambda]"}], "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012404875*^9, 3.657378867595377*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"val", "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "4", "]"}], "]"}]}], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  RowBox[{
   FractionBox["1", "4"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"3", " ", "\[Lambda]"}]}], ")"}]}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980124477262`*^9, 3.6573788678118887`*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{"1", "-", "\[Lambda]"}], "4"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980124477262`*^9, 3.657378867997258*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{"1", "-", "\[Lambda]"}], "4"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980124477262`*^9, 3.657378868195208*^9},
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{"1", "-", "\[Lambda]"}], "4"],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980124477262`*^9, 3.65737886836864*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"entcheck", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "3", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "4", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], "]"}]}]}], ")"}]}], 
   "]"}]}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  FractionBox[
   RowBox[{
    RowBox[{"Log", "[", "256", "]"}], "+", 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "\[Lambda]"}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{"1", "-", "\[Lambda]"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", "\[Lambda]"}]}], ")"}], " ", 
     RowBox[{"Log", "[", 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", "\[Lambda]"}]}], "]"}]}]}], 
   RowBox[{"Log", "[", "16", "]"}]],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012528495*^9, 3.657378868653717*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"entcheck", ",", 
   RowBox[{"{", 
    RowBox[{"\[Lambda]", ",", "0.00001", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.614075346273509*^9},
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox[
  GraphicsBox[{{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwV1nk0lnkUB3BkSZJGM9KCKAktUpKxfCWjUUjSFEkllSVrKksju1TImq0k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      "]]}},
   AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
   Axes->{True, True},
   AxesLabel->{None, None},
   AxesOrigin->{0, 0},
   DisplayFunction->Identity,
   Frame->{{False, False}, {False, False}},
   FrameLabel->{{None, None}, {None, None}},
   FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
   GridLines->{None, None},
   GridLinesStyle->Directive[
     GrayLevel[0.5, 0.4]],
   Method->{
    "DefaultBoundaryStyle" -> Automatic, "DefaultMeshStyle" -> 
     AbsolutePointSize[6], "ScalingFunctions" -> None},
   PlotRange->{{0.00001, 1}, {0., 1.9999999997827127`}},
   PlotRangeClipping->True,
   PlotRangePadding->{{
      Scaled[0.02], 
      Scaled[0.02]}, {
      Scaled[0.05], 
      Scaled[0.05]}},
   Ticks->{Automatic, Automatic}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6553980126950493`*^9, 3.6573788688851852`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "1", ",", "\[Lambda]"}], "]"}], "-", "entcheck"}], 
   "]"}], "]"}]], "Input",
 FontSize->16,
 CellTags->"b:5.4.3"],

Cell[BoxData[
 TagBox["0.`",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655398012850865*^9, 3.6573788691897984`*^9},
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.614075357102055*^9, 3.614075358883482*^9}},
 FontSize->16]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1694, 771},
WindowMargins->{{Automatic, 70}, {Automatic, 0}},
Visible->True,
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, 32000},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"export", "home", "brunojd"}, 
  "t.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 18.585304`8.02174465349935}, {1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 
    5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7,
     7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
    8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
    10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 
    11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 
    12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 
    13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 
    14, 14, 14}, Automatic}, "NextIndexingNumber" -> 5, 
  "IndexEntries" -> {{"i:1", "CNOT\t"}, {"i:2", "HALL"}, {
    "i:3", "bra", "Quantum Density package"}, {
    "i:4", "ket", "Quantum Density Package"}}},
CellLabelAutoDelete->True,
InputAliases->{"intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation>" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation<" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "symb" -> RowBox[{"Symbolize", "[", 
     TagBox[
     "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"], 
     "]"}], "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        ",", "\[Placeholder]"}], "]"}], "addia" -> 
  RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[Placeholder]\"", "\[Rule]", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "pattwraper" -> 
  TagBox["\[Placeholder]", NotationPatternTag, TagStyle -> 
    "NotationPatternWrapperStyle"], "madeboxeswraper" -> 
  TagBox["\[Placeholder]", NotationMadeBoxesTag, TagStyle -> 
    "NotationMadeBoxesWrapperStyle"]},
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 71, 2, 32, "Title",
   CellTags->"c:1"]},
 "c:2"->{
  Cell[1229, 43, 298, 7, 51, "Section",
   CellTags->{"c:2", "b:5.0"}]},
 "b:5.0"->{
  Cell[1229, 43, 298, 7, 51, "Section",
   CellTags->{"c:2", "b:5.0"}],
  Cell[1530, 52, 595, 17, 87, "Text",
   CellTags->"b:5.0"],
  Cell[2150, 73, 194, 6, 49, "Input",
   CellTags->"b:5.0"],
  Cell[2347, 81, 176, 3, 46, "Output",
   CellTags->"b:5.0"],
  Cell[2538, 87, 474, 19, 27, "Text",
   CellTags->"b:5.0"],
  Cell[3037, 110, 339, 10, 75, "Input",
   CellTags->"b:5.0"],
  Cell[3379, 122, 193, 3, 22, "Print",
   CellTags->"b:5.0"],
  Cell[3587, 128, 176, 4, 27, "Text",
   CellTags->"b:5.0"],
  Cell[3788, 136, 243, 6, 51, "Input",
   CellTags->"b:5.0"],
  Cell[4034, 144, 33416, 929, 306, "Print",
   CellTags->"b:5.0"],
  Cell[37465, 1076, 224, 5, 27, "Text",
   CellTags->"b:5.0"],
  Cell[37714, 1085, 83, 3, 49, "Input",
   CellTags->"b:5.0"],
  Cell[37800, 1090, 483, 7, 145, "Print",
   CellTags->{"b:5.0", "Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a"}],
  Cell[38308, 1101, 83, 3, 49, "Input",
   CellTags->"b:5.0"],
  Cell[38394, 1106, 1434, 20, 653, "Print",
   CellTags->{"b:5.0", "Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46"}],
  Cell[39855, 1130, 274, 9, 29, "Text",
   CellTags->"b:5.0"],
  Cell[40166, 1144, 263, 6, 51, "Input",
   CellTags->"b:5.0"],
  Cell[40432, 1152, 32901, 938, 222, "Print",
   CellTags->"b:5.0"]},
 "Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a"->{
  Cell[37800, 1090, 483, 7, 145, "Print",
   CellTags->{"b:5.0", "Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a"}]},
 "Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46"->{
  Cell[38394, 1106, 1434, 20, 653, "Print",
   CellTags->{"b:5.0", "Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46"}]},
 "c:3"->{
  Cell[73370, 2095, 75, 2, 51, "Section",
   CellTags->"c:3"]},
 "SingleQubitStates"->{
  Cell[73470, 2101, 151, 4, 60, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}]},
 "c:4"->{
  Cell[73470, 2101, 151, 4, 60, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
  Cell[463142, 13674, 120, 4, 60, "Subsection",
   CellTags->{"c:4", "b:5.4.2"}],
  Cell[526163, 15521, 295, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[552784, 16415, 323, 10, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[565944, 16879, 290, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[577858, 17286, 316, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}]},
 "b:5.1.0"->{
  Cell[73470, 2101, 151, 4, 60, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
  Cell[73624, 2107, 386, 12, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[74035, 2123, 169, 4, 50, "Input",
   CellTags->"b:5.1.0"],
  Cell[74207, 2129, 671, 19, 62, "Output",
   CellTags->"b:5.1.0"],
  Cell[74893, 2151, 226, 5, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[75122, 2158, 241, 5, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[75388, 2167, 101, 3, 49, "Input",
   CellTags->"b:5.1.0"],
  Cell[75492, 2172, 671, 19, 62, "Output",
   CellTags->"b:5.1.0"],
  Cell[76178, 2194, 226, 5, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[76407, 2201, 292, 6, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[76724, 2211, 341, 8, 70, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[77068, 2221, 672, 19, 62, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[77743, 2242, 663, 18, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[78421, 2263, 510, 9, 59, "Text",
   CellTags->"b:5.1.0"],
  Cell[78956, 2276, 231, 8, 82, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[79190, 2286, 670, 19, 62, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[79863, 2307, 665, 18, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[80543, 2328, 610, 11, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[81178, 2343, 373, 9, 70, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[81554, 2354, 274, 7, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[81831, 2363, 279, 7, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[82125, 2373, 655, 16, 29, "Text",
   CellTags->"b:5.1.0"],
  Cell[87597, 2529, 315, 7, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[89884, 2597, 553, 10, 59, "Text",
   CellTags->"b:5.1.0"],
  Cell[90462, 2611, 507, 13, 55, "Input",
   CellTags->"b:5.1.0"],
  Cell[90972, 2626, 672, 19, 62, "Output",
   CellTags->"b:5.1.0"],
  Cell[92112, 2663, 258, 6, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[93346, 2704, 244, 5, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[94553, 2746, 303, 7, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[94881, 2757, 723, 18, 49, "Input",
   CellTags->"b:5.1.0"],
  Cell[95607, 2777, 895, 27, 64, "Output",
   CellTags->"b:5.1.0"],
  Cell[96505, 2806, 556, 14, 29, "Text",
   CellTags->"b:5.1.0"],
  Cell[98984, 2884, 317, 7, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[102806, 3013, 754, 24, 60, "Text",
   CellTags->"b:5.1.0"],
  Cell[103585, 3041, 215, 5, 70, "Input",
   CellTags->"b:5.1.0"],
  Cell[103803, 3048, 301, 10, 45, "Output",
   CellTags->"b:5.1.0"],
  Cell[104107, 3060, 356, 12, 48, "Output",
   CellTags->"b:5.1.0"],
  Cell[105054, 3092, 536, 14, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[105615, 3110, 348, 8, 110, "Input",
   CellTags->"b:5.1.0"],
  Cell[105966, 3120, 747, 23, 84, "Output",
   CellTags->"b:5.1.0"],
  Cell[106716, 3145, 390, 10, 67, "Output",
   CellTags->"b:5.1.0"],
  Cell[107109, 3157, 771, 24, 84, "Output",
   CellTags->"b:5.1.0"],
  Cell[107883, 3183, 414, 11, 67, "Output",
   CellTags->"b:5.1.0"],
  Cell[108312, 3197, 476, 15, 43, "Text",
   CellTags->"b:5.1.0"],
  Cell[108813, 3216, 406, 13, 70, "Input",
   CellTags->"b:5.1.0"],
  Cell[109222, 3231, 178, 5, 45, "Output",
   CellTags->"b:5.1.0"],
  Cell[109403, 3238, 179, 5, 45, "Output",
   CellTags->"b:5.1.0"],
  Cell[109597, 3246, 505, 13, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[110105, 3261, 576, 16, 49, "Input",
   CellTags->"b:5.1.0"],
  Cell[110706, 3281, 317, 12, 55, "Input",
   CellTags->"b:5.1.0"],
  Cell[111026, 3295, 656, 18, 45, "Output",
   CellTags->"b:5.1.0"],
  Cell[111697, 3316, 272, 6, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[112612, 3347, 297, 6, 27, "Text",
   CellTags->"b:5.1.0"],
  Cell[112934, 3357, 210, 6, 70, "Input",
   CellTags->"b:5.1.0"],
  Cell[113147, 3365, 764, 23, 56, "Output",
   CellTags->"b:5.1.0"],
  Cell[113914, 3390, 766, 23, 56, "Output",
   CellTags->"b:5.1.0"]},
 "i:4"->{
  Cell[76724, 2211, 341, 8, 70, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[77068, 2221, 672, 19, 62, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[77743, 2242, 663, 18, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[78956, 2276, 231, 8, 82, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[79190, 2286, 670, 19, 62, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[79863, 2307, 665, 18, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[81178, 2343, 373, 9, 70, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[81554, 2354, 274, 7, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[81831, 2363, 279, 7, 45, "Output",
   CellTags->{"i:4", "b:5.1.0"}]},
 "Info-ccd51049-17f4-46bc-9e0c-87672f0e626d"->{
  Cell[91798, 2654, 287, 5, 92, "Print",
   CellTags->"Info-ccd51049-17f4-46bc-9e0c-87672f0e626d"]},
 "Info-92b8f6c0-c01b-4e9a-b79f-5a7ee1940fc1"->{
  Cell[97195, 2829, 237, 4, 75, "Print",
   CellTags->"Info-92b8f6c0-c01b-4e9a-b79f-5a7ee1940fc1"]},
 "Info-24462aaf-de2f-4550-90f7-f9a1ef0f9945"->{
  Cell[100024, 2917, 246, 4, 75, "Print",
   CellTags->"Info-24462aaf-de2f-4550-90f7-f9a1ef0f9945"]},
 "Info-b2f223d4-8012-4c5d-8760-579cfb66b1bf"->{
  Cell[104597, 3081, 430, 7, 179, "Print",
   CellTags->"Info-b2f223d4-8012-4c5d-8760-579cfb66b1bf"]},
 "c:5"->{
  Cell[114717, 3418, 128, 4, 60, "Subsection",
   CellTags->{"c:5", "b:5.1.1"}]},
 "b:5.1.1"->{
  Cell[114717, 3418, 128, 4, 60, "Subsection",
   CellTags->{"c:5", "b:5.1.1"}],
  Cell[114848, 3424, 889, 27, 60, "Text",
   CellTags->"b:5.1.1"],
  Cell[115762, 3455, 1006, 28, 113, "Input",
   CellTags->"b:5.1.1"],
  Cell[116771, 3485, 745, 21, 94, "Output",
   CellTags->"b:5.1.1"],
  Cell[117519, 3508, 745, 21, 94, "Output",
   CellTags->"b:5.1.1"],
  Cell[118267, 3531, 745, 21, 94, "Output",
   CellTags->"b:5.1.1"],
  Cell[119015, 3554, 745, 21, 94, "Output",
   CellTags->"b:5.1.1"],
  Cell[121393, 3625, 702, 23, 29, "Text",
   CellTags->"b:5.1.1"],
  Cell[126803, 3797, 693, 23, 29, "Text",
   CellTags->"b:5.1.1"],
  Cell[131921, 3962, 774, 17, 91, "Text",
   CellTags->"b:5.1.1"],
  Cell[134340, 4036, 344, 7, 27, "Text",
   CellTags->"b:5.1.1"],
  Cell[134709, 4047, 977, 32, 50, "Input",
   CellTags->"b:5.1.1"],
  Cell[135689, 4081, 1012, 25, 158, "Output",
   CellTags->"b:5.1.1"],
  Cell[136716, 4109, 436, 8, 59, "Text",
   CellTags->"b:5.1.1"],
  Cell[137177, 4121, 924, 22, 90, "Input",
   CellTags->"b:5.1.1"],
  Cell[138104, 4145, 843, 30, 180, "Output",
   CellTags->"b:5.1.1"],
  Cell[138950, 4177, 418, 11, 67, "Output",
   CellTags->"b:5.1.1"],
  Cell[139383, 4191, 246, 5, 27, "Text",
   CellTags->"b:5.1.1"],
  Cell[139654, 4200, 852, 23, 49, "Input",
   CellTags->"b:5.1.1"],
  Cell[140509, 4225, 1159, 31, 176, "Output",
   CellTags->"b:5.1.1"],
  Cell[141683, 4259, 228, 9, 27, "Text",
   CellTags->"b:5.1.1"],
  Cell[141936, 4272, 170, 4, 70, "Input",
   CellTags->"b:5.1.1"],
  Cell[142109, 4278, 176, 5, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[142288, 4285, 176, 5, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[142479, 4293, 291, 6, 27, "Text",
   CellTags->"b:5.1.1"],
  Cell[142795, 4303, 722, 16, 90, "Input",
   CellTags->"b:5.1.1"],
  Cell[143520, 4321, 733, 25, 158, "Output",
   CellTags->"b:5.1.1"],
  Cell[144256, 4348, 265, 7, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[144836, 4373, 960, 25, 90, "Input",
   CellTags->"b:5.1.1"],
  Cell[145799, 4400, 818, 20, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[146620, 4422, 416, 10, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[147051, 4435, 524, 13, 92, "Text",
   CellTags->"b:5.1.1"],
  Cell[147600, 4452, 1199, 30, 90, "Input",
   CellTags->"b:5.1.1"],
  Cell[148802, 4484, 179, 5, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[148984, 4491, 179, 5, 45, "Output",
   CellTags->"b:5.1.1"],
  Cell[149166, 4498, 429, 6, 143, "Print",
   CellTags->{"b:5.1.1", "Info-03e7af49-ee5b-411c-856b-413db1fdb043"}],
  Cell[155820, 4711, 1410, 44, 92, "Text",
   CellTags->"b:5.1.1"]},
 "Info-03e7af49-ee5b-411c-856b-413db1fdb043"->{
  Cell[149166, 4498, 429, 6, 143, "Print",
   CellTags->{"b:5.1.1", "Info-03e7af49-ee5b-411c-856b-413db1fdb043"}]},
 "c:6"->{
  Cell[160323, 4865, 130, 4, 60, "Subsection",
   CellTags->{"c:6", "b:5.1.2"}]},
 "b:5.1.2"->{
  Cell[160323, 4865, 130, 4, 60, "Subsection",
   CellTags->{"c:6", "b:5.1.2"}],
  Cell[160456, 4871, 297, 6, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[160756, 4879, 1089, 39, 183, "Text",
   CellTags->"b:5.1.2"],
  Cell[161848, 4920, 289, 6, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[167719, 5121, 336, 7, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[170907, 5215, 418, 11, 29, "Text",
   CellTags->"b:5.1.2"],
  Cell[171328, 5228, 363, 8, 42, "Text",
   CellTags->"b:5.1.2"],
  Cell[189580, 5767, 295, 12, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[189878, 5781, 408, 13, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[194473, 5924, 499, 15, 70, "Input",
   CellTags->"b:5.1.2"],
  Cell[194975, 5941, 225, 5, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[195203, 5948, 174, 4, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[196365, 5986, 387, 7, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[198708, 6057, 218, 5, 27, "Text",
   CellTags->"b:5.1.2"],
  Cell[198951, 6066, 1036, 33, 130, "Input",
   CellTags->"b:5.1.2"],
  Cell[199990, 6101, 819, 29, 180, "Output",
   CellTags->"b:5.1.2"],
  Cell[200812, 6132, 394, 10, 67, "Output",
   CellTags->"b:5.1.2"],
  Cell[201209, 6144, 5329, 133, 184, "Output",
   CellTags->"b:5.1.2"],
  Cell[206565, 6281, 286, 6, 27, "Text",
   CellTags->"b:5.1.2"]},
 "c:7"->{
  Cell[212211, 6463, 137, 4, 60, "Subsection",
   CellTags->{"c:7", "b:5.1.3"}]},
 "b:5.1.3"->{
  Cell[212211, 6463, 137, 4, 60, "Subsection",
   CellTags->{"c:7", "b:5.1.3"}],
  Cell[212351, 6469, 663, 16, 47, "Text",
   CellTags->"b:5.1.3"],
  Cell[213039, 6489, 2040, 69, 155, "Input",
   CellTags->"b:5.1.3"],
  Cell[215082, 6560, 2139, 49, 286, "Output",
   CellTags->"b:5.1.3"],
  Cell[217224, 6611, 669, 19, 62, "Output",
   CellTags->"b:5.1.3"],
  Cell[217896, 6632, 743, 21, 94, "Output",
   CellTags->"b:5.1.3"],
  Cell[218642, 6655, 3155, 88, 176, "Output",
   CellTags->"b:5.1.3"],
  Cell[221800, 6745, 745, 21, 94, "Output",
   CellTags->"b:5.1.3"],
  Cell[222548, 6768, 3156, 88, 176, "Output",
   CellTags->"b:5.1.3"],
  Cell[225719, 6859, 402, 15, 27, "Text",
   CellTags->"b:5.1.3"],
  Cell[226146, 6878, 476, 12, 133, "Input",
   CellTags->"b:5.1.3"],
  Cell[226625, 6892, 178, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[226806, 6899, 177, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[226986, 6906, 175, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[227164, 6913, 175, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[227342, 6920, 175, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[227520, 6927, 206, 5, 27, "Text",
   CellTags->"b:5.1.3"],
  Cell[227751, 6936, 1971, 66, 50, "Input",
   CellTags->"b:5.1.3"],
  Cell[229725, 7004, 1089, 28, 184, "Output",
   CellTags->"b:5.1.3"],
  Cell[230851, 7037, 160, 4, 70, "Input",
   CellTags->"b:5.1.3"],
  Cell[231014, 7043, 176, 5, 45, "Output",
   CellTags->"b:5.1.3"],
  Cell[231193, 7050, 197, 6, 63, "Output",
   CellTags->"b:5.1.3"],
  Cell[231417, 7060, 347, 7, 27, "Text",
   CellTags->"b:5.1.3"],
  Cell[231789, 7071, 168, 6, 49, "Input",
   CellTags->"b:5.1.3"],
  Cell[231960, 7079, 721, 21, 80, "Output",
   CellTags->"b:5.1.3"],
  Cell[232718, 7105, 168, 6, 49, "Input",
   CellTags->"b:5.1.3"],
  Cell[232889, 7113, 723, 21, 80, "Output",
   CellTags->"b:5.1.3"],
  Cell[233649, 7139, 168, 6, 49, "Input",
   CellTags->"b:5.1.3"],
  Cell[233820, 7147, 671, 19, 62, "Output",
   CellTags->"b:5.1.3"]},
 "c:8"->{
  Cell[238014, 7274, 130, 4, 60, "Subsection",
   CellTags->{"c:8", "b:5.1.4"}]},
 "b:5.1.4"->{
  Cell[238014, 7274, 130, 4, 60, "Subsection",
   CellTags->{"c:8", "b:5.1.4"}],
  Cell[238147, 7280, 577, 17, 28, "Text",
   CellTags->"b:5.1.4"],
  Cell[240142, 7348, 262, 6, 112, "Input",
   CellTags->"b:5.1.4"],
  Cell[240407, 7356, 670, 19, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[241080, 7377, 672, 19, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[241755, 7398, 716, 20, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[242474, 7420, 694, 20, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[243183, 7443, 162, 4, 27, "Text",
   CellTags->"b:5.1.4"],
  Cell[243370, 7451, 258, 6, 110, "Input",
   CellTags->"b:5.1.4"],
  Cell[243631, 7459, 671, 19, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[244305, 7480, 671, 19, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[244979, 7501, 717, 20, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[245699, 7523, 693, 20, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[246407, 7546, 645, 21, 27, "Text",
   CellTags->"b:5.1.4"],
  Cell[247077, 7571, 2425, 65, 96, "Input",
   CellTags->"b:5.1.4"],
  Cell[249505, 7638, 7525, 215, 130, "Output",
   CellTags->"b:5.1.4"],
  Cell[257033, 7855, 176, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[257212, 7862, 1606, 64, 38, "Text",
   CellTags->"b:5.1.4"],
  Cell[258833, 7929, 652, 19, 47, "Text",
   CellTags->"b:5.1.4"],
  Cell[272274, 8290, 380, 12, 90, "Input",
   CellTags->"b:5.1.4"],
  Cell[272657, 8304, 968, 26, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[273628, 8332, 180, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[273811, 8339, 194, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[274030, 8348, 334, 9, 90, "Input",
   CellTags->"b:5.1.4"],
  Cell[274367, 8359, 2362, 54, 94, "Output",
   CellTags->"b:5.1.4"],
  Cell[276732, 8415, 180, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[276915, 8422, 198, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[277140, 8431, 324, 6, 27, "Text",
   CellTags->"b:5.1.4"],
  Cell[277489, 8441, 284, 10, 51, "Input",
   CellTags->"b:5.1.4"],
  Cell[277776, 8453, 968, 24, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[278759, 8480, 445, 14, 29, "Text",
   CellTags->"b:5.1.4"],
  Cell[279229, 8498, 679, 18, 110, "Input",
   CellTags->"b:5.1.4"],
  Cell[279911, 8518, 179, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[280093, 8525, 193, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[280289, 8532, 197, 5, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[280501, 8540, 179, 4, 27, "Text",
   CellTags->"b:5.1.4"],
  Cell[280705, 8548, 338, 8, 130, "Input",
   CellTags->"b:5.1.4"],
  Cell[281046, 8558, 910, 23, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[281959, 8583, 594, 13, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[282556, 8598, 905, 23, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[283464, 8623, 590, 13, 45, "Output",
   CellTags->"b:5.1.4"],
  Cell[293355, 8861, 1137, 40, 61, "Text",
   CellTags->"b:5.1.4"],
  Cell[294517, 8905, 232, 7, 49, "Input",
   CellTags->"b:5.1.4"],
  Cell[294752, 8914, 1846, 55, 88, "Output",
   CellTags->"b:5.1.4"],
  Cell[296613, 8972, 84, 3, 29, "Text",
   CellTags->"b:5.1.4"],
  Cell[296722, 8979, 356, 11, 50, "Input",
   CellTags->"b:5.1.4"],
  Cell[297081, 8992, 890, 25, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[298008, 9022, 225, 7, 50, "Input",
   CellTags->"b:5.1.4"],
  Cell[298236, 9031, 932, 26, 84, "Output",
   CellTags->"b:5.1.4"],
  Cell[299205, 9062, 154, 5, 50, "Input",
   CellTags->"b:5.1.4"],
  Cell[299362, 9069, 695, 20, 62, "Output",
   CellTags->"b:5.1.4"],
  Cell[300072, 9092, 392, 15, 29, "Text",
   CellTags->"b:5.1.4"],
  Cell[300489, 9111, 372, 12, 50, "Input",
   CellTags->"b:5.1.4"],
  Cell[300864, 9125, 921, 27, 68, "Output",
   CellTags->"b:5.1.4"],
  Cell[301800, 9155, 171, 4, 27, "Text",
   CellTags->"b:5.1.4"]},
 "Info-63e4e1e7-e313-44a7-9b0f-3eaba883f1c7"->{
  Cell[271484, 8271, 430, 7, 179, "Print",
   CellTags->"Info-63e4e1e7-e313-44a7-9b0f-3eaba883f1c7"]},
 "Info-0ab23d4a-e032-424b-a8c4-d4983cab7aea"->{
  Cell[271917, 8280, 320, 5, 111, "Print",
   CellTags->"Info-0ab23d4a-e032-424b-a8c4-d4983cab7aea"]},
 "Quantum Gates"->{
  Cell[302008, 9164, 91, 2, 51, "Section",
   CellTags->{"Quantum Gates", "c:9"}]},
 "c:9"->{
  Cell[302008, 9164, 91, 2, 51, "Section",
   CellTags->{"Quantum Gates", "c:9"}]},
 "c:10"->{
  Cell[302698, 9192, 200, 5, 60, "Subsection",
   CellTags->{"c:10", "b:5.2.0"}]},
 "b:5.2.0"->{
  Cell[302698, 9192, 200, 5, 60, "Subsection",
   CellTags->{"c:10", "b:5.2.0"}],
  Cell[302901, 9199, 1288, 43, 127, "Text",
   CellTags->"b:5.2.0"],
  Cell[304214, 9246, 151, 5, 49, "Input",
   CellTags->"b:5.2.0"],
  Cell[304368, 9253, 861, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[305232, 9283, 146, 4, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[305403, 9291, 80, 2, 49, "Input",
   CellTags->"b:5.2.0"],
  Cell[305486, 9295, 862, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[306363, 9326, 185, 5, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[306573, 9335, 406, 9, 49, "Input",
   CellTags->"b:5.2.0"],
  Cell[306982, 9346, 1781, 61, 246, "Output",
   CellTags->"b:5.2.0"],
  Cell[308766, 9409, 150, 4, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[308941, 9417, 409, 10, 49, "Input",
   CellTags->"b:5.2.0"],
  Cell[309353, 9429, 1780, 61, 246, "Output",
   CellTags->"b:5.2.0"],
  Cell[311172, 9495, 479, 8, 47, "Text",
   CellTags->"b:5.2.0"],
  Cell[311676, 9507, 888, 23, 111, "Input",
   CellTags->"b:5.2.0"],
  Cell[312567, 9532, 1015, 25, 158, "Output",
   CellTags->"b:5.2.0"],
  Cell[313585, 9559, 1117, 29, 176, "Output",
   CellTags->"b:5.2.0"],
  Cell[314705, 9590, 775, 23, 80, "Output",
   CellTags->"b:5.2.0"],
  Cell[315483, 9615, 673, 19, 62, "Output",
   CellTags->"b:5.2.0"],
  Cell[316171, 9637, 444, 16, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[316640, 9657, 211, 6, 49, "Input",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[316854, 9665, 2624, 89, 230, "Output",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[319493, 9757, 201, 5, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[319719, 9766, 746, 21, 150, "Input",
   CellTags->"b:5.2.0"],
  Cell[320468, 9789, 390, 10, 67, "Output",
   CellTags->"b:5.2.0"],
  Cell[320861, 9801, 262, 7, 45, "Output",
   CellTags->"b:5.2.0"],
  Cell[321126, 9810, 416, 11, 67, "Output",
   CellTags->"b:5.2.0"],
  Cell[321557, 9824, 318, 6, 27, "Text",
   CellTags->"b:5.2.0"],
  Cell[321900, 9834, 507, 13, 71, "Input",
   CellTags->"b:5.2.0"],
  Cell[322410, 9849, 961, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[323374, 9879, 1111, 33, 80, "Output",
   CellTags->"b:5.2.0"],
  Cell[324500, 9915, 835, 28, 35, "Text",
   CellTags->"b:5.2.0"],
  Cell[325360, 9947, 251, 6, 70, "Input",
   CellTags->"b:5.2.0"],
  Cell[325614, 9955, 795, 23, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[326412, 9980, 444, 10, 61, "Output",
   CellTags->"b:5.2.0"],
  Cell[326871, 9993, 284, 12, 29, "Text",
   CellTags->"b:5.2.0"],
  Cell[327180, 10009, 600, 14, 130, "Input",
   CellTags->"b:5.2.0"],
  Cell[327783, 10025, 961, 28, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[328747, 10055, 796, 23, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[329546, 10080, 441, 10, 61, "Output",
   CellTags->"b:5.2.0"],
  Cell[329990, 10092, 743, 23, 84, "Output",
   CellTags->"b:5.2.0"],
  Cell[330736, 10117, 389, 10, 67, "Output",
   CellTags->"b:5.2.0"]},
 "i:2"->{
  Cell[316640, 9657, 211, 6, 49, "Input",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[316854, 9665, 2624, 89, 230, "Output",
   CellTags->{"i:2", "b:5.2.0"}]},
 "i:1"->{
  Cell[331174, 10133, 191, 5, 60, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}],
  Cell[336526, 10315, 189, 5, 60, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}],
  Cell[344483, 10583, 187, 5, 60, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}]},
 "c:11"->{
  Cell[331174, 10133, 191, 5, 60, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}]},
 "b:5.2.1"->{
  Cell[331174, 10133, 191, 5, 60, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}],
  Cell[331368, 10140, 672, 17, 61, "Text",
   CellTags->"b:5.2.1"],
  Cell[332065, 10161, 127, 4, 49, "Input",
   CellTags->"b:5.2.1"],
  Cell[332195, 10167, 747, 21, 94, "Output",
   CellTags->"b:5.2.1"],
  Cell[332957, 10191, 349, 12, 27, "Text",
   CellTags->"b:5.2.1"],
  Cell[333331, 10207, 532, 14, 50, "Input",
   CellTags->"b:5.2.1"],
  Cell[333866, 10223, 745, 21, 94, "Output",
   CellTags->"b:5.2.1"],
  Cell[334626, 10247, 237, 5, 27, "Text",
   CellTags->"b:5.2.1"],
  Cell[334888, 10256, 325, 9, 49, "Input",
   CellTags->"b:5.2.1"],
  Cell[335216, 10267, 746, 21, 94, "Output",
   CellTags->"b:5.2.1"],
  Cell[335977, 10291, 363, 12, 27, "Text",
   CellTags->"b:5.2.1"],
  Cell[336343, 10305, 146, 5, 49, "Input",
   CellTags->"b:5.2.1"]},
 "c:12"->{
  Cell[336526, 10315, 189, 5, 60, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}]},
 "b:5.2.2"->{
  Cell[336526, 10315, 189, 5, 60, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}],
  Cell[336718, 10322, 208, 5, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[336929, 10329, 245, 7, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[337177, 10338, 349, 7, 59, "Text",
   CellTags->"b:5.2.2"],
  Cell[337551, 10349, 224, 6, 70, "Input",
   CellTags->"b:5.2.2"],
  Cell[337778, 10357, 767, 22, 94, "Output",
   CellTags->"b:5.2.2"],
  Cell[338548, 10381, 767, 22, 94, "Output",
   CellTags->"b:5.2.2"],
  Cell[339330, 10406, 325, 11, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[339680, 10421, 129, 4, 49, "Input",
   CellTags->"b:5.2.2"],
  Cell[339812, 10427, 1059, 27, 158, "Output",
   CellTags->"b:5.2.2"],
  Cell[340886, 10457, 281, 6, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[341170, 10465, 186, 5, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[341359, 10472, 447, 10, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[341809, 10484, 169, 4, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[342003, 10492, 199, 6, 49, "Input",
   CellTags->"b:5.2.2"],
  Cell[342205, 10500, 762, 24, 94, "Output",
   CellTags->"b:5.2.2"],
  Cell[342982, 10527, 337, 7, 27, "Text",
   CellTags->"b:5.2.2"],
  Cell[343344, 10538, 250, 8, 49, "Input",
   CellTags->"b:5.2.2"],
  Cell[343597, 10548, 837, 29, 158, "Output",
   CellTags->"b:5.2.2"]},
 "c:13"->{
  Cell[344483, 10583, 187, 5, 60, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}]},
 "b:5.2.3"->{
  Cell[344483, 10583, 187, 5, 60, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}],
  Cell[344673, 10590, 291, 6, 27, "Text",
   CellTags->"b:5.2.3"],
  Cell[344967, 10598, 2044, 78, 300, "Text",
   CellTags->"b:5.2.3"],
  Cell[347036, 10680, 148, 4, 49, "Input",
   CellTags->"b:5.2.3"],
  Cell[347187, 10686, 1015, 25, 158, "Output",
   CellTags->"b:5.2.3"],
  Cell[348217, 10714, 862, 30, 63, "Text",
   CellTags->"b:5.2.3"]},
 "Measurement"->{
  Cell[349128, 10750, 89, 2, 51, "Section",
   CellTags->{"Measurement", "c:14"}],
  Cell[391805, 11980, 158, 3, 51, "Section",
   CellTags->{"Measurement", "c:18"}]},
 "c:14"->{
  Cell[349128, 10750, 89, 2, 51, "Section",
   CellTags->{"Measurement", "c:14"}]},
 "Measurements"->{
  Cell[349242, 10756, 228, 6, 60, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}],
  Cell[363449, 11211, 239, 6, 60, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "c:15"->{
  Cell[349242, 10756, 228, 6, 60, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}]},
 "b:5.3.0"->{
  Cell[349242, 10756, 228, 6, 60, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}],
  Cell[349473, 10764, 268, 6, 27, "Text",
   CellTags->"b:5.3.0"],
  Cell[349744, 10772, 365, 10, 29, "Text",
   CellTags->"b:5.3.0"],
  Cell[350134, 10786, 1086, 28, 71, "Input",
   CellTags->"b:5.3.0"],
  Cell[351223, 10816, 3687, 105, 358, "Output",
   CellTags->"b:5.3.0"],
  Cell[354925, 10924, 226, 5, 27, "Text",
   CellTags->"b:5.3.0"],
  Cell[355154, 10931, 512, 13, 52, "Input",
   CellTags->"b:5.3.0"],
  Cell[355669, 10946, 248, 5, 27, "Text",
   CellTags->"b:5.3.0"],
  Cell[355920, 10953, 544, 18, 51, "Input",
   CellTags->"b:5.3.0"],
  Cell[356467, 10973, 247, 5, 27, "Text",
   CellTags->"b:5.3.0"],
  Cell[356739, 10982, 238, 7, 70, "Input",
   CellTags->"b:5.3.0"],
  Cell[356980, 10991, 849, 25, 112, "Output",
   CellTags->"b:5.3.0"],
  Cell[357832, 11018, 180, 5, 45, "Output",
   CellTags->"b:5.3.0"],
  Cell[358027, 11026, 202, 5, 27, "Text",
   CellTags->"b:5.3.0"],
  Cell[358254, 11035, 386, 10, 90, "Input",
   CellTags->"b:5.3.0"],
  Cell[358643, 11047, 4217, 137, 130, "Output",
   CellTags->"b:5.3.0"],
  Cell[362863, 11186, 537, 19, 62, "Output",
   CellTags->"b:5.3.0"]},
 "MeasureKet"->{
  Cell[363449, 11211, 239, 6, 60, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "c:16"->{
  Cell[363449, 11211, 239, 6, 60, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "b:5.3.1"->{
  Cell[363449, 11211, 239, 6, 60, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],
  Cell[363691, 11219, 188, 5, 27, "Text",
   CellTags->"b:5.3.1"],
  Cell[363904, 11228, 1037, 27, 70, "Input",
   CellTags->"b:5.3.1"],
  Cell[364944, 11257, 1397, 57, 374, "Output",
   CellTags->"b:5.3.1"],
  Cell[366356, 11317, 210, 5, 27, "Text",
   CellTags->"b:5.3.1"],
  Cell[366569, 11324, 243, 5, 27, "Text",
   CellTags->"b:5.3.1"],
  Cell[366815, 11331, 324, 11, 50, "Input",
   CellTags->"b:5.3.1"],
  Cell[367142, 11344, 251, 5, 27, "Text",
   CellTags->"b:5.3.1"],
  Cell[367418, 11353, 118, 4, 49, "Input",
   CellTags->"b:5.3.1"],
  Cell[367539, 11359, 769, 25, 116, "Output",
   CellTags->"b:5.3.1"],
  Cell[368323, 11387, 186, 5, 27, "Text",
   CellTags->"b:5.3.1"],
  Cell[368534, 11396, 410, 12, 49, "Input",
   CellTags->"b:5.3.1"],
  Cell[368947, 11410, 845, 25, 112, "Output",
   CellTags->"b:5.3.1"],
  Cell[369829, 11440, 104, 3, 49, "Input",
   CellTags->"b:5.3.1"],
  Cell[369936, 11445, 178, 5, 45, "Output",
   CellTags->"b:5.3.1"],
  Cell[370129, 11453, 186, 5, 27, "Text",
   CellTags->"b:5.3.1"]},
 "c:17"->{
  Cell[370352, 11463, 226, 6, 60, "Subsection",
   CellTags->{"c:17", "b:5.3.2"}]},
 "b:5.3.2"->{
  Cell[370352, 11463, 226, 6, 60, "Subsection",
   CellTags->{"c:17", "b:5.3.2"}],
  Cell[370603, 11473, 265, 8, 70, "Input",
   CellTags->"b:5.3.2"],
  Cell[370871, 11483, 10971, 185, 175, "Output",
   CellTags->"b:5.3.2"],
  Cell[381857, 11671, 217, 5, 27, "Text",
   CellTags->"b:5.3.2"],
  Cell[382077, 11678, 1259, 32, 110, "Input",
   CellTags->"b:5.3.2"],
  Cell[383339, 11712, 238, 5, 59, "Text",
   CellTags->"b:5.3.2"],
  Cell[383580, 11719, 566, 14, 52, "Input",
   CellTags->"b:5.3.2"],
  Cell[384149, 11735, 280, 9, 27, "Text",
   CellTags->"b:5.3.2"],
  Cell[384432, 11746, 248, 5, 27, "Text",
   CellTags->"b:5.3.2"],
  Cell[384683, 11753, 684, 21, 51, "Input",
   CellTags->"b:5.3.2"],
  Cell[385370, 11776, 297, 6, 59, "Text",
   CellTags->"b:5.3.2"],
  Cell[385692, 11786, 206, 5, 49, "Input",
   CellTags->"b:5.3.2"],
  Cell[385901, 11793, 967, 24, 62, "Output",
   CellTags->"b:5.3.2"],
  Cell[386883, 11820, 477, 8, 123, "Text",
   CellTags->"b:5.3.2"],
  Cell[387363, 11830, 158, 4, 27, "Text",
   CellTags->"b:5.3.2"],
  Cell[387524, 11836, 564, 23, 29, "Text",
   CellTags->"b:5.3.2"],
  Cell[388091, 11861, 448, 14, 50, "Input",
   CellTags->"b:5.3.2"],
  Cell[388542, 11877, 484, 13, 50, "Input",
   CellTags->"b:5.3.2"],
  Cell[389051, 11894, 177, 5, 49, "Input",
   CellTags->"b:5.3.2"],
  Cell[389231, 11901, 968, 24, 62, "Output",
   CellTags->"b:5.3.2"],
  Cell[390236, 11930, 278, 9, 49, "Input",
   CellTags->"b:5.3.2"],
  Cell[390517, 11941, 962, 24, 62, "Output",
   CellTags->"b:5.3.2"],
  Cell[391494, 11968, 262, 6, 27, "Text",
   CellTags->"b:5.3.2"]},
 "c:18"->{
  Cell[391805, 11980, 158, 3, 51, "Section",
   CellTags->{"Measurement", "c:18"}]},
 "c:19"->{
  Cell[391988, 11987, 131, 4, 60, "Subsection",
   CellTags->{"c:19", "b:5.4.0"}]},
 "b:5.4.0"->{
  Cell[391988, 11987, 131, 4, 60, "Subsection",
   CellTags->{"c:19", "b:5.4.0"}],
  Cell[392122, 11993, 394, 11, 59, "Text",
   CellTags->"b:5.4.0"],
  Cell[392519, 12006, 765, 27, 63, "Text",
   CellTags->"b:5.4.0"],
  Cell[393287, 12035, 372, 11, 29, "Text",
   CellTags->"b:5.4.0"],
  Cell[393684, 12050, 685, 23, 92, "Input",
   CellTags->"b:5.4.0"],
  Cell[394372, 12075, 671, 19, 62, "Output",
   CellTags->"b:5.4.0"],
  Cell[395046, 12096, 771, 23, 80, "Output",
   CellTags->"b:5.4.0"],
  Cell[395820, 12121, 771, 23, 80, "Output",
   CellTags->"b:5.4.0"],
  Cell[396606, 12147, 153, 4, 27, "Text",
   CellTags->"b:5.4.0"],
  Cell[396784, 12155, 360, 7, 110, "Input",
   CellTags->"b:5.4.0"],
  Cell[397147, 12164, 176, 5, 45, "Output",
   CellTags->"b:5.4.0"],
  Cell[397326, 12171, 178, 5, 45, "Output",
   CellTags->"b:5.4.0"],
  Cell[397507, 12178, 905, 33, 75, "Output",
   CellTags->"b:5.4.0"],
  Cell[398415, 12213, 194, 5, 45, "Output",
   CellTags->"b:5.4.0"],
  Cell[398624, 12221, 469, 13, 29, "Text",
   CellTags->"b:5.4.0"],
  Cell[399654, 12253, 1720, 54, 153, "Input",
   CellTags->"b:5.4.0"],
  Cell[401377, 12309, 7498, 137, 260, "Output",
   CellTags->"b:5.4.0"],
  Cell[408878, 12448, 1698, 41, 256, "Output",
   CellTags->"b:5.4.0"],
  Cell[410591, 12492, 517, 13, 29, "Text",
   CellTags->"b:5.4.0"],
  Cell[411133, 12509, 1839, 55, 174, "Input",
   CellTags->"b:5.4.0"],
  Cell[412975, 12566, 7498, 137, 260, "Output",
   CellTags->"b:5.4.0"],
  Cell[420476, 12705, 1696, 41, 256, "Output",
   CellTags->"b:5.4.0"],
  Cell[422187, 12749, 263, 10, 29, "Text",
   CellTags->"b:5.4.0"]},
 "Info-aacad911-53c1-4908-87ee-2dbbf7a1d457"->{
  Cell[399232, 12242, 385, 6, 110, "Print",
   CellTags->"Info-aacad911-53c1-4908-87ee-2dbbf7a1d457"]},
 "c:20"->{
  Cell[422487, 12764, 120, 4, 60, "Subsection",
   CellTags->{"c:20", "b:5.4.1"}]},
 "b:5.4.1"->{
  Cell[422487, 12764, 120, 4, 60, "Subsection",
   CellTags->{"c:20", "b:5.4.1"}],
  Cell[422610, 12770, 606, 23, 40, "Text",
   CellTags->"b:5.4.1"],
  Cell[423241, 12797, 420, 9, 110, "Input",
   CellTags->"b:5.4.1"],
  Cell[423664, 12808, 2358, 52, 94, "Output",
   CellTags->"b:5.4.1"],
  Cell[426025, 12862, 3642, 95, 176, "Output",
   CellTags->"b:5.4.1"],
  Cell[429670, 12959, 2357, 56, 94, "Output",
   CellTags->"b:5.4.1"],
  Cell[432030, 13017, 3628, 95, 176, "Output",
   CellTags->"b:5.4.1"],
  Cell[435673, 13115, 145, 4, 27, "Text",
   CellTags->"b:5.4.1"],
  Cell[435843, 13123, 228, 6, 70, "Input",
   CellTags->"b:5.4.1"],
  Cell[436074, 13131, 252, 6, 45, "Output",
   CellTags->"b:5.4.1"],
  Cell[436329, 13139, 252, 6, 45, "Output",
   CellTags->"b:5.4.1"],
  Cell[436596, 13148, 176, 4, 27, "Text",
   CellTags->"b:5.4.1"],
  Cell[436797, 13156, 197, 5, 49, "Input",
   CellTags->"b:5.4.1"],
  Cell[436997, 13163, 256, 6, 45, "Output",
   CellTags->"b:5.4.1"],
  Cell[437268, 13172, 206, 5, 27, "Text",
   CellTags->"b:5.4.1"],
  Cell[437499, 13181, 881, 29, 92, "Input",
   CellTags->"b:5.4.1"],
  Cell[438383, 13212, 5037, 97, 271, "Output",
   CellTags->"b:5.4.1"],
  Cell[443457, 13314, 961, 31, 95, "Input",
   CellTags->"b:5.4.1"],
  Cell[444421, 13347, 18672, 321, 258, "Output",
   CellTags->"b:5.4.1"]},
 "b:5.4.2"->{
  Cell[463142, 13674, 120, 4, 60, "Subsection",
   CellTags->{"c:4", "b:5.4.2"}],
  Cell[463265, 13680, 201, 6, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[463469, 13688, 734, 24, 52, "Input",
   CellTags->"b:5.4.2"],
  Cell[464206, 13714, 130, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[464361, 13721, 266, 8, 70, "Input",
   CellTags->"b:5.4.2"],
  Cell[464630, 13731, 11941, 201, 182, "Output",
   CellTags->"b:5.4.2"],
  Cell[476586, 13935, 99, 3, 49, "Input",
   CellTags->"b:5.4.2"],
  Cell[476688, 13940, 438, 14, 51, "Input",
   CellTags->"b:5.4.2"],
  Cell[477129, 13956, 400, 11, 28, "Text",
   CellTags->"b:5.4.2"],
  Cell[477532, 13969, 720, 26, 56, "Input",
   CellTags->"b:5.4.2"],
  Cell[478255, 13997, 114, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[478394, 14004, 195, 8, 52, "Input",
   CellTags->"b:5.4.2"],
  Cell[478592, 14014, 1115, 29, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[479744, 14048, 356, 14, 75, "Input",
   CellTags->"b:5.4.2"],
  Cell[480103, 14064, 1114, 29, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[481220, 14095, 1163, 31, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[482420, 14131, 356, 14, 75, "Input",
   CellTags->"b:5.4.2"],
  Cell[482779, 14147, 1115, 29, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[483897, 14178, 1161, 31, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[485095, 14214, 356, 14, 75, "Input",
   CellTags->"b:5.4.2"],
  Cell[485454, 14230, 1113, 29, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[486570, 14261, 1159, 31, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[487744, 14295, 393, 11, 187, "Text",
   CellTags->"b:5.4.2"],
  Cell[488162, 14310, 506, 18, 73, "Input",
   CellTags->"b:5.4.2"],
  Cell[488671, 14330, 1115, 29, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[490396, 14384, 1479, 42, 144, "Input",
   CellTags->"b:5.4.2"],
  Cell[506323, 14853, 390, 10, 110, "Input",
   CellTags->"b:5.4.2"],
  Cell[506716, 14865, 176, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[506895, 14872, 194, 6, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[507092, 14880, 196, 6, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[507291, 14888, 194, 6, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[507500, 14897, 117, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[507642, 14904, 1073, 32, 87, "Input",
   CellTags->"b:5.4.2"],
  Cell[508718, 14938, 181, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[508914, 14946, 134, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[509073, 14953, 1517, 47, 73, "Input",
   CellTags->"b:5.4.2"],
  Cell[510593, 15002, 179, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[511629, 15030, 136, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[511790, 15037, 278, 8, 49, "Input",
   CellTags->"b:5.4.2"],
  Cell[512071, 15047, 176, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[512262, 15055, 227, 6, 59, "Text",
   CellTags->"b:5.4.2"],
  Cell[514370, 15117, 483, 18, 51, "Input",
   CellTags->"b:5.4.2"],
  Cell[515853, 15172, 150, 5, 49, "Input",
   CellTags->"b:5.4.2"],
  Cell[516006, 15179, 795, 23, 112, "Output",
   CellTags->"b:5.4.2"],
  Cell[516838, 15207, 358, 10, 70, "Input",
   CellTags->"b:5.4.2"],
  Cell[517199, 15219, 794, 23, 112, "Output",
   CellTags->"b:5.4.2"],
  Cell[517996, 15244, 3097, 86, 176, "Output",
   CellTags->"b:5.4.2"],
  Cell[521108, 15333, 122, 3, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[521255, 15340, 170, 4, 49, "Input",
   CellTags->"b:5.4.2"],
  Cell[521428, 15346, 178, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[521621, 15354, 206, 7, 59, "Text",
   CellTags->"b:5.4.2"],
  Cell[521830, 15363, 158, 5, 27, "Text",
   CellTags->"b:5.4.2"],
  Cell[522013, 15372, 430, 14, 72, "Input",
   CellTags->"b:5.4.2"],
  Cell[522446, 15388, 723, 21, 80, "Output",
   CellTags->"b:5.4.2"],
  Cell[523172, 15411, 178, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[523387, 15421, 430, 14, 72, "Input",
   CellTags->"b:5.4.2"],
  Cell[523820, 15437, 723, 21, 80, "Output",
   CellTags->"b:5.4.2"],
  Cell[524546, 15460, 178, 5, 45, "Output",
   CellTags->"b:5.4.2"],
  Cell[524761, 15470, 430, 14, 72, "Input",
   CellTags->"b:5.4.2"],
  Cell[525194, 15486, 725, 21, 80, "Output",
   CellTags->"b:5.4.2"],
  Cell[525922, 15509, 180, 5, 45, "Output",
   CellTags->"b:5.4.2"]},
 "Info-015c69a6-5e03-4543-ad12-b861b736a1df"->{
  Cell[510925, 15016, 677, 10, 349, "Print",
   CellTags->"Info-015c69a6-5e03-4543-ad12-b861b736a1df"]},
 "Info-351e538f-bd6e-4a72-81fc-8f87e467f726"->{
  Cell[513653, 15104, 702, 10, 415, "Print",
   CellTags->"Info-351e538f-bd6e-4a72-81fc-8f87e467f726"]},
 "b:5.4.3"->{
  Cell[526163, 15521, 295, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[526461, 15532, 516, 16, 49, "Text",
   CellTags->"b:5.4.3"],
  Cell[526980, 15550, 1089, 39, 183, "Text",
   CellTags->"b:5.4.3"],
  Cell[528072, 15591, 268, 6, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[528343, 15599, 222, 5, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[528590, 15608, 265, 9, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[528858, 15619, 1131, 39, 138, "Output",
   CellTags->"b:5.4.3"],
  Cell[530004, 15661, 164, 4, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[530171, 15667, 715, 24, 52, "Input",
   CellTags->"b:5.4.3"],
  Cell[530889, 15693, 451, 12, 29, "Text",
   CellTags->"b:5.4.3"],
  Cell[531365, 15709, 448, 13, 117, "Input",
   CellTags->"b:5.4.3"],
  Cell[531816, 15724, 849, 25, 112, "Output",
   CellTags->"b:5.4.3"],
  Cell[532668, 15751, 847, 25, 112, "Output",
   CellTags->"b:5.4.3"],
  Cell[533518, 15778, 893, 27, 112, "Output",
   CellTags->"b:5.4.3"],
  Cell[534414, 15807, 893, 27, 112, "Output",
   CellTags->"b:5.4.3"],
  Cell[535322, 15837, 367, 7, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[535692, 15846, 1434, 48, 53, "Input",
   CellTags->"b:5.4.3"],
  Cell[537129, 15896, 197, 5, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[537351, 15905, 642, 22, 82, "Input",
   CellTags->"b:5.4.3"],
  Cell[537996, 15929, 3122, 101, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[541121, 16032, 181, 5, 45, "Output",
   CellTags->"b:5.4.3"],
  Cell[541317, 16040, 219, 5, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[541561, 16049, 742, 22, 133, "Input",
   CellTags->"b:5.4.3"],
  Cell[542306, 16073, 1055, 31, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[543364, 16106, 1055, 31, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[544422, 16139, 1101, 33, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[545526, 16174, 1101, 33, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[546642, 16210, 220, 5, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[546887, 16219, 1508, 46, 133, "Input",
   CellTags->"b:5.4.3"],
  Cell[548398, 16267, 1083, 34, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[549484, 16303, 1083, 34, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[550570, 16339, 1081, 34, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[551654, 16375, 1081, 34, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[552784, 16415, 323, 10, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[553110, 16427, 182, 6, 59, "Text",
   CellTags->"b:5.4.3"],
  Cell[553317, 16437, 2811, 109, 218, "Input",
   CellTags->"b:5.4.3"],
  Cell[556131, 16548, 728, 22, 78, "Output",
   CellTags->"b:5.4.3"],
  Cell[556862, 16572, 726, 22, 78, "Output",
   CellTags->"b:5.4.3"],
  Cell[557591, 16596, 1097, 33, 86, "Output",
   CellTags->"b:5.4.3"],
  Cell[558703, 16632, 191, 6, 59, "Text",
   CellTags->"b:5.4.3"],
  Cell[558897, 16640, 125, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[559025, 16645, 105, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[559155, 16652, 704, 24, 83, "Input",
   CellTags->"b:5.4.3"],
  Cell[559862, 16678, 808, 27, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[560673, 16707, 5222, 166, 100, "Output",
   CellTags->"b:5.4.3"],
  Cell[565944, 16879, 290, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[566237, 16890, 218, 7, 59, "Text",
   CellTags->"b:5.4.3"],
  Cell[566480, 16901, 867, 27, 117, "Input",
   CellTags->"b:5.4.3"],
  Cell[567350, 16930, 3123, 101, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[570476, 17033, 747, 21, 94, "Output",
   CellTags->"b:5.4.3"],
  Cell[571238, 17057, 1129, 45, 61, "Text",
   CellTags->"b:5.4.3"],
  Cell[572392, 17106, 1484, 47, 72, "Input",
   CellTags->"b:5.4.3"],
  Cell[573879, 17155, 3180, 102, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[577062, 17259, 747, 21, 94, "Output",
   CellTags->"b:5.4.3"],
  Cell[577858, 17286, 316, 9, 52, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[578177, 17297, 94, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[578296, 17304, 1885, 62, 139, "Input",
   CellTags->"b:5.4.3"],
  Cell[580184, 17368, 812, 27, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[580999, 17397, 334, 11, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[581336, 17410, 334, 11, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[581673, 17423, 334, 11, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[582010, 17436, 334, 11, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[582359, 17450, 95, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[582479, 17457, 1707, 55, 117, "Input",
   CellTags->"b:5.4.3"],
  Cell[584189, 17514, 998, 33, 75, "Output",
   CellTags->"b:5.4.3"],
  Cell[585190, 17549, 1021, 34, 75, "Output",
   CellTags->"b:5.4.3"],
  Cell[586214, 17585, 1018, 34, 75, "Output",
   CellTags->"b:5.4.3"],
  Cell[587235, 17621, 998, 33, 75, "Output",
   CellTags->"b:5.4.3"],
  Cell[588248, 17657, 120, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[588371, 17662, 659, 20, 51, "Input",
   CellTags->"b:5.4.3"],
  Cell[589055, 17686, 359, 10, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[589417, 17698, 4515, 88, 247, "Output",
   CellTags->"b:5.4.3"],
  Cell[593969, 17791, 357, 10, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[594329, 17803, 4515, 88, 247, "Output",
   CellTags->"b:5.4.3"],
  Cell[598881, 17896, 359, 10, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[599243, 17908, 4517, 88, 247, "Output",
   CellTags->"b:5.4.3"],
  Cell[603797, 18001, 357, 10, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[604157, 18013, 4517, 88, 247, "Output",
   CellTags->"b:5.4.3"],
  Cell[608689, 18104, 115, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[608807, 18109, 99, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[608931, 18116, 772, 29, 72, "Input",
   CellTags->"b:5.4.3"],
  Cell[609706, 18147, 725, 21, 80, "Output",
   CellTags->"b:5.4.3"],
  Cell[610434, 18170, 730, 22, 78, "Output",
   CellTags->"b:5.4.3"],
  Cell[611179, 18195, 109, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[611313, 18202, 229, 5, 70, "Input",
   CellTags->"b:5.4.3"],
  Cell[611545, 18209, 178, 5, 45, "Output",
   CellTags->"b:5.4.3"],
  Cell[611726, 18216, 199, 6, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[611940, 18225, 99, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[612064, 18232, 772, 29, 72, "Input",
   CellTags->"b:5.4.3"],
  Cell[612839, 18263, 720, 21, 80, "Output",
   CellTags->"b:5.4.3"],
  Cell[613562, 18286, 726, 22, 78, "Output",
   CellTags->"b:5.4.3"],
  Cell[614303, 18311, 109, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[614437, 18318, 229, 5, 70, "Input",
   CellTags->"b:5.4.3"],
  Cell[614669, 18325, 178, 5, 45, "Output",
   CellTags->"b:5.4.3"],
  Cell[614850, 18332, 197, 6, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[615062, 18341, 105, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[615192, 18348, 290, 9, 70, "Input",
   CellTags->"b:5.4.3"],
  Cell[615485, 18359, 767, 23, 80, "Output",
   CellTags->"b:5.4.3"],
  Cell[616255, 18384, 765, 23, 80, "Output",
   CellTags->"b:5.4.3"],
  Cell[617035, 18410, 126, 3, 27, "Text",
   CellTags->"b:5.4.3"],
  Cell[617186, 18417, 476, 16, 51, "Input",
   CellTags->"b:5.4.3"],
  Cell[617665, 18435, 1081, 34, 130, "Output",
   CellTags->"b:5.4.3"],
  Cell[618783, 18474, 358, 10, 110, "Input",
   CellTags->"b:5.4.3"],
  Cell[619144, 18486, 308, 10, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[619455, 18498, 231, 7, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[619689, 18507, 231, 7, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[619923, 18516, 230, 7, 62, "Output",
   CellTags->"b:5.4.3"],
  Cell[620190, 18528, 1118, 36, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[621311, 18566, 694, 22, 65, "Output",
   CellTags->"b:5.4.3"],
  Cell[622042, 18593, 239, 7, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[622284, 18602, 4522, 88, 247, "Output",
   CellTags->"b:5.4.3"],
  Cell[626843, 18695, 237, 8, 49, "Input",
   CellTags->"b:5.4.3"],
  Cell[627083, 18705, 180, 5, 45, "Output",
   CellTags->"b:5.4.3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 631739, 18814},
 {"c:2", 631807, 18817},
 {"b:5.0", 631892, 18820},
 {"Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a", 633184, 18857},
 {"Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46", 633345, 18860},
 {"c:3", 633470, 18863},
 {"SingleQubitStates", 633558, 18866},
 {"c:4", 633670, 18869},
 {"b:5.1.0", 634209, 18882},
 {"i:4", 638087, 18995},
 {"Info-ccd51049-17f4-46bc-9e0c-87672f0e626d", 638821, 19014},
 {"Info-92b8f6c0-c01b-4e9a-b79f-5a7ee1940fc1", 638970, 19017},
 {"Info-24462aaf-de2f-4550-90f7-f9a1ef0f9945", 639119, 19020},
 {"Info-b2f223d4-8012-4c5d-8760-579cfb66b1bf", 639269, 19023},
 {"c:5", 639382, 19026},
 {"b:5.1.1", 639478, 19029},
 {"Info-03e7af49-ee5b-411c-856b-413db1fdb043", 642107, 19104},
 {"c:6", 642233, 19107},
 {"b:5.1.2", 642329, 19110},
 {"c:7", 643634, 19149},
 {"b:5.1.3", 643730, 19152},
 {"c:8", 645738, 19211},
 {"b:5.1.4", 645834, 19214},
 {"Info-63e4e1e7-e313-44a7-9b0f-3eaba883f1c7", 649644, 19325},
 {"Info-0ab23d4a-e032-424b-a8c4-d4983cab7aea", 649795, 19328},
 {"Quantum Gates", 649918, 19331},
 {"c:9", 650012, 19334},
 {"c:10", 650107, 19337},
 {"b:5.2.0", 650204, 19340},
 {"i:2", 653123, 19425},
 {"i:1", 653290, 19430},
 {"c:11", 653572, 19437},
 {"b:5.2.1", 653677, 19440},
 {"c:12", 654533, 19465},
 {"b:5.2.2", 654638, 19468},
 {"c:13", 655970, 19507},
 {"b:5.2.3", 656075, 19510},
 {"Measurement", 656529, 19523},
 {"c:14", 656708, 19528},
 {"Measurements", 656811, 19531},
 {"c:15", 657035, 19536},
 {"b:5.3.0", 657149, 19539},
 {"MeasureKet", 658370, 19574},
 {"c:16", 658495, 19577},
 {"b:5.3.1", 658623, 19580},
 {"c:17", 659777, 19613},
 {"b:5.3.2", 659875, 19616},
 {"c:18", 661478, 19663},
 {"c:19", 661574, 19666},
 {"b:5.4.0", 661672, 19669},
 {"Info-aacad911-53c1-4908-87ee-2dbbf7a1d457", 663336, 19716},
 {"c:20", 663451, 19719},
 {"b:5.4.1", 663549, 19722},
 {"b:5.4.2", 664898, 19761},
 {"Info-015c69a6-5e03-4543-ad12-b861b736a1df", 669185, 19884},
 {"Info-351e538f-bd6e-4a72-81fc-8f87e467f726", 669338, 19887},
 {"b:5.4.3", 669457, 19890}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 71, 2, 32, "Title",
 CellTags->"c:1"],
Cell[619, 24, 131, 2, 33, "Subtitle"],
Cell[753, 28, 451, 11, 24, "Abstract"],
Cell[CellGroupData[{
Cell[1229, 43, 298, 7, 51, "Section",
 CellTags->{"c:2", "b:5.0"}],
Cell[1530, 52, 595, 17, 87, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[2150, 73, 194, 6, 49, "Input",
 CellTags->"b:5.0"],
Cell[2347, 81, 176, 3, 46, "Output",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[2538, 87, 474, 19, 27, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[3037, 110, 339, 10, 75, "Input",
 CellTags->"b:5.0"],
Cell[3379, 122, 193, 3, 22, "Print",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[3587, 128, 176, 4, 27, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[3788, 136, 243, 6, 51, "Input",
 CellTags->"b:5.0"],
Cell[4034, 144, 33416, 929, 306, "Print",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[37465, 1076, 224, 5, 27, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[37714, 1085, 83, 3, 49, "Input",
 CellTags->"b:5.0"],
Cell[37800, 1090, 483, 7, 145, "Print",
 CellTags->{"b:5.0", "Info-eeff9c64-9857-4ad5-b9f6-9a843b49a58a"}],
Cell[CellGroupData[{
Cell[38308, 1101, 83, 3, 49, "Input",
 CellTags->"b:5.0"],
Cell[38394, 1106, 1434, 20, 653, "Print",
 CellTags->{"b:5.0", "Info-8dba0ecf-d8bf-4e51-845b-90d734b6ba46"}]
}, Open  ]]
}, Open  ]],
Cell[39855, 1130, 274, 9, 29, "Text",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40166, 1144, 263, 6, 51, "Input",
 CellTags->"b:5.0"],
Cell[40432, 1152, 32901, 938, 222, "Print",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73370, 2095, 75, 2, 51, "Section",
 CellTags->"c:3"],
Cell[CellGroupData[{
Cell[73470, 2101, 151, 4, 60, "Subsection",
 CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
Cell[73624, 2107, 386, 12, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[74035, 2123, 169, 4, 50, "Input",
 CellTags->"b:5.1.0"],
Cell[74207, 2129, 671, 19, 62, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[74893, 2151, 226, 5, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[75122, 2158, 241, 5, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[75388, 2167, 101, 3, 49, "Input",
 CellTags->"b:5.1.0"],
Cell[75492, 2172, 671, 19, 62, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[76178, 2194, 226, 5, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[76407, 2201, 292, 6, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[76724, 2211, 341, 8, 70, "Input",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[77068, 2221, 672, 19, 62, "Output",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[77743, 2242, 663, 18, 45, "Output",
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],
Cell[78421, 2263, 510, 9, 59, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[78956, 2276, 231, 8, 82, "Input",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[79190, 2286, 670, 19, 62, "Output",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[79863, 2307, 665, 18, 45, "Output",
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],
Cell[80543, 2328, 610, 11, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[81178, 2343, 373, 9, 70, "Input",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[81554, 2354, 274, 7, 45, "Output",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[81831, 2363, 279, 7, 45, "Output",
 CellTags->{"i:4", "b:5.1.0"}]
}, Open  ]],
Cell[82125, 2373, 655, 16, 29, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[82805, 2393, 859, 21, 133, "Input"],
Cell[83667, 2416, 1701, 44, 64, "Output"],
Cell[85371, 2462, 159, 4, 45, "Output"],
Cell[85533, 2468, 1701, 44, 64, "Output"],
Cell[87237, 2514, 159, 4, 45, "Output"],
Cell[87399, 2520, 159, 4, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[87597, 2529, 315, 7, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[87937, 2540, 226, 8, 55, "Input"],
Cell[88166, 2550, 1703, 44, 64, "Output"]
}, Open  ]],
Cell[89884, 2597, 553, 10, 59, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[90462, 2611, 507, 13, 55, "Input",
 CellTags->"b:5.1.0"],
Cell[90972, 2626, 672, 19, 62, "Output",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[91669, 2649, 126, 3, 49, "Input"],
Cell[91798, 2654, 287, 5, 92, "Print",
 CellTags->"Info-ccd51049-17f4-46bc-9e0c-87672f0e626d"]
}, Open  ]]
}, Open  ]],
Cell[92112, 2663, 258, 6, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[92395, 2673, 294, 8, 49, "Input"],
Cell[92692, 2683, 639, 18, 62, "Output"]
}, Open  ]],
Cell[93346, 2704, 244, 5, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[93615, 2713, 279, 10, 55, "Input"],
Cell[93897, 2725, 641, 18, 62, "Output"]
}, Open  ]],
Cell[94553, 2746, 303, 7, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[94881, 2757, 723, 18, 49, "Input",
 CellTags->"b:5.1.0"],
Cell[95607, 2777, 895, 27, 64, "Output",
 CellTags->"b:5.1.0"],
Cell[96505, 2806, 556, 14, 29, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[97086, 2824, 106, 3, 49, "Input"],
Cell[97195, 2829, 237, 4, 75, "Print",
 CellTags->"Info-92b8f6c0-c01b-4e9a-b79f-5a7ee1940fc1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97469, 2838, 620, 15, 49, "Input"],
Cell[98092, 2855, 877, 26, 64, "Output"]
}, Open  ]],
Cell[98984, 2884, 317, 7, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[99326, 2895, 384, 10, 90, "Input"],
Cell[99713, 2907, 308, 8, 45, "Output"],
Cell[100024, 2917, 246, 4, 75, "Print",
 CellTags->"Info-24462aaf-de2f-4550-90f7-f9a1ef0f9945"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[100319, 2927, 182, 6, 49, "Input"],
Cell[100504, 2935, 634, 17, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[101175, 2957, 212, 9, 55, "Input"],
Cell[101390, 2968, 634, 17, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102061, 2990, 409, 10, 49, "Input"],
Cell[102473, 3002, 318, 8, 45, "Output"]
}, Open  ]],
Cell[102806, 3013, 754, 24, 60, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[103585, 3041, 215, 5, 70, "Input",
 CellTags->"b:5.1.0"],
Cell[103803, 3048, 301, 10, 45, "Output",
 CellTags->"b:5.1.0"],
Cell[104107, 3060, 356, 12, 48, "Output",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[104488, 3076, 106, 3, 49, "Input"],
Cell[104597, 3081, 430, 7, 179, "Print",
 CellTags->"Info-b2f223d4-8012-4c5d-8760-579cfb66b1bf"]
}, Open  ]]
}, Open  ]],
Cell[105054, 3092, 536, 14, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[105615, 3110, 348, 8, 110, "Input",
 CellTags->"b:5.1.0"],
Cell[105966, 3120, 747, 23, 84, "Output",
 CellTags->"b:5.1.0"],
Cell[106716, 3145, 390, 10, 67, "Output",
 CellTags->"b:5.1.0"],
Cell[107109, 3157, 771, 24, 84, "Output",
 CellTags->"b:5.1.0"],
Cell[107883, 3183, 414, 11, 67, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[108312, 3197, 476, 15, 43, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[108813, 3216, 406, 13, 70, "Input",
 CellTags->"b:5.1.0"],
Cell[109222, 3231, 178, 5, 45, "Output",
 CellTags->"b:5.1.0"],
Cell[109403, 3238, 179, 5, 45, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[109597, 3246, 505, 13, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[110105, 3261, 576, 16, 49, "Input",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[110706, 3281, 317, 12, 55, "Input",
 CellTags->"b:5.1.0"],
Cell[111026, 3295, 656, 18, 45, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[111697, 3316, 272, 6, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[111994, 3326, 282, 8, 49, "Input"],
Cell[112279, 3336, 318, 8, 45, "Output"]
}, Open  ]],
Cell[112612, 3347, 297, 6, 27, "Text",
 CellTags->"b:5.1.0"],
Cell[CellGroupData[{
Cell[112934, 3357, 210, 6, 70, "Input",
 CellTags->"b:5.1.0"],
Cell[113147, 3365, 764, 23, 56, "Output",
 CellTags->"b:5.1.0"],
Cell[113914, 3390, 766, 23, 56, "Output",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114717, 3418, 128, 4, 60, "Subsection",
 CellTags->{"c:5", "b:5.1.1"}],
Cell[114848, 3424, 889, 27, 60, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[115762, 3455, 1006, 28, 113, "Input",
 CellTags->"b:5.1.1"],
Cell[116771, 3485, 745, 21, 94, "Output",
 CellTags->"b:5.1.1"],
Cell[117519, 3508, 745, 21, 94, "Output",
 CellTags->"b:5.1.1"],
Cell[118267, 3531, 745, 21, 94, "Output",
 CellTags->"b:5.1.1"],
Cell[119015, 3554, 745, 21, 94, "Output",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[119785, 3579, 707, 15, 71, "Input"],
Cell[120495, 3596, 157, 4, 45, "Output"],
Cell[120655, 3602, 723, 20, 94, "Output"]
}, Open  ]],
Cell[121393, 3625, 702, 23, 29, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[122120, 3652, 1031, 23, 190, "Input"],
Cell[123154, 3677, 662, 20, 94, "Output"],
Cell[123819, 3699, 242, 6, 45, "Output"],
Cell[124064, 3707, 663, 20, 94, "Output"],
Cell[124730, 3729, 244, 6, 45, "Output"],
Cell[124977, 3737, 663, 20, 94, "Output"],
Cell[125643, 3759, 244, 6, 45, "Output"],
Cell[125890, 3767, 663, 20, 94, "Output"],
Cell[126556, 3789, 244, 6, 45, "Output"],
Cell[126803, 3797, 693, 23, 29, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[127521, 3824, 1024, 34, 96, "Input"],
Cell[128548, 3860, 665, 20, 94, "Output"],
Cell[129216, 3882, 434, 10, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129687, 3897, 1092, 26, 90, "Input"],
Cell[130782, 3925, 665, 20, 94, "Output"],
Cell[131450, 3947, 432, 10, 45, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[131921, 3962, 774, 17, 91, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[132720, 3983, 643, 16, 76, "Input"],
Cell[133366, 4001, 711, 24, 158, "Output"],
Cell[134080, 4027, 245, 6, 45, "Output"]
}, Open  ]],
Cell[134340, 4036, 344, 7, 27, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[134709, 4047, 977, 32, 50, "Input",
 CellTags->"b:5.1.1"],
Cell[135689, 4081, 1012, 25, 158, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[136716, 4109, 436, 8, 59, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[137177, 4121, 924, 22, 90, "Input",
 CellTags->"b:5.1.1"],
Cell[138104, 4145, 843, 30, 180, "Output",
 CellTags->"b:5.1.1"],
Cell[138950, 4177, 418, 11, 67, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[139383, 4191, 246, 5, 27, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[139654, 4200, 852, 23, 49, "Input",
 CellTags->"b:5.1.1"],
Cell[140509, 4225, 1159, 31, 176, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[141683, 4259, 228, 9, 27, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[141936, 4272, 170, 4, 70, "Input",
 CellTags->"b:5.1.1"],
Cell[142109, 4278, 176, 5, 45, "Output",
 CellTags->"b:5.1.1"],
Cell[142288, 4285, 176, 5, 45, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[142479, 4293, 291, 6, 27, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[142795, 4303, 722, 16, 90, "Input",
 CellTags->"b:5.1.1"],
Cell[143520, 4321, 733, 25, 158, "Output",
 CellTags->"b:5.1.1"],
Cell[144256, 4348, 265, 7, 45, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144558, 4360, 84, 2, 49, "Input"],
Cell[144645, 4364, 154, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144836, 4373, 960, 25, 90, "Input",
 CellTags->"b:5.1.1"],
Cell[145799, 4400, 818, 20, 45, "Output",
 CellTags->"b:5.1.1"],
Cell[146620, 4422, 416, 10, 45, "Output",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[147051, 4435, 524, 13, 92, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[147600, 4452, 1199, 30, 90, "Input",
 CellTags->"b:5.1.1"],
Cell[148802, 4484, 179, 5, 45, "Output",
 CellTags->"b:5.1.1"],
Cell[148984, 4491, 179, 5, 45, "Output",
 CellTags->"b:5.1.1"],
Cell[149166, 4498, 429, 6, 143, "Print",
 CellTags->{"b:5.1.1", "Info-03e7af49-ee5b-411c-856b-413db1fdb043"}],
Cell[CellGroupData[{
Cell[149620, 4508, 211, 4, 49, "Input"],
Cell[149834, 4514, 180, 6, 50, "Output"],
Cell[CellGroupData[{
Cell[150039, 4524, 205, 5, 49, "Input"],
Cell[150247, 4531, 252, 9, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150536, 4545, 751, 19, 130, "Input"],
Cell[151290, 4566, 1720, 46, 96, "Output"],
Cell[153013, 4614, 662, 20, 94, "Output"],
Cell[153678, 4636, 241, 6, 45, "Output"],
Cell[153922, 4644, 664, 20, 94, "Output"],
Cell[154589, 4666, 241, 6, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[154879, 4678, 236, 6, 49, "Input"],
Cell[155118, 4686, 663, 20, 94, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[155820, 4711, 1410, 44, 92, "Text",
 CellTags->"b:5.1.1"],
Cell[CellGroupData[{
Cell[157255, 4759, 1050, 35, 65, "Input"],
Cell[158308, 4796, 722, 20, 94, "Output"],
Cell[159033, 4818, 157, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[159227, 4827, 333, 11, 46, "Input"],
Cell[159563, 4840, 723, 20, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[160323, 4865, 130, 4, 60, "Subsection",
 CellTags->{"c:6", "b:5.1.2"}],
Cell[160456, 4871, 297, 6, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[160756, 4879, 1089, 39, 183, "Text",
 CellTags->"b:5.1.2"],
Cell[161848, 4920, 289, 6, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[162162, 4930, 458, 12, 90, "Input"],
Cell[162623, 4944, 723, 20, 94, "Output"],
Cell[163349, 4966, 1107, 38, 138, "Output"],
Cell[164459, 5006, 1107, 38, 138, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165603, 5049, 276, 8, 49, "Input"],
Cell[165882, 5059, 725, 20, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166644, 5084, 311, 8, 49, "Input"],
Cell[166958, 5094, 746, 24, 116, "Output"]
}, Open  ]],
Cell[167719, 5121, 336, 7, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[168058, 5130, 618, 16, 52, "Input"],
Cell[CellGroupData[{
Cell[168701, 5150, 649, 16, 117, "Input"],
Cell[169353, 5168, 370, 9, 67, "Output"],
Cell[169726, 5179, 370, 9, 67, "Output"],
Cell[170099, 5190, 394, 10, 67, "Output"],
Cell[170496, 5202, 396, 10, 67, "Output"]
}, Open  ]],
Cell[170907, 5215, 418, 11, 29, "Text",
 CellTags->"b:5.1.2"],
Cell[171328, 5228, 363, 8, 42, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[171716, 5240, 1074, 35, 169, "Input"],
Cell[172793, 5277, 825, 24, 112, "Output"],
Cell[173621, 5303, 823, 24, 112, "Output"],
Cell[174447, 5329, 871, 26, 112, "Output"],
Cell[175321, 5357, 869, 26, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[176227, 5388, 847, 22, 133, "Input"],
Cell[177077, 5412, 3105, 86, 176, "Output"],
Cell[180185, 5500, 3104, 86, 176, "Output"],
Cell[183292, 5588, 3107, 86, 176, "Output"],
Cell[186402, 5676, 3163, 88, 176, "Output"]
}, Open  ]],
Cell[189580, 5767, 295, 12, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[189878, 5781, 408, 13, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[190311, 5798, 397, 9, 90, "Input"],
Cell[190711, 5809, 991, 24, 158, "Output"],
Cell[191705, 5835, 991, 24, 158, "Output"],
Cell[192699, 5861, 1759, 60, 246, "Output"]
}, Open  ]],
Cell[194473, 5924, 499, 15, 70, "Input",
 CellTags->"b:5.1.2"],
Cell[194975, 5941, 225, 5, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[195203, 5948, 174, 4, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[195402, 5956, 571, 16, 70, "Input"],
Cell[195976, 5974, 374, 9, 67, "Output"]
}, Open  ]],
Cell[196365, 5986, 387, 7, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[196777, 5997, 662, 21, 90, "Input"],
Cell[197442, 6020, 1091, 28, 176, "Output"],
Cell[198536, 6050, 157, 4, 45, "Output"]
}, Open  ]],
Cell[198708, 6057, 218, 5, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[198951, 6066, 1036, 33, 130, "Input",
 CellTags->"b:5.1.2"],
Cell[199990, 6101, 819, 29, 180, "Output",
 CellTags->"b:5.1.2"],
Cell[200812, 6132, 394, 10, 67, "Output",
 CellTags->"b:5.1.2"],
Cell[201209, 6144, 5329, 133, 184, "Output",
 CellTags->"b:5.1.2"]
}, Open  ]]
}, Open  ]],
Cell[206565, 6281, 286, 6, 27, "Text",
 CellTags->"b:5.1.2"],
Cell[CellGroupData[{
Cell[206876, 6291, 648, 16, 50, "Input"],
Cell[CellGroupData[{
Cell[207549, 6311, 1513, 54, 190, "Input"],
Cell[209065, 6367, 372, 9, 67, "Output"],
Cell[209440, 6378, 374, 9, 67, "Output"],
Cell[209817, 6389, 374, 9, 67, "Output"],
Cell[210194, 6400, 372, 9, 67, "Output"],
Cell[210569, 6411, 396, 10, 67, "Output"],
Cell[210968, 6423, 396, 10, 67, "Output"],
Cell[211367, 6435, 396, 10, 67, "Output"],
Cell[211766, 6447, 396, 10, 67, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[212211, 6463, 137, 4, 60, "Subsection",
 CellTags->{"c:7", "b:5.1.3"}],
Cell[212351, 6469, 663, 16, 47, "Text",
 CellTags->"b:5.1.3"],
Cell[CellGroupData[{
Cell[213039, 6489, 2040, 69, 155, "Input",
 CellTags->"b:5.1.3"],
Cell[215082, 6560, 2139, 49, 286, "Output",
 CellTags->"b:5.1.3"],
Cell[217224, 6611, 669, 19, 62, "Output",
 CellTags->"b:5.1.3"],
Cell[217896, 6632, 743, 21, 94, "Output",
 CellTags->"b:5.1.3"],
Cell[218642, 6655, 3155, 88, 176, "Output",
 CellTags->"b:5.1.3"],
Cell[221800, 6745, 745, 21, 94, "Output",
 CellTags->"b:5.1.3"],
Cell[222548, 6768, 3156, 88, 176, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[225719, 6859, 402, 15, 27, "Text",
 CellTags->"b:5.1.3"],
Cell[CellGroupData[{
Cell[226146, 6878, 476, 12, 133, "Input",
 CellTags->"b:5.1.3"],
Cell[226625, 6892, 178, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[226806, 6899, 177, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[226986, 6906, 175, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[227164, 6913, 175, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[227342, 6920, 175, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[227520, 6927, 206, 5, 27, "Text",
 CellTags->"b:5.1.3"],
Cell[CellGroupData[{
Cell[227751, 6936, 1971, 66, 50, "Input",
 CellTags->"b:5.1.3"],
Cell[229725, 7004, 1089, 28, 184, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[230851, 7037, 160, 4, 70, "Input",
 CellTags->"b:5.1.3"],
Cell[231014, 7043, 176, 5, 45, "Output",
 CellTags->"b:5.1.3"],
Cell[231193, 7050, 197, 6, 63, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]]
}, Open  ]],
Cell[231417, 7060, 347, 7, 27, "Text",
 CellTags->"b:5.1.3"],
Cell[CellGroupData[{
Cell[231789, 7071, 168, 6, 49, "Input",
 CellTags->"b:5.1.3"],
Cell[231960, 7079, 721, 21, 80, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[232718, 7105, 168, 6, 49, "Input",
 CellTags->"b:5.1.3"],
Cell[232889, 7113, 723, 21, 80, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[233649, 7139, 168, 6, 49, "Input",
 CellTags->"b:5.1.3"],
Cell[233820, 7147, 671, 19, 62, "Output",
 CellTags->"b:5.1.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[234540, 7172, 225, 6, 49, "Input"],
Cell[234768, 7180, 3209, 89, 204, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[238014, 7274, 130, 4, 60, "Subsection",
 CellTags->{"c:8", "b:5.1.4"}],
Cell[238147, 7280, 577, 17, 28, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[238749, 7301, 710, 18, 112, "Input"],
Cell[239462, 7321, 159, 4, 45, "Output"],
Cell[239624, 7327, 157, 4, 45, "Output"],
Cell[239784, 7333, 159, 4, 45, "Output"],
Cell[239946, 7339, 159, 4, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240142, 7348, 262, 6, 112, "Input",
 CellTags->"b:5.1.4"],
Cell[240407, 7356, 670, 19, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[241080, 7377, 672, 19, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[241755, 7398, 716, 20, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[242474, 7420, 694, 20, 62, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[243183, 7443, 162, 4, 27, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[243370, 7451, 258, 6, 110, "Input",
 CellTags->"b:5.1.4"],
Cell[243631, 7459, 671, 19, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[244305, 7480, 671, 19, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[244979, 7501, 717, 20, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[245699, 7523, 693, 20, 62, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[246407, 7546, 645, 21, 27, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[247077, 7571, 2425, 65, 96, "Input",
 CellTags->"b:5.1.4"],
Cell[249505, 7638, 7525, 215, 130, "Output",
 CellTags->"b:5.1.4"],
Cell[257033, 7855, 176, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[257212, 7862, 1606, 64, 38, "Text",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[258833, 7929, 652, 19, 47, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[259510, 7952, 1549, 38, 250, "Input"],
Cell[261062, 7992, 157, 4, 45, "Output"],
Cell[261222, 7998, 2356, 57, 94, "Output"],
Cell[263581, 8057, 155, 4, 45, "Output"],
Cell[263739, 8063, 3561, 93, 176, "Output"],
Cell[267303, 8158, 2353, 55, 94, "Output"],
Cell[269659, 8215, 173, 4, 45, "Output"],
Cell[269835, 8221, 173, 4, 45, "Output"],
Cell[270011, 8227, 1145, 31, 280, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271193, 8263, 288, 6, 70, "Input"],
Cell[271484, 8271, 430, 7, 179, "Print",
 CellTags->"Info-63e4e1e7-e313-44a7-9b0f-3eaba883f1c7"],
Cell[271917, 8280, 320, 5, 111, "Print",
 CellTags->"Info-0ab23d4a-e032-424b-a8c4-d4983cab7aea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[272274, 8290, 380, 12, 90, "Input",
 CellTags->"b:5.1.4"],
Cell[272657, 8304, 968, 26, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[273628, 8332, 180, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[273811, 8339, 194, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[274030, 8348, 334, 9, 90, "Input",
 CellTags->"b:5.1.4"],
Cell[274367, 8359, 2362, 54, 94, "Output",
 CellTags->"b:5.1.4"],
Cell[276732, 8415, 180, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[276915, 8422, 198, 5, 45, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]]
}, Open  ]],
Cell[277140, 8431, 324, 6, 27, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[277489, 8441, 284, 10, 51, "Input",
 CellTags->"b:5.1.4"],
Cell[277776, 8453, 968, 24, 62, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[278759, 8480, 445, 14, 29, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[279229, 8498, 679, 18, 110, "Input",
 CellTags->"b:5.1.4"],
Cell[279911, 8518, 179, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[280093, 8525, 193, 5, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[280289, 8532, 197, 5, 45, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[280501, 8540, 179, 4, 27, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[280705, 8548, 338, 8, 130, "Input",
 CellTags->"b:5.1.4"],
Cell[281046, 8558, 910, 23, 62, "Output",
 CellTags->"b:5.1.4"],
Cell[281959, 8583, 594, 13, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[282556, 8598, 905, 23, 45, "Output",
 CellTags->"b:5.1.4"],
Cell[283464, 8623, 590, 13, 45, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284091, 8641, 712, 15, 110, "Input"],
Cell[284806, 8658, 1723, 45, 158, "Output"],
Cell[286532, 8705, 1683, 30, 61, "Output"],
Cell[288218, 8737, 1668, 37, 45, "Output"],
Cell[289889, 8776, 1735, 30, 61, "Output"],
Cell[CellGroupData[{
Cell[291649, 8810, 383, 9, 70, "Input"],
Cell[292035, 8821, 645, 17, 45, "Output"],
Cell[292683, 8840, 645, 17, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[293355, 8861, 1137, 40, 61, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[294517, 8905, 232, 7, 49, "Input",
 CellTags->"b:5.1.4"],
Cell[294752, 8914, 1846, 55, 88, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[296613, 8972, 84, 3, 29, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[296722, 8979, 356, 11, 50, "Input",
 CellTags->"b:5.1.4"],
Cell[297081, 8992, 890, 25, 62, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[298008, 9022, 225, 7, 50, "Input",
 CellTags->"b:5.1.4"],
Cell[298236, 9031, 932, 26, 84, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[299205, 9062, 154, 5, 50, "Input",
 CellTags->"b:5.1.4"],
Cell[299362, 9069, 695, 20, 62, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[300072, 9092, 392, 15, 29, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[300489, 9111, 372, 12, 50, "Input",
 CellTags->"b:5.1.4"],
Cell[300864, 9125, 921, 27, 68, "Output",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[301800, 9155, 171, 4, 27, "Text",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302008, 9164, 91, 2, 51, "Section",
 CellTags->{"Quantum Gates", "c:9"}],
Cell[302102, 9168, 242, 5, 27, "Text"],
Cell[302347, 9175, 326, 13, 29, "Text"],
Cell[CellGroupData[{
Cell[302698, 9192, 200, 5, 60, "Subsection",
 CellTags->{"c:10", "b:5.2.0"}],
Cell[302901, 9199, 1288, 43, 127, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[304214, 9246, 151, 5, 49, "Input",
 CellTags->"b:5.2.0"],
Cell[304368, 9253, 861, 28, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[305232, 9283, 146, 4, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[305403, 9291, 80, 2, 49, "Input",
 CellTags->"b:5.2.0"],
Cell[305486, 9295, 862, 28, 84, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[306363, 9326, 185, 5, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[306573, 9335, 406, 9, 49, "Input",
 CellTags->"b:5.2.0"],
Cell[306982, 9346, 1781, 61, 246, "Output",
 CellTags->"b:5.2.0"],
Cell[308766, 9409, 150, 4, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[308941, 9417, 409, 10, 49, "Input",
 CellTags->"b:5.2.0"],
Cell[309353, 9429, 1780, 61, 246, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[311172, 9495, 479, 8, 47, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[311676, 9507, 888, 23, 111, "Input",
 CellTags->"b:5.2.0"],
Cell[312567, 9532, 1015, 25, 158, "Output",
 CellTags->"b:5.2.0"],
Cell[313585, 9559, 1117, 29, 176, "Output",
 CellTags->"b:5.2.0"],
Cell[314705, 9590, 775, 23, 80, "Output",
 CellTags->"b:5.2.0"],
Cell[315483, 9615, 673, 19, 62, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[316171, 9637, 444, 16, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[316640, 9657, 211, 6, 49, "Input",
 CellTags->{"i:2", "b:5.2.0"}],
Cell[316854, 9665, 2624, 89, 230, "Output",
 CellTags->{"i:2", "b:5.2.0"}]
}, Open  ]],
Cell[319493, 9757, 201, 5, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[319719, 9766, 746, 21, 150, "Input",
 CellTags->"b:5.2.0"],
Cell[320468, 9789, 390, 10, 67, "Output",
 CellTags->"b:5.2.0"],
Cell[320861, 9801, 262, 7, 45, "Output",
 CellTags->"b:5.2.0"],
Cell[321126, 9810, 416, 11, 67, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[321557, 9824, 318, 6, 27, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[321900, 9834, 507, 13, 71, "Input",
 CellTags->"b:5.2.0"],
Cell[322410, 9849, 961, 28, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[323374, 9879, 1111, 33, 80, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[324500, 9915, 835, 28, 35, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[325360, 9947, 251, 6, 70, "Input",
 CellTags->"b:5.2.0"],
Cell[325614, 9955, 795, 23, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[326412, 9980, 444, 10, 61, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[326871, 9993, 284, 12, 29, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[327180, 10009, 600, 14, 130, "Input",
 CellTags->"b:5.2.0"],
Cell[327783, 10025, 961, 28, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[328747, 10055, 796, 23, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[329546, 10080, 441, 10, 61, "Output",
 CellTags->"b:5.2.0"],
Cell[329990, 10092, 743, 23, 84, "Output",
 CellTags->"b:5.2.0"],
Cell[330736, 10117, 389, 10, 67, "Output",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[331174, 10133, 191, 5, 60, "Subsection",
 CellTags->{"i:1", "c:11", "b:5.2.1"}],
Cell[331368, 10140, 672, 17, 61, "Text",
 CellTags->"b:5.2.1"],
Cell[CellGroupData[{
Cell[332065, 10161, 127, 4, 49, "Input",
 CellTags->"b:5.2.1"],
Cell[332195, 10167, 747, 21, 94, "Output",
 CellTags->"b:5.2.1"]
}, Open  ]],
Cell[332957, 10191, 349, 12, 27, "Text",
 CellTags->"b:5.2.1"],
Cell[CellGroupData[{
Cell[333331, 10207, 532, 14, 50, "Input",
 CellTags->"b:5.2.1"],
Cell[333866, 10223, 745, 21, 94, "Output",
 CellTags->"b:5.2.1"]
}, Open  ]],
Cell[334626, 10247, 237, 5, 27, "Text",
 CellTags->"b:5.2.1"],
Cell[CellGroupData[{
Cell[334888, 10256, 325, 9, 49, "Input",
 CellTags->"b:5.2.1"],
Cell[335216, 10267, 746, 21, 94, "Output",
 CellTags->"b:5.2.1"]
}, Open  ]],
Cell[335977, 10291, 363, 12, 27, "Text",
 CellTags->"b:5.2.1"],
Cell[336343, 10305, 146, 5, 49, "Input",
 CellTags->"b:5.2.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[336526, 10315, 189, 5, 60, "Subsection",
 CellTags->{"i:1", "c:12", "b:5.2.2"}],
Cell[336718, 10322, 208, 5, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[336929, 10329, 245, 7, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[337177, 10338, 349, 7, 59, "Text",
 CellTags->"b:5.2.2"],
Cell[CellGroupData[{
Cell[337551, 10349, 224, 6, 70, "Input",
 CellTags->"b:5.2.2"],
Cell[337778, 10357, 767, 22, 94, "Output",
 CellTags->"b:5.2.2"],
Cell[338548, 10381, 767, 22, 94, "Output",
 CellTags->"b:5.2.2"]
}, Open  ]],
Cell[339330, 10406, 325, 11, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[CellGroupData[{
Cell[339680, 10421, 129, 4, 49, "Input",
 CellTags->"b:5.2.2"],
Cell[339812, 10427, 1059, 27, 158, "Output",
 CellTags->"b:5.2.2"]
}, Open  ]],
Cell[340886, 10457, 281, 6, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[341170, 10465, 186, 5, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[341359, 10472, 447, 10, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[341809, 10484, 169, 4, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[CellGroupData[{
Cell[342003, 10492, 199, 6, 49, "Input",
 CellTags->"b:5.2.2"],
Cell[342205, 10500, 762, 24, 94, "Output",
 CellTags->"b:5.2.2"]
}, Open  ]],
Cell[342982, 10527, 337, 7, 27, "Text",
 CellTags->"b:5.2.2"],
Cell[CellGroupData[{
Cell[343344, 10538, 250, 8, 49, "Input",
 CellTags->"b:5.2.2"],
Cell[343597, 10548, 837, 29, 158, "Output",
 CellTags->"b:5.2.2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[344483, 10583, 187, 5, 60, "Subsection",
 CellTags->{"i:1", "c:13", "b:5.2.3"}],
Cell[344673, 10590, 291, 6, 27, "Text",
 CellTags->"b:5.2.3"],
Cell[344967, 10598, 2044, 78, 300, "Text",
 CellTags->"b:5.2.3"],
Cell[CellGroupData[{
Cell[347036, 10680, 148, 4, 49, "Input",
 CellTags->"b:5.2.3"],
Cell[347187, 10686, 1015, 25, 158, "Output",
 CellTags->"b:5.2.3"]
}, Open  ]],
Cell[348217, 10714, 862, 30, 63, "Text",
 CellTags->"b:5.2.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[349128, 10750, 89, 2, 51, "Section",
 CellTags->{"Measurement", "c:14"}],
Cell[CellGroupData[{
Cell[349242, 10756, 228, 6, 60, "Subsection",
 CellTags->{"Measurements", "c:15", "b:5.3.0"}],
Cell[349473, 10764, 268, 6, 27, "Text",
 CellTags->"b:5.3.0"],
Cell[349744, 10772, 365, 10, 29, "Text",
 CellTags->"b:5.3.0"],
Cell[CellGroupData[{
Cell[350134, 10786, 1086, 28, 71, "Input",
 CellTags->"b:5.3.0"],
Cell[351223, 10816, 3687, 105, 358, "Output",
 CellTags->"b:5.3.0"]
}, Open  ]],
Cell[354925, 10924, 226, 5, 27, "Text",
 CellTags->"b:5.3.0"],
Cell[355154, 10931, 512, 13, 52, "Input",
 CellTags->"b:5.3.0"],
Cell[355669, 10946, 248, 5, 27, "Text",
 CellTags->"b:5.3.0"],
Cell[355920, 10953, 544, 18, 51, "Input",
 CellTags->"b:5.3.0"],
Cell[356467, 10973, 247, 5, 27, "Text",
 CellTags->"b:5.3.0"],
Cell[CellGroupData[{
Cell[356739, 10982, 238, 7, 70, "Input",
 CellTags->"b:5.3.0"],
Cell[356980, 10991, 849, 25, 112, "Output",
 CellTags->"b:5.3.0"],
Cell[357832, 11018, 180, 5, 45, "Output",
 CellTags->"b:5.3.0"]
}, Open  ]],
Cell[358027, 11026, 202, 5, 27, "Text",
 CellTags->"b:5.3.0"],
Cell[CellGroupData[{
Cell[358254, 11035, 386, 10, 90, "Input",
 CellTags->"b:5.3.0"],
Cell[358643, 11047, 4217, 137, 130, "Output",
 CellTags->"b:5.3.0"],
Cell[362863, 11186, 537, 19, 62, "Output",
 CellTags->"b:5.3.0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[363449, 11211, 239, 6, 60, "Subsection",
 CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],
Cell[363691, 11219, 188, 5, 27, "Text",
 CellTags->"b:5.3.1"],
Cell[CellGroupData[{
Cell[363904, 11228, 1037, 27, 70, "Input",
 CellTags->"b:5.3.1"],
Cell[364944, 11257, 1397, 57, 374, "Output",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[366356, 11317, 210, 5, 27, "Text",
 CellTags->"b:5.3.1"],
Cell[366569, 11324, 243, 5, 27, "Text",
 CellTags->"b:5.3.1"],
Cell[366815, 11331, 324, 11, 50, "Input",
 CellTags->"b:5.3.1"],
Cell[367142, 11344, 251, 5, 27, "Text",
 CellTags->"b:5.3.1"],
Cell[CellGroupData[{
Cell[367418, 11353, 118, 4, 49, "Input",
 CellTags->"b:5.3.1"],
Cell[367539, 11359, 769, 25, 116, "Output",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[368323, 11387, 186, 5, 27, "Text",
 CellTags->"b:5.3.1"],
Cell[CellGroupData[{
Cell[368534, 11396, 410, 12, 49, "Input",
 CellTags->"b:5.3.1"],
Cell[368947, 11410, 845, 25, 112, "Output",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[369829, 11440, 104, 3, 49, "Input",
 CellTags->"b:5.3.1"],
Cell[369936, 11445, 178, 5, 45, "Output",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[370129, 11453, 186, 5, 27, "Text",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[370352, 11463, 226, 6, 60, "Subsection",
 CellTags->{"c:17", "b:5.3.2"}],
Cell[CellGroupData[{
Cell[370603, 11473, 265, 8, 70, "Input",
 CellTags->"b:5.3.2"],
Cell[370871, 11483, 10971, 185, 175, "Output",
 CellTags->"b:5.3.2"]
}, Open  ]],
Cell[381857, 11671, 217, 5, 27, "Text",
 CellTags->"b:5.3.2"],
Cell[382077, 11678, 1259, 32, 110, "Input",
 CellTags->"b:5.3.2"],
Cell[383339, 11712, 238, 5, 59, "Text",
 CellTags->"b:5.3.2"],
Cell[383580, 11719, 566, 14, 52, "Input",
 CellTags->"b:5.3.2"],
Cell[384149, 11735, 280, 9, 27, "Text",
 CellTags->"b:5.3.2"],
Cell[384432, 11746, 248, 5, 27, "Text",
 CellTags->"b:5.3.2"],
Cell[384683, 11753, 684, 21, 51, "Input",
 CellTags->"b:5.3.2"],
Cell[385370, 11776, 297, 6, 59, "Text",
 CellTags->"b:5.3.2"],
Cell[CellGroupData[{
Cell[385692, 11786, 206, 5, 49, "Input",
 CellTags->"b:5.3.2"],
Cell[385901, 11793, 967, 24, 62, "Output",
 CellTags->"b:5.3.2"]
}, Open  ]],
Cell[386883, 11820, 477, 8, 123, "Text",
 CellTags->"b:5.3.2"],
Cell[387363, 11830, 158, 4, 27, "Text",
 CellTags->"b:5.3.2"],
Cell[387524, 11836, 564, 23, 29, "Text",
 CellTags->"b:5.3.2"],
Cell[388091, 11861, 448, 14, 50, "Input",
 CellTags->"b:5.3.2"],
Cell[388542, 11877, 484, 13, 50, "Input",
 CellTags->"b:5.3.2"],
Cell[CellGroupData[{
Cell[389051, 11894, 177, 5, 49, "Input",
 CellTags->"b:5.3.2"],
Cell[389231, 11901, 968, 24, 62, "Output",
 CellTags->"b:5.3.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[390236, 11930, 278, 9, 49, "Input",
 CellTags->"b:5.3.2"],
Cell[390517, 11941, 962, 24, 62, "Output",
 CellTags->"b:5.3.2"]
}, Open  ]],
Cell[391494, 11968, 262, 6, 27, "Text",
 CellTags->"b:5.3.2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[391805, 11980, 158, 3, 51, "Section",
 CellTags->{"Measurement", "c:18"}],
Cell[CellGroupData[{
Cell[391988, 11987, 131, 4, 60, "Subsection",
 CellTags->{"c:19", "b:5.4.0"}],
Cell[392122, 11993, 394, 11, 59, "Text",
 CellTags->"b:5.4.0"],
Cell[392519, 12006, 765, 27, 63, "Text",
 CellTags->"b:5.4.0"],
Cell[393287, 12035, 372, 11, 29, "Text",
 CellTags->"b:5.4.0"],
Cell[CellGroupData[{
Cell[393684, 12050, 685, 23, 92, "Input",
 CellTags->"b:5.4.0"],
Cell[394372, 12075, 671, 19, 62, "Output",
 CellTags->"b:5.4.0"],
Cell[395046, 12096, 771, 23, 80, "Output",
 CellTags->"b:5.4.0"],
Cell[395820, 12121, 771, 23, 80, "Output",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[396606, 12147, 153, 4, 27, "Text",
 CellTags->"b:5.4.0"],
Cell[CellGroupData[{
Cell[396784, 12155, 360, 7, 110, "Input",
 CellTags->"b:5.4.0"],
Cell[397147, 12164, 176, 5, 45, "Output",
 CellTags->"b:5.4.0"],
Cell[397326, 12171, 178, 5, 45, "Output",
 CellTags->"b:5.4.0"],
Cell[397507, 12178, 905, 33, 75, "Output",
 CellTags->"b:5.4.0"],
Cell[398415, 12213, 194, 5, 45, "Output",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[398624, 12221, 469, 13, 29, "Text",
 CellTags->"b:5.4.0"],
Cell[CellGroupData[{
Cell[399118, 12238, 111, 2, 45, "Input"],
Cell[399232, 12242, 385, 6, 110, "Print",
 CellTags->"Info-aacad911-53c1-4908-87ee-2dbbf7a1d457"]
}, Open  ]],
Cell[CellGroupData[{
Cell[399654, 12253, 1720, 54, 153, "Input",
 CellTags->"b:5.4.0"],
Cell[401377, 12309, 7498, 137, 260, "Output",
 CellTags->"b:5.4.0"],
Cell[408878, 12448, 1698, 41, 256, "Output",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[410591, 12492, 517, 13, 29, "Text",
 CellTags->"b:5.4.0"],
Cell[CellGroupData[{
Cell[411133, 12509, 1839, 55, 174, "Input",
 CellTags->"b:5.4.0"],
Cell[412975, 12566, 7498, 137, 260, "Output",
 CellTags->"b:5.4.0"],
Cell[420476, 12705, 1696, 41, 256, "Output",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[422187, 12749, 263, 10, 29, "Text",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[422487, 12764, 120, 4, 60, "Subsection",
 CellTags->{"c:20", "b:5.4.1"}],
Cell[422610, 12770, 606, 23, 40, "Text",
 CellTags->"b:5.4.1"],
Cell[CellGroupData[{
Cell[423241, 12797, 420, 9, 110, "Input",
 CellTags->"b:5.4.1"],
Cell[423664, 12808, 2358, 52, 94, "Output",
 CellTags->"b:5.4.1"],
Cell[426025, 12862, 3642, 95, 176, "Output",
 CellTags->"b:5.4.1"],
Cell[429670, 12959, 2357, 56, 94, "Output",
 CellTags->"b:5.4.1"],
Cell[432030, 13017, 3628, 95, 176, "Output",
 CellTags->"b:5.4.1"]
}, Open  ]],
Cell[435673, 13115, 145, 4, 27, "Text",
 CellTags->"b:5.4.1"],
Cell[CellGroupData[{
Cell[435843, 13123, 228, 6, 70, "Input",
 CellTags->"b:5.4.1"],
Cell[436074, 13131, 252, 6, 45, "Output",
 CellTags->"b:5.4.1"],
Cell[436329, 13139, 252, 6, 45, "Output",
 CellTags->"b:5.4.1"]
}, Open  ]],
Cell[436596, 13148, 176, 4, 27, "Text",
 CellTags->"b:5.4.1"],
Cell[CellGroupData[{
Cell[436797, 13156, 197, 5, 49, "Input",
 CellTags->"b:5.4.1"],
Cell[436997, 13163, 256, 6, 45, "Output",
 CellTags->"b:5.4.1"]
}, Open  ]],
Cell[437268, 13172, 206, 5, 27, "Text",
 CellTags->"b:5.4.1"],
Cell[CellGroupData[{
Cell[437499, 13181, 881, 29, 92, "Input",
 CellTags->"b:5.4.1"],
Cell[438383, 13212, 5037, 97, 271, "Output",
 CellTags->"b:5.4.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[443457, 13314, 961, 31, 95, "Input",
 CellTags->"b:5.4.1"],
Cell[444421, 13347, 18672, 321, 258, "Output",
 CellTags->"b:5.4.1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[463142, 13674, 120, 4, 60, "Subsection",
 CellTags->{"c:4", "b:5.4.2"}],
Cell[463265, 13680, 201, 6, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[463469, 13688, 734, 24, 52, "Input",
 CellTags->"b:5.4.2"],
Cell[464206, 13714, 130, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[464361, 13721, 266, 8, 70, "Input",
 CellTags->"b:5.4.2"],
Cell[464630, 13731, 11941, 201, 182, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[476586, 13935, 99, 3, 49, "Input",
 CellTags->"b:5.4.2"],
Cell[476688, 13940, 438, 14, 51, "Input",
 CellTags->"b:5.4.2"],
Cell[477129, 13956, 400, 11, 28, "Text",
 CellTags->"b:5.4.2"],
Cell[477532, 13969, 720, 26, 56, "Input",
 CellTags->"b:5.4.2"],
Cell[478255, 13997, 114, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[478394, 14004, 195, 8, 52, "Input",
 CellTags->"b:5.4.2"],
Cell[478592, 14014, 1115, 29, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[479744, 14048, 356, 14, 75, "Input",
 CellTags->"b:5.4.2"],
Cell[480103, 14064, 1114, 29, 176, "Output",
 CellTags->"b:5.4.2"],
Cell[481220, 14095, 1163, 31, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[482420, 14131, 356, 14, 75, "Input",
 CellTags->"b:5.4.2"],
Cell[482779, 14147, 1115, 29, 176, "Output",
 CellTags->"b:5.4.2"],
Cell[483897, 14178, 1161, 31, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[485095, 14214, 356, 14, 75, "Input",
 CellTags->"b:5.4.2"],
Cell[485454, 14230, 1113, 29, 176, "Output",
 CellTags->"b:5.4.2"],
Cell[486570, 14261, 1159, 31, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[487744, 14295, 393, 11, 187, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[488162, 14310, 506, 18, 73, "Input",
 CellTags->"b:5.4.2"],
Cell[488671, 14330, 1115, 29, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[489801, 14362, 570, 18, 55, "Input"],
Cell[CellGroupData[{
Cell[490396, 14384, 1479, 42, 144, "Input",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[491900, 14430, 1851, 58, 190, "Input"],
Cell[493754, 14490, 704, 21, 78, "Output"],
Cell[494461, 14513, 704, 21, 78, "Output"],
Cell[495168, 14536, 704, 21, 78, "Output"],
Cell[CellGroupData[{
Cell[495897, 14561, 402, 8, 110, "Input"],
Cell[496302, 14571, 2491, 68, 78, "Output"],
Cell[498796, 14641, 2491, 68, 78, "Output"],
Cell[501290, 14711, 2493, 68, 78, "Output"],
Cell[503786, 14781, 2476, 65, 78, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[506323, 14853, 390, 10, 110, "Input",
 CellTags->"b:5.4.2"],
Cell[506716, 14865, 176, 5, 45, "Output",
 CellTags->"b:5.4.2"],
Cell[506895, 14872, 194, 6, 45, "Output",
 CellTags->"b:5.4.2"],
Cell[507092, 14880, 196, 6, 45, "Output",
 CellTags->"b:5.4.2"],
Cell[507291, 14888, 194, 6, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[507500, 14897, 117, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[507642, 14904, 1073, 32, 87, "Input",
 CellTags->"b:5.4.2"],
Cell[508718, 14938, 181, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[508914, 14946, 134, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[509073, 14953, 1517, 47, 73, "Input",
 CellTags->"b:5.4.2"],
Cell[510593, 15002, 179, 5, 45, "Output",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[510797, 15011, 125, 3, 49, "Input"],
Cell[510925, 15016, 677, 10, 349, "Print",
 CellTags->"Info-015c69a6-5e03-4543-ad12-b861b736a1df"]
}, Open  ]]
}, Open  ]],
Cell[511629, 15030, 136, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[511790, 15037, 278, 8, 49, "Input",
 CellTags->"b:5.4.2"],
Cell[512071, 15047, 176, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[512262, 15055, 227, 6, 59, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[512514, 15065, 277, 8, 49, "Input"],
Cell[512794, 15075, 679, 19, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[513510, 15099, 140, 3, 49, "Input"],
Cell[513653, 15104, 702, 10, 415, "Print",
 CellTags->"Info-351e538f-bd6e-4a72-81fc-8f87e467f726"]
}, Open  ]],
Cell[514370, 15117, 483, 18, 51, "Input",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[514878, 15139, 162, 4, 49, "Input"],
Cell[515043, 15145, 773, 22, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[515853, 15172, 150, 5, 49, "Input",
 CellTags->"b:5.4.2"],
Cell[516006, 15179, 795, 23, 112, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[516838, 15207, 358, 10, 70, "Input",
 CellTags->"b:5.4.2"],
Cell[517199, 15219, 794, 23, 112, "Output",
 CellTags->"b:5.4.2"],
Cell[517996, 15244, 3097, 86, 176, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[521108, 15333, 122, 3, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[521255, 15340, 170, 4, 49, "Input",
 CellTags->"b:5.4.2"],
Cell[521428, 15346, 178, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[521621, 15354, 206, 7, 59, "Text",
 CellTags->"b:5.4.2"],
Cell[521830, 15363, 158, 5, 27, "Text",
 CellTags->"b:5.4.2"],
Cell[CellGroupData[{
Cell[522013, 15372, 430, 14, 72, "Input",
 CellTags->"b:5.4.2"],
Cell[522446, 15388, 723, 21, 80, "Output",
 CellTags->"b:5.4.2"],
Cell[523172, 15411, 178, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[523387, 15421, 430, 14, 72, "Input",
 CellTags->"b:5.4.2"],
Cell[523820, 15437, 723, 21, 80, "Output",
 CellTags->"b:5.4.2"],
Cell[524546, 15460, 178, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[524761, 15470, 430, 14, 72, "Input",
 CellTags->"b:5.4.2"],
Cell[525194, 15486, 725, 21, 80, "Output",
 CellTags->"b:5.4.2"],
Cell[525922, 15509, 180, 5, 45, "Output",
 CellTags->"b:5.4.2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[526163, 15521, 295, 9, 52, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[526461, 15532, 516, 16, 49, "Text",
 CellTags->"b:5.4.3"],
Cell[526980, 15550, 1089, 39, 183, "Text",
 CellTags->"b:5.4.3"],
Cell[528072, 15591, 268, 6, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[528343, 15599, 222, 5, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[528590, 15608, 265, 9, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[528858, 15619, 1131, 39, 138, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[530004, 15661, 164, 4, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[530171, 15667, 715, 24, 52, "Input",
 CellTags->"b:5.4.3"],
Cell[530889, 15693, 451, 12, 29, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[531365, 15709, 448, 13, 117, "Input",
 CellTags->"b:5.4.3"],
Cell[531816, 15724, 849, 25, 112, "Output",
 CellTags->"b:5.4.3"],
Cell[532668, 15751, 847, 25, 112, "Output",
 CellTags->"b:5.4.3"],
Cell[533518, 15778, 893, 27, 112, "Output",
 CellTags->"b:5.4.3"],
Cell[534414, 15807, 893, 27, 112, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[535322, 15837, 367, 7, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[535692, 15846, 1434, 48, 53, "Input",
 CellTags->"b:5.4.3"],
Cell[537129, 15896, 197, 5, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[537351, 15905, 642, 22, 82, "Input",
 CellTags->"b:5.4.3"],
Cell[537996, 15929, 3122, 101, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[541121, 16032, 181, 5, 45, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[541317, 16040, 219, 5, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[541561, 16049, 742, 22, 133, "Input",
 CellTags->"b:5.4.3"],
Cell[542306, 16073, 1055, 31, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[543364, 16106, 1055, 31, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[544422, 16139, 1101, 33, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[545526, 16174, 1101, 33, 130, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[546642, 16210, 220, 5, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[546887, 16219, 1508, 46, 133, "Input",
 CellTags->"b:5.4.3"],
Cell[548398, 16267, 1083, 34, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[549484, 16303, 1083, 34, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[550570, 16339, 1081, 34, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[551654, 16375, 1081, 34, 130, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[552784, 16415, 323, 10, 52, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[553110, 16427, 182, 6, 59, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[553317, 16437, 2811, 109, 218, "Input",
 CellTags->"b:5.4.3"],
Cell[556131, 16548, 728, 22, 78, "Output",
 CellTags->"b:5.4.3"],
Cell[556862, 16572, 726, 22, 78, "Output",
 CellTags->"b:5.4.3"],
Cell[557591, 16596, 1097, 33, 86, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[558703, 16632, 191, 6, 59, "Text",
 CellTags->"b:5.4.3"],
Cell[558897, 16640, 125, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[559025, 16645, 105, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[559155, 16652, 704, 24, 83, "Input",
 CellTags->"b:5.4.3"],
Cell[559862, 16678, 808, 27, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[560673, 16707, 5222, 166, 100, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[565944, 16879, 290, 9, 52, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[566237, 16890, 218, 7, 59, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[566480, 16901, 867, 27, 117, "Input",
 CellTags->"b:5.4.3"],
Cell[567350, 16930, 3123, 101, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[570476, 17033, 747, 21, 94, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[571238, 17057, 1129, 45, 61, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[572392, 17106, 1484, 47, 72, "Input",
 CellTags->"b:5.4.3"],
Cell[573879, 17155, 3180, 102, 130, "Output",
 CellTags->"b:5.4.3"],
Cell[577062, 17259, 747, 21, 94, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[577858, 17286, 316, 9, 52, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[578177, 17297, 94, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[578296, 17304, 1885, 62, 139, "Input",
 CellTags->"b:5.4.3"],
Cell[580184, 17368, 812, 27, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[580999, 17397, 334, 11, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[581336, 17410, 334, 11, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[581673, 17423, 334, 11, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[582010, 17436, 334, 11, 62, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[582359, 17450, 95, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[582479, 17457, 1707, 55, 117, "Input",
 CellTags->"b:5.4.3"],
Cell[584189, 17514, 998, 33, 75, "Output",
 CellTags->"b:5.4.3"],
Cell[585190, 17549, 1021, 34, 75, "Output",
 CellTags->"b:5.4.3"],
Cell[586214, 17585, 1018, 34, 75, "Output",
 CellTags->"b:5.4.3"],
Cell[587235, 17621, 998, 33, 75, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[588248, 17657, 120, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[588371, 17662, 659, 20, 51, "Input",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[589055, 17686, 359, 10, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[589417, 17698, 4515, 88, 247, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[593969, 17791, 357, 10, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[594329, 17803, 4515, 88, 247, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[598881, 17896, 359, 10, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[599243, 17908, 4517, 88, 247, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[603797, 18001, 357, 10, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[604157, 18013, 4517, 88, 247, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[608689, 18104, 115, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[608807, 18109, 99, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[608931, 18116, 772, 29, 72, "Input",
 CellTags->"b:5.4.3"],
Cell[609706, 18147, 725, 21, 80, "Output",
 CellTags->"b:5.4.3"],
Cell[610434, 18170, 730, 22, 78, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[611179, 18195, 109, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[611313, 18202, 229, 5, 70, "Input",
 CellTags->"b:5.4.3"],
Cell[611545, 18209, 178, 5, 45, "Output",
 CellTags->"b:5.4.3"],
Cell[611726, 18216, 199, 6, 62, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[611940, 18225, 99, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[612064, 18232, 772, 29, 72, "Input",
 CellTags->"b:5.4.3"],
Cell[612839, 18263, 720, 21, 80, "Output",
 CellTags->"b:5.4.3"],
Cell[613562, 18286, 726, 22, 78, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[614303, 18311, 109, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[614437, 18318, 229, 5, 70, "Input",
 CellTags->"b:5.4.3"],
Cell[614669, 18325, 178, 5, 45, "Output",
 CellTags->"b:5.4.3"],
Cell[614850, 18332, 197, 6, 62, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[615062, 18341, 105, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[615192, 18348, 290, 9, 70, "Input",
 CellTags->"b:5.4.3"],
Cell[615485, 18359, 767, 23, 80, "Output",
 CellTags->"b:5.4.3"],
Cell[616255, 18384, 765, 23, 80, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[617035, 18410, 126, 3, 27, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[617186, 18417, 476, 16, 51, "Input",
 CellTags->"b:5.4.3"],
Cell[617665, 18435, 1081, 34, 130, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[618783, 18474, 358, 10, 110, "Input",
 CellTags->"b:5.4.3"],
Cell[619144, 18486, 308, 10, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[619455, 18498, 231, 7, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[619689, 18507, 231, 7, 62, "Output",
 CellTags->"b:5.4.3"],
Cell[619923, 18516, 230, 7, 62, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[620190, 18528, 1118, 36, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[621311, 18566, 694, 22, 65, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[622042, 18593, 239, 7, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[622284, 18602, 4522, 88, 247, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[626843, 18695, 237, 8, 49, "Input",
 CellTags->"b:5.4.3"],
Cell[627083, 18705, 180, 5, 45, "Output",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]],
Cell[627290, 18714, 133, 3, 49, "Input"]
}
]
*)

(* End of internal cache information *)
