(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    108690,       2889]
NotebookOptionsPosition[     98353,       2609]
NotebookOutlinePosition[    104673,       2766]
CellTagsIndexPosition[    104195,       2751]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[{
 StyleBox["QDENSITY",
  FontSlant->"Italic"],
 "\nIntroductory Tutorial For New TensorProduct"
}], "Title",
 CellChangeTimes->{{3.612866572274436*^9, 3.612866577920342*^9}, {
  3.612872992793129*^9, 3.6128730053232937`*^9}},
 CellTags->"c:1"],

Cell["Basic tools in QDENSITY", "Subtitle"],

Cell["\<\
Last Version:November 2014
Frank Tabakin\
\>", "Abstract",
 CellChangeTimes->{{3.612866584682075*^9, 3.612866585559554*^9}, {
  3.624541233272476*^9, 3.624541248199376*^9}}],

Cell[TextData[ButtonBox["Click here to get the palette: QDENSpalette.nb",
 BaseStyle->"Hyperlink",
 ButtonData:>{"QDENSpalette.nb", None}]], "Text"],

Cell[CellGroupData[{

Cell["Getting started", "Section",
 FontFamily->"Times",
 CellTags->{"b:14.0", "c:2"}],

Cell[TextData[StyleBox["and most importantly you need to load the package \
file Qdensity.m,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:14.0"],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox[
  RowBox[{"$", 
   StyleBox["UserBaseDirectory", "MR"]}]]], "Input"],

Cell[BoxData["\<\"/Users/franktabakin/Library/Mathematica\"\>"], "Output",
 CellChangeTimes->{3.6166717809770823`*^9, 3.624286674737104*^9, 
  3.655398222580708*^9, 3.657378727326799*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 CellChangeTimes->{
  3.6128672956697693`*^9, {3.6130382690497913`*^9, 3.613038269442749*^9}, {
   3.61313727257333*^9, 3.613137273123706*^9}},
 CellTags->"b:14.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.624286674804366*^9, 3.6553982226431437`*^9, 
  3.6573787274309387`*^9},
 CellTags->"b:14.0"]
}, Open  ]],

Cell[TextData[StyleBox["To see all the commands contained in the 2014 \
package:  ",
 FontFamily->"Helvetica"]], "Text",
 CellChangeTimes->{{3.625332591203515*^9, 3.625332592560601*^9}},
 FontFamily->"Courier New",
 CellTags->"b:14.0"],

Cell[TextData[StyleBox["If you click on any entry in the display above, \
information about it will appear above this line.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:14.0"],

Cell[TextData[{
 StyleBox["You can access the package Palette by clicking here: ",
  FontFamily->"Helvetica"],
 ButtonBox["QDENSpalette14.nb",
  BaseStyle->"Hyperlink",
  ButtonData:>{"QDENSpalette14.nb", None}]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:14.0"],

Cell["TensorProduct", "Section",
 CellChangeTimes->{{3.6128730458375998`*^9, 3.612873051291319*^9}, 
   3.612873145834054*^9},
 FontFamily->"Times",
 CellTags->{"b:14.3", "Measurement", "c:18"}]
}, Open  ]],

Cell[TextData[{
 StyleBox["Versions 9.0-10 have a built-in definition of TensorProduct and of \
A",
  FontFamily->"Helvetica"],
 "\[TensorProduct]",
 StyleBox["B.\nEarlier, we had revised Qdensity.m to provide our own \
TensorProductQD.\nNow we switch over to the built-in version,  which is \
tested herein.\n\[OpenCurlyDoubleQuote]TensorProductQ\[CloseCurlyDoubleQuote] \
is the new Qdensity version.  There is a defect in ",
  FontFamily->"Helvetica"],
 StyleBox["Mathematica",
  FontFamily->"Helvetica",
  FontSlant->"Italic"],
 StyleBox["\[CloseCurlyQuote]s\ntensorproduct as  illustated here, in that \
the TensorProduct output needs to be flatten to\nform matrices and state \
vectors which can be used in subsequent steps.  Thus, we now \nuse \
TensorProductQ to incorporates the requisite flattening, using  an array \
flattening \[OpenCurlyDoubleQuote]AF\[CloseCurlyDoubleQuote]command: \n",
  FontFamily->"Helvetica"],
 "AF[st_]:=FixedPoint[ArrayFlatten,st].",
 StyleBox["\nNote that the command ",
  FontFamily->"Helvetica"],
 "AF[",
 StyleBox["\[SelectionPlaceholder]\[TensorProduct]\[SelectionPlaceholder]] is \
now in the  2014 Palette",
  ScriptLevel->0],
 StyleBox["\nThe definition used in older \nQDENSITY  \
\[OpenCurlyDoubleQuote]TensorProductQD\[CloseCurlyDoubleQuote] is now \
omittted",
  FontFamily->"Helvetica"]
}], "Text",
 CellChangeTimes->{{3.612873195563862*^9, 3.612873324725799*^9}, {
  3.613136985135907*^9, 3.61313716284385*^9}, {3.616578886929525*^9, 
  3.616579122480771*^9}, {3.616579210666616*^9, 3.616579297207447*^9}, {
  3.616579556238492*^9, 3.6165796246567802`*^9}, {3.625332625716468*^9, 
  3.625332663787443*^9}},
 FontFamily->"Courier New",
 CellTags->"b:14.1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TensorProduct"}]], "Input",
 CellChangeTimes->{{3.612873159443659*^9, 3.61287316049649*^9}, {
   3.612873329833703*^9, 3.612873366081641*^9}, 3.6129561903057823`*^9, {
   3.6131371709569893`*^9, 3.613137172428883*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"TensorProduct\\\", \\\"[\\\", \
RowBox[{SubscriptBox[StyleBox[\\\"tensor\\\", \\\"TI\\\"], \
StyleBox[\\\"1\\\", \\\"TR\\\"]], \\\",\\\", SubscriptBox[StyleBox[\\\"tensor\
\\\", \\\"TI\\\"], StyleBox[\\\"2\\\", \\\"TR\\\"]], \\\",\\\", StyleBox[\\\"\
\[Ellipsis]\\\", \\\"TR\\\"]}], \\\"]\\\"}]\) represents the tensor product \
of the \!\(\*SubscriptBox[StyleBox[\\\"tensor\\\", \\\"TI\\\"], \
StyleBox[\\\"i\\\", \\\"TI\\\"]]\).\"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/TensorProduct"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378727932495*^9},
 CellTags->"Info-768aa162-e5fe-4f8e-97ea-a10a6eff4a8a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TensorProductQ"}]], "Input",
 CellChangeTimes->{3.6165788626198683`*^9}],

Cell[BoxData[
 StyleBox["\<\"TensorProductQ[{a,b,c,...}], Note need to include {.. } \
brackets\\n\\n\t gives the tensor product of A,B,C ... . \\n\\n Now using \
built in definition of TensorProduct.\\nTensorProductQ provides the flattened \
\\nmatrix to be used in qdensity.  \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737872805474*^9},
 CellTags->"Info-54c50a1d-0cf6-4285-b3a0-eb0c3639a251"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AF"}]], "Input",
 CellChangeTimes->{{3.6165791293262167`*^9, 3.616579136261491*^9}}],

Cell[BoxData[
 StyleBox["\<\"AF[state]\\n\\n   AF denotes ArrayFlatten,  which is needed \
for \\nthe MMA 9.0 and 10.0 built-in Tensorproduct setup.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.65737872813868*^9},
 CellTags->"Info-693c54f6-a34a-4498-9aef-56d5e0c7ef2c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"resa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{
     RowBox[{"s", "[", "1", "]"}], ",", 
     RowBox[{"s", "[", "2", "]"}]}], "]"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"resb", "=", 
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", 
   RowBox[{"s", "[", "2", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"resa", "\[Equal]", "resb"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "resa", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "resb", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", "[", "1", "]"}], ",", 
     RowBox[{"s", "[", "2", "]"}]}], "}"}], "]"}], " ", "==", 
  RowBox[{"AF", "[", "resa", "]"}]}]}], "Input",
 CellChangeTimes->{{3.612956204662084*^9, 3.612956358979048*^9}, {
   3.612956634165707*^9, 3.61295664873437*^9}, {3.612963498724348*^9, 
   3.612963500456565*^9}, {3.6129641058527927`*^9, 3.6129641302734547`*^9}, {
   3.613137190519945*^9, 3.6131372505591393`*^9}, {3.616580623237986*^9, 
   3.616580670119042*^9}, {3.6165807035048447`*^9, 3.61658078921506*^9}, {
   3.616580827405676*^9, 3.616580830137701*^9}, 3.616667147834362*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "\[ImaginaryI]"}]},
         {"\[ImaginaryI]", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "\[ImaginaryI]"}]},
         {"\[ImaginaryI]", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.657378728185089*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "\[ImaginaryI]"}]},
         {"\[ImaginaryI]", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", "\[ImaginaryI]"}]},
         {"\[ImaginaryI]", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0"},
         {"0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.657378728208712*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.657378728231229*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0", "0", "\[ImaginaryI]", "0"},
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0"},
     {"\[ImaginaryI]", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.6573787282537317`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}]},
     {"0", "0", "\[ImaginaryI]", "0"},
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0"},
     {"\[ImaginaryI]", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.65737872827678*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781175145*^9, 3.6242866750540237`*^9, 
  3.655398223288755*^9, 3.657378728299891*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"resa", "=", " ", 
    RowBox[{"TensorProduct", "[", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], ",", 
      RowBox[{"s", "[", "2", "]"}], ",", 
      RowBox[{"s", "[", "3", "]"}]}], "]"}]}], " ", "\[IndentingNewLine]", 
   RowBox[{"resb", "=", 
    RowBox[{
     RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", 
     RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", 
     RowBox[{"s", "[", "3", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"resa", "\[Equal]", "resb"}], "\[IndentingNewLine]", 
   RowBox[{"AF", "[", "resa", "]"}], " ", "\[IndentingNewLine]", 
   RowBox[{"AF", "[", "resb", "]"}], " ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TensorProductQ", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"s", "[", "1", "]"}], ",", 
       RowBox[{"s", "[", "2", "]"}], ",", 
       RowBox[{"s", "[", "3", "]"}]}], "}"}], "]"}], " ", "==", 
    RowBox[{"AF", "[", "resa", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.612956204662084*^9, 3.612956358979048*^9}, {
  3.612956634165707*^9, 3.61295664873437*^9}, {3.612963498724348*^9, 
  3.612963500456565*^9}, {3.6129641058527927`*^9, 3.6129641302734547`*^9}, {
  3.613137190519945*^9, 3.6131372505591393`*^9}, {3.616580623237986*^9, 
  3.616580670119042*^9}, {3.6165807035048447`*^9, 3.61658078921506*^9}, {
  3.616580827405676*^9, 3.616580884080323*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {
              RowBox[{"-", "\[ImaginaryI]"}], "0"},
             {"0", "\[ImaginaryI]"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"\[ImaginaryI]", "0"},
             {"0", 
              RowBox[{"-", "\[ImaginaryI]"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {
              RowBox[{"-", "\[ImaginaryI]"}], "0"},
             {"0", "\[ImaginaryI]"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"\[ImaginaryI]", "0"},
             {"0", 
              RowBox[{"-", "\[ImaginaryI]"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.6573787283478413`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {
              RowBox[{"-", "\[ImaginaryI]"}], "0"},
             {"0", "\[ImaginaryI]"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"\[ImaginaryI]", "0"},
             {"0", 
              RowBox[{"-", "\[ImaginaryI]"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {
              RowBox[{"-", "\[ImaginaryI]"}], "0"},
             {"0", "\[ImaginaryI]"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"\[ImaginaryI]", "0"},
             {"0", 
              RowBox[{"-", "\[ImaginaryI]"}]}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0", "0"},
             {"0", "0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.6573787283761272`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.657378728404807*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "\[ImaginaryI]"},
     {"0", "0", "0", "0", "\[ImaginaryI]", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0"},
     {"0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "\[ImaginaryI]", "0", "0", "0", "0"},
     {"\[ImaginaryI]", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.657378728433332*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", "\[ImaginaryI]"},
     {"0", "0", "0", "0", "\[ImaginaryI]", "0", "0", "0"},
     {"0", "0", "0", "0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0"},
     {"0", "0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0", "0", "0", "0"},
     {"0", "0", "0", "\[ImaginaryI]", "0", "0", "0", "0"},
     {"\[ImaginaryI]", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "\[ImaginaryI]"}], "0", "0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.657378728462985*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781208003*^9, 3.624286675086339*^9, 
  3.655398223337687*^9, 3.65737872849199*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"A", "=", 
    RowBox[{
     RowBox[{"a", " ", 
      RowBox[{"s", "[", "0", "]"}]}], " ", "+", " ", 
     RowBox[{"b", " ", 
      RowBox[{"s", "[", "1", "]"}]}], " ", "+", " ", 
     RowBox[{"c", " ", 
      RowBox[{"s", "[", "2", "]"}]}], " ", "+", " ", 
     RowBox[{"d", " ", 
      RowBox[{"s", "[", "3", "]"}]}]}]}], "\[IndentingNewLine]", 
   RowBox[{"B", "=", 
    RowBox[{
     RowBox[{"e", " ", 
      RowBox[{"s", "[", "0", "]"}]}], " ", "+", " ", 
     RowBox[{"f", " ", 
      RowBox[{"s", "[", "1", "]"}]}], " ", "+", " ", 
     RowBox[{"g", " ", 
      RowBox[{"s", "[", "2", "]"}]}], " ", "+", " ", 
     RowBox[{"h", " ", 
      RowBox[{"s", "[", "3", "]"}]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.612956569920528*^9, 3.612956573958146*^9}, 
   3.6129566283527603`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"a", "+", "d"}], 
      RowBox[{"b", "-", 
       RowBox[{"\[ImaginaryI]", " ", "c"}]}]},
     {
      RowBox[{"b", "+", 
       RowBox[{"\[ImaginaryI]", " ", "c"}]}], 
      RowBox[{"a", "-", "d"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717812414*^9, 3.624286675120726*^9, 
  3.65539822337151*^9, 3.657378728719228*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"e", "+", "h"}], 
      RowBox[{"f", "-", 
       RowBox[{"\[ImaginaryI]", " ", "g"}]}]},
     {
      RowBox[{"f", "+", 
       RowBox[{"\[ImaginaryI]", " ", "g"}]}], 
      RowBox[{"e", "-", "h"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717812414*^9, 3.624286675120726*^9, 
  3.65539822337151*^9, 3.657378728756359*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"resa", "=."}], "\[IndentingNewLine]", 
 RowBox[{"resb", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{"A", ",", "B"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resb", "=", 
   RowBox[{"A", "\[TensorProduct]", "B"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"resa", "\[Equal]", "resb"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "resa", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "resb", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "resb", "]"}], " ", "==", 
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.616580977078704*^9, 3.6165810425610447`*^9}, {
  3.616581078233035*^9, 3.616581140779366*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781252748*^9, 3.624286675154497*^9, 
  3.655398223389591*^9, 3.657378728811227*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781252748*^9, 3.624286675154497*^9, 
  3.655398223389591*^9, 3.6573787288608637`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "+", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "-", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"b", "+", 
         RowBox[{"\[ImaginaryI]", " ", "c"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"f", "+", 
         RowBox[{"\[ImaginaryI]", " ", "g"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "d"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"e", "-", "h"}], ")"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781252748*^9, 3.624286675154497*^9, 
  3.655398223389591*^9, 3.65737872890343*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781252748*^9, 3.624286675154497*^9, 
  3.655398223389591*^9, 3.657378728934629*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"nqubits", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A", "=", 
   RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"C1", "=", 
   RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"resa", "=."}], "\[IndentingNewLine]", 
 RowBox[{"resb", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{"A", ",", "B", ",", "C1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resb", "=", 
   RowBox[{"A", "\[TensorProduct]", "B", "\[TensorProduct]", "C1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resa", "\[Equal]", "resb"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ra", "=", 
   RowBox[{"AF", "[", "resa", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rb", "=", 
   RowBox[{"AF", 
    StyleBox["[",
     FontFamily->"Consolas-Bold"], 
    StyleBox["  ",
     FontWeight->"Plain",
     FontColor->RGBColor[
      0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
    RowBox[{"Chop", "[", "resb", "]"}], 
    StyleBox["]",
     FontFamily->"Consolas-Bold",
     FontColor->RGBColor[0., 0., 0.]]}]}], 
  StyleBox[";",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]]}], "\[IndentingNewLine]", 
 RowBox[{
  StyleBox["ra",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]], 
  StyleBox["\[Equal]",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]], "rb"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"TensorProductQ", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B", ",", "C1"}], "}"}], "]"}], "\[Equal]", 
   "ra"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.612956677329481*^9, 3.612956738698048*^9}, {
   3.6129632897098627`*^9, 3.612963301444356*^9}, 3.6129633375070963`*^9, {
   3.612963368353578*^9, 3.61296343483722*^9}, {3.612964221925551*^9, 
   3.612964258822942*^9}, {3.6129926968579197`*^9, 3.612992732956745*^9}, {
   3.612992787237377*^9, 3.6129927946834106`*^9}, {3.612992856106578*^9, 
   3.6129928671415443`*^9}, {3.612992929870529*^9, 3.612992964047225*^9}, {
   3.612993019191976*^9, 3.6129930618602743`*^9}, {3.612993093337223*^9, 
   3.612993112270495*^9}, {3.612993300362871*^9, 3.6129933764996758`*^9}, {
   3.612993406524843*^9, 3.6129934473722763`*^9}, {3.612993593751287*^9, 
   3.612993601693369*^9}, {3.612993697945345*^9, 3.612993862704698*^9}, 
   3.613137500085346*^9, {3.613137693217203*^9, 3.61313770211427*^9}, {
   3.613137750499507*^9, 3.6131377507683783`*^9}, {3.613165228457123*^9, 
   3.613165254008669*^9}, {3.6131654277657022`*^9, 3.613165432493691*^9}, {
   3.613165469231474*^9, 3.613165566359887*^9}, {3.6131656038651333`*^9, 
   3.6131656518339767`*^9}, {3.613165842638425*^9, 3.6131658636509733`*^9}, {
   3.613165907053094*^9, 3.613165916546286*^9}, {3.613166101962759*^9, 
   3.613166118700822*^9}, {3.6131662292401667`*^9, 3.6131662298464327`*^9}, {
   3.613166278726551*^9, 3.613166320489647*^9}, {3.613166407761145*^9, 
   3.6131664325181704`*^9}, {3.6131665198711557`*^9, 3.613166590349565*^9}, {
   3.613167326960739*^9, 3.613167340863371*^9}, {3.6131674919793863`*^9, 
   3.6131675443677273`*^9}, {3.613167711357827*^9, 3.613167782076166*^9}, {
   3.61316782057148*^9, 3.6131678863884783`*^9}, {3.6165811944517593`*^9, 
   3.616581288218318*^9}, {3.6165813575010443`*^9, 3.616581423796563*^9}, 
   3.616581479861909*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781292327*^9, 3.624286675188191*^9, 
  3.655398223422069*^9, 3.6573787289955683`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781292327*^9, 3.624286675188191*^9, 
  3.655398223422069*^9, 3.657378729026587*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781292327*^9, 3.624286675188191*^9, 
  3.655398223422069*^9, 3.657378729060758*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"nqubits", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"A", "=", 
  RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"C1", "=", 
   RowBox[{"RandomQubitN", "[", "nqubits", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"resa", "=."}], "\[IndentingNewLine]", 
 RowBox[{"resb", "=."}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{"A", ",", "B", ",", "C1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"resb", "=", 
   RowBox[{"A", "\[TensorProduct]", "B", "\[TensorProduct]", "C1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"resa", "\[Equal]", "resb", " "}]}], "Input",
 CellChangeTimes->{{3.612956677329481*^9, 3.612956738698048*^9}, {
   3.6129632897098627`*^9, 3.612963301444356*^9}, 3.6129633375070963`*^9, {
   3.612963368353578*^9, 3.61296343483722*^9}, {3.612964221925551*^9, 
   3.612964258822942*^9}, {3.6129926968579197`*^9, 3.612992732956745*^9}, {
   3.612992787237377*^9, 3.6129927946834106`*^9}, {3.612992856106578*^9, 
   3.6129928671415443`*^9}, {3.612992929870529*^9, 3.612992964047225*^9}, {
   3.612993019191976*^9, 3.6129930618602743`*^9}, {3.612993093337223*^9, 
   3.612993112270495*^9}, {3.612993300362871*^9, 3.6129933764996758`*^9}, {
   3.612993406524843*^9, 3.6129934473722763`*^9}, {3.612993593751287*^9, 
   3.612993601693369*^9}, {3.612993697945345*^9, 3.612993862704698*^9}, 
   3.613137500085346*^9, {3.613137693217203*^9, 3.61313770211427*^9}, {
   3.613137750499507*^9, 3.6131377507683783`*^9}, {3.613165228457123*^9, 
   3.613165254008669*^9}, {3.6131654277657022`*^9, 3.613165432493691*^9}, {
   3.613165469231474*^9, 3.613165566359887*^9}, {3.6131656038651333`*^9, 
   3.6131656518339767`*^9}, {3.613165842638425*^9, 3.6131658636509733`*^9}, {
   3.613165907053094*^9, 3.613165916546286*^9}, {3.613166101962759*^9, 
   3.613166118700822*^9}, {3.6131662292401667`*^9, 3.6131662298464327`*^9}, {
   3.613166278726551*^9, 3.613166320489647*^9}, {3.613166407761145*^9, 
   3.6131664325181704`*^9}, {3.6131665198711557`*^9, 3.613166590349565*^9}, {
   3.613167326960739*^9, 3.613167340863371*^9}, {3.6131674919793863`*^9, 
   3.6131675443677273`*^9}, {3.613167711357827*^9, 3.613167782076166*^9}, {
   3.61316782057148*^9, 3.6131678863884783`*^9}, {3.6165811944517593`*^9, 
   3.616581288218318*^9}, {3.6165813575010443`*^9, 3.616581423796563*^9}, {
   3.616581479861909*^9, 3.61658150445153*^9}, 3.616581618199155*^9, {
   3.616581866259696*^9, 3.6165818736698303`*^9}, {3.616581910265068*^9, 
   3.6165819340691*^9}, {3.616662233429838*^9, 3.6166622378826637`*^9}, {
   3.6166622855271187`*^9, 3.616662286493168*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.1288263157930394`", 
      RowBox[{"0.024487308645748104`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.06855036456649359`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.08729272601057612`"}], "+", 
       RowBox[{"0.02511703697720556`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.013765092065017753`"}], "+", 
       RowBox[{"0.02905570484300879`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0494217902517628`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0003145028260184358`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.03823168569181191`"}], "-", 
       RowBox[{"0.03673501444107838`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.033960330297306704`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.04083552367406419`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.012874685701842813`"}], "-", 
       RowBox[{"0.02918673279301149`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.024487308645748104`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.06855036456649359`", " ", "\[ImaginaryI]"}]}], 
      "0.1576804424005487`", 
      RowBox[{
       RowBox[{"-", "0.022955754329268337`"}], "+", 
       RowBox[{"0.06748585655736176`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.001027467431817154`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.005646977818737793`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.013645411112608084`"}], "+", 
       RowBox[{"0.019361660194080917`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.025560865667479858`"}], "+", 
       RowBox[{"0.043548500618076295`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.011577400298884561`"}], "+", 
       RowBox[{"0.0020950110369097256`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.043936121059126185`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.03365474553844892`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.08729272601057612`"}], "-", 
       RowBox[{"0.02511703697720556`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.022955754329268337`"}], "-", 
       RowBox[{"0.06748585655736176`", " ", "\[ImaginaryI]"}]}], 
      "0.15160740789128915`", 
      RowBox[{
       RowBox[{"-", "0.009690136314411693`"}], "+", 
       RowBox[{"0.008539864764489213`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.033344318727288005`"}], "+", 
       RowBox[{"0.015739556915507505`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.02663592738988848`"}], "+", 
       RowBox[{"0.03243115921358663`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0017667461893543313`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.021272001217228675`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0078608509841534`"}], "+", 
       RowBox[{"0.01875897123622014`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.013765092065017753`"}], "-", 
       RowBox[{"0.02905570484300879`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.001027467431817154`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.005646977818737793`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.009690136314411693`"}], "-", 
       RowBox[{"0.008539864764489213`", " ", "\[ImaginaryI]"}]}], 
      "0.08661886944107873`", 
      RowBox[{"0.005373897719556688`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.02546544661533613`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00474648952481682`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.0178086617069664`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.002579791959208429`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.01731384615251894`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.048321784850428776`"}], "+", 
       RowBox[{"0.05614012018153492`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.0494217902517628`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0003145028260184358`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.013645411112608084`"}], "-", 
       RowBox[{"0.019361660194080917`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.033344318727288005`"}], "-", 
       RowBox[{"0.015739556915507505`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.005373897719556688`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.02546544661533613`", " ", "\[ImaginaryI]"}]}], 
      "0.1262516957432815`", 
      RowBox[{"0.007197896538032928`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.018929897641342473`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0068159625629364`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.049792054326762876`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.008882302473486777`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.04192939381306965`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.03823168569181191`"}], "+", 
       RowBox[{"0.03673501444107838`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.025560865667479858`"}], "-", 
       RowBox[{"0.043548500618076295`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.02663592738988848`"}], "-", 
       RowBox[{"0.03243115921358663`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.00474648952481682`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.0178086617069664`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.007197896538032928`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.018929897641342473`", " ", "\[ImaginaryI]"}]}], 
      "0.09403895172255519`", 
      RowBox[{
       RowBox[{"-", "0.05341883465774985`"}], "-", 
       RowBox[{"0.018330608260654323`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.007532928225921602`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.018319123593652127`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{"0.033960330297306704`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.04083552367406419`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.011577400298884561`"}], "-", 
       RowBox[{"0.0020950110369097256`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0017667461893543313`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.021272001217228675`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.002579791959208429`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.01731384615251894`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.0068159625629364`", "\[VeryThinSpace]", "-", 
       RowBox[{"0.049792054326762876`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.05341883465774985`"}], "+", 
       RowBox[{"0.018330608260654323`", " ", "\[ImaginaryI]"}]}], 
      "0.11221250097690504`", 
      RowBox[{
       RowBox[{"-", "0.023351415135692947`"}], "+", 
       RowBox[{"0.007964925390179081`", " ", "\[ImaginaryI]"}]}]},
     {
      RowBox[{
       RowBox[{"-", "0.012874685701842813`"}], "+", 
       RowBox[{"0.02918673279301149`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.043936121059126185`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.03365474553844892`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.0078608509841534`"}], "-", 
       RowBox[{"0.01875897123622014`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.048321784850428776`"}], "-", 
       RowBox[{"0.05614012018153492`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.008882302473486777`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.04192939381306965`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{"0.007532928225921602`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.018319123593652127`", " ", "\[ImaginaryI]"}]}], 
      RowBox[{
       RowBox[{"-", "0.023351415135692947`"}], "-", 
       RowBox[{"0.007964925390179081`", " ", "\[ImaginaryI]"}]}], 
      "0.14276381603130234`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781336207*^9, 3.624286675254841*^9, 
  3.6553982235044737`*^9, 3.65737872911206*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671781336207*^9, 3.624286675254841*^9, 
  3.6553982235044737`*^9, 3.6573787294394083`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ra", "=", 
   RowBox[{"AF", "[", 
    RowBox[{"Chop", "[", "resa", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rb", "=", 
   RowBox[{"AF", 
    StyleBox["[",
     FontFamily->"Consolas-Bold"], 
    StyleBox["  ",
     FontWeight->"Plain",
     FontColor->RGBColor[
      0.15294117647058825`, 0.32941176470588235`, 0.6431372549019608]], 
    RowBox[{"Chop", "[", "resb", "]"}], 
    StyleBox["]",
     FontFamily->"Consolas-Bold",
     FontColor->RGBColor[0., 0., 0.]]}]}], 
  StyleBox[";",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]]}], "\[IndentingNewLine]", 
 RowBox[{
  StyleBox["ra",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]], 
  StyleBox["\[Equal]",
   FontFamily->"Consolas-Bold",
   FontColor->RGBColor[0., 0., 0.]], "rb"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chop", "[", 
   RowBox[{"TensorProductQ", "[", 
    RowBox[{"{", 
     RowBox[{"A", ",", "B", ",", "C1"}], "}"}], "]"}], "]"}], "\[Equal]", 
  RowBox[{"Chop", "[", "ra", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Length", "[", "ra", "]"}], "==", 
  RowBox[{
   RowBox[{"Length", "[", "A", "]"}], 
   RowBox[{"Length", "[", "B", "]"}], 
   RowBox[{"Length", "[", "C1", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.616581645081767*^9, 3.616581679325593*^9}, {
  3.616582005671831*^9, 3.616582022647626*^9}, {3.616662141250332*^9, 
  3.616662184019951*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717837672253`*^9, 3.624286677623934*^9, 
  3.6553982260353518`*^9, 3.657378731415825*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717837672253`*^9, 3.624286677623934*^9, 
  3.6553982260353518`*^9, 3.657378732546425*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717837672253`*^9, 3.624286677623934*^9, 
  3.6553982260353518`*^9, 3.657378732598783*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SP"}]], "Input",
 CellChangeTimes->{{3.6166674345299253`*^9, 3.6166674360874557`*^9}}],

Cell[BoxData[
 StyleBox["\<\"SP[Length[V],V]\\n\\n\t SP returns the tensor or spin \
product(SP) of \\n\\n Length[V] qubits with the components\\n\\n specified by \
the array V.  The array V={0, 1,2,q,...}has \\n\\n a length equal to the \
number of qubits\\n\\n and the entries in the array V specify the\\n\\n \
components of the qth Pauli operator.  \\n\\n\t For example:  SP[2,{3,2}] \
returns the same 4X4 matrix as\\n\\n AF[Sigma3\[TensorProduct]Sigma2].  The \
advantage of SP is that it\\n\\n works for large dimensional matrices.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378732761303*^9},
 CellTags->"Info-7f15bd94-0ab3-4b14-8b09-75a0b385a4cb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SP", "[", 
  RowBox[{"2", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.616671517336484*^9, 3.616671518052984*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "1", "0", "0"},
     {"1", "0", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "1", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785145495*^9, 3.624286679142125*^9, 
  3.655398227410575*^9, 3.657378732837833*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SP", "[", 
   RowBox[{"4", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]}], "]"}], " ", 
  "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], "\[TensorProduct]", 
    RowBox[{"s", "[", "1", "]"}], "\[TensorProduct]", 
    RowBox[{"s", "[", "2", "]"}], "\[TensorProduct]", 
    RowBox[{"s", "[", "3", "]"}]}], "]"}], "==", 
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], ",", 
     RowBox[{"s", "[", "1", "]"}], ",", 
     RowBox[{"s", "[", "2", "]"}], ",", 
     RowBox[{"s", "[", "3", "]"}]}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"AF", "[", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], ",", 
     RowBox[{"s", "[", "1", "]"}], ",", 
     RowBox[{"s", "[", "2", "]"}], ",", 
     RowBox[{"s", "[", "3", "]"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.61666759917225*^9, {3.616667654711658*^9, 3.616667704119039*^9}, {
   3.616671512959073*^9, 3.616671513350789*^9}, {3.616671547156845*^9, 
   3.61667171139919*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6166717851567574`*^9, 3.6242866791585417`*^9, 
  3.6553982274236403`*^9, 3.6573787328999643`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", "States", "  ", "*)"}]], "Input",
 CellChangeTimes->{{3.612868130203895*^9, 3.612868132228266*^9}, {
  3.6166672375254717`*^9, 3.6166672423267813`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"sb", "=", 
  RowBox[{
   RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", 
   RowBox[{"Ket", "[", "0", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"sa", "\[Equal]", "sb"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "sa", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "sb", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}]}], "}"}], "]"}], " ", "==", 
  RowBox[{"AF", "[", "sa", "]"}]}]}], "Input",
 CellChangeTimes->{{3.612956204662084*^9, 3.612956358979048*^9}, {
   3.612956634165707*^9, 3.61295664873437*^9}, {3.612963498724348*^9, 
   3.612963500456565*^9}, {3.6129641058527927`*^9, 3.6129641302734547`*^9}, {
   3.613137190519945*^9, 3.6131372505591393`*^9}, {3.616580623237986*^9, 
   3.616580670119042*^9}, {3.6165807035048447`*^9, 3.61658078921506*^9}, {
   3.616580827405676*^9, 3.616580830137701*^9}, 3.616667147834362*^9, {
   3.616667222518607*^9, 3.616667309239479*^9}, {3.616667351369646*^9, 
   3.6166673746902122`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.6573787329627953`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.657378733000647*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.657378733036345*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.6573787330721416`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"1"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.6573787331094*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785180317*^9, 3.624286679242422*^9, 
  3.655398227454815*^9, 3.657378733146307*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"sa", "=", " ", 
   RowBox[{"TensorProduct", "[", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}]}], "]"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"sb", "=", 
  RowBox[{
   RowBox[{"Ket", "[", "1", "]"}], "\[TensorProduct]", 
   RowBox[{"Ket", "[", "0", "]"}], "\[TensorProduct]", 
   RowBox[{"Ket", "[", "0", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"sa", "\[Equal]", "sb"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "sa", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AF", "[", "sb", "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TensorProductQ", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}], ",", 
     RowBox[{"Ket", "[", "0", "]"}]}], "}"}], "]"}], " ", "==", 
  RowBox[{"AF", "[", "sa", "]"}]}]}], "Input",
 CellChangeTimes->{{3.612956204662084*^9, 3.612956358979048*^9}, {
   3.612956634165707*^9, 3.61295664873437*^9}, {3.612963498724348*^9, 
   3.612963500456565*^9}, {3.6129641058527927`*^9, 3.6129641302734547`*^9}, {
   3.613137190519945*^9, 3.6131372505591393`*^9}, {3.616580623237986*^9, 
   3.616580670119042*^9}, {3.6165807035048447`*^9, 3.61658078921506*^9}, {
   3.616580827405676*^9, 3.616580830137701*^9}, 3.616667147834362*^9, {
   3.616667222518607*^9, 3.616667309239479*^9}, {3.616667351369646*^9, 
   3.6166674060993567`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"1"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.6573787332061234`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"1"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
         {
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0"},
             {"0"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.6573787332456427`*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.657378733284389*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.657378733322761*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"0"},
     {"0"},
     {"0"},
     {"1"},
     {"0"},
     {"0"},
     {"0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.6573787333609*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.616671785212699*^9, 3.6242866793263474`*^9, 
  3.65539822750392*^9, 3.6573787333991823`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.612868130203895*^9, 3.612868132228266*^9}}]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1143, 878},
WindowMargins->{{221, Automatic}, {Automatic, 7}},
Visible->True,
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, 32000},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "export", "home", 
   "brunojd"}, "t.ps", CharacterEncoding -> "iso8859-1"]},
ShowSelection->True,
TaggingRules:>{
 "NextIndexingNumber" -> 3, 
  "IndexEntries" -> {{"i:1", "CNOT\t"}, {"i:2", "HALL"}}, 
  "PaginationCache" -> {{2005, 8, 9, 3, 36, 18.585304`8.02174465349935}, {1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5,
     5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 
    7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
     8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
    10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 
    11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 
    12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 
    13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 
    14, 14, 14}, Automatic}},
CellLabelAutoDelete->True,
InputAliases->{"intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation>" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation<" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "symb" -> RowBox[{"Symbolize", "[", 
     TagBox[
     "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"], 
     "]"}], "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        ",", "\[Placeholder]"}], "]"}], "addia" -> 
  RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[Placeholder]\"", "\[Rule]", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "pattwraper" -> 
  TagBox["\[Placeholder]", NotationPatternTag, TagStyle -> 
    "NotationPatternWrapperStyle"], "madeboxeswraper" -> 
  TagBox["\[Placeholder]", NotationMadeBoxesTag, TagStyle -> 
    "NotationMadeBoxesWrapperStyle"]},
Magnification->1,
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[557, 20, 258, 7, 97, "Title",
   CellTags->"c:1"]},
 "b:14.0"->{
  Cell[1223, 44, 86, 2, 51, "Section",
   CellTags->{"b:14.0", "c:2"}],
  Cell[1312, 48, 179, 4, 23, "Text",
   CellTags->"b:14.0"],
  Cell[1836, 68, 248, 5, 46, "Input",
   CellTags->"b:14.0"],
  Cell[2087, 75, 223, 4, 22, "Print",
   CellTags->"b:14.0"],
  Cell[2325, 82, 235, 5, 23, "Text",
   CellTags->"b:14.0"],
  Cell[2563, 89, 210, 4, 23, "Text",
   CellTags->"b:14.0"],
  Cell[2776, 95, 272, 8, 24, "Text",
   CellTags->"b:14.0"]},
 "c:2"->{
  Cell[1223, 44, 86, 2, 51, "Section",
   CellTags->{"b:14.0", "c:2"}]},
 "b:14.3"->{
  Cell[3051, 105, 194, 4, 51, "Section",
   CellTags->{"b:14.3", "Measurement", "c:18"}]},
 "Measurement"->{
  Cell[3051, 105, 194, 4, 51, "Section",
   CellTags->{"b:14.3", "Measurement", "c:18"}]},
 "c:18"->{
  Cell[3051, 105, 194, 4, 51, "Section",
   CellTags->{"b:14.3", "Measurement", "c:18"}]},
 "b:14.1"->{
  Cell[3260, 112, 1707, 37, 306, "Text",
   CellTags->"b:14.1"]},
 "Info-768aa162-e5fe-4f8e-97ea-a10a6eff4a8a"->{
  Cell[5242, 159, 785, 15, 42, "Print",
   CellTags->"Info-768aa162-e5fe-4f8e-97ea-a10a6eff4a8a"]},
 "Info-54c50a1d-0cf6-4285-b3a0-eb0c3639a251"->{
  Cell[6156, 182, 413, 6, 143, "Print",
   CellTags->"Info-54c50a1d-0cf6-4285-b3a0-eb0c3639a251"]},
 "Info-693c54f6-a34a-4498-9aef-56d5e0c7ef2c"->{
  Cell[6722, 197, 286, 5, 92, "Print",
   CellTags->"Info-693c54f6-a34a-4498-9aef-56d5e0c7ef2c"]},
 "Info-7f15bd94-0ab3-4b14-8b09-75a0b385a4cb"->{
  Cell[76317, 1995, 677, 10, 349, "Print",
   CellTags->"Info-7f15bd94-0ab3-4b14-8b09-75a0b385a4cb"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 102588, 2703},
 {"b:14.0", 102660, 2706},
 {"c:2", 103111, 2721},
 {"b:14.3", 103197, 2724},
 {"Measurement", 103306, 2727},
 {"c:18", 103408, 2730},
 {"b:14.1", 103512, 2733},
 {"Info-768aa162-e5fe-4f8e-97ea-a10a6eff4a8a", 103626, 2736},
 {"Info-54c50a1d-0cf6-4285-b3a0-eb0c3639a251", 103774, 2739},
 {"Info-693c54f6-a34a-4498-9aef-56d5e0c7ef2c", 103922, 2742},
 {"Info-7f15bd94-0ab3-4b14-8b09-75a0b385a4cb", 104069, 2745}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 258, 7, 97, "Title",
 CellTags->"c:1"],
Cell[818, 29, 43, 0, 35, "Subtitle"],
Cell[864, 31, 183, 5, 33, "Abstract"],
Cell[1050, 38, 148, 2, 22, "Text"],
Cell[CellGroupData[{
Cell[1223, 44, 86, 2, 51, "Section",
 CellTags->{"b:14.0", "c:2"}],
Cell[1312, 48, 179, 4, 23, "Text",
 CellTags->"b:14.0"],
Cell[CellGroupData[{
Cell[1516, 56, 93, 3, 46, "Input"],
Cell[1612, 61, 187, 2, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1836, 68, 248, 5, 46, "Input",
 CellTags->"b:14.0"],
Cell[2087, 75, 223, 4, 22, "Print",
 CellTags->"b:14.0"]
}, Open  ]],
Cell[2325, 82, 235, 5, 23, "Text",
 CellTags->"b:14.0"],
Cell[2563, 89, 210, 4, 23, "Text",
 CellTags->"b:14.0"],
Cell[2776, 95, 272, 8, 24, "Text",
 CellTags->"b:14.0"],
Cell[3051, 105, 194, 4, 51, "Section",
 CellTags->{"b:14.3", "Measurement", "c:18"}]
}, Open  ]],
Cell[3260, 112, 1707, 37, 306, "Text",
 CellTags->"b:14.1"],
Cell[CellGroupData[{
Cell[4992, 153, 247, 4, 45, "Input"],
Cell[5242, 159, 785, 15, 42, "Print",
 CellTags->"Info-768aa162-e5fe-4f8e-97ea-a10a6eff4a8a"],
Cell[CellGroupData[{
Cell[6052, 178, 101, 2, 45, "Input"],
Cell[6156, 182, 413, 6, 143, "Print",
 CellTags->"Info-54c50a1d-0cf6-4285-b3a0-eb0c3639a251"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6606, 193, 113, 2, 45, "Input"],
Cell[6722, 197, 286, 5, 92, "Print",
 CellTags->"Info-693c54f6-a34a-4498-9aef-56d5e0c7ef2c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7057, 208, 1247, 28, 121, "Input"],
Cell[8307, 238, 3002, 77, 96, "Output"],
Cell[11312, 317, 3002, 77, 96, "Output"],
Cell[14317, 396, 206, 5, 45, "Output"],
Cell[14526, 403, 866, 23, 94, "Output"],
Cell[15395, 428, 863, 23, 94, "Output"],
Cell[16261, 453, 206, 5, 45, "Output"],
Cell[CellGroupData[{
Cell[16492, 462, 1402, 30, 136, "Input"],
Cell[17897, 494, 13038, 319, 164, "Output"],
Cell[30938, 815, 13038, 319, 164, "Output"],
Cell[43979, 1136, 204, 5, 45, "Output"],
Cell[44186, 1143, 1222, 29, 158, "Output"],
Cell[45411, 1174, 1222, 29, 158, "Output"],
Cell[46636, 1205, 203, 5, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[46888, 1216, 859, 24, 77, "Input"],
Cell[47750, 1242, 881, 25, 62, "Output"],
Cell[48634, 1269, 881, 25, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49552, 1299, 863, 21, 151, "Input"],
Cell[50418, 1322, 204, 5, 45, "Output"],
Cell[50625, 1329, 3700, 117, 94, "Output"],
Cell[54328, 1448, 3697, 117, 94, "Output"],
Cell[58028, 1567, 204, 5, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58269, 1577, 3661, 82, 247, "Input"],
Cell[61933, 1661, 206, 5, 45, "Output"],
Cell[62142, 1668, 204, 5, 45, "Output"],
Cell[62349, 1675, 204, 5, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62590, 1685, 2845, 50, 170, "Input"],
Cell[65438, 1737, 8391, 174, 158, "Output"],
Cell[73832, 1913, 208, 5, 45, "Output"],
Cell[CellGroupData[{
Cell[74065, 1922, 1452, 42, 110, "Input"],
Cell[75520, 1966, 208, 5, 45, "Output"],
Cell[75731, 1973, 208, 5, 45, "Output"],
Cell[75942, 1980, 208, 5, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[76199, 1991, 115, 2, 45, "Input"],
Cell[76317, 1995, 677, 10, 349, "Print",
 CellTags->"Info-7f15bd94-0ab3-4b14-8b09-75a0b385a4cb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77031, 2010, 193, 5, 45, "Input"],
Cell[77227, 2017, 770, 21, 94, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78034, 2043, 1116, 30, 45, "Input"],
Cell[79153, 2075, 212, 5, 45, "Output"]
}, Open  ]],
Cell[79380, 2083, 186, 3, 46, "Input"],
Cell[CellGroupData[{
Cell[79591, 2090, 1347, 30, 121, "Input"],
Cell[80941, 2122, 1770, 47, 96, "Output"],
Cell[82714, 2171, 1768, 47, 96, "Output"],
Cell[84485, 2220, 204, 5, 45, "Output"],
Cell[84692, 2227, 712, 21, 94, "Output"],
Cell[85407, 2250, 708, 21, 94, "Output"],
Cell[86118, 2273, 204, 5, 45, "Output"],
Cell[CellGroupData[{
Cell[86347, 2282, 1489, 33, 121, "Input"],
Cell[87839, 2317, 4211, 107, 164, "Output"],
Cell[92053, 2426, 4211, 107, 164, "Output"],
Cell[96267, 2535, 205, 5, 45, "Output"],
Cell[96475, 2542, 759, 25, 158, "Output"],
Cell[97237, 2569, 757, 25, 158, "Output"],
Cell[97997, 2596, 207, 5, 45, "Output"]
}, Open  ]]
}, Open  ]],
Cell[98231, 2605, 118, 2, 45, "Input"]
}
]
*)

(* End of internal cache information *)
