(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    185565,       5580]
NotebookOptionsPosition[    173540,       5234]
NotebookOutlinePosition[    174325,       5264]
CellTagsIndexPosition[    174193,       5258]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Needs", "[", "\"\<QDENSITY`Circuits`\>\"", "]"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Needs", "[", "\"\<QDENSITY`QCWave`\>\"", "]"}], ";"}], 
  " "}]}], "Input",
 CellChangeTimes->{{3.483432390978092*^9, 3.483432400626445*^9}, {
   3.53079499934487*^9, 3.530795001544505*^9}, 3.5437525607932043`*^9, {
   3.548070897892881*^9, 3.548070916184149*^9}, {3.548070957087976*^9, 
   3.5480709578212748`*^9}, {3.548071305010578*^9, 3.548071306230961*^9}, {
   3.5480713947805653`*^9, 3.5480713956338*^9}, {3.548072099176927*^9, 
   3.548072101620358*^9}, {3.5480722624525137`*^9, 3.5480722637314672`*^9}, {
   3.548105051099502*^9, 3.548105052472144*^9}, {3.548369028268242*^9, 
   3.548369035859907*^9}, {3.548944622457534*^9, 3.548944629293009*^9}, {
   3.548947550869351*^9, 3.548947560976862*^9}, 3.549272600983625*^9},
 FontFamily->"Courier New",
 FontSize->16,
 CellTags->"b:5.0"],

Cell[BoxData["\<\"Type \\\"?intro\\\", \\\"?QDENSITY`Qdensity`*\\\" or \
\\\"?about for help.\"\>"], "Print",
 CellChangeTimes->{3.657378342118907*^9},
 CellTags->"b:5.0"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"SetOptions", "[", 
  RowBox[{"$FrontEndSession", ",", 
   RowBox[{"NotebookAutoSave", "\[Rule]", "True"}]}], "]"}], "\n", 
 RowBox[{"NotebookSave", "[", "]"}]}], "Input",
 CellChangeTimes->{{3.6431945483631763`*^9, 3.643194548365107*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<QDENSITY`BTSystem`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.548105830878007*^9, 3.548105833803213*^9}, {
   3.548105995819116*^9, 3.548105998543726*^9}, {3.548199704121345*^9, 
   3.548199705758276*^9}, {3.548349113316387*^9, 3.5483491159930687`*^9}, {
   3.548349560312273*^9, 3.548349562679538*^9}, 3.549272600984004*^9},
 FontSize->16],

Cell[BoxData["\<\"Type \\\"?introBT\\\", \\\"?QDENSITY`BTSystem`*\\\" or \
\\\"?aboutBT for help.\"\>"], "Print",
 CellChangeTimes->{3.657378342417317*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DToMR", "[", 
    RowBox[{"n_Integer", ",", "radixlist_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"b", "=", 
        RowBox[{"Reverse", "@", 
         RowBox[{"FoldList", "[", 
          RowBox[{"Times", ",", "1", ",", 
           RowBox[{"Reverse", "@", "radixlist"}]}], "]"}]}]}], ",", "rep"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rep", "=", 
       RowBox[{"Rest", "@", 
        RowBox[{"Last", "@", 
         RowBox[{"Last", "@", 
          RowBox[{"Reap", "[", 
           RowBox[{"Fold", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Sow", "[", 
                 RowBox[{"Quotient", "[", 
                  RowBox[{"#1", ",", "#2"}], "]"}], "]"}], ";", 
                RowBox[{"Mod", "[", 
                 RowBox[{"#1", ",", "#2"}], "]"}]}], ")"}], "&"}], ",", "n", 
             ",", "b"}], "]"}], "]"}]}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rep", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{"Subscript", ",", 
         RowBox[{"{", 
          RowBox[{"rep", ",", 
           RowBox[{"Take", "[", 
            RowBox[{"radixlist", ",", 
             RowBox[{"-", 
              RowBox[{"Length", "[", "rep", "]"}]}]}], "]"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "rep"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DToMR2", "[", 
    RowBox[{"n_Integer", ",", "radixlist_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"b", "=", 
        RowBox[{"Reverse", "@", 
         RowBox[{"FoldList", "[", 
          RowBox[{"Times", ",", "1", ",", 
           RowBox[{"Reverse", "@", "radixlist"}]}], "]"}]}]}], ",", "rep"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rep", "=", 
       RowBox[{"Rest", "@", 
        RowBox[{"Last", "@", 
         RowBox[{"Last", "@", 
          RowBox[{"Reap", "[", 
           RowBox[{"Fold", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Sow", "[", 
                 RowBox[{"Quotient", "[", 
                  RowBox[{"#1", ",", "#2"}], "]"}], "]"}], ";", 
                RowBox[{"Mod", "[", 
                 RowBox[{"#1", ",", "#2"}], "]"}]}], ")"}], "&"}], ",", "n", 
             ",", "b"}], "]"}], "]"}]}]}]}]}], ";", "\[IndentingNewLine]", 
      "rep"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BTbit", "[", 
   RowBox[{"is_", ",", "n_", ",", "QDv_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"DToMR", "[", 
     RowBox[{
      RowBox[{"n", "-", "1"}], ",", "QDv"}], "]"}], "[", 
    RowBox[{"[", "is", "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"strideA", "[", "QDV_", "]"}], ":=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"Most", "@", 
     RowBox[{"FoldList", "[", 
      RowBox[{"Times", ",", "1", ",", 
       RowBox[{"Reverse", "@", "QDV"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"strideBT", "[", 
    RowBox[{"is_", ",", "QDv_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"strideA", "[", "QDv", "]"}], "[", 
    RowBox[{"[", "is", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",\

 CellChangeTimes->{{3.6436516803983994`*^9, 3.643651681782177*^9}, {
  3.643652867893261*^9, 3.643652884364106*^9}, {3.64365291578592*^9, 
  3.643652916573359*^9}, {3.643725122601639*^9, 3.643725126100031*^9}, {
  3.6437251567107277`*^9, 3.6437251575442257`*^9}, {3.6437256008329763`*^9, 
  3.643725601327559*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", "T", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "1"}], ";", 
  RowBox[{"nB", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nB", "==", "0"}], ",", 
      RowBox[{"3", "^", "nT"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR2", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"BTbit", "[", 
      RowBox[{"1", ",", "i", ",", "QD"}], "]"}], "    ", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "dim"}], "}"}]}], "]"}], "\[Equal]", 
  "%"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643651178283058*^9, 3.643651194393365*^9}, {
   3.643651226951729*^9, 3.643651227401774*^9}, {3.643651263302492*^9, 
   3.643651297849867*^9}, {3.6436513982126226`*^9, 3.643651437631359*^9}, {
   3.643651500689899*^9, 3.64365150451437*^9}, 3.6436515377935534`*^9, {
   3.643724637878076*^9, 3.6437246852076902`*^9}, {3.643724755396776*^9, 
   3.643724756792165*^9}, {3.6437248031672163`*^9, 3.643724884210194*^9}, {
   3.643724917860273*^9, 3.643724928524159*^9}, {3.6437251663297*^9, 
   3.643725169885087*^9}, {3.643725465024877*^9, 3.643725488095248*^9}, {
   3.643725629272214*^9, 3.643725640117*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682517762*^9, 3.655399123774702*^9, 
  3.6573783424832706`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682517762*^9, 3.655399123774702*^9, 
  3.657378342515853*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"1"},
     {"2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682517762*^9, 3.655399123774702*^9, 
  3.657378342551906*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682517762*^9, 3.655399123774702*^9, 
  3.657378342589446*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682517762*^9, 3.655399123774702*^9, 
  3.657378342627109*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"T", ",", "T"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "2"}], ";", 
  RowBox[{"nB", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nB", "==", "0"}], ",", 
      RowBox[{"3", "^", "nT"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR2", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"BTbit", "[", 
       RowBox[{"1", ",", "i", ",", "QD"}], "]"}], ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"2", ",", "i", ",", "QD"}], "]"}]}], "    ", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "dim"}], "}"}]}], "]"}], "\[Equal]", 
  "%"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"2", ",", "QD"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643651178283058*^9, 3.643651194393365*^9}, {
   3.643651226951729*^9, 3.643651227401774*^9}, {3.643651263302492*^9, 
   3.643651297849867*^9}, {3.6436513982126226`*^9, 3.643651437631359*^9}, {
   3.643651500689899*^9, 3.64365150451437*^9}, 3.6436515377935534`*^9, {
   3.643724637878076*^9, 3.6437246852076902`*^9}, {3.643724755396776*^9, 
   3.643724756792165*^9}, {3.6437248031672163`*^9, 3.643724884210194*^9}, {
   3.643724917860273*^9, 3.64372495555832*^9}, {3.643724992314299*^9, 
   3.643725088885042*^9}, {3.643725195389884*^9, 3.6437251987304573`*^9}, {
   3.64372542952744*^9, 3.6437254395619793`*^9}, {3.643725657769669*^9, 
   3.643725669299616*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.657378342697028*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["2", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.657378342730791*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0"},
     {"0", "1"},
     {"0", "2"},
     {"1", "0"},
     {"1", "1"},
     {"1", "2"},
     {"2", "0"},
     {"2", "1"},
     {"2", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.657378342780794*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.6573783428318996`*^9}],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.657378342884329*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606826707573`*^9, 3.655399124024769*^9, 
  3.6573783429217043`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"T", ",", "B", ",", "B", ",", "T"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"QD", "=", 
  RowBox[{"QA", " ", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"B", "->", "2"}], ",", 
     RowBox[{"T", "->", "3"}]}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "2"}], ";", 
  RowBox[{"nB", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nB", "==", "0"}], ",", 
      RowBox[{"3", "^", "nT"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR2", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"BTbit", "[", 
       RowBox[{"1", ",", "i", ",", "QD"}], "]"}], ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"2", ",", "i", ",", "QD"}], "]"}], " ", ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"3", ",", "i", ",", "QD"}], "]"}], ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"4", ",", "i", ",", "QD"}], "]"}]}], "   ", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "dim"}], "}"}]}], "]"}], "\[Equal]", 
  "%"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"2", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"3", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"strideBT", "[", 
   RowBox[{"4", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643651178283058*^9, 3.643651194393365*^9}, {
   3.643651226951729*^9, 3.643651227401774*^9}, {3.643651263302492*^9, 
   3.643651297849867*^9}, {3.6436513982126226`*^9, 3.643651437631359*^9}, {
   3.643651500689899*^9, 3.64365150451437*^9}, 3.6436515377935534`*^9, {
   3.643724708192128*^9, 3.643724751316001*^9}, {3.643725233495945*^9, 
   3.643725262339498*^9}, {3.643725312391233*^9, 3.643725354814692*^9}, {
   3.643725401381678*^9, 3.6437254190744743`*^9}, {3.64372569867591*^9, 
   3.643725715852529*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"},
      {"B"},
      {"B"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.657378343009616*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"3"},
      {"2"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.657378343044582*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.657378343083624*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "0", "2"},
     {"0", "0", "1", "0"},
     {"0", "0", "1", "1"},
     {"0", "0", "1", "2"},
     {"0", "1", "0", "0"},
     {"0", "1", "0", "1"},
     {"0", "1", "0", "2"},
     {"0", "1", "1", "0"},
     {"0", "1", "1", "1"},
     {"0", "1", "1", "2"},
     {"1", "0", "0", "0"},
     {"1", "0", "0", "1"},
     {"1", "0", "0", "2"},
     {"1", "0", "1", "0"},
     {"1", "0", "1", "1"},
     {"1", "0", "1", "2"},
     {"1", "1", "0", "0"},
     {"1", "1", "0", "1"},
     {"1", "1", "0", "2"},
     {"1", "1", "1", "0"},
     {"1", "1", "1", "1"},
     {"1", "1", "1", "2"},
     {"2", "0", "0", "0"},
     {"2", "0", "0", "1"},
     {"2", "0", "0", "2"},
     {"2", "0", "1", "0"},
     {"2", "0", "1", "1"},
     {"2", "0", "1", "2"},
     {"2", "1", "0", "0"},
     {"2", "1", "0", "1"},
     {"2", "1", "0", "2"},
     {"2", "1", "1", "0"},
     {"2", "1", "1", "1"},
     {"2", "1", "1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.657378343123611*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.6573783431623707`*^9}],

Cell[BoxData[
 TagBox["12",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.6573783432050858`*^9}],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.6573783432452297`*^9}],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.6573783432840357`*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760682871621*^9, 3.655399124318635*^9, 
  3.657378343323728*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "T", ",", "B", ",", "T"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"QD", "=", 
  RowBox[{"QA", " ", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"B", "->", "2"}], ",", 
     RowBox[{"T", "->", "3"}]}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "2"}], ";", 
  RowBox[{"nB", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nB", "==", "0"}], ",", 
      RowBox[{"3", "^", "nT"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"DToMR2", "[", 
    RowBox[{"i", ",", "QD"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"BTbit", "[", 
       RowBox[{"1", ",", "i", ",", "QD"}], "]"}], ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"2", ",", "i", ",", "QD"}], "]"}], " ", ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"3", ",", "i", ",", "QD"}], "]"}], ",", 
      RowBox[{"BTbit", "[", 
       RowBox[{"4", ",", "i", ",", "QD"}], "]"}]}], "   ", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "dim"}], "}"}]}], "]"}], "\[Equal]", 
  "%"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"2", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"strideBT", "[", 
  RowBox[{"3", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"strideBT", "[", 
   RowBox[{"4", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643651178283058*^9, 3.643651194393365*^9}, {
   3.643651226951729*^9, 3.643651227401774*^9}, {3.643651263302492*^9, 
   3.643651297849867*^9}, {3.6436513982126226`*^9, 3.643651437631359*^9}, {
   3.643651500689899*^9, 3.64365150451437*^9}, 3.6436515377935534`*^9, {
   3.643724708192128*^9, 3.643724751316001*^9}, {3.643725233495945*^9, 
   3.643725262339498*^9}, {3.643725312391233*^9, 3.643725354814692*^9}, {
   3.643725401381678*^9, 3.6437254190744743`*^9}, {3.64372569867591*^9, 
   3.643725746858078*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"T"},
      {"B"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.6573783434585857`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"2"},
      {"3"},
      {"2"},
      {"3"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.657378343502551*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["0", "2"], 
      SubscriptBox["2", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["0", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["1", "3"]},
     {
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"], 
      SubscriptBox["1", "2"], 
      SubscriptBox["2", "3"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.657378343543729*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {"0", "0", "0", "1"},
     {"0", "0", "0", "2"},
     {"0", "0", "1", "0"},
     {"0", "0", "1", "1"},
     {"0", "0", "1", "2"},
     {"0", "1", "0", "0"},
     {"0", "1", "0", "1"},
     {"0", "1", "0", "2"},
     {"0", "1", "1", "0"},
     {"0", "1", "1", "1"},
     {"0", "1", "1", "2"},
     {"0", "2", "0", "0"},
     {"0", "2", "0", "1"},
     {"0", "2", "0", "2"},
     {"0", "2", "1", "0"},
     {"0", "2", "1", "1"},
     {"0", "2", "1", "2"},
     {"1", "0", "0", "0"},
     {"1", "0", "0", "1"},
     {"1", "0", "0", "2"},
     {"1", "0", "1", "0"},
     {"1", "0", "1", "1"},
     {"1", "0", "1", "2"},
     {"1", "1", "0", "0"},
     {"1", "1", "0", "1"},
     {"1", "1", "0", "2"},
     {"1", "1", "1", "0"},
     {"1", "1", "1", "1"},
     {"1", "1", "1", "2"},
     {"1", "2", "0", "0"},
     {"1", "2", "0", "1"},
     {"1", "2", "0", "2"},
     {"1", "2", "1", "0"},
     {"1", "2", "1", "1"},
     {"1", "2", "1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.657378343585642*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.65737834362703*^9}],

Cell[BoxData[
 TagBox["18",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.65737834366706*^9}],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.6573783437087317`*^9}],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.657378343750969*^9}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606831891203`*^9, 3.6553991248681393`*^9, 
  3.657378343792536*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vec", "[", 
   RowBox[{"is_", ",", "QDv_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"KroneckerDelta", "[", 
     RowBox[{"i", ",", "is"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "QDv", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"str", "[", 
   RowBox[{"is_", ",", "QDv_"}], "]"}], ":=", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"DToMR2", "[", 
         RowBox[{"j", ",", "QDv"}], "]"}], "-", 
        RowBox[{"DToMR2", "[", 
         RowBox[{"0", ",", "QDv"}], "]"}]}], "\[Equal]", 
       RowBox[{"vec", "[", 
        RowBox[{"is", ",", "QDv"}], "]"}]}], ",", 
      RowBox[{"Print", "[", "j", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6437575974006968`*^9, 3.643757611755238*^9}, 
   3.6437577869542217`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"is", "=", "1"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"is", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"DToMR2", "[", 
        RowBox[{"j", ",", "QD"}], "]"}], "-", 
       RowBox[{"DToMR2", "[", 
        RowBox[{"i", ",", "QD"}], "]"}]}], "\[Equal]", 
      RowBox[{"vec", "[", 
       RowBox[{"is", ",", "QD"}], "]"}]}], ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<i=  \>\"", ",", "i", ",", "\"\<    \>\"", ",", "\"\<j=  \>\"", ",",
        "j"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.643727385822547*^9, 3.643727426221964*^9}, {
  3.643757630915702*^9, 3.643757644819969*^9}, {3.6437578004768343`*^9, 
  3.643757838590282*^9}}],

Cell[BoxData[
 TagBox["1",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760683532462*^9, 3.655399125316881*^9, 
  3.6573783438655357`*^9}],

Cell[CellGroupData[{

Cell[BoxData["18"], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.65737834390084*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "18"}],
  SequenceForm["i=  ", 0, "    ", "j=  ", 18],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.65737834395497*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "19"}],
  SequenceForm["i=  ", 1, "    ", "j=  ", 19],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.6573783440110073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "20"}],
  SequenceForm["i=  ", 2, "    ", "j=  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344067039*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "21"}],
  SequenceForm["i=  ", 3, "    ", "j=  ", 21],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344123478*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "22"}],
  SequenceForm["i=  ", 4, "    ", "j=  ", 22],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.65737834417505*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "23"}],
  SequenceForm["i=  ", 5, "    ", "j=  ", 23],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344218782*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "24"}],
  SequenceForm["i=  ", 6, "    ", "j=  ", 24],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344262917*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "25"}],
  SequenceForm["i=  ", 7, "    ", "j=  ", 25],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344308301*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "26"}],
  SequenceForm["i=  ", 8, "    ", "j=  ", 26],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344381391*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "27"}],
  SequenceForm["i=  ", 9, "    ", "j=  ", 27],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344426393*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "28"}],
  SequenceForm["i=  ", 10, "    ", "j=  ", 28],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344469494*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "29"}],
  SequenceForm["i=  ", 11, "    ", "j=  ", 29],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.6573783445144978`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "30"}],
  SequenceForm["i=  ", 12, "    ", "j=  ", 30],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.6573783445599127`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "13", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "31"}],
  SequenceForm["i=  ", 13, "    ", "j=  ", 31],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.65737834460527*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "14", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "32"}],
  SequenceForm["i=  ", 14, "    ", "j=  ", 32],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344649767*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "15", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "33"}],
  SequenceForm["i=  ", 15, "    ", "j=  ", 33],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344695429*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "34"}],
  SequenceForm["i=  ", 16, "    ", "j=  ", 34],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344741152*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "17", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "35"}],
  SequenceForm["i=  ", 17, "    ", "j=  ", 35],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760683566958*^9, 3.655399125358691*^9, 
  3.657378344789445*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"is", "=", "2"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"is", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"DToMR2", "[", 
        RowBox[{"j", ",", "QD"}], "]"}], "-", 
       RowBox[{"DToMR2", "[", 
        RowBox[{"i", ",", "QD"}], "]"}]}], "\[Equal]", 
      RowBox[{"vec", "[", 
       RowBox[{"is", ",", "QD"}], "]"}]}], ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<i=  \>\"", ",", "i", ",", "\"\<    \>\"", ",", "\"\<j=  \>\"", ",",
        "j"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.643757925407929*^9, 3.6437579256323137`*^9}}],

Cell[BoxData[
 TagBox["2",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760684361232*^9, 3.655399126302943*^9, 
  3.657378344928239*^9}],

Cell[CellGroupData[{

Cell[BoxData["6"], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378344974169*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "6"}],
  SequenceForm["i=  ", 0, "    ", "j=  ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345014658*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "7"}],
  SequenceForm["i=  ", 1, "    ", "j=  ", 7],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345058694*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "8"}],
  SequenceForm["i=  ", 2, "    ", "j=  ", 8],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345104257*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "9"}],
  SequenceForm["i=  ", 3, "    ", "j=  ", 9],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345148707*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "10"}],
  SequenceForm["i=  ", 4, "    ", "j=  ", 10],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.65737834519394*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "11"}],
  SequenceForm["i=  ", 5, "    ", "j=  ", 11],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345239511*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "12"}],
  SequenceForm["i=  ", 6, "    ", "j=  ", 12],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345286985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "13"}],
  SequenceForm["i=  ", 7, "    ", "j=  ", 13],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345332424*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["i=  ", 8, "    ", "j=  ", 14],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.6573783454046383`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "15"}],
  SequenceForm["i=  ", 9, "    ", "j=  ", 15],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345451352*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "16"}],
  SequenceForm["i=  ", 10, "    ", "j=  ", 16],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345497553*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "17"}],
  SequenceForm["i=  ", 11, "    ", "j=  ", 17],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345543178*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "18", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "24"}],
  SequenceForm["i=  ", 18, "    ", "j=  ", 24],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345596685*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "19", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "25"}],
  SequenceForm["i=  ", 19, "    ", "j=  ", 25],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.6573783456473513`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "20", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "26"}],
  SequenceForm["i=  ", 20, "    ", "j=  ", 26],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345692169*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "27"}],
  SequenceForm["i=  ", 21, "    ", "j=  ", 27],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345738303*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "22", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "28"}],
  SequenceForm["i=  ", 22, "    ", "j=  ", 28],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378345786148*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "23", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "29"}],
  SequenceForm["i=  ", 23, "    ", "j=  ", 29],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.65737834583384*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "24", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "30"}],
  SequenceForm["i=  ", 24, "    ", "j=  ", 30],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.6573783459209433`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "25", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "31"}],
  SequenceForm["i=  ", 25, "    ", "j=  ", 31],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.6573783459747763`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "26", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "32"}],
  SequenceForm["i=  ", 26, "    ", "j=  ", 32],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378346021462*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "27", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "33"}],
  SequenceForm["i=  ", 27, "    ", "j=  ", 33],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.65737834607027*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "28", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "34"}],
  SequenceForm["i=  ", 28, "    ", "j=  ", 34],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.657378346122086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "29", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "35"}],
  SequenceForm["i=  ", 29, "    ", "j=  ", 35],
  Editable->False]], "Print",
 CellChangeTimes->{3.64376068439692*^9, 3.655399126348673*^9, 
  3.6573783461702747`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"is", "=", "3"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"is", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"DToMR2", "[", 
        RowBox[{"j", ",", "QD"}], "]"}], "-", 
       RowBox[{"DToMR2", "[", 
        RowBox[{"i", ",", "QD"}], "]"}]}], "\[Equal]", 
      RowBox[{"vec", "[", 
       RowBox[{"is", ",", "QD"}], "]"}]}], ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<i=  \>\"", ",", "i", ",", "\"\<    \>\"", ",", "\"\<j=  \>\"", ",",
        "j"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.643757929524871*^9, 3.6437579300312157`*^9}}],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606854492826`*^9, 3.655399127725102*^9, 
  3.657378346275363*^9}],

Cell[CellGroupData[{

Cell[BoxData["3"], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346318849*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "3"}],
  SequenceForm["i=  ", 0, "    ", "j=  ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346364644*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["i=  ", 1, "    ", "j=  ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346411213*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "5"}],
  SequenceForm["i=  ", 2, "    ", "j=  ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346458152*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "9"}],
  SequenceForm["i=  ", 6, "    ", "j=  ", 9],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.6573783465047293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "10"}],
  SequenceForm["i=  ", 7, "    ", "j=  ", 10],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346551984*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "11"}],
  SequenceForm["i=  ", 8, "    ", "j=  ", 11],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346598928*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "15"}],
  SequenceForm["i=  ", 12, "    ", "j=  ", 15],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346647029*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "13", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "16"}],
  SequenceForm["i=  ", 13, "    ", "j=  ", 16],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346693801*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "14", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "17"}],
  SequenceForm["i=  ", 14, "    ", "j=  ", 17],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.6573783467712603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "18", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "21"}],
  SequenceForm["i=  ", 18, "    ", "j=  ", 21],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346820695*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "19", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "22"}],
  SequenceForm["i=  ", 19, "    ", "j=  ", 22],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346870332*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "20", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "23"}],
  SequenceForm["i=  ", 20, "    ", "j=  ", 23],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378346918241*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "24", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "27"}],
  SequenceForm["i=  ", 24, "    ", "j=  ", 27],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.6573783469675617`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "25", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "28"}],
  SequenceForm["i=  ", 25, "    ", "j=  ", 28],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378347016214*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "26", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "29"}],
  SequenceForm["i=  ", 26, "    ", "j=  ", 29],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.6573783470651627`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "30", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "33"}],
  SequenceForm["i=  ", 30, "    ", "j=  ", 33],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378347113831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "31", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "34"}],
  SequenceForm["i=  ", 31, "    ", "j=  ", 34],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378347163495*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "32", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "35"}],
  SequenceForm["i=  ", 32, "    ", "j=  ", 35],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760685489707*^9, 3.655399127769994*^9, 
  3.657378347213511*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"is", "=", "4"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"is", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"DToMR2", "[", 
        RowBox[{"j", ",", "QD"}], "]"}], "-", 
       RowBox[{"DToMR2", "[", 
        RowBox[{"i", ",", "QD"}], "]"}]}], "\[Equal]", 
      RowBox[{"vec", "[", 
       RowBox[{"is", ",", "QD"}], "]"}]}], ",", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<i=  \>\"", ",", "i", ",", "\"\<    \>\"", ",", "\"\<j=  \>\"", ",",
        "j"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.643757933124998*^9, 3.643757933867536*^9}}],

Cell[BoxData[
 TagBox["4",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760686345846*^9, 3.655399128874724*^9, 
  3.657378347359149*^9}],

Cell[CellGroupData[{

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347413571*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "1"}],
  SequenceForm["i=  ", 0, "    ", "j=  ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347459731*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "2"}],
  SequenceForm["i=  ", 1, "    ", "j=  ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783475069113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "4"}],
  SequenceForm["i=  ", 3, "    ", "j=  ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783475558243`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "5"}],
  SequenceForm["i=  ", 4, "    ", "j=  ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347604856*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "7"}],
  SequenceForm["i=  ", 6, "    ", "j=  ", 7],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347653276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "8"}],
  SequenceForm["i=  ", 7, "    ", "j=  ", 8],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347702352*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "10"}],
  SequenceForm["i=  ", 9, "    ", "j=  ", 10],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347751801*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "11"}],
  SequenceForm["i=  ", 10, "    ", "j=  ", 11],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347800432*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "13"}],
  SequenceForm["i=  ", 12, "    ", "j=  ", 13],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347874344*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "13", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["i=  ", 13, "    ", "j=  ", 14],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.65737834792472*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "15", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "16"}],
  SequenceForm["i=  ", 15, "    ", "j=  ", 16],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378347975211*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "17"}],
  SequenceForm["i=  ", 16, "    ", "j=  ", 17],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348024581*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "18", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "19"}],
  SequenceForm["i=  ", 18, "    ", "j=  ", 19],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348073902*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "19", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "20"}],
  SequenceForm["i=  ", 19, "    ", "j=  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348124373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "22"}],
  SequenceForm["i=  ", 21, "    ", "j=  ", 22],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348175379*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "22", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "23"}],
  SequenceForm["i=  ", 22, "    ", "j=  ", 23],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348232004*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "24", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "25"}],
  SequenceForm["i=  ", 24, "    ", "j=  ", 25],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348283839*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "25", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "26"}],
  SequenceForm["i=  ", 25, "    ", "j=  ", 26],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783483402643`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "27", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "28"}],
  SequenceForm["i=  ", 27, "    ", "j=  ", 28],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783484394073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "28", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "29"}],
  SequenceForm["i=  ", 28, "    ", "j=  ", 29],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348490066*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "30", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "31"}],
  SequenceForm["i=  ", 30, "    ", "j=  ", 31],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348542815*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "31", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "32"}],
  SequenceForm["i=  ", 31, "    ", "j=  ", 32],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783485952*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "33", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "34"}],
  SequenceForm["i=  ", 33, "    ", "j=  ", 34],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.657378348647011*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=  \"\>", "\[InvisibleSpace]", "34", 
   "\[InvisibleSpace]", "\<\"    \"\>", "\[InvisibleSpace]", "\<\"j=  \"\>", 
   "\[InvisibleSpace]", "35"}],
  SequenceForm["i=  ", 34, "    ", "j=  ", 35],
  Editable->False]], "Print",
 CellChangeTimes->{3.643760686389502*^9, 3.65539912892635*^9, 
  3.6573783486986647`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"QA", "=", 
   RowBox[{"{", 
    RowBox[{"B", ",", "B"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "0"}], ";", 
  RowBox[{"nB", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{"dim", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"nB", "==", "0"}], ",", 
     RowBox[{"3", "^", "nT"}], " ", ",", 
     RowBox[{
      RowBox[{"2", "^", "nB"}], " ", 
      RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", "dim", "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"str", "[", 
   RowBox[{"2", ",", "QD"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643729167130925*^9, 3.6437291755452757`*^9}, {
   3.6437292216068296`*^9, 3.643729221997126*^9}, {3.643729263028637*^9, 
   3.6437292740642567`*^9}, {3.643729308331234*^9, 3.643729358877388*^9}, {
   3.643729899154829*^9, 3.64372992724642*^9}, {3.643730019092045*^9, 
   3.643730073892129*^9}, {3.64373011326819*^9, 3.643730113975968*^9}, {
   3.643730151576787*^9, 3.6437302175555553`*^9}, 3.643730294708679*^9}],

Cell[BoxData[
 TagBox["4",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760687651905*^9, 3.6553991303742857`*^9, 
  3.657378348825294*^9}],

Cell[CellGroupData[{

Cell[BoxData["2"], "Print",
 CellChangeTimes->{3.6437606876997766`*^9, 3.655399130425727*^9, 
  3.657378348872979*^9}],

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.6437606876997766`*^9, 3.655399130425727*^9, 
  3.6573783489223833`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"QA", "=", 
   RowBox[{"{", 
    RowBox[{"T", ",", "T"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "2"}], ";", 
  RowBox[{"nB", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{"dim", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"nB", "==", "0"}], ",", 
     RowBox[{"3", "^", "nT"}], " ", ",", 
     RowBox[{
      RowBox[{"2", "^", "nB"}], " ", 
      RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", "dim", "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"str", "[", 
   RowBox[{"2", ",", "QD"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643729167130925*^9, 3.6437291755452757`*^9}, {
   3.6437292216068296`*^9, 3.643729221997126*^9}, {3.643729263028637*^9, 
   3.6437292740642567`*^9}, {3.643729308331234*^9, 3.643729358877388*^9}, {
   3.643729899154829*^9, 3.64372992724642*^9}, {3.643730019092045*^9, 
   3.643730073892129*^9}, {3.64373011326819*^9, 3.643730113975968*^9}, {
   3.643730151576787*^9, 3.643730239705463*^9}, 3.6437302902088747`*^9}],

Cell[BoxData[
 TagBox["9",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606878106947`*^9, 3.655399130563588*^9, 
  3.6573783490028*^9}],

Cell[CellGroupData[{

Cell[BoxData["3"], "Print",
 CellChangeTimes->{3.643760687859086*^9, 3.655399130614284*^9, 
  3.657378349051482*^9}],

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.643760687859086*^9, 3.655399130614284*^9, 
  3.657378349102386*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"QA", "=", 
   RowBox[{"{", 
    RowBox[{"B", ",", "T"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "1"}], ";", 
  RowBox[{"nB", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{"dim", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"nB", "==", "0"}], ",", 
     RowBox[{"3", "^", "nT"}], " ", ",", 
     RowBox[{
      RowBox[{"2", "^", "nB"}], " ", 
      RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", "dim", "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"str", "[", 
   RowBox[{"2", ",", "QD"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643729167130925*^9, 3.6437291755452757`*^9}, {
  3.6437292216068296`*^9, 3.643729221997126*^9}, {3.643729263028637*^9, 
  3.6437292740642567`*^9}, {3.643729308331234*^9, 3.643729358877388*^9}, {
  3.643729899154829*^9, 3.64372992724642*^9}, {3.643730019092045*^9, 
  3.643730073892129*^9}, {3.64373011326819*^9, 3.643730113975968*^9}, {
  3.643730151576787*^9, 3.64373028443777*^9}}],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.64376068797756*^9, 3.6553991307466507`*^9, 
  3.6573783492190523`*^9}],

Cell[CellGroupData[{

Cell[BoxData["3"], "Print",
 CellChangeTimes->{3.643760688024619*^9, 3.655399130803055*^9, 
  3.657378349268715*^9}],

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.643760688024619*^9, 3.655399130803055*^9, 
  3.657378349318879*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"QA", "=", 
   RowBox[{"{", 
    RowBox[{"T", ",", "B"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nT", "=", "1"}], ";", 
  RowBox[{"nB", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dim", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"nT", "==", "0"}], ",", 
      RowBox[{"2", "^", "nB"}], " ", ",", 
      RowBox[{
       RowBox[{"2", "^", "nB"}], " ", 
       RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{"dim", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"nB", "==", "0"}], ",", 
     RowBox[{"3", "^", "nT"}], " ", ",", 
     RowBox[{
      RowBox[{"2", "^", "nB"}], " ", 
      RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", "dim", "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"2", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"i", ",", "QD"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"dim", "-", "1"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643729167130925*^9, 3.6437291755452757`*^9}, {
  3.6437292216068296`*^9, 3.643729221997126*^9}, {3.643729263028637*^9, 
  3.6437292740642567`*^9}, {3.643729308331234*^9, 3.643729358877388*^9}, {
  3.643729899154829*^9, 3.64372992724642*^9}, {3.643730019092045*^9, 
  3.643730073892129*^9}, {3.64373011326819*^9, 3.643730113975968*^9}, {
  3.643730151576787*^9, 3.64373028443777*^9}, {3.643730318524444*^9, 
  3.643730323383609*^9}, {3.643758795281258*^9, 3.643758890815509*^9}, {
  3.643758938234838*^9, 3.6437589910877867`*^9}}],

Cell[BoxData[
 TagBox["6",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688143333*^9, 3.6553991309322863`*^9, 
  3.657378349436043*^9}],

Cell[CellGroupData[{

Cell[BoxData["2"], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.6573783494853477`*^9}],

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.657378349537051*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.657378349590103*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.65737834964392*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.657378349697228*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.6573783497507687`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.657378349805181*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.643760688193766*^9, 3.655399130982048*^9, 
  3.6573783498601837`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.64372844339712*^9, 3.643728503598941*^9}, 
   3.643729568379819*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"str", "[", 
  RowBox[{"1", ",", "QD"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"str", "[", 
  RowBox[{"2", ",", "QD"}], "]"}]}], "Input",
 CellChangeTimes->{{3.643758258609252*^9, 3.643758259288446*^9}, {
  3.643758495217814*^9, 3.643758501312323*^9}, {3.643758617853468*^9, 
  3.64375862131715*^9}}],

Cell[CellGroupData[{

Cell[BoxData["2"], "Print",
 CellChangeTimes->{3.643760688643456*^9, 3.655399131460576*^9, 
  3.65737835009352*^9}],

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.643760688643456*^9, 3.655399131460576*^9, 
  3.657378350151663*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"2", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"0", ",", "QD"}], "]"}]}], "==", 
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"3", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"1", ",", "QD"}], "]"}]}], "==", 
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"4", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"2", ",", "QD"}], "]"}]}], "==", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"5", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"3", ",", "QD"}], "]"}]}], "==", 
   RowBox[{"vec", "[", 
    RowBox[{"1", ",", "QD"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"1", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"0", ",", "QD"}], "]"}]}], "==", 
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"3", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"2", ",", "QD"}], "]"}]}], "==", 
   RowBox[{
    RowBox[{"DToMR2", "[", 
     RowBox[{"5", ",", "QD"}], "]"}], "-", 
    RowBox[{"DToMR2", "[", 
     RowBox[{"4", ",", "QD"}], "]"}]}], "==", 
   RowBox[{"vec", "[", 
    RowBox[{"2", ",", "QD"}], "]"}]}], " ", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643758321988228*^9, 3.643758345678035*^9}, {
  3.643758381466552*^9, 3.643758402918825*^9}, {3.6437585101114264`*^9, 
  3.64375854585251*^9}, {3.643758576002861*^9, 3.643758592652041*^9}, {
  3.643758633705029*^9, 3.643758685613648*^9}, {3.643758716136324*^9, 
  3.643758755306118*^9}, {3.643759029394473*^9, 3.6437591228139763`*^9}, {
  3.643759155631219*^9, 3.643759204782597*^9}, {3.6437592800252123`*^9, 
  3.643759303592555*^9}, {3.643759382849573*^9, 3.64375939728327*^9}, {
  3.643759586151778*^9, 3.643759621759568*^9}, {3.64375993654734*^9, 
  3.6437600697044983`*^9}}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688812418*^9, 3.65539913159872*^9, 
  3.657378350237981*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688812418*^9, 3.65539913159872*^9, 
  3.657378350289682*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.6437596362936*^9, 3.6437596410843678`*^9}, {
   3.6437596779876204`*^9, 3.64375968168745*^9}, 3.643759933446187*^9}],

Cell[BoxData[
 RowBox[{"Clear", "[", "PartnerBT1", "]"}]], "Input",
 CellChangeTimes->{{3.643582945357305*^9, 3.643582955003558*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA3_", ",", "  ", "isBT_"}], "]"}], " ", ":=", "\n", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"QDx", ",", "nB", ",", "nT", ",", "nf3", ",", 
       RowBox[{"jpBT", "=", "isBT"}], ",", "strideA", ",", "strideBT", ",", 
       "tempBT", ",", "npBT", ",", "yp1BT", ",", "dimBT"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"QDx", " ", "=", 
       RowBox[{"QA3", " ", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"B", "->", "2"}], ",", 
          RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";", "\n", 
      RowBox[{"nB", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"Cases", "[", 
         RowBox[{"QA3", ",", "B"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"nT", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"Cases", "[", 
         RowBox[{"QA3", ",", "T"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"nf3", "=", 
       RowBox[{"Length", "[", "QA3", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dimBT", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"nT", "==", "0"}], ",", 
         RowBox[{"2", "^", "nB"}], " ", ",", 
         RowBox[{
          RowBox[{"2", "^", "nB"}], " ", 
          RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], " ", ";", "  ", "\n", 
      "       ", 
      RowBox[{"dimBT", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"nB", "==", "0"}], ",", 
         RowBox[{"3", "^", "nT"}], " ", ",", 
         RowBox[{
          RowBox[{"2", "^", "nB"}], " ", 
          RowBox[{"3", "^", "nT"}]}]}], "   ", "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"strideA", "[", "QDV_", "]"}], ":=", 
       RowBox[{"Reverse", "@", 
        RowBox[{"Most", "@", 
         RowBox[{"FoldList", "[", 
          RowBox[{"Times", ",", "1", ",", 
           RowBox[{"Reverse", "@", "QDV"}]}], "]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"strideBT", "[", 
        RowBox[{"is_", ",", "QDv_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"strideA", "[", "QDv", "]"}], "[", 
        RowBox[{"[", "is", "]"}], "]"}]}], ";", 
      RowBox[{"tempBT", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"BTbit", "[", 
            RowBox[{"jpBT", ",", "npBT", ",", "QDx"}], "]"}], "==", "0"}], 
          ",", "\[IndentingNewLine]", "       ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"QDx", "[", 
              RowBox[{"[", "jpBT", "]"}], "]"}], "\[Equal]", "2"}], ",", " ", 
            
            RowBox[{"tempBT", "=", 
             RowBox[{"{", 
              RowBox[{"tempBT", ",", 
               RowBox[{"{", 
                RowBox[{"npBT", ",", 
                 RowBox[{"npBT", "+", 
                  RowBox[{"strideBT", "[", 
                   RowBox[{"jpBT", ",", "QDx"}], "]"}]}]}], "}"}]}], "}"}]}], 
            ",", "\[IndentingNewLine]", "      ", 
            RowBox[{"tempBT", "=", 
             RowBox[{"{", 
              RowBox[{"tempBT", ",", 
               RowBox[{"{", 
                RowBox[{"npBT", ",", 
                 RowBox[{"npBT", "+", 
                  RowBox[{"strideBT", "[", 
                   RowBox[{"jpBT", ",", "QDx"}], "]"}]}], " ", ",", " ", 
                 RowBox[{"npBT", "+", 
                  RowBox[{"2", "*", 
                   RowBox[{"strideBT", "[", 
                    RowBox[{"jpBT", ",", "QDx"}], "]"}]}]}]}], "}"}]}], 
              "}"}]}]}], "]"}], ","}], "        ", "\[IndentingNewLine]", 
         "   ", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"npBT", ",", "1", ",", "dimBT"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Flatten", "[", "tempBT", "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"is_", ",", "icase_", ",", "ip1_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"QD", "[", 
        RowBox[{"[", "is", "]"}], "]"}], "\[Equal]", "2"}], ",", 
      RowBox[{
       RowBox[{"PartnerBT1", "[", 
        RowBox[{"QA", ",", "is"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"2", "*", "icase"}], "-", "1", "+", "ip1", "-", "1"}], "]"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PartnerBT1", "[", 
        RowBox[{"QA", ",", "is"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"3", "*", "icase"}], "-", "2", "+", "ip1", "-", "1"}], "]"}],
        "]"}]}], "  ", "]"}]}], ";"}], " "}]}], "Input",
 CellChangeTimes->{{3.643540939040204*^9, 3.643540963294571*^9}, {
   3.6435410616452312`*^9, 3.643541140327099*^9}, {3.643541185452771*^9, 
   3.6435412182108517`*^9}, 3.643541259938171*^9, {3.6435413013611717`*^9, 
   3.643541313185014*^9}, {3.643541350917616*^9, 3.6435413990001593`*^9}, {
   3.64354154779641*^9, 3.643541559685855*^9}, {3.643541594775214*^9, 
   3.643541614225683*^9}, {3.643541745582499*^9, 3.643541748620298*^9}, {
   3.643541780537059*^9, 3.643541814388089*^9}, {3.6435418935662394`*^9, 
   3.6435419396034527`*^9}, {3.643541986278379*^9, 3.643542123293376*^9}, 
   3.643542187914989*^9, {3.6435422486651382`*^9, 3.643542258958415*^9}, 
   3.643542318044488*^9, 3.6435423538538857`*^9, {3.643542389516489*^9, 
   3.643542429678275*^9}, {3.643542581432406*^9, 3.64354258820259*^9}, {
   3.643542618691368*^9, 3.6435426194898*^9}, {3.643542789963018*^9, 
   3.643542922409067*^9}, {3.643543193077693*^9, 3.6435432162074327`*^9}, {
   3.6435432623788147`*^9, 3.6435432820208282`*^9}, 3.643543489024466*^9, {
   3.643543559112473*^9, 3.643543579406807*^9}, {3.643543631507021*^9, 
   3.6435436331816893`*^9}, {3.643543684607409*^9, 3.643543688836618*^9}, {
   3.643543827022354*^9, 3.643543840296836*^9}, {3.643580723611177*^9, 
   3.64358073133108*^9}, {3.643580775462893*^9, 3.643580822285263*^9}, {
   3.6435808851532297`*^9, 3.6435808909449377`*^9}, {3.6435809735430593`*^9, 
   3.643581037050673*^9}, {3.6435810920631866`*^9, 3.64358109533685*^9}, {
   3.643581131754424*^9, 3.6435811432969418`*^9}, {3.643581179072509*^9, 
   3.643581181704164*^9}, {3.643581343098572*^9, 3.6435813485783577`*^9}, {
   3.643581396232602*^9, 3.643581450165663*^9}, {3.6435816807265253`*^9, 
   3.6435817482506933`*^9}, {3.643581820981884*^9, 3.643581845922277*^9}, {
   3.6435819943113613`*^9, 3.6435819947839003`*^9}, {3.6435821108184433`*^9, 
   3.643582169656543*^9}, {3.6435823487937803`*^9, 3.643582352741942*^9}, {
   3.64358243946841*^9, 3.643582467344998*^9}, {3.6435825285473833`*^9, 
   3.643582576718533*^9}, 3.6435826108307*^9, {3.643582696578288*^9, 
   3.643582704002528*^9}, {3.6435827393736143`*^9, 3.643582770536806*^9}, {
   3.643582810734277*^9, 3.643582815312107*^9}, {3.643582920636263*^9, 
   3.643582921569202*^9}, {3.643582999903707*^9, 3.643583015630478*^9}, 
   3.643583052452937*^9, {3.6435832153320503`*^9, 3.643583215803863*^9}, {
   3.6435832802000504`*^9, 3.64358328078468*^9}, {3.643583332558405*^9, 
   3.643583462542625*^9}, {3.643584377099238*^9, 3.643584384208622*^9}, {
   3.643584433282196*^9, 3.643584437589529*^9}, {3.643584487721589*^9, 
   3.6435846193692713`*^9}, {3.64358542453092*^9, 3.6435854449035378`*^9}, {
   3.643585486766547*^9, 3.643585508983124*^9}, {3.643585556124483*^9, 
   3.6435856612329607`*^9}, {3.643585819488824*^9, 3.643585888506105*^9}, {
   3.643585957065586*^9, 3.64358595781819*^9}, 3.643586036853948*^9, {
   3.643586199495047*^9, 3.643586201687325*^9}, {3.643586270573256*^9, 
   3.643586335541441*^9}, {3.643586366266822*^9, 3.643586366749187*^9}, {
   3.6435864821769*^9, 3.643586540237311*^9}, {3.643586596028481*^9, 
   3.643586602270299*^9}, 3.643586632601943*^9, {3.643586786471229*^9, 
   3.643586793331285*^9}, 3.643613564377368*^9, 3.643613605560549*^9, 
   3.64361413524927*^9, {3.643614167661488*^9, 3.643614167942093*^9}, {
   3.643614212818886*^9, 3.643614258764385*^9}, {3.643614296149427*^9, 
   3.6436143305963306`*^9}, {3.6436144326019707`*^9, 3.643614452491519*^9}, {
   3.6436144844986887`*^9, 3.643614496445849*^9}, {3.64361454944586*^9, 
   3.643614614358203*^9}, {3.643614671937406*^9, 3.643614700140606*^9}, {
   3.6436518830139017`*^9, 3.643652015842853*^9}, {3.6436520514965*^9, 
   3.6436520614064617`*^9}, {3.643652118265585*^9, 3.643652174177244*^9}, {
   3.643652221395382*^9, 3.643652254211308*^9}, {3.64365230551366*^9, 
   3.6436523125207663`*^9}, {3.643652370595623*^9, 3.643652372280531*^9}, {
   3.643652403322126*^9, 3.643652425417293*^9}, 3.6436524917816877`*^9, {
   3.643652550562031*^9, 3.643652571362829*^9}, 3.643652635660029*^9, 
   3.643654133241459*^9, {3.643654814660413*^9, 3.643654881687189*^9}, {
   3.6436549253181047`*^9, 3.643654931097438*^9}, {3.64367263766577*^9, 
   3.643672650578936*^9}, {3.643724430314802*^9, 3.643724458089986*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "T"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "5", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<*****\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqt"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqt"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "4", ",", "6"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643652731530715*^9, 3.643652733408741*^9}, {
   3.643654156718238*^9, 3.643654312318404*^9}, {3.643654358929434*^9, 
   3.643654407381975*^9}, {3.643654959933894*^9, 3.643655065132889*^9}, {
   3.6436734272561274`*^9, 3.643673492539062*^9}, 3.6437602006228867`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.657378350493443*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"4"},
      {"2"},
      {"5"},
      {"3"},
      {"6"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.657378350555789*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.657378350610094*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "5"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.657378350666842*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.6573783507216883`*^9}],

Cell[BoxData["\<\"*****\"\>"], "Print",
 CellChangeTimes->{3.6437606891959047`*^9, 3.655399132070994*^9, 
  3.6573783507768717`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"},
      {"4"},
      {"5"},
      {"6"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.6573783508321047`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2", "3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.657378350888721*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"4", "5", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760688943416*^9, 3.6553991317770557`*^9, 
  3.6573783509799*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"T", ",", "B"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqt"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", 
      RowBox[{
       RowBox[{"3", "^", "nqt"}], "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "4", ",", "6"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<*****\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "5", ",", "6"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643652731530715*^9, 3.643652733408741*^9}, {
  3.643654156718238*^9, 3.643654312318404*^9}, {3.643654358929434*^9, 
  3.643654407381975*^9}, {3.643654959933894*^9, 3.643655065132889*^9}, {
  3.6436734272561274`*^9, 3.643673492539062*^9}, {3.643673524106621*^9, 
  3.6436736213517017`*^9}, {3.643674020970292*^9, 3.643674051706183*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"},
      {"B"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351130972*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"3"},
      {"5"},
      {"2"},
      {"4"},
      {"6"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351196151*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "3", "5"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351253141*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "4", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351310058*^9}],

Cell[BoxData["\<\"*****\"\>"], "Print",
 CellChangeTimes->{3.643760689662758*^9, 3.655399132559597*^9, 
  3.657378351367831*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"},
      {"4"},
      {"5"},
      {"6"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351424419*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351481469*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351561316*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.6437606894459667`*^9, 3.655399132331409*^9, 
  3.657378351620063*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "B"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", 
      RowBox[{
       RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<*****\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", 
      RowBox[{
       RowBox[{"2", "^", "nqt"}], "/", "2"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"nqx", "=", "2"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PartnerBT1", "[", 
     RowBox[{"QA", ",", " ", "1"}], "]"}], "==", 
    RowBox[{"Partner1", "[", "1", "]"}]}], "&&", 
   RowBox[{
    RowBox[{"PartnerBT1", "[", 
     RowBox[{"QA", ",", " ", "2"}], "]"}], "==", 
    RowBox[{"Partner1", "[", "2", "]"}]}]}], " ", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643584680738243*^9, 3.643584750928176*^9}, {
   3.643585712071478*^9, 3.643585712575889*^9}, {3.643668977650837*^9, 
   3.643668989328182*^9}, {3.643669032205881*^9, 3.6436691419249*^9}, {
   3.643671393355733*^9, 3.643671438535537*^9}, 3.643671526309826*^9, 
   3.643673700756536*^9, {3.6436737309390917`*^9, 3.6436738149213457`*^9}, {
   3.643673858855927*^9, 3.643673859562272*^9}, {3.6436738939007874`*^9, 
   3.643673929166635*^9}, {3.6436739676544333`*^9, 3.643673990964534*^9}, {
   3.643760321696292*^9, 3.643760337219345*^9}, {3.643760390254137*^9, 
   3.643760394909904*^9}, {3.643760467508518*^9, 3.643760477316936*^9}, {
   3.6437605220048*^9, 3.643760581889422*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"B"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.657378351738165*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"3"},
      {"2"},
      {"4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.657378351796756*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.6573783518554707`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.6573783519191008`*^9}],

Cell[BoxData["\<\"*****\"\>"], "Print",
 CellChangeTimes->{3.643760690241778*^9, 3.6553991331709337`*^9, 
  3.657378351976243*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"},
      {"4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.657378352034782*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.6573783521269913`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.6573783521867523`*^9}],

Cell[BoxData[
 TagBox["2",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.657378352270686*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760689966518*^9, 3.655399132920392*^9, 
  3.657378352343862*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"T", ",", "T"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqT", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"is", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "is"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "4", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", 
      RowBox[{
       RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "7", ",", "9"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<*****\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"is", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "is"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "4", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", 
     RowBox[{
      RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "7", ",", "9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QD", "=", 
   RowBox[{"QA", " ", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"B", "->", "2"}], ",", 
      RowBox[{"T", "->", "3"}]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PartnerBT1", "[", 
     RowBox[{"QA", ",", " ", "1"}], "]"}], "==", 
    RowBox[{"PartnerT1", "[", "1", "]"}]}], "&&", 
   RowBox[{
    RowBox[{"PartnerBT1", "[", 
     RowBox[{"QA", ",", " ", "2"}], "]"}], "==", 
    RowBox[{"PartnerT1", "[", "2", "]"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643584680738243*^9, 3.643584750928176*^9}, {
   3.643585712071478*^9, 3.643585712575889*^9}, {3.643668977650837*^9, 
   3.643668989328182*^9}, {3.643669032205881*^9, 3.6436691419249*^9}, {
   3.643671393355733*^9, 3.643671438535537*^9}, 3.643671526309826*^9, 
   3.643673700756536*^9, {3.6436737309390917`*^9, 3.6436738149213457`*^9}, {
   3.643673858855927*^9, 3.643673859562272*^9}, {3.6436738939007874`*^9, 
   3.643673929166635*^9}, {3.6436739676544333`*^9, 3.643673990964534*^9}, {
   3.643674085195004*^9, 3.643674086747075*^9}, {3.643674117170368*^9, 
   3.643674152763686*^9}, {3.6436742212351923`*^9, 3.6436742299979773`*^9}, {
   3.643674278038999*^9, 3.643674391302484*^9}, 3.643674435087184*^9, {
   3.643674465349172*^9, 3.643674534704297*^9}, {3.64367458060703*^9, 
   3.643674581336627*^9}, {3.643674623301668*^9, 3.643674651885968*^9}, {
   3.643674708847549*^9, 3.6436747287463818`*^9}, {3.6436748030781097`*^9, 
   3.643674803650305*^9}, {3.6436748831709833`*^9, 3.6436748998614197`*^9}, {
   3.643674936192066*^9, 3.643674947628791*^9}, {3.6436749808414993`*^9, 
   3.6436750257160807`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378352590942*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"4"},
      {"7"},
      {"2"},
      {"5"},
      {"8"},
      {"3"},
      {"6"},
      {"9"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378352660335*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "4", "7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378352720682*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "5", "8"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.65737835278246*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "6", "9"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378352843947*^9}],

Cell[BoxData["\<\"*****\"\>"], "Print",
 CellChangeTimes->{3.643760690925659*^9, 3.655399133915213*^9, 
  3.657378352906433*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"2"},
      {"3"},
      {"4"},
      {"5"},
      {"6"},
      {"7"},
      {"8"},
      {"9"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.65737835299116*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2", "3"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378353052699*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"4", "5", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378353114846*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"7", "8", "9"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378353177804*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760690634946*^9, 3.6553991335835953`*^9, 
  3.657378353241796*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Pick1"}]], "Input",
 CellChangeTimes->{{3.6436766564503736`*^9, 3.643676660145227*^9}}],

Cell[BoxData[
 StyleBox["\<\"Pick1  is used to pick out the members of each pair labelled \
by icase.\\nicase runs from 1 to 2**nqx/2  and ip1 \
=1,2.\\nPick1[is_,icase_,ip1_]:=Pick1[is,icase,ip1]=Partner1[is][[2*icase-1+\
ip1-1]].\\n\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.657378353725916*^9},
 CellTags->"Info-2d40a666-041b-4d6c-be2e-46fa0b36eae9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"T", ",", "T", ",", "T"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqT", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"is", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "is"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", 
      RowBox[{
       RowBox[{"3", "^", "nqT"}], "/", "3"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "1"}], "]"}], "==", 
   RowBox[{"PartnerT1", "[", "1", "]"}]}], "&&", 
  RowBox[{
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "2"}], "]"}], "==", 
   RowBox[{"PartnerT1", "[", "2", "]"}]}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQvWTT8/BG1deOUkfzI0G03QJp8SYgrXXFVh5E/9yj
yj0FSM9QcuYD0YctRYVBtPKGYyIg2vnqby0QbSXGqw2iF2w7EgiiV6TeCQbR
JpbVaSA64/DqIhCdVrSuHETfer+hAkSff7m7cSrI3KsLmkC0z87gPhB9dXJz
P4hmOGw1G0RPYRJdDKJn1W7fAqJr9U9vA9GHDmW9mgakI1r034PoVVpmJoeA
tIT5dksQvc+hzg9E78zP9wfRGZl3QkC0cmlCKIhex+KSAKIX/f2eDKIP6Hpn
g+hZMeFg+sDvTYUgWmwFYymIlvmzsRJEs/HurwPRFtoTW0D0hpLZ7SDaZ+Pb
PhCdxso1EUQDAC70qu4=
  "]],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"T"},
      {"T"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691502944*^9, 3.6553991345427856`*^9, 
  3.6573783540085983`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"10"},
      {"19"},
      {"2"},
      {"11"},
      {"20"},
      {"3"},
      {"12"},
      {"21"},
      {"4"},
      {"13"},
      {"22"},
      {"5"},
      {"14"},
      {"23"},
      {"6"},
      {"15"},
      {"24"},
      {"7"},
      {"16"},
      {"25"},
      {"8"},
      {"17"},
      {"26"},
      {"9"},
      {"18"},
      {"27"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691502944*^9, 3.6553991345427856`*^9, 
  3.657378354083272*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "10", "19"},
     {"2", "11", "20"},
     {"3", "12", "21"},
     {"4", "13", "22"},
     {"5", "14", "23"},
     {"6", "15", "24"},
     {"7", "16", "25"},
     {"8", "17", "26"},
     {"9", "18", "27"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691502944*^9, 3.6553991345427856`*^9, 
  3.657378354146213*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691502944*^9, 3.6553991345427856`*^9, 
  3.6573783542093143`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "B", ",", "B"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqT", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"is", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"PartnerBT1", "[", 
  RowBox[{"QA", ",", " ", "is"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"PickBT1", "[", 
     RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "5", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"is", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "7", ",", "8"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"nqx", "=", "3"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "1"}], "]"}], "==", 
   RowBox[{"Partner1", "[", "1", "]"}]}], "&&", 
  RowBox[{
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "2"}], "]"}], "==", 
   RowBox[{"Partner1", "[", "2", "]"}], " "}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwdzE8oQwEAx/E34UA4+JupxZoysYuwFdFcNJEN868YeflzeMj/oTbKbcgs
mbRGWhTb0tZGrPeGorh4JVFumLRERoj3c/j2uX3T2yhlRxhBEAIuuO68V+tE
T6WpR1QDLLbwk/Wc4ssiAfzcF0UbOZcy5LGQkSbGQ6H9OAHK2S8xlCXFZEOL
y18NbR03Kpgn1ZKwk9nqh2T/9jC8DtpH4MXjnm4RX9aihxUelQGyC1OzkGBk
ZmgMS1yDyxPuXTghOXNBmu4OmDjrpyVBuCnOz6M5UwrcUnhQMlkJPRRVBTu7
bmqgcLC1Fm6Hl7VC60+oHfpyFD1wuVn9r+/L2QeTbLxBmPbtGIWRMYeTsDB7
fhraB8wzsMLxbIBkRNQ8/LX7THBMrV2B+8kna/CVN7cF/VeaHWjJsnrhaimf
gQ+B/H8zldpzSG/IX+C44O4dnj6mhWCuv7yc4ezjsQrYa9Io4VvjbR0k44aa
oPfjsgX+Aais+BQ=
  "]],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"B"},
      {"B"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.6573783543092012`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"5"},
      {"2"},
      {"6"},
      {"3"},
      {"7"},
      {"4"},
      {"8"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354374071*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "5"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354438716*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "6"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.6573783545025263`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354565547*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"4", "8"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354630211*^9}],

Cell[BoxData[
 TagBox["3",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354717864*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760691785572*^9, 3.655399134829137*^9, 
  3.657378354782168*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.643677381077022*^9, 3.643677392552305*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.643677398107684*^9, 3.643677398111903*^9}}],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.643676526964731*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "B", ",", "B", ",", "B", ",", "B", ",", "B"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqx", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Partner1", "[", "1", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "1"}], "]"}]}], "&&", 
  RowBox[{
   RowBox[{"Partner1", "[", "2", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "2"}], "]"}]}], "&&", 
  RowBox[{
   RowBox[{"Partner1", "[", "3", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "3"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Partner1", "[", "4", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "4"}], "]"}]}], "&&", 
  RowBox[{
   RowBox[{"Partner1", "[", "5", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "5"}], "]"}]}], "&&", 
  RowBox[{
   RowBox[{"Partner1", "[", "6", "]"}], "==", 
   RowBox[{"PartnerBT1", "[", 
    RowBox[{"QA", ",", " ", "6"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.643584792350362*^9, 3.6435848657015667`*^9}, {
  3.643584945307732*^9, 3.643585028513554*^9}, {3.643585125815947*^9, 
  3.643585214881872*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"B"},
      {"B"},
      {"B"},
      {"B"},
      {"B"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760692377584*^9, 3.655399135443076*^9, 
  3.657378354954205*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760692377584*^9, 3.655399135443076*^9, 
  3.657378355028227*^9}],

Cell[BoxData[
 TagBox["True",
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.643760692377584*^9, 3.655399135443076*^9, 
  3.657378355093346*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"QA", "=", 
  RowBox[{"{", 
   RowBox[{"B", ",", "T", ",", "B", ",", "T"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nqt", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "3", ",", "4"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"1", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "5", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PartnerBT1", "[", 
   RowBox[{"QA", ",", " ", "1"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<*****\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "4", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PickBT1", "[", 
    RowBox[{"2", ",", "icase", ",", "iv"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"icase", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"iv", ",", "7", ",", "9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PartnerBT1", "[", 
   RowBox[{"QA", ",", " ", "2"}], "]"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.643584680738243*^9, 3.643584750928176*^9}, {
   3.643585712071478*^9, 3.643585712575889*^9}, {3.643668977650837*^9, 
   3.643668989328182*^9}, {3.643669032205881*^9, 3.6436691419249*^9}, {
   3.643671393355733*^9, 3.643671438535537*^9}, 3.643671526309826*^9, 
   3.643673700756536*^9, {3.6436737309390917`*^9, 3.6436738149213457`*^9}, {
   3.643673858855927*^9, 3.643673859562272*^9}, {3.6436738939007874`*^9, 
   3.643673929166635*^9}, {3.6436739676544333`*^9, 3.643673990964534*^9}, {
   3.643677476623926*^9, 3.643677493385792*^9}, {3.643677568944203*^9, 
   3.6436776561313887`*^9}, {3.643677696901599*^9, 3.643677853030127*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"B"},
      {"T"},
      {"B"},
      {"T"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.657378355199897*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "19"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.657378355278714*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "20"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.657378355356925*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "21"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.657378355421279*^9}],

Cell[BoxData["\<\"*****\"\>"], "Print",
 CellChangeTimes->{3.655399135938712*^9, 3.6573783554868517`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "7", "13"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.657378355553751*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "8", "14"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.65737835565305*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "9", "15"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.6573783557186747`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {"1"},
      {"7"},
      {"13"},
      {"2"},
      {"8"},
      {"14"},
      {"3"},
      {"9"},
      {"15"},
      {"4"},
      {"10"},
      {"16"},
      {"5"},
      {"11"},
      {"17"},
      {"6"},
      {"12"},
      {"18"},
      {"19"},
      {"25"},
      {"31"},
      {"20"},
      {"26"},
      {"32"},
      {"21"},
      {"27"},
      {"33"},
      {"22"},
      {"28"},
      {"34"},
      {"23"},
      {"29"},
      {"35"},
      {"24"},
      {"30"},
      {"36"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.655399135668818*^9, 3.6573783557858553`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Op*"}]], "Input",
 CellChangeTimes->{{3.643760859773562*^9, 3.643760866143814*^9}}],

Cell[BoxData[{
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["System`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["System`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["Opacity",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Opacity", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Opening",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Opening", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionInspectorSettings",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionInspectorSettings", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpacityFunction",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpacityFunction", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OpenRead",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenRead", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionQ",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionQ", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpacityFunctionScaling",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpacityFunctionScaling", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OpenSpecialOptions",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenSpecialOptions", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Options",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Options", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["Open",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {"Open", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OpenTemporary",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenTemporary", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionsPacket",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionsPacket", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpenAppend",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenAppend", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OpenWrite",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenWrite", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionsPattern",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionsPattern", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["Opener",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {"Opener", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Operate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Operate", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionValue",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionValue", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpenerBox",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenerBox", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OperatingSystem",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OperatingSystem", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionValueBox",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionValueBox", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpenerBoxOptions",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenerBoxOptions", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptimumFlowData",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptimumFlowData", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionValueBoxOptions",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionValueBoxOptions", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["OpenerView",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenerView", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["Optional",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Optional", "System`"}},
          ButtonNote->"System`"], ""},
        {
         ButtonBox["OpenFunctionInspectorPacket",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpenFunctionInspectorPacket", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["OptionalElement",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OptionalElement", "System`"}},
          ButtonNote->"System`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.31666666666666665`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]], "\n", 
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`BTSystem`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`BTSystem`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["OpBT1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpBT1", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"], 
         ButtonBox["OpBT2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpBT2", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"], 
         ButtonBox["Opmat",
          BaseStyle->"InformationLink",
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Opmat", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"], 
         ButtonBox["Opmat$",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Opmat$", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"], 
         ButtonBox["OpT1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpT1", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"], 
         ButtonBox["OpT2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "OpT2", "QDENSITY`BTSystem`"}},
          ButtonNote->"QDENSITY`BTSystem`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.15833333333333333`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]], "\n", 
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QDENSITY`QCWave`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QDENSITY`QCWave`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["Op1",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Op1", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Op2",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Op2", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"], 
         ButtonBox["Op3",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info-1ba71abc-26cf-4fba-ac69-d9434d76e4b8", {
            "Op3", "QDENSITY`QCWave`"}},
          ButtonNote->"QDENSITY`QCWave`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.31666666666666665`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]}], "Print", "InfoCell",
 CellChangeTimes->{3.6573783559669123`*^9}]
}, Open  ]]
},
WindowSize->{843, 825},
WindowMargins->{{80, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"10.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 9, \
2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "b:5.0"->{
  Cell[580, 22, 1075, 23, 81, "Input",
   CellTags->"b:5.0"],
  Cell[1658, 47, 171, 3, 22, "Print",
   CellTags->"b:5.0"]},
 "Info-2d40a666-041b-4d6c-be2e-46fa0b36eae9"->{
  Cell[138749, 4154, 370, 6, 92, "Print",
   CellTags->"Info-2d40a666-041b-4d6c-be2e-46fa0b36eae9"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"b:5.0", 173896, 5247},
 {"Info-2d40a666-041b-4d6c-be2e-46fa0b36eae9", 174068, 5252}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 1075, 23, 81, "Input",
 CellTags->"b:5.0"],
Cell[1658, 47, 171, 3, 22, "Print",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[1844, 53, 263, 5, 46, "Input"],
Cell[CellGroupData[{
Cell[2132, 62, 402, 7, 32, "Input"],
Cell[2537, 71, 155, 2, 22, "Print"]
}, Open  ]],
Cell[2707, 76, 3835, 106, 267, "Input"],
Cell[CellGroupData[{
Cell[6567, 186, 2488, 67, 199, "Input"],
Cell[9058, 255, 705, 20, 28, "Output"],
Cell[9766, 277, 754, 23, 63, "Output"],
Cell[10523, 302, 676, 20, 63, "Output"],
Cell[11202, 324, 182, 5, 28, "Output"],
Cell[11387, 331, 179, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11603, 341, 2758, 74, 216, "Input"],
Cell[14364, 417, 718, 21, 45, "Output"],
Cell[15085, 440, 1263, 44, 165, "Output"],
Cell[16351, 486, 795, 26, 165, "Output"],
Cell[17149, 514, 186, 5, 28, "Output"],
Cell[17338, 521, 181, 5, 28, "Output"],
Cell[17522, 528, 183, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17742, 538, 3017, 82, 284, "Input"],
Cell[20762, 622, 742, 23, 77, "Output"],
Cell[21507, 647, 742, 23, 81, "Output"],
Cell[22252, 672, 5356, 197, 625, "Output"],
Cell[27611, 871, 1612, 53, 625, "Output"],
Cell[29226, 926, 184, 5, 28, "Output"],
Cell[29413, 933, 182, 5, 28, "Output"],
Cell[29598, 940, 181, 5, 28, "Output"],
Cell[29782, 947, 181, 5, 28, "Output"],
Cell[29966, 954, 179, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30182, 964, 3017, 82, 284, "Input"],
Cell[33202, 1048, 748, 23, 77, "Output"],
Cell[33953, 1073, 746, 23, 81, "Output"],
Cell[34702, 1098, 5360, 197, 625, "Output"],
Cell[40065, 1297, 1616, 53, 625, "Output"],
Cell[41684, 1352, 185, 5, 28, "Output"],
Cell[41872, 1359, 183, 5, 28, "Output"],
Cell[42058, 1366, 185, 5, 28, "Output"],
Cell[42246, 1373, 183, 5, 28, "Output"],
Cell[42432, 1380, 183, 5, 28, "Output"]
}, Open  ]],
Cell[42630, 1388, 1054, 32, 63, "Input"],
Cell[CellGroupData[{
Cell[43709, 1424, 1018, 28, 80, "Input"],
Cell[44730, 1454, 181, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[44936, 1463, 116, 2, 21, "Print"],
Cell[45055, 1467, 361, 8, 22, "Print"],
Cell[45419, 1477, 364, 8, 22, "Print"],
Cell[45786, 1487, 362, 8, 22, "Print"],
Cell[46151, 1497, 362, 8, 22, "Print"],
Cell[46516, 1507, 361, 8, 22, "Print"],
Cell[46880, 1517, 362, 8, 22, "Print"],
Cell[47245, 1527, 362, 8, 22, "Print"],
Cell[47610, 1537, 362, 8, 22, "Print"],
Cell[47975, 1547, 362, 8, 22, "Print"],
Cell[48340, 1557, 362, 8, 22, "Print"],
Cell[48705, 1567, 364, 8, 22, "Print"],
Cell[49072, 1577, 366, 8, 22, "Print"],
Cell[49441, 1587, 366, 8, 22, "Print"],
Cell[49810, 1597, 363, 8, 22, "Print"],
Cell[50176, 1607, 364, 8, 22, "Print"],
Cell[50543, 1617, 364, 8, 22, "Print"],
Cell[50910, 1627, 364, 8, 22, "Print"],
Cell[51277, 1637, 364, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51690, 1651, 920, 26, 80, "Input"],
Cell[52613, 1679, 179, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[52817, 1688, 115, 2, 21, "Print"],
Cell[52935, 1692, 359, 8, 22, "Print"],
Cell[53297, 1702, 359, 8, 22, "Print"],
Cell[53659, 1712, 359, 8, 22, "Print"],
Cell[54021, 1722, 359, 8, 22, "Print"],
Cell[54383, 1732, 360, 8, 22, "Print"],
Cell[54746, 1742, 361, 8, 22, "Print"],
Cell[55110, 1752, 361, 8, 22, "Print"],
Cell[55474, 1762, 361, 8, 22, "Print"],
Cell[55838, 1772, 363, 8, 22, "Print"],
Cell[56204, 1782, 361, 8, 22, "Print"],
Cell[56568, 1792, 363, 8, 22, "Print"],
Cell[56934, 1802, 363, 8, 22, "Print"],
Cell[57300, 1812, 363, 8, 22, "Print"],
Cell[57666, 1822, 365, 8, 22, "Print"],
Cell[58034, 1832, 363, 8, 22, "Print"],
Cell[58400, 1842, 363, 8, 22, "Print"],
Cell[58766, 1852, 363, 8, 22, "Print"],
Cell[59132, 1862, 362, 8, 22, "Print"],
Cell[59497, 1872, 365, 8, 22, "Print"],
Cell[59865, 1882, 365, 8, 22, "Print"],
Cell[60233, 1892, 363, 8, 22, "Print"],
Cell[60599, 1902, 362, 8, 22, "Print"],
Cell[60964, 1912, 363, 8, 22, "Print"],
Cell[61330, 1922, 365, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61744, 1936, 920, 26, 80, "Input"],
Cell[62667, 1964, 181, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[62873, 1973, 116, 2, 21, "Print"],
Cell[62992, 1977, 360, 8, 22, "Print"],
Cell[63355, 1987, 360, 8, 22, "Print"],
Cell[63718, 1997, 360, 8, 22, "Print"],
Cell[64081, 2007, 362, 8, 22, "Print"],
Cell[64446, 2017, 362, 8, 22, "Print"],
Cell[64811, 2027, 362, 8, 22, "Print"],
Cell[65176, 2037, 364, 8, 22, "Print"],
Cell[65543, 2047, 364, 8, 22, "Print"],
Cell[65910, 2057, 366, 8, 22, "Print"],
Cell[66279, 2067, 364, 8, 22, "Print"],
Cell[66646, 2077, 364, 8, 22, "Print"],
Cell[67013, 2087, 364, 8, 22, "Print"],
Cell[67380, 2097, 366, 8, 22, "Print"],
Cell[67749, 2107, 364, 8, 22, "Print"],
Cell[68116, 2117, 366, 8, 22, "Print"],
Cell[68485, 2127, 364, 8, 22, "Print"],
Cell[68852, 2137, 364, 8, 22, "Print"],
Cell[69219, 2147, 364, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[69632, 2161, 918, 26, 80, "Input"],
Cell[70553, 2189, 179, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[70757, 2198, 115, 2, 21, "Print"],
Cell[70875, 2202, 359, 8, 22, "Print"],
Cell[71237, 2212, 361, 8, 22, "Print"],
Cell[71601, 2222, 361, 8, 22, "Print"],
Cell[71965, 2232, 359, 8, 22, "Print"],
Cell[72327, 2242, 359, 8, 22, "Print"],
Cell[72689, 2252, 359, 8, 22, "Print"],
Cell[73051, 2262, 361, 8, 22, "Print"],
Cell[73415, 2272, 363, 8, 22, "Print"],
Cell[73781, 2282, 363, 8, 22, "Print"],
Cell[74147, 2292, 362, 8, 22, "Print"],
Cell[74512, 2302, 363, 8, 22, "Print"],
Cell[74878, 2312, 363, 8, 22, "Print"],
Cell[75244, 2322, 363, 8, 22, "Print"],
Cell[75610, 2332, 363, 8, 22, "Print"],
Cell[75976, 2342, 363, 8, 22, "Print"],
Cell[76342, 2352, 363, 8, 22, "Print"],
Cell[76708, 2362, 363, 8, 22, "Print"],
Cell[77074, 2372, 365, 8, 22, "Print"],
Cell[77442, 2382, 365, 8, 22, "Print"],
Cell[77810, 2392, 363, 8, 22, "Print"],
Cell[78176, 2402, 363, 8, 22, "Print"],
Cell[78542, 2412, 361, 8, 22, "Print"],
Cell[78906, 2422, 363, 8, 22, "Print"],
Cell[79272, 2432, 365, 8, 22, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79686, 2446, 1700, 46, 182, "Input"],
Cell[81389, 2494, 181, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[81595, 2503, 118, 2, 21, "Print"],
Cell[81716, 2507, 120, 2, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[81885, 2515, 1700, 46, 182, "Input"],
Cell[83588, 2563, 179, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[83792, 2572, 116, 2, 21, "Print"],
Cell[83911, 2576, 116, 2, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[84076, 2584, 1670, 46, 182, "Input"],
Cell[85749, 2632, 182, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[85956, 2641, 116, 2, 21, "Print"],
Cell[86075, 2645, 116, 2, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[86240, 2653, 2040, 55, 182, "Input"],
Cell[88283, 2710, 181, 5, 28, "Output"],
Cell[CellGroupData[{
Cell[88489, 2719, 118, 2, 21, "Print"],
Cell[88610, 2723, 116, 2, 21, "Print"],
Cell[88729, 2727, 161, 4, 21, "Print"],
Cell[88893, 2733, 160, 4, 21, "Print"],
Cell[89056, 2739, 161, 4, 21, "Print"],
Cell[89220, 2745, 163, 4, 21, "Print"],
Cell[89386, 2751, 161, 4, 21, "Print"],
Cell[89550, 2757, 163, 4, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[89740, 2765, 117, 2, 28, "Input"],
Cell[CellGroupData[{
Cell[89882, 2771, 326, 7, 46, "Input"],
Cell[CellGroupData[{
Cell[90233, 2782, 115, 2, 21, "Print"],
Cell[90351, 2786, 116, 2, 21, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[90516, 2794, 2061, 54, 148, "Input"],
Cell[92580, 2850, 181, 5, 28, "Output"],
Cell[92764, 2857, 181, 5, 28, "Output"]
}, Open  ]],
Cell[92960, 2865, 165, 2, 28, "Input"],
Cell[93128, 2869, 133, 2, 28, "Input"],
Cell[93264, 2873, 9067, 184, 335, "Input"],
Cell[CellGroupData[{
Cell[102356, 3061, 2465, 65, 199, "Input"],
Cell[104824, 3128, 718, 21, 45, "Output"],
Cell[105545, 3151, 770, 25, 113, "Output"],
Cell[106318, 3178, 659, 18, 28, "Output"],
Cell[106980, 3198, 659, 18, 28, "Output"],
Cell[107642, 3218, 661, 18, 28, "Output"],
Cell[108306, 3238, 132, 2, 21, "Print"],
Cell[108441, 3242, 772, 25, 113, "Output"],
Cell[109216, 3269, 664, 18, 28, "Output"],
Cell[109883, 3289, 662, 18, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110582, 3312, 2583, 68, 216, "Input"],
Cell[113168, 3382, 718, 21, 45, "Output"],
Cell[113889, 3405, 770, 25, 113, "Output"],
Cell[114662, 3432, 664, 18, 28, "Output"],
Cell[115329, 3452, 664, 18, 28, "Output"],
Cell[115996, 3472, 128, 2, 21, "Print"],
Cell[116127, 3476, 770, 25, 113, "Output"],
Cell[116900, 3503, 659, 18, 28, "Output"],
Cell[117562, 3523, 659, 18, 28, "Output"],
Cell[118224, 3543, 659, 18, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118920, 3566, 3112, 77, 318, "Input"],
Cell[122035, 3645, 716, 21, 45, "Output"],
Cell[122754, 3668, 742, 23, 81, "Output"],
Cell[123499, 3693, 659, 18, 28, "Output"],
Cell[124161, 3713, 659, 18, 28, "Output"],
Cell[124823, 3733, 130, 2, 21, "Print"],
Cell[124956, 3737, 742, 23, 81, "Output"],
Cell[125701, 3762, 659, 18, 28, "Output"],
Cell[126363, 3782, 659, 18, 28, "Output"],
Cell[127025, 3802, 179, 5, 28, "Output"],
Cell[127207, 3809, 182, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127426, 3819, 4504, 112, 352, "Input"],
Cell[131933, 3933, 718, 21, 45, "Output"],
Cell[132654, 3956, 809, 28, 163, "Output"],
Cell[133466, 3986, 664, 18, 28, "Output"],
Cell[134133, 4006, 663, 18, 28, "Output"],
Cell[134799, 4026, 664, 18, 28, "Output"],
Cell[135466, 4046, 128, 2, 21, "Print"],
Cell[135597, 4050, 808, 28, 163, "Output"],
Cell[136408, 4080, 664, 18, 28, "Output"],
Cell[137075, 4100, 664, 18, 28, "Output"],
Cell[137742, 4120, 664, 18, 28, "Output"],
Cell[138409, 4140, 184, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138630, 4150, 116, 2, 28, "Input"],
Cell[138749, 4154, 370, 6, 92, "Print",
 CellTags->"Info-2d40a666-041b-4d6c-be2e-46fa0b36eae9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139156, 4165, 1552, 41, 148, "Input"],
Cell[140711, 4208, 733, 22, 61, "Output"],
Cell[141447, 4232, 1061, 46, 469, "Output"],
Cell[142511, 4280, 858, 26, 165, "Output"],
Cell[143372, 4308, 186, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143595, 4318, 2449, 64, 182, "Input"],
Cell[146047, 4384, 731, 22, 61, "Output"],
Cell[146781, 4408, 794, 27, 147, "Output"],
Cell[147578, 4437, 657, 18, 28, "Output"],
Cell[148238, 4457, 659, 18, 28, "Output"],
Cell[148900, 4477, 657, 18, 28, "Output"],
Cell[149560, 4497, 657, 18, 28, "Output"],
Cell[150220, 4517, 179, 5, 28, "Output"],
Cell[150402, 4524, 182, 5, 28, "Output"]
}, Open  ]],
Cell[150599, 4532, 92, 1, 28, "Input"],
Cell[150694, 4535, 92, 1, 28, "Input"],
Cell[150789, 4538, 87, 1, 46, "Input"],
Cell[CellGroupData[{
Cell[150901, 4543, 1277, 35, 114, "Input"],
Cell[152181, 4580, 768, 25, 109, "Output"],
Cell[152952, 4607, 182, 5, 28, "Output"],
Cell[153137, 4614, 182, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[153356, 4624, 2977, 72, 267, "Input"],
Cell[156336, 4698, 717, 22, 77, "Output"],
Cell[157056, 4722, 633, 17, 28, "Output"],
Cell[157692, 4741, 633, 17, 28, "Output"],
Cell[158328, 4760, 633, 17, 28, "Output"],
Cell[158964, 4779, 105, 1, 21, "Print"],
Cell[159072, 4782, 638, 17, 28, "Output"],
Cell[159713, 4801, 637, 17, 28, "Output"],
Cell[160353, 4820, 640, 17, 28, "Output"],
Cell[160996, 4839, 1162, 54, 623, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162195, 4898, 112, 2, 28, "Input"],
Cell[162310, 4902, 11214, 329, 360, "Print"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
